# Swiftest 

---
Swiftest is a software packaged designed to model the long-term dynamical dynamics of n-body systems with a dominant central body, 
like the solar system. Swiftest is a re-write of the [Swifter](https://www.boulder.swri.edu/swifter/) software package that 
incorporates modern programming techniques and performance improvements. 

#### Installation

For most users, installing swiftest can be done via pip using the command:

```
pip install swiftest
```

This will install the `swiftest` Python package, which can be incorporated into Python projects using `import swiftest`. It also will install a standalone executable called `swiftest_driver`, which can execute simulations from the command line, provided that initial conditions and configuration files are available in the path. 

#### Documentation

Please see the [Swiftest documentation](https://swiftest.readthedocs.io/en/latest/) page for more details, including advanced installation instructions, user guides, API documentation, and examples.

#### Licensing Agreement

Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Swiftest. If not, see <https://www.gnu.org/licenses/>. 

# Including custom extra acceleration functions

If you wish to include custom user-defined forces, create a file called `swiftest_user.f90` using the following template:

```fortran
submodule(swiftest) s_swiftest_user
   use swiftest
contains
   module subroutine swiftest_user_kick_getacch_body(self, nbody_system, param, t, lbeg)
      !! author: Your Name
      !!
      !! Description of the function
      !!
      !! Adapted from David E. Kaufmann's Swifter routine whm_user_kick_getacch.f90
      !! 
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self   
         !! Swiftest particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody_system_object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters user parameters
      real(DP),                     intent(in)    :: t      
         !! Current time
      logical,                      intent(in)    :: lbeg   
         !! Logical flag that determines whether or not this is the beginning or end of the step

      ! Internals: Add your own variables here
      integer(I4B) :: i

      ! Your code goes here
      ! do i = 1, self%nbody
      ! ...
      ! end do

      return
   end subroutine swiftest_user_kick_getacch_body

end submodule s_swiftest_user
```

By default, CMake will look for a `swiftest_user.f90` file here and automatically include it into the build if it exists. However, if you wish to you can place this file in a different directory and pass `-DSWIFTEST_USER_DIR=/full/path/to/folder` to CMake (see build instructions [here](https://swiftest.readthedocs.io/en/latest/getting-started-guide/index.html#building-the-executable-using-cmake) for details of how to set CMake options).

Copyright 2023 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
This file is part of Swiftest.
Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with Swiftest. 
If not, see: https://www.gnu.org/licenses. 

README.txt

Swiftest Example : Swifter_Swiftest
Author           : Carlisle A. Wishard
Date             : August 15, 2022

Included in the Swifter_Swiftest/108pl_50tp example directory are the following files:

	- README.txt                 : This file
	- param.swifter.in           : The Swifter parameter input file
	- param.swiftest.in          : The Swiftest parameter input file
	- cb.in                      : The Swiftest central body input file
	- pl.swifter.in              : The Swifter massive body input file
	- pl.swiftest.in             : The Swiftest massive body input file
	- tp.swifter.in              : The Swifter test particle input file
	- tp.swiftest.in             : The Swiftest test particle input file
	- swifter.dat                : The Swifter output file in binary format
	- swiftest.nc                : The Swiftest output file in NetCDF format
	- swifter_start.in           : The Swifter file containing additional parameter information
	- swifter_swiftest_comp.py   : A Python Script that generates swifter_swiftest_comp.eps
	- swifter_swifterst_comp.eps : A plot of the results of the Swifter run compared to the results of the Swiftest run, generated by swifter_swiftest_comp.py

This example is intended to be run with the SyMBA integrator for both Swifter and Swiftest. For details on how to generate, run, and analyze this example, see the Swiftest User Manual. To obtain a copy of Swifter, please see https://www.boulder.swri.edu/swifter/home.html.

Copyright 2023 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
This file is part of Swiftest.
Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with Swiftest. 
If not, see: https://www.gnu.org/licenses. 

README.txt

Swiftest Example : Fragmentation
Author           : David Minton and Carlisle Wishard
Date             : December 6, 2022

Included in the Fragmentation example directory are the following files:

	- README.txt 		    : This file
	- Fragmentation_Movie.py    : A Python Script that generates and runs initial conditions of collisional events, and then generates a movie (.mp4) of the collisional event.

This example is intended to be run with Swiftest SyMBA. For details on how to generate, run, and analyze this example, see the Swiftest User Manual.

Copyright 2023 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
This file is part of Swiftest.
Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with Swiftest. 
If not, see: https://www.gnu.org/licenses. 

README.txt

Swiftest Example : solar_impact
Author           : David Minton and Carlisle Wishard
Date             : December 6, 2022

Included in the solar_impact example directory are the following files:

	- README.txt   : This file
	- sundiver.py  : A Python Script that generates and runs a set of initial conditions.

This example is intended to be run with Swiftest SyMBA. For details on how to generate, run, and analyze this example, 
see the Swiftest User Manual.

Copyright 2023 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
This file is part of Swiftest.
Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with Swiftest. 
If not, see: https://www.gnu.org/licenses. 

README.txt

Swiftest Example : Swifter_Swiftest/8pl_0tp
Author           : David Minton and Carlisle Wishard
Date             : August 15, 2022

Included in the symba_swifter_comparison/8pl example directory are the following files:

	- README.txt                            : This file
	- param.swiftest.in                     : The Swiftest parameter input file
	- param.swifter.in                      : The Swifter parameter input file
	- cb.swiftest.in                        : The Swiftest central body input file
	- pl.swifter.in                         : The Swifter massive body input file
	- pl.swiftest.in                        : The Swiftest massive body input file
	- tp.swifter.in                         : The Swifter test particle input file
	- tp.swiftest.in                        : The Swiftest test particle input file
	- init_cond.py                          : A Python Script that generates two sets of initial conditions: one Swifter and one Swiftest
	- swiftest_symba_vs_swifter_symba.ipynb : A Jupyter Notebook for processing and analysing Swifter and Swiftest data
	
This example is intended to be run with the SyMBA integrator for both Swifter and Swiftest. For details on how to generate, run, and analyze this example, see the Swiftest User Manual. To obtain a copy of Swifter, please see https://www.boulder.swri.edu/swifter/home.html.

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (encounter) s_encounter_check
   use swiftest
contains

   module subroutine encounter_check_all_plpl(param, npl, r, v, renc, dt, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies. Choose between the standard triangular or the Sort & Sweep method based on 
      !! user inputs
      implicit none
      ! Arguments
      class(base_parameters),                  intent(inout) :: param  
         !! Current Swiftest run configuration parameter5s
      integer(I4B),                            intent(in)    :: npl    
         !! Total number of massive bodies
      real(DP),     dimension(:),              intent(in)    :: renc   
         !! Critical radii of massive bodies that defines an encounter 
      real(DP),     dimension(:,:),            intent(in)    :: r      
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)    :: v      
         !! Velocity vectors of massive bodies
      real(DP),                                intent(in)    :: dt     
         !! Step size
      integer(I8B),                            intent(out)   :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out)   :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out)   :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out)   :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x

      if (param%lencounter_sas_plpl) then
         call encounter_check_all_sort_and_sweep_plpl(npl, r, v, renc, dt, nenc, index1, index2, lvdotr)
      else
         call encounter_check_all_triangular_plpl(npl, r, v, renc, dt, nenc, index1, index2, lvdotr) 
      end if

      return
   end subroutine encounter_check_all_plpl


   module subroutine encounter_check_all_plplm(param, nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, nenc, index1, index2, &
                                               lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between fully interacting massive bodies partially interacting massive bodies. Choose between the
      !! standard triangular or the Sort & Sweep method based on user inputs
      implicit none
      ! Arguments
      class(base_parameters),                  intent(inout) :: param  
         !! Current Swiftest run configuration parameter5s
      integer(I4B),                            intent(in)    :: nplm   
         !! Total number of fully interacting massive bodies 
      integer(I4B),                            intent(in)    :: nplt   
         !! Total number of partially interacting masive bodies (GM < GMTINY) 
      real(DP),     dimension(:,:),            intent(in)    :: rplm   
         !! Position vectors of fully interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)    :: vplm   
         !! Velocity vectors of fully interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)    :: rplt   
         !! Position vectors of partially interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)    :: vplt   
         !! Velocity vectors of partially interacting massive bodies
      real(DP),     dimension(:),              intent(in)    :: rencm  
         !! Critical radii of fully interacting massive bodies that defines an encounter
      real(DP),     dimension(:),              intent(in)    :: renct  
         !! Critical radii of partially interacting massive bodies that defines an encounter
      real(DP),                                intent(in)    :: dt     
         !! Step size
      integer(I8B),                            intent(out)   :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out)   :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out)   :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out)   :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      logical,      dimension(:), allocatable :: plmplt_lvdotr 
         !! Logical flag indicating the sign of v .dot. x in the plm-plt group
      integer(I4B), dimension(:), allocatable :: plmplt_index1 
         !! List of indices for body 1 in each encounter in the plm-plt group
      integer(I4B), dimension(:), allocatable :: plmplt_index2 
         !! List of indices for body 2 in each encounter in the plm-lt group
      integer(I8B)                            :: plmplt_nenc   
         !! Number of encounters of the plm-plt group
      class(base_parameters), allocatable :: tmp_param     
         !! Temporary parameter structure to turn off adaptive timer for the pl-pl phase if necessary
      integer(I8B), dimension(:), allocatable :: ind
      integer(I4B), dimension(:), allocatable :: itmp
      logical, dimension(:), allocatable :: ltmp

      allocate(tmp_param, source=param)

      ! Start with the pl-pl group
      call encounter_check_all_plpl(tmp_param, nplm, rplm, vplm, rencm, dt, nenc, index1, index2, lvdotr)

      if (param%lencounter_sas_plpl) then
         call encounter_check_all_sort_and_sweep_plplm(nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, &
                                                       plmplt_nenc, plmplt_index1, plmplt_index2, plmplt_lvdotr)
      else
         call encounter_check_all_triangular_plplm(nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, &
                                                   plmplt_nenc, plmplt_index1, plmplt_index2, plmplt_lvdotr) 
      end if

      if (plmplt_nenc > 0) then ! Consolidate the two lists
         allocate(itmp(nenc+plmplt_nenc))
         if (nenc > 0) itmp(1:nenc) = index1(1:nenc)
         itmp(nenc+1:nenc+plmplt_nenc) = plmplt_index1(1:plmplt_nenc)
         call move_alloc(itmp, index1)
         allocate(itmp(nenc+plmplt_nenc))
         if (nenc > 0) itmp(1:nenc) = index2(1:nenc)
         itmp(nenc+1:nenc+plmplt_nenc) = plmplt_index2(1:plmplt_nenc) + nplm ! Be sure to shift these indices back to their natural 
                                                                             ! range
         call move_alloc(itmp, index2)
         allocate(ltmp(nenc+plmplt_nenc))
         if (nenc > 0) ltmp(1:nenc) = lvdotr(1:nenc)
         ltmp(nenc+1:nenc+plmplt_nenc) = plmplt_lvdotr(1:plmplt_nenc)
         call move_alloc(ltmp, lvdotr)
         nenc = nenc + plmplt_nenc

         call util_sort(index1, ind)
         call util_sort_rearrange(index1, ind, nenc)
         call util_sort_rearrange(index2, ind, nenc)
         call util_sort_rearrange(lvdotr, ind, nenc)

      end if

      return
   end subroutine encounter_check_all_plplm


   module subroutine encounter_check_all_pltp(param, npl, ntp, rpl, vpl, rtp, vtp, renc, dt, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies and test particles. Choose between the standard triangular or the Sort & Sweep
      !! method based on user inputs
      !!
      implicit none
      ! Arguments
      class(base_parameters),                  intent(inout) :: param  
         !! Current Swiftest run configuration parameter5s
      integer(I4B),                            intent(in)    :: npl    
         !! Total number of massive bodies 
      integer(I4B),                            intent(in)    :: ntp    
         !! Total number of test particles 
      real(DP),     dimension(:,:),            intent(in)    :: rpl    
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)    :: vpl    
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)    :: rtp    
         !! Position vectors of test particlse
      real(DP),     dimension(:,:),            intent(in)    :: vtp    
         !! Velocity vectors of test particles
      real(DP),     dimension(:),              intent(in)    :: renc   
         !! Critical radii of massive bodies that defines an encounter
      real(DP),                                intent(in)    :: dt     
         !! Step size
      integer(I8B),                            intent(out)   :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out)   :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out)   :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out)   :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x

      if (param%lencounter_sas_pltp) then
         call encounter_check_all_sort_and_sweep_pltp(npl, ntp, rpl, vpl, rtp, vtp, renc, dt, nenc, index1, index2, lvdotr)
      else
         call encounter_check_all_triangular_pltp(npl, ntp, rpl, vpl, rtp, vtp, renc, dt, nenc, index1, index2, lvdotr) 
      end if

      return
   end subroutine encounter_check_all_pltp


   subroutine encounter_check_all_sort_and_sweep_plpl(npl, r, v, renc, dt, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies. 
      !! This is the sort and sweep version
      !! References: Adapted from Christer Ericson's _Real Time Collision Detection_
      !!
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)  :: npl    
         !! Total number of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: r      
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: v      
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:),              intent(in)  :: renc   
         !! Critical radii of massive bodies that defines an encounter 
      real(DP),                                intent(in)  :: dt     
         !! Step size
      integer(I8B),                            intent(out) :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out) :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out) :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      integer(I4B) :: i, n
      integer(I4B), save :: npl_last = 0
      type(encounter_bounding_box), save :: boundingbox
      real(DP), dimension(npl) :: rmin,rmax
      real(DP) :: rmag

      if (npl == 0) return

      ! If this is the first time through, build the index lists
      n = 2 * npl
      if (npl_last /= npl) then
         call boundingbox%setup(npl, npl_last)
         npl_last = npl
      end if

#ifdef DOCONLOC
      do concurrent (i = 1:npl) shared(r,renc,rmin,rmax) local(rmag)
#else
      do concurrent (i = 1:npl)
#endif
         rmag = norm2(r(:,i))
         rmax(i) = rmag + RSWEEP_FACTOR * renc(i)
         rmin(i) = rmag - RSWEEP_FACTOR * renc(i)
      end do

      call boundingbox%aabb%sort(npl, [rmin,rmax]) 

      call boundingbox%sweep(npl, r, v, renc, dt, nenc, index1, index2, lvdotr) 

      return
   end subroutine encounter_check_all_sort_and_sweep_plpl


   subroutine encounter_check_all_sort_and_sweep_plplm(nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, nenc, index1, index2, &
                                                      lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies and test particles. 
      !! This is the sort and sweep version
      !! References: Adapted from Christer Ericson's _Real Time Collision Detection_
      !!
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)  :: nplm   
         !! Total number of fully interacting massive bodies 
      integer(I4B),                            intent(in)  :: nplt   
         !! Total number of partially interacting masive bodies (GM < GMTINY) 
      real(DP),     dimension(:,:),            intent(in)  :: rplm   
         !! Position vectors of fully interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vplm   
         !! Velocity vectors of fully interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: rplt   
         !! Position vectors of partially interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vplt   
         !! Velocity vectors of partially interacting massive bodies
      real(DP),     dimension(:),              intent(in)  :: rencm  
         !! Critical radii of fully interacting massive bodies that defines an encounter
      real(DP),     dimension(:),              intent(in)  :: renct  
         !! Critical radii of partially interacting massive bodies that defines an encounter
      real(DP),                                intent(in)  :: dt     
         !! Step size
      integer(I8B),                            intent(out) :: nenc   
         !! Total number of encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out) :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      type(encounter_bounding_box), save :: boundingbox
      integer(I4B) :: i, n, ntot
      integer(I4B), save :: ntot_last = 0
      real(DP), dimension(nplm+nplt) :: rmin,rmax
      real(DP) :: rmag

      ! If this is the first time through, build the index lists
      if ((nplm == 0) .or. (nplt == 0)) return

      ntot = nplm + nplt
      n = 2 * ntot
      if (ntot /= ntot_last) then
         call boundingbox%setup(ntot, ntot_last)
         ntot_last = ntot
      end if

#ifdef DOCONLOC
      do concurrent (i = 1:nplm) shared(rmin,rmax,rplm,rencm) local(rmag)
#else
      do concurrent (i = 1:nplm)
#endif
         rmag = norm2(rplm(:,i))
         rmax(i) = rmag + RSWEEP_FACTOR * rencm(i)
         rmin(i) = rmag - RSWEEP_FACTOR * rencm(i)
      end do
#ifdef DOCONLOC
      do concurrent (i = 1:nplt) shared(rmin,rmax,rplt,renct) local(rmag)
#else
      do concurrent (i = 1:nplt)
#endif
         rmag = norm2(rplt(:,i))
         rmax(nplm+i) = rmag + RSWEEP_FACTOR * renct(i)
         rmin(nplm+i) = rmag - RSWEEP_FACTOR * renct(i)
      end do

      call boundingbox%aabb%sort(ntot, [rmin, rmax])

      call boundingbox%sweep(nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, nenc, index1, index2, lvdotr) 

      return
   end subroutine encounter_check_all_sort_and_sweep_plplm


   subroutine encounter_check_all_sort_and_sweep_pltp(npl, ntp, rpl, vpl, rtp, vtp, rencpl, dt, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies and test particles. 
      !! This is the sort and sweep version
      !! References: Adapted from Christer Ericson's _Real Time Collision Detection_
      !!
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)  :: npl    
         !! Total number of massive bodies 
      integer(I4B),                            intent(in)  :: ntp    
         !! Total number of test particles 
      real(DP),     dimension(:,:),            intent(in)  :: rpl    
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vpl    
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: rtp    
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vtp    
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:),              intent(in)  :: rencpl 
         !! Critical radii of massive bodies that defines an encounter
      real(DP),                                intent(in)  :: dt     
         !! Step size
      integer(I8B),                            intent(out) :: nenc   
         !! Total number of encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out) :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      type(encounter_bounding_box), save :: boundingbox
      integer(I4B) :: i, n, ntot
      integer(I4B), save :: ntot_last = 0
      real(DP), dimension(npl+ntp) :: rmin,rmax
      real(DP), dimension(ntp) :: renctp
      real(DP) :: rmag

      ! If this is the first time through, build the index lists
      if ((ntp == 0) .or. (npl == 0)) return

      ntot = npl + ntp
      n = 2 * ntot
      if (ntot /= ntot_last) then
         call boundingbox%setup(ntot, ntot_last)
         ntot_last = ntot
      end if

      renctp(:) = 0.0_DP

#ifdef DOCONLOC
      do concurrent (i = 1:npl) shared(rmin,rmax,rpl,rencpl) local(rmag)
#else
      do concurrent (i = 1:npl)
#endif
         rmag = norm2(rpl(:,i))
         rmax(i) = rmag + RSWEEP_FACTOR * rencpl(i)
         rmin(i) = rmag - RSWEEP_FACTOR * rencpl(i)
      end do
#ifdef DOCONLOC
      do concurrent (i = 1:ntp) shared(rmin,rmax,rtp,renctp) local(rmag)
#else
      do concurrent (i = 1:ntp) 
#endif
         rmag = norm2(rtp(:,i))
         rmax(npl+i) = rmag + RSWEEP_FACTOR * renctp(i)
         rmin(npl+i) = rmag - RSWEEP_FACTOR * renctp(i)
      end do

      call boundingbox%aabb%sort(ntot, [rmin, rmax])

      call boundingbox%sweep(npl, ntp, rpl, vpl, rtp, vtp, rencpl, renctp, dt, nenc, index1, index2, lvdotr) 

      return
   end subroutine encounter_check_all_sort_and_sweep_pltp


   pure subroutine encounter_check_all_sweep_one(i, n, xi, yi, zi, vxi, vyi, vzi, x, y, z, vx, vy, vz, renci, renc, dt, &
                                                 ind_arr, lgood, nenci, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between the ith body and all other bodies.
      !! This is used in the narrow phase of the sort & sweep algorithm
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)    :: i             
         !! Index of the ith body that is being checked
      integer(I4B),                            intent(in)    :: n             
         !! Total number of bodies being checked
      real(DP),                                intent(in)    :: xi, yi, zi    
         !! Position vector components of the ith body
      real(DP),                                intent(in)    :: vxi, vyi, vzi 
         !! Velocity vector components of the ith body
      real(DP),     dimension(:),              intent(in)    :: x, y, z       
         !! Arrays of position vector components of all bodies
      real(DP),     dimension(:),              intent(in)    :: vx, vy, vz    
         !! Arrays of velocity vector components of all bodies
      real(DP),                                intent(in)    :: renci         
         !! Encounter radius of the ith body
      real(DP),     dimension(:),              intent(in)    :: renc          
         !! Array of encounter radii of all bodies
      real(DP),                                intent(in)    :: dt            
         !! Step size
      integer(I4B), dimension(:),              intent(in)    :: ind_arr       
         !! Index array [1, 2, ..., n]
      logical,      dimension(:),              intent(in)    :: lgood         
         !! Logical array mask where true values correspond to bodies selected in the broad phase
      integer(I8B),                            intent(out)   :: nenci         
         !! Total number of encountering bodies
      integer(I4B), dimension(:), allocatable, intent(inout) :: index1        
         !! Array of indices of the ith body of size nenci [i, i, ..., i]
      integer(I4B), dimension(:), allocatable, intent(inout) :: index2        
         !! Array of indices of the encountering bodies of size nenci 
      logical,      dimension(:), allocatable, intent(inout) :: lvdotr        
         !! v.dot.r direction array
      ! Internals
      integer(I4B) :: j
      real(DP) :: xr, yr, zr, vxr, vyr, vzr, renc12
      logical, dimension(n) :: lencounteri, lvdotri

      lencounteri(:) = .false.
#ifdef DOCONLOC
      do concurrent(j = 1:n, lgood(j)) shared(lgood,lencounteri,lvdotri,x,y,z,vx,vy,vz,renci,renc) &
                                       local(xr,yr,zr,vxr,vyr,vzr,renc12)
#else
      do concurrent(j = 1:n, lgood(j))
#endif
         xr = x(j) - xi
         yr = y(j) - yi
         zr = z(j) - zi
         vxr = vx(j) - vxi
         vyr = vy(j) - vyi
         vzr = vz(j) - vzi
         renc12 = renci + renc(j)
         call encounter_check_one(xr, yr, zr, vxr, vyr, vzr, renc12, dt, lencounteri(j), lvdotri(j))
      end do
      if (any(lencounteri(:))) then
         nenci = count(lencounteri(:))
         allocate(lvdotr(nenci), index1(nenci), index2(nenci))
         index1(:) = i
         index2(:) = pack(ind_arr(1:n), lencounteri(1:n)) 
         lvdotr(:) = pack(lvdotri(1:n), lencounteri(1:n)) 
      end if

      return
   end subroutine encounter_check_all_sweep_one


   subroutine encounter_check_all_triangular_one(i, n, xi, yi, zi, vxi, vyi, vzi, x, y, z, vx, vy, vz, renci, renc, &
                                                      dt, ind_arr, lenci)
      !! author: David A. Minton
      !!
      !! Check for encounters between the ith body and all other bodies.
      !! This is the upper triangular (double loop) version.
      implicit none
      ! Arguments
      integer(I4B),                       intent(in)  :: i             
         !! Index of the ith body that is being checked
      integer(I4B),                       intent(in)  :: n             
         !! Total number of bodies being checked
      real(DP),                           intent(in)  :: xi, yi, zi    
         !! Position vector components of the ith body
      real(DP),                           intent(in)  :: vxi, vyi, vzi 
         !! Velocity vector components of the ith body
      real(DP),             dimension(:), intent(in)  :: x, y, z       
         !! Arrays of position vector components of all bodies
      real(DP),             dimension(:), intent(in)  :: vx, vy, vz    
         !! Arrays of velocity vector components of all bodies
      real(DP),                           intent(in)  :: renci         
         !! Encounter radius of the ith body
      real(DP),             dimension(:), intent(in)  :: renc          
         !! Array of encounter radii of all bodies
      real(DP),                           intent(in)  :: dt            
         !! Step size
      integer(I4B),         dimension(:), intent(in)  :: ind_arr       
         !! Index array [1, 2, ..., n]
      class(encounter_list),              intent(out) :: lenci         
         !! Output encounter lists containing number of encounters, the v.dot.r direction array, and the index list of encountering
         !! bodies 
      ! Internals
      integer(I4B) :: j
      integer(I8B) :: nenci
      real(DP) :: xr, yr, zr, vxr, vyr, vzr, renc12
      logical, dimension(n) :: lencounteri, lvdotri

#ifdef DOCONLOC
      do concurrent(j = i+1:n) shared(lencounteri, lvdotri, renci, renc) local(xr,yr,zr,vxr,vyr,vzr,renc12)
#else
      do concurrent(j = i+1:n)
#endif
         xr = x(j) - xi
         yr = y(j) - yi
         zr = z(j) - zi
         vxr = vx(j) - vxi
         vyr = vy(j) - vyi
         vzr = vz(j) - vzi
         renc12 = renci + renc(j)
         call encounter_check_one(xr, yr, zr, vxr, vyr, vzr, renc12, dt, lencounteri(j), lvdotri(j))
      end do
      nenci = count(lencounteri(i+1:n))
      if (nenci > 0_I8B) then
         allocate(lenci%lvdotr(nenci), lenci%index1(nenci), lenci%index2(nenci))
         lenci%nenc = nenci
         lenci%index1(:) = i
         lenci%index2(:) = pack(ind_arr(i+1:n), lencounteri(i+1:n)) 
         lenci%lvdotr(:) = pack(lvdotri(i+1:n), lencounteri(i+1:n)) 
      end if

      return
   end subroutine encounter_check_all_triangular_one


   subroutine encounter_check_all_triangular_plpl(npl, r, v, renc, dt, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies. Split off from the main subroutine for performance
      !! This is the upper triangular (double loop) version.
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)  :: npl    
         !! Total number of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: r      
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: v      
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:),              intent(in)  :: renc   
         !! Critical radii of massive bodies that defines an encounter 
      real(DP),                                intent(in)  :: dt     
         !! Step size
      integer(I8B),                            intent(out) :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out) :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out) :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      integer(I4B) :: i
      integer(I4B), dimension(:), allocatable, save :: ind_arr
      type(collision_list_plpl), dimension(npl) :: lenc

      call swiftest_util_index_array(ind_arr, npl) 

      !$omp parallel do default(private) schedule(static)&
      !$omp shared(r, v, renc, lenc, ind_arr) &
      !$omp firstprivate(npl, dt)
      do i = 1,npl
         call encounter_check_all_triangular_one(i, npl, r(1,i), r(2,i), r(3,i), &
                                                         v(1,i), v(2,i), v(3,i), &
                                                         r(1,:), r(2,:), r(3,:), &
                                                         v(1,:), v(2,:), v(3,:), &
                                                         renc(i), renc(:), dt, ind_arr(:), lenc(i))
         if (lenc(i)%nenc > 0) lenc(i)%index1(:) = i
      end do
      !$omp end parallel do

      call encounter_check_collapse_ragged_list(lenc, npl, nenc, index1, index2, lvdotr)

      return
   end subroutine encounter_check_all_triangular_plpl


   subroutine encounter_check_all_triangular_plplm(nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, &
                                                   nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies and test particles. Split off from the main subroutine for performance
      !! This is the upper triangular (double loop) version.
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)  :: nplm   
         !! Total number of fully interacting massive bodies 
      integer(I4B),                            intent(in)  :: nplt   
         !! Total number of partially interacting masive bodies (GM < GMTINY) 
      real(DP),     dimension(:,:),            intent(in)  :: rplm   
         !! Position vectors of fully interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vplm   
         !! Velocity vectors of fully interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: rplt   
         !! Position vectors of partially interacting massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vplt   
         !! Velocity vectors of partially interacting massive bodies
      real(DP),     dimension(:),              intent(in)  :: rencm  
         !! Critical radii of fully interacting massive bodies that defines an encounter
      real(DP),     dimension(:),              intent(in)  :: renct  
         !! Critical radii of partially interacting massive bodies that defines an encounter
      real(DP),                                intent(in)  :: dt     
         !! Step size
      integer(I8B),                            intent(out) :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out) :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out) :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      integer(I4B) :: i
      integer(I4B), dimension(:), allocatable, save :: ind_arr
      type(collision_list_plpl), dimension(nplm) :: lenc

      call swiftest_util_index_array(ind_arr, nplt)

      !$omp parallel do default(private) schedule(dynamic)&
      !$omp shared(rplm, vplm, rplt, vplt, rencm, renct, lenc, ind_arr) &
      !$omp firstprivate(nplm, nplt, dt)
      do i = 1, nplm
         call encounter_check_all_triangular_one(0, nplt, rplm(1,i), rplm(2,i), rplm(3,i), &
                                                          vplm(1,i), vplm(2,i), vplm(3,i), &
                                                          rplt(1,:), rplt(2,:), rplt(3,:), &
                                                          vplt(1,:), vplt(2,:), vplt(3,:), &
                                                          rencm(i), renct(:), dt, ind_arr(:), lenc(i))
         if (lenc(i)%nenc > 0) lenc(i)%index1(:) = i
      end do
      !$omp end parallel do

      call encounter_check_collapse_ragged_list(lenc, nplm, nenc, index1, index2, lvdotr)

      return
   end subroutine encounter_check_all_triangular_plplm


   subroutine encounter_check_all_triangular_pltp(npl, ntp, rpl, vpl, rtp, vtp, renc, dt, &
                                                  nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Check for encounters between massive bodies and test particles. Split off from the main subroutine for performance
      !! This is the upper triangular (double loop) version.
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)  :: npl    
         !! Total number of massive bodies 
      integer(I4B),                            intent(in)  :: ntp    
         !! Total number of test particles 
      real(DP),     dimension(:,:),            intent(in)  :: rpl    
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vpl    
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: rtp    
         !! Position vectors of massive bodies
      real(DP),     dimension(:,:),            intent(in)  :: vtp    
         !! Velocity vectors of massive bodies
      real(DP),     dimension(:),              intent(in)  :: renc   
         !! Critical radii of massive bodies that defines an encounter
      real(DP),                                intent(in)  :: dt     
         !! Step size
      integer(I8B),                            intent(out) :: nenc   
         !! Total number of encounters
      integer(I4B), dimension(:), allocatable, intent(out) :: index1 
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(out) :: index2 
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(out) :: lvdotr 
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      integer(I4B) :: i
      integer(I4B), dimension(:), allocatable, save :: ind_arr
      type(collision_list_pltp), dimension(npl) :: lenc
      real(DP), dimension(ntp) :: renct

      call swiftest_util_index_array(ind_arr, ntp)
      renct(:) = 0.0_DP

      !$omp parallel do default(private) schedule(dynamic)&
      !$omp shared(rpl, vpl, rtp, vtp, renc, renct, lenc, ind_arr) &
      !$omp firstprivate(npl, ntp, dt)
      do i = 1, npl
         call encounter_check_all_triangular_one(0, ntp, rpl(1,i), rpl(2,i), rpl(3,i), &
                                                         vpl(1,i), vpl(2,i), vpl(3,i), &
                                                         rtp(1,:), rtp(2,:), rtp(3,:), &
                                                         vtp(1,:), vtp(2,:), vtp(3,:), &
                                                         renc(i), renct(:), dt, ind_arr(:), lenc(i))
         if (lenc(i)%nenc > 0) lenc(i)%index1(:) = i
      end do
      !$omp end parallel do

      call encounter_check_collapse_ragged_list(lenc, npl, nenc, index1, index2, lvdotr)

      return
   end subroutine encounter_check_all_triangular_pltp


   elemental module subroutine encounter_check_one(xr, yr, zr, vxr, vyr, vzr, renc, dt, lencounter, lvdotr)
      !! author: David A. Minton
      !!
      !! Determine whether a test particle and planet are having or will have an encounter within the next time step
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: rmvs_chk_ind.f90
      !! Adapted from Hal Levison's Swift routine rmvs_chk_ind.f
      implicit none
      ! Arguments
      real(DP), intent(in)  :: xr, yr, zr    
         !! Relative distance vector components
      real(DP), intent(in)  :: vxr, vyr, vzr 
         !! Relative velocity vector components
      real(DP), intent(in)  :: renc        
         !! Square of the critical encounter distance
      real(DP), intent(in)  :: dt            
         !! Step size
      logical,  intent(out) :: lencounter    
         !! Flag indicating that an encounter has occurred
      logical,  intent(out) :: lvdotr        
         !! Logical flag indicating the direction of the v .dot. r vector
      ! Internals
      real(DP) :: r2crit, r2min, r2, v2, vdotr, tmin

      r2 = xr**2 + yr**2 + zr**2
      r2crit = renc**2

      if (r2 > r2crit) then 
         vdotr = vxr * xr + vyr * yr + vzr * zr
         if (vdotr > 0.0_DP) then
            r2min = r2
         else
            v2 = vxr**2 + vyr**2 + vzr**2
            if (v2 <= VSMALL) then
               r2min = r2
            else
               tmin = -vdotr / v2
         
               if (tmin < dt) then
                  r2min = r2 - vdotr**2 / v2
               else
                  r2min = r2 + 2 * vdotr * dt + v2 * dt**2
               end if
            end if
         end if
      else
         vdotr = -1.0_DP
         r2min = r2
      end if

      lvdotr = (vdotr < 0.0_DP)
      lencounter = lvdotr .and. (r2min <= r2crit) 

      return
   end subroutine encounter_check_one


   module subroutine encounter_check_collapse_ragged_list(ragged_list, n1, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!    
      !! Collapses a ragged index list (one encounter list per body) into a pair of index arrays and a vdotr logical array (optional)
      implicit none
      ! Arguments
      class(encounter_list), dimension(:),              intent(in)            :: ragged_list 
         !! The ragged encounter list
      integer(I4B),                                     intent(in)            :: n1          
         !! Number of bodies 1
      integer(I8B),                                     intent(out)           :: nenc        
         !! Total number of encountersj 
      integer(I4B),          dimension(:), allocatable, intent(out)           :: index1      
         !! Array of indices for body 1
      integer(I4B),          dimension(:), allocatable, intent(out)           :: index2      
         !! Array of indices for body 1
      logical,               dimension(:), allocatable, intent(out), optional :: lvdotr      
         !! Array indicating which bodies are approaching
      ! Internals
      integer(I4B) :: i
      integer(I8B) :: j1, j0, nenci
      integer(I8B), dimension(n1) :: ibeg

      associate(nenc_arr => ragged_list(:)%nenc)
         nenc = sum(nenc_arr(:))
      end associate
      if (nenc == 0) return

      allocate(index1(nenc))
      allocate(index2(nenc))
      if (present(lvdotr)) allocate(lvdotr(nenc))

      j0 = 1
      do i = 1, n1
         nenci = ragged_list(i)%nenc
         if (nenci == 0) cycle
         ibeg(i) = j0
         j0 = j0 + nenci
      end do

      !$omp parallel do simd default(private) schedule(simd: static)&
      !$omp shared(ragged_list, index1, index2, ibeg, lvdotr) &
      !$omp firstprivate(n1)
      do i = 1,n1
         if (ragged_list(i)%nenc == 0_I8B) cycle
         nenci = ragged_list(i)%nenc
         j0 = ibeg(i)
         j1 = j0 + nenci - 1_I8B
         index1(j0:j1) = ragged_list(i)%index1(:)
         index2(j0:j1) = ragged_list(i)%index2(:)
         if (present(lvdotr)) lvdotr(j0:j1) = ragged_list(i)%lvdotr(:)
      end do
      !$omp end parallel do simd

      return
   end subroutine encounter_check_collapse_ragged_list


   subroutine encounter_check_remove_duplicates(n, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Takes the candidate encounter lists that came out of the sort & sweep method and remove any duplicates.
      implicit none
      ! Arguments
      integer(I4B),                            intent(in)    :: n          
         !! Number of bodies 
      integer(I8B),                            intent(inout) :: nenc       
         !! Number of encountering bodies (input is the broad phase value, output is the final narrow phase value)
      integer(I4B), dimension(:), allocatable, intent(inout) :: index1     
         !! List of indices for body 1 in each encounter
      integer(I4B), dimension(:), allocatable, intent(inout) :: index2     
         !! List of indices for body 2 in each encounter
      logical,      dimension(:), allocatable, intent(inout) :: lvdotr     
         !! Logical flag indicating the sign of v .dot. x
      ! Internals
      integer(I4B) :: i, i0
      integer(I8B) :: j, k, klo, khi, nenci
      integer(I4B), dimension(:), allocatable :: itmp
      integer(I8B), dimension(:), allocatable :: ind
      integer(I8B), dimension(n) :: ibeg, iend
      logical, dimension(:), allocatable :: ltmp
      logical, dimension(nenc) :: lencounter

      if (nenc == 0) then
         if (allocated(index1)) deallocate(index1)
         if (allocated(index2)) deallocate(index2)
         if (allocated(lvdotr)) deallocate(lvdotr)
         return
      end if

      call util_sort(index1, ind)
      call util_sort_rearrange(index1, ind, nenc)
      call util_sort_rearrange(index2, ind, nenc)
      call util_sort_rearrange(lvdotr, ind, nenc)

      ! Get the bounds on the bodies in the first index
      ibeg(:) = n
      iend(:) = 1_I8B
      i0 = index1(1) 
      ibeg(i0) = 1_I8B
      do k = 2_I8B, nenc 
         i = index1(k)
         if (i /= i0) then
            iend(i0) = k - 1_I8B
            ibeg(i) = k
            i0 = i
         end if
         if (k == nenc) iend(i) = k
      end do

      lencounter(:) = .true.
      ! Sort on the second index and remove duplicates 
      if (allocated(itmp)) deallocate(itmp)
      allocate(itmp, source=index2)
#ifdef DOCONLOC
      do concurrent(i = 1:n, iend(i) - ibeg(i) > 0_I8B) shared(iend,ibeg,index2,lencounter,itmp) local(klo,khi,nenci,j)
#else
      do concurrent(i = 1:n, iend(i) - ibeg(i) > 0_I8B)
#endif
         klo = ibeg(i)
         khi = iend(i)
         nenci = khi - klo + 1_I8B
         if (allocated(ind)) deallocate(ind)
         call util_sort(index2(klo:khi), ind)
         index2(klo:khi) = itmp(klo - 1_I8B + ind(:))
         do j = klo + 1_I8B, khi
            if (index2(j) == index2(j - 1_I8B)) lencounter(j) = .false. 
         end do
      end do

      if (count(lencounter(:)) == nenc) return
      nenc = count(lencounter(:)) ! Count the true number of encounters

      if (allocated(itmp)) deallocate(itmp)
      allocate(itmp(nenc))
      itmp(:) = pack(index1(:), lencounter(:))
      call move_alloc(itmp, index1)

      allocate(itmp(nenc))
      itmp(:) = pack(index2(:), lencounter(:))
      call move_alloc(itmp, index2)

      allocate(ltmp(nenc))
      ltmp(:) = pack(lvdotr(:), lencounter(:))
      call move_alloc(ltmp, lvdotr)

      return
   end subroutine encounter_check_remove_duplicates


   pure module subroutine encounter_check_sort_aabb_1D(self, n, extent_arr)
      !! author: David A. Minton
      !!
      !! Sorts the bounding box extents along a single dimension prior to the sweep phase. 
      !! This subroutine sets the sorted index array (ind) and the beginning/ending index list (beg & end)
      implicit none
      ! Arguments
      class(encounter_bounding_box_1D), intent(inout) :: self       
         !! Bounding box structure along a single dimension
      integer(I4B),                     intent(in)    :: n          
         !! Number of bodies with extents
      real(DP), dimension(:),           intent(in)    :: extent_arr 
         !! Array of extents of size 2*n
      ! Internals
      integer(I8B) :: i, k

      call util_sort(extent_arr, self%ind)

#ifdef DOCONLOC
      do concurrent(k = 1_I8B:2_I8B * n) shared(self,n) local(i)
#else
      do concurrent(k = 1_I8B:2_I8B * n)
#endif
         i = self%ind(k)
         if (i <= n) then
            self%ibeg(i) = k
         else
            self%iend(i - n) = k
         end if
      end do

      return
   end subroutine encounter_check_sort_aabb_1D 


   module subroutine encounter_check_sweep_aabb_double_list(self, n1, n2, r1, v1, r2, v2, renc1, renc2, dt, &
                                                            nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Sweeps the sorted bounding box extents and returns the true encounters (combines broad and narrow phases)
      !! Double list version (e.g. pl-tp or plm-plt)
      implicit none
      ! Arguments
      class(encounter_bounding_box),           intent(inout) :: self       
         !! Multi-dimensional bounding box structure
      integer(I4B),                            intent(in)    :: n1         
         !! Number of bodies 1
      integer(I4B),                            intent(in)    :: n2         
         !! Number of bodies 2
      real(DP),     dimension(:,:),            intent(in)    :: r1, v1     
         !! Array of position and velocity vectorrs for bodies 1
      real(DP),     dimension(:,:),            intent(in)    :: r2, v2     
         !! Array of position and velocity vectorrs for bodies 2
      real(DP),     dimension(:),              intent(in)    :: renc1      
         !! Radius of encounter regions of bodies 1
      real(DP),     dimension(:),              intent(in)    :: renc2      
         !! Radius of encounter regions of bodies 2
      real(DP),                                intent(in)    :: dt         
         !! Step size
      integer(I8B),                            intent(out)   :: nenc       
         !! Total number of encounter candidates
      integer(I4B), dimension(:), allocatable, intent(out)   :: index1     
         !! List of indices for body 1 in each encounter candidate pair
      integer(I4B), dimension(:), allocatable, intent(out)   :: index2     
         !! List of indices for body 2 in each encounter candidate pair
      logical,      dimension(:), allocatable, intent(out)   :: lvdotr     
         !! Logical array indicating which pairs are approaching
      ! Internals
      integer(I4B) :: ii, i, ntot, nbox, dim
      logical, dimension(n1+n2) :: loverlap
      logical, dimension(2*(n1+n2)) :: llist1
      integer(I4B), dimension(2*(n1+n2)) :: ext_ind
      type(collision_list_pltp), dimension(n1+n2) :: lenc         
         !! Array of encounter lists (one encounter list per body)
      integer(I4B), dimension(:), allocatable, save :: ind_arr
      integer(I8B) :: ibeg, iend
      real(DP), dimension(2*(n1+n2)) :: xind, yind, zind, vxind, vyind, vzind, rencind

      ntot = n1 + n2
      call swiftest_util_index_array(ind_arr, ntot)

      loverlap(:) = (self%aabb%ibeg(:) + 1_I8B) < (self%aabb%iend(:) - 1_I8B)
      where(self%aabb%ind(:) > ntot)
         ext_ind(:) = self%aabb%ind(:) - ntot
      elsewhere
         ext_ind(:) = self%aabb%ind(:)
      endwhere
      llist1(:) = ext_ind(:) <= n1
      where(.not.llist1(:)) ext_ind(:) = ext_ind(:) - n1


      dim = 1
      where(llist1(:))
         xind(:) = r1(1,ext_ind(:))
         yind(:) = r1(2,ext_ind(:))
         zind(:) = r1(3,ext_ind(:))
         vxind(:) = v1(1,ext_ind(:))
         vyind(:) = v1(2,ext_ind(:))
         vzind(:) = v1(3,ext_ind(:))
         rencind(:) = renc1(ext_ind(:))
      elsewhere
         xind(:) = r2(1,ext_ind(:))
         yind(:) = r2(2,ext_ind(:))
         zind(:) = r2(3,ext_ind(:))
         vxind(:) = v2(1,ext_ind(:))
         vyind(:) = v2(2,ext_ind(:))
         vzind(:) = v2(3,ext_ind(:))
         rencind(:) = renc2(ext_ind(:))
      endwhere

      where(.not.loverlap(:)) lenc(:)%nenc = 0
      !$omp parallel default(private) &
      !$omp shared(self, ext_ind, lenc, loverlap, r1, v1, r2, v2, renc1, renc2, xind, yind, zind, vxind, vyind, vzind, rencind, &
      !$omp        llist1) &
      !$omp firstprivate(ntot, n1, n2, dt, dim) 
     
      ! Do the first group of bodies (i is in list 1, all the others are from list 2)
      !$omp do schedule(static)
      do i = 1, n1
         if (loverlap(i)) then
            ibeg =  self%aabb%ibeg(i) + 1_I8B
            iend =  self%aabb%iend(i) - 1_I8B
            nbox = int(iend - ibeg, kind=I4B) + 1
            call encounter_check_all_sweep_one(i, nbox, r1(1,i), r1(2,i), r1(3,i), v1(1,i), v1(2,i), v1(3,i), &
                                                         xind(ibeg:iend), yind(ibeg:iend), zind(ibeg:iend),&
                                                         vxind(ibeg:iend), vyind(ibeg:iend), vzind(ibeg:iend), &
                                                         renc1(i), rencind(ibeg:iend), dt, ext_ind(ibeg:iend), &
                                                         .not.llist1(ibeg:iend), lenc(i)%nenc, lenc(i)%index1, lenc(i)%index2, &
                                                         lenc(i)%lvdotr)
         end if
      end do
      !$omp end do nowait

      ! Do the second group of bodies (i is in list 2, all the others are in list 1)
      !$omp do schedule(static)
      do i = n1+1, ntot
         if (loverlap(i)) then
            ibeg =  self%aabb%ibeg(i) + 1_I8B
            iend =  self%aabb%iend(i) - 1_I8B
            nbox = int(iend - ibeg, kind=I4B) + 1
            ii = i - n1
            call encounter_check_all_sweep_one(ii, nbox, r2(1,ii), r2(2,ii), r2(3,ii), v2(1,ii), v2(2,ii), v2(3,ii), &
                                                          xind(ibeg:iend), yind(ibeg:iend), zind(ibeg:iend),&
                                                          vxind(ibeg:iend), vyind(ibeg:iend), vzind(ibeg:iend), &
                                                          renc2(ii), rencind(ibeg:iend), dt, ext_ind(ibeg:iend), &
                                                          llist1(ibeg:iend), lenc(i)%nenc, lenc(i)%index2, lenc(i)%index1, &
                                                          lenc(i)%lvdotr)
         end if
      end do
      !$omp end do nowait

      !$omp end parallel

      call encounter_check_collapse_ragged_list(lenc, ntot, nenc, index1, index2, lvdotr)

      call encounter_check_remove_duplicates(ntot, nenc, index1, index2, lvdotr)

      return
   end subroutine encounter_check_sweep_aabb_double_list


   module subroutine encounter_check_sweep_aabb_single_list(self, n, r, v, renc, dt, nenc, index1, index2, lvdotr)
      !! author: David A. Minton
      !!
      !! Sweeps the sorted bounding box extents and returns the true encounters (combines broad and narrow phases)
      !! Single list version (e.g. pl-pl)
      implicit none
      ! Arguments
      class(encounter_bounding_box),           intent(inout) :: self       
         !! Multi-dimensional bounding box structure
      integer(I4B),                            intent(in)    :: n          
         !! Number of bodies
      real(DP),     dimension(:,:),            intent(in)    :: r, v       
         !! Array of position and velocity vectors 
      real(DP),     dimension(:),              intent(in)    :: renc       
         !! Radius of encounter regions of bodies 1
      real(DP),                                intent(in)    :: dt         
         !! Step size
      integer(I8B),                            intent(out)   :: nenc       
         !! Total number of encounter candidates
      integer(I4B), dimension(:), allocatable, intent(out)   :: index1     
         !! List of indices for one body in each encounter candidate pair
      integer(I4B), dimension(:), allocatable, intent(out)   :: index2     
         !! List of indices for the other body in each encounter candidate pair
      logical,      dimension(:), allocatable, intent(out)   :: lvdotr     
         !! Logical array indicating which pairs are approaching
      ! Internals
      integer(I4B) :: i, dim, itmp, nbox
      integer(I8B) :: k
      logical, dimension(n) :: loverlap
      logical, dimension(2*n) :: lencounteri
      real(DP), dimension(2*n) :: xind, yind, zind, vxind, vyind, vzind, rencind
      integer(I4B), dimension(2*n) :: ext_ind
      type(collision_list_plpl), dimension(n) :: lenc         
         !! Array of encounter lists (one encounter list per body)
      integer(I4B), dimension(:), allocatable, save :: ind_arr
      integer(I8B) :: ibeg, iend

      call swiftest_util_index_array(ind_arr, n)
      dim = 1

      ! Sweep the intervals for each of the massive bodies along one dimension
      ! This will build a ragged pair of index lists inside of the lenc data structure
      where(self%aabb%ind(:) > n)
         ext_ind(:) = self%aabb%ind(:) - n
      elsewhere
         ext_ind(:) = self%aabb%ind(:)
      endwhere

      xind(:) = r(1,ext_ind(:))
      yind(:) = r(2,ext_ind(:))
      zind(:) = r(3,ext_ind(:))
      vxind(:) = v(1,ext_ind(:))
      vyind(:) = v(2,ext_ind(:))
      vzind(:) = v(3,ext_ind(:))
      rencind(:) = renc(ext_ind(:))

      loverlap(:) = (self%aabb%ibeg(:) + 1_I8B) < (self%aabb%iend(:) - 1_I8B)
      where(.not.loverlap(:)) lenc(:)%nenc = 0

      !$omp parallel do default(private) schedule(static)&
      !$omp shared(self, ext_ind, lenc, loverlap, r, v, renc, xind, yind, zind, vxind, vyind, vzind, rencind) &
      !$omp firstprivate(n, dt, dim) 
      do i = 1, n
         if (loverlap(i)) then
            ibeg =  self%aabb%ibeg(i) + 1_I8B
            iend =  self%aabb%iend(i) - 1_I8B
            nbox = int(iend - ibeg, kind=I4B) + 1
            lencounteri(ibeg:iend) = .true.
            call encounter_check_all_sweep_one(i, nbox, r(1,i), r(2,i), r(3,i), v(1,i), v(2,i), v(3,i), &
                                                      xind(ibeg:iend), yind(ibeg:iend), zind(ibeg:iend),&
                                                      vxind(ibeg:iend), vyind(ibeg:iend), vzind(ibeg:iend), &
                                                      renc(i), rencind(ibeg:iend), dt, ext_ind(ibeg:iend), &
                                                      lencounteri(ibeg:iend), lenc(i)%nenc, lenc(i)%index1, lenc(i)%index2, &
                                                      lenc(i)%lvdotr)
            end if
      end do
      !$omp end parallel do

      call encounter_check_collapse_ragged_list(lenc, n, nenc, index1, index2, lvdotr)

      ! By convention, we always assume that index1 < index2, and so we must swap any that are out of order
#ifdef DOCONLOC
      do concurrent(k = 1_I8B:nenc, index1(k) > index2(k)) shared(index1,index2) local(itmp)
#else
      do concurrent(k = 1_I8B:nenc, index1(k) > index2(k))
#endif
         itmp = index1(k)
         index1(k) = index2(k)
         index2(k) = itmp
      end do

      call encounter_check_remove_duplicates(n, nenc, index1, index2, lvdotr)

      return
   end subroutine encounter_check_sweep_aabb_single_list

end submodule s_encounter_check

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

  submodule (symba) s_symba_drift
   use swiftest
contains

   module subroutine symba_drift_pl(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Wrapper function used to call the body drift routine from a symba_pl structure
      implicit none
      ! Arguments
      class(symba_pl),              intent(inout) :: self   !! Helio massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Stepsize

      if (self%nbody == 0) return
      associate(pl => self, npl => self%nbody)
         select type(nbody_system)
         class is (symba_nbody_system)
            pl%lmask(1:npl) = pl%status(1:npl) /= INACTIVE .and. pl%levelg(1:npl) == nbody_system%irec
            call helio_drift_body(pl, nbody_system, param, dt)
            pl%lmask(1:npl) = pl%status(1:npl) /= INACTIVE 
         end select
      end associate

      return
   end subroutine symba_drift_pl


   module subroutine symba_drift_tp(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Wrapper function used to call the body drift routine from a symba_pl structure
      implicit none
      ! Arguments
      class(symba_tp),              intent(inout) :: self   !! Helio massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Stepsize

      if (self%nbody == 0) return
      associate (tp => self, ntp => self%nbody)
         select type(nbody_system)
         class is (symba_nbody_system)
            tp%lmask(1:ntp) = tp%status(1:ntp) /= INACTIVE .and. tp%levelg(1:ntp) == nbody_system%irec
            call helio_drift_body(tp, nbody_system, param, dt)
            tp%lmask(1:ntp) = tp%status(1:ntp) /= INACTIVE 
         end select
      end associate

      return
   end subroutine symba_drift_tp

end submodule s_symba_drift

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(rmvs) s_rmvs_step
   use swiftest
contains

   module subroutine rmvs_step_system(self, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step massive bodies and and active test particles ahead in heliocentric coordinates
      !! 
      !! Adapted from Hal Levison's Swift routine rmvs3_step.f
      !! Adapted from David E. Kaufmann's Swifter routine rmvs_step.f90
      implicit none
      ! Arguments
      class(rmvs_nbody_system),   intent(inout)  :: self   !! RMVS nbody system object
      class(swiftest_parameters), intent(inout)  :: param  !! Current run configuration parameters 
      real(DP),                   intent(in)    :: t     !! Current simulation time
      real(DP),                   intent(in)    :: dt    !! Current stepsiz
      ! Internals
      logical :: lencounter, lfirstpl
      real(DP), dimension(:,:), allocatable :: rbeg, rend, vbeg

      if ((self%tp%nbody == 0) .or. (self%pl%nbody == 0)) then
         call whm_step_system(self, param, t, dt)
      else
         select type(cb => self%cb)
         class is (rmvs_cb)
            select type(pl => self%pl)
            class is (rmvs_pl)
               select type(tp => self%tp)
               class is (rmvs_tp)
                  associate(nbody_system => self, ntp => tp%nbody, npl => pl%nbody)
                     allocate(rbeg, source=pl%rh)
                     allocate(vbeg, source=pl%vh)
                     call pl%set_beg_end(rbeg = rbeg, vbeg = vbeg)
                     ! ****** Check for close encounters ***** !
                     call pl%set_renc(RHSCALE)
                     lencounter = tp%encounter_check(param, nbody_system, dt)
                     if (lencounter) then
                        lfirstpl = pl%lfirst
                        pl%outer(0)%x(:, 1:npl) = rbeg(:, 1:npl)
                        pl%outer(0)%v(:, 1:npl) = vbeg(:, 1:npl)
                        call pl%step(nbody_system, param, t, dt) 
                        pl%outer(NTENC)%x(:, 1:npl) = pl%rh(:, 1:npl)
                        pl%outer(NTENC)%v(:, 1:npl) = pl%vh(:, 1:npl)
                        call rmvs_interp_out(cb, pl, dt)
                        call rmvs_step_out(cb, pl, tp, nbody_system, param, t, dt) 
                        tp%lmask(1:ntp) = .not. tp%lmask(1:ntp)
                        call pl%set_beg_end(rbeg = rbeg, rend = rend)
                        tp%lfirst = .true.
                        call tp%step(nbody_system, param, t, dt)
                        tp%lmask(1:ntp) = .true.
                        pl%lfirst = lfirstpl
                        tp%lfirst = .true.
                        ! if (param%ltides) call nbody_system%step_spin(param, t, dt)
                     else
                        call whm_step_system(nbody_system, param, t, dt)
                     end if
                  end associate
               end select
            end select
         end select
      end if

      return
   end subroutine rmvs_step_system 


   subroutine rmvs_interp_out(cb, pl, dt)
      !! author: David A. Minton
      !!
      !! Interpolate planet positions between two Keplerian orbits in outer encounter region
      !!
      !! Adapted from David E. Kaufmann's Swifter routine rmvs_interp_out.f90 
      !!
      !! Adapted from Hal Levison's Swift routine rmvs3_interp.f
      implicit none
      ! Arguments
      class(rmvs_cb),             intent(inout) :: cb      !! RMVS central body object
      class(rmvs_pl),             intent(inout) :: pl      !! RMVS massive body object
      real(DP),                   intent(in)    :: dt   !! Step size
      ! Internals
      integer(I4B)                              :: i, outer_index
      real(DP)                                  :: frac, dntenc
      real(DP),     dimension(:,:), allocatable :: xtmp, vtmp
      real(DP),     dimension(:),   allocatable :: GMcb, dto
      integer(I4B), dimension(:),   allocatable :: iflag
      character(len=STRMAX) :: message

      dntenc = real(NTENC, kind=DP)
      associate (npl => pl%nbody)
         allocate(xtmp, mold = pl%rh)
         allocate(vtmp, mold = pl%vh)
         allocate(GMcb(npl))
         allocate(dto(npl))
         allocate(iflag(npl))
         dto(1:npl) = dt / dntenc
         GMcb(1:npl) = cb%Gmass
         xtmp(:,1:npl) = pl%outer(0)%x(:, 1:npl)
         vtmp(:,1:npl) = pl%outer(0)%v(:, 1:npl)
         do outer_index = 1, NTENC - 1
            call swiftest_drift_one(GMcb(1:npl), xtmp(1,1:npl), xtmp(2,1:npl), xtmp(3,1:npl), &
                                        vtmp(1,1:npl), vtmp(2,1:npl), vtmp(3,1:npl), &
                                        dto(1:npl), iflag(1:npl))
            if (any(iflag(1:npl) /= 0)) then
               do i = 1, npl
                  if (iflag(i) /= 0) then
                     write(message, *) " Planet ", pl%id(i), " is lost!!!!!!!!!!",new_line('a'), &
                                       GMcb(i), dto(i),new_line('a'), &
                                       xtmp(:,i),new_line('a'), &
                                       vtmp(:,i),new_line('a'), &
                                       " STOPPING "
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT,message)
                     call base_util_exit(FAILURE)
                  end if
               end do
            end if
            frac = 1.0_DP - outer_index / dntenc
            pl%outer(outer_index)%x(:, 1:npl) = frac * xtmp(:, 1:npl)
            pl%outer(outer_index)%v(:, 1:npl) = frac * vtmp(:, 1:npl)
         end do
         xtmp(:, 1:npl) = pl%outer(NTENC)%x(:, 1:npl)
         vtmp(:, 1:npl) = pl%outer(NTENC)%v(:, 1:npl)
         do outer_index = NTENC - 1, 1, -1
            call swiftest_drift_one(GMcb(1:npl), xtmp(1,1:npl), xtmp(2,1:npl), xtmp(3,1:npl), &
                                        vtmp(1,1:npl), vtmp(2,1:npl), vtmp(3,1:npl), &
                                       -dto(1:npl), iflag(1:npl))
            if (any(iflag(1:npl) /= 0)) then
               do i = 1, npl
                  if (iflag(i) /= 0) then
                     write(message, *) " Planet ", pl%id(i), " is lost!!!!!!!!!!",new_line('a'), &
                                       GMcb(i), -dto(i), new_line('a'), &
                                       xtmp(:,i), new_line('a'), &
                                       vtmp(:,i), new_line('a'), &
                                       " STOPPING "
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT,message)
                     call base_util_exit(FAILURE)
                  end if
               end do
            end if
            frac = outer_index / dntenc
            pl%outer(outer_index)%x(:, 1:npl) = pl%outer(outer_index)%x(:, 1:npl) + frac * xtmp(:, 1:npl)
            pl%outer(outer_index)%v(:, 1:npl) = pl%outer(outer_index)%v(:, 1:npl) + frac * vtmp(:, 1:npl)
         end do
      end associate

      return
   end subroutine rmvs_interp_out   


   subroutine rmvs_step_out(cb, pl, tp, nbody_system, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step ACTIVE test particles ahead in the outer encounter region, setting up and calling the inner region
      !!    integration if necessar
      !! 
      !! Adapted from Hal Levison's Swift routines rmvs3_step_out.f and rmvs3_step_out2.f
      !! Adapted from David E. Kaufmann's Swifter routines rmvs_step_out.f90 and rmvs_step_out2.f90
      implicit none
      ! Arguments
      class(rmvs_cb),             intent(inout) :: cb     !! RMVS central body object
      class(rmvs_pl),             intent(inout) :: pl     !! RMVS massive body object
      class(rmvs_tp),             intent(inout) :: tp     !! RMVS test particle object
      class(rmvs_nbody_system),   intent(inout) :: nbody_system !! RMVS nbody system object
      class(swiftest_parameters), intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                   intent(in)    :: t      !! Current simulation time
      real(DP),                   intent(in)    :: dt     !! Current stepsiz
      ! Internals
      integer(I4B)                              :: outer_index, j
      real(DP)                                  :: dto, outer_time
      logical                                   :: lencounter, lfirsttp

      associate(npl => pl%nbody, ntp => tp%nbody)
         dto = dt / NTENC
         where(tp%plencP(1:ntp) == 0)
            tp%lmask(1:ntp) = .false.
         elsewhere  
            tp%lperi(1:ntp) = .false.
         end where
         call pl%set_renc(RHPSCALE)
         do outer_index = 1, NTENC
            outer_time = t + (outer_index - 1) * dto
            call pl%set_beg_end(rbeg = pl%outer(outer_index - 1)%x(:, 1:npl), &
                                vbeg = pl%outer(outer_index - 1)%v(:, 1:npl), &
                                rend = pl%outer(outer_index    )%x(:, 1:npl))
            lencounter = tp%encounter_check(param, nbody_system, dto) 
            if (lencounter) then
               ! Interpolate planets in inner encounter region
               call rmvs_interp_in(cb, pl, nbody_system, param, dto, outer_index) 
               ! Step through the inner region
               call rmvs_step_in(cb, pl, tp, param, outer_time, dto)
               lfirsttp = tp%lfirst
               tp%lfirst = .true.
               call tp%step(nbody_system, param, outer_time, dto)
               tp%lfirst = lfirsttp
            else
               if (param%lnon_spherical_cb) then
                  call swiftest_obl_acc(npl, cb%Gmass, cb%j2rp2, cb%j4rp4, pl%rbeg, pl%lmask, pl%outer(outer_index-1)%aobl, cb%rot,&
                                        pl%Gmass, cb%aoblbeg)
                  call swiftest_obl_acc(npl, cb%Gmass, cb%j2rp2, cb%j4rp4, pl%rend, pl%lmask, pl%outer(outer_index)%aobl, cb%rot, &
                                        pl%Gmass, cb%aoblend)
               end if
               call tp%step(nbody_system, param, outer_time, dto)
            end if
            do j = 1, npl
               if (pl%nenc(j) == 0) cycle
               tp%lfirst = .true.
               where((tp%plencP(1:ntp) == j) .and. (.not.tp%lmask(1:ntp)))
                  tp%lmask(1:ntp) = .true.
               end where 
            end do
         end do
      end associate

      return
   end subroutine rmvs_step_out


   subroutine rmvs_interp_in(cb, pl, nbody_system, param, dt, outer_index)
      !! author: David A. Minton
      !!
      !! Interpolate planet positions between two Keplerian orbits in inner encounter regio
      !!
      !! Adapted from David E. Kaufmann's Swifter routine rmvs_interp_in.f90 
      !!
      !! Adapted from Hal Levison's Swift routine rmvs3_interp.f
      implicit none
      ! Arguments
      class(rmvs_cb),             intent(inout) :: cb          !! RMVS cenral body object
      class(rmvs_pl),             intent(inout) :: pl          !! RMVS massive body object
      class(rmvs_nbody_system),   intent(inout) :: nbody_system      !! RMVS nbody system object
      class(swiftest_parameters), intent(in)    :: param       !! Swiftest parameters file
      real(DP),                   intent(in)    :: dt          !! Step size
      integer(I4B),               intent(in)    :: outer_index !! Outer substep number within current set
      ! Internals
      integer(I4B)                              :: i, inner_index
      real(DP)                                  :: frac, dntphenc
      real(DP),     dimension(:,:), allocatable :: xtmp, vtmp, rh_original, ah_original
      real(DP),     dimension(:),   allocatable :: GMcb, dti
      integer(I4B), dimension(:),   allocatable :: iflag
      character(len=STRMAX) :: message

      associate (npl => nbody_system%pl%nbody)
         dntphenc = real(NTPHENC, kind=DP)

         ! Set the endpoints of the inner region from the outer region values in the current outer step index
         pl%inner(0)%x(:, 1:npl) = pl%outer(outer_index - 1)%x(:, 1:npl)
         pl%inner(0)%v(:, 1:npl) = pl%outer(outer_index - 1)%v(:, 1:npl)
         pl%inner(NTPHENC)%x(:, 1:npl) = pl%outer(outer_index)%x(:, 1:npl)
         pl%inner(NTPHENC)%v(:, 1:npl) = pl%outer(outer_index)%v(:, 1:npl)

         allocate(xtmp,mold=pl%rh)
         allocate(vtmp,mold=pl%vh)
         allocate(GMcb(npl))
         allocate(dti(npl))
         allocate(iflag(npl))
         dti(1:npl) = dt / dntphenc
         GMcb(1:npl) = cb%Gmass
         xtmp(:, 1:npl) = pl%inner(0)%x(:, 1:npl)
         vtmp(:, 1:npl) = pl%inner(0)%v(:, 1:npl)

         if ((param%lnon_spherical_cb) .or. (param%ltides)) then
            allocate(rh_original, source=pl%rh)
            allocate(ah_original, source=pl%ah)
            pl%rh(:, 1:npl) = xtmp(:, 1:npl) ! Temporarily replace heliocentric position with inner substep values to calculate the 
                                             ! oblateness terms
         end if
         if (param%lnon_spherical_cb) then
            call pl%accel_non_spherical_cb(nbody_system)
            pl%inner(0)%aobl(:, 1:npl) = pl%aobl(:, 1:npl) ! Save the oblateness acceleration on the planet for this substep
         end if
         ! TODO: Implement tides
         ! if (param%ltides) then
         !    call pl%accel_tides(nbody_system)
         !    pl%inner(0)%atide(:, 1:npl) = pl%atide(:, 1:npl) ! Save the oblateness acceleration on the planet for this substep
         ! end if

         do inner_index = 1, NTPHENC - 1
            call swiftest_drift_one(GMcb(1:npl), xtmp(1,1:npl), xtmp(2,1:npl), xtmp(3,1:npl), &
                                        vtmp(1,1:npl), vtmp(2,1:npl), vtmp(3,1:npl), &
                                        dti(1:npl), iflag(1:npl))
            if (any(iflag(1:npl) /= 0)) then
               do i = 1, npl
                  if (iflag(i) /=0) then
                     write(message, *) " Planet ", pl%id(i), " is lost!!!!!!!!!!", new_line('a'), &
                                       GMcb(i), dti(i), new_line('a'), &
                                       xtmp(:,i), new_line('a'), &
                                       vtmp(:,i), new_line('a'), &
                                       " STOPPING "
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                     call base_util_exit(FAILURE,param%display_unit)
                  end if
               end do
            end if
            frac = 1.0_DP - inner_index / dntphenc
            pl%inner(inner_index)%x(:, 1:npl) = frac * xtmp(:, 1:npl)
            pl%inner(inner_index)%v(:, 1:npl) = frac * vtmp(:, 1:npl)
         end do

         xtmp(:, 1:npl) = pl%inner(NTPHENC)%x(:, 1:npl)
         vtmp(:, 1:npl) = pl%inner(NTPHENC)%v(:, 1:npl)

         do inner_index = NTPHENC - 1, 1, -1
            call swiftest_drift_one(GMcb(1:npl), xtmp(1,1:npl), xtmp(2,1:npl), xtmp(3,1:npl), &
                                        vtmp(1,1:npl), vtmp(2,1:npl), vtmp(3,1:npl), &
                                        -dti(1:npl), iflag(1:npl))
            if (any(iflag(1:npl) /= 0)) then
               do i = 1, npl
                  if (iflag(i) /=0) then
                     write(*, *) " Planet ", pl%id(i), " is lost!!!!!!!!!!"
                     write(*, *) GMcb(i), -dti(i)
                     write(*, *) xtmp(:,i)
                     write(*, *) vtmp(:,i)
                     write(*, *) " STOPPING "
                     call base_util_exit(FAILURE,param%display_unit)
                  end if
               end do
            end if
            frac = inner_index / dntphenc
            pl%inner(inner_index)%x(:, 1:npl) = pl%inner(inner_index)%x(:, 1:npl) + frac * xtmp(:, 1:npl)
            pl%inner(inner_index)%v(:, 1:npl) = pl%inner(inner_index)%v(:, 1:npl) + frac * vtmp(:, 1:npl)

            if (param%lnon_spherical_cb) then
               pl%rh(:,1:npl) = pl%inner(inner_index)%x(:, 1:npl)
               call pl%accel_non_spherical_cb(nbody_system)
               pl%inner(inner_index)%aobl(:, 1:npl) = pl%aobl(:, 1:npl) 
            end if
            ! TODO: Implement tides
            ! if (param%ltides) then 
            !    call pl%accel_tides(nbody_system)
            !    pl%inner(inner_index)%atide(:, 1:npl) = pl%atide(:, 1:npl)  
            ! end if
         end do
         if (param%lnon_spherical_cb) then
            ! Calculate the final value of oblateness accelerations at the final inner substep
            pl%rh(:, 1:npl) = pl%inner(NTPHENC)%x(:, 1:npl)
            call pl%accel_non_spherical_cb(nbody_system)
            pl%inner(NTPHENC)%aobl(:, 1:npl) = pl%aobl(:, 1:npl) 
         end if
         ! TODO: Implement tides
         ! if (param%ltides) then
         !    call pl%accel_tides(nbody_system)
         !    pl%inner(NTPHENC)%atide(:, 1:npl) = pl%atide(:, 1:npl) 
         ! end if
         ! Put the planet positions and accelerations back into place 
         if (allocated(rh_original)) call move_alloc(rh_original, pl%rh)
         if (allocated(ah_original)) call move_alloc(ah_original, pl%ah)
      end associate
      return

   end subroutine rmvs_interp_in


   subroutine rmvs_step_in(cb, pl, tp, param, outer_time, dto)
      !! author: David A. Minton
      !!
      !! Step active test particles ahead in the inner encounter region
      !! 
      !! Adapted from Hal Levison's Swift routine rmvs3_step_in.f
      !! Adapted from David E. Kaufmann's Swifter routine rmvs_step_in.f90
      implicit none
      ! Arguments
      class(rmvs_cb),             intent(inout) :: cb         !! RMVS central body object
      class(rmvs_pl),             intent(inout) :: pl         !! RMVS massive body object
      class(rmvs_tp),             intent(inout) :: tp         !! RMVS test particle object
      class(swiftest_parameters), intent(inout) :: param      !! Current run configuration parameters 
      real(DP),                   intent(in)    :: outer_time !! Current time
      real(DP),                   intent(in)    :: dto        !! Outer step size
      ! Internals
      logical                                   :: lfirsttp
      integer(I4B)                              :: i, j
      real(DP)                                  :: dti, inner_time

      associate(npl => pl%nbody)
         dti = dto / NTPHENC
         call rmvs_make_planetocentric(param, cb, pl, tp)
         do i = 1, npl
            if (pl%nenc(i) == 0) cycle
            select type(planetocen_system => pl%planetocentric(i))
            class is (rmvs_nbody_system)
               select type(cbenci => planetocen_system%cb)
               class is (rmvs_cb)
                  select type(plenci => planetocen_system%pl)
                  class is (rmvs_pl)
                     select type(tpenci => planetocen_system%tp)
                     class is (rmvs_tp)
                        associate(inner_index => tpenci%index)
                           ! There are inner encounters with this planet...switch to planetocentric coordinates to proceed
                           tpenci%lfirst = .true.
                           inner_time = outer_time
                           call rmvs_peri_tp(tpenci, pl, inner_time, dti, .true., 0, i, param) 
                           ! now step the encountering test particles fully through the inner encounter
                           lfirsttp = .true.
                           do inner_index = 1, NTPHENC ! Integrate over the encounter region, using the "substitute" planetocentric 
                                                       ! systems at each level
                              plenci%rh(:, 1:npl) = plenci%inner(inner_index - 1)%x(:, 1:npl)
                              call plenci%set_beg_end(rbeg = plenci%inner(inner_index - 1)%x, &
                                                      rend = plenci%inner(inner_index)%x)

                              if (param%lnon_spherical_cb) then
                                 cbenci%aoblbeg = cbenci%inner(inner_index - 1)%aobl(:, 1)
                                 cbenci%aoblend = cbenci%inner(inner_index    )%aobl(:, 1)
                              end if
                              if (param%ltides) then
                                 cbenci%atidebeg = cbenci%inner(inner_index - 1)%atide(:, 1)
                                 cbenci%atideend = cbenci%inner(inner_index    )%atide(:, 1)
                              end if

                              call tpenci%step(planetocen_system, param, inner_time, dti)
                              do j = 1, pl%nenc(i)
                                 tpenci%rheliocentric(:, j) = tpenci%rh(:, j) + pl%inner(inner_index)%x(:,i)
                              end do
                              inner_time = outer_time + j * dti
                              call rmvs_peri_tp(tpenci, pl, inner_time, dti, .false., inner_index, i, param) 
                           end do
                           tpenci%lmask(:) = .false.
                        end associate
                     end select
                  end select
               end select
            end select
         end do
         call rmvs_end_planetocentric(pl, tp)
      end associate
      return
   end subroutine rmvs_step_in


   subroutine rmvs_make_planetocentric(param, cb, pl, tp)
      !! author: David A. Minton
      !!
      !! When encounters are detected, this method will call the interpolation methods for the planets and 
      !! creates a Swiftest test particle structure for each planet's encountering test particles to simplify the 
      !! planetocentric calculations. This subroutine is not based on an existing one from Swift and Swifter
      !!
      implicit none
      ! Arguments
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration paramete
      class(rmvs_cb),             intent(inout) :: cb     !! RMVS central body object
      class(rmvs_pl),             intent(inout) :: pl     !! RMVS massive body object
      class(rmvs_tp),             intent(inout) :: tp     !! RMVS test particle object

      ! Internals
      integer(I4B)                        :: i, j, inner_index, ipc2hc
      logical, dimension(:), allocatable  :: encmask

      associate (npl => pl%nbody, ntp => tp%nbody)
         do i = 1, npl
            if (pl%nenc(i) == 0) cycle 
            ! There are inner encounters with this planet
            if (allocated(encmask)) deallocate(encmask)
            allocate(encmask(ntp))
            encmask(1:ntp) = tp%plencP(1:ntp) == i
            allocate(rmvs_tp :: pl%planetocentric(i)%tp)
            ! Create encountering test particle structure
            select type(cbenci => pl%planetocentric(i)%cb)
            class is (rmvs_cb)
               select type(plenci => pl%planetocentric(i)%pl)
               class is (rmvs_pl)
                  select type(tpenci => pl%planetocentric(i)%tp)
                  class is (rmvs_tp)
                     tpenci%lplanetocentric = .true.
                     associate(nenci => pl%nenc(i))
                        call tpenci%setup(nenci, param)
                        tpenci%cb_heliocentric = cb
                        tpenci%ipleP = i
                        tpenci%lmask(1:nenci) = .true.
                        tpenci%status(1:nenci) = ACTIVE
                        ! Grab all the encountering test particles and convert them to a planetocentric frame
                        tpenci%id(1:nenci) = pack(tp%id(1:ntp), encmask(1:ntp)) 
                        do j = 1, NDIM 
                           tpenci%rheliocentric(j, 1:nenci) = pack(tp%rh(j,1:ntp), encmask(:)) 
                           tpenci%rh(j, 1:nenci) = tpenci%rheliocentric(j, 1:nenci) - pl%inner(0)%x(j, i)
                           tpenci%vh(j, 1:nenci) = pack(tp%vh(j, 1:ntp), encmask(1:ntp)) - pl%inner(0)%v(j, i)
                        end do
                        tpenci%lperi(1:nenci) = pack(tp%lperi(1:ntp), encmask(1:ntp)) 
                        tpenci%plperP(1:nenci) = pack(tp%plperP(1:ntp), encmask(1:ntp)) 
                        ! Make sure that the test particles get the planetocentric value of mu 
                        allocate(cbenci%inner(0:NTPHENC))
                        do inner_index = 0, NTPHENC 
                           allocate(plenci%inner(inner_index)%x, mold=pl%inner(inner_index)%x)
                           allocate(plenci%inner(inner_index)%v, mold=pl%inner(inner_index)%x)
                           allocate(cbenci%inner(inner_index)%x(NDIM,1))
                           allocate(cbenci%inner(inner_index)%v(NDIM,1))
                           cbenci%inner(inner_index)%x(:,1)    =  pl%inner(inner_index)%x(:, i) 
                           cbenci%inner(inner_index)%v(:,1)    =  pl%inner(inner_index)%v(:, i) 
                           plenci%inner(inner_index)%x(:,1)    = -cbenci%inner(inner_index)%x(:,1)
                           plenci%inner(inner_index)%v(:,1)    = -cbenci%inner(inner_index)%v(:,1)
   
                           if (param%lnon_spherical_cb) then
                              allocate(plenci%inner(inner_index)%aobl, mold=pl%inner(inner_index)%aobl)
                              allocate(cbenci%inner(inner_index)%aobl(NDIM,1))
                              cbenci%inner(inner_index)%aobl(:,1) =  pl%inner(inner_index)%aobl(:, i) 
                           end if
   
                           if (param%ltides) then  
                              allocate(plenci%inner(inner_index)%atide, mold=pl%inner(inner_index)%atide)
                              allocate(cbenci%inner(inner_index)%atide(NDIM,1))
                              cbenci%inner(inner_index)%atide(:,1) =  pl%inner(inner_index)%atide(:, i) 
                           end if
   
                           do j = 2, npl
                              ipc2hc = plenci%plind(j)
                              plenci%inner(inner_index)%x(:,j) = pl%inner(inner_index)%x(:, ipc2hc) &
                                                                 - cbenci%inner(inner_index)%x(:,1)
                              plenci%inner(inner_index)%v(:,j) = pl%inner(inner_index)%v(:, ipc2hc) &
                                                                 - cbenci%inner(inner_index)%v(:,1)
                           end do
                        end do
                        call tpenci%set_mu(cbenci)
                     end associate
                  end select
               end select
            end select
         end do
      end associate

      return
   end subroutine rmvs_make_planetocentric


   subroutine rmvs_peri_tp(tp, pl, t, dt, lfirst, inner_index, ipleP, param)
      !! author: David A. Minton
      !!
      !! Determine planetocentric pericenter passages for test particles in close encounters with a planet
      !! 
      !! Adapted from Hal Levison's Swift routine Adapted from Hal Levison's Swift routine util_peri.f
      !! Adapted from David E. Kaufmann's Swifter routine rmvs_peri.f90
      implicit none
      ! Arguments
      class(rmvs_tp),             intent(inout) :: tp        !! RMVS test particle object (planetocentric) 
      class(rmvs_pl),             intent(inout) :: pl        !! RMVS massive body object (heliocentric)
      real(DP),                   intent(in)    :: t         !! current time
      real(DP),                   intent(in)    :: dt        !! step size
      logical,                    intent(in)    :: lfirst    !! Logical flag indicating whether current invocation is the first
      integer(I4B),               intent(in)    :: inner_index !! Outer substep number within current set
      integer(I4B),               intent(in)    :: ipleP     !!  index of RMVS planet being closely encountered
      class(swiftest_parameters), intent(in)    :: param    !! Current run configuration parameters
      ! Internals
      integer(I4B)              :: i
      real(DP)                  :: r2, mu, rhill2, vdotr, a, peri, capm, tperi

      rhill2 = pl%rhill(ipleP)**2
      mu = pl%Gmass(ipleP)
      associate(nenc => tp%nbody, xpc => tp%rh, vpc => tp%vh)
         if (lfirst) then
            do i = 1, nenc
               if (tp%lmask(i)) then
                  vdotr = dot_product(xpc(:, i), vpc(:, i))
                  if (vdotr > 0.0_DP) then
                     tp%isperi(i) = 1
                  else
                     tp%isperi(i) = -1
                  end if
               end if
            end do
         else
            do i = 1, nenc
               if (tp%lmask(i)) then
                  vdotr = dot_product(xpc(:, i), vpc(:, i))
                  if (tp%isperi(i) == -1) then
                     if (vdotr >= 0.0_DP) then
                        tp%isperi(i) = 0
                        call swiftest_orbel_xv2aqt(mu, xpc(1,i), xpc(2,i), xpc(3,i), vpc(1,i), vpc(2,i), vpc(3,i), &
                                          a, peri, capm, tperi)
                        r2 = dot_product(xpc(:, i), xpc(:, i))
                        if ((abs(tperi) > FACQDT * dt) .or. (r2 > rhill2)) peri = sqrt(r2)
                        ! TODO: write NetCDF encounter output writer
                        if (tp%lperi(i)) then
                           if (peri < tp%peri(i)) then
                              tp%peri(i) = peri
                              tp%plperP(i) = ipleP
                           end if
                        else
                           tp%lperi(i) = .true.
                           tp%peri(i) = peri
                           tp%plperP(i) = ipleP
                        end if
                     end if
                  else
                     if (vdotr > 0.0_DP) then
                        tp%isperi(i) = 1
                     else
                        tp%isperi(i) = -1
                     end if
                  end if
               end if
            end do                   
         end if
         end associate
      return

   end subroutine rmvs_peri_tp


   subroutine rmvs_end_planetocentric(pl, tp)
      !! author: David A. Minton
      !!
      !! Deallocates all of the encountering particle data structures for next time
      !!
      implicit none
      ! Arguments
      class(rmvs_pl), intent(inout) :: pl     !! RMVS massive body object
      class(rmvs_tp), intent(inout) :: tp     !! RMVS test particle objec
      ! Internals
      integer(I4B) :: i, j, inner_index
      integer(I4B), dimension(:), allocatable :: tpind
      logical, dimension(:), allocatable :: encmask

      associate (npl => pl%nbody, ntp => tp%nbody)
         do i = 1, npl
            if (pl%nenc(i) == 0) cycle
            select type(cbenci => pl%planetocentric(i)%cb)
            class is (rmvs_cb)
               select type(plenci => pl%planetocentric(i)%pl)
               class is (rmvs_pl)
                  select type(tpenci => pl%planetocentric(i)%tp)
                  class is (rmvs_tp)
                     associate(nenci => pl%nenc(i))
                        if (allocated(tpind)) deallocate(tpind)
                        allocate(tpind(nenci))
                        ! Index array of encountering test particles
                        if (allocated(encmask)) deallocate(encmask)
                        allocate(encmask(ntp))
                        encmask(1:ntp) = tp%plencP(1:ntp) == i
                        tpind(1:nenci) = pack([(j,j=1,ntp)], encmask(1:ntp))
               
                        ! Copy the results of the integration back over and shift back to heliocentric reference
                        tp%status(tpind(1:nenci)) = tpenci%status(1:nenci) 
                        tp%lmask(tpind(1:nenci)) = tpenci%lmask(1:nenci) 
                        do j = 1, NDIM
                           tp%rh(j, tpind(1:nenci)) = tpenci%rh(j,1:nenci) + pl%inner(NTPHENC)%x(j, i)
                           tp%vh(j, tpind(1:nenci)) = tpenci%vh(j,1:nenci) + pl%inner(NTPHENC)%v(j, i)
                        end do
                        tp%lperi(tpind(1:nenci)) = tpenci%lperi(1:nenci)
                        tp%plperP(tpind(1:nenci)) = tpenci%plperP(1:nenci)
                        deallocate(pl%planetocentric(i)%tp)
                        deallocate(cbenci%inner)
                        do inner_index = 0, NTPHENC 
                           deallocate(plenci%inner(inner_index)%x) 
                           deallocate(plenci%inner(inner_index)%v) 
                           if (allocated(plenci%inner(inner_index)%aobl))  deallocate(plenci%inner(inner_index)%aobl)
                           if (allocated(plenci%inner(inner_index)%atide)) deallocate(plenci%inner(inner_index)%atide)
                        end do
                     end associate
                  end select
               end select
            end select
         end do
      end associate
      return
   end subroutine rmvs_end_planetocentric
   
end submodule s_rmvs_step

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (encounter) s_encounter_io
   use swiftest
contains

   module subroutine encounter_io_netcdf_dump(self, param)
      ! author: David A. Minton
      !!
      !! Dumps the time history of an encounter to file.
      implicit none
      ! Arguments
      class(encounter_storage), intent(inout) :: self   !! Encounter storage object
      class(base_parameters),      intent(inout) :: param  !! Current run configuration parameters 
      ! Internals
      integer(I4B) :: i

      select type(nc => self%nc)
      class is (encounter_netcdf_parameters)
         if (self%iframe > 0) then
            ! Create and save the output files for this encounter and fragmentation
            call self%make_index_map()
            call nc%open(param)
            do i = 1, self%iframe
               if (allocated(self%frame(i)%item)) then
                  select type(snapshot => self%frame(i)%item)
                  class is (encounter_snapshot)
                     nc%tslot = nc%max_tslot + self%tmap(i)
                     call snapshot%write_frame(self,param)
                  end select
               else
                  exit
               end if
            end do

            nc%max_tslot = nc%max_tslot + maxval(self%tmap(1:self%iframe))
            call nc%close()
            ! Update the time slot tracker
            call self%reset()
         end if
      end select

      return
   end subroutine encounter_io_netcdf_dump


   module subroutine encounter_io_netcdf_initialize_output(self, param)
      !! author: David A. Minton
      !!
      !! Initialize a NetCDF encounter file system. This is a simplified version of the main simulation output NetCDF file, but with
      !! fewer variables.
      use, intrinsic :: ieee_arithmetic
      use netcdf
      implicit none
      ! Arguments
      class(encounter_netcdf_parameters), intent(inout) :: self    !! Parameters used to identify a particular NetCDF dataset
      class(base_parameters),     intent(in)    :: param   !! Current run configuration parameters
      ! Internals
      integer(I4B) :: nvar, varid, vartype
      real(DP) :: dfill
      real(SP) :: sfill
      integer(I4B), parameter :: NO_FILL = 0
      logical :: fileExists
      character(len=STRMAX) :: errmsg
      integer(I4B) :: ndims

      associate(nc => self)
         dfill = ieee_value(dfill, IEEE_QUIET_NAN)
         sfill = ieee_value(sfill, IEEE_QUIET_NAN)

         select case (param%out_type)
         case("NETCDF_FLOAT")
            self%out_type = NF90_FLOAT
         case("NETCDF_DOUBLE")
            self%out_type = NF90_DOUBLE
         case default
            write(*,*) trim(adjustl(param%out_type)), " is an invalid OUT_TYPE"
         end select

         ! Check if the file exists, and if it does, delete it
         inquire(file=nc%file_name, exist=fileExists)
         if (fileExists) then
            open(unit=LUN, file=nc%file_name, status="old", err=667, iomsg=errmsg)
            close(unit=LUN, status="delete")
         end if

         call netcdf_io_check( nf90_create(nc%file_name, NF90_NETCDF4, nc%id), "encounter_io_netcdf_initialize_output nf90_create" )
         nc%lfile_is_open = .true.

         ! Dimensions

         ! Simulation time dimension
         call netcdf_io_check( nf90_def_dim(nc%id, nc%time_dimname, NF90_UNLIMITED, nc%time_dimid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_dim time_dimid" ) 

         ! 3D space dimension
         call netcdf_io_check( nf90_def_dim(nc%id, nc%space_dimname, NDIM, nc%space_dimid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_dim space_dimid" )

         ! dimension to store particle id numbers
         call netcdf_io_check( nf90_def_dim(nc%id, nc%name_dimname, NF90_UNLIMITED, nc%name_dimid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_dim name_dimid" ) 
         
                                    ! Dimension for string variables (aka character arrays)
         call netcdf_io_check( nf90_def_dim(nc%id, nc%str_dimname, NAMELEN, nc%str_dimid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_dim str_dimid"  )

         ! Dimension coordinates
         call netcdf_io_check( nf90_def_var(nc%id, nc%time_dimname, nc%out_type, nc%time_dimid, nc%time_varid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_var time_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%space_dimname, NF90_CHAR, nc%space_dimid, nc%space_varid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_var space_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%name_dimname, NF90_CHAR, [nc%str_dimid, nc%name_dimid], nc%name_varid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_var id_varid"  )
      
         ! Variables
         call netcdf_io_check( nf90_def_var(nc%id, nc%id_varname, NF90_INT, nc%name_dimid, nc%id_varid), &
                                    "encounter_io_netcdf_initialize_output nf90_def_var id_varid" )
         call netcdf_io_check( nf90_def_var(nc%id, nc%ptype_varname, NF90_CHAR, [nc%str_dimid, nc%name_dimid], nc%ptype_varid), &
                                       "encounter_io_netcdf_initialize_output nf90_def_var ptype_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%rh_varname,  nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                           nc%rh_varid), "encounter_io_netcdf_initialize_output nf90_def_var rh_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%vh_varname,  nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                           nc%vh_varid), "encounter_io_netcdf_initialize_output nf90_def_var vh_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%Gmass_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%Gmass_varid), &
                           "encounter_io_netcdf_initialize_output nf90_def_var Gmass_varid"  )
         if (param%lclose) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%radius_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], &
                           nc%radius_varid), "encounter_io_netcdf_initialize_output nf90_def_var radius_varid"  )
         end if
         if (param%lrotation) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%Ip_varname, nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                              nc%Ip_varid), "encounter_io_netcdf_initialize_output nf90_def_var Ip_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%rot_varname, nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                              nc%rot_varid), "encounter_io_netcdf_initialize_output nf90_def_var rot_varid"  )
         end if

         call netcdf_io_check( nf90_inquire(nc%id, nVariables=nvar), &
                              "encounter_io_netcdf_initialize_output nf90_inquire nVariables" )
         do varid = 1, nvar
            call netcdf_io_check( nf90_inquire_variable(nc%id, varid, xtype=vartype, ndims=ndims), &
                                 "encounter_io_netcdf_initialize_output nf90_inquire_variable"  )
            select case(vartype)
            case(NF90_INT)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, NF90_FILL_INT), &
                                 "encounter_io_netcdf_initialize_output nf90_def_var_fill NF90_INT"  )
            case(NF90_FLOAT)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, sfill), &
                                 "encounter_io_netcdf_initialize_output nf90_def_var_fill NF90_FLOAT"  )
            case(NF90_DOUBLE)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, dfill), &
                                 "encounter_io_netcdf_initialize_output nf90_def_var_fill NF90_DOUBLE"  )
            case(NF90_CHAR)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, 0), &
                                 "encounter_io_netcdf_initialize_output nf90_def_var_fill NF90_CHAR"  )
            end select
         end do

         ! Take the file out of define mode
         call netcdf_io_check( nf90_enddef(nc%id), "encounter_io_netcdf_initialize_output nf90_enddef"  )

         ! Add in the space dimension coordinates
         call netcdf_io_check( nf90_put_var(nc%id, nc%space_varid, nc%space_coords, start=[1], count=[NDIM]), &
                           "encounter_io_netcdf_initialize_output nf90_put_var space"  )

      end associate

      return

      667 continue
      write(*,*) "Error creating encounter output file. " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,param%display_unit)
   end subroutine encounter_io_netcdf_initialize_output


   module subroutine encounter_io_netcdf_open(self, param, readonly)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Opens a NetCDF file and does the variable inquiries to activate variable ids
      use netcdf
      implicit none
      ! Arguments
      class(encounter_netcdf_parameters), intent(inout) :: self     !! Parameters used to identify a particular NetCDF dataset
      class(base_parameters),             intent(in)    :: param    !! Current run configuration parameters
      logical, optional,                  intent(in)    :: readonly !! Logical flag indicating that this should be open read only
      ! Internals
      integer(I4B) :: mode
      character(len=STRMAX) :: errmsg
      logical fileExists

      mode = NF90_WRITE
      if (present(readonly)) then
         if (readonly) mode = NF90_NOWRITE
      end if

      select type(param)
      class is (base_parameters)
         associate(nc => self)

            inquire(file=nc%file_name, exist=fileExists)
            if (.not.fileExists) then
               call nc%initialize(param)
               return
            end if

            write(errmsg,*) "encounter_io_netcdf_open nf90_open ",trim(adjustl(nc%file_name))
            call netcdf_io_check( nf90_open(nc%file_name, mode, nc%id), errmsg)
            self%lfile_is_open = .true.

            ! Dimensions
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%time_dimname, nc%time_dimid), &
                                    "encounter_io_netcdf_open nf90_inq_dimid time_dimid"  )
            call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%time_dimid, nc%time_dimname, len=nc%max_tslot), &
                                    "encounter_io_netcdf_open nf90_inquire_dimension max_tslot"  )

            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%space_dimname, nc%space_dimid), &
                                    "encounter_io_netcdf_open nf90_inq_dimid space_dimid"  )
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%name_dimname, nc%name_dimid), &
                                    "encounter_io_netcdf_open nf90_inq_dimid name_dimid"  )
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%str_dimname, nc%str_dimid), &
                                    "encounter_io_netcdf_open nf90_inq_dimid str_dimid"  )

            ! Dimension coordinates
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%time_dimname, nc%time_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid time_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%space_dimname, nc%space_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid space_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%name_dimname, nc%name_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid name_varid" )

            ! Required Variables
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%id_varname, nc%id_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid name_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%ptype_varname, nc%ptype_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid ptype_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%time_dimname, nc%time_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid time_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%rh_varname, nc%rh_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid rh_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%vh_varname, nc%vh_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid vh_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%Gmass_varname, nc%Gmass_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid Gmass_varid" )
            if (param%lclose) then
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%radius_varname, nc%radius_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid radius_varid" )
            end if
            
            if (param%lrotation) then
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%Ip_varname, nc%Ip_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid Ip_varid" )
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%rot_varname, nc%rot_varid), &
                                    "encounter_io_netcdf_open nf90_inq_varid rot_varid" )
            end if

         end associate
      end select 

      return
   end subroutine encounter_io_netcdf_open


   module subroutine encounter_io_netcdf_write_frame_snapshot(self, history, param)
      !! author: David A. Minton
      !!
      !! Write a frame of output of an encounter trajectory.
      use netcdf
      implicit none
      ! Arguments
      class(encounter_snapshot),   intent(in)    :: self              !! Swiftest encounter structure
      class(encounter_storage), intent(inout) :: history !! Encounter storage object
      class(base_parameters),      intent(inout) :: param             !! Current run configuration parameters
 
      ! Internals
      integer(I4B)           :: i, idslot, old_mode, npl, ntp, tmp
      character(len=STRMAX) :: charstring

      select type(param)
      class is (swiftest_parameters)
      select type(pl => self%pl)
      class is (swiftest_pl)
      select type(tp => self%tp)
      class is (swiftest_tp)
      select type (nc => history%nc)
      class is (encounter_netcdf_parameters)
         associate(tslot => nc%tslot)
            call netcdf_io_check( nf90_set_fill(nc%id, NF90_NOFILL, old_mode), &
                                    "encounter_io_netcdf_write_frame_snapshot nf90_set_fill"  )
      
            call netcdf_io_check( nf90_put_var(nc%id, nc%time_varid, self%t, start=[tslot]), &
                                    "encounter_io_netcdf_write_frame_snapshot nf90_put_var time_varid"  )

            npl = pl%nbody
            ! This ensures that there first idslot will have the first body in it, not id 0 which is &
            ! the default for a new idvals array
            if (.not.allocated(nc%idvals)) allocate(nc%idvals, source=pl%id)
            do i = 1, npl
               call nc%find_idslot(pl%id(i), idslot) 
               call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid, pl%id(i),   start=[idslot]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl id_varid"  )
               call netcdf_io_check( nf90_put_var(nc%id, nc%rh_varid, pl%rh(:,i), start=[1,idslot,tslot], count=[NDIM,1,1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl rh_varid"  )
               call netcdf_io_check( nf90_put_var(nc%id, nc%vh_varid, pl%vh(:,i), start=[1,idslot,tslot], count=[NDIM,1,1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl vh_varid"  )
               call netcdf_io_check( nf90_put_var(nc%id, nc%Gmass_varid, pl%Gmass(i), start=[idslot, tslot]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl Gmass_varid"  )

               if (param%lclose) call netcdf_io_check( nf90_put_var(nc%id, nc%radius_varid, pl%radius(i), start=[idslot, tslot]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl radius_varid"  )

               if (param%lrotation) then
                  call netcdf_io_check( nf90_put_var(nc%id, nc%Ip_varid, pl%Ip(:,i), start=[1, idslot, tslot], count=[NDIM,1,1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl Ip_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%rot_varid, pl%rot(:,i), start=[1,idslot, tslot], &
                                       count=[NDIM,1,1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl rotx_varid"  )
               end if

               charstring = trim(adjustl(pl%info(i)%name))
               call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl name_varid"  )
               charstring = trim(adjustl(pl%info(i)%particle_type))
               call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var pl particle_type_varid"  )
            end do

            ntp = tp%nbody
            if (.not.allocated(nc%idvals)) allocate(nc%idvals, source=tp%id)
            do i = 1, ntp
               call nc%find_idslot(tp%id(i), idslot) 
               call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid, tp%id(i), start=[idslot]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var tp id_varid"  )
               call netcdf_io_check( nf90_put_var(nc%id, nc%rh_varid, tp%rh(:,i), start=[1,idslot,tslot], count=[NDIM,1,1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var tp rh_varid"  )
               call netcdf_io_check( nf90_put_var(nc%id, nc%vh_varid, tp%vh(:,i), start=[1,idslot,tslot], count=[NDIM,1,1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var tp vh_varid"  )

               charstring = trim(adjustl(tp%info(i)%name))
               call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var tp name_varid"  )
               charstring = trim(adjustl(tp%info(i)%particle_type))
               call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                       "encounter_io_netcdf_write_frame_snapshot nf90_put_var tp particle_type_varid"  )
            end do

            call netcdf_io_check( nf90_set_fill(nc%id, old_mode, tmp) )
         end associate
      end select
      end select
      end select
      end select

      return
   end subroutine encounter_io_netcdf_write_frame_snapshot

end submodule s_encounter_io

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(collision) s_collision_generate
   use swiftest
contains

   module subroutine collision_generate_basic(self, nbody_system, param, t)
      !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Merge massive bodies no matter the regime
      !! 
      !! Adapted from David E. Kaufmann's Swifter routines symba_merge_pl.f90 and symba_discard_merge_pl.f90
      !!
      !! Adapted from Hal Levison's Swift routines symba5_merge.f and discard_mass_merge.f
      implicit none
      ! Arguments
      class(collision_basic),   intent(inout) :: self         !! Merge fragment system object 
      class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            !! The time of the collision

      call self%merge(nbody_system, param, t)

      return
   end subroutine collision_generate_basic


   module subroutine collision_generate_bounce(self, nbody_system, param, t)
      !! author: David A. Minton
      !!
      !! In this collision model, if the collision would result in a disruption, the bodies are instead "bounced" off 
      !! of the center of mass. This is done as a reflection in the 2-body equivalent distance vector direction.
      implicit none
      ! Arguments
      class(collision_bounce),  intent(inout) :: self         !! Bounce fragment system object 
      class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            !! The time of the collision
      ! Internals
      integer(I4B) :: i,j,nimp
      logical, dimension(:), allocatable :: lmask

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type (pl => nbody_system%pl)
      class is (swiftest_pl)
         associate(impactors => nbody_system%collider%impactors, fragments => nbody_system%collider%fragments)
            allocate(lmask, mold=pl%lmask)
            lmask(:) = .false.
            lmask(impactors%id(:)) = .true.
            select case (impactors%regime) 
            case (COLLRESOLVE_REGIME_DISRUPTION, COLLRESOLVE_REGIME_SUPERCATASTROPHIC)

               ! Manually save the before/after snapshots because this case doesn't use the mergeaddsub procedure
               select type(before => self%before)
               class is (swiftest_nbody_system)
                  allocate(before%pl, mold=pl) 
                  call pl%spill(before%pl, lmask, ldestructive=.false.)
               end select

               nimp = size(impactors%id(:))
               do i = 1, nimp
                  j = impactors%id(i)
                  call collision_util_bounce_one(pl%rb(:,j),pl%vb(:,j),impactors%rbcom(:),impactors%vbcom(:),pl%radius(j))
                  self%status = DISRUPTED
                  pl%status(j) = ACTIVE
                  pl%ldiscard(j) = .false.
                  pl%lcollision(j) = .false.
               end do

               select type(after => self%after)
               class is (swiftest_nbody_system)
                  allocate(after%pl, mold=pl) 
                  call pl%spill(after%pl, lmask, ldestructive=.false.)
               end select

            case (COLLRESOLVE_REGIME_HIT_AND_RUN)
               call self%hitandrun(nbody_system, param, t)
            case (COLLRESOLVE_REGIME_MERGE, COLLRESOLVE_REGIME_GRAZE_AND_MERGE)
               call self%merge(nbody_system, param, t) ! Use the default collision model, which is merge
            case default 
               call swiftest_io_log_one_message(COLLISION_LOG_OUT,"Error in swiftest_collision, unrecognized collision regime")
               call base_util_exit(FAILURE,unit=param%display_unit)
            end select
            end associate
      end select
      end select

      return
   end subroutine collision_generate_bounce

   
   module subroutine collision_generate_hitandrun(self, nbody_system, param, t) 
      !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Create the fragments resulting from a non-catastrophic hit-and-run collision
      !! 
      implicit none
      ! Arguments
      class(collision_basic),   intent(inout) :: self         !! Collision system object
      class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters with SyMBA additions
      real(DP),                 intent(in)    :: t            !! Time of collision
      ! Result
      integer(I4B)                            :: status           !! Status flag assigned to this outcome
      ! Internals
      character(len=STRMAX) :: message
      logical, dimension(:), allocatable :: lmask

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(pl => nbody_system%pl)
      class is (swiftest_pl)
         associate(impactors => self%impactors)

            allocate(lmask, mold=pl%lmask)
            lmask(:) = .false.
            lmask(impactors%id(:)) = .true.

            message = "Hit and run between"
            call collision_io_collider_message(nbody_system%pl, impactors%id, message)
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, trim(adjustl(message)))

            ! Manually save the before/after snapshots because this case doesn't use the mergeaddsub procedure
            select type(before => self%before)
            class is (swiftest_nbody_system)
               allocate(before%pl, mold=pl) 
               call pl%spill(before%pl, lmask, ldestructive=.false.)
            end select

            status = HIT_AND_RUN_PURE
            pl%status(impactors%id(:)) = ACTIVE
            pl%ldiscard(impactors%id(:)) = .false.
            pl%lcollision(impactors%id(:)) = .false.

            select type(after => self%after)
            class is (swiftest_nbody_system)
               allocate(after%pl, mold=pl) 
               call pl%spill(after%pl, lmask, ldestructive=.false.)
            end select

         end associate
      end select
      end select

      return
   end subroutine collision_generate_hitandrun


   module subroutine collision_generate_merge(self, nbody_system, param, t)
      !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Merge massive bodies in any collisional system.
      !! 
      !! Adapted from David E. Kaufmann's Swifter routines symba_merge_pl.f90 and symba_discard_merge_pl.f90
      !!
      !! Adapted from Hal Levison's Swift routines symba5_merge.f and discard_mass_merge.f
      implicit none
      ! Arguments
      class(collision_basic),   intent(inout) :: self         !! Merge fragment system object 
      class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            !! The time of the collision
      ! Internals
      integer(I4B)                              :: i, j, ibiggest
      integer(I8B)                              :: k
      real(DP), dimension(NDIM)                 :: L_spin_new, L_residual
      real(DP)                                  :: volume
      character(len=STRMAX) :: message

      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(impactors => self%impactors)
            message = "Merging"
            call collision_io_collider_message(nbody_system%pl, impactors%id, message)
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)

            select type(pl => nbody_system%pl)
            class is (swiftest_pl)
               ! Get coordinate system
               call impactors%set_coordinate_system()

               ! Generate the merged body as a single fragment
               call self%setup_fragments(1)
               associate(fragments => self%fragments)

                  ! Calculate the initial energy of the nbody_system without the collisional family
                  call self%get_energy_and_momentum(nbody_system, param, phase="before")
               
                  ! The new body's metadata will be taken from the largest of the two impactor bodies, so we need 
                  ! its index in the main pl structure
                  ibiggest = impactors%id(maxloc(pl%Gmass(impactors%id(:)), dim=1))
                  fragments%id(1) = pl%id(ibiggest)
                  if (allocated(fragments%info)) deallocate(fragments%info)
                  allocate(fragments%info, source=pl%info(ibiggest:ibiggest))

                  ! Compute the physical properties of the new body after the merge.
                  volume = 4._DP / 3._DP * PI * sum(impactors%radius(:)**3)
                  fragments%mass(1) = sum(impactors%mass(:))
                  fragments%Gmass(1) =sum(impactors%Gmass(:))
                  fragments%density(1) = fragments%mass(1) / volume
                  fragments%radius(1) = (3._DP * volume / (4._DP * PI))**(THIRD)
                  if (param%lrotation) then
#ifdef DOCONLOC
                     do concurrent(i = 1:NDIM) shared(impactors, fragments, L_spin_new)
#else
                     do concurrent(i = 1:NDIM)
#endif
                        fragments%Ip(i,1) = sum(impactors%mass(:) * impactors%Ip(i,:)) 
                        L_spin_new(i) = sum(impactors%L_orbit(i,:) + impactors%L_spin(i,:))
                     end do
                     fragments%Ip(:,1) = fragments%Ip(:,1) / fragments%mass(1)
                     fragments%rot(:,1) = L_spin_new(:) / (fragments%Ip(3,1) * fragments%mass(1) * fragments%radius(1)**2)
                  else ! If spin is not enabled, we will consider the lost pre-collision angular momentum as "escaped" and add it to our bookkeeping variable
                     nbody_system%L_escape(:) = nbody_system%L_escape(:) + impactors%L_orbit(:,1) + impactors%L_orbit(:,2) 
                  end if

                  ! The fragment trajectory will be the barycentric trajectory
                  fragments%rb(:,1) = impactors%rbcom(:)
                  fragments%vb(:,1) = impactors%vbcom(:)
                  fragments%rc(:,1) = 0.0_DP
                  fragments%vc(:,1) = 0.0_DP

                  ! Get the energy of the system after the collision
                  call self%get_energy_and_momentum(nbody_system, param, phase="after")

                  L_residual(:) = (self%L_total(:,2) - self%L_total(:,1))
                  call collision_util_velocity_torque(-L_residual(:), fragments%mass(1), fragments%rb(:,1), fragments%vb(:,1))

                  ! Update any encounter lists that have the removed bodies in them so that they instead point to the new body
                  do k = 1_I8B, nbody_system%plpl_encounter%nenc
                     do j = 1, impactors%ncoll
                        i = impactors%id(j)
                        if (i == ibiggest) cycle
                        if (nbody_system%plpl_encounter%id1(k) == pl%id(i)) then
                           nbody_system%plpl_encounter%id1(k) = pl%id(ibiggest)
                           nbody_system%plpl_encounter%index1(k) = i
                        end if
                        if (nbody_system%plpl_encounter%id2(k) == pl%id(i)) then
                           nbody_system%plpl_encounter%id2(k) = pl%id(ibiggest)
                           nbody_system%plpl_encounter%index2(k) = i
                        end if
                        if (nbody_system%plpl_encounter%id1(k) == nbody_system%plpl_encounter%id2(k)) nbody_system%plpl_encounter%status(k) = INACTIVE
                     end do
                  end do

                  self%status = MERGED
                  
                  call collision_resolve_mergeaddsub(nbody_system, param, t, self%status) 

               end associate
            end select
         end associate
      end select
      return 
   end subroutine collision_generate_merge


end submodule s_collision_generate

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(rmvs) s_rmvs_discard
   use swiftest
contains  

   module subroutine rmvs_discard_tp(self, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if test particles should be discarded based on pericenter passage distances with respect to planets 
      !! encountered
      !!
      !! Adapted from Hal Levison's Swift routine discard_pl.f
      !! Adapted from Hal Levison's Swift routine rmvs_discard_pl.f90
      implicit none
      ! Arguments
      class(rmvs_tp),               intent(inout) :: self   
         !! RMVS test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      ! Internals
      integer(I4B)                                 :: i
      character(len=STRMAX) :: timestr, idstri, idstrj, message
      logical, allocatable, dimension(:) :: ldiscard_tp, ldiscard_pl

      if (self%nbody == 0) return

      associate(tp => self, &
                ntp => self%nbody, &
                pl => nbody_system%pl, &
                t => nbody_system%t, &
                collider => nbody_system%collider, &
                impactors => nbody_system%collider%impactors, &
                collision_history => nbody_system%collision_history)
         do i = 1, ntp
            associate(iplperP => tp%plperP(i))
               if ((tp%status(i) == ACTIVE) .and. (tp%lperi(i))) then 
                  if ((tp%peri(i) < pl%radius(iplperP))) then
                     tp%status(i) = DISCARDED_PLQ
                     write(idstri, *) tp%id(i)
                     write(idstrj, *) pl%id(iplperP)
                     write(timestr, *) t
                     write(message, *) "Particle "  // trim(adjustl(tp%info(i)%name)) // " (" // trim(adjustl(idstri)) &
                              // ") q with respect to massive body " // trim(adjustl(pl%info(iplperP)%name))   &
                              // " (" // trim(adjustl(idstrj)) // ") is too small at t = " // trim(adjustl(timestr))
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT,message)
                     tp%ldiscard(i) = .true.
                     tp%lmask(i) = .false.
                     pl%ldiscard(iplperP) = .true.
                     call tp%info(i)%set_value(status="DISCARDED_PLQ", discard_time=t, discard_rh=tp%rh(:,i), &
                     discard_vh=tp%vh(:,i), discard_body_id=pl%id(iplperP))

                     ! Save the system snapshot
                     impactors%regime = COLLRESOLVE_REGIME_MERGE
                     allocate(ldiscard_tp, mold=tp%ldiscard(:))
                     allocate(ldiscard_pl, mold=pl%ldiscard(:))
                     ldiscard_tp(:) = .false.
                     ldiscard_pl(:) = .false.
                     ldiscard_tp(i) = .true.
                     ldiscard_pl(iplperP) = .true.
                     call tp%save_discard(ldiscard_tp,nbody_system,collider%before)
                     call pl%save_discard(ldiscard_pl,nbody_system,collider%before)
                     call collision_history%take_snapshot(param,nbody_system, t, "before") 
                     call pl%save_discard(ldiscard_pl,nbody_system,collider%after)
                     call collision_history%take_snapshot(param,nbody_system, t, "after") 
                     deallocate(ldiscard_tp, ldiscard_pl)
                  end if
               end if
            end associate
         end do
         ! Call the base method that this overrides
         call swiftest_discard_tp(tp, nbody_system, param)
      end associate


      return

   end subroutine rmvs_discard_tp

end submodule s_rmvs_discard

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 


module collision
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods used to determine close encounters
   use globals
   use base
   use encounter
   implicit none
   public

   character(len=*), parameter :: COLLISION_OUTFILE = 'collisions.nc'  !! Name of NetCDF output file for collision information
#ifdef COARRAY
   character(len=STRMAX) :: COLLISION_LOG_OUT !! Name of log file for collision diagnostic information (each co-image gets its own)
#else
   character(len=*), parameter :: COLLISION_LOG_OUT = "collisions.log" !! Name of log file for collision diagnostic information
#endif

   !>Symbolic names for collisional outcomes from collresolve_resolve:
   integer(I4B), parameter :: COLLRESOLVE_REGIME_MERGE              =  1
   integer(I4B), parameter :: COLLRESOLVE_REGIME_DISRUPTION         =  2
   integer(I4B), parameter :: COLLRESOLVE_REGIME_SUPERCATASTROPHIC  =  3
   integer(I4B), parameter :: COLLRESOLVE_REGIME_GRAZE_AND_MERGE    =  4
   integer(I4B), parameter :: COLLRESOLVE_REGIME_HIT_AND_RUN        =  5
   character(len=NAMELEN),parameter :: REGIME_NAME_MERGE = "Merge"
   character(len=NAMELEN),parameter :: REGIME_NAME_DISRUPTION = "Disruption"
   character(len=NAMELEN),parameter :: REGIME_NAME_SUPERCATASTROPHIC = "Supercatastrophic"
   character(len=NAMELEN),parameter :: REGIME_NAME_GRAZE_AND_MERGE = "Graze and Merge"
   character(len=NAMELEN),parameter :: REGIME_NAME_HIT_AND_RUN = "Hit and Run"
   character(len=NAMELEN),dimension(5), parameter :: REGIME_NAMES = [REGIME_NAME_MERGE, REGIME_NAME_DISRUPTION, REGIME_NAME_SUPERCATASTROPHIC, REGIME_NAME_GRAZE_AND_MERGE, REGIME_NAME_HIT_AND_RUN]
   real(DP), parameter :: MAX_ROT_SI = 7.108e-4 !! Spin limit in rad/s of cohesionless body from Holsapple (2007)

   !> Swiftest class for tracking pl-pl close encounters in a step when collisions are possible
   type, extends(encounter_list) :: collision_list_plpl
   contains
      procedure :: extract_collisions => collision_resolve_extract_plpl      !! Processes the pl-pl encounter list remove only those encounters that led to a collision
      procedure :: collision_check    => collision_check_plpl                !! Checks if a test particle is going to collide with a massive body
      procedure :: resolve_collision  => collision_resolve_plpl              !! Process the pl-pl collision list, then modifiy the massive bodies based on the outcome of the collision
      final     ::                       collision_final_plpl
   end type collision_list_plpl


   !> Class for tracking pl-tp close encounters in a step when collisions are possible
   type, extends(encounter_list) :: collision_list_pltp
   contains
      procedure :: extract_collisions => collision_resolve_extract_pltp !! Processes the pl-tp encounter list remove only those encounters that led to a collision
      procedure :: collision_check    => collision_check_pltp           !! Checks if a test particle is going to collide with a massive body
      procedure :: resolve_collision  => collision_resolve_pltp         !! Process the pl-tp collision list
      final     ::                       collision_final_pltp
   end type collision_list_pltp


   !> Class definition for the variables that describe the bodies involved in the collision
   type, extends(base_object) :: collision_impactors
      integer(I4B)                                 :: ncoll     !! Number of bodies involved in the collision
      integer(I4B), dimension(:),      allocatable :: id        !! Index of bodies involved in the collision
      real(DP),     dimension(NDIM,2)              :: rb        !! Two-body equivalent position vectors of the collider bodies prior to collision in system barycentric coordinates
      real(DP),     dimension(NDIM,2)              :: vb        !! Two-body equivalent velocity vectors of the collider bodies prior to collision in system barycentric coordinate
      real(DP),     dimension(NDIM,2)              :: rc        !! Two-body equivalent position vectors of the collider bodies prior to collision in collision center of mass coordinates
      real(DP),     dimension(NDIM,2)              :: vc        !! Two-body equivalent velocity vectors of the collider bodies prior to collision in collision center of mass coordinates
      real(DP),     dimension(NDIM,2)              :: rot       !! Two-body equivalent principal axes moments of inertia the collider bodies prior to collision
      real(DP),     dimension(NDIM,2)              :: L_spin    !! Two-body equivalent spin angular momentum vectors of the collider bodies prior to collision
      real(DP),     dimension(NDIM,2)              :: L_orbit   !! Two-body equivalent orbital angular momentum vectors of the collider bodies prior to collision
      real(DP),     dimension(2)                   :: ke_orbit  !! Orbital kinetic energy of each individual impactor
      real(DP),     dimension(2)                   :: ke_spin   !! Spin kinetic energy of each individual impactor
      real(DP),     dimension(2)                   :: be        !! Binding energy of each individual impactor
      real(DP),     dimension(NDIM,2)              :: Ip        !! Two-body equivalent principal axes moments of inertia the collider bodies prior to collision
      real(DP),     dimension(2)                   :: Gmass     !! Two-body equivalent G*mass of the collider bodies prior to the collision
      real(DP),     dimension(2)                   :: mass      !! Two-body equivalent mass of the collider bodies prior to the collision
      real(DP),     dimension(2)                   :: radius    !! Two-body equivalent radii of the collider bodies prior to the collision
      real(DP)                                     :: Qloss     !! Energy lost during the collision
      integer(I4B)                                 :: regime    !! Collresolve regime code for this collision
      real(DP),     dimension(:),      allocatable :: mass_dist !! Distribution of fragment mass determined by the regime calculation (largest fragment, second largest, and remainder)    
      real(DP)                                     :: Mcb       !! Mass of central body (used to compute potential energy in regime determination)

      ! Values in a coordinate frame centered on the collider barycenter and collisional system unit vectors 
      real(DP), dimension(NDIM) :: x_unit !! x-direction unit vector of collisional system
      real(DP), dimension(NDIM) :: y_unit !! y-direction unit vector of collisional system
      real(DP), dimension(NDIM) :: z_unit !! z-direction unit vector of collisional system
      real(DP), dimension(NDIM) :: v_unit !! velocity direction unit vector of collisional system
      real(DP), dimension(NDIM) :: rbcom  !! Center of mass position vector of the collider nbody_system in nbody_system barycentric coordinates
      real(DP), dimension(NDIM) :: vbcom  !! Velocity vector of the center of mass of the collider nbody_system in nbody_system barycentric coordinates
      real(DP), dimension(NDIM) :: rcimp  !! Impact point position vector of the collider nbody_system in nbody_system barycentric coordinates
      real(DP), dimension(NDIM) :: bounce_unit  !! The impact point velocity vector is the component of the velocity in the distance vector direction

   contains
      procedure :: consolidate           => collision_resolve_consolidate_impactors !! Consolidates a multi-body collision into an equivalent 2-body collision
      procedure :: dealloc               => collision_util_dealloc_impactors        !! Resets the collider object variables to 0 and deallocates the index and mass distributions
      procedure :: set_coordinate_system => collision_util_set_coordinate_impactors !! Sets the coordinate system of the impactors
      final     ::                          collision_final_impactors               !! Finalizer will deallocate all allocatables
   end type collision_impactors


   !> Class definition for the variables that describe a collection of fragments in barycentric coordinates
   type, extends(base_object) :: collision_fragments
      integer(I4B)                                           :: nbody = 0    !! Number of bodies
      real(DP)                                               :: mtot         !! Total mass of fragments       
      integer(I4B),              dimension(:),   allocatable :: id           !! Identifier
      class(base_particle_info), dimension(:),   allocatable :: info         !! Particle metadata information
      integer(I4B),              dimension(:),   allocatable :: status       !! An integrator-specific status indicator 
      real(DP),                  dimension(:,:), allocatable :: rh           !! Heliocentric position
      real(DP),                  dimension(:,:), allocatable :: vh           !! Heliocentric velocity
      real(DP),                  dimension(:,:), allocatable :: rb           !! Barycentric position
      real(DP),                  dimension(:,:), allocatable :: vb           !! Barycentric velocity
      real(DP),                  dimension(:,:), allocatable :: rc           !! Position vectors in the collision coordinate frame
      real(DP),                  dimension(:,:), allocatable :: vc           !! Velocity vectors in the collision coordinate frame
      real(DP),                  dimension(:,:), allocatable :: r_unit       !! Array of radial direction unit vectors of individual fragments in the collisional coordinate frame
      real(DP),                  dimension(:,:), allocatable :: v_unit       !! Array of velocity direction unit vectors of individual fragments in the collisional coordinate frame
      real(DP),                  dimension(:,:), allocatable :: t_unit       !! Array of tangential direction unit vectors of individual fragments in the collisional coordinate frame
      real(DP),                  dimension(:,:), allocatable :: n_unit       !! Array of normal direction unit vectors of individual fragments in the collisional coordinate frame
      real(DP),                  dimension(:,:), allocatable :: rot          !! rotation vectors of fragments
      real(DP),                  dimension(:,:), allocatable :: Ip           !! Principal axes moment of inertia for fragments
      real(DP),                  dimension(:),   allocatable :: Gmass        !! G*mass of fragments
      real(DP),                  dimension(:),   allocatable :: mass         !! masses of fragments
      real(DP),                  dimension(:),   allocatable :: radius       !! Radii  of fragments
      real(DP),                  dimension(:),   allocatable :: density      !! Radii  of fragments
      real(DP),                  dimension(:),   allocatable :: rmag         !! Array of radial distance magnitudes of individual fragments in the collisional coordinate frame 
      real(DP),                  dimension(:),   allocatable :: vmag         !! Array of radial distance magnitudes of individual fragments in the collisional coordinate frame 
      real(DP),                  dimension(:),   allocatable :: rotmag       !! Array of rotation magnitudes of individual fragments 
      integer(I4B),              dimension(:),   allocatable :: origin_body  !! Array of indices indicating which impactor body (1 or 2) the fragment originates from
      real(DP),                  dimension(NDIM)             :: L_orbit_tot  !! Orbital angular momentum vector of all fragments
      real(DP),                  dimension(NDIM)             :: L_spin_tot   !! Spin angular momentum vector of all fragments
      real(DP),                  dimension(:,:), allocatable :: L_orbit      !! Orbital angular momentum vector of each individual fragment
      real(DP),                  dimension(:,:), allocatable :: L_spin       !! Spin angular momentum vector of each individual fragment
      real(DP)                                               :: ke_orbit_tot !! Orbital kinetic energy of all fragments
      real(DP)                                               :: ke_spin_tot  !! Spin kinetic energy of all fragments
      real(DP)                                               :: pe           !! Potential energy of all fragments
      real(DP)                                               :: be           !! Binding energy of all fragments
      real(DP),                  dimension(:), allocatable   :: ke_orbit     !! Orbital kinetic energy of each individual fragment
      real(DP),                  dimension(:), allocatable   :: ke_spin      !! Spin kinetic energy of each individual fragment
   contains
      procedure :: dealloc               => collision_util_dealloc_fragments        !! Deallocates all allocatable arrays and sets everything else to 0
      procedure :: setup                 => collision_util_setup_fragments          !! Allocates all allocatables
      procedure :: reset                 => collision_util_reset_fragments          !! Resets all position and velocity-dependent fragment quantities in order to do a fresh calculation (does not reset mass, radius, or other values that get set prior to the call to fraggle_generate)
      procedure :: set_coordinate_system => collision_util_set_coordinate_fragments !! Sets the coordinate system of the fragments
      final     ::                          collision_final_fragments               !! Finalizer deallocates all allocatables
   end type collision_fragments


   type :: collision_basic
      !! This class defines a collisional system that stores impactors and fragments. This is written so that various collision models (i.e. Fraggle) could potentially be used
      !! to resolve collision by defining extended types of encounters_impactors and/or encounetr_fragments
      !!
      !! The generate method for this class is the merge model. This allows any extended type to have access to the merge procedure by selecting the collision_basic parent class
      class(collision_fragments), allocatable :: fragments           !! Object containing information on the pre-collision system
      class(collision_impactors), allocatable :: impactors           !! Object containing information on the post-collision system
      class(base_nbody_system),   allocatable :: before              !! A snapshot of the subset of the nbody_system involved in the collision
      class(base_nbody_system),   allocatable :: after               !! A snapshot of the subset of the nbody_system containing products of the collision
      integer(I4B)                            :: status              !! Status flag to pass to the collision list once the collision has been resolved
      integer(I4B)                            :: collision_id        !! ID number of this collision event
      integer(I4B)                            :: maxid_collision = 0 !! The current maximum collision id number
      real(DP)                                :: min_mfrag           !! Minimum fragment mass
      real(DP)                                :: max_rot             !! Maximum rotation rate (in system or natural units, depending on )

      ! Scale factors used to scale dimensioned quantities to a more "natural" system where escape velocity is 1 and body masses are of order 1
      real(DP) :: dscale = 1.0_DP !! Distance dimension scale factor
      real(DP) :: mscale = 1.0_DP !! Mass scale factor
      real(DP) :: tscale = 1.0_DP !! Time scale factor
      real(DP) :: vscale = 1.0_DP !! Velocity scale factor (a convenience unit that is derived from dscale and tscale)
      real(DP) :: Escale = 1.0_DP !! Energy scale factor (a convenience unit that is derived from dscale, tscale, and mscale)
      real(DP) :: Lscale = 1.0_DP !! Angular momentum scale factor (a convenience unit that is derived from dscale, tscale, and mscale)

      ! For the following variables, index 1 refers to the *entire* n-body system in its pre-collisional state and index 2 refers to the system in its post-collisional state
      real(DP), dimension(NDIM,2) :: L_orbit  !! Before/after orbital angular momentum 
      real(DP), dimension(NDIM,2) :: L_spin   !! Before/after spin angular momentum 
      real(DP), dimension(NDIM,2) :: L_total  !! Before/after total nbody_system angular momentum 
      real(DP), dimension(2)      :: ke_orbit !! Before/after orbital kinetic energy
      real(DP), dimension(2)      :: ke_spin  !! Before/after spin kinetic energy
      real(DP), dimension(2)      :: pe       !! Before/after potential energy
      real(DP), dimension(2)      :: be       !! Before/after binding energy
      real(DP), dimension(2)      :: te       !! Before/after total system energy

   contains
      procedure :: generate                   => collision_generate_basic                  !! Merges the impactors to make a single final body
      procedure :: hitandrun                  => collision_generate_hitandrun              !! Merges the impactors to make a single final body
      procedure :: merge                      => collision_generate_merge                  !! Merges the impactors to make a single final body
      procedure :: add_fragments              => collision_util_add_fragments_to_collider  !! Add fragments to nbody_system
      procedure :: get_energy_and_momentum    => collision_util_get_energy_and_momentum    !! Calculates total nbody_system energy in either the pre-collision outcome state (lbefore = .true.) or the post-collision outcome state (lbefore = .false.)
      procedure :: dealloc                    => collision_util_dealloc_basic               !! Deallocates all allocatables
      procedure :: get_regime                 => collision_regime_collider              !! Determine which fragmentation regime the set of impactors will be
      procedure :: setup                      => collision_util_setup_collider             !! Initializer for the encounter collision system and the before/after snapshots
      procedure :: setup_impactors            => collision_util_setup_impactors_collider   !! Initializer for the impactors for the encounter collision system. Deallocates old impactors before creating new ones
      procedure :: setup_fragments            => collision_util_setup_fragments_collider   !! Initializer for the fragments of the collision system. 
      procedure :: set_coordinate_system      => collision_util_set_coordinate_collider    !! Sets the coordinate system of the collisional system
      procedure :: set_natural_scale          => collision_util_set_natural_scale_factors  !! Scales dimenional quantities to ~O(1) with respect to the collisional system.  
      procedure :: set_original_scale         => collision_util_set_original_scale_factors !! Restores dimenional quantities back to the original system units
      final     ::                               collision_final_basic
   end type collision_basic

   
   type, extends(collision_basic) :: collision_bounce
   contains 
      procedure :: generate => collision_generate_bounce !! If a collision would result in a disruption, "bounce" the bodies instead.
   end type collision_bounce


   !! NetCDF dimension and variable names for the enounter save object
   type, extends(encounter_netcdf_parameters) :: collision_netcdf_parameters
      integer(I4B)       :: stage_dimid                                    !! ID for the stage dimension
      integer(I4B)       :: stage_varid                                    !! ID for the stage variable  
      character(NAMELEN) :: stage_dimname            = "stage"             !! name of the stage dimension (before/after)
      character(len=6), dimension(2) :: stage_coords = ["before", "after "] !! The stage coordinate labels

      integer(I4B)       :: collision_id_dimid                 !! ID for the collision event dimension       

      character(NAMELEN) :: Qloss_varname  = "Qloss"   !! name of the energy loss variable
      integer(I4B)       :: Qloss_varid                !! ID for the energy loss variable 
      character(NAMELEN) :: regime_varname = "regime"  !! name of the collision regime variable
      integer(I4B)       :: regime_varid               !! ID for the collision regime variable
   contains
      procedure :: initialize => collision_io_netcdf_initialize_output !! Initialize a set of parameters used to identify a NetCDF output object
      procedure :: open       => collision_io_netcdf_open              !! Opens an old file
   end type collision_netcdf_parameters


   type, extends(encounter_snapshot)  :: collision_snapshot
      logical                             :: lcollision !! Indicates that this snapshot contains at least one collision
      class(collision_basic), allocatable :: collider  !! Collider object at this snapshot
   contains
      procedure :: write_frame => collision_io_netcdf_write_frame_snapshot !! Writes a frame of encounter data to file 
      procedure :: dealloc     => collision_util_dealloc_snapshot          !! Deallocates all allocatables
      procedure :: get_idvals  => collision_util_get_idvalues_snapshot     !! Gets an array of all id values saved in this snapshot
   end type collision_snapshot


   !> A class that that is used to store simulation history data between file output
   type, extends(encounter_storage) :: collision_storage
   contains
      procedure :: dump           => collision_io_netcdf_dump !! Dumps contents of encounter history to file
      procedure :: take_snapshot  => collision_util_snapshot  !! Take a minimal snapshot of the nbody_system through an encounter
      procedure :: make_index_map => collision_util_index_map !! Maps body id values to storage index values so we don't have to use unlimited dimensions for id
   end type collision_storage


   interface
      module subroutine collision_generate_basic(self, nbody_system, param, t)
         implicit none
         class(collision_basic),   intent(inout) :: self          !! Merge fragment nbody_system object 
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters 
         real(DP),                 intent(in)    :: t            !! The time of the collision
      end subroutine collision_generate_basic 

      module subroutine collision_generate_bounce(self, nbody_system, param, t)
         implicit none
         class(collision_bounce),  intent(inout) :: self         !! Bounce fragment nbody_system object 
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters 
         real(DP),                 intent(in)    :: t            !! The time of the collision
      end subroutine collision_generate_bounce 

      module subroutine collision_generate_hitandrun(self, nbody_system, param, t) 
         implicit none
         class(collision_basic),   intent(inout) :: self
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters with SyMBA additions
         real(DP),                 intent(in)    :: t            !! Time of collision
      end subroutine collision_generate_hitandrun

      module subroutine collision_generate_merge(self, nbody_system, param, t)
         implicit none
         class(collision_basic),   intent(inout) :: self          !! Merge fragment nbody_system object 
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters 
         real(DP),                 intent(in)    :: t            !! The time of the collision
      end subroutine collision_generate_merge
    
      module subroutine collision_io_collider_message(pl, collidx, collider_message)
         implicit none
         class(base_object),            intent(in)    :: pl               !! Swiftest massive body object
         integer(I4B),    dimension(:), intent(in)    :: collidx          !! Index of collisional colliders%idx members
         character(*),                  intent(inout) :: collider_message !! The message to print to the screen.
      end subroutine collision_io_collider_message

      module subroutine collision_io_log_regime(impactors)
         implicit none
         class(collision_impactors), intent(inout) :: impactors  !! Collision system object
      end subroutine collision_io_log_regime

      module subroutine collision_io_netcdf_dump(self, param)
         implicit none
         class(collision_storage), intent(inout) :: self  !! Collision storage object
         class(base_parameters),   intent(inout) :: param !! Current run configuration parameters 
      end subroutine collision_io_netcdf_dump

      module subroutine collision_io_netcdf_initialize_output(self, param)
         implicit none
         class(collision_netcdf_parameters), intent(inout) :: self  !! Parameters used to identify a particular NetCDF dataset
         class(base_parameters),   intent(in)    :: param !! Current run configuration parameters  
      end subroutine collision_io_netcdf_initialize_output

      module subroutine collision_io_netcdf_open(self, param, readonly)
         implicit none
         class(collision_netcdf_parameters), intent(inout) :: self     !! Parameters used to identify a particular NetCDF dataset
         class(base_parameters),             intent(in)    :: param    !! Current run configuration parameters
         logical, optional,                  intent(in)    :: readonly !! Logical flag indicating that this should be open read only
      end subroutine collision_io_netcdf_open

      module subroutine collision_io_netcdf_write_frame_snapshot(self, history, param)
         implicit none
         class(collision_snapshot),   intent(in)    :: self    !! Swiftest encounter structure
         class(encounter_storage), intent(inout) :: history !! Collision history object
         class(base_parameters),      intent(inout) :: param   !! Current run configuration parameters
      end subroutine collision_io_netcdf_write_frame_snapshot

      module subroutine collision_regime_collider(self, nbody_system, param)
         implicit none 
         class(collision_basic),   intent(inout) :: self         !! Collision system object
         class(base_nbody_system), intent(in)    :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(in)    :: param        !! Current Swiftest run configuration parameters
      end subroutine collision_regime_collider

      module subroutine collision_check_plpl(self, nbody_system, param, t, dt, irec, lany_collision)
         implicit none
         class(collision_list_plpl), intent(inout) :: self           !! encounter list object
         class(base_nbody_system),   intent(inout) :: nbody_system   !! Swiftest nbody system object
         class(base_parameters),     intent(inout) :: param          !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t              !! current time
         real(DP),                   intent(in)    :: dt             !! step size
         integer(I4B),               intent(in)    :: irec           !! Current recursion level
         logical,                    intent(out)   :: lany_collision !! Returns true if any pair of encounters resulted in a collision 
      end subroutine collision_check_plpl

      module subroutine collision_check_pltp(self, nbody_system, param, t, dt, irec, lany_collision)
         implicit none
         class(collision_list_pltp), intent(inout) :: self           !!  encounter list object
         class(base_nbody_system),   intent(inout) :: nbody_system   !! Swiftest nbody system object
         class(base_parameters),     intent(inout) :: param          !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t              !! current time
         real(DP),                   intent(in)    :: dt             !! step size
         integer(I4B),               intent(in)    :: irec           !! Current recursion level
         logical,                    intent(out)   :: lany_collision !! Returns true if any pair of encounters resulted in a collision 
      end subroutine collision_check_pltp

      module subroutine collision_resolve_consolidate_impactors(self, nbody_system, param, idx_parent, lflag)
         implicit none
         class(collision_impactors),               intent(out)   :: self         !! Collision impactors object
         class(base_nbody_system),                 intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),                   intent(in)    :: param        !! Current run configuration parameters with Swiftest additions
         integer(I4B),               dimension(:), intent(inout) :: idx_parent !! Index of the two bodies considered the "parents" of the collision
         logical,                                  intent(out)   :: lflag      !! Logical flag indicating whether a impactors%id was successfully created or not
      end subroutine collision_resolve_consolidate_impactors
   
      module subroutine collision_resolve_extract_plpl(self, nbody_system, param)
         implicit none
         class(collision_list_plpl), intent(inout) :: self         !! pl-pl encounter list
         class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),     intent(in)    :: param        !! Current run configuration parameters
      end subroutine collision_resolve_extract_plpl

      module subroutine collision_resolve_extract_pltp(self, nbody_system, param)
         implicit none
         class(collision_list_pltp), intent(inout) :: self   !! pl-tp encounter list
         class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),     intent(in)    :: param  !! Current run configuration parameters
      end subroutine collision_resolve_extract_pltp

      module subroutine collision_resolve_make_impactors_pl(pl, idx)
         implicit none
         class(base_object),           intent(inout) :: pl  !! Massive body object
         integer(I4B), dimension(:), intent(in)    :: idx !! Array holding the indices of the two bodies involved in the collision
      end subroutine collision_resolve_make_impactors_pl

      module subroutine collision_resolve_mergeaddsub(nbody_system, param, t, status)
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param  !! Current run configuration parameters with Swiftest additions
         real(DP),                  intent(in)    :: t      !! Time of collision
         integer(I4B),              intent(in)    :: status !! Status flag to assign to adds
      end subroutine collision_resolve_mergeaddsub
   
      module subroutine collision_resolve_plpl(self, nbody_system, param, t, dt, irec)
         implicit none
         class(collision_list_plpl), intent(inout) :: self   !! pl-pl encounter list
         class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),     intent(inout) :: param  !! Current run configuration parameters with Swiftest additions
         real(DP),                   intent(in)    :: t      !! Current simulation time
         real(DP),                   intent(in)    :: dt     !! Current simulation step size
         integer(I4B),               intent(in)    :: irec   !! Current recursion level
      end subroutine collision_resolve_plpl
   
      module subroutine collision_resolve_pltp(self, nbody_system, param, t, dt, irec)
         implicit none
         class(collision_list_pltp), intent(inout) :: self   !! pl-tp encounter list
         class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),     intent(inout) :: param  !! Current run configuration parameters with Swiftest additions
         real(DP),                   intent(in)    :: t      !! Current simulation time
         real(DP),                   intent(in)    :: dt     !! Current simulation step size
         integer(I4B),               intent(in)    :: irec   !! Current recursion level
      end subroutine collision_resolve_pltp

      module subroutine collision_util_add_fragments_to_collider(self, nbody_system, param)
         implicit none
         class(collision_basic),  intent(in)    :: self         !! Collision system object
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(in)    :: param        !! Current Swiftest run configuration parameters
      end subroutine collision_util_add_fragments_to_collider

      module subroutine collision_util_bounce_one(r,v,rcom,vcom,radius)
         implicit none
         real(DP), dimension(:), intent(inout) :: r,v
         real(DP), dimension(:), intent(in)    :: rcom,vcom
         real(DP),               intent(in)    :: radius
      end subroutine collision_util_bounce_one

      module subroutine collision_util_dealloc_fragments(self)
         implicit none
         class(collision_fragments), intent(inout) :: self
      end subroutine collision_util_dealloc_fragments

      module subroutine collision_util_dealloc_snapshot(self)
         implicit none
         class(collision_snapshot),  intent(inout) :: self !! Collsion snapshot object
      end subroutine collision_util_dealloc_snapshot

      module subroutine collision_util_reset_fragments(self)
         implicit none
         class(collision_fragments), intent(inout) :: self
      end subroutine collision_util_reset_fragments

      module subroutine collision_util_set_coordinate_collider(self)
         implicit none
         class(collision_basic), intent(inout) :: self      !! collisional system
      end subroutine collision_util_set_coordinate_collider

      module subroutine collision_util_set_coordinate_fragments(self)
         implicit none
         class(collision_fragments), intent(inout) :: self      !! Collisional nbody_system
      end subroutine collision_util_set_coordinate_fragments

      module subroutine collision_util_set_coordinate_impactors(self)
         implicit none
         class(collision_impactors), intent(inout) :: self      !! collisional system
      end subroutine collision_util_set_coordinate_impactors

      module subroutine collision_util_setup_collider(self, nbody_system)
         implicit none
         class(collision_basic),   intent(inout) :: self         !! Encounter collision system object
         class(base_nbody_system), intent(in)    :: nbody_system !! Current nbody system. Used as a mold for the before/after snapshots
      end subroutine collision_util_setup_collider
   
      module subroutine collision_util_setup_impactors_collider(self)
         implicit none
         class(collision_basic), intent(inout) :: self   !! Encounter collision system object
      end subroutine collision_util_setup_impactors_collider
   
      module subroutine collision_util_setup_fragments_collider(self, nfrag)
         implicit none
         class(collision_basic), intent(inout) :: self  !! Encounter collision system object
         integer(I4B),           intent(in)    :: nfrag !! Number of fragments to create
      end subroutine collision_util_setup_fragments_collider

      module subroutine collision_util_shift_vector_to_origin(m_frag, vec_frag)
         implicit none
         real(DP), dimension(:),   intent(in)    :: m_frag    !! Fragment masses
         real(DP), dimension(:,:), intent(inout) :: vec_frag  !! Fragment positions or velocities in the center of mass frame
      end subroutine

      module subroutine collision_util_get_idvalues_snapshot(self, idvals)
         implicit none
         class(collision_snapshot),               intent(in)  :: self   !! Collision snapshot object
         integer(I4B), dimension(:), allocatable, intent(out) :: idvals !! Array of all id values saved in this snapshot
      end subroutine collision_util_get_idvalues_snapshot

      module subroutine collision_util_get_energy_and_momentum(self, nbody_system, param, phase)
         use base, only : base_nbody_system, base_parameters
         implicit none
         class(collision_basic),   intent(inout) :: self         !! Encounter collision system object
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        !! Current Swiftest run configuration parameters
         character(len=*),         intent(in)    :: phase        !! One of "before" or "after", indicating which phase of the calculation this needs to be done
      end subroutine collision_util_get_energy_and_momentum

      module subroutine collision_util_index_map(self)
         implicit none
         class(collision_storage), intent(inout) :: self  !! Collision storage object 
      end subroutine collision_util_index_map

      module subroutine collision_util_dealloc_impactors(self)
         implicit none
         class(collision_impactors),  intent(inout) :: self !! Collision system object
      end subroutine collision_util_dealloc_impactors

      module subroutine collision_util_dealloc_basic(self)
         implicit none
         class(collision_basic), intent(inout) :: self  !! Collision system object
      end subroutine collision_util_dealloc_basic

      module subroutine collision_util_snapshot(self, param, nbody_system, t, arg)
         implicit none
         class(collision_storage), intent(inout)        :: self         !! Swiftest storage object
         class(base_parameters),      intent(inout)        :: param        !! Current run configuration parameters
         class(base_nbody_system),    intent(inout)        :: nbody_system !! Swiftest nbody system object to store
         real(DP),                    intent(in), optional :: t            !! Time of snapshot if different from nbody_system time
         character(*),                intent(in), optional :: arg          !! "before": takes a snapshot just before the collision. "after" takes the snapshot just after the collision.
      end subroutine collision_util_snapshot

      module subroutine collision_util_set_natural_scale_factors(self)
         implicit none
         class(collision_basic), intent(inout) :: self  !! collision system object
      end subroutine collision_util_set_natural_scale_factors

      module subroutine collision_util_set_original_scale_factors(self)
         implicit none
         class(collision_basic), intent(inout) :: self  !! collision system object
      end subroutine collision_util_set_original_scale_factors

      module subroutine collision_util_setup_fragments(self, n)
         implicit none
         class(collision_fragments), intent(inout) :: self  !! Swiftest generic body object
         integer(I4B),               intent(in)    :: n     !! Number of particles to allocate space for
      end subroutine collision_util_setup_fragments

      module subroutine collision_util_velocity_torque(dL, mass, r, v)
         implicit none
         real(DP), dimension(:), intent(in)    :: dL   !! Change in angular momentum to apply
         real(DP),               intent(in)    :: mass !! Mass of body
         real(DP), dimension(:), intent(in)    :: r    !! Position of body wrt system center of mass
         real(DP), dimension(:), intent(inout) :: v !! Velocity of body wrt system center of mass
      end subroutine collision_util_velocity_torque
   end interface

   contains

      subroutine collision_final_fragments(self)
         !! author: David A. Minton
         !!
         !! Finalizer will deallocate all allocatables
         implicit none
         ! Arguments
         type(collision_fragments),  intent(inout) :: self !! Collision impactors storage object

         call self%dealloc()

         return
      end subroutine collision_final_fragments

      subroutine collision_final_impactors(self)
         !! author: David A. Minton
         !!
         !! Finalizer will deallocate all allocatables
         implicit none
         ! Arguments
         type(collision_impactors),  intent(inout) :: self !! Collision impactors storage object

         call self%dealloc()

         return
      end subroutine collision_final_impactors

      subroutine collision_final_plpl(self)
         !! author: David A. Minton
         !!
         !! Finalizer will deallocate all allocatables
         implicit none
         ! Arguments
         type(collision_list_plpl),  intent(inout) :: self !! PL-PL collision list object

         call self%dealloc()

         return
      end subroutine collision_final_plpl

      subroutine collision_final_pltp(self)
         !! author: David A. Minton
         !!
         !! Finalizer will deallocate all allocatables
         implicit none
         ! Arguments
         type(collision_list_pltp),  intent(inout) :: self !! PL-TP collision list object

         call self%dealloc()

         return
      end subroutine collision_final_pltp

      subroutine collision_final_basic(self)
         !! author: David A. Minton
         !!
         !! Finalizer will deallocate all allocatables
         implicit none
         ! Arguments
         type(collision_basic),  intent(inout) :: self !!  Collision system object

         call self%dealloc()

         return
      end subroutine collision_final_basic


end module collision

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module operators
   !! author: David A. Minton
   !!
   !! Custom operators, including
   !!   A .cross. B = Cross product of A(1:NDIM) and B(1:NDIM) 
   !!
   !! Each operator can also do element-wise computation on arrays of the form .mag. A(1:NDIM, 1:n)
   use globals
   implicit none
   public

   !********************************************************************************************************************************
   ! Interfaces for .cross. operator: Computes the cross product of two (NDIM) vectors or (NDIM,:) arrays 
   !********************************************************************************************************************************

   interface operator(.cross.)
      pure module function operator_cross_sp(A, B) result(C)
         !$omp declare simd(operator_cross_sp)
         implicit none
         real(SP), dimension(:), intent(in) :: A, B
         real(SP), dimension(NDIM) :: C
      end function operator_cross_sp

      pure module function operator_cross_dp(A, B) result(C)
         !$omp declare simd(operator_cross_dp)
         implicit none
         real(DP), dimension(:), intent(in) :: A, B
         real(DP), dimension(NDIM) :: C
      end function operator_cross_dp

#ifdef QUADPREC
      pure module function operator_cross_qp(A, B) result(C)
         !$omp declare simd(operator_cross_qp)
         implicit none
         real(QP), dimension(:), intent(in) :: A, B
         real(QP), dimension(NDIM) :: C
      end function operator_cross_qp
#endif

      pure module function operator_cross_i1b(A, B) result(C)
         !$omp declare simd(operator_cross_i1b)
         implicit none
         integer(I1B), dimension(:), intent(in) :: A, B
         integer(I1B), dimension(NDIM) :: C
      end function operator_cross_i1b

      pure module function operator_cross_i2b(A, B) result(C)
         !$omp declare simd(operator_cross_i2b)
         implicit none
         integer(I2B), dimension(:), intent(in) :: A, B
         integer(I2B), dimension(NDIM) :: C
      end function operator_cross_i2b

      pure module function operator_cross_i4b(A, B) result(C)
         !$omp declare simd(operator_cross_i4b)
         implicit none
         integer(I4B), dimension(:), intent(in) :: A, B
         integer(I4B), dimension(NDIM) :: C
      end function operator_cross_i4b

      pure module function operator_cross_i8b(A, B) result(C)
         !$omp declare simd(operator_cross_i8b)
         implicit none
         integer(I8B), dimension(:), intent(in) :: A, B
         integer(I8B), dimension(NDIM) :: C
      end function operator_cross_i8b

      pure module function operator_cross_el_sp(A, B) result(C)
         implicit none
         real(SP), dimension(:,:), intent(in) :: A, B
         real(SP), dimension(:,:), allocatable :: C
      end function operator_cross_el_sp

      pure module function operator_cross_el_dp(A, B) result(C)
         implicit none
         real(DP), dimension(:,:), intent(in) :: A, B
         real(DP), dimension(:,:), allocatable :: C
      end function operator_cross_el_dp

#ifdef QUADPREC
      pure module function operator_cross_el_qp(A, B) result(C)
         implicit none
         real(QP), dimension(:,:), intent(in) :: A, B
         real(QP), dimension(:,:), allocatable :: C
      end function operator_cross_el_qp
#endif

      pure module function operator_cross_el_i1b(A, B) result(C)
         implicit none
         integer(I1B), dimension(:,:), intent(in) :: A, B
         integer(I1B), dimension(:,:), allocatable :: C
      end function operator_cross_el_i1b

      pure module function operator_cross_el_i2b(A, B) result(C)
         implicit none
         integer(I2B), dimension(:,:), intent(in) :: A, B
         integer(I2B), dimension(:,:), allocatable :: C
      end function operator_cross_el_i2b

      pure module function operator_cross_el_i4b(A, B) result(C)
         implicit none
         integer(I4B), dimension(:,:), intent(in) :: A, B
         integer(I4B), dimension(:,:), allocatable :: C
      end function operator_cross_el_i4b

      pure module function operator_cross_el_i8b(A, B) result(C)
         implicit none
         integer(I8B), dimension(:,:), intent(in) :: A, B
         integer(I8B), dimension(:,:), allocatable :: C
      end function operator_cross_el_i8b
   end interface

   !********************************************************************************************************************************
   ! Interfaces for .mag. operator: Computes the magnitude of a vector or array of vectors using norm2
   !********************************************************************************************************************************

   interface operator(.mag.)
      pure module function operator_mag_sp(A) result(B)
         !$omp declare simd(operator_mag_sp)
         implicit none
         real(SP), dimension(:), intent(in) :: A
         real(SP)                           :: B
      end function operator_mag_sp

      pure module function operator_mag_dp(A) result(B)
         !$omp declare simd(operator_mag_dp)
         implicit none
         real(DP), dimension(:), intent(in) :: A
         real(DP)                           :: B
      end function operator_mag_dp

#ifdef QUADPREC
      pure module function operator_mag_qp(A) result(B)
         !$omp declare simd(operator_mag_qp)
         implicit none
         real(QP), dimension(:), intent(in) :: A
         real(QP)                           :: B
      end function operator_mag_qp
#endif
      pure module function operator_mag_el_sp(A) result(B)
         implicit none
         real(SP), dimension(:,:), intent(in) :: A
         real(SP), dimension(:), allocatable  :: B
      end function operator_mag_el_sp

      pure module function operator_mag_el_dp(A) result(B)
         implicit none
         real(DP), dimension(:,:), intent(in) :: A
         real(DP), dimension(:), allocatable  :: B
      end function operator_mag_el_dp

#ifdef QUADPREC
      pure module function operator_mag_el_qp(A) result(B)
         implicit none
         real(QP), dimension(:,:), intent(in) :: A
         real(QP), dimension(:), allocatable  :: B
      end function operator_mag_el_qp
#endif

   end interface


   !********************************************************************************************************************************
   ! Interfaces for .unit. operator: Returns a unit vector or array of unit vectors from an input vector or array of vectors
   !********************************************************************************************************************************

   interface operator(.unit.)
      pure module function operator_unit_sp(A) result(B)
         !$omp declare simd(operator_unit_sp)
         implicit none
         real(SP), dimension(:), intent(in)  :: A
         real(SP), dimension(NDIM)              :: B
      end function operator_unit_sp

      pure module function operator_unit_dp(A) result(B)
         !$omp declare simd(operator_unit_dp)
         implicit none
         real(DP), dimension(:), intent(in)  :: A
         real(DP), dimension(NDIM)              :: B
      end function operator_unit_dp

#ifdef QUADPREC
      pure module function operator_unit_qp(A) result(B)
         !$omp declare simd(operator_unit_qp)
         implicit none
         real(QP), dimension(:), intent(in)  :: A
         real(QP), dimension(NDIM)              :: B
      end function operator_unit_qp
#endif

      pure module function operator_unit_el_sp(A) result(B)
         implicit none
         real(SP), dimension(:,:), intent(in)  :: A
         real(SP), dimension(:,:), allocatable :: B
      end function operator_unit_el_sp

      pure module function operator_unit_el_dp(A) result(B)
         implicit none
         real(DP), dimension(:,:), intent(in) :: A
         real(DP), dimension(:,:), allocatable  :: B
      end function operator_unit_el_dp

#ifdef QUADPREC
      pure module function operator_unit_el_qp(A) result(B)
         implicit none
         real(QP), dimension(:,:), intent(in)  :: A
         real(QP), dimension(:,:), allocatable :: B
      end function operator_unit_el_qp
#endif
   end interface


end module operators

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(helio) s_helio_util
   use swiftest
contains

      module subroutine helio_util_setup_initialize_system(self, system_history, param)
      !! author: David A. Minton
      !!
      !! Initialize a Helio nbody system from files, converting all heliocentric quantities to barycentric.
      !!
      implicit none
      ! Arguments
      class(helio_nbody_system),               intent(inout) :: self   !! Helio nbody system object
      class(swiftest_storage),    allocatable, intent(inout) :: system_history !! Stores the system history between output dumps
      class(swiftest_parameters),              intent(inout) :: param          !! Current run configuration parameters 

      call swiftest_util_setup_initialize_system(self, system_history, param)
      call self%pl%sort("mass", ascending=.false.)
      call self%pl%vh2vb(self%cb)
      call self%tp%h2b(self%cb)

      ! Make sure that the discard list gets allocated initially
      call self%pl_discards%setup(0, param)
      call self%tp_discards%setup(0, param)
      call self%pl%set_mu(self%cb)
      call self%tp%set_mu(self%cb)

      if (param%lgr .and. param%in_type == "ASCII") then !! pseudovelocity conversion for NetCDF input files is handled by NetCDF routines
         call self%pl%v2pv(param)
         call self%tp%v2pv(param)
      end if

      call self%pl%flatten(param)

      return
   end subroutine helio_util_setup_initialize_system

end submodule s_helio_util

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (helio) s_helio_drift
   use swiftest
contains

   module subroutine helio_drift_body(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Loop through bodies and call Danby drift routine on democratic heliocentric coordinates
      !!
      !! Adapted from David E. Kaufmann's Swifter routine helio_drift.f90
      !! Adapted from Hal Levison's Swift routine drift.f
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self   !! Swiftest body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Stepsize
      ! Internals
      integer(I4B) :: i !! Loop counter
      integer(I4B), dimension(:),allocatable :: iflag !! Vectorized error code flag
      real(DP), dimension(:), allocatable    :: mu
      character(len=STRMAX) message

      if (self%nbody == 0) return

      associate(n => self%nbody)
         allocate(iflag(n))
         iflag(:) = 0
         allocate(mu(n))
         mu(:) = nbody_system%cb%Gmass
         call swiftest_drift_all(mu, self%rh, self%vb, self%nbody, param, dt, self%lmask, iflag)
         if (any(iflag(1:n) /= 0)) then
            where(iflag(1:n) /= 0) self%status(1:n) = DISCARDED_DRIFTERR
            do i = 1, n
               if (iflag(i) /= 0) then
                  write(message, *) " Body ", self%id(i), " lost due to error in Danby drift"
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT,message)
               end if
            end do
         end if
      end associate

      deallocate(iflag, mu)
      return
   end subroutine helio_drift_body


   module subroutine helio_drift_pl(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Wrapper function used to call the body drift routine from a helio_pl structure
      implicit none
      ! Arguments
      class(helio_pl),              intent(inout) :: self   !! Helio massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Stepsize

      call helio_drift_body(self, nbody_system, param, dt)

      return
   end subroutine helio_drift_pl


   module subroutine helio_drift_tp(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Wrapper function used to call the body drift routine from a helio_pl structure
      implicit none
      ! Arguments
      class(helio_tp),              intent(inout) :: self   !! Helio massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Stepsize

      call helio_drift_body(self, nbody_system, param, dt)

      return
   end subroutine helio_drift_tp


   pure elemental subroutine helio_drift_linear_one(rhx, rhy, rhz, ptx, pty, ptz, dt)
      !! author: David A. Minton
      !!
      !! Calculate the linear drift for a single body
      implicit none
      real(DP), intent(inout) :: rhx, rhy, rhz
      real(DP), intent(in) :: ptx, pty, ptz, dt
     
      rhx = rhx + ptx * dt
      rhy = rhy + pty * dt
      rhz = rhz + ptz * dt

      return
   end subroutine helio_drift_linear_one


   subroutine helio_drift_linear_all(rh, pt, dt, n, lmask)
      !! author: David A. Minton
      !!
      !! Loop through all the bodies and calculate the linear drift
      implicit none
      ! Arguments
      real(DP), dimension(:,:), intent(inout) :: rh
      real(DP), dimension(:),   intent(in)    :: pt
      real(DP),                 intent(in)    :: dt
      integer(I4B),             intent(in)    :: n
      logical,  dimension(:),   intent(in)    :: lmask
      ! Internals
      integer(I4B) :: i

      do i = 1, n
         if (lmask(i)) call helio_drift_linear_one(rh(1,i), rh(2,i), rh(3,i), pt(1), pt(2), pt(3), dt) 
      end do

      return
   end subroutine helio_drift_linear_all

   
   module subroutine helio_drift_linear_pl(self, cb, dt, lbeg)
      !! author: David A. Minton
      !!
      !! Perform linear drift of massive bodies due to barycentric momentum of Sun
      !!
      !! Adapted from David E. Kaufmann's Swifter routine helio_lindrift.f90
      !! Adapted from Hal Levison's Swift routine helio_lindrift.f
      implicit none
      ! Arguments
      class(helio_pl),               intent(inout) :: self !! Helio massive body object
      class(helio_cb),               intent(inout) :: cb   !! Helio central body
      real(DP),                      intent(in)    :: dt   !! Stepsize
      logical,                       intent(in)    :: lbeg !! Argument that determines whether or not this is the beginning or end of the step
      ! Internals
      real(DP), dimension(NDIM) :: pt     !! negative barycentric velocity of the central body

      if (self%nbody == 0) return

      associate(pl => self, npl => self%nbody)
         if (npl == 0) return
         pt(1) = sum(pl%Gmass(1:npl) * pl%vb(1,1:npl), self%lmask(1:npl))
         pt(2) = sum(pl%Gmass(1:npl) * pl%vb(2,1:npl), self%lmask(1:npl))
         pt(3) = sum(pl%Gmass(1:npl) * pl%vb(3,1:npl), self%lmask(1:npl))
         pt(:) = pt(:) / cb%Gmass
         call helio_drift_linear_all(pl%rh(:,:), pt(:), dt, npl, pl%lmask(:))

         if (lbeg) then
            cb%ptbeg = pt(:)
         else
            cb%ptend = pt(:) 
         end if
      end associate
   
      return
   end subroutine helio_drift_linear_pl
   

   module subroutine helio_drift_linear_tp(self, cb, dt, lbeg)
      !! author: David A. Minton
      !!
      !! Perform linear drift of test particles due to barycentric momentum of Sun
      !! New vectorized version included
      !!
      !! Adapted from David E. Kaufmann's Swifter routine helio_lindrift_tp.f90
      !! Adapted from Hal Levison's Swift routine helio_lindrift_tp.f
      implicit none
      ! Arguments
      class(helio_tp),               intent(inout) :: self !! Helio test particleb object
      class(helio_cb),               intent(in)    :: cb   !! Helio central body
      real(DP),                      intent(in)    :: dt   !! Stepsize
      logical,                       intent(in)    :: lbeg !! Argument that determines whether or not this is the beginning or end of the step
      ! Internals
      real(DP), dimension(NDIM)      :: pt     !! negative barycentric velocity of the central body
        
      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody)
         if (ntp == 0) return
         if (lbeg) then
            pt(:) = cb%ptbeg
         else
            pt(:) = cb%ptend
         end if
         where (self%lmask(1:ntp))
            tp%rh(1, 1:ntp) = tp%rh(1, 1:ntp) + pt(1) * dt
            tp%rh(2, 1:ntp) = tp%rh(2, 1:ntp) + pt(2) * dt
            tp%rh(3, 1:ntp) = tp%rh(3, 1:ntp) + pt(3) * dt
         end where
      end associate
   
      return
   end subroutine helio_drift_linear_tp

end submodule s_helio_drift

! Copyright 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 
submodule (swiftest) s_swiftest_drift
   !> Integration control parameters:
   real(DP), parameter :: E2MAX    = 0.36_DP      
   real(DP), parameter :: DM2MAX   = 0.16_DP
   real(DP), parameter :: E2DM2MAX = 0.0016_DP
   real(DP),     parameter :: DANBYB   = 1.0E-13_DP
   integer(I2B), parameter :: NLAG1    = 50
   integer(I2B), parameter :: NLAG2    = 40

contains

   module subroutine swiftest_drift_body(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Loop bodies and call Danby drift routine on the heliocentric position and velocities.
      !!
      !! Adapted from Hal Levison's Swift routine drift_tp.f 
      !! Adapted from David E. Kaufmann's Swifter routine whm_drift_tp.f90
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self   !! Swiftest test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Stepsize
      ! Internals
      integer(I4B)                              :: i   
      integer(I4B), dimension(:), allocatable   :: iflag
      character(len=STRMAX) :: message

      associate(n => self%nbody)
         allocate(iflag(n))
         iflag(:) = 0
         call swiftest_drift_all(self%mu, self%rh, self%vh, self%nbody, param, dt, self%lmask, iflag)
         if (any(iflag(1:n) /= 0)) then
            where(iflag(1:n) /= 0) self%status(1:n) = DISCARDED_DRIFTERR
            do i = 1, n
               if (iflag(i) /= 0) then
                  write(message, *) " Body ", self%id(i), " lost due to error in Danby drift"
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
               end if
            end do
         end if
      end associate

      deallocate(iflag)

      return
   end subroutine swiftest_drift_body


   module subroutine swiftest_drift_all(mu, x, v, n, param, dt, lmask, iflag)
      !! author: David A. Minton
      !!
      !! Loop bodies and call Danby drift routine on all bodies for the given position and velocity vector.
      !!
      !! Adapted from Hal Levison's Swift routine drift_tp.f 
      !! Adapted from David E. Kaufmann's Swifter routine whm_drift_tp.f9
      implicit none
      ! Arguments
      real(DP), dimension(:),     intent(in)    :: mu    !! Vector of gravitational constants
      real(DP), dimension(:,:),   intent(inout) :: x, v  !! Position and velocity vectors
      integer(I4B),               intent(in)    :: n     !! number of bodies
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters
      real(DP),                   intent(in)    :: dt    !! Stepsize
      logical, dimension(:),      intent(in)    :: lmask !! Logical mask of size self%nbody that determines which bodies to drift.
      integer(I4B), dimension(:), intent(out)   :: iflag !! Vector of error flags. 0 means no problem
      ! Internals
      integer(I4B)                              :: i   
      real(DP)                                  :: energy, vmag2, rmag  !! Variables used in GR calculation
      real(DP), dimension(:), allocatable       :: dtp

      if (n == 0) return

      allocate(dtp(n))
      if (param%lgr) then
#ifdef DOCONLOC
         do concurrent(i = 1:n, lmask(i)) shared(param,lmask,x,v,mu,dtp,dt) local(rmag,vmag2,energy)
#else
         do concurrent(i = 1:n, lmask(i))
#endif
            rmag = norm2(x(:, i))
            vmag2 = dot_product(v(:, i), v(:, i))
            energy = 0.5_DP * vmag2 - mu(i) / rmag
            dtp(i) = dt * (1.0_DP + 3 * param%inv_c2 * energy)
         end do
      else
         where(lmask(1:n)) dtp(1:n) = dt
      end if 

      !!$omp simd ! SIMD does not yet work
      do i = 1, n
         if (lmask(i)) call swiftest_drift_one(mu(i), x(1,i), x(2,i), x(3,i), v(1,i), v(2,i), v(3,i), dtp(i), iflag(i))
      end do
      !!$omp end simd

      deallocate(dtp)

      return
   end subroutine swiftest_drift_all


   pure elemental module subroutine swiftest_drift_one(mu, rx, ry, rz, vx, vy, vz, dt, iflag) 
      !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Perform Danby drift for one body, redoing drift with smaller substeps if original accuracy is insufficient
      !!
      !! Adapted from David E. Kaufmann's Swifter routine routine drift_one.f90
      !! Adapted from Hal Levison and Martin Duncan's Swift routine drift_one.f
      implicit none
      ! Arguments
      real(DP), intent(in)      :: mu                     !! G * (Mcb + m), G = gravitational constant, Mcb = mass of central body, m = mass of body to drift
      real(DP), intent(inout)   :: rx, ry, rz, vx, vy, vz !! Position and velocity of body to drift
      real(DP), intent(in)      :: dt                     !! Step size
      integer(I4B), intent(out) :: iflag                  !! iflag : error status flag for Danby drift (0 = OK, nonzero = ERROR)
      ! Internals
      integer(I4B) :: i
      real(DP)   :: dttmp

      call swiftest_drift_dan(mu, rx, ry, rz, vx, vy, vz, dt, iflag)
      if (iflag /= 0) then
         dttmp = 0.1_DP * dt
         do i = 1, 10
            call swiftest_drift_dan(mu, rx, ry, rz, vx, vy, vz, dttmp, iflag)
            if (iflag /= 0) exit
         end do
      end if

      return
   end subroutine swiftest_drift_one


   pure subroutine swiftest_drift_dan(mu, rx0, ry0, rz0, vx0, vy0, vz0, dt0, iflag)
      !! author: David A. Minton
      !!
      !! Perform Kepler drift, solving Kepler's equation in appropriate variables
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_dan.f90
      !! Adapted from Hal Levison and Martin Duncan's Swift routine drift_dan.f
      implicit none
      ! Arguments
      real(DP),     intent(in)    :: mu            !! G * (m1 + m2), G = gravitational constant, m1 = mass of central body, m2 = mass of body to drift
      real(DP),     intent(inout) :: rx0, ry0, rz0 !! position of body to drift
      real(DP),     intent(inout) :: vx0, vy0, vz0 !! velocity of body to drift     
      real(DP),     intent(in)    :: dt0           !! time step
      integer(I4B), intent(out)   :: iflag         !! error status flag for Kepler drift (0 = OK, nonzero = NO CONVERGENCE)
      ! Internals
      real(DP)        :: rx, ry, rz, vx, vy, vz, dt
      real(DP)        :: f, g, fdot, gdot, c1, c2, c3, u, alpha, fp, r0
      real(DP)        :: v0s, a, asq, en, dm, ec, es, esq, xkep, fchk, s, c

      ! Executable code
      iflag = 0
      dt = dt0
      r0 = sqrt(rx0*rx0 + ry0*ry0 + rz0*rz0)
      v0s = vx0*vx0 + vy0*vy0 + vz0*vz0
      u = rx0*vx0 + ry0*vy0 + rz0*vz0
      alpha = 2 * mu / r0 - v0s
      if (alpha > 0.0_DP) then
         a = mu / alpha
         asq = a**2
         en = sqrt(mu / (a * asq))
         ec = 1.0_DP - r0 / a
         es = u / (en * asq)
         esq = ec**2 + es**2
         dm = dt * en - int(dt * en / TWOPI, kind = I4B) * TWOPI
         dt = dm / en
         if ((esq < E2MAX) .and. (dm**2 < DM2MAX) .and. (esq * dm**2 < E2DM2MAX)) then
            call swiftest_drift_kepmd(dm, es, ec, xkep, s, c)
            fchk = (xkep - ec * s + es * (1.0_DP - c) - dm)
            ! DEK - original code compared fchk*fchk with DANBYB, but i think it should
            ! DEK - be compared with DANBYB*DANBYB, and i changed it accordingly - please
            ! DEK - check with hal and/or martin about this
            if (fchk**2 > DANBYB**2) then
               iflag = 1
               return
            end if
            fp = 1.0_DP - ec * c + es * s
            f = a / r0 * (c - 1.0_DP) + 1.0_DP
            g = dt + (s - xkep) / en
            fdot = -(a / (r0 * fp)) * en * s
            gdot = (c - 1.0_DP) / fp + 1.0_DP
            rx = rx0 * f + vx0 * g
            ry = ry0 * f + vy0 * g
            rz = rz0 * f + vz0 * g
            vx = rx0 * fdot + vx0 * gdot
            vy = ry0 * fdot + vy0 * gdot
            vz = rz0 * fdot + vz0 * gdot

            rx0 = rx
            ry0 = ry
            rz0 = rz
            vx0 = vx
            vy0 = vy
            vz0 = vz
            iflag = 0
            return
         end if
      end if

      call swiftest_drift_kepu(dt, r0, mu, alpha, u, fp, c1, c2, c3, iflag)
      if (iflag == 0) then
         f = 1.0_DP - mu / r0 * c2
         g = dt - mu * c3
         fdot = -mu / (fp * r0) * c1
         gdot = 1.0_DP - mu / fp * c2
         rx = rx0 * f + vx0 * g
         ry = ry0 * f + vy0 * g
         rz = rz0 * f + vz0 * g
         vx = rx0 * fdot + vx0 * gdot
         vy = ry0 * fdot + vy0 * gdot
         vz = rz0 * fdot + vz0 * gdot

         rx0 = rx
         ry0 = ry
         rz0 = rz
         vx0 = vx
         vy0 = vy
         vz0 = vz
      end if

      return
   end subroutine swiftest_drift_dan


   pure subroutine swiftest_drift_kepmd(dm, es, ec, x, s, c)
      !! author: David A. Minton
      !!
      !! Solve Kepler's equation in difference form for an ellipse for small input dm and eccentricity
      !!    Original disclaimer: built for speed, does not check how well the original equation is solved
      !!    Can do that in calling routine by checking how close (x - ec*s + es*(1.0 - c) - dm) is to zero
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepmd.f90
      !! Adapted from Martin Duncan's Swift routine drift_kepmd.f
      implicit none
      ! Arguments
      real(DP), intent(in)  :: dm !! increment in mean anomaly
      real(DP), intent(in)  :: es !! eccentricity times the sine of eccentric anomaly
      real(DP), intent(in)  :: ec !! eccentricity times the cosine of eccentric anomaly
      real(DP), intent(out) :: x  !! solution to Kepler's equation in difference form (x = dE)
      real(DP), intent(out) :: s  !! sine of x
      real(DP), intent(out) :: c  !! cosine of x
      ! Internals
      real(DP), parameter :: a0 = 39916800.0_DP, a1 = 6652800.0_DP, a2 = 332640.0_DP, a3 = 7920.0_DP, a4 = 110.0_DP
      real(DP)      :: dx, fac1, fac2, q, y, f, fp, fpp, fppp
      
      ! executable code
      fac1 = 1.0_DP / (1.0_DP - ec)
      q = fac1 * dm
      fac2 = es*es*fac1 - ec / 3.0_DP
      x = q * (1.0_DP - 0.5_DP * fac1 * q * (es - q * fac2))
      y = x*x
      s = x * (a0 - y * (a1 - y * (a2 - y * (a3 - y * (a4 - y))))) / a0
      c = sqrt(1.0_DP - s*s)
      f = x - ec * s + es * (1.0_DP - c) - dm
      fp = 1.0_DP - ec * c + es * s
      fpp = ec * s + es * c
      fppp = ec * c - es * s
      dx = -f / fp
      dx = -f / (fp + dx * fpp/2.0_DP)
      dx = -f / (fp + dx * fpp/2.0_DP + dx*dx * fppp * SIXTH)
      x = x + dx
      y = x*x
      s = x * (a0 - y * (a1 - y * (a2 - y * (a3 - y * (a4 - y))))) / a0
      c = sqrt(1.0_DP - s*s)
      
      return
   end subroutine swiftest_drift_kepmd


   pure subroutine swiftest_drift_kepu(dt,r0,mu,alpha,u,fp,c1,c2,c3,iflag)
      !! author: David A. Minton
      !!
      !! Solve Kepler's equation in universal variables
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu.f90
      !! Adapted from Hal Levison's Swift routine drift_kepu.f
      implicit none
      integer(I4B), intent(out) :: iflag
      real(DP), intent(in)      :: dt, r0, mu, alpha, u
      real(DP), intent(out)     :: fp, c1, c2, c3      
      real(DP) :: s, st, fo, fn
      
      ! executable code
      call swiftest_drift_kepu_guess(dt, r0, mu, alpha, u, s)
      st = s
      call swiftest_drift_kepu_new(s, dt, r0, mu, alpha, u, fp, c1, c2, c3, iflag)
      if (iflag /= 0) then
         call swiftest_drift_kepu_fchk(dt, r0, mu, alpha, u, st, fo)
         call swiftest_drift_kepu_fchk(dt, r0, mu, alpha, u, s, fn)
         if (abs(fo) < abs(fn)) s = st
         call swiftest_drift_kepu_lag(s, dt, r0, mu, alpha, u, fp, c1, c2, c3, iflag)
      end if
      
      return
   end subroutine swiftest_drift_kepu


   pure subroutine swiftest_drift_kepu_fchk(dt, r0, mu, alpha, u, s, f)
      !! author: David A. Minton
      !!
      !! Computes the value of f, the function whose root we are trying to find in universal variables
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu_fchk.f90
      !! Adapted from Martin Duncan's Swift routine drift_kepu_fchk.f
      implicit none
      ! Internals
      real(DP), intent(in)  :: dt    !! time step
      real(DP), intent(in)  :: r0    !! distance between two bodies
      real(DP), intent(in)  :: mu    !! G * (m1 + m2), G = gravitational constant, m1 = mass of central body, m2 = mass of body to drift
      real(DP), intent(in)  :: alpha !! twice the binding energy
      real(DP), intent(in)  :: u     !! dot product of position and velocity vectors
      real(DP), intent(in)  :: s     !! universal variable (approximate root of f)
      real(DP), intent(out) :: f     !! function value
      ! Arguments
      real(DP) :: x, c0, c1, c2, c3

      x = s**2 * alpha
      call swiftest_drift_kepu_stumpff(x, c0, c1, c2, c3)
      c1 = c1 * s
      c2 = c2 * s**2
      c3 = c3 * s**3
      f = r0 * c1 + u * c2 + mu * c3 - dt

      return
   end subroutine swiftest_drift_kepu_fchk


   pure subroutine swiftest_drift_kepu_guess(dt, r0, mu, alpha, u, s)
      !! author: David A. Minton
      !!
      !! Compute initial guess for solving Kepler's equation using universal variables
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu_guess.f90
      !! Adapted from Hal Levison and Martin Duncan's Swift routine drift_kepu_guess.f
      implicit none
      ! Arguments
      real(DP), intent(in)  :: dt    !! time ste4p
      real(DP), intent(in)  :: r0    !! distance between two bodies
      real(DP), intent(in)  :: mu    !! G * (m1 + m2), G = gravitational constant, m1 = mass of central body, m2 = mass of body to drift
      real(DP), intent(in)  :: alpha !! twice the binding energy
      real(DP), intent(in)  :: u     !! dot product of position and velocity vectors
      real(DP), intent(out) :: s     !! initial guess for the value of the universal variable
      ! Internals
      integer(I4B) :: iflag
      real(DP), parameter :: thresh = 0.4_DP, danbyk = 0.85_DP
      real(DP)        :: y, sy, cy, sigma, es, x, a, en, ec, e

      if (alpha > 0.0_DP) then
         if (dt / r0 <= thresh) then
            s = dt/r0 - (dt*dt*u)/(2.0_DP*r0*r0*r0)
         else
            a = mu/alpha
            en = sqrt(mu/(a*a*a))
            ec = 1.0_DP - r0/a
            es = u/(en*a*a)
            e = sqrt(ec*ec + es*es)
            y = en*dt - es
            call swiftest_orbel_scget(y, sy, cy)
            sigma = sign(1.0_DP, es*cy + ec*sy)
            x = y + sigma*DANBYK*e
            s = x/sqrt(alpha)
         end if
      else
         call swiftest_drift_kepu_p3solve(dt, r0, mu, alpha, u, s, iflag)
         if (iflag /= 0) s = dt / r0
      end if

      return
   end subroutine swiftest_drift_kepu_guess


   pure subroutine swiftest_drift_kepu_lag(s, dt, r0, mu, alpha, u, fp, c1, c2, c3, iflag)
      !! author: David A. Minton
      !!
      !! Solve Kepler's equation in universal variables using Laguerre's method
      !!      Reference: Danby, J. M. A. 1988. Fundamentals of Celestial Mechanics, (Willmann-Bell, Inc.), 178 - 180.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu_lag.f90
      !! Adapted from Hal Levison's Swift routine drift_kepu_lag.f
      implicit none
      ! Arguments
      real(DP),     intent(inout) :: s     !! universal variable 
      real(DP),     intent(in)    :: dt    !! time step
      real(DP),     intent(in)    :: r0    !! distance between two bodies 
      real(DP),     intent(in)    :: mu    !! G * (m1 + m2), G = gravitational constant, m1 = mass of central body, m2 = mass of body to drift 
      real(DP),     intent(in)    :: alpha !! twice the binding energy 
      real(DP),     intent(in)    :: u     !! dot product of position and velocity vectors
      real(DP),     intent(out)   :: fp    !! first derivative of Kepler's equation in universal variables with respect to s (see Danby, p. 175)
      real(DP),     intent(out)   :: c1    !! Stumpff function c1 times s
      real(DP),     intent(out)   :: c2    !! Stumpff function c2 times s**2
      real(DP),     intent(out)   :: c3    !! Stumpff function c3 times s**3
      integer(I4B), intent(out)   :: iflag !! error status flag for convergence (0 = CONVERGED, nonzero = NOT CONVERGED)
      ! Internals
      integer(I4B) :: nc, ncmax
      real(DP)   :: x, fpp, ds, c0, f, fdt
      integer(I4B), parameter :: ln = 5

      if (alpha < 0.0_DP) then
         ncmax = NLAG2
      else
         ncmax = NLAG1
      end if
      do nc = 0, ncmax
         x = s * s * alpha
         call swiftest_drift_kepu_stumpff(x, c0, c1, c2, c3)
         c1 = c1*s
         c2 = c2*s*s
         c3 = c3*s*s*s
         f = r0 * c1 + u * c2 + mu * c3 - dt
         fp = r0 * c0 + u * c1 + mu * c2
         fpp = (-r0 * alpha + mu) * c1 + u * c0
         ds = -ln*f/(fp + sign(1.0_DP, fp)*sqrt(abs((ln - 1.0_DP)*(ln - 1.0_DP)*fp*fp - (ln - 1.0_DP)*ln*f*fpp)))
         s = s + ds
         fdt = f / dt
         if (fdt*fdt < DANBYB*DANBYB) then
            iflag = 0
            return
         end if
      end do
      iflag = 2

      return
   end subroutine swiftest_drift_kepu_lag


   pure subroutine swiftest_drift_kepu_new(s, dt, r0, mu, alpha, u, fp, c1, c2, c3, iflag)
      !! author: David A. Minton
      !!
      !! Solve Kepler's equation in universal variables using Newton's method
      !!      Reference: Danby, J. M. A. 1988. Fundamentals of Celestial Mechanics, (Willmann-Bell, Inc.), 174 - 175.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu_new.f90
      !! Adapted from Hal Levison's Swift routine drift_kepu_new.f
      implicit none
      ! Arguments
      real(DP),     intent(inout) :: s     !! universal variable
      real(DP),     intent(in)    :: dt    !! time step
      real(DP),     intent(in)    :: r0    !! distance between two bodies
      real(DP),     intent(in)    :: mu    !! G * (m1 + m2), G = gravitational constant, m1 = mass of central body, m2 = mass of body to drift
      real(DP),     intent(in)    :: alpha !! twice the binding energy
      real(DP),     intent(in)    :: u     !! dot product of position and velocity vectors
      real(DP),     intent(out)   :: fp    !! first derivative of Kepler's equation in universal variables with respect to s (see Danby, p. 175)
      real(DP),     intent(out)   :: c1    !! Stumpff function c1 times s
      real(DP),     intent(out)   :: c2    !! Stumpff function c2 times s**2
      real(DP),     intent(out)   :: c3    !! Stumpff function c3 times s**3
      integer(I4B), intent(out)   :: iflag !! error status flag for convergence (0 = CONVERGED, nonzero = NOT CONVERGED)
      ! Internals
      integer( I4B) :: nc
      real(DP)   :: x, c0, ds, f, fpp, fppp, fdt

      do nc = 0, 6
         x = s*s*alpha
         call swiftest_drift_kepu_stumpff(x, c0, c1, c2, c3)
         c1 = c1*s
         c2 = c2*s*s
         c3 = c3*s*s*s
         f = r0*c1 + u*c2 + mu*c3 - dt
         fp = r0*c0 + u*c1 + mu*c2
         fpp = (-r0*alpha + mu)*c1 + u*c0
         fppp = (-r0*alpha + mu)*c0 - u*alpha*c1
         ds = -f/fp
         ds = -f/(fp + ds*fpp/2.0_DP)
         ds = -f/(fp + ds*fpp/2.0_DP + ds*ds*fppp/6.0_DP)
         s = s + ds
         fdt = f/dt
         if (fdt*fdt < DANBYB*DANBYB) then
              iflag = 0
              return
         end if
      end do
      iflag = 1

      return
   end subroutine swiftest_drift_kepu_new


   pure subroutine swiftest_drift_kepu_p3solve(dt, r0, mu, alpha, u, s, iflag)
      !! author: David A. Minton
      !!
      !! Computes real root of cubic involved in setting initial guess for solving Kepler's equation in universal variables
      !!      Reference: Danby, J. M. A. 1988. Fundamentals of Celestial Mechanics, (Willmann-Bell, Inc.), 177 - 178.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu_p3solve.f90
      !! Adapted from Martin Duncan's Swift routine drift_kepu_p3solve.f
      implicit none
      ! Arguments
      real(DP), intent(in)      :: dt    !! time step
      real(DP), intent(in)      :: r0    !! distance between two bodies
      real(DP), intent(in)      :: mu    !! G * (m1 + m2), G = gravitational constant, m1 = mass of central body, m2 = mass of body to drift
      real(DP), intent(in)      :: alpha !! twice the binding energy
      real(DP), intent(in)      :: u     !! dot product of position and velocity vectors
      real(DP), intent(out)     :: s     !! s     : real solution of cubic equation
      integer(I4B), intent(out) :: iflag !! error status flag for solution (0 = OK, nonzero = ERROR)
      ! Internals
      real(DP) :: denom, a0, a1, a2, q, r, sq2, sq, p1, p2

      denom = (mu - alpha * r0) * SIXTH
      a2 = 0.5_DP * u / denom
      a1 = r0 / denom
      a0 = -dt / denom
      q = (a1 - a2*a2 * THIRD) * THIRD
      r = (a1*a2 - 3 * a0) * SIXTH - (a2*a2*a2)/27.0_DP
      sq2 = q*q*q + r*r
      if (sq2 >= 0.0_DP) then
         sq = sqrt(sq2)
         if ((r + sq) <= 0.0_DP) then
            p1 = -(-(r + sq))**(THIRD)
         else
            p1 = (r + sq)**(THIRD)
         end if
         if ((r - sq) <= 0.0_DP) then
            p2 = -(-(r - sq))**(THIRD)
         else
            p2 = (r - sq)**(THIRD)
         end if
         iflag = 0
         s = p1 + p2 - a2 * THIRD
      else
         iflag = 1
         s = 0.0_DP
      end if

      return
   end subroutine swiftest_drift_kepu_p3solve


   pure subroutine swiftest_drift_kepu_stumpff(x, c0, c1, c2, c3)
      !! author: David A. Minton
      !!
      !! Compute Stumpff functions needed for Kepler drift in universal variables
      !!      Reference: Danby, J. M. A. 1988. Fundamentals of Celestial Mechanics, (Willmann-Bell, Inc.), 171 - 172.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: drift_kepu_stumpff.f90
      !! Adapted from Hal Levison's Swift routine drift_kepu_stumpff.f
      implicit none
      ! Arguments
      real(DP), intent(inout) :: x  !! argument of Stumpff functions
      real(DP), intent(out)   :: c0 !! zeroth Stumpff function
      real(DP), intent(out)   :: c1 !! first Stumpff function
      real(DP), intent(out)   :: c2 !! second Stumpff function
      real(DP), intent(out)   :: c3 !! third Stumpff function
      ! Internals
      integer(I4B) :: i, n
      real(DP)   :: xm

      n = 0
      xm = 0.1_DP
      do while (abs(x) >= xm)
         n = n + 1
         x = x / 4.0_DP
      end do
      c2 = (1.0_DP - x * (1.0_DP - x * (1.0_DP - x * (1.0_DP - x * (1.0_DP - x * &
            (1.0_DP - x / 182.0_DP) / 132.0_DP) / 90.0_DP) / 56.0_DP) /        &
            30.0_DP) / 12.0_DP) / 2.0_DP
      c3 = (1.0_DP - x * (1.0_DP - x * (1.0_DP - x * (1.0_DP - x * (1.0_DP - x * &
            (1.0_DP - x / 210.0_DP) / 156.0_DP) / 110.0_DP) / 72.0_DP) /       &
            42.0_DP) / 20.0_DP ) / 6.0_DP
      c1 = 1.0_DP - x * c3
      c0 = 1.0_DP - x * c2
      if (n /= 0) then
         do i = n, 1, -1
            c3 = (c2 + c0 * c3) / 4.0_DP
            c2 = c1*c1 / 2.0_DP
            c1 = c0 * c1
            c0 = 2 * c0*c0 - 1.0_DP
            x = x * 4
         end do
      end if

      return
   end subroutine swiftest_drift_kepu_stumpff


end submodule s_swiftest_drift

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(fraggle) s_fraggle_util
   use swiftest
contains

   module subroutine fraggle_util_restructure(self, nbody_system, param, lfailure)
      !! author: David A. Minton
      !!
      !! Restructures the fragment distribution after a failure to converge on a solution.
      implicit none
      ! Arguments
      class(collision_fraggle),     intent(inout) :: self         
         !! Fraggle collision system object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      logical,                      intent(out)   :: lfailure     
         !! Did the computation fail?
      ! Internals
      class(collision_fragments), allocatable :: new_fragments
      integer(I4B) :: i,nnew, nold
      real(DP) :: volume

      associate(old_fragments => self%fragments)
         lfailure = .false.
         ! Merge the second-largest fragment into the first and shuffle the masses up
         nold = old_fragments%nbody
         if (nold <= 3) then
            lfailure = .true.
            return
         end if
         nnew = nold - 1
         allocate(new_fragments, mold=old_fragments)
         call new_fragments%setup(nnew)

         ! Merge the first and second bodies
         volume = 4._DP / 3._DP * PI * sum(old_fragments%radius(1:2)**3)
         new_fragments%mass(1) = sum(old_fragments%mass(1:2))
         new_fragments%Gmass(1) =sum(old_fragments%Gmass(1:2))
         new_fragments%density(1) = new_fragments%mass(1) / volume
         new_fragments%radius(1) = (3._DP * volume / (4._DP * PI))**(THIRD)
#ifdef DOCONLOC
         do concurrent(i = 1:NDIM) shared(old_fragments, new_fragments)
#else
         do concurrent(i = 1:NDIM)
#endif
            new_fragments%Ip(i,1) = sum(old_fragments%mass(1:2) * old_fragments%Ip(i,1:2)) 
         end do
         new_fragments%Ip(:,1) = new_fragments%Ip(:,1) / new_fragments%mass(1)
         new_fragments%origin_body(1) = old_fragments%origin_body(1)
         
         ! Copy the n>2 old fragments to the n>1 new fragments
         new_fragments%mass(2:nnew) = old_fragments%mass(3:nold)
         new_fragments%Gmass(2:nnew) = old_fragments%Gmass(3:nold)
         new_fragments%density(2:nnew) = old_fragments%density(3:nold)
         new_fragments%radius(2:nnew) = old_fragments%radius(3:nold)
#ifdef DOCONLOC
         do concurrent(i = 1:NDIM) shared(old_fragments,new_fragments)
#else
         do concurrent(i = 1:NDIM)
#endif
            new_fragments%Ip(i,2:nnew) = old_fragments%Ip(i,3:nold) 
         end do
         new_fragments%origin_body(2:nnew) = old_fragments%origin_body(3:nold)

         new_fragments%mtot = old_fragments%mtot
      end associate

      deallocate(self%fragments)
      call move_alloc(new_fragments, self%fragments)

      call fraggle_generate_pos_vec(self, nbody_system, param, lfailure)
      if (lfailure) return
      call fraggle_generate_rot_vec(self, nbody_system, param)

      ! Increase the spatial size factor to get a less dense cloud
      self%fail_scale = self%fail_scale * 1.001_DP

   end subroutine fraggle_util_restructure

   module subroutine fraggle_util_set_mass_dist(self, param)
      !! author: David A. Minton
      !!
      !! Sets the mass of fragments based on the mass distribution returned by the regime calculation.
      !! This subroutine must be run after the the setup routine has been run on the fragments
      use, intrinsic :: ieee_exceptions
      implicit none
      ! Arguments
      class(collision_fraggle),   intent(inout) :: self  
         !! Fraggle collision system object
      class(swiftest_parameters), intent(in)    :: param 
         !! Current Swiftest run configuration parameters
      ! Internals
      integer(I4B)              :: i, j, jproj, jtarg, istart, nfragmax
      real(DP), dimension(2)    :: volume
      real(DP), dimension(NDIM) :: Ip_avg
      real(DP) ::  mremaining, mtot, mcumul, G, mass_noise
      real(DP), dimension(:), allocatable :: mass
      real(DP)  :: beta 
      integer(I4B), parameter :: MASS_NOISE_FACTOR = 5  ! The number of digits of random noise that get added to the minimum mass 
                                                        ! value to prevent identical masses from being generated in a single run 
      integer(I4B), parameter :: NFRAGMAX_UNSCALED = 100  ! Maximum number of fragments that can be generated
      integer(I4B), dimension(:), allocatable :: ind
      logical :: flipper
      logical, dimension(size(IEEE_ALL))      :: fpe_halting_modes

      call ieee_get_halting_mode(IEEE_ALL,fpe_halting_modes)  ! Save the current halting modes so we can turn them off temporarily
      call ieee_set_halting_mode(IEEE_ALL,.false.)
     
      associate(impactors => self%impactors, min_mfrag => self%min_mfrag)
         ! Get mass weighted mean of Ip and density
         volume(1:2) = 4._DP / 3._DP * PI * impactors%radius(1:2)**3
         mtot = sum(impactors%mass(:))
         G = impactors%Gmass(1) / impactors%mass(1)
         Ip_avg(:) = (impactors%mass(1) * impactors%Ip(:,1) + impactors%mass(2) * impactors%Ip(:,2)) / mtot

         if (impactors%mass(1) >= impactors%mass(2)) then
            jtarg = 1
            jproj = 2
         else
            jtarg = 2
            jproj = 1
         end if

         select case(impactors%regime)
         case(COLLRESOLVE_REGIME_DISRUPTION, COLLRESOLVE_REGIME_SUPERCATASTROPHIC, COLLRESOLVE_REGIME_HIT_AND_RUN)
            ! The first two bins of the mass_dist are the largest and second-largest fragments that came out of collision_regime.
            ! The remainder from the third bin will be distributed among nfrag-2 bodies. 

            ! Add a small amount of noise to the last digits of the minimum mass value so that multiple fragments don't get 
            ! generated with identical mass values
            call random_number(mass_noise)
            mass_noise = 1.0_DP + mass_noise * epsilon(1.0_DP) * 10**(MASS_NOISE_FACTOR)
            min_mfrag = (param%min_GMfrag / param%GU) * mass_noise
            
            mremaining = impactors%mass_dist(iMrem)
            nfrag = iMrem - 1 
            Mslr = impactors%mass_dist(iMslr)
            nfragmax = ceiling(NFRAGMAX_UNSCALED / param%nfrag_reduction)
            Mrat = max((mremaining + Mslr) / min_mfrag, 1.0_DP)
            nfrag = max(ceiling(nfragmax * (log(Mrat) + 1.0_DP)), NFRAGMIN)

            call self%setup_fragments(nfrag)

         case (COLLRESOLVE_REGIME_MERGE, COLLRESOLVE_REGIME_GRAZE_AND_MERGE) 

            call self%setup_fragments(1)
            associate(fragments => self%fragments)
               fragments%mass(1) = impactors%mass_dist(1)
               fragments%Gmass(1) = G * impactors%mass_dist(1)
               fragments%radius(1) = impactors%radius(jtarg)
               fragments%density(1) = impactors%mass_dist(1) / volume(jtarg)
               if (param%lrotation) fragments%Ip(:, 1) = impactors%Ip(:,1)
            end associate
            call ieee_set_halting_mode(IEEE_ALL,fpe_halting_modes)
            return
         case default
            write(*,*) "fraggle_util_set_mass_dist_fragments error: Unrecognized regime code",impactors%regime
         end select

         associate(fragments => self%fragments)
            fragments%mtot = mtot
            allocate(mass, mold=fragments%mass)

            ! Make the first two bins the same as the Mlr and Mslr values that came from collision_regime
            mass(1) = impactors%mass_dist(iMlr) 
            mass(2) = impactors%mass_dist(iMslr)

            ! Recompute the slope parameter beta so that we span the complete size range
            if (abs(Mslr - min_mfrag) < epsilon(min_mfrag) * min_mfrag) Mslr = Mslr + impactors%mass_dist(iMrem) / nfrag
            mremaining = impactors%mass_dist(iMrem)

            ! The mass will be distributed in a power law where N>M=(M/Mslr)**(-beta/3)
            ! Use Brent's method solver to get the logspace slope of the mass function
            Mrat = (mremaining + Mslr) / Mslr
            beta = 3.0_DP
            call solve_roots(fraggle_util_sfd_function,beta)

            do i = iMrem,nfrag
               mass(i) = Mslr * (i-1)**(-beta/3.0_DP)
            end do

            ! There may still be some small residual due to round-off error. If so, simply add it to the last bin of the mass 
            ! distribution.
            mremaining = fragments%mtot - sum(mass(1:nfrag))
            if (mremaining < 0.0_DP) then
               mass(iMlr) = mass(iMlr) + mremaining
            else
               mass(iMslr) = mass(iMslr) + mremaining
            end if

            ! Sort the distribution in descending order by mass so that the largest fragment is always the first
            call util_sort(-mass, ind)
            call util_sort_rearrange(mass, ind, nfrag)
            call move_alloc(mass, fragments%mass)

            fragments%Gmass(:) = G * fragments%mass(:)

            ! Compute physical properties of the new fragments
            select case(impactors%regime)
            case(COLLRESOLVE_REGIME_HIT_AND_RUN)  
               ! The hit and run case always preserves the largest body intact, so there is no need to recompute the physical 
               ! properties of the first fragment
               fragments%radius(1) = impactors%radius(jtarg)
               fragments%density(1) = impactors%mass_dist(iMlr) / volume(jtarg)
               fragments%Ip(:, 1) = impactors%Ip(:,1)
               istart = 2
            case default
               istart = 1
            end select

            fragments%density(istart:nfrag) = fragments%mtot / sum(volume(:))
            fragments%radius(istart:nfrag) = (3 * fragments%mass(istart:nfrag) / &
                                             (4 * PI * fragments%density(istart:nfrag)))**(1.0_DP / 3.0_DP)
#ifdef DOCONLOC
            do concurrent(i = istart:nfrag) shared(fragments,Ip_avg)
#else
            do concurrent(i = istart:nfrag)
#endif
               fragments%Ip(:, i) = Ip_avg(:)
            end do

            ! For catastrophic impacts, we will assign each of the n>2 fragments to one of the two original bodies so that the 
            ! fragment cloud occupies roughly the same space as both original bodies. For all other disruption cases, we use body 2
            ! as the center of the cloud.
            fragments%origin_body(1) = 1_I1B
            fragments%origin_body(2) = 2_I1B
            if (impactors%regime == COLLRESOLVE_REGIME_SUPERCATASTROPHIC) then
               mcumul = fragments%mass(1)
               flipper = .true.
               j = 2
               do i = 1, nfrag
                  if (flipper .and. (mcumul < impactors%mass(1))) then
                     flipper = .false.
                     j = 1
                  else
                     j = 2
                     flipper = .true.
                  end if
                  fragments%origin_body(i) = j
               end do
            else
               fragments%origin_body(3:nfrag) = 2
            end if
         end associate
      end associate

      call ieee_set_halting_mode(IEEE_ALL,fpe_halting_modes)
      return

   end subroutine fraggle_util_set_mass_dist

   module function fraggle_util_sfd_function(x) result(y)
      !! author: David A. Minton
      !!
      !! Function to be used in the Brent's method solver to find the slope of the mass distribution
      implicit none
      ! Arguments
      real(DP), intent(in) :: x
      ! Result
      real(DP)             :: y
      ! Internals
      integer(I4B) :: i

      y = Mrat - 1.0_DP
      do i = iMrem, nfrag
         y = y - (i-1)**(-x/3.0_DP)
      end do
   end function fraggle_util_sfd_function

end submodule s_fraggle_util

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (collision) s_collision_check
   use swiftest
   use symba, only : symba_pl, symba_tp
contains

   pure elemental subroutine collision_check_one(xr, yr, zr, vxr, vyr, vzr, Gmtot, rlim, dt, lvdotr, lcollision, lclosest)
      !! author: David A. Minton
      !! 
      !! Check for a merger between a single pair of particles
      !!
      !! Adapted from David E. Kaufmann's Swifter routines symba_merge_tp.f90 and symba_merge_pl.f90
      !!
      !! Adapted from Hal Levison's Swift routine symba5_merge.f
      implicit none
      ! Arguments
      real(DP), intent(in) :: xr, yr, zr    !! Relative position vector components
      real(DP), intent(in) :: vxr, vyr, vzr !! Relative velocity vector components
      real(DP), intent(in) :: Gmtot         !! Sum of G*mass of colliding bodies
      real(DP), intent(in) :: rlim          !! Collision limit - Typically the sum of the radii of colliding bodies
      real(DP), intent(in) :: dt            !! Step size
      logical,  intent(in) :: lvdotr        !! Logical flag indicating that these two bodies are approaching in the current substep
      logical, intent(out) :: lcollision    !! Logical flag indicating whether these two bodies will collide or not
      logical, intent(out) :: lclosest      !! Logical flag indicating that, while not a collision, this is the closest approach for
                                            !!  this pair of bodies
      ! Internals
      real(DP) :: r2, rlim2, a, e, q, vdotr, tcr2, dt2

      r2 = xr**2 + yr**2 + zr**2
      rlim2 = rlim**2
      lclosest = .false. 
      if (r2 <= rlim2) then ! checks if bodies are actively colliding in this time step
         lcollision = .true.
      else ! if they are not actively colliding in  this time step, checks if they are going to collide next time step based on 
           ! velocities and q 
         lcollision = .false.
         vdotr = xr * vxr + yr * vyr + zr * vzr
         if (lvdotr .and. (vdotr > 0.0_DP)) then 
            tcr2 = r2 / (vxr**2 + vyr**2 + vzr**2)
            dt2 = dt**2
            if (tcr2 <= dt2) then
               call swiftest_orbel_xv2aeq(Gmtot, xr, yr, zr, vxr, vyr, vzr, a, e, q)
               lcollision = (q < rlim) 
            end if
            lclosest = .not. lcollision
         end if
      end if

      return
   end subroutine collision_check_one


   module subroutine collision_check_plpl(self, nbody_system, param, t, dt, irec, lany_collision)
      !! author: David A. Minton
      !!
      !! Check for merger between massive bodies and test particles in SyMBA
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine symba_merge.f90 and symba_merge_tp.f90
      !!
      !! Adapted from Hal Levison's Swift routine symba5_merge.f
      implicit none
      ! Arguments
      class(collision_list_plpl), intent(inout) :: self !! SyMBA pl-tp encounter list object
      class(base_nbody_system), intent(inout) :: nbody_system  !! SyMBA nbody system object
      class(base_parameters),intent(inout) :: param !! Current run configuration parameters 
      real(DP),  intent(in) :: t !! current time
      real(DP), intent(in) :: dt  !! step size
      integer(I4B), intent(in)  :: irec  !! Current recursion level
      logical, intent(out) :: lany_collision !! Returns true if cany pair of encounters resulted in a collision 
      ! Internals
      logical, dimension(:), allocatable        :: lcollision, lmask
      real(DP), dimension(NDIM)                 :: xr, vr
      integer(I4B)                              :: i, j
      integer(I8B)                              :: k, nenc
      real(DP)                                  :: rlim, Gmtot
      logical                                   :: lany_closest

      lany_collision = .false.
      if (self%nenc == 0) return

      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(pl => nbody_system%pl)

            nenc = self%nenc
            allocate(lmask(nenc))
            lmask(:) = (self%status(1:nenc) == ACTIVE)
            select type(pl)
            class is (symba_pl)
               lmask(:) = lmask(:).and. (pl%levelg(self%index1(1:nenc)) >= irec)
            end select
            if (.not.any(lmask(:))) return

            allocate(lcollision(nenc))
            lcollision(:) = .false.
            self%lclosest(:) = .false.

#ifdef DOCONLOC
            do concurrent(k = 1_I8B:nenc, lmask(k)) shared(self,pl,lmask, dt, lcollision) local(i,j,xr,vr,rlim,Gmtot)
#else
            do concurrent(k = 1_I8B:nenc, lmask(k))
#endif
               i = self%index1(k)
               j = self%index2(k)
               xr(:) = pl%rh(:, i) - pl%rh(:, j) 
               vr(:) = pl%vb(:, i) - pl%vb(:, j)
               rlim = pl%radius(i) + pl%radius(j)
               Gmtot = pl%Gmass(i) + pl%Gmass(j)
               call collision_check_one(xr(1), xr(2), xr(3), vr(1), vr(2), vr(3), Gmtot, rlim, dt, self%lvdotr(k), lcollision(k), &
                                        self%lclosest(k))
            end do

            lany_collision = any(lcollision(:))
            lany_closest = (param%lenc_save_closest .and. any(self%lclosest(:)))

            if (lany_collision .or. lany_closest) then
               call pl%rh2rb(nbody_system%cb) ! Update the central body barycenteric position vector to get us out of DH and into 
                                              ! barycentric coordinates
               do k = 1_I8B, nenc
                  if (.not.lcollision(k) .and. .not. self%lclosest(k)) cycle
                  i = self%index1(k)
                  j = self%index2(k)
                  self%r1(:,k) = pl%rh(:,i) + nbody_system%cb%rb(:)
                  self%v1(:,k) = pl%vb(:,i) 
                  if (lcollision(k)) then
                     self%status(k) = COLLIDED
                     self%tcollision(k) = t
                  end if
                  self%r2(:,k) = pl%rh(:,j) + nbody_system%cb%rb(:)
                  self%v2(:,k) = pl%vb(:,j) 
                  if (lcollision(k)) then
                     ! Check to see if either of these bodies has been involved with a collision before, and if so, make this a 
                     ! collider pair
                     if (pl%lcollision(i) .or. pl%lcollision(j)) call pl%make_impactors([i,j])

                     ! Set the collision flag for these to bodies to true in case they become involved in another collision later in
                     ! the step
                     pl%lcollision([i, j]) = .true.
                     pl%status([i, j]) = COLLIDED
                     call pl%info(i)%set_value(status="COLLIDED")
                     call pl%info(j)%set_value(status="COLLIDED")
                  end if

               end do

               ! Extract the pl-pl encounter list and return the pl-pl collision_list
               call self%extract_collisions(nbody_system, param)
            end if

            ! Take snapshots of pairs of bodies at close approach (but not collision) if requested
            if (lany_closest) call nbody_system%encounter_history%take_snapshot(param, nbody_system, t, "closest") 

         end associate
      end select
      return 
   end subroutine collision_check_plpl


   module subroutine collision_check_pltp(self, nbody_system, param, t, dt, irec, lany_collision)
      !! author: David A. Minton
      !!
      !! Check for merger between massive bodies and test particles in SyMBA
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine symba_merge.f90 and symba_merge_tp.f90
      !!
      !! Adapted from Hal Levison's Swift routine symba5_merge.f
      implicit none
      ! Arguments
      class(collision_list_pltp),intent(inout) :: self  !! SyMBA pl-tp encounter list object
      class(base_nbody_system), intent(inout) :: nbody_system !! SyMBA nbody system object
      class(base_parameters), intent(inout) :: param !! Current run configuration parameters 
      real(DP), intent(in) :: t !! current time
      real(DP), intent(in) :: dt  !! step size
      integer(I4B), intent(in)  :: irec  !! Current recursion level
      logical, intent(out)  :: lany_collision !! Returns true if cany pair of encounters resulted in a collision 
      ! Internals
      logical, dimension(:), allocatable        :: lcollision, lmask
      real(DP), dimension(NDIM)                 :: xr, vr
      integer(I4B)                              :: i, j
      integer(I8B)                              :: k, nenc
      logical                                   :: lany_closest
      character(len=STRMAX)                     :: timestr, idstri, idstrj, message

      lany_collision = .false.
      if (self%nenc == 0) return

      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(pl => nbody_system%pl, tp => nbody_system%tp)

            nenc = self%nenc
            allocate(lmask(nenc))
            lmask(:) = (self%status(1:nenc) == ACTIVE) 
            select type(pl)
            class is (symba_pl)
               select type(tp)
               class is (symba_tp)
                  lmask(:) = lmask(:) .and. (tp%levelg(self%index2(1:nenc)) >= irec)
               end select
            end select
            if (.not.any(lmask(:))) return

            allocate(lcollision(nenc))
            lcollision(:) = .false.
            self%lclosest(:) = .false.

#ifdef DOCONLOC
            do concurrent(k = 1_I8B:nenc, lmask(k)) shared(self,pl,tp,lmask, dt, lcollision) local(i,j,xr,vr)
#else
            do concurrent(k = 1_I8B:nenc, lmask(k))
#endif
               i = self%index1(k)
               j = self%index2(k)
               xr(:) = pl%rh(:, i) - tp%rh(:, j) 
               vr(:) = pl%vb(:, i) - tp%vb(:, j)
               call collision_check_one(xr(1), xr(2), xr(3), vr(1), vr(2), vr(3), pl%Gmass(i), pl%radius(i), dt, self%lvdotr(k), &
                                        lcollision(k), self%lclosest(k))
            end do

            lany_collision = any(lcollision(:))
            lany_closest = (param%lenc_save_closest .and. any(self%lclosest(:)))


            if (lany_collision .or. lany_closest) then
               call pl%rh2rb(nbody_system%cb) ! Update the central body barycenteric position vector to get us out of DH and into 
                                              ! barycentric coordiantes
               do k = 1, nenc
                  if (.not.lcollision(k) .and. .not. self%lclosest(k)) cycle
                  i = self%index1(k)
                  j = self%index2(k)
                  self%r1(:,k) = pl%rh(:,i) + nbody_system%cb%rb(:)
                  self%v1(:,k) = pl%vb(:,i) 
                  if (lcollision(k)) then
                     self%status(k) = COLLIDED
                     self%tcollision(k) = t
                  end if

                  self%r2(:,k) = tp%rh(:,j) + nbody_system%cb%rb(:)
                  self%v2(:,k) = tp%vb(:,j) 
                  if (lcollision(k)) then
                     tp%status(j) = DISCARDED_PLR
                     tp%ldiscard(j) = .true.
                     write(idstri, *) pl%id(i)
                     write(idstrj, *) tp%id(j)
                     write(timestr, *) t
                     call tp%info(j)%set_value(status="DISCARDED_PLR", discard_time=t, discard_rh=tp%rh(:,j), discard_vh=tp%vh(:,j))
                     write(message, *) "Particle " // trim(adjustl(tp%info(j)%name)) // " ("  // trim(adjustl(idstrj)) // ")" &
                           //  " collided with massive body " // trim(adjustl(pl%info(i)%name)) // " (" // trim(adjustl(idstri)) &
                           // ")" //  " at t = " // trim(adjustl(timestr))
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                  end if
               end do

               ! Extract the pl-tp encounter list and return the pl-tp collision_list
               call self%extract_collisions(nbody_system, param)
            end if

            ! Take snapshots of pairs of bodies at close approach (but not collision) if requested
            if (lany_closest) call nbody_system%encounter_history%take_snapshot(param, nbody_system, t, "closest") 
         end associate
      end select

      return 
   end subroutine collision_check_pltp

end submodule s_collision_check

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (collision) s_collision_util
   use swiftest
contains

   module subroutine collision_util_add_fragments_to_collider(self, nbody_system, param)
      !! Author: David A. Minton
      !!
      !! Adds fragments to the temporary system pl object
      implicit none
      ! Arguments
      class(collision_basic),   intent(in)    :: self      
         !! Collision system system object
      class(base_nbody_system), intent(inout) :: nbody_system    
         !! Swiftest nbody system object
      class(base_parameters),   intent(in)    :: param    
          !! Current Swiftest run configuration parameters
      ! Internals
      integer(I4B) :: i, npl_before, npl_after, nfrag
      logical, dimension(:), allocatable :: lexclude

      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(fragments => self%fragments, impactors => self%impactors, pl => nbody_system%pl, cb => nbody_system%cb)
            npl_after = pl%nbody
            npl_before = npl_after - nfrag
            nfrag = self%fragments%nbody
            allocate(lexclude(npl_after))

            pl%status(npl_before+1:npl_after) = ACTIVE
            pl%mass(npl_before+1:npl_after) = fragments%mass(1:nfrag)
            pl%Gmass(npl_before+1:npl_after) = fragments%mass(1:nfrag) * param%GU
            pl%radius(npl_before+1:npl_after) = fragments%radius(1:nfrag)
#ifdef DOCONLOC
            do concurrent (i = 1:nfrag) shared(cb,pl,fragments)
#else
            do concurrent (i = 1:nfrag)
#endif
               pl%rb(:,npl_before+i) =  fragments%rb(:,i) 
               pl%vb(:,npl_before+i) =  fragments%vb(:,i) 
               pl%rh(:,npl_before+i) =  fragments%rb(:,i) - cb%rb(:)
               pl%vh(:,npl_before+i) =  fragments%vb(:,i) - cb%vb(:)
            end do
            if (param%lrotation) then
               pl%Ip(:,npl_before+1:npl_after) = fragments%Ip(:,1:nfrag)
               pl%rot(:,npl_before+1:npl_after) = fragments%rot(:,1:nfrag)
            end if
            ! This will remove the impactors from the system since we've replaced them with fragments
            lexclude(1:npl_after) = .false.
            lexclude(impactors%id(1:impactors%ncoll)) = .true.
            where(lexclude(1:npl_after)) 
               pl%status(1:npl_after) = INACTIVE
            elsewhere
               pl%status(1:npl_after) = ACTIVE
            endwhere

         end associate
      end select

      return
   end subroutine collision_util_add_fragments_to_collider

   module subroutine collision_util_bounce_one(r,v,rcom,vcom,radius)
      !! Author: David A. Minton
      !!
      !! Performs a "bounce" operation on a single body by reversing its velocity in a center of mass frame.
      implicit none
      ! Arguments
      real(DP), dimension(:), intent(inout) :: r,v
      real(DP), dimension(:), intent(in)    :: rcom,vcom
      real(DP),               intent(in)    :: radius
      ! Internals
      real(DP), dimension(NDIM) :: rrel, vrel, rnorm

      rrel(:) = r(:) - rcom(:)
      vrel(:) = v(:) - vcom(:)
      rnorm(:) = .unit. rrel(:)
      ! Do the reflection
      vrel(:) = vrel(:) - 2 * dot_product(vrel(:),rnorm(:)) * rnorm(:)
      ! Shift the positions so that the collision doesn't immediately occur again
      r(:) = r(:) + 0.5_DP * radius * rnorm(:)
      v(:) = vcom(:) + vrel(:)

      return
   end subroutine collision_util_bounce_one


   module subroutine collision_util_get_idvalues_snapshot(self, idvals)
      !! author: David A. Minton
      !!
      !! Returns an array of all id values saved in this snapshot
      implicit none
      ! Arguments
      class(collision_snapshot),               intent(in)  :: self   
         !! Collision snapshot object
      integer(I4B), dimension(:), allocatable, intent(out) :: idvals 
         !! Array of all id values saved in this snapshot
      ! Internals
      integer(I4B) :: npl_before, ntp_before, npl_after, ntp_after, ntot, nlo, nhi

      select type(before => self%collider%before)
      class is (swiftest_nbody_system)
      select type(after => self%collider%after)
      class is (swiftest_nbody_system)
         npl_before = 0; ntp_before = 0; npl_after = 0; ntp_after = 0
         if (allocated(before%pl)) then
            npl_before = before%pl%nbody
         endif

         if (allocated(before%tp)) then
            ntp_before = before%tp%nbody
         end if 

         if (allocated(after%pl)) then
            npl_after = after%pl%nbody
         end if

         if (allocated(after%tp)) then
            ntp_after = after%tp%nbody
         end if 

         ntot = npl_before + ntp_before + npl_after + ntp_after
         if (ntot == 0) return
         allocate(idvals(ntot))

         nlo = 1; nhi = npl_before
         if (npl_before > 0) idvals(nlo:nhi) = before%pl%id(1:npl_before)
         nlo = nhi + 1; nhi = nhi + ntp_before
         if (ntp_before > 0) idvals(nlo:nhi) = before%tp%id(1:ntp_before)

         nlo = nhi + 1; nhi = nhi + npl_after
         if (npl_after > 0) idvals(nlo:nhi) = after%pl%id(1:npl_after)
         nlo = nhi + 1; nhi = nhi + ntp_after
         if (ntp_after > 0) idvals(nlo:nhi) = after%tp%id(1:ntp_after)
      end select
      end select

      return

   end subroutine collision_util_get_idvalues_snapshot


   module subroutine collision_util_get_energy_and_momentum(self, nbody_system, param, phase)
      !! Author: David A. Minton
      !!
      !! Calculates total system energy in either the pre-collision outcome state (phase = "before") or the post-collision outcome 
      !! state (lbefore = .false.)
      implicit none
      ! Arguments
      class(collision_basic),   intent(inout) :: self         
         !! Collision system object
      class(base_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        
         !! Current Swiftest run configuration parameters
      character(len=*),         intent(in)    :: phase        
         !! One of "before" or "after", indicating which phase of the calculation this needs to be done
      ! Internals
      integer(I4B) :: i, phase_val, nfrag

      select case(phase)
      case("before")
         phase_val = 1
      case("after")
         phase_val = 2
      case default
         write(*,*) "Unknown value of phase argument passed to collision_util_get_energy_and_momentum: ",trim(adjustl(phase))
         return
      end select

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(param)
      class is (swiftest_parameters)
         associate(fragments => self%fragments, impactors => self%impactors, pl => nbody_system%pl, cb => nbody_system%cb)
            nfrag = self%fragments%nbody
            if (phase_val == 1) then
#ifdef DOCONLOC
               do concurrent(i = 1:2) shared(impactors)
#else
               do concurrent(i = 1:2)
#endif
                  impactors%ke_orbit(i) = 0.5_DP * impactors%mass(i) * dot_product(impactors%vc(:,i), impactors%vc(:,i))
                  impactors%ke_rot(i) = 0.5_DP * impactors%mass(i) * impactors%radius(i)**2 * impactors%Ip(3,i)  & 
                                                * dot_product(impactors%rot(:,i), impactors%rot(:,i))
                  impactors%be(i) = -3 * impactors%Gmass(i) * impactors%mass(i) / (5 * impactors%radius(i))
                  impactors%L_orbit(1,i) = impactors%mass(i) * (impactors%rc(2,i) * impactors%vc(3,i) &
                                                              - impactors%rc(3,i) * impactors%vc(2,i))
                  impactors%L_orbit(2,i) = impactors%mass(i) * (impactors%rc(3,i) * impactors%vc(1,i) &
                                                              - impactors%rc(1,i) * impactors%vc(3,i))
                  impactors%L_orbit(3,i) = impactors%mass(i) * (impactors%rc(1,i) * impactors%vc(2,i) &
                                                              - impactors%rc(2,i) * impactors%vc(1,i))
                  impactors%L_rot(:,i) = impactors%mass(i) * impactors%radius(i)**2 * impactors%Ip(3,i) * impactors%rot(:,i)
               end do
               self%L_orbit(:,phase_val) = sum(impactors%L_orbit(:,1:2),dim=2)
               self%L_rot(:,phase_val) = sum(impactors%L_rot(:,1:2),dim=2)
               self%L_total(:,phase_val) = self%L_orbit(:,phase_val) + self%L_rot(:,phase_val) 
               self%ke_orbit(phase_val) = sum(impactors%ke_orbit(1:2))
               self%ke_rot(phase_val) = sum(impactors%ke_rot(1:2))
               self%be(phase_val) = sum(impactors%be(1:2))
               call swiftest_util_get_potential_energy(2, [(.true., i = 1, 2)], 0.0_DP, impactors%Gmass, impactors%mass, & 
                                                            impactors%rb, self%pe(phase_val))
               self%te(phase_val) = self%ke_orbit(phase_val) + self%ke_rot(phase_val) + self%be(phase_val) + self%pe(phase_val)
            else if (phase_val == 2) then
#ifdef DOCONLOC
               do concurrent(i = 1:nfrag) shared(fragments)
#else
               do concurrent(i = 1:nfrag)
#endif
                  fragments%ke_orbit(i) = 0.5_DP * fragments%mass(i) * dot_product(fragments%vc(:,i), fragments%vc(:,i))
                  fragments%ke_rot(i) = 0.5_DP * fragments%mass(i) * fragments%radius(i)**2 * fragments%Ip(3,i) & 
                                                * dot_product(fragments%rot(:,i), fragments%rot(:,i))
                  fragments%L_orbit(1,i) = fragments%mass(i) * (fragments%rc(2,i) * fragments%vc(3,i) - &
                                                                fragments%rc(3,i) * fragments%vc(2,i))
                  fragments%L_orbit(2,i) = fragments%mass(i) * (fragments%rc(3,i) * fragments%vc(1,i) - &
                                                                fragments%rc(1,i) * fragments%vc(3,i))
                  fragments%L_orbit(3,i) = fragments%mass(i) * (fragments%rc(1,i) * fragments%vc(2,i) - &
                                                                fragments%rc(2,i) * fragments%vc(1,i))
                  fragments%L_rot(:,i) = fragments%mass(i) * fragments%radius(i)**2 * fragments%Ip(3,i) * fragments%rot(:,i)
               end do
               call swiftest_util_get_potential_energy(nfrag, [(.true., i = 1, nfrag)], 0.0_DP, fragments%Gmass, fragments%mass, &
                                                      fragments%rb, fragments%pe)
               fragments%be = sum(-3*fragments%Gmass(1:nfrag)*fragments%mass(1:nfrag)/(5*fragments%radius(1:nfrag)))
               fragments%L_orbit_tot(:) = sum(fragments%L_orbit(:,1:nfrag),dim=2)
               fragments%L_rot_tot(:) = sum(fragments%L_rot(:,1:nfrag),dim=2)
               fragments%ke_orbit_tot = sum(fragments%ke_orbit(1:nfrag))
               fragments%ke_rot_tot = sum(fragments%ke_rot(1:nfrag))
               self%L_orbit(:,phase_val) = fragments%L_orbit_tot(:)
               self%L_rot(:,phase_val) = fragments%L_rot_tot(:)
               self%L_total(:,phase_val) = self%L_orbit(:,phase_val) + self%L_rot(:,phase_val) 
               self%ke_orbit(phase_val) = fragments%ke_orbit_tot
               self%ke_rot(phase_val) = fragments%ke_rot_tot
               self%be(phase_val) = fragments%be
               self%pe(phase_val) = fragments%pe
               self%te(phase_val) = self%ke_orbit(phase_val) + self%ke_rot(phase_val) + self%be(phase_val) + self%pe(phase_val)
            end if

         end associate
      end select
      end select

      return
   end subroutine collision_util_get_energy_and_momentum


   module subroutine collision_util_index_map(self)
      !! author: David A. Minton
      !!
      !! Maps body id values to storage index values so we don't have to use unlimited dimensions for id
      implicit none
      ! Arguments
      class(collision_storage), intent(inout) :: self  
         !! Collision storage object
      ! Internals
      integer(I4B), dimension(:), allocatable :: idvals
      real(DP), dimension(:), allocatable :: tvals

      call self%get_index_values(idvals, tvals)

      ! Consolidate ids to only unique values
      call util_unique(idvals,self%idvals,self%idmap)
      self%nid = size(self%idvals)

      ! Don't consolidate time values (multiple collisions can happen in a single time step)
      if (.not.allocated(self%tvals)) call util_unique(tvals,self%tvals,self%tmap)
      self%nt = size(self%tvals)

      return
   end subroutine collision_util_index_map


   module subroutine collision_util_dealloc_snapshot(self)
      !! author: David A. Minton
      !!
      !! Finalizer will deallocate all allocatables
      implicit none
      ! Arguments
      class(collision_snapshot),  intent(inout) :: self 
         !! Collsion snapshot object

      if (allocated(self%collider)) then
         call self%collider%dealloc()
         deallocate(self%collider)
      end if

      call self%encounter_snapshot%dealloc()

      return
   end subroutine collision_util_dealloc_snapshot


   module subroutine collision_util_dealloc_impactors(self)
      !! author: David A. Minton
      !!
      !! Resets the collider object variables to 0 and deallocates the index and mass distributions
      implicit none
      ! Arguments
      class(collision_impactors),  intent(inout) :: self
         !! Collision impactors object

      if (allocated(self%id)) deallocate(self%id)
      if (allocated(self%mass_dist)) deallocate(self%mass_dist)
      self%ncoll = 0
      self%rb(:,:) = 0.0_DP
      self%vb(:,:) = 0.0_DP
      self%rot(:,:) = 0.0_DP
      self%L_rot(:,:) = 0.0_DP
      self%L_orbit(:,:) = 0.0_DP
      self%ke_rot(:) = 0.0_DP
      self%ke_orbit(:) = 0.0_DP
      self%Ip(:,:) = 0.0_DP
      self%mass(:) = 0.0_DP
      self%radius(:) = 0.0_DP
      self%Qloss = 0.0_DP
      self%regime = 0

      self%x_unit(:) = 0.0_DP
      self%y_unit(:) = 0.0_DP
      self%z_unit(:) = 0.0_DP
      self%v_unit(:) = 0.0_DP
      self%rbcom(:) = 0.0_DP
      self%vbcom(:) = 0.0_DP
      self%rcimp(:) = 0.0_DP

      return
   end subroutine collision_util_dealloc_impactors


   module subroutine collision_util_dealloc_fragments(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables
      implicit none
      ! Arguments
      class(collision_fragments),  intent(inout) :: self
         !! Collision fragments object

      self%nbody = 0
      if (allocated(self%id)) deallocate(self%id)
      if (allocated(self%info)) deallocate(self%info) 
      if (allocated(self%status)) deallocate(self%status) 
      if (allocated(self%rh)) deallocate(self%rh)
      if (allocated(self%vh)) deallocate(self%vh)
      if (allocated(self%rb))  deallocate(self%rb)
      if (allocated(self%vb)) deallocate(self%vb)
      if (allocated(self%rc)) deallocate(self%rc)
      if (allocated(self%vc)) deallocate(self%vc)
      if (allocated(self%r_unit)) deallocate(self%r_unit)
      if (allocated(self%t_unit)) deallocate(self%t_unit)
      if (allocated(self%n_unit)) deallocate(self%n_unit)
      if (allocated(self%rot)) deallocate(self%rot)
      if (allocated(self%Ip)) deallocate(self%Ip)
      if (allocated(self%mass)) deallocate(self%mass)
      if (allocated(self%radius)) deallocate(self%radius)
      if (allocated(self%density)) deallocate(self%density)
      if (allocated(self%rmag)) deallocate(self%rmag)
      if (allocated(self%vmag)) deallocate(self%vmag)
      if (allocated(self%rotmag)) deallocate(self%rotmag)
      if (allocated(self%origin_body)) deallocate(self%origin_body)
      if (allocated(self%L_orbit)) deallocate(self%L_orbit)
      if (allocated(self%L_rot)) deallocate(self%L_rot)
      if (allocated(self%ke_orbit)) deallocate(self%ke_orbit)
      if (allocated(self%ke_rot)) deallocate(self%ke_rot)

      return
   end subroutine collision_util_dealloc_fragments


   module subroutine collision_util_dealloc_basic(self)
      !! author: David A. Minton
      !!
      !! Resets the collider nbody_system and deallocates all allocatables
      implicit none
      ! Arguments
      class(collision_basic), intent(inout) :: self  
         !! Collision system object

      if (allocated(self%impactors)) then 
         call self%impactors%dealloc()
         deallocate(self%impactors)
      end if

      if (allocated(self%fragments)) then
         call self%fragments%dealloc()
         deallocate(self%fragments)
      end if

      if (allocated(self%before)) then
         select type(before => self%before)
         class is (swiftest_nbody_system)
            if (allocated(before%pl)) deallocate(before%pl)
            if (allocated(before%tp)) deallocate(before%tp)
         end select
         deallocate(self%before)
      end if

      if (allocated(self%after)) then
         select type(after => self%after)
         class is (swiftest_nbody_system)
            if (allocated(after%pl)) deallocate(after%pl)
            if (allocated(after%tp)) deallocate(after%tp)
         end select
         deallocate(self%after)
      end if

      self%L_orbit(:,:) = 0.0_DP
      self%L_rot(:,:) = 0.0_DP
      self%L_total(:,:) = 0.0_DP
      self%ke_orbit(:) = 0.0_DP
      self%ke_rot(:) = 0.0_DP
      self%pe(:) = 0.0_DP
      self%te(:) = 0.0_DP

      self%dscale = 1.0_DP 
      self%mscale = 1.0_DP 
      self%tscale = 1.0_DP 
      self%vscale = 1.0_DP 
      self%Escale = 1.0_DP 
      self%Lscale = 1.0_DP


      return
   end subroutine collision_util_dealloc_basic


   module subroutine collision_util_reset_fragments(self)
      !! author: David A. Minton
      !!
      !! Resets all position and velocity-dependent fragment quantities in order to do a fresh calculation (does not reset mass, 
      !! radius, or other values that get set prior to the call to fraggle_generate)
      implicit none
      ! Arguments
      class(collision_fragments), intent(inout) :: self
         !! Collision fragments object

      self%rc(:,:) = 0.0_DP
      self%vc(:,:) = 0.0_DP
      self%rh(:,:) = 0.0_DP
      self%vh(:,:) = 0.0_DP
      self%rb(:,:) = 0.0_DP
      self%vb(:,:) = 0.0_DP
      self%rot(:,:) = 0.0_DP
      self%r_unit(:,:) = 0.0_DP
      self%t_unit(:,:) = 0.0_DP
      self%n_unit(:,:) = 0.0_DP

      self%rmag(:) = 0.0_DP
      self%vmag(:) = 0.0_DP
      self%rotmag(:) = 0.0_DP

      self%L_orbit_tot(:) = 0.0_DP 
      self%L_rot_tot(:)  = 0.0_DP 
      self%L_orbit(:,:)   = 0.0_DP 
      self%L_rot(:,:)    = 0.0_DP 
      self%ke_orbit_tot   = 0.0_DP 
      self%ke_rot_tot    = 0.0_DP 
      self%pe             = 0.0_DP 
      self%be             = 0.0_DP 
      self%ke_orbit(:)    = 0.0_DP 
      self%ke_rot(:)     = 0.0_DP 

      return
   end subroutine collision_util_reset_fragments


   module subroutine collision_util_setup_fragments(self, n)
      !! author: David A. Minton
      !!
      !! Constructor for fragment class. Allocates space for all particles and
      implicit none
      ! Arguments
      class(collision_fragments), intent(inout) :: self  
         !! Collision fragments
      integer(I4B),               intent(in)    :: n     
         !! Number of particles to allocate space for
      ! Internals
      integer(I4B) :: i

      if (n < 0) return

      self%nbody = n
      if (n == 0) return

      if(allocated(self%info)) deallocate(self%info); allocate(swiftest_particle_info :: self%info(n))
      if (allocated(self%id)) deallocate(self%id); allocate(self%id(n))
      if (allocated(self%status)) deallocate(self%status); allocate(self%status(n))
      if (allocated(self%rh)) deallocate(self%rh); allocate(self%rh(NDIM, n))
      if (allocated(self%vh)) deallocate(self%vh); allocate(self%vh(NDIM, n))
      if (allocated(self%rb)) deallocate(self%rb); allocate(self%rb(NDIM, n))
      if (allocated(self%vb)) deallocate(self%vb); allocate(self%vb(NDIM, n))
      if (allocated(self%rc)) deallocate(self%rc); allocate(self%rc(NDIM, n))
      if (allocated(self%vc)) deallocate(self%vc); allocate(self%vc(NDIM, n))
      if (allocated(self%r_unit)) deallocate(self%r_unit); allocate(self%r_unit(NDIM, n))
      if (allocated(self%v_unit)) deallocate(self%v_unit); allocate(self%v_unit(NDIM, n))
      if (allocated(self%t_unit)) deallocate(self%t_unit); allocate(self%t_unit(NDIM, n))
      if (allocated(self%n_unit)) deallocate(self%n_unit); allocate(self%n_unit(NDIM, n))
      if (allocated(self%rot)) deallocate(self%rot); allocate(self%rot(NDIM, n))
      if (allocated(self%Ip)) deallocate(self%Ip); allocate(self%Ip(NDIM, n))
      if (allocated(self%Gmass)) deallocate(self%Gmass); allocate(self%Gmass(n))
      if (allocated(self%mass)) deallocate(self%mass); allocate(self%mass(n))
      if (allocated(self%radius)) deallocate(self%radius); allocate(self%radius(n))
      if (allocated(self%density)) deallocate(self%density); allocate(self%density(n))
      if (allocated(self%rmag)) deallocate(self%rmag); allocate(self%rmag(n))
      if (allocated(self%vmag)) deallocate(self%vmag); allocate(self%vmag(n))
      if (allocated(self%rotmag)) deallocate(self%rotmag); allocate(self%rotmag(n))
      if (allocated(self%origin_body)) deallocate(self%origin_body); allocate(self%origin_body(n))
      if (allocated(self%L_orbit)) deallocate(self%L_orbit); allocate(self%L_orbit(NDIM, n))
      if (allocated(self%L_rot)) deallocate(self%L_rot); allocate(self%L_rot(NDIM, n))
      if (allocated(self%ke_orbit)) deallocate(self%ke_orbit); allocate(self%ke_orbit(n))
      if (allocated(self%ke_rot)) deallocate(self%ke_rot); allocate(self%ke_rot(n))

      self%id(:) = 0
      select type(info => self%info)
      class is (swiftest_particle_info)
         do i = 1, n
            call info(i)%set_value(&
               name = "UNNAMED", &
               particle_type = "UNKNOWN", &
               status = "INACTIVE", & 
               origin_type = "UNKNOWN", &
               collision_id = 0, &
               origin_time = -huge(1.0_DP), & 
               origin_rh = [0.0_DP, 0.0_DP, 0.0_DP], &
               origin_vh = [0.0_DP, 0.0_DP, 0.0_DP], &
               discard_time = huge(1.0_DP), & 
               discard_rh = [0.0_DP, 0.0_DP, 0.0_DP], &
               discard_vh = [0.0_DP, 0.0_DP, 0.0_DP], &
               discard_body_id = -1  &
            )
         end do
      end select

      self%mtot = 0.0_DP
      self%status(:) = ACTIVE
      self%rh(:,:)   = 0.0_DP
      self%vh(:,:)   = 0.0_DP
      self%rb(:,:)   = 0.0_DP
      self%vb(:,:)   = 0.0_DP
      self%rc(:,:)   = 0.0_DP
      self%vc(:,:)   = 0.0_DP
      self%r_unit(:,:)   = 0.0_DP
      self%v_unit(:,:)   = 0.0_DP
      self%t_unit(:,:)   = 0.0_DP
      self%n_unit(:,:)   = 0.0_DP
      self%rot(:,:)   = 0.0_DP
      self%Ip(:,:)   = 0.0_DP
      self%Gmass(:)   = 0.0_DP
      self%mass(:)   = 0.0_DP
      self%radius(:)   = 0.0_DP
      self%density(:)   = 0.0_DP
      self%rmag(:)   = 0.0_DP
      self%vmag(:)   = 0.0_DP
      self%rotmag(:)   = 0.0_DP
      self%origin_body(:)   = 0
      self%L_orbit_tot(:)   = 0.0_DP
      self%L_rot_tot(:)   = 0.0_DP
      self%L_orbit(:,:)   = 0.0_DP
      self%L_rot(:,:)   = 0.0_DP
      self%ke_orbit_tot = 0.0_DP
      self%ke_rot_tot = 0.0_DP
      self%pe = 0.0_DP
      self%be = 0.0_DP
      self%ke_orbit(:)   = 0.0_DP
      self%ke_rot(:)   = 0.0_DP

      return
   end subroutine collision_util_setup_fragments


   module subroutine collision_util_set_coordinate_collider(self)
      !! author: David A. Minton
      !! 
      !!
      !! Defines the collisional coordinate nbody_system, including the unit vectors of both the nbody_system and individual 
      !! fragments.
      implicit none
      ! Arguments
      class(collision_basic),    intent(inout) :: self      
         !! Collisional system

      associate(fragments => self%fragments, impactors => self%impactors)
         call impactors%set_coordinate_system() 

         if (.not.allocated(self%fragments)) return
         call fragments%set_coordinate_system()


      end associate

      return
   end subroutine collision_util_set_coordinate_collider


   module subroutine collision_util_set_coordinate_fragments(self)
      !! author: David A. Minton
      !!
      !! Defines the collisional coordinate nbody_system, including the unit vectors of both the nbody_system and individual 
      !! fragments.
      implicit none
      ! Arguments
      class(collision_fragments), intent(inout) :: self      
         !! Collisional fragments object

      associate(fragments => self, nfrag => self%nbody)
         if ((nfrag == 0) .or. (.not.any(fragments%rc(:,:) > 0.0_DP))) return

         fragments%rmag(:) = .mag. fragments%rc(:,:)
         fragments%vmag(:) = .mag. fragments%vc(:,:)
         fragments%rotmag(:) = .mag. fragments%rot(:,:)
   
         ! Define the radial, normal, and tangential unit vectors for each individual fragment
         fragments%r_unit(:,:) = .unit. fragments%rc(:,:) 
         fragments%v_unit(:,:) = .unit. fragments%vc(:,:) 
         fragments%n_unit(:,:) = .unit. (fragments%rc(:,:) .cross. fragments%vc(:,:))
         fragments%t_unit(:,:) = -.unit. (fragments%r_unit(:,:) .cross. fragments%n_unit(:,:))
      end associate

      return
   end subroutine collision_util_set_coordinate_fragments


   module subroutine collision_util_set_coordinate_impactors(self)
      !! author: David A. Minton
      !!
      !! Defines the collisional coordinate nbody_system, including the unit vectors of both the nbody_system and individual 
      !! fragments.
      implicit none
      ! Arguments
      class(collision_impactors), intent(inout) :: self      
         !! Collisional impactors object
      ! Internals
      real(DP), dimension(NDIM) ::  delta_r, delta_v, L_total
      real(DP)   ::  L_mag, mtot

      associate(impactors => self)
         delta_v(:) = impactors%vb(:, 2) - impactors%vb(:, 1)
         delta_r(:) = impactors%rb(:, 2) - impactors%rb(:, 1)
   
         ! We will initialize fragments on a plane defined by the pre-impact nbody_system, with the z-axis aligned with the angular 
         ! momentum vector and the y-axis aligned with the pre-impact distance vector.

         ! y-axis is the separation distance
         impactors%y_unit(:) = .unit.delta_r(:) 
         L_total = impactors%L_orbit(:,1) + impactors%L_orbit(:,2) + impactors%L_rot(:,1) + impactors%L_rot(:,2)

         L_mag = .mag.L_total(:)
         if (L_mag > sqrt(tiny(L_mag))) then
            impactors%z_unit(:) = .unit.L_total(:) 
         else ! Not enough angular momentum to determine a z-axis direction. We'll just pick a random direction
            call random_number(impactors%z_unit(:))
            impactors%z_unit(:) = .unit.impactors%z_unit(:) 
         end if

         ! The cross product of the y- by z-axis will give us the x-axis
         impactors%x_unit(:) = impactors%y_unit(:) .cross. impactors%z_unit(:)
         impactors%v_unit(:) = .unit.delta_v(:)

         ! Find the center of mass of the collisional system	
         mtot = sum(impactors%mass(:))
         impactors%rbcom(:) = (impactors%mass(1) * impactors%rb(:,1) + impactors%mass(2) * impactors%rb(:,2)) / mtot 
         impactors%vbcom(:) = (impactors%mass(1) * impactors%vb(:,1) + impactors%mass(2) * impactors%vb(:,2)) / mtot

         ! The center of mass coordinate position and velocities
         impactors%rc(:,1) = impactors%rb(:,1) - impactors%rbcom(:)
         impactors%rc(:,2) = impactors%rb(:,2) - impactors%rbcom(:)
         impactors%vc(:,1) = impactors%vb(:,1) - impactors%vbcom(:)
         impactors%vc(:,2) = impactors%vb(:,2) - impactors%vbcom(:)
   
         ! Find the point of impact between the two bodies, defined as the location (in the collisional coordinate system) at the 
         ! surface of body 1 along the line connecting the two bodies.
         impactors%rcimp(:) = impactors%rb(:,1) + impactors%radius(1) * impactors%y_unit(:) - impactors%rbcom(:)

         ! Set the velocity direction as the "bounce" direction" for disruptions, and body 2's direction for hit and runs
         if (impactors%regime == COLLRESOLVE_REGIME_HIT_AND_RUN) then
            impactors%bounce_unit(:) = .unit. impactors%vc(:,2)
         else
            impactors%bounce_unit(:) = .unit. (impactors%vc(:,2) - 2 * dot_product(impactors%vc(:,2),impactors%y_unit(:)) &
                                                                     * impactors%y_unit(:))
         end if

      end associate

      return
   end subroutine collision_util_set_coordinate_impactors


   module subroutine collision_util_setup_collider(self, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Initializer for the encounter collision system. Sets up impactors and the before/after snapshots,
      !! but not fragments. Those are setup later when the number of fragments is known.
      implicit none
      ! Arguments
      class(collision_basic),   intent(inout) :: self         
         !! Collision system object
      class(base_nbody_system), intent(in)    :: nbody_system 
         !! Current nbody system. Used as a mold for the before/after snapshots
      class(base_parameters),   intent(inout) :: param        
         !! Current Swiftest run configuration parameters

      call self%setup_impactors()
      if (allocated(self%before)) deallocate(self%before)
      if (allocated(self%after)) deallocate(self%after)

      allocate(self%before, mold=nbody_system)
      allocate(self%after,  mold=nbody_system)

      self%max_rot = MAX_ROT_SI * param%TU2S          

      return
   end subroutine collision_util_setup_collider


   module subroutine collision_util_setup_impactors_collider(self)
      !! author: David A. Minton
      !!
      !! Initializer for the impactors for the encounter collision system. Deallocates old impactors before creating new ones
      implicit none
      ! Arguments
      class(collision_basic), intent(inout) :: self   
         !! Collision system object

      if (allocated(self%impactors)) deallocate(self%impactors)
      allocate(collision_impactors :: self%impactors)

      return
   end subroutine collision_util_setup_impactors_collider


   module subroutine collision_util_setup_fragments_collider(self, nfrag)
      !! author: David A. Minton
      !!
      !! Initializer for the fragments of the collision system. 
      implicit none
      ! Arguments
      class(collision_basic), intent(inout) :: self 
          !! collision system object
      integer(I4B),            intent(in)    :: nfrag 
         !! Number of fragments to create

      if (allocated(self%fragments)) deallocate(self%fragments)
      allocate(collision_fragments :: self%fragments)
      call self%fragments%setup(nfrag)

      return
   end subroutine collision_util_setup_fragments_collider


   module subroutine collision_util_shift_vector_to_origin(m_frag, vec_frag)
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Adjusts the position or velocity of the fragments as needed to align them with the center of mass origin
      implicit none
      ! Arguments
      real(DP), dimension(:),   intent(in)    :: m_frag    
         !! Fragment masses
      real(DP), dimension(:,:), intent(inout) :: vec_frag  
         !! Fragment positions or velocities in the center of mass frame

      ! Internals
      real(DP), dimension(NDIM) :: mvec_frag, COM_offset
      integer(I4B) :: i, nfrag
      real(DP) :: mtot

      mvec_frag(:) = 0.0_DP
      mtot = sum(m_frag)
      nfrag = count(m_frag > tiny(0.0_DP))

      do i = 1, nfrag
         mvec_frag = mvec_frag(:) + vec_frag(:,i) * m_frag(i)
      end do
      COM_offset(:) = -mvec_frag(:) / mtot
      do i = 1, nfrag 
         vec_frag(:, i) = vec_frag(:, i) + COM_offset(:)
      end do

      return
   end subroutine collision_util_shift_vector_to_origin


   module subroutine collision_util_take_snapshot(self, param, nbody_system, t, arg)
      !! author: David A. Minton
      !!
      !! Takes a minimal snapshot of the state of the nbody_system during a collision to record the before and after states of the
      !! system through the collision.
      implicit none
      ! Internals
      class(collision_storage), intent(inout)          :: self   
         !! Collision storage object
      class(base_parameters),   intent(inout)          :: param  
         !! Current run configuration parameters
      class(base_nbody_system), intent(inout)          :: nbody_system 
         !! Swiftest nbody system object to store
      real(DP),                 intent(in),   optional :: t      
         !! Time of snapshot if different from nbody_system time
      character(*),             intent(in),   optional :: arg    
         !! "before": takes a snapshot just before the collision. 
         !! "after" : takes the snapshot just after the collision.
      ! Arguments
      class(collision_snapshot), allocatable, save :: snapshot
      character(len=:), allocatable :: stage
      integer(I4B) :: i,phase_val
      character(len=STRMAX) :: message, idstr
#ifdef COARRAY
      integer(I4B), save :: maxid_collision[*] = 0
#endif

      if (present(arg)) then
         stage = arg
      else
         stage = ""
      end if 

      select type (nbody_system)
      class is (swiftest_nbody_system)
      select type(param)
      class is (swiftest_parameters)
         if (stage /= "after") then
            ! Advance the collision id number and save it
            associate(collider => nbody_system%collider)
               collider%maxid_collision = max(collider%maxid_collision, maxval(nbody_system%pl%info(:)%collision_id))
#ifdef COARRAY
               ! Make sure all images get updated so that we don't get repeat collision_id numbers
               critical
               do i = 1, num_images()
                  collider%maxid_collision = max(maxid_collision[i], collider%maxid_collision)
               end do
#endif
               collider%maxid_collision = collider%maxid_collision + 1
               collider%collision_id = collider%maxid_collision
               write(idstr,*) collider%collision_id
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, "collision_id " // trim(adjustl(idstr)))
#ifdef COARRAY
               maxid_collision = collider%maxid_collision
               end critical
#endif
            end associate
         end if

         select case (stage)
         case ("before")
            phase_val = 1

            allocate(collision_snapshot :: snapshot)
            allocate(snapshot%collider, source=nbody_system%collider) 
            snapshot%t = t

         case ("after")
            phase_val = 2
         case ("particle")
            phase_val = -1
            allocate(collision_snapshot :: snapshot)
            allocate(snapshot%collider, source=nbody_system%collider) 
         case default
            write(*,*) "collision_util_take_snapshot requies either 'before', 'after', or 'particle' passed to 'arg'"
            return
         end select

         if (stage /= "particle" ) then
            if (stage == "after") then
               select type(before_snap => snapshot%collider%before )
               class is (swiftest_nbody_system)
               select type(before_orig => nbody_system%collider%before)
               class is (swiftest_nbody_system)
                  if (allocated(before_orig%pl)) then
                     select type(plsub => before_orig%pl)
                     class is (swiftest_pl)
                        ! Log the properties of the old and new bodies
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Removing bodies:")
                        do i = 1, plsub%nbody
                           write(message,*) trim(adjustl(plsub%info(i)%name)), " (", trim(adjustl(plsub%info(i)%particle_type)),")"
                           call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                        end do
                        if (allocated(before_snap%pl)) deallocate(before_snap%pl)
                        allocate(before_snap%pl, source=plsub)
                     end select
                     deallocate(before_orig%pl)
                  end if

                  if (allocated(before_orig%tp)) then   
                     select type(tpsub => before_orig%tp)
                     class is (swiftest_tp)
                        ! Log the properties of the old and new bodies
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Removing bodies:")
                        do i = 1, tpsub%nbody
                           write(message,*) trim(adjustl(tpsub%info(i)%name)), " (", trim(adjustl(tpsub%info(i)%particle_type)),")"
                           call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                        end do
                        if (allocated(before_snap%tp)) deallocate(before_snap%tp)
                        allocate(before_snap%tp, source=tpsub)
                     end select
                     deallocate(before_orig%tp)
                  end if

                  if (allocated(before_orig%cb)) then
                     select type(cbsub => before_orig%cb)
                     class is (swiftest_cb)
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Collision with the central body")
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, & 
                           "***********************************************************" // &
                           "***********************************************************")
                        if (allocated(before_snap%cb)) deallocate(before_snap%cb)
                        allocate(before_snap%cb, source=cbsub)
                     end select
                     deallocate(before_orig%cb)
                  end if

               end select
               end select

               select type(after_snap => snapshot%collider%after )
               class is (swiftest_nbody_system)
               select type(after_orig => nbody_system%collider%after)
               class is (swiftest_nbody_system)
                  if (allocated(after_orig%pl)) then
                     select type(plnew => after_orig%pl)
                     class is (swiftest_pl)
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Adding bodies:")
                        do i = 1, plnew%nbody
                           write(message,*) trim(adjustl(plnew%info(i)%name)), " (", trim(adjustl(plnew%info(i)%particle_type)),")"
                           call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                        end do
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, & 
                           "***********************************************************" // &
                           "***********************************************************")
                        allocate(after_snap%pl, source=plnew)
                     end select
                     deallocate(after_orig%pl)
                  end if
                  if (allocated(after_orig%cb)) then
                     select type(cbnew => after_orig%cb)
                     class is (swiftest_cb)
                        allocate(after_snap%cb, source=cbnew)
                     end select
                     deallocate(after_orig%cb)
                  end if
               end select
               end select
            end if
         end if

         if ((stage == "after") .or. (stage == "particle")) then
            ! Save the snapshot for posterity
            call self%save(snapshot)
            deallocate(snapshot)
         end if
      end select
      end select

      return
   end subroutine collision_util_take_snapshot


   module subroutine collision_util_save_energy_snapshot(self, stage, nbody_system, iframe_start, iframe_end)
      !! author: David A. Minton
      !!
      !! Retroactively save the energy of the system before and after a collision to an existing snapshot 
      implicit none
      ! Arguments
      class(collision_storage), intent(inout) :: self  
         !! Collision storage object with snapshots
      character(len=*), intent(in) :: stage
         !! Phase of the collision, either 'before' or 'after'
      class(base_nbody_system), intent(inout) :: nbody_system
         !! Swiftest nbody system object with energy information stored in it
      integer(I4B), intent(in) :: iframe_start 
         !! Starting frame index to save the snapshot
      integer(I4B), intent(in) :: iframe_end   
         !! Ending frame index to save the snapshot
      ! Internals
      integer(I4B) :: i, phase_val

      ! Save the energy in the before snapshots
      select case (stage)
      case ("before")
         phase_val = 1
      case ("after")
         phase_val = 2
      case default
         write(*,*) "collision_util_take_snapshot requies either 'before' or 'after'"
         return
      end select

      select type(nbody_system)
      class is (swiftest_nbody_system)

         do i = iframe_start, iframe_end
            if (allocated(self%frame(i)%item)) then
               select type(snapshot => self%frame(i)%item)
               class is (collision_snapshot)
                  snapshot%collider%L_orbit(:,phase_val) = nbody_system%L_orbit(:)
                  snapshot%collider%L_rot(:,phase_val) = nbody_system%L_rot(:)
                  snapshot%collider%L_total(:,phase_val) = nbody_system%L_total(:)
                  snapshot%collider%ke_orbit(phase_val) = nbody_system%ke_orbit
                  snapshot%collider%ke_rot(phase_val) = nbody_system%ke_rot
                  snapshot%collider%pe(phase_val) = nbody_system%pe
                  snapshot%collider%be(phase_val) = nbody_system%be
                  snapshot%collider%te(phase_val) = nbody_system%te
               end select
            end if
         end do
      end select

   end subroutine collision_util_save_energy_snapshot


   module subroutine collision_util_set_natural_scale_factors(self)
      !! author: David A. Minton
      !!
      !! Scales dimenional quantities to ~O(1) with respect to the collisional system. 
      !! This scaling makes it it easier to converge on a solution without having floating point issues
      implicit none
      ! Arguments
      class(collision_basic), intent(inout) :: self  
         !! Collision system object
      ! Internals
      integer(I4B) :: i
      real(DP) :: vesc

      associate(collider => self, fragments => self%fragments, impactors => self%impactors)
         ! Set primary scale factors (mass, length, and time) based on the impactor properties at the time of collision
         collider%mscale = minval(impactors%mass(:))
         collider%dscale = minval(impactors%radius(:))

         vesc = sqrt(2 * sum(impactors%Gmass(:)) / sum(impactors%radius(:)))
         collider%tscale = collider%dscale / vesc

         ! Set secondary scale factors for convenience
         collider%vscale = collider%dscale / collider%tscale
         collider%Escale = collider%mscale * collider%vscale**2
         collider%Lscale = collider%mscale * collider%dscale * collider%vscale

         ! Scale all dimensioned quantities of impactors and fragments
         impactors%rbcom(:)     = impactors%rbcom(:)      / collider%dscale
         impactors%vbcom(:)     = impactors%vbcom(:)      / collider%vscale
         impactors%rcimp(:)     = impactors%rcimp(:)      / collider%dscale
         impactors%rb(:,:)      = impactors%rb(:,:)       / collider%dscale
         impactors%vb(:,:)      = impactors%vb(:,:)       / collider%vscale
         impactors%rc(:,:)      = impactors%rc(:,:)       / collider%dscale
         impactors%vc(:,:)      = impactors%vc(:,:)       / collider%vscale
         impactors%mass(:)      = impactors%mass(:)       / collider%mscale
         impactors%Gmass(:)     = impactors%Gmass(:)      / (collider%dscale**3/collider%tscale**2)
         impactors%Mcb          = impactors%Mcb           / collider%mscale
         impactors%radius(:)    = impactors%radius(:)     / collider%dscale
         impactors%L_rot(:,:)  = impactors%L_rot(:,:)   / collider%Lscale
         impactors%L_orbit(:,:) = impactors%L_orbit(:,:)  / collider%Lscale
         impactors%ke_orbit(:)  = impactors%ke_orbit(:)   / collider%Escale
         impactors%ke_rot(:)   = impactors%ke_rot(:)    / collider%Escale

         do concurrent(i = 1:2)
            impactors%rot(:,i) = impactors%L_rot(:,i) / (impactors%mass(i) * impactors%radius(i)**2 * impactors%Ip(3,i))
         end do

         fragments%mtot      = fragments%mtot      / collider%mscale
         fragments%mass(:)   = fragments%mass(:)   / collider%mscale
         fragments%Gmass(:)  = fragments%Gmass(:)  / (collider%dscale**3/collider%tscale**2)
         fragments%radius(:) = fragments%radius(:) / collider%dscale
         impactors%Qloss     = impactors%Qloss     / collider%Escale

         collider%min_mfrag = collider%min_mfrag / collider%mscale
         collider%max_rot   = collider%max_rot   * collider%tscale * DEG2RAD
      end associate

      return
   end subroutine collision_util_set_natural_scale_factors


   module subroutine collision_util_set_original_scale_factors(self)
      !! author: David A. Minton
      !!
      !! Restores dimenional quantities back to the system units
      use, intrinsic :: ieee_exceptions
      implicit none
      ! Arguments
      class(collision_basic),      intent(inout) :: self      
         !! Collision system object
      ! Internals
      integer(I4B) :: i
      logical, dimension(size(IEEE_ALL))      :: fpe_halting_modes

      call ieee_get_halting_mode(IEEE_ALL,fpe_halting_modes)  ! Save the current halting modes so we can turn them off temporarily
      call ieee_set_halting_mode(IEEE_ALL,.false.)

      associate(collider => self, fragments => self%fragments, impactors => self%impactors)

         ! Restore scale factors
         impactors%rbcom(:)  = impactors%rbcom(:) * collider%dscale
         impactors%vbcom(:)  = impactors%vbcom(:) * collider%vscale
         impactors%rcimp(:)  = impactors%rcimp(:) * collider%dscale

         impactors%mass      = impactors%mass      * collider%mscale
         impactors%Gmass(:)  = impactors%Gmass(:)  * (collider%dscale**3/collider%tscale**2)
         impactors%Mcb       = impactors%Mcb       * collider%mscale
         impactors%mass_dist = impactors%mass_dist * collider%mscale
         impactors%radius    = impactors%radius    * collider%dscale
         impactors%rb        = impactors%rb        * collider%dscale
         impactors%vb        = impactors%vb        * collider%vscale
         impactors%rc        = impactors%rc        * collider%dscale
         impactors%vc        = impactors%vc        * collider%vscale
         impactors%L_rot    = impactors%L_rot    * collider%Lscale
         impactors%L_orbit   = impactors%L_orbit   * collider%Lscale
         impactors%ke_orbit  = impactors%ke_orbit  * collider%Escale
         impactors%ke_rot   = impactors%ke_rot   * collider%Escale
#ifdef DOCONLOC
         do concurrent(i = 1:2) shared(impactors)
#else
         do concurrent(i = 1:2)
#endif
            impactors%rot(:,i) = impactors%L_rot(:,i) / (impactors%mass(i) * impactors%radius(i)**2 * impactors%Ip(3,i)) * RAD2DEG
         end do
   
         fragments%mtot      = fragments%mtot      * collider%mscale
         fragments%mass(:)   = fragments%mass(:)   * collider%mscale
         fragments%Gmass(:)  = fragments%Gmass(:)  * (collider%dscale**3/collider%tscale**2)
         fragments%radius(:) = fragments%radius(:) * collider%dscale
         fragments%rot(:,:)  = fragments%rot(:,:)  / collider%tscale * RAD2DEG
         fragments%rc(:,:)   = fragments%rc(:,:)   * collider%dscale
         fragments%vc(:,:)   = fragments%vc(:,:)   * collider%vscale
         fragments%rb(:,:)   = fragments%rb(:,:)   * collider%dscale
         fragments%vb(:,:)   = fragments%vb(:,:)   * collider%vscale

         impactors%Qloss = impactors%Qloss * collider%Escale

         collider%L_orbit(:,:) = collider%L_orbit(:,:) * collider%Lscale
         collider%L_rot(:,:)  = collider%L_rot(:,:)  * collider%Lscale
         collider%L_total(:,:) = collider%L_total(:,:) * collider%Lscale
         collider%ke_orbit(:)  = collider%ke_orbit(:)  * collider%Escale
         collider%ke_rot(:)   = collider%ke_rot(:)   * collider%Escale
         collider%pe(:)        = collider%pe(:)        * collider%Escale
         collider%be(:)        = collider%be(:)        * collider%Escale
         collider%te(:)        = collider%te(:)        * collider%Escale
         collider%min_mfrag    = collider%min_mfrag    * collider%mscale
         collider%max_rot      = collider%max_rot      / collider%tscale * RAD2DEG
   
         collider%mscale = 1.0_DP
         collider%dscale = 1.0_DP
         collider%vscale = 1.0_DP
         collider%tscale = 1.0_DP
         collider%Lscale = 1.0_DP
         collider%Escale = 1.0_DP
      end associate
      call ieee_set_halting_mode(IEEE_ALL,fpe_halting_modes)
   
      return
   end subroutine collision_util_set_original_scale_factors


   module subroutine collision_util_velocity_torque(dL, mass, r, v)
      !! author: David A. Minton
      !!
      !! Applies a torque to a body's center of mass velocity given a change in angular momentum
      implicit none
      ! Arguments
      real(DP), dimension(:), intent(in)    :: dL   
         !! Change in angular momentum to apply
      real(DP),               intent(in)    :: mass 
         !! Mass of body
      real(DP), dimension(:), intent(in)    :: r 
         !! Position of body wrt system center of mass
      real(DP), dimension(:), intent(inout) :: v 
         !! Velocity of body wrt system center of mass
      ! Internals
      real(DP), dimension(NDIM) :: dL_unit, r_unit, vapply
      real(DP) :: rmag, vmag, vapply_mag

      dL_unit(:) = .unit. dL
      r_unit(:) = .unit.r(:)
      rmag = .mag.r(:)
      vmag = .mag.v(:)
      vapply_mag = .mag.(dL(:)/(rmag * mass))
      if ((vapply_mag / vmag) > epsilon(1.0_DP)) then
         vapply(:) = vapply_mag * (dL_unit(:) .cross. r_unit(:))
         v(:) = v(:) + vapply(:)
      end if

      return
   end subroutine collision_util_velocity_torque

end submodule s_collision_util

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (symba) s_symba_discard
   use swiftest
contains

   subroutine symba_discard_cb_pl(pl, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if planets should be discarded based on their positions relative to the central body.
      !! If a body gets flagged here when it has also been previously flagged for a collision with another massive body,
      !! its collisional status will be revoked. Discards due to colliding with or escaping the central body take precedence 
      !! over pl-pl collisions
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_discard_sun.f90
      !! Adapted from Hal Levison's Swift routine discard_massive5.f
      implicit none
      ! Arguments
      class(symba_pl),              intent(inout) :: pl     !! SyMBA massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters
      ! Internals
      integer(I4B) :: i
      real(DP)     :: energy, vb2, rb2, rh2, rmin2, rmax2, rmaxu2
      character(len=STRMAX) :: idstr, timestr, message
   
      associate(npl => pl%nbody, cb => nbody_system%cb)
         call nbody_system%set_msys()
         rmin2 = param%rmin**2
         rmax2 = param%rmax**2
         rmaxu2 = param%rmaxu**2
         do i = 1, npl
            if (pl%status(i) == ACTIVE) then
               rh2 = dot_product(pl%rh(:,i), pl%rh(:,i))
               if ((param%rmax >= 0.0_DP) .and. (rh2 > rmax2)) then
                  pl%ldiscard(i) = .true.
                  pl%lcollision(i) = .false. 
                  pl%status(i) = DISCARDED_RMAX
                  write(idstr, *) pl%id(i)
                  write(timestr, *) nbody_system%t
                  write(message, *) trim(adjustl(pl%info(i)%name)) // " (" // trim(adjustl(idstr)) // ")" // &
                                    " too far from the central body at t = " // trim(adjustl(timestr))
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                   "***********************************************************" // &
                                                   "***********************************************************")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, & 
                                                   "***********************************************************" // &
                                                   "***********************************************************")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                  call pl%info(i)%set_value(status="DISCARDED_RMAX", discard_time=nbody_system%t, discard_rh=pl%rh(:,i), &
                                            discard_vh=pl%vh(:,i))
               else if ((param%rmin >= 0.0_DP) .and. (rh2 < rmin2)) then
                  pl%ldiscard(i) = .true.
                  pl%lcollision(i) = .false. 
                  pl%status(i) = DISCARDED_RMIN
                  write(idstr, *) pl%id(i)
                  write(timestr, *) nbody_system%t
                  write(message, *) trim(adjustl(pl%info(i)%name)) // " ("  // trim(adjustl(idstr)) // ")" // &
                                    " too close to the central body at t = " // trim(adjustl(timestr))
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                    "************************************************************" // &
                                                    "************************************************************")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                   "************************************************************" // &
                                                   "************************************************************")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                  call pl%info(i)%set_value(status="DISCARDED_RMIN", discard_time=nbody_system%t, discard_rh=pl%rh(:,i), &
                                            discard_vh=pl%vh(:,i), discard_body_id=cb%id)
               else if (param%rmaxu >= 0.0_DP) then
                  rb2 = dot_product(pl%rb(:,i), pl%rb(:,i))
                  vb2 = dot_product(pl%vb(:,i), pl%vb(:,i))
                  energy = 0.5_DP * vb2 - nbody_system%Gmtot / sqrt(rb2)
                  if ((energy > 0.0_DP) .and. (rb2 > rmaxu2)) then
                     pl%ldiscard(i) = .true.
                     pl%lcollision(i) = .false. 
                     pl%status(i) = DISCARDED_RMAXU
                     write(idstr, *) pl%id(i)
                     write(timestr, *) nbody_system%t
                     write(message, *) trim(adjustl(pl%info(i)%name)) // " (" // trim(adjustl(idstr)) // ")" // &
                                       " is unbound and too far from barycenter at t = " // trim(adjustl(timestr))
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                      "************************************************************" // &
                                                      "************************************************************")
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                      "************************************************************" // &
                                                      "************************************************************")
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                     call pl%info(i)%set_value(status="DISCARDED_RMAXU", discard_time=nbody_system%t, discard_rh=pl%rh(:,i), &
                                               discard_vh=pl%vh(:,i))
                  end if
               end if
            end if
         end do
      end associate
   
      return
   end subroutine symba_discard_cb_pl


   subroutine symba_discard_conserve_energy_and_momentum(pl, nbody_system, param, ipl, lescape_body)
      !! author: David A. Minton
      !! 
      !! Conserves nbody_system momentum when a body is lost from the nbody_system or collides with central body
      implicit none
      ! Arguments
      class(symba_pl),           intent(inout) :: pl
      class(symba_nbody_system), intent(inout) :: nbody_system
      class(swiftest_parameters),   intent(inout) :: param
      integer(I4B),              intent(in)    :: ipl
      logical,                   intent(in)         :: lescape_body
      ! Internals
      real(DP), dimension(NDIM) :: Lpl, L_total, Lcb, xcom, vcom, drot0, drot1
      real(DP)                  :: pe, be, ke_orbit, ke_spin, becb0, becb1
      integer(I4B)              :: i, oldstat
   
      select type(cb => nbody_system%cb)
      class is (symba_cb)
   
         ! Add the potential, binding, and kinetic energy of the lost body to the records
         pe = -cb%Gmass * pl%mass(ipl) / norm2(pl%rb(:, ipl) - cb%rb(:))
         be = -3*pl%Gmass(ipl) * pl%mass(ipl) / (5 * pl%radius(ipl))
         ke_orbit = 0.5_DP * pl%mass(ipl) * dot_product(pl%vb(:, ipl), pl%vb(:, ipl)) 
         if (param%lrotation) then
            ke_spin  = 0.5_DP * pl%mass(ipl) * pl%radius(ipl)**2 * pl%Ip(3, ipl) * dot_product(pl%rot(:, ipl), pl%rot(:, ipl))
         else
            ke_spin = 0.0_DP
         end if
   
         if (lescape_body) then
            nbody_system%GMescape = nbody_system%GMescape + pl%Gmass(ipl)
            do i = 1, pl%nbody
               if (i == ipl) cycle
               pe = pe - pl%Gmass(i) * pl%mass(ipl) / norm2(pl%rb(:, ipl) - pl%rb(:, i))
            end do

            nbody_system%E_collisions  = nbody_system%E_collisions + ke_orbit + ke_spin + pe + be
            nbody_system%E_untracked  = nbody_system%E_untracked - (ke_orbit + ke_spin + pe + be)
   
            L_total(:) = 0.0_DP
            do i = 1, pl%nbody
               Lpl(:) = pL%mass(i) * (pl%rb(:,i) .cross. pl%vb(:, i))
               L_total(:) = L_total(:) + Lpl(:)
            end do
            L_total(:) = L_total(:) + cb%mass * (cb%rb(:) .cross. cb%vb(:))
            call pl%b2h(cb)
            oldstat = pl%status(ipl)
            pl%status(ipl) = INACTIVE
            call pl%h2b(cb)
            pl%status(ipl) = oldstat
            do i = 1, pl%nbody
               if (i == ipl) cycle
               Lpl(:) = pl%mass(i) * (pl%rb(:,i) .cross. pl%vb(:, i))
               L_total(:) = L_total(:) - Lpl(:) 
            end do 
            L_total(:) = L_total(:) - cb%mass * (cb%rb(:) .cross. cb%vb(:))
            nbody_system%L_escape(:) = nbody_system%L_escape(:) + L_total(:)
            if (param%lrotation) nbody_system%L_escape(:) = nbody_system%L_escape + pl%mass(ipl) * pl%radius(ipl)**2 &
                                                                    * pl%Ip(3, ipl) * pl%rot(:, ipl)
   
         else
            xcom(:) = (pl%mass(ipl) * pl%rb(:, ipl) + cb%mass * cb%rb(:)) / (cb%mass + pl%mass(ipl))
            vcom(:) = (pl%mass(ipl) * pl%vb(:, ipl) + cb%mass * cb%vb(:)) / (cb%mass + pl%mass(ipl))
            Lpl(:) = (pl%rb(:,ipl) - xcom(:)) .cross. (pL%vb(:,ipl) - vcom(:))
            if (param%lrotation) Lpl(:) = Lpl(:) + pl%radius(ipl)**2 * pl%Ip(3,ipl) * pl%rot(:, ipl)
            Lpl(:) = pl%mass(ipl) * Lpl(:)
     
            Lcb(:) = cb%mass * ((cb%rb(:) - xcom(:)) .cross. (cb%vb(:) - vcom(:)))
   
            ke_orbit = ke_orbit + 0.5_DP * cb%mass * dot_product(cb%vb(:), cb%vb(:)) 
            if (param%lrotation) ke_spin = ke_spin + 0.5_DP * cb%mass * cb%radius**2 * cb%Ip(3) * dot_product(cb%rot(:), cb%rot(:))
            ! Update mass of central body to be consistent with its total mass
            becb0 = -(3 * cb%Gmass * cb%mass) / (5 * cb%radius)
            cb%dGM = cb%dGM + pl%Gmass(ipl)
            cb%dR = cb%dR + 1.0_DP / 3.0_DP * (pl%radius(ipl) / cb%radius)**3 - 2.0_DP / 9.0_DP * (pl%radius(ipl) / cb%radius)**6
            cb%Gmass = cb%GM0 + cb%dGM
            cb%mass = cb%Gmass / param%GU
            cb%radius = cb%R0 + cb%dR
            param%rmin = cb%radius
            becb1 = -(3 * cb%Gmass * cb%mass) / (5 * cb%radius)

            ! Add planet angular momentum to central body accumulator
            cb%dL(:) = Lpl(:) + cb%dL(:) + Lcb(:)
            ! Update rotation of central body to by consistent with its angular momentum 
            if (param%lrotation) then
               drot0(:) = cb%L0(:)/ (cb%Ip(3) * cb%mass * cb%radius**2)  
               drot1(:) = cb%dL(:) / (cb%Ip(3) * cb%mass * cb%radius**2)
               cb%rot(:) = drot0(:) + drot1(:)
               ke_spin  = ke_spin - 0.5_DP * cb%mass * cb%radius**2 * cb%Ip(3) * dot_product(cb%rot(:), cb%rot(:)) 
            end if
            cb%rb(:) = xcom(:)
            cb%vb(:) = vcom(:)
            ke_orbit = ke_orbit - 0.5_DP * cb%mass * dot_product(cb%vb(:), cb%vb(:)) 

            ! Add the change in central body binding energy to the collision energy tracker
            nbody_system%E_collisions  = nbody_system%E_collisions + (becb1 - becb0)
         end if
         call pl%b2h(cb)
   
      end select
      return
   end subroutine symba_discard_conserve_energy_and_momentum


   subroutine symba_discard_nonplpl(pl, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if planets should be discarded based on their positions or because they are unbound
      !s
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_discard_pl.f90
      !! Adapted from Hal Levison's Swift routine discard_massive5.f 
      implicit none
      ! Arguments
      class(symba_pl),              intent(inout) :: pl     !! SyMBA test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      ! Internals
      logical, dimension(pl%nbody) ::  ldiscard
      integer(I4B) :: i, nstart, nend, nsub
      class(symba_pl), allocatable            :: plsub
    
      ! First check for collisions with the central body
      associate(npl => pl%nbody, cb => nbody_system%cb, pl_discards => nbody_system%pl_discards)
         if (npl == 0) return 
         if ((param%rmin >= 0.0_DP) .or. (param%rmax >= 0.0_DP) .or.  (param%rmaxu >= 0.0_DP)) then
            call symba_discard_cb_pl(pl, nbody_system, param)
         end if
         if (param%qmin >= 0.0_DP) call symba_discard_peri_pl(pl, nbody_system, param)
      end associate

      return
   end subroutine symba_discard_nonplpl


   subroutine symba_discard_nonplpl_conservation(pl, nbody_system, param)
      !! author: David A. Minton
      !!
      !! If there are any bodies that are removed due to either colliding with the central body or escaping the systme,
      !! we need to track the conserved quantities with the nbody_system bookkeeping terms.
      implicit none
      ! Arguments
      class(symba_pl),           intent(inout) :: pl     !! SyMBA test particle object
      class(symba_nbody_system), intent(inout) :: nbody_system !! SyMBA nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      ! Internals
      integer(I4B)                            :: i, ndiscard, dstat
      logical                                 :: lescape
      logical, dimension(pl%nbody)            :: discard_l_pl
      integer(I4B), dimension(:), allocatable :: discard_index_list

      associate(npl => pl%nbody)
         discard_l_pl(1:npl) = pl%ldiscard(1:npl) .and. .not. pl%lcollision(1:npl) ! These are bodies that are discarded but not 
                                                                                   ! flagged as pl-pl collision
         ndiscard = count(discard_l_pl(:)) 
         allocate(discard_index_list(ndiscard))
         discard_index_list(:) = pack([(i, i = 1, npl)], discard_l_pl(1:npl))
         do i = 1, ndiscard
            dstat = pl%status(discard_index_list(i)) 
            if ((dstat == DISCARDED_RMIN) .or. (dstat == DISCARDED_PERI)) then
               lescape = .false.
            else if ((dstat == DISCARDED_RMAX) .or. (dstat == DISCARDED_RMAXU)) then
               lescape = .true.
            else 
               cycle
            end if
            ! Conserve all the quantities
            call symba_discard_conserve_energy_and_momentum(pl, nbody_system, param, discard_index_list(i), lescape)
         end do
      end associate

      return
   end subroutine symba_discard_nonplpl_conservation


   subroutine symba_discard_peri_pl(pl, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if a test particle should be discarded because its perihelion distance becomes too small
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_discard_peri_pl.f90
      !! Adapted from Hal Levison's Swift routine discard_mass_peri.f
      implicit none
      ! Arguments
      class(symba_pl),              intent(inout) :: pl     !! SyMBA massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters
      ! Internals
      logical               :: lfirst_orig
      integer(I4B)          :: i
      character(len=STRMAX) :: timestr, idstr, message


      lfirst_orig = pl%lfirst
      pl%lfirst = nbody_system%lfirst_peri
      if (nbody_system%lfirst_peri) then
         call pl%get_peri(nbody_system, param)          
         nbody_system%lfirst_peri = .false.
      else
         call pl%get_peri(nbody_system, param)          
         do i = 1, pl%nbody
            if (pl%status(i) == ACTIVE) then
               if ((pl%isperi(i) == 0) .and. (pl%nplenc(i)== 0)) then
                  if ((pl%atp(i) >= param%qmin_alo) .and. (pl%atp(i) <= param%qmin_ahi) .and. (pl%peri(i) <= param%qmin)) then
                     pl%ldiscard(i) = .true.
                     pl%lcollision(i) = .false.
                     pl%status(i) = DISCARDED_PERI
                     write(timestr, *) nbody_system%t
                     write(idstr, *) pl%id(i)
                     write(message, *) trim(adjustl(pl%info(i)%name)) // " (" // trim(adjustl(idstr)) // &
                                 ") perihelion distance too small at t = " // trim(adjustl(timestr)) 
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                     call pl%info(i)%set_value(status="DISCARDED_PERI", discard_time=nbody_system%t, &
                                               discard_rh=pl%rh(:,i), discard_vh=pl%vh(:,i), discard_body_id=nbody_system%cb%id)
                  end if
               end if
            end if
         end do
      end if
      pl%lfirst = lfirst_orig
   
      return
   end subroutine symba_discard_peri_pl


   module subroutine symba_discard_pl(self, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Call the various flavors of discards for massive bodies in SyMBA runs, including discards due to colliding with the central
      !! body or escaping the nbody_system
      implicit none
      ! Arguments
      class(symba_pl),              intent(inout) :: self   !! SyMBA test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      ! Internals
      real(DP) :: E_orbit_before, E_orbit_after
   
      select type(nbody_system)
      class is (symba_nbody_system)
         select type(param)
         class is (swiftest_parameters)
            associate(pl => self, plpl_encounter => nbody_system%plpl_encounter, plpl_collision => nbody_system%plpl_collision)
               call pl%vb2vh(nbody_system%cb) 
               call pl%rh2rb(nbody_system%cb)
               !call plpl_encounter%write(pl, pl, param) TODO: write the encounter list writer for NetCDF

               call symba_discard_nonplpl(self, nbody_system, param)

               if (.not.any(pl%ldiscard(:))) return

               if (param%lenergy) then
                  call nbody_system%get_energy_and_momentum(param)
                  E_orbit_before = nbody_system%te
               end if

               call symba_discard_nonplpl_conservation(self, nbody_system, param)

               call pl%rearray(nbody_system, param)

               if (param%lenergy) then
                  call nbody_system%get_energy_and_momentum(param)
                  E_orbit_after = nbody_system%te
                  nbody_system%E_collisions = nbody_system%E_collisions + (E_orbit_after - E_orbit_before)
               end if

            end associate
         end select 
      end select

      return
   end subroutine symba_discard_pl

end submodule s_symba_discard

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(helio) s_helio_kick
   use swiftest
contains

   module subroutine helio_kick_getacch_pl(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute heliocentric accelerations of massive bodies
      !!
      !! Adapted from David E. Kaufmann's Swifter routine helio_kick_getacch.f90
      !! Adapted from Hal Levison's Swift routine helio_kick_getacch.f
      implicit none
      ! Arguments
      class(helio_pl),              intent(inout) :: self   
         !! Helio massive body particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current simulation time
      logical,                      intent(in)    :: lbeg   
         !! Logical flag that determines whether or not this is the beginning or end of the step

      if (self%nbody == 0) return

      associate(cb => nbody_system%cb, pl => self, npl => self%nbody)
         call pl%accel_int(param)
         if (param%lnon_spherical_cb) then 
            call pl%accel_non_spherical_cb(nbody_system)
            if (lbeg) then
               cb%aoblbeg = cb%aobl
            else
               cb%aoblend = cb%aobl
            end if
            ! TODO: Implement tides
            ! if (param%ltides) then
            !    call pl%accel_tides(nbody_system)
            !    if (lbeg) then
            !       cb%atidebeg = cb%atide
            !    else
            !       cb%atideend = cb%atide
            !    end if
            ! end if
         end if
         if (param%lextra_force) call pl%accel_user(nbody_system, param, t, lbeg)
         if (param%lgr) call pl%accel_gr(param)
      end associate

      return
   end subroutine helio_kick_getacch_pl


   module subroutine helio_kick_getacch_tp(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute heliocentric accelerations of test particles
      !!
      !! Adapted from David E. Kaufmann's Swifter routine helio_kick_getacch_tp.f90
      !! Adapted from Hal Levison's Swift routine helio_kick_getacch_tp.f
      implicit none
      ! Arguments
      class(helio_tp),              intent(inout) :: self   
         !! Helio test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current time
      logical,                      intent(in)    :: lbeg   
         !! Logical flag that determines whether or not this is the beginning or end of the step
   
      if (self%nbody == 0) return

      associate(tp => self, cb => nbody_system%cb, pl => nbody_system%pl, npl => nbody_system%pl%nbody)
         nbody_system%lbeg = lbeg
         if (npl > 0) then
            if (nbody_system%lbeg) then
               call tp%accel_int(param, pl%Gmass(1:npl), pl%rbeg(:,1:npl), npl)
            else
               call tp%accel_int(param, pl%Gmass(1:npl), pl%rend(:,1:npl), npl)
            end if
         end if
         if (param%lnon_spherical_cb) call tp%accel_non_spherical_cb(nbody_system)
         if (param%lextra_force) call tp%accel_user(nbody_system, param, t, lbeg)
         if (param%lgr) call tp%accel_gr(param)
      end associate

      return
   end subroutine helio_kick_getacch_tp


   module subroutine helio_kick_vb_pl(self, nbody_system, param, t, dt, lbeg)
      !! author: David A. Minton
      !!
      !! Kick barycentric velocities of bodies
      !!
      !! Adapted from Martin Duncan and Hal Levison's Swift routine kickvh.f 
      !! Adapted from David E. Kaufmann's Swifter routine helio_kick_vb.f90
      implicit none
      ! Arguments
      class(helio_pl),              intent(inout) :: self   
         !! Swiftest generic body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current time
      real(DP),                     intent(in)    :: dt     
         !! Stepsize
      logical,                      intent(in)    :: lbeg   
         !! Logical flag indicating whether this is the beginning of the half step or not. 
      ! Internals
      integer(I4B) :: i, npl

      if (self%nbody == 0) return

      associate(pl => self)
         npl = self%nbody
         pl%ah(:, 1:npl) = 0.0_DP
         call pl%accel(nbody_system, param, t, lbeg)
         if (lbeg) then
            call pl%set_beg_end(rbeg = pl%rh)
         else
            call pl%set_beg_end(rend = pl%rh)
         end if
#ifdef DOCONLOC
         do concurrent(i = 1:npl, pl%lmask(i)) shared(pl,dt)
#else
         do concurrent(i = 1:npl, pl%lmask(i)) 
#endif
            pl%vb(1, i) = pl%vb(1, i) + pl%ah(1, i) * dt
            pl%vb(2, i) = pl%vb(2, i) + pl%ah(2, i) * dt
            pl%vb(3, i) = pl%vb(3, i) + pl%ah(3, i) * dt
         end do
      end associate
   
      return
   end subroutine helio_kick_vb_pl


   module subroutine helio_kick_vb_tp(self, nbody_system, param, t, dt, lbeg)
      !! author: David A. Minton
      !!
      !! Kick barycentric velocities of bodies
      !!
      !! Adapted from Martin Duncan and Hal Levison's Swift routine kickvh_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine helio_kick_vb_tp.f90
      implicit none
      ! Arguments
      class(helio_tp),              intent(inout) :: self 
         !! Swiftest generic body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param 
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t     
         !! Current time
      real(DP),                     intent(in)    :: dt    
         !! Stepsize
      logical,                      intent(in)    :: lbeg  
         !! Logical flag indicating whether this is the beginning of the half step or not. 
      ! Internals
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return

      associate(tp => self)
         ntp = self%nbody
         tp%ah(:, 1:ntp) = 0.0_DP
         call tp%accel(nbody_system, param, t, lbeg)
#ifdef DOCONLOC
         do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp,dt)
#else
         do concurrent(i = 1:ntp, tp%lmask(i)) 
#endif
            tp%vb(:, i) = tp%vb(:, i) + tp%ah(:, i) * dt
         end do
      end associate
   
      return
   end subroutine helio_kick_vb_tp

end submodule s_helio_kick

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(whm) s_whm_kick
   use swiftest
contains

   module subroutine whm_kick_getacch_pl(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute heliocentric accelerations of planets
      !!
      !! Adapted from Hal Levison's Swift routine getacch.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch.f90
      implicit none
      ! Arguments
      class(whm_pl),                intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest central body particle data structure
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t       !! Current time
      logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      ! Internals
      integer(I4B)                                :: i
      real(DP), dimension(NDIM)                   :: ah0

      if (self%nbody == 0) return

      associate(cb => nbody_system%cb, pl => self, npl => self%nbody)
         call pl%set_ir3()

         ah0(:) = whm_kick_getacch_ah0(pl%Gmass(2:npl), pl%rh(:,2:npl), npl-1)
         do i = 1, npl
            pl%ah(:, i) = pl%ah(:, i) + ah0(:)
         end do

         call whm_kick_getacch_ah1(cb, pl) 
         call whm_kick_getacch_ah2(cb, pl) 
         call pl%accel_int(param) 

         if (param%lnon_spherical_cb) then
            call pl%accel_non_spherical_cb(nbody_system)
            if (lbeg) then
               cb%aoblbeg = cb%aobl
            else
               cb%aoblend = cb%aobl
            end if
            ! TODO: Implement tides
            ! if (param%ltides) then
            !    cb%atidebeg = cb%aobl
            !    call pl%accel_tides(nbody_system)
            !    cb%atideend = cb%atide
            ! end if
         end if

         if (param%lgr) call pl%accel_gr(param) 
         if (param%lextra_force) call pl%accel_user(nbody_system, param, t, lbeg)
      end associate

      return
   end subroutine whm_kick_getacch_pl


   module subroutine whm_kick_getacch_tp(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute heliocentric accelerations of test particles
      !!
      !! Adapted from Hal Levison's Swift routine getacch_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_tp.f90
      implicit none
      ! Arguments
      class(whm_tp),                intent(inout) :: self   !! WHM test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest central body particle data structure
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      !! Current time
      logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      ! Internals
      integer(I4B)                                :: i, npl, ntp
      real(DP), dimension(NDIM)                   :: ah0
   
      associate(tp => self, pl => nbody_system%pl, cb => nbody_system%cb)
         npl = nbody_system%pl%nbody
         ntp = self%nbody
         if (ntp == 0) return
         nbody_system%lbeg = lbeg

         if(npl > 0) then
            if (lbeg) then
               ah0(:) = whm_kick_getacch_ah0(pl%Gmass(1:npl), pl%rbeg(:, 1:npl), npl)
#ifdef DOCONLOC
               do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp,ah0)
#else
               do concurrent(i = 1:ntp, tp%lmask(i))
#endif
                  tp%ah(:, i) = tp%ah(:, i) + ah0(:)
               end do
               call tp%accel_int(param, pl%Gmass(1:npl), pl%rbeg(:, 1:npl), npl)
            else
               ah0(:) = whm_kick_getacch_ah0(pl%Gmass(1:npl), pl%rend(:, 1:npl), npl)
#ifdef DOCONLOC
               do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp,ah0)
#else
               do concurrent(i = 1:ntp, tp%lmask(i))
#endif
                  tp%ah(:, i) = tp%ah(:, i) + ah0(:)
               end do
               call tp%accel_int(param, pl%Gmass(1:npl), pl%rend(:, 1:npl), npl)
            end if
         end if

         if (param%lnon_spherical_cb) call tp%accel_non_spherical_cb(nbody_system)
         if (param%lextra_force) call tp%accel_user(nbody_system, param, t, lbeg)
         if (param%lgr) call tp%accel_gr(param) 
      end associate

      return
   end subroutine whm_kick_getacch_tp


   function whm_kick_getacch_ah0(mu, rhp, n) result(ah0)
      !! author: David A. Minton
      !!
      !! Compute zeroth term heliocentric accelerations of planets 
      implicit none
      ! Arguments
      real(DP), dimension(:),   intent(in)         :: mu
      real(DP), dimension(:,:), intent(in)         :: rhp
      integer(I4B),             intent(in)         :: n
      ! Result
      real(DP), dimension(NDIM)                    :: ah0
      ! Internals
      real(DP)                                     :: fac, r2, ir3h
      integer(I4B)                                 :: i

      ah0(:) = 0.0_DP
      do i = 1, n
         r2 = dot_product(rhp(:, i), rhp(:, i))
         ir3h = 1.0_DP / (r2 * sqrt(r2)) 
         fac = mu(i) * ir3h 
         ah0(:) = ah0(:) - fac * rhp(:, i)
      end do

      return
   end function whm_kick_getacch_ah0


   pure subroutine whm_kick_getacch_ah1(cb, pl)
      !! author: David A. Minton
      !!
      !! Compute first term heliocentric accelerations of planets
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah1.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah1.f90
      implicit none
      ! Arguments
      class(swiftest_cb), intent(in)    :: cb !! WHM central body object
      class(whm_pl),      intent(inout) :: pl !! WHM massive body object
      ! Internals
      integer(I4B)                 :: i, npl
      real(DP), dimension(NDIM)    :: ah1h, ah1j

      npl = pl%nbody
#ifdef DOCONLOC
      do concurrent (i = 2:npl, pl%lmask(i)) shared(pl,cb) local(ah1j,ah1h)
#else
      do concurrent (i = 2:npl, pl%lmask(i))
#endif
         ah1j(:) = pl%xj(:, i) * pl%ir3j(i)
         ah1h(:) = pl%rh(:, i) * pl%ir3h(i)
         pl%ah(:, i) = pl%ah(:, i) + cb%Gmass * (ah1j(:) - ah1h(:))
      end do
   
      return
   end subroutine whm_kick_getacch_ah1


   pure subroutine whm_kick_getacch_ah2(cb, pl)
      !! author: David A. Minton
      !!
      !! Compute second term heliocentric accelerations of planets
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah2.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah2.f90
      implicit none
      ! Arguments
      class(swiftest_cb), intent(in)    :: cb !! Swiftest central body object
      class(whm_pl),      intent(inout) :: pl !! WHM massive body object
      ! Internals
      integer(I4B)                 :: i, npl
      real(DP)                     :: etaj, fac
      real(DP), dimension(NDIM)    :: ah2, ah2o
   
      npl = pl%nbody
      ah2(:) = 0.0_DP
      ah2o(:) = 0.0_DP
      etaj = cb%Gmass
#ifdef DOCONLOC
      do concurrent(i = 2:npl, pl%lmask(i)) shared(pl,cb,ah2,ah2o) local(etaj,fac)
#else
      do concurrent(i = 2:npl, pl%lmask(i))
#endif
         etaj = etaj + pl%Gmass(i - 1)
         fac = pl%Gmass(i) * cb%Gmass * pl%ir3j(i) / etaj
         ah2(:) = ah2o(:) + fac * pl%xj(:, i)
         pl%ah(:,i) = pl%ah(:, i) + ah2(:)
         ah2o(:) = ah2(:)
      end do
   
      return
   end subroutine whm_kick_getacch_ah2


   module subroutine whm_kick_vh_pl(self, nbody_system, param, t, dt, lbeg)
      !! author: David A. Minton
      !!
      !! Kick heliocentric velocities of massive bodies
      !!
      !! Adapted from Martin Duncan and Hal Levison's Swift routine kickvh.f 
      !! Adapted from David E. Kaufmann's Swifter routine whm_kickvh.f90 
      implicit none
      ! Arguments
      class(whm_pl),                intent(inout) :: self  !! WHM massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      !! Current time
      real(DP),                     intent(in)    :: dt     !! Stepsize
      logical,                      intent(in)    :: lbeg   !! Logical flag indicating whether this is the beginning of the half step or not. 
      ! Internals
      integer(I4B) :: i, npl

      associate(pl => self, cb => nbody_system%cb)
         npl = self%nbody
         if (npl == 0) return
         if (lbeg) then
            if (pl%lfirst) then
               call pl%h2j(cb)
               pl%ah(:, 1:npl) = 0.0_DP
               call pl%accel(nbody_system, param, t, lbeg)
               pl%lfirst = .false.
            end if
            call pl%set_beg_end(rbeg = pl%rh)
         else
            pl%ah(:, 1:npl) = 0.0_DP
            call pl%accel(nbody_system, param, t, lbeg)
            call pl%set_beg_end(rend = pl%rh)
         end if
#ifdef DOCONLOC
         do concurrent(i = 1:npl, pl%lmask(i)) shared(pl,dt)
#else
         do concurrent(i = 1:npl, pl%lmask(i))
#endif
            pl%vh(:, i) = pl%vh(:, i) + pl%ah(:, i) * dt
         end do
      end associate

      return
   end subroutine whm_kick_vh_pl


   module subroutine whm_kick_vh_tp(self, nbody_system, param, t, dt, lbeg)
      !! author: David A. Minton
      !!
      !! Kick heliocentric velocities of test particles
      !!
      !! Adapted from Martin Duncan and Hal Levison's Swift routine kickvh_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kickvh_tp.f90
      implicit none
      ! Arguments
      class(whm_tp),                intent(inout) :: self   !! WHM massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      !! Current time
      real(DP),                     intent(in)    :: dt     !! Stepsize
      logical,                      intent(in)    :: lbeg   !! Logical flag indicating whether this is the beginning of the half step or not. 
      ! Internals
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return

      associate(tp => self)
         ntp = self%nbody
         if (tp%lfirst) then
#ifdef DOCONLOC
            do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp)
#else
            do concurrent(i = 1:ntp, tp%lmask(i))
#endif
               tp%ah(:, i) = 0.0_DP
            end do
            call tp%accel(nbody_system, param, t, lbeg=.true.)
            tp%lfirst = .false.
         end if
         if (.not.lbeg) then
#ifdef DOCONLOC
            do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp)
#else
            do concurrent(i = 1:ntp, tp%lmask(i))
#endif
               tp%ah(:, i) = 0.0_DP
            end do
            call tp%accel(nbody_system, param, t, lbeg)
         end if
#ifdef DOCONLOC
         do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp)
#else
         do concurrent(i = 1:ntp, tp%lmask(i))
#endif
            tp%vh(:, i) = tp%vh(:, i) + tp%ah(:, i) * dt
         end do
      end associate

      return
   end subroutine whm_kick_vh_tp

end submodule s_whm_kick

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module netcdf_io
   !! author: The Purdue Swiftest Team -  David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Base type definitions. This allows the collision and encounter modules to be defined before the swiftest module.
   !!
   use globals
   use base
   implicit none
   public


   !! This derived datatype stores the NetCDF ID values for each of the variables included in the NetCDF data file. This is used as the base class defined in base
   type, abstract :: netcdf_parameters
      character(STRMAX)  :: file_name                                   !! Name of the output file
      logical            :: lfile_is_open = .false.                     !! Flag indicating that the linked file is currently open
      integer(I4B)       :: out_type                                    !! output type (will be assigned either NF90_DOUBLE or NF90_FLOAT, depending on the user parameter)
      integer(I4B)       :: id                                          !! ID for the output file
      integer(I4B)       :: tslot                   = 1                 !! The current time slot that gets passed to the NetCDF reader/writer
      integer(I4B)       :: max_tslot               = 0                 !! Records the last index value of time in the NetCDF file
      integer(I4B), dimension(:), allocatable :: idvals                 !! Array of id values in this NetCDF file
      integer(I4B)       :: idslot                  = 1                 !! The current id slot that gets passed to the NetCDF reader/writer
      integer(I4B)       :: max_idslot              = 0                 !! Records the last index value of id in the NetCDF file

      ! Dimension ids and variable names
      character(NAMELEN) :: str_dimname             = "string32"        !! name of the character string dimension
      integer(I4B)       :: str_dimid                                   !! ID for the character string dimension
      character(NAMELEN) :: time_dimname            = "time"            !! name of the time dimension 
      integer(I4B)       :: time_dimid                                  !! ID for the time dimension 
      integer(I4B)       :: time_varid                                  !! ID for the time variable
      character(NAMELEN) :: name_dimname            = "name"            !! name of the particle name dimension
      integer(I4B)       :: name_dimid                                  !! ID for the particle name dimension
      integer(I4B)       :: name_varid                                  !! ID for the particle name variable
      character(NAMELEN) :: space_dimname           = "space"           !! name of the space dimension
      integer(I4B)       :: space_dimid                                 !! ID for the space dimension
      integer(I4B)       :: space_varid                                 !! ID for the space variable
      character(len=1), dimension(3) :: space_coords = ["x","y","z"]    !! The space dimension coordinate labels

      ! Non-dimension ids and variable names
      character(NAMELEN) :: id_varname              = "id"              !! name of the particle id variable
      integer(I4B)       :: id_varid                                    !! ID for the id variable 
      character(NAMELEN) :: status_varname          = "status"          !! name of the particle status variable
      integer(I4B)       :: status_varid                                !! ID for the status variable 
      character(NAMELEN) :: ptype_varname           = "particle_type"   !! name of the particle type variable
      integer(I4B)       :: ptype_varid                                 !! ID for the particle type variable
      character(NAMELEN) :: npl_varname             = "npl"             !! name of the number of active massive bodies variable
      integer(I4B)       :: npl_varid                                   !! ID for the number of active massive bodies variable
      character(NAMELEN) :: ntp_varname             = "ntp"             !! name of the number of active test particles variable
      integer(I4B)       :: ntp_varid                                   !! ID for the number of active test particles variable
      character(NAMELEN) :: nplm_varname            = "nplm"            !! name of the number of active fully interacting massive bodies variable (SyMBA)
      integer(I4B)       :: nplm_varid                                  !! ID for the number of active fully interacting massive bodies variable (SyMBA)
      character(NAMELEN) :: a_varname               = "a"               !! name of the semimajor axis variable 
      integer(I4B)       :: a_varid                                     !! ID for the semimajor axis variable 
      character(NAMELEN) :: e_varname               = "e"               !! name of the eccentricity variable 
      integer(I4B)       :: e_varid                                     !! ID for the eccentricity variable 
      character(NAMELEN) :: inc_varname             = "inc"             !! name of the inclination variable 
      integer(I4B)       :: inc_varid                                   !! ID for the inclination variable 
      character(NAMELEN) :: capom_varname           = "capom"           !! name of the long. asc. node variable 
      integer(I4B)       :: capom_varid                                 !! ID for the long. asc. node variable 
      character(NAMELEN) :: omega_varname           = "omega"           !! name of the arg. of periapsis variable 
      integer(I4B)       :: omega_varid                                 !! ID for the arg. of periapsis variable 
      character(NAMELEN) :: capm_varname            = "capm"            !! name of the mean anomaly variable 
      integer(I4B)       :: capm_varid                                  !! ID for the mean anomaly variable 
      character(NAMELEN) :: varpi_varname           = "varpi"           !! name of the long. of periapsis variable 
      integer(I4B)       :: varpi_varid                                 !! ID for the long. of periapsis variable 
      character(NAMELEN) :: lam_varname             = "lam"             !! name of the mean longitude variable 
      integer(I4B)       :: lam_varid                                   !! ID for the mean longitude variable 
      character(NAMELEN) :: f_varname               = "f"               !! name of the true anomaly variable 
      integer(I4B)       :: f_varid                                     !! ID for the true anomaly variable 
      character(NAMELEN) :: cape_varname            = "cape"            !! name of the eccentric anomaly variable 
      integer(I4B)       :: cape_varid                                  !! ID for the eccentric anomaly variable 
      character(NAMELEN) :: rh_varname              = "rh"              !! name of the heliocentric position vector variable
      integer(I4B)       :: rh_varid                                    !! ID for the heliocentric position vector variable 
      character(NAMELEN) :: vh_varname              = "vh"              !! name of the heliocentric velocity vector variable
      integer(I4B)       :: vh_varid                                    !! ID for the heliocentric velocity vector variable 
      character(NAMELEN) :: gr_pseudo_vh_varname    = "gr_pseudo_vh"    !! name of the heliocentric pseudovelocity vector variable (used in GR only)
      integer(I4B)       :: gr_pseudo_vh_varid                          !! ID for the heliocentric pseudovelocity vector variable (used in GR)
      character(NAMELEN) :: Gmass_varname           = "Gmass"           !! name of the G*mass variable
      integer(I4B)       :: Gmass_varid                                 !! ID for the G*mass variable
      character(NAMELEN) :: mass_varname            = "mass"            !! name of the mass variable
      integer(I4B)       :: mass_varid                                  !! ID for the mass variable
      character(NAMELEN) :: rhill_varname           = "rhill"           !! name of the hill radius variable
      integer(I4B)       :: rhill_varid                                 !! ID for the hill radius variable
      character(NAMELEN) :: radius_varname          = "radius"          !! name of the radius variable
      integer(I4B)       :: radius_varid                                !! ID for the radius variable
      character(NAMELEN) :: Ip_varname              = "Ip"              !! name of the principal moment of inertial variable
      integer(I4B)       :: Ip_varid                                    !! ID for the axis principal moment of inertia variable
      character(NAMELEN) :: rot_varname             = "rot"             !! name of the rotation vector variable
      integer(I4B)       :: rot_varid                                   !! ID for the rotation vector variable
      character(NAMELEN) :: j2rp2_varname           = "j2rp2"           !! name of the j2rp2 variable
      integer(I4B)       :: j2rp2_varid                                 !! ID for the j2 variable
      character(NAMELEN) :: j4rp4_varname           = "j4rp4"           !! name of the j4pr4 variable
      integer(I4B)       :: j4rp4_varid                                 !! ID for the j4 variable
      character(NAMELEN) :: k2_varname              = "k2"              !! name of the Love number variable
      integer(I4B)       :: k2_varid                                    !! ID for the Love number variable
      character(NAMELEN) :: q_varname               = "Q"               !! name of the energy dissipation variable
      integer(I4B)       :: Q_varid                                     !! ID for the energy dissipation variable
      character(NAMELEN) :: ke_orb_varname          = "KE_orb"          !! name of the system orbital kinetic energy variable
      integer(I4B)       :: KE_orb_varid                                !! ID for the system orbital kinetic energy variable
      character(NAMELEN) :: ke_spin_varname         = "KE_spin"         !! name of the system spin kinetic energy variable
      integer(I4B)       :: KE_spin_varid                               !! ID for the system spin kinetic energy variable
      character(NAMELEN) :: pe_varname              = "PE"              !! name of the system potential energy variable
      integer(I4B)       :: PE_varid                                    !! ID for the system potential energy variable
      character(NAMELEN) :: be_varname              = "BE"              !! name of the system binding energy variable
      integer(I4B)       :: BE_varid                                    !! ID for the system binding energy variable
      character(NAMELEN) :: te_varname              = "TE"              !! name of the system binding energy variable
      integer(I4B)       :: TE_varid                                    !! ID for the system binding energy variable
      character(NAMELEN) :: L_orbit_varname         = "L_orbit"           !! name of the orbital angular momentum vector variable
      integer(I4B)       :: L_orbit_varid                                 !! ID for the system orbital angular momentum vector variable
      character(NAMELEN) :: L_spin_varname          = "L_spin"            !! name of the spin angular momentum vector variable
      integer(I4B)       :: L_spin_varid                                 !! ID for the system spin angular momentum vector variable
      character(NAMELEN) :: L_escape_varname        = "L_escape"        !! name of the escaped angular momentum vector variable
      integer(I4B)       :: L_escape_varid                              !! ID for the escaped angular momentum vector variable
      character(NAMELEN) :: E_collisions_varname    = "E_collisions"     !! name of the escaped angular momentum y variable                             
      integer(I4B)       :: E_collisions_varid                           !! ID for the energy lost in collisions variable
      character(NAMELEN) :: E_untracked_varname     = "E_untracked"      !! name of the energy that is untracked due to loss (untracked potential energy due to mergers and body energy for escaped bodies)
      integer(I4B)       :: E_untracked_varid                            !! ID for the energy that is untracked due to loss (untracked potential energy due to mergers and body energy for escaped bodies)
      character(NAMELEN) :: GMescape_varname        = "GMescape"        !! name of the G*Mass of bodies that escape the system
      integer(I4B)       :: GMescape_varid                              !! ID for the G*Mass of bodies that escape the system
      character(NAMELEN) :: origin_type_varname     = "origin_type"     !! name of the origin type variable (Initial Conditions, Disruption, etc.)
      integer(I4B)       :: origin_type_varid                           !! ID for the origin type
      character(NAMELEN) :: origin_time_varname     = "origin_time"     !! name of the time of origin variable
      integer(I4B)       :: origin_time_varid                           !! ID for the origin time
      character(NAMELEN) :: collision_id_varname    = "collision_id"    !! name of the collision id variable
      integer(I4B)       :: collision_id_varid                          !! Netcdf ID for the origin collision ID
      character(NAMELEN) :: origin_rh_varname       = "origin_rh"       !! name of the heliocentric position vector of the body at the time of origin variable
      integer(I4B)       :: origin_rh_varid                             !! ID for the origin position vector variable
      character(NAMELEN) :: origin_vh_varname       = "origin_vh"       !! name of the heliocentric velocity vector of the body at the time of origin variable
      integer(I4B)       :: origin_vh_varid                             !! ID for the origin velocity vector component
      character(NAMELEN) :: discard_time_varname    = "discard_time"    !! name of the time of discard variable
      integer(I4B)       :: discard_time_varid                          !! ID for the time of discard variable
      character(NAMELEN) :: discard_rh_varname      = "discard_rh"      !! name of the heliocentric position vector of the body at the time of discard variable
      integer(I4B)       :: discard_rh_varid                            !! ID for the heliocentric position vector of the body at the time of discard variable
      character(NAMELEN) :: discard_vh_varname      = "discard_vh"      !! name of the heliocentric velocity vector of the body at the time of discard variable
      integer(I4B)       :: discard_vh_varid                            !! ID for the heliocentric velocity vector of the body at the time of discard variable
      character(NAMELEN) :: discard_body_id_varname = "discard_body_id" !! name of the id of the other body involved in the discard
      integer(I4B)       :: discard_body_id_varid                       !! ID for the id of the other body involved in the discard
      logical            :: lpseudo_vel_exists = .false.                !! Logical flag to indicate whether or not the pseudovelocity vectors were present in an old file.
   contains
      procedure :: close       => netcdf_io_close       !! Closes an open NetCDF file
      procedure :: find_tslot  => netcdf_io_find_tslot  !! Finds the time dimension index for a given value of t
      procedure :: find_idslot => netcdf_io_find_idslot !! Finds the id dimension index for a given value of id
      procedure :: get_idvals  => netcdf_io_get_idvals  !! Gets the valid id numbers currently stored in this dataset
      procedure :: sync        => netcdf_io_sync        !! Syncrhonize the disk and memory buffer of the NetCDF file (e.g. commit the frame files stored in memory to disk) 
   end type netcdf_parameters

   interface
      module subroutine netcdf_io_check(status, call_identifier)
         implicit none
         integer, intent (in) :: status !! The status code returned by a NetCDF function
         character(len=*), intent(in), optional :: call_identifier !! String that indicates which calling function caused the error for diagnostic purposes
      end subroutine netcdf_io_check
   
      module subroutine netcdf_io_close(self)
         implicit none
         class(netcdf_parameters),   intent(inout) :: self   !! Parameters used to identify a particular NetCDF dataset
      end subroutine netcdf_io_close

      module subroutine netcdf_io_get_idvals(self)
         implicit none
         class(netcdf_parameters),                            intent(inout) :: self   !! Parameters used to identify a particular NetCDF dataset
      end subroutine netcdf_io_get_idvals

      module subroutine netcdf_io_find_tslot(self, t, tslot)
         implicit none
         class(netcdf_parameters), intent(inout) :: self  !! Parameters used to identify a particular NetCDF dataset
         real(DP),                 intent(in)    :: t     !! The value of time to search for
         integer(I4B),             intent(out)   :: tslot !! The index of the time slot where this data belongs
      end subroutine netcdf_io_find_tslot

      module subroutine netcdf_io_find_idslot(self, id, idslot)
         implicit none
         class(netcdf_parameters), intent(inout) :: self   !! Parameters used to identify a particular NetCDF dataset
         integer(I4B),             intent(in)    :: id     !! The value of id to search for
         integer(I4B),             intent(out)   :: idslot !! The index of the id slot where this data belongs
      end subroutine netcdf_io_find_idslot
   
      module subroutine netcdf_io_sync(self)
         implicit none
         class(netcdf_parameters), intent(inout) :: self !! Parameters used to identify a particular NetCDF dataset
      end subroutine netcdf_io_sync
   end interface 


end module netcdf_io

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module fraggle
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods specific to Fraggle: *Fragment* *g*eneration that conserves angular momentum (*L*) and 
   !! energy (*E*)
   use swiftest
   implicit none
   public

   integer(I4B), parameter :: iMlr = 1
   integer(I4B), parameter :: iMslr = 2
   integer(I4B), parameter :: iMrem = 3
   integer(I4B), parameter :: NFRAGMIN = iMrem + 2
   integer(I4B) :: nfrag
   real(DP) :: Mslr, Mrat

   type, extends(collision_basic) :: collision_fraggle
      real(DP) :: fail_scale !! Scale factor to apply to distance values in the position model when overlaps occur. 
   contains
      procedure :: generate      => fraggle_generate           
         !! A simple disruption models that does not constrain energy loss in collisions
      procedure :: disrupt       => fraggle_generate_disrupt   
         !! Generates a system of fragments in barycentric coordinates that conserves energy and momentum.
      procedure :: hitandrun     => fraggle_generate_hitandrun 
         !! Generates either a pure hit and run, or one in which the runner is disrupted
      procedure :: merge         => fraggle_generate_merge     
         !! Merges bodies unless the rotation would be too high, then it switches to pure hit and run.
      procedure :: set_mass_dist => fraggle_util_set_mass_dist 
         !! Sets the distribution of mass among the fragments depending on the regime type
      procedure :: restructure   => fraggle_util_restructure   
         !! Restructures the fragment distribution after a failure to converge on a solution
   end type collision_fraggle  

   interface
      module subroutine fraggle_generate(self, nbody_system, param, t)
         implicit none
         class(collision_fraggle), intent(inout) :: self         
            !! Fraggle fragment system object 
         class(base_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         real(DP),                 intent(in)    :: t            
            !! The time of the collision
      end subroutine fraggle_generate

      module subroutine fraggle_generate_disrupt(self, nbody_system, param, t, lfailure)
         implicit none
         class(collision_fraggle), intent(inout) :: self         
            !! Fraggle system object
         class(base_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         real(DP),                 intent(in)    :: t            
            !! Time of collision 
         logical,                  intent(out)   :: lfailure     
            !! True if Fraggle could not satisfy all constraints.
      end subroutine fraggle_generate_disrupt

      module subroutine fraggle_generate_hitandrun(self, nbody_system, param, t) 
         implicit none
         class(collision_fraggle), intent(inout) :: self         
            !! Fraggle system object
         class(base_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        
            !! Current run configuration parameters with SyMBA additions
         real(DP),                 intent(in)    :: t            
            !! Time of collision
      end subroutine fraggle_generate_hitandrun

      module subroutine fraggle_generate_merge(self, nbody_system, param, t)
         implicit none
         class(collision_fraggle), intent(inout) :: self         
            !! Fraggle system object
         class(base_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(base_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         real(DP),                 intent(in)    :: t            
            !! The time of the collision
      end subroutine fraggle_generate_merge

      module subroutine fraggle_generate_pos_vec(collider, nbody_system, param, lfailure)
         implicit none
         class(collision_fraggle),     intent(inout) :: collider     
            !! Fraggle collision system object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         logical,                      intent(out)   :: lfailure     
            !! Did the velocity computation fail?
      end subroutine fraggle_generate_pos_vec 

      module subroutine fraggle_generate_rot_vec(collider, nbody_system, param)
         implicit none
         class(collision_fraggle),     intent(inout) :: collider     
            !! Collision system object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
      end subroutine fraggle_generate_rot_vec 

      module subroutine fraggle_generate_vel_vec(collider, nbody_system, param, lfailure)
         implicit none
         class(collision_fraggle),     intent(inout) :: collider     
            !! Fraggle collision system object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         logical,                      intent(out)   :: lfailure     
            !! Did the velocity computation fail?
      end subroutine fraggle_generate_vel_vec

      module function fraggle_util_sfd_function(x) result(y)
         implicit none
         real(DP), intent(in) :: x
         real(DP)             :: y
         integer(I4B) :: i
      end function fraggle_util_sfd_function

      module subroutine fraggle_util_restructure(self, nbody_system, param, lfailure)
         implicit none
         class(collision_fraggle),     intent(inout) :: self         
            !! Fraggle collision system object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         logical,                      intent(out)   :: lfailure     
            !! Did the computation fail?
      end subroutine fraggle_util_restructure

      module subroutine fraggle_util_set_mass_dist(self, param)
         implicit none
         class(collision_fraggle), intent(inout) :: self  
            !! Fraggle collision object
         class(swiftest_parameters),   intent(in)    :: param 
            !! Current Swiftest run configuration parameters
      end subroutine fraggle_util_set_mass_dist
   end interface
   
end module fraggle

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module symba
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods specific to the SyMBA integrator
   !! Adapted from David E. Kaufmann's Swifter routine: module_symba.f90
   use swiftest
   use helio
   implicit none
   public

   integer(I4B), private, parameter :: NENMAX  = 32767
   integer(I4B), private, parameter :: NTENC   = 3
   real(DP),     private, parameter :: RHSCALE = 6.5_DP
   real(DP),     private, parameter :: RSHELL  = 0.48075_DP

   !> SyMBA central body particle class
   type, extends(helio_cb) :: symba_cb
   end type symba_cb


   !> SyMBA massive body class
   type, extends(helio_pl) :: symba_pl
      integer(I4B),              dimension(:), allocatable :: levelg     !! level at which this body should be moved
      integer(I4B),              dimension(:), allocatable :: levelm     !! deepest encounter level achieved this time step
   contains
      procedure :: flatten         => symba_util_flatten_eucl_plpl      !! Sets up the (i, j) -> k indexing used for the single-loop blocking Euclidean distance matrix
      procedure :: discard         => symba_discard_pl                  !! Process massive body discards
      procedure :: drift           => symba_drift_pl                    !! Method for Danby drift in Democratic Heliocentric coordinates. Sets the mask to the current recursion level
      procedure :: encounter_check => symba_encounter_check_pl          !! Checks if massive bodies are going through close encounters with each other
      procedure :: gr_pos_kick     => symba_gr_p4_pl                    !! Position kick due to p**4 term in the post-Newtonian correction
      procedure :: accel_int       => symba_kick_getacch_int_pl         !! Compute direct cross (third) term heliocentric accelerations of massive bodiess, with no mutual interactions between bodies below GMTINY
      procedure :: accel           => symba_kick_getacch_pl             !! Compute heliocentric accelerations of massive bodies
      procedure :: setup           => symba_util_setup_pl                    !! Constructor method - Allocates space for the input number of bodies
      procedure :: append          => symba_util_append_pl              !! Appends elements from one structure to another
      procedure :: dealloc         => symba_util_dealloc_pl             !! Deallocates all allocatable arrays
      procedure :: fill            => symba_util_fill_pl                !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: resize          => symba_util_resize_pl              !! Checks the current size of a SyMBA massive body against the requested size and resizes it if it is too small.
      procedure :: set_renc_I4B    => symba_util_set_renc               !! Sets the critical radius for encounter given an input recursion depth
      procedure :: sort            => symba_util_sort_pl                !! Sorts body arrays by a sortable componen
      procedure :: rearrange       => symba_util_sort_rearrange_pl      !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill           => symba_util_spill_pl               !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
   end type symba_pl


   !> SyMBA test particle class
   type, extends(helio_tp) :: symba_tp
      integer(I4B), dimension(:), allocatable :: levelg  !! level at which this particle should be moved
      integer(I4B), dimension(:), allocatable :: levelm  !! deepest encounter level achieved this time step
   contains
      procedure :: drift           => symba_drift_tp               !! Method for Danby drift in Democratic Heliocentric coordinates. Sets the mask to the current recursion level
      procedure :: encounter_check => symba_encounter_check_tp     !! Checks if any test particles are undergoing a close encounter with a massive body
      procedure :: gr_pos_kick     => symba_gr_p4_tp               !! Position kick due to p**4 term in the post-Newtonian correction
      procedure :: accel           => symba_kick_getacch_tp        !! Compute heliocentric accelerations of test particles
      procedure :: setup           => symba_util_setup_tp               !! Constructor method - Allocates space for the input number of bodies
      procedure :: append          => symba_util_append_tp         !! Appends elements from one structure to another
      procedure :: dealloc         => symba_util_dealloc_tp        !! Deallocates all allocatable arrays
      procedure :: fill            => symba_util_fill_tp           !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: resize          => symba_util_resize_tp         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: sort            => symba_util_sort_tp           !! Sorts body arrays by a sortable componen
      procedure :: rearrange       => symba_util_sort_rearrange_tp !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill           => symba_util_spill_tp          !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
   end type symba_tp


   !> SyMBA class for tracking close encounters in a step
   type, extends(collision_list_plpl) :: symba_list_plpl
   contains
      procedure :: encounter_check => symba_encounter_check_list_plpl !! Checks if massive bodies are going through close encounters with each other
      procedure :: kick            => symba_kick_list_plpl            !! Kick barycentric velocities of active massive bodies within SyMBA recursion
   end type symba_list_plpl


   !> SyMBA class for tracking close encounters in a step
   type, extends(collision_list_pltp) :: symba_list_pltp
   contains
      procedure :: encounter_check => symba_encounter_check_list_pltp !! Checks if massive bodies are going through close encounters with test particles
      procedure :: kick            => symba_kick_list_pltp            !! Kick barycentric velocities of active test particles within SyMBA recursion
   end type symba_list_pltp


   type, extends(helio_nbody_system) :: symba_nbody_system
      integer(I4B)  :: irec = -1 !! nbody_system recursion level
   contains
      procedure :: dealloic         => symba_util_dealloc_system          !! Deallocates all allocatables
      procedure :: initialize       => symba_util_setup_initialize_system !! Performs SyMBA-specific initilization steps
      procedure :: step             => symba_step_system                  !! Advance the SyMBA nbody system forward in time by one step
      procedure :: interp           => symba_step_interp_system           !! Perform an interpolation step on the SymBA nbody system 
      procedure :: set_recur_levels => symba_step_set_recur_levels_system !! Sets recursion levels of bodies and encounter lists to the current nbody_system level
      procedure :: recursive_step   => symba_step_recur_system            !! Step interacting planets and active test particles ahead in democratic heliocentric coordinates at the current recursion level, if applicable, and descend to the next deeper level if necessary
      procedure :: reset            => symba_step_reset_system            !! Resets pl, tp,and encounter structures at the start of a new step 
   end type symba_nbody_system

   interface
      module subroutine symba_discard_pl(self, nbody_system, param)
         implicit none
         class(symba_pl),              intent(inout) :: self   !! SyMBA test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      end subroutine symba_discard_pl

      module subroutine symba_drift_pl(self, nbody_system, param, dt)
         implicit none
         class(symba_pl),              intent(inout) :: self   !! Helio massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Stepsize
      end subroutine symba_drift_pl
   
      module subroutine symba_drift_tp(self, nbody_system, param, dt)
         implicit none
         class(symba_tp),              intent(inout) :: self   !! Helio massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Stepsize
      end subroutine symba_drift_tp

      module function symba_encounter_check_pl(self, param, nbody_system, dt, irec) result(lany_encounter)
         implicit none
         class(symba_pl),            intent(inout) :: self           !! SyMBA test particle object  
         class(swiftest_parameters), intent(inout) :: param          !! Current Swiftest run configuration parameters
         class(symba_nbody_system),  intent(inout) :: nbody_system         !! SyMBA nbody system object
         real(DP),                   intent(in)    :: dt             !! step size
         integer(I4B),               intent(in)    :: irec           !! Current recursion level
         logical                                   :: lany_encounter !! Returns true if there is at least one close encounter      
      end function symba_encounter_check_pl

      module function symba_encounter_check_list_plpl(self, param, nbody_system, dt, irec) result(lany_encounter)
         implicit none
         class(symba_list_plpl),     intent(inout) :: self           !! SyMBA pl-pl encounter list object
         class(swiftest_parameters), intent(inout) :: param          !! Current Swiftest run configuration parameters
         class(symba_nbody_system),  intent(inout) :: nbody_system         !! SyMBA nbody system object
         real(DP),                   intent(in)    :: dt             !! step size
         integer(I4B),               intent(in)    :: irec           !! Current recursion level 
         logical                                   :: lany_encounter !! Returns true if there is at least one close encounter      
      end function symba_encounter_check_list_plpl

      module function symba_encounter_check_list_pltp(self, param, nbody_system, dt, irec) result(lany_encounter)
         implicit none
         class(symba_list_pltp),     intent(inout) :: self           !! SyMBA pl-tp encounter list object
         class(swiftest_parameters), intent(inout) :: param          !! Current Swiftest run configuration parameters
         class(symba_nbody_system),  intent(inout) :: nbody_system         !! SyMBA nbody system object
         real(DP),                   intent(in)    :: dt             !! step size
         integer(I4B),               intent(in)    :: irec           !! Current recursion level 
         logical                                   :: lany_encounter !! Returns true if there is at least one close encounter      
      end function symba_encounter_check_list_pltp

      module function symba_encounter_check_tp(self, param, nbody_system, dt, irec) result(lany_encounter)
         implicit none
         class(symba_tp),            intent(inout) :: self           !! SyMBA test particle object  
         class(swiftest_parameters), intent(inout) :: param          !! Current Swiftest run configuration parameters
         class(symba_nbody_system),  intent(inout) :: nbody_system         !! SyMBA nbody system object
         real(DP),                   intent(in)    :: dt             !! step size
         integer(I4B),               intent(in)    :: irec           !! Current recursion level 
         logical                                   :: lany_encounter !! Returns true if there is at least one close encounter      
      end function symba_encounter_check_tp

      pure module subroutine symba_gr_p4_pl(self, nbody_system, param, dt)
         implicit none
         class(symba_pl),              intent(inout) :: self   !! SyMBA massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Step size
      end subroutine symba_gr_p4_pl
   
      pure module subroutine symba_gr_p4_tp(self, nbody_system, param, dt)
         implicit none
         class(symba_tp),              intent(inout) :: self   !! SyMBA test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Step size
      end subroutine symba_gr_p4_tp

      module subroutine symba_util_set_renc(self, scale)
         implicit none
         class(symba_pl), intent(inout) :: self !! SyMBA massive body object
         integer(I4B),    intent(in)    :: scale !! Current recursion depth
      end subroutine symba_util_set_renc
   
      module subroutine symba_io_param_writer(self, unit, iotype, v_list, iostat, iomsg) 
         implicit none
         class(swiftest_parameters),intent(in)    :: self      !! Current run configuration parameters with SyMBA additions
         integer,                intent(in)    :: unit      !! File unit number
         character(len=*),       intent(in)    :: iotype    !! Dummy argument passed to the  input/output procedure contains the text from the char-literal-constant, prefixed with DT. 
                                                            !!    If you do not include a char-literal-constant, the iotype argument contains only DT.
         integer,                intent(in)    :: v_list(:) !! Not used in this procedure
         integer,                intent(out)   :: iostat    !! IO status code
         character(len=*),       intent(inout) :: iomsg     !! Message to pass if iostat /= 0
      end subroutine symba_io_param_writer

      module subroutine symba_kick_getacch_int_pl(self, param)
         implicit none
         class(symba_pl),            intent(inout) :: self  !! SyMBA massive body object
         class(swiftest_parameters), intent(inout) :: param !! Current Swiftest run configuration parameters
      end subroutine symba_kick_getacch_int_pl

      module subroutine symba_kick_getacch_pl(self, nbody_system, param, t, lbeg)
         implicit none
         class(symba_pl),              intent(inout) :: self   !! SyMBA massive body particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current simulation time
         logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine symba_kick_getacch_pl

      module subroutine symba_kick_getacch_tp(self, nbody_system, param, t, lbeg)
         implicit none
         class(symba_tp),              intent(inout) :: self   !! SyMBA test particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current time
         logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine symba_kick_getacch_tp

      module subroutine symba_kick_list_plpl(self, nbody_system, dt, irec, sgn)
         implicit none
         class(symba_list_plpl),    intent(in)    :: self   !! SyMBA pl-tp encounter list object
         class(symba_nbody_system), intent(inout) :: nbody_system !! SyMBA nbody system object
         real(DP),                  intent(in)    :: dt     !! step size
         integer(I4B),              intent(in)    :: irec   !! Current recursion level
         integer(I4B),              intent(in)    :: sgn    !! sign to be applied to acceleration
      end subroutine symba_kick_list_plpl

      module subroutine symba_kick_list_pltp(self, nbody_system, dt, irec, sgn)
         implicit none
         class(symba_list_pltp),    intent(in)    :: self   !! SyMBA pl-tp encounter list object
         class(symba_nbody_system), intent(inout) :: nbody_system !! SyMBA nbody system object
         real(DP),                  intent(in)    :: dt     !! step size
         integer(I4B),              intent(in)    :: irec   !! Current recursion level
         integer(I4B),              intent(in)    :: sgn    !! sign to be applied to acceleration
      end subroutine symba_kick_list_pltp

      module subroutine symba_util_dealloc_system(self)
         implicit none
         class(symba_nbody_system), intent(inout) :: self
      end subroutine symba_util_dealloc_system


      module subroutine symba_util_setup_initialize_system(self, system_history, param)
         implicit none
         class(symba_nbody_system),               intent(inout) :: self           !! SyMBA nbody_system object
         class(swiftest_storage),    allocatable, intent(inout) :: system_history !! Stores the system history between output dumps
         class(swiftest_parameters),              intent(inout) :: param          !! Current run configuration parameters 
      end subroutine symba_util_setup_initialize_system

      module subroutine symba_util_setup_pl(self, n, param)
         implicit none
         class(symba_pl),            intent(inout) :: self  !! SyMBA massive body object
         integer(I4B),               intent(in)    :: n     !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters
      end subroutine symba_util_setup_pl

      module subroutine symba_util_setup_tp(self, n, param)
         implicit none
         class(symba_tp),            intent(inout) :: self  !! SyMBA test particle object
         integer(I4B),               intent(in)    :: n     !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameter
      end subroutine symba_util_setup_tp

      module subroutine symba_step_system(self, param, t, dt)
         implicit none
         class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system object
         class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t     !! Simulation time
         real(DP),                   intent(in)    :: dt    !! Current stepsize
      end subroutine symba_step_system

      module subroutine symba_step_interp_system(self, param, t, dt)
         implicit none
         class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system object
         class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t     !! Simulation time
         real(DP),                   intent(in)    :: dt    !! Current stepsize
      end subroutine symba_step_interp_system

      module subroutine symba_step_set_recur_levels_system(self, ireci)
         implicit none
         class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system objec
         integer(I4B),               intent(in)    :: ireci !! Input recursion level
      end subroutine symba_step_set_recur_levels_system

      recursive module subroutine symba_step_recur_system(self, param, t, ireci)
         implicit none
         class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system object
         class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t     !! Current simulation time
         integer(I4B),               intent(in)    :: ireci !! input recursion level
      end subroutine symba_step_recur_system

      module subroutine symba_step_reset_system(self, param)
         implicit none
         class(symba_nbody_system), intent(inout) :: self  !! SyMBA nbody system object
         class(swiftest_parameters),   intent(in)    :: param !! Current run configuration parameters with SyMBA additions
      end subroutine symba_step_reset_system

      module subroutine symba_util_append_pl(self, source, lsource_mask)
         implicit none
         class(symba_pl),                 intent(inout) :: self         !! SyMBA massive body object
         class(swiftest_body),            intent(in)    :: source       !! Source object to append
         logical, dimension(:),           intent(in)    :: lsource_mask !! Logical mask indicating which elements to append to
      end subroutine symba_util_append_pl

      module subroutine symba_util_append_tp(self, source, lsource_mask)
         implicit none
         class(symba_tp),                 intent(inout) :: self        !! SyMBA test particle object
         class(swiftest_body),            intent(in)    :: source       !! Source object to append
         logical, dimension(:),           intent(in)    :: lsource_mask !! Logical mask indicating which elements to append to
      end subroutine symba_util_append_tp

      module subroutine symba_util_dealloc_pl(self)
         implicit none
         class(symba_pl),  intent(inout) :: self !! SyMBA massive body object
      end subroutine symba_util_dealloc_pl

      module subroutine symba_util_dealloc_tp(self)
         implicit none
         class(symba_tp),  intent(inout) :: self !! SyMBA test particle object
      end subroutine symba_util_dealloc_tp
   end interface 


   interface
      module subroutine symba_util_fill_pl(self, inserts, lfill_list)
         implicit none
         class(symba_pl),       intent(inout) :: self       !! SyMBA massive body object
         class(swiftest_body),  intent(in)    :: inserts    !! Inserted object 
         logical, dimension(:), intent(in)    :: lfill_list !! Logical array of bodies to merge into the keeps
      end subroutine symba_util_fill_pl

      module subroutine symba_util_fill_tp(self, inserts, lfill_list)
         implicit none
         class(symba_tp),       intent(inout) :: self       !! SyMBA test particle object
         class(swiftest_body),  intent(in)    :: inserts    !! Inserted object 
         logical, dimension(:), intent(in)    :: lfill_list !! Logical array of bodies to merge into the keeps
      end subroutine symba_util_fill_tp

      module subroutine symba_util_flatten_eucl_plpl(self, param)
         implicit none
         class(symba_pl),            intent(inout) :: self  !! SyMBA massive body object
         class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters
      end subroutine symba_util_flatten_eucl_plpl

   end interface

   interface
      module subroutine symba_util_resize_pl(self, nnew)
         implicit none
         class(symba_pl), intent(inout) :: self  !! SyMBA massive body object
         integer(I4B),    intent(in)    :: nnew  !! New size neded
      end subroutine symba_util_resize_pl

      module subroutine symba_util_resize_tp(self, nnew)
         implicit none
         class(symba_tp), intent(inout) :: self  !! SyMBA massive body object
         integer(I4B),    intent(in)    :: nnew  !! New size neded
      end subroutine symba_util_resize_tp

      module subroutine symba_util_sort_pl(self, sortby, ascending)
         implicit none
         class(symba_pl), intent(inout) :: self      !! SyMBA massive body object
         character(*),    intent(in)    :: sortby    !! Sorting attribute
         logical,         intent(in)    :: ascending !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine symba_util_sort_pl 

      module subroutine symba_util_sort_tp(self, sortby, ascending)
         implicit none
         class(symba_tp), intent(inout) :: self      !! SyMBA test particle object
         character(*),    intent(in)    :: sortby    !! Sorting attribute
         logical,         intent(in)    :: ascending !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine symba_util_sort_tp
   end interface

   interface
      module subroutine symba_util_sort_rearrange_pl(self, ind)
         implicit none
         class(symba_pl),               intent(inout) :: self !! SyMBA massive body object
         integer(I4B),    dimension(:), intent(in)    :: ind  !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine symba_util_sort_rearrange_pl

      module subroutine symba_util_sort_rearrange_tp(self, ind)
         implicit none
         class(symba_tp),               intent(inout) :: self !! SyMBA massive body object
         integer(I4B),    dimension(:), intent(in)    :: ind  !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine symba_util_sort_rearrange_tp
   end interface

   interface
      module subroutine symba_util_spill_pl(self, discards, lspill_list, ldestructive)
         implicit none
         class(symba_pl),       intent(inout) :: self         !! SyMBA massive body object
         class(swiftest_body),  intent(inout) :: discards     !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine symba_util_spill_pl

      module subroutine symba_util_spill_tp(self, discards, lspill_list, ldestructive)
         implicit none
         class(symba_tp),       intent(inout) :: self         !! SyMBA test particle object
         class(swiftest_body),  intent(inout) :: discards     !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine symba_util_spill_tp
   end interface

end module symba

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(swiftest) s_swiftest_gr
contains

   pure module subroutine swiftest_gr_kick_getaccb_ns_body(self, nbody_system, param) 
      !! author: David A. Minton
      !!
      !! Add relativistic correction acceleration for non-symplectic integrators.
      !! Based on Quinn et al. (1991) eq. 5
      !!
      !! Reference:  
      !!    Quinn, T.R., Tremaine, S., Duncan, M., 1991. A three million year integration of the earth’s orbit. 
      !!       AJ 101, 2287–2305. https://doi.org/10.1086/115850
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_kick_getaccb_ns.f90
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self   !! Swiftest generic body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      ! Internals
      real(DP)                  :: rmag, rdotv, vmag2
      integer(I4B)              :: i

      associate(n => self%nbody, cb => nbody_system%cb, inv_c2 => param%inv_c2)
         if (n == 0) return
         do i = 1, n
            rmag = norm2(self%rh(:,i))
            vmag2 = dot_product(self%vh(:,i), self%vh(:,i))
            rdotv = dot_product(self%rh(:,i), self%vh(:,i))
            self%agr(:, i) = self%mu * inv_c2 / rmag**3 * ((4 * self%mu(i) / rmag - vmag2) &
                           * self%rh(:,i) + 4 * rdotv * self%vh(:,i))
         end do

         select type(self)
         class is (swiftest_pl)
            cb%agr(:) = 0.0_DP
            do i = n, 1, -1
               cb%agr(:) = cb%agr(:) - self%Gmass(i) * self%agr(:, i) / cb%Gmass
            end do
         end select
      end associate 

      return
   end subroutine swiftest_gr_kick_getaccb_ns_body


   pure module subroutine swiftest_gr_kick_getacch(mu, x, lmask, n, inv_c2, agr) 
      !! author: David A. Minton
      !!
      !! Compute relativisitic accelerations of massive bodies
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_whm_kick_getacch.f90
      implicit none
      ! Arguments
      real(DP), dimension(:),     intent(in)    :: mu     !! Gravitational constant
      real(DP), dimension(:,:),   intent(in)    :: x      !! Position vectors
      logical,  dimension(:),     intent(in)    :: lmask  !! Logical mask indicating which bodies to compute
      integer(I4B),               intent(in)    :: n      !! Total number of bodies
      real(DP),                   intent(in)    :: inv_c2 !! Inverse speed of light squared: 1 / c**2
      real(DP), dimension(:,:),   intent(out)   :: agr    !! Accelerations
      ! Internals
      integer(I4B)                              :: i
      real(DP)                                  :: beta, rjmag4
     
      agr(:,:) = 0.0_DP
#ifdef DOCONLOC
      do concurrent (i = 1:n, lmask(i)) shared(lmask,x,mu,agr,inv_c2) local(rjmag4,beta)
#else
      do concurrent (i = 1:n, lmask(i))
#endif
         rjmag4 = (dot_product(x(:, i), x(:, i)))**2
         beta = -mu(i)**2 * inv_c2 
         agr(:, i) = 2 * beta * x(:, i) / rjmag4
      end do

      return
   end subroutine swiftest_gr_kick_getacch


   pure elemental module subroutine swiftest_gr_p4_pos_kick(inv_c2, rx, ry, rz, vx, vy, vz, dt)
      !! author: David A. Minton
      !!
      !! Position kick due to p**4 term in the post-Newtonian correction
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Reference:
      !!    Saha, P., Tremaine, S., 1994. Long-term planetary integration with individual time steps. 
      !!       AJ 108, 1962–1969. https://doi.org/10.1086/117210
      !!
      !! Adapted from David A. Minton's Swifter routine gr_whm_p4.f90  
      implicit none
      ! Arguments
      real(DP), intent(in)    :: inv_c2     !! One over speed of light squared (1/c**2)
      real(DP), intent(inout) :: rx, ry, rz !! Position vector
      real(DP), intent(in)    :: vx, vy, vz !! Velocity vector
      real(DP), intent(in)    :: dt         !! Step size
      ! Internals
      real(DP) :: drx, dry, drz
      real(DP) :: vmag2

      vmag2 = vx*vx + vy*vy + vz*vz
      drx = -2 * inv_c2 * vmag2 * vx
      dry = -2 * inv_c2 * vmag2 * vy
      drz = -2 * inv_c2 * vmag2 * vz
      rx = rx + drx * dt
      ry = ry + dry * dt
      rz = rz + drz * dt

      return
   end subroutine swiftest_gr_p4_pos_kick


   pure module subroutine swiftest_gr_pseudovel2vel(param, mu, rh, pv, vh) 
      !! author: David A. Minton
      !!
      !! Converts the relativistic pseudovelocity back into a veliocentric velocity
      !!    Based on Saha & Tremaine (1994) Eq. 32
      !! 
      !! Reference:
      !!    Saha, P., Tremaine, S., 1994. Long-term planetary integration with individual time steps. 
      !!       AJ 108, 1962–1969. https://doi.org/10.1086/117210
      !!
      !! Adapted from David A. Minton's Swifter routine gr_pseudovel2vel.f90 
      implicit none
      ! Arguments
      class(swiftest_parameters), intent(in)  :: param !! Current run configuration parameters 
      real(DP),                   intent(in)  :: mu    !! G * (Mcb + m), G = gravitational constant, Mcb = mass of central body, m = mass of body
      real(DP), dimension(:),     intent(in)  :: rh    !! Heliocentric position vector 
      real(DP), dimension(:),     intent(in)  :: pv    !! Pseudovelocity velocity vector - see Saha & Tremain (1994), eq. (32)
      real(DP), dimension(:),     intent(out) :: vh    !! Heliocentric velocity vector 
      ! Internals
      real(DP) :: vmag2, rmag, grterm
   
      associate(inv_c2 => param%inv_c2)
         vmag2 = dot_product(pv(:), pv(:))
         rmag  = norm2(rh(:))
         grterm = 1.0_DP - inv_c2 * (0.5_DP * vmag2 + 3 * mu / rmag)
         vh(:) = pv(:) * grterm
      end associate

      return
   end subroutine swiftest_gr_pseudovel2vel


   pure module subroutine swiftest_gr_pv2vh_body(self, param)
      !! author: David A. Minton
      !!
      !! Wrapper function that converts from pseudovelocity to heliocentric velocity for swiftest bodies
      implicit none
      ! Arguments
      class(swiftest_body),       intent(inout) :: self  !! Swiftest particle object
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters 
      ! Internals
      integer(I4B)                              :: i
      real(DP), dimension(:,:), allocatable     :: vh    !! Temporary holder of pseudovelocity for in-place conversion
      
      associate(n => self%nbody)
         if (n == 0) return
         allocate(vh, mold = self%vh)
         do i = 1, n
            call swiftest_gr_pseudovel2vel(param, self%mu(i), self%rh(:, i), self%vh(:, i), vh(:, i))
         end do
         call move_alloc(vh, self%vh)
      end associate

      return
   end subroutine swiftest_gr_pv2vh_body


   pure module subroutine swiftest_gr_vel2pseudovel(param, mu, rh, vh, pv)
      !! author: David A. Minton
      !!
      !! Converts the heliocentric velocity into a pseudovelocity with relativistic corrections. 
      !! Uses Newton-Raphson method with direct inversion of the Jacobian (yeah, it's slow, but 
      !! this is only done once per run).
      !!
      !! Reference:
      !!    Saha, P., Tremaine, S., 1994. Long-term planetary integration with individual time steps. 
      !!       AJ 108, 1962–1969. https://doi.org/10.1086/117210
      !!
      !! Adapted from David A. Minton's Swifter routine gr_vel2pseudovel.f90
      implicit none
      ! Arguments
      class(swiftest_parameters), intent(in)  :: param !! Current run configuration parameters 
      real(DP),                   intent(in)  :: mu    !! G * (Mcb + m), G = gravitational constant, Mcb = mass of central body, m = mass of body
      real(DP), dimension(:),     intent(in)  :: rh    !! Heliocentric position vector 
      real(DP), dimension(:),     intent(in)  :: vh    !! Heliocentric velocity vector 
      real(DP), dimension(:),     intent(out) :: pv    !! Pseudovelocity vector - see Saha & Tremain (1994), eq. (32)
      ! Internals
      real(DP)                       :: v2, G, pv2, rterm, det
      real(DP), dimension(NDIM,NDIM) :: J,Jinv
      real(DP), dimension(NDIM)      :: F
      integer(I4B)                   :: n,i,k
      integer(I4B), parameter        :: MAXITER = 50
      real(DP),parameter             :: TOL = 1.0e-12_DP

      associate(inv_c2 => param%inv_c2)
         pv(1:NDIM) = vh(1:NDIM) ! Initial guess
         rterm = 3 * mu / norm2(rh(:))
         v2 = dot_product(vh(:), vh(:))
         if (v2 < TINY(1.0_DP)) then
            pv(:) = 0.0_DP
            return
         end if
         do n = 1, MAXITER
            pv2 = dot_product(pv(:), pv(:))
            G = 1.0_DP - inv_c2 * (0.5_DP * pv2 + rterm)
            F(:) = pv(:) * G - vh(:)
            if (abs(sum(F) / v2 ) < TOL) exit ! Root found

            ! Calculate the Jacobian
            do k = 1, NDIM
               do i = 1, NDIM
                  if (i == k) then
                     J(i,k) = G - inv_c2 * pv(k)
                  else
                     J(i,k) = -inv_c2 * pv(k)
                  end if
               end do
            end do

            ! Inverse of the Jacobian
            det = J(1,1) * (J(3,3) * J(2,2) - J(3,2) * J(2,3))
            det = det - J(2,1) * (J(3,3) * J(1,2)-J(3,2) * J(1,3))
            det = det + J(3,1) * (J(2,3) * J(1,2)-J(2,2) * J(1,3))

            Jinv(1,1) =   J(3,3) * J(2,2) - J(3,2) * J(2,3)
            Jinv(1,2) = -(J(3,3) * J(1,2) - J(3,2) * J(1,3))
            Jinv(1,3) =   J(2,3) * J(1,2) - J(2,2) * J(1,3)

            Jinv(2,1) = -(J(3,3) * J(2,1) - J(3,1) * J(2,3))
            Jinv(2,2) =   J(3,3) * J(1,1) - J(3,1) * J(1,3)
            Jinv(2,3) = -(J(2,3) * J(1,1) - J(2,1) * J(1,3))

            Jinv(3,1) =   J(3,2) * J(2,1) - J(3,1) * J(2,2)
            Jinv(3,2) = -(J(3,2) * J(1,1) - J(3,1) * J(1,2))
            Jinv(3,3) =   J(2,2) * J(1,1) - J(2,1) * J(1,2)

            Jinv = Jinv * det

            pv(1) = pv(1) - dot_product(Jinv(1,:), F(:))
            pv(2) = pv(2) - dot_product(Jinv(2,:), F(:))
            pv(3) = pv(3) - dot_product(Jinv(3,:), F(:))
         end do 
      end associate
   
      return
   end subroutine swiftest_gr_vel2pseudovel


   pure module subroutine swiftest_gr_vh2pv_body(self, param)
      !! author: David A. Minton
      !!
      !! Wrapper function that converts from heliocentric velocity to pseudovelocity for Swiftest bodies
      implicit none
      ! Arguments
      class(swiftest_body),       intent(inout) :: self  !! Swiftest particle object
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters 
      ! Internals
      integer(I4B)                                 :: i
      real(DP), dimension(:,:), allocatable        :: pv !! Temporary holder of pseudovelocity for in-place conversion
      
      associate(n => self%nbody)
         if (n == 0) return
         allocate(pv, mold = self%vh)
         do i = 1, n
            call swiftest_gr_vel2pseudovel(param, self%mu(i), self%rh(:, i), self%vh(:, i), pv(:, i))
         end do
         call move_alloc(pv, self%vh)
      end associate

      return
   end subroutine swiftest_gr_vh2pv_body

end submodule s_swiftest_gr

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

program main
   !! author: David A. Minton
   !!
   !! This is used as a wrapper for the swiftest_driver subroutine so that the driver can be used as either
   !! a function call or a standalone executable program.
   use swiftest
   implicit none

   character(len=:), allocatable :: integrator    
         !! Integrator type code (see globals for symbolic names)
   character(len=:), allocatable :: param_file_name 
         !! Name of the file containing user-defined parameters
   character(len=:), allocatable :: display_style 
         !! {"PROGRESS", "CLASSIC", "QUIET", "COMPACT"}). 
         !! Default is "PROGRESS"   

   call swiftest_io_get_args(integrator, param_file_name, display_style, from_cli=.true.)
   call swiftest_driver(integrator, param_file_name, display_style)
   call base_util_exit(SUCCESS)

end program main

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (swiftest) s_swiftest_io
   use symba
   use netcdf
contains

   module subroutine swiftest_io_compact_output(self, param, timer)
      !! author: David Minton
      !!
      !! Generates the terminal output displayed when display_style is set to COMPACT. This is used by the Python driver to 
      !! make nice-looking progress reports.
      implicit none

      interface fmt
         !! author: David Minton
         !!
         !! Formats a pair of variables and corresponding values for the compact display output. Generic interface for different 
         !! variable types to format.
         procedure :: fmt_I4B, fmt_I8B, fmt_DP
      end interface

      ! Arguments
      class(swiftest_nbody_system), intent(in) :: self  !! Swiftest nbody system object   
      class(swiftest_parameters),   intent(in) :: param !! Input colleciton of user-defined parameters
      class(*),                     intent(in) :: timer !! Object used for computing elapsed wall time  (must be unlimited 
                                                        !! polymorphic because the walltimer module requires base)
      ! Internals
      character(len=:), allocatable :: formatted_output

      select type(timer)
      class is (walltimer)
         formatted_output = fmt("ILOOP",param%iloop) // fmt("T",self%t) // fmt("NPL",self%pl%nbody) // fmt("NTP",self%tp%nbody) 
         select type(pl => self%pl)
         class is (symba_pl)
            formatted_output = formatted_output // fmt("NPLM",pl%nplm)
         end select
         if (param%lenergy) then
            formatted_output = formatted_output // fmt("LTOTERR",self%L_total_error) // fmt("ETOTERR",self%te_error) &
                             // fmt("MTOTERR",self%Mtot_error) // fmt("KEOERR",self%ke_orbit_error) // fmt("PEERR",self%pe_error) &
                             // fmt("EORBERR",self%E_orbit_error) // fmt("EUNTRERR",self%E_untracked_error) &
                             // fmt("LESCERR",self%L_escape_error) // fmt("MESCERR",self%Mescape_error)
            if (param%lclose) formatted_output = formatted_output // fmt("ECOLLERR",self%Ecoll_error)
            if (param%lrotation) formatted_output = formatted_output // fmt("KESPINERR",self%ke_spin_error) &
                             // fmt("LSPINERR",self%L_spin_error) 
         end if

         if (.not. timer%main_is_started) then ! This is the start of a new run
            formatted_output =  formatted_output // fmt("WT",0.0_DP) // fmt("IWT",0.0_DP) // fmt("WTPS",0.0_DP) 
         else
            formatted_output = formatted_output // fmt("WT",timer%wall_main) // fmt("IWT",timer%wall_step) &
                                               // fmt("WTPS",timer%wall_per_substep)
         end if
         write(*,*) formatted_output
      end select
      return

      contains

         function fmt_I4B(varname,val) result(pair_string)
            implicit none
            ! Arguments
            character(*), intent(in) :: varname !! The variable name of the pair
            integer(I4B), intent(in) :: val !! A 4-byte integer value
            ! Result
            character(len=:), allocatable :: pair_string
            ! Internals
            character(len=24) :: str_value
      
            write(str_value,*) val
            pair_string = trim(adjustl(varname)) // " " // trim(adjustl(str_value)) // ";"

            return 
         end function fmt_I4B

         function fmt_I8B(varname, val) result(pair_string)
            implicit none
            ! Arguments
            character(*), intent(in) :: varname !! The variable name of the pair
            integer(I8B), intent(in) :: val     !! An 8-byte integer value
            ! Result
            character(len=:), allocatable :: pair_string
            ! Internals
            character(len=24) :: str_value
      
            write(str_value,*) val
            pair_string = trim(adjustl(varname)) // " " // trim(adjustl(str_value)) // ";"

            return 
         end function fmt_I8B

         function fmt_DP(varname, val) result(pair_string)
            implicit none
            ! Arguments
            character(*), intent(in) :: varname !! The variable name of the pair
            real(DP),     intent(in) :: val     !! A double precision floating point value
            ! Result
            character(len=:), allocatable :: pair_string
            ! Internals
            character(len=24) :: str_value
      
            write(str_value,'(ES24.16)') val
            pair_string = trim(adjustl(varname)) // " " // trim(adjustl(str_value)) // ";"

            return 
         end function fmt_DP

   end subroutine swiftest_io_compact_output


   module subroutine swiftest_io_conservation_report(self, param, lterminal)
      !! author: The Purdue Swiftest Team -  David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Reports the current state of energy, mass, and angular momentum conservation in a run
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self      !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param     !! Input colleciton of user-defined parameters
      logical,                      intent(in)    :: lterminal !! Indicates whether to output information to the terminal screen
      ! Internals
      real(DP), dimension(NDIM)       :: L_total_now,  L_orbit_now,  L_spin_now
      real(DP)                        :: ke_orbit_now,  ke_spin_now,  pe_now,  E_orbit_now, be_now, be_cb_now, be_cb_orig, te_now
      real(DP)                        :: GMtot_now
      character(len=*), parameter     :: EGYTERMFMT = '(" DL/L0 = ", ES12.5, "; DE_orbit/|E0| = ", ES12.5,' &
                                                     //'"; DE_total/|E0| = ", ES12.5, "; DM/M0 = ", ES12.5)'

      associate(nbody_system => self, pl => self%pl, cb => self%cb, npl => self%pl%nbody, display_unit => param%display_unit)

         select type(self)
         class is (helio_nbody_system) ! Don't convert vh to vb for Helio-based integrators, because it's already calculated
         class is (whm_nbody_system)
            call pl%vh2vb(cb)
         end select
         call pl%rh2rb(cb)

         call nbody_system%get_energy_and_momentum(param) 
         ke_orbit_now = nbody_system%ke_orbit
         ke_spin_now = nbody_system%ke_spin
         pe_now = nbody_system%pe
         be_now = nbody_system%be
         be_cb_now = nbody_system%be_cb
         te_now = nbody_system%te
         L_orbit_now(:) = nbody_system%L_orbit(:)
         L_spin_now(:) = nbody_system%L_spin(:)
         E_orbit_now = ke_orbit_now + pe_now
         L_total_now(:) = nbody_system%L_total(:) + nbody_system%L_escape(:)
         GMtot_now = nbody_system%GMtot + nbody_system%GMescape 

         if (param%lfirstenergy) then
            nbody_system%ke_orbit_orig = ke_orbit_now
            nbody_system%ke_spin_orig = ke_spin_now
            nbody_system%pe_orig = pe_now
            nbody_system%be_orig = be_now
            nbody_system%te_orig = te_now
            nbody_system%E_orbit_orig = E_orbit_now
            nbody_system%GMtot_orig = GMtot_now
            nbody_system%L_orbit_orig(:) = L_orbit_now(:)
            nbody_system%L_spin_orig(:) = L_spin_now(:)
            nbody_system%L_total_orig(:) = L_total_now(:)
            param%lfirstenergy = .false.
         end if

         if (.not.param%lfirstenergy) then 
            nbody_system%ke_orbit_error = (ke_orbit_now - nbody_system%ke_orbit_orig) / abs(nbody_system%te_orig)
            nbody_system%ke_spin_error = (ke_spin_now - nbody_system%ke_spin_orig) / abs(nbody_system%te_orig)
            nbody_system%pe_error = (pe_now - nbody_system%pe_orig) / abs(nbody_system%te_orig)

            be_cb_orig = -(3 * cb%GM0**2 / param%GU) / (5 * cb%R0)
            nbody_system%be_error = (be_now - nbody_system%be_orig) / abs(nbody_system%te_orig) + (be_cb_now - be_cb_orig) & 
                                    / abs(nbody_system%te_orig)

            if (abs(nbody_system%E_orbit_orig) < 10*tiny(1.0_DP)) then
               nbody_system%E_orbit_error = 0.0_DP
            else
               nbody_system%E_orbit_error = (E_orbit_now - nbody_system%E_orbit_orig) / abs(nbody_system%E_orbit_orig)
            end if
            nbody_system%Ecoll_error = nbody_system%E_collisions / abs(nbody_system%te_orig)
            nbody_system%E_untracked_error = nbody_system%E_untracked / abs(nbody_system%te_orig)
            nbody_system%te_error = (nbody_system%te - nbody_system%te_orig - nbody_system%E_collisions - nbody_system%E_untracked)&
                                   / abs(nbody_system%te_orig) + (be_cb_now - be_cb_orig) / abs(nbody_system%te_orig)

            nbody_system%L_orbit_error = norm2(L_orbit_now(:) - nbody_system%L_orbit_orig(:)) / norm2(nbody_system%L_total_orig(:))
            nbody_system%L_spin_error = norm2(L_spin_now(:) - nbody_system%L_spin_orig(:)) / norm2(nbody_system%L_total_orig(:))
            nbody_system%L_escape_error = norm2(nbody_system%L_escape(:)) / norm2(nbody_system%L_total_orig(:))
            nbody_system%L_total_error = norm2(L_total_now(:) - nbody_system%L_total_orig(:)) / norm2(nbody_system%L_total_orig(:))

            nbody_system%Mescape_error = nbody_system%GMescape / nbody_system%GMtot_orig
#ifdef COARRAY
   if (this_image() == 1 .or. param%log_output) then
#endif 
            if (lterminal) then
               write(display_unit, EGYTERMFMT) nbody_system%L_total_error, nbody_system%E_orbit_error, nbody_system%te_error, &
                                               nbody_system%Mtot_error
               if (param%log_output) flush(display_unit)
            end if

#ifdef COARRAY
   end if ! (this_image() == 1) then
#endif 

            if (abs(nbody_system%Mtot_error) > 100 * epsilon(nbody_system%Mtot_error)) then
               write(*,*) "Severe error! Mass not conserved! Halting!"
               ! Save the frame of data to the bin file in the slot just after the present one for diagnostics
               call base_util_exit(FAILURE,param%display_unit)
            end if
         end if
      end associate

      return
   end subroutine swiftest_io_conservation_report


   module subroutine swiftest_io_display_run_information(self, param, integration_timer, phase)
      !! author:  David A. Minton
      !!
      !! Displays helpful information while a run is executing. The format of the output depends on user parameters
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param !! Current run configuration parameters 
      type(walltimer),              intent(inout) :: integration_timer !! Object used for computing elapsed wall time
      character(len=*), optional,   intent(in)    :: phase !! One of "first" or "last" 
      ! Internals
      integer(I4B)                                   :: phase_val   
      real(DP)                                       :: tfrac             !! Fraction of total simulation time completed
      type(progress_bar), save                       :: pbar              !! Object used to print out a progress bar
      character(len=64)                              :: pbarmessage
#ifdef COARRAY
      character(*), parameter :: co_statusfmt = '("Image: ",I4, "; Time = ", ES12.5, "; fraction done = ", F6.3, ' // & 
                                             '"; Number of active pl, tp = ", I6, ", ", I6)'
      character(*), parameter :: co_symbastatfmt = '("Image: ",I4, "; Image: Time = ", ES12.5, "; fraction done = ", F6.3, ' // &
                                                '"; Number of active pl, plm, tp = ", I6, ", ", I6, ", ", I6)'
#endif
      character(*), parameter :: statusfmt = '("Time = ", ES12.5, "; fraction done = ", F6.3, ' // & 
                                             '"; Number of active pl, tp = ", I6, ", ", I6)'
      character(*), parameter :: symbastatfmt = '("Time = ", ES12.5, "; fraction done = ", F6.3, ' // &
                                                '"; Number of active pl, plm, tp = ", I6, ", ", I6, ", ", I6)'
      character(*), parameter :: pbarfmt = '("Time = ", ES12.5," of ",ES12.5)'

! The following will syncronize the images so that they report in order, and only write to file one at at ime


      phase_val = 1
      if (present(phase)) then
         if (phase == "first") then
            phase_val = 0
         else if (phase == "last") then
            phase_val = -1
         end if
      end if

      tfrac = (self%t - param%t0) / (param%tstop - param%t0)

#ifdef COARRAY
         if (this_image() == 1 .or. param%log_output) then
#endif
         if (phase_val == 0) then
            if (param%lrestart) then
               write(param%display_unit, *) " *************** Swiftest " // VERSION // " restart " // &
                                               trim(adjustl(param%integrator)) // " *************** "
            else
               write(param%display_unit, *) " *************** Swiftest " // VERSION // " start " // &
                                              trim(adjustl(param%integrator)) // " *************** "
            end if
            if (param%display_style == "PROGRESS") then
               call pbar%reset(param%nloops)
            else if (param%display_style == "COMPACT") then
               write(*,*) "SWIFTEST START " // trim(adjustl(param%integrator))
            end if
         end if
#ifdef COARRAY
         end if !(this_image() == 1)
#endif

      if (param%display_style == "PROGRESS") then
#ifdef COARRAY
         if (this_image() == 1) then
#endif
            write(pbarmessage,fmt=pbarfmt) self%t, param%tstop
            call pbar%update(param%iloop,message=pbarmessage)
#ifdef COARRAY
         end if !(this_image() == 1)
#endif
      else if (param%display_style == "COMPACT") then
         call self%compact_output(param,integration_timer)
      end if

      if (param%lmtiny_pl) then
#ifdef COARRAY
         if (param%lcoarray) then
            write(param%display_unit, co_symbastatfmt) this_image(),self%t, tfrac, self%pl%nbody, self%pl%nplm, self%tp%nbody
         else
#endif
            write(param%display_unit, symbastatfmt) self%t, tfrac, self%pl%nbody, self%pl%nplm, self%tp%nbody
#ifdef COARRAY
         end if
#endif
      else
#ifdef COARRAY
         if (param%lcoarray) then
            write(param%display_unit, co_statusfmt) this_image(),self%t, tfrac, self%pl%nbody, self%tp%nbody
         else
#endif
            write(param%display_unit, statusfmt) self%t, tfrac, self%pl%nbody, self%tp%nbody
#ifdef COARRAY
         end if
#endif
      end if

#ifdef COARRAY
      if (this_image() == num_images() .or. param%log_output) then
#endif
         if (phase_val == -1) then
            write(param%display_unit, *)" *************** Swiftest stop " // trim(adjustl(param%integrator)) // " *************** "
            if (param%display_style == "COMPACT") write(*,*) "SWIFTEST STOP" // trim(adjustl(param%integrator))
            if (param%log_output) close(param%display_unit)
         end if

#ifdef COARRAY
      end if ! this_image() == num_images()
      if (param%log_output) flush(param%display_unit)
#endif

      return
   end subroutine swiftest_io_display_run_information


   module subroutine swiftest_io_dump_param(self, param_file_name)
      !! author: David A. Minton
      !!
      !! Dump integration parameters to file
      !!
      !! Adapted from David E. Kaufmann's Swifter routine io_dump_param.f90
      !! Adapted from Martin Duncan's Swift routine io_dump_param.f
      implicit none
      ! Arguments
      class(swiftest_parameters),intent(in) :: self    !! Output collection of parameters
      character(len=*),          intent(in) :: param_file_name !! Parameter input file name (i.e. param.in)
      ! Internals
      character(STRMAX)        :: errmsg !! Error message in UDIO procedure
      integer(I4B)             :: ierr

      open(unit = LUN, file = param_file_name, status='replace', form = 'FORMATTED', err = 667, iomsg = errmsg)
      !! todo: Currently this procedure does not work in user-defined derived-type input mode 
      !!    due to compiler incompatabilities
      !write(LUN,'(DT)') param
      call self%writer(LUN, iotype = "none", v_list = [0], iostat = ierr, iomsg = errmsg)
      if (ierr == 0) then
         close(LUN, err = 667, iomsg = errmsg)
         return
      end if

      667 continue
      write(*,*) "Error opening parameter dump file " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,self%display_unit)
   end subroutine swiftest_io_dump_param


   module subroutine swiftest_io_dump_system(self, param, system_history)
      !! author: David A. Minton
      !!
      !! Dumps the state of the nbody_system to files in case the simulation is interrupted.
      !! As a safety mechanism, there are two dump files that are written in alternating order
      !! so that if a dump file gets corrupted during writing, the user can restart from the older one.
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self  !! Swiftest nbody_system object
      class(swiftest_parameters),   intent(inout) :: param !! Current run configuration parameters 
      class(swiftest_storage),      intent(inout) :: system_history    !! Stores the system history between output dumps
      ! Internals
      class(swiftest_parameters), allocatable :: param_restart !! Local parameters variable used to parameters change input file 
                                                               !! names to dump file-specific values without changing the 
                                                               !! user-defined values
      character(len=:), allocatable :: param_file_name
      character(len=STRMAX) :: time_text
   
      ! Dump the encounter history if necessary
      if (param%lenc_save_trajectory &
         .or. param%lenc_save_closest &
         .and. allocated(self%encounter_history)) &
            call self%encounter_history%dump(param)
      if (allocated(self%collision_history)) call self%collision_history%dump(param)

      ! Dump the nbody_system history to file
      call system_history%dump(param)

#ifdef COARRAY
      if (this_image() == 1) then
#endif 
         allocate(param_restart, source=param)
         param_restart%in_form  = "XV"
         param_restart%out_stat = 'APPEND'
         param_restart%in_type = "NETCDF_DOUBLE"
         param_restart%nc_in = param%outfile
         param_restart%lrestart = .true.
         param_restart%tstart = self%t
         param_file_name    = trim(adjustl(PARAM_RESTART_FILE))
         call param_restart%dump(param_file_name)
         write(time_text,'(I0.20)') param%iloop
         param_file_name = "param." // trim(adjustl(time_text)) // ".in"
         call param_restart%dump(param_file_name)
#ifdef COARRAY
      end if ! (this_image() == 1) 
#endif 
      return
   end subroutine swiftest_io_dump_system


   module subroutine swiftest_io_dump_storage(self, param)
      !! author: David A. Minton
      !!
      !! Dumps the time history of the simulation to file. Each time it writes a frame to file, it deallocates the nbody_system
      !! object from inside. It will only dump frames with systems that are allocated, so this can be called at the end of
      !! a simulation for cases when the number of saved frames is not equal to the dump cadence (for instance, if the dump
      !! cadence is not divisible by the total number of loops).
      implicit none
      ! Arguments
      class(swiftest_storage),   intent(inout)        :: self   !! Swiftest simulation history storage object
      class(swiftest_parameters),   intent(inout)     :: param  !! Current run configuration parameters 
      ! Internals
      integer(I4B) :: i
#ifdef COARRAY
      type(walltimer) :: iotimer
#endif

      if (self%iframe == 0) return
      call self%make_index_map()
      associate(nc => self%nc)
#ifdef COARRAY
         sync all
         write(param%display_unit,*) "File output started"
         call iotimer%start()
         critical
#endif
         call nc%open(param)
         do i = 1, self%iframe
            ! Writing files is more efficient if we write out the common frames from each image before going to the next frame
            if (allocated(self%frame(i)%item)) then
               select type(nbody_system => self%frame(i)%item)
               class is (swiftest_nbody_system)
                  call nbody_system%write_frame(nc, param)
               end select
               deallocate(self%frame(i)%item)
            end if
         end do
         call nc%close()
#ifdef COARRAY  
         end critical
         call iotimer%stop()
         sync all
         call iotimer%report(message="File output :", unit=param%display_unit)
         flush(param%display_unit)
#endif
      end associate

      call self%reset()
      return
   end subroutine swiftest_io_dump_storage


   module subroutine swiftest_io_get_args(integrator, param_file_name, display_style, from_cli)
      !! author: David A. Minton
      !!
      !! Reads in the name of the parameter file from command line arguments. 
      implicit none
      ! Arguments
      character(len=:), intent(inout), allocatable :: integrator      !! Symbolic code of the requested integrator  
      character(len=:), intent(inout), allocatable :: param_file_name !! Name of the input parameters file
      character(len=:), intent(inout), allocatable :: display_style   !! Style of the output display 
                                                                      !! {"STANDARD", "COMPACT", "PROGRESS"}). Default is "STANDARD"
      logical,          intent(in)                 :: from_cli        !! If true, get command-line arguments. Otherwise, use the 
                                                                      !! values of the input variables
      ! Internals
      character(len=STRMAX), dimension(:), allocatable :: arg
      character(len=STRMAX), dimension(3)              :: tmp_arg
      integer(I4B), dimension(:), allocatable :: ierr
      integer :: i,narg

      if (from_cli) then
         narg = command_argument_count() 
         if (narg > 0) then
            allocate(arg(narg),ierr(narg))
            do i = 1,narg
               call get_command_argument(i, arg(i), status = ierr(i))
            end do
            if (any(ierr /= 0)) call base_util_exit(USAGE)
         else
            call base_util_exit(USAGE)
         end if
      else
         narg = 0
         if (len(integrator) > 0) then
            narg = narg + 1
            tmp_arg(narg) = integrator
         end if
         if (len(param_file_name) > 0) then
            narg = narg + 1
            tmp_arg(narg) = param_file_name
         end if
         if (len(display_style) > 0) then
            narg = narg + 1
            tmp_arg(narg) = display_style
         end if
         allocate(arg(narg))
         arg(1:narg) = tmp_arg(1:narg)
         deallocate(integrator, param_file_name, display_style)
      end if
   
      if (narg == 1) then
         if (arg(1) == '-v' .or. arg(1) == '--version') then
            call swiftest_util_version() 
         else if (arg(1) == '-h' .or. arg(1) == '--help') then
            call base_util_exit(HELP)
         else
            call base_util_exit(USAGE)
         end if
      else if (narg >= 2) then
         call swiftest_io_toupper(arg(1))
         select case(arg(1))
         case('BS')
            integrator = INT_BS
         case('HELIO')
            integrator = INT_HELIO
         case('RA15')
            integrator = INT_RA15
         case('TU4')
            integrator = INT_TU4
         case('WHM')
            integrator = INT_WHM
         case('RMVS')
            integrator = INT_RMVS
         case('SYMBA')
            integrator = INT_SYMBA
         case('RINGMOONS')
            integrator = INT_RINGMOONS
         case default
            integrator = UNKNOWN_INTEGRATOR
            write(*,*) trim(adjustl(arg(1))) // ' is not a valid integrator.'
            call base_util_exit(USAGE)
         end select
         param_file_name = trim(adjustl(arg(2)))
      end if

      if (narg == 2) then
         display_style = "STANDARD"
      else if (narg == 3) then
         call swiftest_io_toupper(arg(3))
         display_style = trim(adjustl(arg(3)))
      else
         call base_util_exit(USAGE)
      end if

      return
   end subroutine swiftest_io_get_args


   module function swiftest_io_get_token(buffer, ifirst, ilast, ierr) result(token)
      !! author: David A. Minton
      !!
      !! Retrieves a character token from an input string. Here a token is defined as any set of contiguous non-blank characters not
      !! beginning with or containing "!". If "!" is present, any remaining part of the buffer including the "!" is ignored
      !!
      !! Adapted from David E. Kaufmann's Swifter routine swiftest_io_get_token.f90
      implicit none
      ! Arguments
      character(len=*), intent(in)    :: buffer         !! Input string buffer
      integer(I4B),     intent(inout) :: ifirst         !! Index of the buffer at which to start the search for a token
      integer(I4B),     intent(out)   :: ilast          !! Index of the buffer at the end of the returned token
      integer(I4B),     intent(out)   :: ierr           !! Error code
      ! Result
      character(len=:), allocatable   :: token          !! Returned token string
      ! Internals
      integer(I4B) :: i,ilength
   
      ilength = len(buffer)
   
      if (ifirst > ilength) then
          ilast = ifirst
          ierr = -1 !! Bad input
          token = ''
          return
      end if
      do i = ifirst, ilength
          if (buffer(i:i) /= ' ') exit
      end do
      if ((i > ilength) .or. (buffer(i:i) == '!')) then
          ifirst = i
          ilast = i
          ierr = -2 !! No valid token
          token = ''
          return
      end if
      ifirst = i
      do i = ifirst, ilength
          if ((buffer(i:i) == ' ') .or. (buffer(i:i) == '!')) exit
      end do
      ilast = i - 1
      ierr = 0
   
      token = buffer(ifirst:ilast)

      return
   end function swiftest_io_get_token


   module subroutine swiftest_io_log_one_message(file, message)
      !! author: David A. Minton
      !!
      !! Writes a single message to a log file
      implicit none
      ! Arguments
      character(len=*), intent(in) :: file   !! Name of file to log
      character(len=*), intent(in) :: message
      ! Internals
      character(STRMAX) :: errmsg

      open(unit=LUN, file=trim(adjustl(file)), status = 'OLD', position = 'APPEND', form = 'FORMATTED', err = 667, iomsg = errmsg)
      write(LUN, *) trim(adjustl(message)) 
      close(LUN)

      return
      667 continue
      write(*,*) "Error writing message to log file: " // trim(adjustl(errmsg))
   end subroutine swiftest_io_log_one_message


   module subroutine swiftest_io_log_start(param, file, header)
      !! author: David A. Minton
      !!
      !! Checks to see if a log file needs to be created if this is a new run, or appended if this is a restarted run
      implicit none
      ! Arguments
      class(swiftest_parameters), intent(in) :: param  !! Current Swiftest run configuration parameters
      character(len=*),           intent(in) :: file   !! Name of file to log
      character(len=*),           intent(in) :: header !! Header to print at top of log file
      ! Internals
      character(STRMAX) :: errmsg
      logical           :: fileExists

      inquire(file=trim(adjustl(file)), exist=fileExists)
      if (.not.param%lrestart .or. .not.fileExists) then
         open(unit=LUN, file=file, status="REPLACE", err = 667, iomsg = errmsg)
         write(LUN, *, err = 667, iomsg = errmsg) trim(adjustl(header))
      end if
      close(LUN)

      return

      667 continue
      write(*,*) "Error writing log file: " // trim(adjustl(errmsg))
   end subroutine swiftest_io_log_start


   module subroutine swiftest_io_netcdf_flush(self, param)
      !! author: David A. Minton
      !!
      !! Flushes the current buffer to disk by closing and re-opening the file.
      !!    
      implicit none
      ! Arguments
      class(swiftest_netcdf_parameters), intent(inout) :: self !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters 

      call self%close()
      call self%open(param,readonly=.false.)

      return
   end subroutine swiftest_io_netcdf_flush


   module subroutine swiftest_io_netcdf_get_t0_values_system(self, nc, param) 
      !! author: David A. Minton
      !!
      !! Gets the t0 values of various parameters such as energy and momentum
      !!
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self
      class(swiftest_netcdf_parameters), intent(inout) :: nc     !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param
      ! Internals
      integer(I4B)                              :: itmax, idmax, tslot, status
      real(DP), dimension(:), allocatable       :: vals
      logical, dimension(:), allocatable        :: plmask, tpmask
      real(DP), dimension(1)                    :: rtemp
      real(DP), dimension(NDIM)                 :: rot0, Ip0, L
      real(DP) :: mass0

      associate (cb => self%cb)
         call nc%open(param, readonly=.true.)
         call nc%find_tslot(param%t0, tslot)
         call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%time_dimid, len=itmax), "netcdf_io_get_t0_values_system time_dimid")
         call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%name_dimid, len=idmax), "netcdf_io_get_t0_values_system name_dimid")
         allocate(vals(idmax))
         call netcdf_io_check( nf90_get_var(nc%id, nc%time_varid, rtemp, start=[tslot], count=[1]), &
                              "netcdf_io_get_t0_values_system time_varid" )

         if (param%lenergy) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%KE_orb_varid, rtemp, start=[tslot], count=[1]), & 
                                  "netcdf_io_get_t0_values_system KE_orb_varid" )
            self%ke_orbit_orig = rtemp(1)

            call netcdf_io_check( nf90_get_var(nc%id, nc%KE_spin_varid, rtemp, start=[tslot], count=[1]), &
                                 "netcdf_io_get_t0_values_system KE_spin_varid" )
            self%ke_spin_orig = rtemp(1)

            call netcdf_io_check( nf90_get_var(nc%id, nc%PE_varid, rtemp, start=[tslot], count=[1]), &
                                  "netcdf_io_get_t0_values_system PE_varid" )
            self%pe_orig = rtemp(1)

            call netcdf_io_check( nf90_get_var(nc%id, nc%BE_varid, rtemp, start=[tslot], count=[1]), &
                                  "netcdf_io_get_t0_values_system BE_varid" )
            self%be_orig = rtemp(1)
            
            call netcdf_io_check( nf90_get_var(nc%id, nc%TE_varid, rtemp, start=[tslot], count=[1]), &
                                  "netcdf_io_get_t0_values_system TE_varid" )
            self%te_orig = rtemp(1)

            self%E_orbit_orig = self%ke_orbit_orig + self%pe_orig

            call netcdf_io_check( nf90_get_var(nc%id, nc%L_orbit_varid, self%L_orbit_orig(:), start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_get_t0_values_system L_orbit_varid" )
            call netcdf_io_check( nf90_get_var(nc%id, nc%L_spin_varid, self%L_spin_orig(:), start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_get_t0_values_system L_spin_varid" )

            self%L_total_orig(:) = self%L_orbit_orig(:) + self%L_spin_orig(:) 

            call netcdf_io_check( nf90_get_var(nc%id, nc%Gmass_varid, vals, start=[1,tslot], count=[idmax,1]), &
                                  "netcdf_io_get_t0_values_system Gmass_varid" )
            call nc%get_valid_masks(plmask,tpmask)
            self%GMtot_orig = vals(1) + sum(vals(2:idmax), plmask(:))

            cb%GM0 = vals(1)
            cb%dGM = cb%Gmass - cb%GM0
            mass0 = cb%GM0 / param%GU

            call netcdf_io_check( nf90_get_var(nc%id, nc%radius_varid, rtemp, start=[1,tslot], count=[1,1]), &
                                  "netcdf_io_get_t0_values_system radius_varid" )
            cb%R0 = rtemp(1) 

            if (param%lrotation) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%rot_varid, rot0, start=[1,1,tslot], count=[NDIM,1,1]), &
                                     "netcdf_io_get_t0_values_system rot_varid" )
               rot0(:) = rot0(:) * DEG2RAD
               call netcdf_io_check( nf90_get_var(nc%id, nc%Ip_varid, Ip0, start=[1,1,tslot], count=[NDIM,1,1]), &
                                     "netcdf_io_get_t0_values_system Ip_varid" )
               cb%L0(:) = Ip0(3) * mass0 * cb%R0**2 * rot0(:)
               L(:) = cb%Ip(3) * cb%mass * cb%radius**2 * cb%rot(:)
               cb%dL(:) = L(:) - cb%L0

               status = nf90_inq_varid(nc%id, nc%j2rp2_varname, nc%j2rp2_varid)
               if (status == NF90_NOERR) then
                  call netcdf_io_check( nf90_get_var(nc%id, nc%j2rp2_varid, cb%j2rp2, start=[tslot]), &
                                        "netcdf_io_get_t0_values_system nf90_getvar j2rp2_varid"  )
               else 
                  cb%j2rp2 = 0.0_DP
               end if
      
               status = nf90_inq_varid(nc%id, nc%j4rp4_varname, nc%j4rp4_varid)   
               if (status == NF90_NOERR) then      
                  call netcdf_io_check( nf90_get_var(nc%id, nc%j4rp4_varid, cb%j4rp4, start=[tslot]), &
                                        "netcdf_io_get_t0_values_system nf90_getvar j4rp4_varid"  )
               else 
                  cb%j4rp4 = 0.0_DP
               end if

            end if

            ! Retrieve the current bookkeeping variables
            call nc%find_tslot(self%t, tslot)
            call netcdf_io_check( nf90_get_var(nc%id, nc%L_escape_varid, self%L_escape(:),  start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_get_t0_values_system L_escape_varid" )
            call netcdf_io_check( nf90_get_var(nc%id, nc%GMescape_varid,    self%GMescape,    start=[tslot]), &
                                  "netcdf_io_get_t0_values_system GMescape_varid" )
            call netcdf_io_check( nf90_get_var(nc%id, nc%E_collisions_varid, self%E_collisions, start=[tslot]), &
                                  "netcdf_io_get_t0_values_system E_collisions_varid" )
            call netcdf_io_check( nf90_get_var(nc%id, nc%E_untracked_varid,  self%E_untracked,  start=[tslot]), &
                                   "netcdf_io_get_t0_values_system E_untracked_varid" )

         end if

         deallocate(vals)
         call nc%close()
      end associate
      
      return
   end subroutine swiftest_io_netcdf_get_t0_values_system


   module subroutine swiftest_io_netcdf_initialize_output(self, param)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Initialize a NetCDF file nbody_system and defines all variables.
      use, intrinsic :: ieee_arithmetic
      implicit none
      ! Arguments
      class(swiftest_netcdf_parameters), intent(inout) :: self  !! Parameters used to for writing a NetCDF dataset to file
      class(swiftest_parameters),        intent(in)    :: param !! Current run configuration parameters 
      ! Internals
      integer(I4B) :: nvar, varid, vartype
      integer(I4B) :: status
      real(DP) :: dfill
      real(SP) :: sfill
      integer(I4B), parameter :: NO_FILL = 0
      logical :: fileExists
      character(len=STRMAX) :: errmsg
      integer(I4B) :: i, ndims

      associate(nc => self)

         dfill = ieee_value(dfill, IEEE_QUIET_NAN)
         sfill = ieee_value(sfill, IEEE_QUIET_NAN)

         select case (param%out_type)
         case("NETCDF_FLOAT")
            nc%out_type = NF90_FLOAT
         case("NETCDF_DOUBLE")
            nc%out_type = NF90_DOUBLE
         case default
            write(*,*) trim(adjustl(param%out_type)), " is an invalid OUT_TYPE"
         end select

         ! Check if the file exists, and if it does, delete it
         inquire(file=nc%file_name, exist=fileExists)
         if (fileExists) then
            open(unit=LUN, file=nc%file_name, status="old", err=667, iomsg=errmsg)
            close(unit=LUN, status="delete")
         end if

         ! Create the file
         call netcdf_io_check( nf90_create(nc%file_name, NF90_NETCDF4, nc%id), "netcdf_io_initialize_output nf90_create" )
         nc%lfile_is_open = .true.

         ! Dimensions
         call netcdf_io_check( nf90_def_dim(nc%id, nc%time_dimname, NF90_UNLIMITED, nc%time_dimid), &
                               "netcdf_io_initialize_output nf90_def_dim time_dimid" ) ! Simulation time dimension
         call netcdf_io_check( nf90_def_dim(nc%id, nc%space_dimname, NDIM, nc%space_dimid), &
                               "netcdf_io_initialize_output nf90_def_dim space_dimid" ) ! 3D space dimension
         call netcdf_io_check( nf90_def_dim(nc%id, nc%name_dimname, NF90_UNLIMITED, nc%name_dimid), &
                               "netcdf_io_initialize_output nf90_def_dim name_dimid" ) ! dimension to store particle id numbers
         call netcdf_io_check( nf90_def_dim(nc%id, nc%str_dimname, NAMELEN, nc%str_dimid), &
                               "netcdf_io_initialize_output nf90_def_dim str_dimid"  )  ! Dimension for string variables 
        

         ! Dimension coordinates
         call netcdf_io_check( nf90_def_var(nc%id, nc%time_dimname, nc%out_type, nc%time_dimid, nc%time_varid), &
                              "netcdf_io_initialize_output nf90_def_var time_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%space_dimname, NF90_CHAR, nc%space_dimid, nc%space_varid), &
                               "netcdf_io_initialize_output nf90_def_var space_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%name_dimname, NF90_CHAR, [nc%str_dimid, nc%name_dimid], nc%name_varid), &
                               "netcdf_io_initialize_output nf90_def_var name_varid"  )

         ! Variables
         call netcdf_io_check( nf90_def_var(nc%id, nc%id_varname, NF90_INT, nc%name_dimid, nc%id_varid), &
                               "netcdf_io_initialize_output nf90_def_var id_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%status_varname, NF90_INT, [nc%name_dimid, nc%time_dimid], nc%status_varid), &
                               "netcdf_io_initialize_output nf90_def_var status_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%npl_varname, NF90_INT, nc%time_dimid, nc%npl_varid), &
                               "netcdf_io_initialize_output nf90_def_var npl_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%ntp_varname, NF90_INT, nc%time_dimid, nc%ntp_varid), &
                               "netcdf_io_initialize_output nf90_def_var ntp_varid"  )
         if (param%lmtiny_pl) call netcdf_io_check( nf90_def_var(nc%id, nc%nplm_varname, NF90_INT, nc%time_dimid, nc%nplm_varid), &
                               "netcdf_io_initialize_output nf90_def_var nplm_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%ptype_varname, NF90_CHAR, [nc%str_dimid, nc%name_dimid], nc%ptype_varid), &
                               "netcdf_io_initialize_output nf90_def_var ptype_varid"  )

         if ((param%out_form == "XV") .or. (param%out_form == "XVEL")) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%rh_varname,  nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                                  nc%rh_varid), "netcdf_io_initialize_output nf90_def_var rh_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%vh_varname,  nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                                 nc%vh_varid), "netcdf_io_initialize_output nf90_def_var vh_varid"  )

            !! When GR is enabled, we need to save the pseudovelocity vectors in addition to the true heliocentric velocity vectors,
            !! otherwise we cannnot expect bit-identical runs from restarted runs with GR enabled due to floating point errors 
            !! during the conversion.
            if (param%lgr) then
               call netcdf_io_check( nf90_def_var(nc%id, nc%gr_pseudo_vh_varname, nc%out_type, &
                                     [nc%space_dimid, nc%name_dimid, nc%time_dimid], nc%gr_pseudo_vh_varid), &
                                     "netcdf_io_initialize_output nf90_def_var gr_psuedo_vh_varid"  )
               nc%lpseudo_vel_exists = .true.
            end if

         end if
      
         if ((param%out_form == "EL") .or. (param%out_form == "XVEL")) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%a_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%a_varid), &
                                  "netcdf_io_initialize_output nf90_def_var a_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%e_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%e_varid), &
                                  "netcdf_io_initialize_output nf90_def_var e_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%inc_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%inc_varid), &
                                  "netcdf_io_initialize_output nf90_def_var inc_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%capom_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], &
                                               nc%capom_varid), &
                                  "netcdf_io_initialize_output nf90_def_var capom_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%omega_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], &
                                               nc%omega_varid), &
                                  "netcdf_io_initialize_output nf90_def_var omega_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%capm_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], &
                                               nc%capm_varid), &
                                  "netcdf_io_initialize_output nf90_def_var capm_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%varpi_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], &
                                               nc%varpi_varid), &
                                  "netcdf_io_initialize_output nf90_def_var varpi_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%lam_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%lam_varid), &
                                  "netcdf_io_initialize_output nf90_def_var lam_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%f_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%f_varid), &
                                  "netcdf_io_initialize_output nf90_def_var f_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%cape_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%cape_varid),&
                                  "netcdf_io_initialize_output nf90_def_var cape_varid"  )
         end if

         call netcdf_io_check( nf90_def_var(nc%id, nc%Gmass_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%Gmass_varid), &
                                  "netcdf_io_initialize_output nf90_def_var Gmass_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%mass_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%mass_varid), &
                                  "netcdf_io_initialize_output nf90_def_var mass_varid"  )
         call netcdf_io_check( nf90_def_var(nc%id, nc%rhill_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%rhill_varid), &
                                  "netcdf_io_initialize_output nf90_def_var rhill_varid"  )

         if (param%lclose) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%radius_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], &
                                               nc%radius_varid), &
                                  "netcdf_io_initialize_output nf90_def_var radius_varid"  )

            call netcdf_io_check( nf90_def_var(nc%id, nc%origin_time_varname, nc%out_type, nc%name_dimid, nc%origin_time_varid), &
                                  "netcdf_io_initialize_output nf90_def_var origin_time_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%origin_type_varname, NF90_CHAR, [nc%str_dimid, nc%name_dimid], &
                                    nc%origin_type_varid), &
                                  "netcdf_io_initialize_output nf90_create"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%origin_rh_varname, nc%out_type, [nc%space_dimid, nc%name_dimid], &
                                               nc%origin_rh_varid), &
                                  "netcdf_io_initialize_output nf90_def_var origin_rh_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%origin_vh_varname, nc%out_type, [nc%space_dimid, nc%name_dimid], &
                                               nc%origin_vh_varid), &
                                  "netcdf_io_initialize_output nf90_def_var origin_vh_varid"  )

            call netcdf_io_check( nf90_def_var(nc%id, nc%collision_id_varname, NF90_INT, nc%name_dimid, nc%collision_id_varid), &
                                  "netcdf_io_initialize_output nf90_def_var collision_id_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%discard_time_varname, nc%out_type, nc%name_dimid, nc%discard_time_varid), &
                                  "netcdf_io_initialize_output nf90_def_var discard_time_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%discard_rh_varname, nc%out_type, [nc%space_dimid, nc%name_dimid], &
                                               nc%discard_rh_varid), &
                                  "netcdf_io_initialize_output nf90_def_var discard_rh_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%discard_vh_varname, nc%out_type, [nc%space_dimid, nc%name_dimid], &
                                               nc%discard_vh_varid), &
                                  "netcdf_io_initialize_output nf90_def_var discard_vh_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%discard_body_id_varname, NF90_INT, nc%name_dimid, &
                                               nc%discard_body_id_varid), &
                                  "netcdf_io_initialize_output nf90_def_var discard_body_id_varid"  )
         end if

         if (param%lrotation) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%Ip_varname, nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                                  nc%Ip_varid), "netcdf_io_initialize_output nf90_def_var Ip_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%rot_varname, nc%out_type, [nc%space_dimid, nc%name_dimid, nc%time_dimid], &
                                   nc%rot_varid), "netcdf_io_initialize_output nf90_def_var rot_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%rotphase_varname, nc%out_type, nc%time_dimid, nc%rotphase_varid), &
                                  "netcdf_io_initialize_output nf90_def_var rotphase_varid"  )


            if (nc%lc_lm_exists) then
               call netcdf_io_check( nf90_def_dim(nc%id, nc%sign_dimname, NF90_UNLIMITED, nc%sign_dimid), &
                                    "swiftest_io_netcdf_open nf90_def_dim sign_dimid")
               call netcdf_io_check( nf90_def_dim(nc%id, nc%l_dimname, NF90_UNLIMITED, nc%l_dimid), &
                                    "swiftest_io_netcdf_open nf90_def_dim l_dimid")
               call netcdf_io_check( nf90_def_dim(nc%id, nc%m_dimname, NF90_UNLIMITED, nc%m_dimid), &
                                    "swiftest_io_netcdf_open nf90_def_dim m_dimid")

               call netcdf_io_check( nf90_def_var(nc%id, nc%sign_dimname, nc%out_type, nc%sign_dimid, nc%sign_varid), &
                                    "swiftest_io_netcdf_open nf90_def_var sign_varid")
               call netcdf_io_check( nf90_def_var(nc%id, nc%l_dimname, nc%out_type, nc%l_dimid, nc%l_varid), &
                                    "swiftest_io_netcdf_open nf90_def_var l_varid")
               call netcdf_io_check( nf90_def_var(nc%id, nc%m_dimname, nc%out_type, nc%m_dimid, nc%m_varid), &
                                    "swiftest_io_netcdf_open nf90_def_var m_varid")
               call netcdf_io_check( nf90_def_var(nc%id, nc%c_lm_varname, nc%out_type, [nc%m_dimid, nc%l_dimid, nc%sign_dimid], &
                                     nc%c_lm_varid), "netcdf_io_initialize_output nf90_def_var c_lm_varid" )
              
            else
               call netcdf_io_check( nf90_def_var(nc%id, nc%j2rp2_varname, nc%out_type, nc%time_dimid, nc%j2rp2_varid), &
                                    "netcdf_io_initialize_output nf90_def_var j2rp2_varid"  )
               call netcdf_io_check( nf90_def_var(nc%id, nc%j4rp4_varname, nc%out_type, nc%time_dimid, nc%j4rp4_varid), &
                                    "netcdf_io_initialize_output nf90_def_var j4rp4_varid"  )
            end if
                        
         end if

         ! if (param%ltides) then
         !    call netcdf_io_check( nf90_def_var(nc%id, nc%k2_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%k2_varid), &
         !                        "netcdf_io_initialize_output nf90_def_var k2_varid"  )
         !    call netcdf_io_check( nf90_def_var(nc%id, nc%q_varname, nc%out_type, [nc%name_dimid, nc%time_dimid], nc%Q_varid), &
         !                        "netcdf_io_initialize_output nf90_def_var Q_varid"  )
         ! end if

         if (param%lenergy) then
            call netcdf_io_check( nf90_def_var(nc%id, nc%ke_orb_varname, nc%out_type, nc%time_dimid, nc%KE_orb_varid), &
                                  "netcdf_io_initialize_output nf90_def_var KE_orb_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%ke_spin_varname, nc%out_type, nc%time_dimid, nc%KE_spin_varid), &
                                  "netcdf_io_initialize_output nf90_def_var KE_spin_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%pe_varname, nc%out_type, nc%time_dimid, nc%PE_varid), &
                                  "netcdf_io_initialize_output nf90_def_var PE_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%be_varname, nc%out_type, nc%time_dimid, nc%BE_varid), &
                                  "netcdf_io_initialize_output nf90_def_var BE_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%te_varname, nc%out_type, nc%time_dimid, nc%TE_varid), &
                                  "netcdf_io_initialize_output nf90_def_var TE_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%L_orbit_varname, nc%out_type, [nc%space_dimid, nc%time_dimid], &
                                               nc%L_orbit_varid), &
                                  "netcdf_io_initialize_output nf90_def_var L_orbit_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%L_spin_varname, nc%out_type, [nc%space_dimid, nc%time_dimid], &
                                               nc%L_spin_varid), &
                                  "netcdf_io_initialize_output nf90_def_var L_spin_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%L_escape_varname, nc%out_type, [nc%space_dimid, nc%time_dimid], &
                                               nc%L_escape_varid), &
                                  "netcdf_io_initialize_output nf90_def_var L_escape_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%E_collisions_varname, nc%out_type, nc%time_dimid, nc%E_collisions_varid), &
                                  "netcdf_io_initialize_output nf90_def_var E_collisions_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%E_untracked_varname, nc%out_type, nc%time_dimid, nc%E_untracked_varid), &
                                  "netcdf_io_initialize_output nf90_def_var E_untracked_varid"  )
            call netcdf_io_check( nf90_def_var(nc%id, nc%GMescape_varname, nc%out_type, nc%time_dimid, nc%GMescape_varid), &
                                  "netcdf_io_initialize_output nf90_def_var GMescape_varid"  )
         end if

         ! Set fill mode to NaN for all variables
         call netcdf_io_check( nf90_inquire(nc%id, nVariables=nvar), "netcdf_io_initialize_output nf90_inquire nVariables" )
         do varid = 1, nvar
            call netcdf_io_check( nf90_inquire_variable(nc%id, varid, xtype=vartype, ndims=ndims), &
                                  "netcdf_io_initialize_output nf90_inquire_variable"  )
            select case(vartype)
            case(NF90_INT)
               if (varid == nc%status_varid) then
                  ! Be sure the status variable fill value is the INACTIVE symbolic value
                  call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, INACTIVE), &
                                  "netcdf_io_netcdf_initialize_output nf90_def_var_fill status variable"  )
               else
                  call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, NF90_FILL_INT), &
                                  "netcdf_io_initialize_output nf90_def_var_fill NF90_INT"  )
               end if
            case(NF90_FLOAT)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, sfill), &
                                  "netcdf_io_initialize_output nf90_def_var_fill NF90_FLOAT"  )
            case(NF90_DOUBLE)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, dfill), &
                                  "netcdf_io_initialize_output nf90_def_var_fill NF90_DOUBLE"  )
            case(NF90_CHAR)
               call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, 0), &
                                  "netcdf_io_initialize_output nf90_def_var_fill NF90_CHAR"  )
            end select
         end do

         ! Set special fill mode for discard time so that we can make use of it for non-discarded bodies.
         if (param%lclose) then
            select case (vartype)
            case(NF90_FLOAT)
               call netcdf_io_check( nf90_def_var_fill(nc%id, nc%discard_time_varid, NO_FILL, huge(1.0_SP)), &
                                  "netcdf_io_initialize_output nf90_def_var_fill discard_time NF90_FLOAT"  )
            case(NF90_DOUBLE)
               call netcdf_io_check( nf90_def_var_fill(nc%id, nc%discard_time_varid, NO_FILL, huge(1.0_DP)), &
                                  "netcdf_io_initialize_output nf90_def_var_fill discard_time NF90_DOUBLE"  )
            end select
         end if

         ! Take the file out of define mode
         call netcdf_io_check( nf90_enddef(nc%id), "netcdf_io_initialize_output nf90_enddef"  )

         ! Add in the space dimension coordinates
         call netcdf_io_check( nf90_put_var(nc%id, nc%space_varid, nc%space_coords, start=[1], count=[NDIM]), &
                                  "netcdf_io_initialize_output nf90_put_var space"  )

         if (param%lrotation .and. nc%lc_lm_exists) then
            ! Populate coordinate values for l, m, and sign
            call netcdf_io_check( nf90_put_var(nc%id, nc%l_varid, [(i, i=0, nc%l_dim_max-1)], start=[1], count=[nc%l_dim_max]), &
                                 "netcdf_io_netcdf_initialize_output nf90_put_var l_varid")
            call netcdf_io_check( nf90_put_var(nc%id, nc%m_varid, [(i, i=0, nc%m_dim_max-1)], start=[1], count=[nc%m_dim_max]), &
                                 "netcdf_io_netcdf_initialize_output nf90_put_var m_varid")
            call netcdf_io_check( nf90_put_var(nc%id, nc%sign_varid, nc%sign_coords, start=[1], count=[2] ), &
                                  "netcdf_io_netcdf_initialize_output nf90_put_var sign_varid")
         end if

      end associate
      return

      667 continue
      write(*,*) "Error creating NetCDF output file. " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,param%display_unit)
   end subroutine swiftest_io_netcdf_initialize_output


   module subroutine swiftest_io_netcdf_open(self, param, readonly)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Opens a NetCDF file and does the variable inquiries to activate variable ids
      implicit none
      ! Arguments
      class(swiftest_netcdf_parameters), intent(inout) :: self     !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param    !! Current run configuration parameters
      logical, optional,                 intent(in)    :: readonly !! Logical flag indicating that this should be open read only
      ! Internals
      integer(I4B) :: mode, status
      character(len=STRMAX) :: errmsg

      mode = NF90_WRITE
      if (present(readonly)) then
         if (readonly) mode = NF90_NOWRITE
      end if

      associate(nc => self)
         write(errmsg,*) "swiftest_io_netcdf_open nf90_open ",trim(adjustl(nc%file_name))
         call netcdf_io_check( nf90_open(nc%file_name, mode, nc%id), errmsg)
         self%lfile_is_open = .true.

         ! Dimensions
         call netcdf_io_check( nf90_inq_dimid(nc%id, nc%time_dimname, nc%time_dimid), &
                                  "swiftest_io_netcdf_open nf90_inq_dimid time_dimid"  )
         call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%time_dimid, nc%time_dimname, len=nc%max_tslot), &
                                  "swiftest_io_netcdf_open nf90_inquire_dimension max_tslot"  )
         call netcdf_io_check( nf90_inq_dimid(nc%id, nc%space_dimname, nc%space_dimid), &
                                  "swiftest_io_netcdf_open nf90_inq_dimid space_dimid"  )
         call netcdf_io_check( nf90_inq_dimid(nc%id, nc%name_dimname, nc%name_dimid), &
                                  "swiftest_io_netcdf_open nf90_inq_dimid name_dimid"  )
         call netcdf_io_check( nf90_inq_dimid(nc%id, nc%str_dimname, nc%str_dimid), &
                                  "swiftest_io_netcdf_open nf90_inq_dimid str_dimid"  )

         status = nf90_inq_varid(nc%id, nc%c_lm_varname, nc%c_lm_varid)
         if (status == NF90_NOERR) then
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%sign_dimname, nc%sign_dimid), &
                                    "swiftest_io_netcdf_open nf90_inq_dimid sign_dimid")
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%l_dimname, nc%l_dimid), &
                                    "swiftest_io_netcdf_open nf90_inq_dimid l_dimid")
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%m_dimname, nc%m_dimid), &
                                    "swiftest_io_netcdf_open nf90_inq_dimid m_dimid")
         end if

         ! Dimension coordinates
         call netcdf_io_check( nf90_inq_varid(nc%id, nc%time_dimname, nc%time_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid time_varid" )
         call netcdf_io_check( nf90_inq_varid(nc%id, nc%space_dimname, nc%space_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid space_varid" )
         call netcdf_io_check( nf90_inq_varid(nc%id, nc%name_dimname, nc%name_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid name_varid" )
         status = nf90_inq_varid(nc%id, nc%c_lm_varname, nc%c_lm_varid)
         if (status == NF90_NOERR) then
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%sign_dimname, nc%sign_varid), &
                                    "swiftest_io_netcdf_open nf90_inq_varid sign_varid")
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%l_dimname, nc%l_varid), &
                                    "swiftest_io_netcdf_open nf90_inq_varid l_varid")
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%m_dimname, nc%m_varid), &
                                    "swiftest_io_netcdf_open nf90_inq_varid m_varid")
         end if

         ! Required Variables
         call netcdf_io_check( nf90_inq_varid(nc%id, nc%id_varname, nc%id_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid name_varid" )
         call netcdf_io_check( nf90_inq_varid(nc%id, nc%Gmass_varname, nc%Gmass_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid Gmass_varid" )

         if ((param%out_form == "XV") .or. (param%out_form == "XVEL")) then
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%rh_varname, nc%rh_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid rh_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%vh_varname, nc%vh_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid vh_varid" )

            if (param%lgr) then
               !! check if pseudovelocity vectors exist in this file. If they are, set the correct flag so we know whe should not 
               !! do the conversion.
               status = nf90_inq_varid(nc%id, nc%gr_pseudo_vh_varname, nc%gr_pseudo_vh_varid)
               nc%lpseudo_vel_exists = (status == NF90_NOERR)
               if (param%lrestart .and. .not.nc%lpseudo_vel_exists) then
                  write(*,*) "Warning! Pseudovelocity not found in input file for GR enabled run. " &
                          // "If this is a restarted run, bit-identical trajectories are not guarunteed!"
               end if

            end if
         end if

         if ((param%out_form == "EL") .or. (param%out_form == "XVEL")) then
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%a_varname, nc%a_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid a_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%e_varname, nc%e_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid e_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%inc_varname, nc%inc_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid inc_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%capom_varname, nc%capom_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid capom_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%omega_varname, nc%omega_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid omega_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%capm_varname, nc%capm_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid capm_varid" )
         end if

         if (param%lclose) then
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%radius_varname, nc%radius_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid radius_varid" )
         end if 

         if (param%lrotation) then
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%Ip_varname, nc%Ip_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid Ip_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%rot_varname, nc%rot_varid), &
                                  "swiftest_io_netcdf_open nf90_inq_varid rot_varid" )

            ! rotphase may not be input by the user                      
            status = nf90_inq_varid(nc%id, nc%rotphase_varname, nc%rotphase_varid)

            ! call netcdf_io_check( nf90_inq_varid(nc%id, nc%rotphase_varname, nc%rotphase_varid), &
            !                       "swiftest_io_netcdf_open nf90_inq_varid rotphase_varid")
                                   
         end if

         ! if (param%ltides) then
         !    call netcdf_io_check( nf90_inq_varid(nc%id, nc%k2_varname, nc%k2_varid), &
         !                         "swiftest_io_netcdf_open nf90_inq_varid k2_varid" )
         !    call netcdf_io_check( nf90_inq_varid(nc%id, nc%q_varname, nc%Q_varid), &
         !                         "swiftest_io_netcdf_open nf90_inq_varid Q_varid" )
         ! end if

         ! Optional variables The User Doesn't Need to Know About
         status = nf90_inq_varid(nc%id, nc%mass_varname, nc%mass_varid)
         status = nf90_inq_varid(nc%id, nc%rhill_varname, nc%rhill_varid)
         status = nf90_inq_varid(nc%id, nc%npl_varname, nc%npl_varid)
         status = nf90_inq_varid(nc%id, nc%status_varname, nc%status_varid)
         status = nf90_inq_varid(nc%id, nc%ntp_varname, nc%ntp_varid)
         status = nf90_inq_varid(nc%id, nc%j2rp2_varname, nc%j2rp2_varid)
         status = nf90_inq_varid(nc%id, nc%j4rp4_varname, nc%j4rp4_varid)
         status = nf90_inq_varid(nc%id, nc%ptype_varname, nc%ptype_varid)
         status = nf90_inq_varid(nc%id, nc%varpi_varname, nc%varpi_varid)
         status = nf90_inq_varid(nc%id, nc%lam_varname, nc%lam_varid)
         status = nf90_inq_varid(nc%id, nc%f_varname, nc%f_varid)
         status = nf90_inq_varid(nc%id, nc%cape_varname, nc%cape_varid)

         if (param%lmtiny_pl) status = nf90_inq_varid(nc%id, nc%nplm_varname, nc%nplm_varid)

         if (param%lclose) then
            status = nf90_inq_varid(nc%id, nc%origin_type_varname, nc%origin_type_varid)
            status = nf90_inq_varid(nc%id, nc%origin_time_varname, nc%origin_time_varid)
            status = nf90_inq_varid(nc%id, nc%origin_rh_varname, nc%origin_rh_varid)
            status = nf90_inq_varid(nc%id, nc%origin_vh_varname, nc%origin_vh_varid)
            status = nf90_inq_varid(nc%id, nc%collision_id_varname, nc%collision_id_varid)
            status = nf90_inq_varid(nc%id, nc%discard_time_varname, nc%discard_time_varid)
            status = nf90_inq_varid(nc%id, nc%discard_rh_varname, nc%discard_rh_varid)
            status = nf90_inq_varid(nc%id, nc%discard_vh_varname, nc%discard_vh_varid)
            status = nf90_inq_varid(nc%id, nc%discard_body_id_varname, nc%discard_body_id_varid)
         end if

         if (param%lenergy) then
            status = nf90_inq_varid(nc%id, nc%ke_orb_varname, nc%KE_orb_varid)
            status = nf90_inq_varid(nc%id, nc%ke_spin_varname, nc%KE_spin_varid)
            status = nf90_inq_varid(nc%id, nc%pe_varname, nc%PE_varid)
            status = nf90_inq_varid(nc%id, nc%be_varname, nc%BE_varid)
            status = nf90_inq_varid(nc%id, nc%te_varname, nc%TE_varid)
            status = nf90_inq_varid(nc%id, nc%L_orbit_varname, nc%L_orbit_varid)
            status = nf90_inq_varid(nc%id, nc%L_spin_varname, nc%L_spin_varid)
            status = nf90_inq_varid(nc%id, nc%L_escape_varname, nc%L_escape_varid)
            status = nf90_inq_varid(nc%id, nc%E_collisions_varname, nc%E_collisions_varid)
            status = nf90_inq_varid(nc%id, nc%E_untracked_varname, nc%E_untracked_varid)
            status = nf90_inq_varid(nc%id, nc%GMescape_varname, nc%GMescape_varid)
         end if

         status = nf90_inq_varid(nc%id, nc%c_lm_varname, nc%c_lm_varid)

      end associate

      return
   end subroutine swiftest_io_netcdf_open


   module subroutine swiftest_io_netcdf_get_valid_masks(self, plmask, tpmask, plmmask, Gmtiny)
      !! author: David A. Minton
      !!
      !! Given an open NetCDF, returns logical masks indicating which bodies in the body arrays are active pl and tp type at the 
      !! current time. Uses the value of tslot stored in the NetCDF parameter object as the definition of current time
      use, intrinsic :: ieee_exceptions
      use, intrinsic :: ieee_arithmetic
      implicit none
      ! Arguments
      class(swiftest_netcdf_parameters),  intent(inout)          :: self    !! Parameters used to identify a particular NetCDF 
                                                                            !!   dataset
      logical, dimension(:), allocatable, intent(out)            :: plmask  !! Logical mask indicating which bodies are massive 
                                                                            !!   bodies
      logical, dimension(:), allocatable, intent(out)            :: tpmask  !! Logical mask indicating which bodies are test 
                                                                            !!   particles
      logical, dimension(:), allocatable, intent(out), optional  :: plmmask !! Logical mask indicating which bodies are fully 
                                                                            !!   interacting massive bodies
      real(DP),                           intent(in),  optional  :: Gmtiny  !! The cutoff G*mass between semi-interacting and fully
                                                                            !!   interacting massive bodies
      ! Internals
      real(DP), dimension(:), allocatable :: Gmass, a
      real(DP), dimension(:,:), allocatable :: rh
      integer(I4B), dimension(:), allocatable :: body_status 
      logical, dimension(:), allocatable :: lvalid
      integer(I4B) :: idmax, status
      logical, dimension(size(IEEE_ALL))      :: fpe_halting_modes

      call ieee_get_halting_mode(IEEE_ALL,fpe_halting_modes)  ! Save the current halting modes so we can turn them off temporarily
      call ieee_set_halting_mode(IEEE_ALL,.false.)

      call netcdf_io_check( nf90_inquire_dimension(self%id, self%name_dimid, len=idmax), &
                                  "swiftest_io_netcdf_get_valid_masks nf90_inquire_dimension name_dimid"  )

      allocate(Gmass(idmax))
      allocate(tpmask(idmax))
      allocate(plmask(idmax))
      allocate(lvalid(idmax))
      associate(tslot => self%tslot)

         call netcdf_io_check( nf90_get_var(self%id, self%Gmass_varid, Gmass, start=[1,tslot], count=[idmax,1]), &
                                  "swiftest_io_netcdf_get_valid_masks nf90_getvar Gmass_varid"  )

         status = nf90_inq_varid(self%id, self%status_varname, self%status_varid) 
         if (status == NF90_NOERR) then
            allocate(body_status(idmax))
            call netcdf_io_check( nf90_get_var(self%id, self%status_varid, body_status, start=[1, tslot], count=[idmax,1]), &
                                  "swiftest_io_netcdf_get_valid_masks nf90_getvar status_varid"  )
            lvalid(:) = body_status(:) /= INACTIVE
         else
            status = nf90_inq_varid(self%id, self%rh_varname, self%rh_varid) 
            if (status == NF90_NOERR) then
               allocate(rh(NDIM,idmax))
               call netcdf_io_check( nf90_get_var(self%id, self%rh_varid, rh, start=[1, 1, tslot], count=[NDIM,idmax,1]), &
                                  "swiftest_io_netcdf_get_valid_masks nf90_getvar rh_varid"  )
               lvalid(:) = ieee_is_normal(rh(1,:)) 
            else
               status = nf90_inq_varid(self%id, self%a_varname, self%a_varid) 
               if (status == NF90_NOERR) then
                  allocate(a(idmax))
                  call netcdf_io_check( nf90_get_var(self%id, self%a_varid, a, start=[1, tslot], count=[idmax,1]), &
                                  "swiftest_io_netcdf_get_valid_masks nf90_getvar a_varid"  )
                  lvalid(:) = ieee_is_normal(a(:))
               else
                  lvalid(:) = .false.
               end if
            end if
         end if

         plmask(:) = ieee_is_normal(Gmass(:))
         where(plmask(:)) plmask(:) = Gmass(:) > 0.0_DP
         tpmask(:) = .not. plmask(:)
         plmask(1) = .false. ! This is the central body

         ! Select only active bodies
         plmask(:) = plmask(:) .and. lvalid(:)
         tpmask(:) = tpmask(:) .and. lvalid(:)

         if (present(plmmask) .and. present(Gmtiny)) then
            allocate(plmmask, source=plmask)
            where(plmask(:))
               plmmask = Gmass(:) > Gmtiny
            endwhere
         end if

         call ieee_set_halting_mode(IEEE_ALL,fpe_halting_modes)

      end associate

      return
   end subroutine swiftest_io_netcdf_get_valid_masks


   module function swiftest_io_netcdf_read_frame_system(self, nc, param) result(ierr)
      !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Read a frame (header plus records for each massive body and active test particle) from an output binary file
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self  !! Swiftest nbody_system object
      class(swiftest_netcdf_parameters), intent(inout) :: nc    !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters 
      ! Return
      integer(I4B)                                :: ierr  !! Error code: returns 0 if the read is successful
      ! Internals
      integer(I4B)                              :: i, idmax, npl_check, ntp_check, str_max, status, npl, ntp
      real(DP), dimension(:), allocatable       :: rtemp
      real(DP), dimension(:,:), allocatable     :: vectemp
      integer(I4B), dimension(:), allocatable   :: itemp
      logical, dimension(:), allocatable        :: tpmask, plmask

      associate(cb => self%cb, pl => self%pl, tp => self%tp, tslot => nc%tslot)
         call nc%open(param, readonly=.true.)
         call nc%find_tslot(self%t, tslot)
         call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%time_dimid, len=nc%max_tslot), &
                                  "netcdf_io_read_frame_system nf90_inquire_dimension time_dimid"  )
         tslot = min(tslot, nc%max_tslot)

         call self%read_hdr(nc, param)

         ! Save these values as variables as they get reset by the setup method
         npl = pl%nbody
         ntp = tp%nbody
         call pl%setup(npl, param)
         call tp%setup(ntp, param)
         call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%name_dimid, len=idmax), &
                                  "netcdf_io_read_frame_system nf90_inquire_dimension name_dimid"  )
         allocate(rtemp(idmax))
         allocate(vectemp(NDIM,idmax))
         allocate(itemp(idmax))

         call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%str_dimid, len=str_max), &
                                  "netcdf_io_read_frame_system nf90_inquire_dimension str_dimid"  )

         call nc%get_valid_masks(plmask, tpmask)

         ! Check to make sure the number of bodies is correct
         npl_check = count(plmask(:))
         ntp_check = count(tpmask(:))

         if (npl_check /= npl) then
            write(*,*) "Error reading in NetCDF file: The recorded value of npl does not match the number of active massive bodies"
            write(*,*) "Recorded: ",npl
            write(*,*) "Active  : ",npl_check
         end if

         if (ntp_check /= ntp) then
            write(*,*) "Error reading in NetCDF file: The recorded value of ntp does not match the number of active test particles"
            write(*,*) "Recorded: ",ntp
            write(*,*) "Active  : ",ntp_check
            call base_util_exit(FAILURE,param%display_unit)
         end if

         ! Now read in each variable and split the outputs by body type
         if ((param%in_form == "XV") .or. (param%in_form == "XVEL")) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%rh_varid, vectemp, start=[1, 1, tslot], count=[NDIM,idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar rh_varid"  )
            do i = 1, NDIM
               if (npl > 0) pl%rh(i,:) = pack(vectemp(i,:), plmask(:))
               if (ntp > 0) tp%rh(i,:) = pack(vectemp(i,:), tpmask(:))
            end do

            if (param%lgr .and. nc%lpseudo_vel_exists) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%gr_pseudo_vh_varid, vectemp, start=[1, 1, tslot], &
                                                  count=[NDIM,idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar gr_pseudo_vh_varid"  )
               do i = 1, NDIM
                  if (npl > 0) pl%vh(i,:) = pack(vectemp(i,:), plmask(:))
                  if (ntp > 0) tp%vh(i,:) = pack(vectemp(i,:), tpmask(:))
               end do
            else
               call netcdf_io_check( nf90_get_var(nc%id, nc%vh_varid, vectemp, start=[1, 1, tslot], count=[NDIM,idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar vh_varid"  )
               do i = 1, NDIM
                  if (npl > 0) pl%vh(i,:) = pack(vectemp(i,:), plmask(:))
                  if (ntp > 0) tp%vh(i,:) = pack(vectemp(i,:), tpmask(:))
               end do
            end if
         end if

         if ((param%in_form == "EL")  .or. (param%in_form == "XVEL")) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%a_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar a_varid"  )
            if (.not.allocated(pl%a)) allocate(pl%a(npl))
            if (.not.allocated(tp%a)) allocate(tp%a(ntp))
            if (npl > 0) pl%a(:) = pack(rtemp, plmask)
            if (ntp > 0) tp%a(:) = pack(rtemp, tpmask)

            call netcdf_io_check( nf90_get_var(nc%id, nc%e_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar e_varid"  )
            if (.not.allocated(pl%e)) allocate(pl%e(npl))
            if (.not.allocated(tp%e)) allocate(tp%e(ntp))
            if (npl > 0) pl%e(:) = pack(rtemp, plmask)
            if (ntp > 0) tp%e(:) = pack(rtemp, tpmask)

            call netcdf_io_check( nf90_get_var(nc%id, nc%inc_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar inc_varid"  )
            rtemp = rtemp * DEG2RAD
            if (.not.allocated(pl%inc)) allocate(pl%inc(npl))
            if (.not.allocated(tp%inc)) allocate(tp%inc(ntp))
            if (npl > 0) pl%inc(:) = pack(rtemp, plmask)
            if (ntp > 0) tp%inc(:) = pack(rtemp, tpmask)

            call netcdf_io_check( nf90_get_var(nc%id, nc%capom_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar capom_varid"  )
            rtemp = rtemp * DEG2RAD
            if (.not.allocated(pl%capom)) allocate(pl%capom(npl))
            if (.not.allocated(tp%capom)) allocate(tp%capom(ntp))
            if (npl > 0) pl%capom(:) = pack(rtemp, plmask)
            if (ntp > 0) tp%capom(:) = pack(rtemp, tpmask)

            call netcdf_io_check( nf90_get_var(nc%id, nc%omega_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar omega_varid"  )
            rtemp = rtemp * DEG2RAD
            if (.not.allocated(pl%omega)) allocate(pl%omega(npl))
            if (.not.allocated(tp%omega)) allocate(tp%omega(ntp))
            if (npl > 0) pl%omega(:) = pack(rtemp, plmask)
            if (ntp > 0) tp%omega(:) = pack(rtemp, tpmask)

            call netcdf_io_check( nf90_get_var(nc%id, nc%capm_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar capm_varid"  )
            rtemp = rtemp * DEG2RAD
            if (.not.allocated(pl%capm)) allocate(pl%capm(npl))
            if (.not.allocated(tp%capm)) allocate(tp%capm(ntp))
            if (npl > 0) pl%capm(:) = pack(rtemp, plmask)
            if (ntp > 0) tp%capm(:) = pack(rtemp, tpmask)

         end if
      
         call netcdf_io_check( nf90_get_var(nc%id, nc%Gmass_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar Gmass_varid"  )
         cb%Gmass = rtemp(1)
         cb%mass = cb%Gmass / param%GU

         ! Set initial central body mass for Helio bookkeeping
         cb%GM0 = cb%Gmass

         if (npl > 0) then
            pl%Gmass(:) = pack(rtemp, plmask)
            pl%mass(:) = pl%Gmass(:) / param%GU
            if (param%lmtiny_pl) pl%nplm = count(pack(rtemp,plmask) > param%GMTINY )

            status = nf90_get_var(nc%id, nc%rhill_varid, rtemp, start=[1, tslot], count=[idmax,1])
            if (status == NF90_NOERR) then
               pl%rhill(:) = pack(rtemp, plmask)
            end if
         end if

         if (param%lclose) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%radius_varid, rtemp, start=[1, tslot], count=[idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar radius_varid"  )
            cb%radius = rtemp(1)

            if (npl > 0) pl%radius(:) = pack(rtemp, plmask)
         else
            cb%radius = param%rmin
            if (npl > 0) pl%radius(:) = 0.0_DP
         end if
         cb%R0 = cb%radius

         if (param%lrotation) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%Ip_varid,  vectemp, start=[1, 1, tslot], count=[NDIM,idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar Ip_varid"  )
            cb%Ip(:) = vectemp(:,1)
            do i = 1, NDIM
               if (npl > 0) pl%Ip(i,:) = pack(vectemp(i,:), plmask(:))
            end do

            call netcdf_io_check( nf90_get_var(nc%id, nc%rot_varid, vectemp, start=[1, 1, tslot], count=[NDIM,idmax,1]), &
                                  "netcdf_io_read_frame_system nf90_getvar rot_varid"  )
            vectemp(:,:) = vectemp(:,:) * DEG2RAD
            cb%rot(:) = vectemp(:,1) 
            do i = 1, NDIM
               if (npl > 0) pl%rot(i,:) = pack(vectemp(i,:), plmask(:))
            end do

            ! Set initial central body angular momentum for bookkeeping
            cb%L0(:) = cb%Ip(3) * cb%mass * cb%R0**2 * cb%rot(:) 
           
            ! Check if rotphase is input by user. If not, set to 0 
            status = nf90_inq_varid(nc%id, nc%rotphase_varname, nc%rotphase_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%rotphase_varid, cb%rotphase, start=[tslot]), &
                                  "netcdf_io_read_frame_system nf90_getvar rotphase_varid"  )
               cb%rotphase = cb%rotphase * DEG2RAD
            else
               cb%rotphase = 0.0_DP
            end if

            ! Check if the J2 and J4 terms are input by user. If not, set them to 0
            status = nf90_inq_varid(nc%id, nc%j2rp2_varname, nc%j2rp2_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%j2rp2_varid, cb%j2rp2, start=[tslot]), &
                                     "netcdf_io_read_frame_system nf90_getvar j2rp2_varid"  )
            else 
               cb%j2rp2 = 0.0_DP
            end if

            status = nf90_inq_varid(nc%id, nc%j4rp4_varname, nc%j4rp4_varid)   
            if (status == NF90_NOERR) then      
               call netcdf_io_check( nf90_get_var(nc%id, nc%j4rp4_varid, cb%j4rp4, start=[tslot]), &
                                     "netcdf_io_read_frame_system nf90_getvar j4rp4_varid"  )
            else 
               cb%j4rp4 = 0.0_DP
            end if
  
            ! Check if gravitational harmonics coefficients, c_lm, are set by the user. Also ensure that
            ! c_lm and j2rp2/j4rp4 are not both set.
            status = nf90_inq_varid(nc%id, nc%c_lm_varname, nc%c_lm_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%l_dimid, len = nc%l_dim_max),&
                                     "netcdf_io_read_frame_system nf90_inquire_dimension l_dimid"  )
               call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%m_dimid, len = nc%m_dim_max), &
                                      "netcdf_io_read_frame_system nf90_inquire_dimension m_dimid")
              
               if (nc%l_dim_max /= nc%m_dim_max) then
                  write(*,*) "Error reading in NetCDF file: c_lm requires l_dim_max = m_dim_max"
                  call base_util_exit(FAILURE,param%display_unit) 
               end if
   
               if(.not. allocated(cb%c_lm)) allocate(cb%c_lm(nc%m_dim_max, nc%l_dim_max, 2)) 
               call netcdf_io_check( nf90_get_var(nc%id, nc%c_lm_varid, cb%c_lm, count = [nc%m_dim_max, nc%l_dim_max, 2]), &
                                     "netcdf_io_read_frame_system nf90_getvar c_lm_varid")
               
               if (abs(cb%j2rp2) > tiny(1.0_DP) .or. (abs(cb%j4rp4) > tiny(1.0_DP))) then
                  write(*,*) "Error reading in NetCDF file: cannot use both c_lm and j2rp2/j4rp4"
                  call base_util_exit(FAILURE,param%display_unit) 
               end if
   
               nc%lc_lm_exists = .true.
            else
               if (allocated(cb%c_lm)) deallocate(cb%c_lm)
               nc%lc_lm_exists = .false.
            end if

         end if

         ! if (param%ltides) then
         !    call netcdf_io_check( nf90_get_var(nc%id, nc%k2_varid, rtemp, start=[1, tslot]), &
         !                        "netcdf_io_read_frame_system nf90_getvar k2_varid"  )
         !    cb%k2 = rtemp(1)
         !    if (npl > 0) pl%k2(:) = pack(rtemp, plmask)

         !    call netcdf_io_check( nf90_get_var(nc%id, nc%Q_varid,  rtemp,  start=[1, tslot]), &
         !                        "netcdf_io_read_frame_system nf90_getvar Q_varid"  )
         !    cb%Q = rtemp(1)
         !    if (npl > 0) pl%Q(:) = pack(rtemp, plmask)
         ! end if

         call self%read_particle_info(nc, param, plmask, tpmask) 

         if (param%in_form == "EL") then
            call pl%el2xv(cb)
            call tp%el2xv(cb)
         end if
         ! if this is a GR-enabled run, check to see if we got the pseudovelocities in. Otherwise, we'll need to generate them.
         if (param%lgr .and. .not.(nc%lpseudo_vel_exists)) then
            call pl%set_mu(cb)
            call tp%set_mu(cb)
            call pl%v2pv(param)
            call tp%v2pv(param)
         end if
         
      end associate

      call nc%close()

      ierr = 0
      return
   end function swiftest_io_netcdf_read_frame_system


   module subroutine swiftest_io_netcdf_read_hdr_system(self, nc, param) 
      !! author: David A. Minton
      !!
      !! Reads header information (variables that change with time, but not particle id). 
      !! This subroutine swiftest_significantly improves the output over the original binary file, allowing us to track energy, 
      !! momentum, and other quantities that previously were handled as separate output files.
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self  !! Swiftest nbody system object
      class(swiftest_netcdf_parameters), intent(inout) :: nc    !! Parameters used to for reading a NetCDF dataset to file
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B) :: status
      logical, dimension(:), allocatable        :: plmask, tpmask, plmmask

      associate(tslot => nc%tslot)
         call netcdf_io_check( nf90_get_var(nc%id, nc%time_varid, self%t, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar time_varid"  )
         if (param%lmtiny_pl) then
            call nc%get_valid_masks(plmask, tpmask, plmmask, param%GMTINY)
         else
            call nc%get_valid_masks(plmask, tpmask)
         end if

         status = nf90_inq_varid(nc%id, nc%npl_varname, nc%npl_varid)
         if (status == NF90_NOERR) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%npl_varid,  self%pl%nbody, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar npl_varid"  )
         else
            self%pl%nbody = count(plmask(:))
         end if

         status = nf90_inq_varid(nc%id, nc%ntp_varname, nc%ntp_varid)
         if (status == NF90_NOERR) then
            call netcdf_io_check( nf90_get_var(nc%id, nc%ntp_varid,  self%tp%nbody, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar ntp_varid"  )
         else
            self%tp%nbody = count(tpmask(:))
         end if

         if (param%lmtiny_pl) then
            status = nf90_inq_varid(nc%id, nc%nplm_varname, nc%nplm_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%nplm_varid,  self%pl%nplm, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar nplm_varid"  )
            else
               self%pl%nplm = count(plmmask(:))
            end if
         end if

         if (param%lenergy) then
            status = nf90_inq_varid(nc%id, nc%ke_orb_varname, nc%KE_orb_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%KE_orb_varid, self%ke_orbit, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar KE_orb_varid"  )
            status = nf90_inq_varid(nc%id, nc%ke_spin_varname, nc%KE_spin_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%KE_spin_varid, self%ke_spin, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar KE_spin_varid"  )
            status = nf90_inq_varid(nc%id, nc%pe_varname, nc%PE_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%PE_varid, self%pe, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar PE_varid"  )
            status = nf90_inq_varid(nc%id, nc%be_varname, nc%BE_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%BE_varid, self%be, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar BE_varid"  )
            status = nf90_inq_varid(nc%id, nc%te_varname, nc%TE_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%TE_varid, self%te, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar TE_varid"  )
            status = nf90_inq_varid(nc%id, nc%L_orbit_varname, nc%L_orbit_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%L_orbit_varid, self%L_orbit(:), & 
                                                                         start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_read_hdr_system nf90_getvar L_orbit_varid"  )
            status = nf90_inq_varid(nc%id, nc%L_spin_varname, nc%L_spin_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%L_spin_varid, self%L_spin(:), start=[1,tslot], &
                                                            count=[NDIM,1]), &
                                  "netcdf_io_read_hdr_system nf90_getvar L_spin_varid"  )
            status = nf90_inq_varid(nc%id, nc%L_escape_varname, nc%L_escape_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%L_escape_varid, self%L_escape(:), &
                                                                         start=[1, tslot], count=[NDIM,1]), &
                                  "netcdf_io_read_hdr_system nf90_getvar L_escape_varid"  )
            status = nf90_inq_varid(nc%id, nc%E_collisions_varname, nc%E_collisions_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%E_collisions_varid, self%E_collisions, &
                                                                         start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar E_collisions_varid"  )
            status = nf90_inq_varid(nc%id, nc%E_untracked_varname, nc%E_untracked_varid)
            if (status == NF90_NOERR) call netcdf_io_check( nf90_get_var(nc%id, nc%E_untracked_varid, self%E_untracked, &
                                                                          start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar E_untracked_varid"  )
            status = nf90_inq_varid(nc%id, nc%GMescape_varname, nc%GMescape_varid)
            if (status == NF90_NOERR)  call netcdf_io_check( nf90_get_var(nc%id, nc%GMescape_varid, self%GMescape, start=[tslot]), &
                                  "netcdf_io_read_hdr_system nf90_getvar GMescape_varid"  )
         end if

      end associate

      return
   end subroutine swiftest_io_netcdf_read_hdr_system


   module subroutine swiftest_io_netcdf_read_particle_info_system(self, nc, param, plmask, tpmask)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Reads particle information metadata from file
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self   !! Swiftest nbody system object
      class(swiftest_netcdf_parameters), intent(inout) :: nc     !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param  !! Current run configuration parameters
      logical, dimension(:),             intent(in)    :: plmask !! Logical array indicating which index values belong to massive 
                                                                 !!     bodies
      logical, dimension(:),             intent(in)    :: tpmask !! Logical array indicating which index values belong to test 
                                                                 !!     particles

      ! Internals
      integer(I4B)                                :: i, idmax, status
      real(DP), dimension(:), allocatable         :: rtemp
      real(DP), dimension(:,:), allocatable       :: vectemp
      integer(I4B), dimension(:), allocatable     :: itemp
      character(len=NAMELEN), dimension(:), allocatable :: ctemp
      integer(I4B), dimension(:), allocatable     :: plind, tpind

      ! This string of spaces of length NAMELEN is used to clear out any old data left behind inside the string variables
      idmax = size(plmask)
      allocate(rtemp(idmax))
      allocate(vectemp(NDIM,idmax))
      allocate(itemp(idmax))
      allocate(ctemp(idmax))

      associate(cb => self%cb, pl => self%pl, tp => self%tp, npl => self%pl%nbody, ntp => self%tp%nbody)

         if (npl > 0) then
            pl%status(:) = ACTIVE
            pl%lmask(:) = .true.
            do i = 1, npl
               call pl%info(i)%set_value(status="ACTIVE")
            end do
            allocate(plind(npl))
            plind(:) = pack([(i, i = 1, idmax)], plmask(:))
         end if
         if (ntp > 0) then
            tp%status(:) = ACTIVE
            tp%lmask(:) = .true.
            do i = 1, ntp
               call tp%info(i)%set_value(status="ACTIVE")
            end do
            allocate(tpind(ntp))
            tpind(:) = pack([(i, i = 1, idmax)], tpmask(:))
         end if

         call netcdf_io_check( nf90_get_var(nc%id, nc%id_varid, itemp), "netcdf_io_read_particle_info_system nf90_getvar id_varid")
         cb%id = itemp(1)
         pl%id(:) = pack(itemp, plmask)
         tp%id(:) = pack(itemp, tpmask)
         cb%id = 0
         pl%id(:) = pack([(i,i=0,idmax-1)],plmask)
         tp%id(:) = pack([(i,i=0,idmax-1)],tpmask)

         call netcdf_io_check( nf90_get_var(nc%id, nc%name_varid, ctemp, count=[NAMELEN, idmax]), &
                                  "netcdf_io_read_particle_info_system nf90_getvar name_varid"  )
         call cb%info%set_value(name=ctemp(1))
         do i = 1, npl
            call pl%info(i)%set_value(name=ctemp(plind(i)))
         end do
         do i = 1, ntp
            call tp%info(i)%set_value(name=ctemp(tpind(i)))
         end do

         status = nf90_get_var(nc%id, nc%ptype_varid, ctemp, count=[NAMELEN, idmax])
         if (status /= NF90_NOERR) then ! Set default particle types
            call cb%info%set_value(particle_type=CB_TYPE_NAME)

            ! Handle semi-interacting bodies in SyMBA
            do i = 1, npl
               if (param%lmtiny_pl .and. (pl%Gmass(i) < param%GMTINY)) then
                  call pl%info(i)%set_value(particle_type=PL_TINY_TYPE_NAME)
               else
                  call pl%info(i)%set_value(particle_type=PL_TYPE_NAME)
               end if
            end do
            do i = 1, ntp
               call tp%info(i)%set_value(particle_type=TP_TYPE_NAME)
            end do
         else ! Use particle types defined in input file
            call cb%info%set_value(particle_type=ctemp(1))
            do i = 1, npl
               call pl%info(i)%set_value(particle_type=ctemp(plind(i)))
            end do
            do i = 1, ntp
               call tp%info(i)%set_value(particle_type=ctemp(tpind(i)))
            end do
         end if

         call cb%info%set_value(status="ACTIVE")

         if (param%lclose) then
            status = nf90_inq_varid(nc%id, nc%origin_type_varname, nc%origin_type_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%origin_type_varid, ctemp, count=[NAMELEN, idmax]), &
                                  "netcdf_io_read_particle_info_system nf90_getvar origin_type_varid"  )
            else
               ctemp = "Initial Conditions"
            end if

            call cb%info%set_value(origin_type=ctemp(1))
            do i = 1, npl
               call pl%info(i)%set_value(origin_type=ctemp(plind(i)))
            end do
            do i = 1, ntp
               call tp%info(i)%set_value(origin_type=ctemp(tpind(i)))
            end do

            status = nf90_inq_varid(nc%id, nc%origin_time_varname, nc%origin_time_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%origin_time_varid, rtemp), &
                                  "netcdf_io_read_particle_info_system nf90_getvar origin_time_varid"  )
            else
               rtemp = param%t0
            end if

            call cb%info%set_value(origin_time=rtemp(1))
            do i = 1, npl
               call pl%info(i)%set_value(origin_time=rtemp(plind(i)))
            end do
            do i = 1, ntp
               call tp%info(i)%set_value(origin_time=rtemp(tpind(i)))
            end do

            status = nf90_inq_varid(nc%id, nc%origin_rh_varname, nc%origin_rh_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%origin_rh_varid, vectemp(:,:)), &
                                  "netcdf_io_read_particle_info_system nf90_getvar origin_rh_varid"  )
            else if ((param%out_form == "XV") .or. (param%out_form == "XVEL")) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%rh_varid, vectemp(:,:)), &
                                  "netcdf_io_read_particle_info_system nf90_getvar rh_varid"  )
            else 
               vectemp(:,:) = 0._DP
            end if 

            do i = 1, npl
               call pl%info(i)%set_value(origin_rh=vectemp(:,plind(i)))
            end do
            do i = 1, ntp
               call tp%info(i)%set_value(origin_rh=vectemp(:,tpind(i)))
            end do

            status = nf90_inq_varid(nc%id, nc%origin_vh_varname, nc%origin_vh_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%origin_vh_varid, vectemp(:,:)), &
                                  "netcdf_io_read_particle_info_system nf90_getvar origin_vh_varid"  )
            else if ((param%out_form == "XV") .or. (param%out_form == "XVEL")) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%vh_varid, vectemp(:,:)), &
                                  "netcdf_io_read_particle_info_system nf90_getvar vh_varid"  )
            else
               vectemp(:,:) = 0._DP
            end if 
            
            do i = 1, npl
               call pl%info(i)%set_value(origin_vh=vectemp(:,plind(i)))
            end do
            do i = 1, ntp
               call tp%info(i)%set_value(origin_vh=vectemp(:,tpind(i)))
            end do

            status = nf90_inq_varid(nc%id, nc%collision_id_varname, nc%collision_id_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%collision_id_varid, itemp), &
                                  "netcdf_io_read_particle_info_system nf90_getvar collision_id_varid"  )
               do i = 1, npl
                  call pl%info(i)%set_value(collision_id=itemp(plind(i)))
               end do
               do i = 1, ntp
                  call tp%info(i)%set_value(collision_id=itemp(tpind(i)))
               end do
            end if

            status = nf90_inq_varid(nc%id, nc%discard_time_varname, nc%discard_time_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%discard_time_varid, rtemp), &
                                  "netcdf_io_read_particle_info_system nf90_getvar discard_time_varid"  )
               call cb%info%set_value(discard_time=rtemp(1))
               do i = 1, npl
                  call pl%info(i)%set_value(discard_time=rtemp(plind(i)))
               end do
               do i = 1, ntp
                  call tp%info(i)%set_value(discard_time=rtemp(tpind(i)))
               end do
            end if

            status = nf90_inq_varid(nc%id, nc%discard_rh_varname, nc%discard_rh_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%discard_rh_varid, vectemp(:,:)), &
                                  "netcdf_io_read_particle_info_system nf90_getvar discard_rh_varid"  )
               do i = 1, npl
                  call pl%info(i)%set_value(discard_rh=vectemp(:,plind(i)))
               end do
               do i = 1, ntp
                  call tp%info(i)%set_value(discard_rh=vectemp(:,tpind(i)))
               end do
            end if

            status = nf90_inq_varid(nc%id, nc%discard_vh_varname, nc%discard_vh_varid)
            if (status == NF90_NOERR) then
               call netcdf_io_check( nf90_get_var(nc%id, nc%discard_vh_varid, vectemp(:,:)), &
                                  "netcdf_io_read_particle_info_system nf90_getvar discard_vh_varid"  )
               do i = 1, npl
                  call pl%info(i)%set_value(discard_vh=vectemp(:,plind(i)))
               end do
               do i = 1, ntp
                  call tp%info(i)%set_value(discard_vh=vectemp(:,tpind(i)))
               end do
            end if
         end if

      end associate

      return
   end subroutine swiftest_io_netcdf_read_particle_info_system


   module subroutine swiftest_io_netcdf_write_frame_body(self, nc, param)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Write a frame of output of either test particle or massive body data to the binary output file
      !!    Note: If outputting to orbital elements, but sure that the conversion is done prior to calling this method
      implicit none
      ! Arguments
      class(swiftest_body),              intent(in)    :: self  !! Swiftest base object
      class(swiftest_netcdf_parameters), intent(inout) :: nc    !! Parameters used to for writing a NetCDF dataset to file
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters 
      ! Internals
      integer(I4B)                              :: i, j, idslot, old_mode, tmp
      integer(I4B), dimension(:), allocatable   :: ind
      real(DP), dimension(NDIM)                 :: vh !! Temporary variable to store heliocentric velocity values when converting 
                                                      !! from pseudovelocity in GR-enabled runs
      real(DP)                                  :: a, e, inc, omega, capom, capm, varpi, lam, f, cape, capf
#ifdef COARRAY
      integer(I4B) :: ntp
      logical, dimension(:), allocatable        :: tpmask, plmask
#endif

      call self%write_info(nc, param)

      call netcdf_io_check( nf90_set_fill(nc%id, NF90_NOFILL, old_mode), "netcdf_io_write_frame_body nf90_set_fill"  )
      select type(self)
      class is (swiftest_body)
      select type (param)
      class is (swiftest_parameters)
         associate(n => self%nbody, tslot => nc%tslot)
            if (n == 0) return

            call util_sort(self%id(1:n), ind)

            do i = 1, n
               j = ind(i)
               call nc%find_idslot(self%id(j), idslot) 
               ! Convert from pseudovelocity to heliocentric without replacing the current value of pseudovelocity 
               if (param%lgr) call swiftest_gr_pseudovel2vel(param, self%mu(j), self%rh(:, j), self%vh(:, j), vh(:))

               if ((param%out_form == "XV") .or. (param%out_form == "XVEL")) then
                  call netcdf_io_check( nf90_put_var(nc%id, nc%rh_varid, self%rh(:, j), start=[1,idslot, tslot], count=[NDIM,1,1]),&
                                  "netcdf_io_write_frame_body nf90_put_var rh_varid"  )
                  if (param%lgr) then ! Convert from pseudovelocity to heliocentric without replacing the current value of 
                                      !  pseudovelocity
                     call netcdf_io_check( nf90_put_var(nc%id, nc%vh_varid, vh(:), start=[1,idslot, tslot], count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var vh_varid"  )
                     call netcdf_io_check( nf90_put_var(nc%id, nc%gr_pseudo_vh_varid, self%vh(:, j), start=[1,idslot, tslot], &
                                                        count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var gr_pseudo_vhx_varid"  )

                  else
                     call netcdf_io_check( nf90_put_var(nc%id, nc%vh_varid, self%vh(:, j), start=[1,idslot, tslot], &
                                                        count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var vh_varid"  )
                  end if
               end if

               if ((param%out_form == "EL") .or. (param%out_form == "XVEL")) then
                  if (param%lgr) then ! For GR-enabled runs, use the true value of velocity computed above
                     call swiftest_orbel_xv2el(self%mu(j), self%rh(1,j), self%rh(2,j), self%rh(3,j), &
                                       vh(1), vh(2), vh(3), &
                                       a, e, inc, capom, omega, capm, varpi, lam, f, cape, capf)
                  else !! For non-GR runs just convert from the velocity we have
                     call swiftest_orbel_xv2el(self%mu(j), self%rh(1,j), self%rh(2,j), self%rh(3,j), &
                                       self%vh(1,j), self%vh(2,j), self%vh(3,j), &
                                       a, e, inc, capom, omega, capm, varpi, lam, f, cape, capf)
                  end if
                  call netcdf_io_check( nf90_put_var(nc%id, nc%a_varid, a, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body a_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%e_varid, e, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body e_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%inc_varid, inc * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body inc_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%capom_varid, capom * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body capom_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%omega_varid, omega * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body omega_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%capm_varid, capm * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body capm_varid"  ) 
                  call netcdf_io_check( nf90_put_var(nc%id, nc%varpi_varid, varpi * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body varpi_varid"  ) 
                  call netcdf_io_check( nf90_put_var(nc%id, nc%lam_varid, lam * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body lam_varid"  ) 
                  call netcdf_io_check( nf90_put_var(nc%id, nc%f_varid, f * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body f_varid"  ) 
                  if (e < 1.0_DP) then
                     call netcdf_io_check( nf90_put_var(nc%id, nc%cape_varid, cape * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body cape_varid"  ) 
                  else if (e > 1.0_DP) then
                     call netcdf_io_check( nf90_put_var(nc%id, nc%cape_varid, capf * RAD2DEG, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body (capf) cape_varid"  ) 
                  end if
               end if

               select type(self)  
               class is (swiftest_pl)  ! Additional output if the passed polymorphic object is a massive body
                  call netcdf_io_check( nf90_put_var(nc%id, nc%Gmass_varid, self%Gmass(j), start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body Gmass_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%mass_varid, self%mass(j), start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body mass_varid"  )
                  if (param%lrhill_present) then
                     call netcdf_io_check( nf90_put_var(nc%id, nc%rhill_varid, self%rhill(j), start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body rhill_varid"  )
                  end if
                  if (param%lclose) call netcdf_io_check( nf90_put_var(nc%id, nc%radius_varid, self%radius(j), &
                                                                       start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body radius_varid"  )
                  if (param%lrotation) then
                     call netcdf_io_check( nf90_put_var(nc%id, nc%Ip_varid, self%Ip(:, j), start=[1,idslot, tslot], &
                                                        count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var body Ip_varid"  )
                     call netcdf_io_check( nf90_put_var(nc%id, nc%rot_varid, self%rot(:, j) * RAD2DEG, start=[1,idslot, tslot], &
                                                        count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var body rotx_varid"  )
                  end if
                  ! if (param%ltides) then
                  !    call netcdf_io_check( nf90_put_var(nc%id, nc%k2_varid, self%k2(j), start=[idslot, tslot]), &
                  !                "netcdf_io_write_frame_body nf90_put_var body k2_varid"  )
                  !    call netcdf_io_check( nf90_put_var(nc%id, nc%Q_varid, self%Q(j), start=[idslot, tslot]), &
                  !                "netcdf_io_write_frame_body nf90_put_var body Q_varid"  )
                  ! end if
               class is (swiftest_tp)
                  call netcdf_io_check( nf90_put_var(nc%id, nc%Gmass_varid, 0.0_DP, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body Gmass_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%mass_varid, 0.0_DP, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body mass_varid"  )
                  if (param%lrhill_present) then
                     call netcdf_io_check( nf90_put_var(nc%id, nc%rhill_varid, 0.0_DP, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body rhill_varid"  )
                  end if
                  if (param%lclose) call netcdf_io_check( nf90_put_var(nc%id, nc%radius_varid, 0.0_DP, start=[idslot, tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var body radius_varid"  )
                  if (param%lrotation) then
                     call netcdf_io_check( nf90_put_var(nc%id, nc%Ip_varid, [0.0_DP,0.0_DP,0.0_DP], start=[1,idslot, tslot], &
                                                        count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var body Ip_varid"  )
                     call netcdf_io_check( nf90_put_var(nc%id, nc%rot_varid, [0.0_DP,0.0_DP,0.0_DP], start=[1,idslot, tslot], &
                                                        count=[NDIM,1,1]), &
                                  "netcdf_io_write_frame_body nf90_put_var body rotx_varid"  )
                  end if
               end select
            end do
         end associate
      end select
      end select
#ifdef COARRAY
      select type(self)
      class is (swiftest_tp)
         call nc%get_valid_masks(plmask, tpmask)
         ntp = count(tpmask(:))  
         call netcdf_io_check( nf90_put_var(nc%id, nc%ntp_varid, ntp, start=[nc%tslot]), &
                                  "netcdf_io_write_frame_body nf90_put_var ntp_varid"  )
      end select
#endif   

      call netcdf_io_check( nf90_set_fill(nc%id, old_mode, tmp), &
                                  "netcdf_io_write_frame_body nf90_set_fill old_mode"  )

      return
   end subroutine swiftest_io_netcdf_write_frame_body


   module subroutine swiftest_io_netcdf_write_frame_cb(self, nc, param)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Write a frame of output of the central body
      implicit none
      ! Arguments
      class(swiftest_cb),                intent(inout)    :: self  !! Swiftest base object
      class(swiftest_netcdf_parameters), intent(inout) :: nc    !! Parameters used to for writing a NetCDF dataset to file
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters 
      ! Internals
      integer(I4B)                              :: idslot, old_mode, tmp, i
      integer(I4B), dimension(:), allocatable   :: lm_coords
      integer(I4B) :: status

      associate(tslot => nc%tslot)
         call self%write_info(nc, param)

         call netcdf_io_check( nf90_set_fill(nc%id, NF90_NOFILL, old_mode), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_set_fill"  )

         call nc%find_idslot(self%id, idslot) 
         call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid, self%id, start=[idslot]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb id_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%status_varid, ACTIVE, start=[idslot, tslot]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb id_varid"  )

         call netcdf_io_check( nf90_put_var(nc%id, nc%Gmass_varid, self%Gmass, start=[idslot, tslot]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb Gmass_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%mass_varid, self%mass, start=[idslot, tslot]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb mass_varid"  )
         if (param%lclose) call netcdf_io_check( nf90_put_var(nc%id, nc%radius_varid, self%radius, start=[idslot, tslot]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb radius_varid"  )

         if (param%lrotation) then
            call netcdf_io_check( nf90_put_var(nc%id, nc%Ip_varid, self%Ip(:), start=[1, idslot, tslot], count=[NDIM,1,1]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb Ip_varid"  )
            call netcdf_io_check( nf90_put_var(nc%id, nc%rot_varid, self%rot(:) * RAD2DEG, start=[1, idslot, tslot], &
                                               count=[NDIM,1,1]), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb rot_varid"  )
            
            call netcdf_io_check( nf90_put_var(nc%id, nc%rotphase_varid, self%rotphase * RAD2DEG, start = [tslot]), & 
                                  "swiftest_io_netcdf_write_frame_cb nf90_put_var cb rotphase")
            
            if (nc%lc_lm_exists) then
               call netcdf_io_check( nf90_put_var(nc%id, nc%c_lm_varid, self%c_lm, count = [nc%m_dim_max, nc%l_dim_max, 2]), &
                                       "netcdf_io_write_frame_cb nf90_put_var c_lm_varid")
            else
               call netcdf_io_check( nf90_put_var(nc%id, nc%j2rp2_varid, self%j2rp2, start=[tslot]), &
                                    "swiftest_io_netcdf_write_frame_cb nf90_put_var cb j2rp2_varid" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%j4rp4_varid, self%j4rp4, start=[tslot]), &
                                    "swiftest_io_netcdf_write_frame_cb nf90_put_var cb j4rp4_varid" )
            end if
         end if

         call netcdf_io_check( nf90_set_fill(nc%id, old_mode, tmp), &
                                  "swiftest_io_netcdf_write_frame_cb nf90_set_fill old_mode"  )
      end associate

      return
   end subroutine swiftest_io_netcdf_write_frame_cb


   module subroutine swiftest_io_netcdf_write_frame_system(self, nc, param)
      !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Write a frame (header plus records for each massive body and active test particle) to a output binary file
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self  !! Swiftest nbody_system object
      class(swiftest_netcdf_parameters), intent(inout) :: nc    !! Parameters used to for writing a NetCDF dataset to file
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters 

      call self%write_hdr(nc, param)
#ifdef COARRAY
      if (this_image() == 1) then
#endif
         call self%cb%write_frame(nc, param)
         call self%pl%write_frame(nc, param)
#ifdef COARRAY
      end if ! this_image() == 1
#endif
      call self%tp%write_frame(nc, param)

      return
   end subroutine swiftest_io_netcdf_write_frame_system


   module subroutine swiftest_io_netcdf_write_hdr_system(self, nc, param) 
      !! author: David A. Minton
      !!
      !! Writes header information (variables that change with time, but not particle id). 
      !! This subroutine swiftest_significantly improves the output over the original binary file, allowing us to track energy,
      !! momentum, and other quantities that previously were handled as separate output files.
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(in)    :: self  !! Swiftest nbody system object
      class(swiftest_netcdf_parameters), intent(inout) :: nc    !! Parameters used to for writing a NetCDF dataset to file
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B) :: tslot

      call nc%find_tslot(self%t, tslot)
      call netcdf_io_check( nf90_put_var(nc%id, nc%time_varid, self%t, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var time_varid"  )
      call netcdf_io_check( nf90_put_var(nc%id, nc%npl_varid, self%pl%nbody, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var npl_varid"  )
#ifndef COARRAY
      call netcdf_io_check( nf90_put_var(nc%id, nc%ntp_varid, self%tp%nbody, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var ntp_varid"  )
#endif
      if (param%lmtiny_pl) call netcdf_io_check( nf90_put_var(nc%id, nc%nplm_varid, self%pl%nplm, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var nplm_varid"  )

      if (param%lenergy) then
         call netcdf_io_check( nf90_put_var(nc%id, nc%KE_orb_varid, self%ke_orbit, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var KE_orb_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%KE_spin_varid, self%ke_spin, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var KE_spin_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%PE_varid, self%pe, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var PE_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%BE_varid, self%be, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var BE_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%TE_varid, self%te, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var TE_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%L_orbit_varid, self%L_orbit(:), start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_write_hdr_system nf90_put_var L_orbit_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%L_spin_varid, self%L_spin(:), start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_write_hdr_system nf90_put_var L_spin_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%L_escape_varid, self%L_escape(:), start=[1,tslot], count=[NDIM,1]), &
                                  "netcdf_io_write_hdr_system nf90_put_var L_escape_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%E_collisions_varid, self%E_collisions, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var E_collisions_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%E_untracked_varid, self%E_untracked, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var E_untracked_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%GMescape_varid, self%GMescape, start=[tslot]), &
                                  "netcdf_io_write_hdr_system nf90_put_var GMescape_varid"  )
      end if

      return
   end subroutine swiftest_io_netcdf_write_hdr_system


   module subroutine swiftest_io_netcdf_write_info_body(self, nc, param)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Write all current particle information metadata to file
      implicit none
      ! Arguments
      class(swiftest_body),              intent(in)    :: self  !! Swiftest particle object
      class(swiftest_netcdf_parameters), intent(inout) :: nc      !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B)                              :: i, j, idslot, old_mode, tmp
      integer(I4B), dimension(:), allocatable   :: ind
      character(len=NAMELEN) :: charstring
      character(len=NAMELEN), dimension(self%nbody) :: origin_type

      call netcdf_io_check( nf90_set_fill(nc%id, NF90_NOFILL, old_mode), &
                                  "netcdf_io_write_info_body nf90_set_fill NF90_NOFILL"  )

      select type(self)
         class is (swiftest_body)
         associate(n => self%nbody, tslot => nc%tslot)
            if (n == 0) return
            call util_sort(self%id(1:n), ind)
            call nc%get_idvals()

            do i = 1, n
               j = ind(i)
               call nc%find_idslot(self%id(j), idslot) 
               call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid, self%id(j), start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var id_varid"  )
               call netcdf_io_check( nf90_put_var(nc%id, nc%status_varid, self%status(j), start=[idslot,tslot]), &
                                  "netcdf_io_write_info_body nf90_put_var status_varid"  )

               charstring = trim(adjustl(self%info(j)%name))
               call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                  "netcdf_io_write_info_body nf90_put_var name_varid"  )

               charstring = trim(adjustl(self%info(j)%particle_type))
               call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                  "netcdf_io_write_info_body nf90_put_var particle_type_varid"  )

               if (param%lclose) then
                  charstring = trim(adjustl(self%info(j)%origin_type))
                  origin_type(i) = charstring
                  call netcdf_io_check( nf90_put_var(nc%id, nc%origin_type_varid, charstring, start=[1, idslot], &
                                                     count=[NAMELEN, 1]), &
                                  "netcdf_io_write_info_body nf90_put_var origin_type_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%origin_time_varid,  self%info(j)%origin_time,  start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var origin_time_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%origin_rh_varid,    self%info(j)%origin_rh(:), start=[1,idslot], &
                                                     count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var origin_rh_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%origin_vh_varid,    self%info(j)%origin_vh(:), start=[1,idslot], &
                                                     count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var origin_vh_varid"  )
   
                  call netcdf_io_check( nf90_put_var(nc%id, nc%collision_id_varid, self%info(j)%collision_id, start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var collision_id_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%discard_time_varid, self%info(j)%discard_time, start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var discard_time_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%discard_rh_varid,   self%info(j)%discard_rh(:), start=[1,idslot], &
                                                     count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var discard_rh_varid"  )
                  call netcdf_io_check( nf90_put_var(nc%id, nc%discard_vh_varid,   self%info(j)%discard_vh(:), start=[1,idslot], &
                                                     count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var discard_vh_varid"  )
               end if

            end do
         end associate
      end select

      call netcdf_io_check( nf90_set_fill(nc%id, old_mode, tmp) )
      return
   end subroutine swiftest_io_netcdf_write_info_body


   module subroutine swiftest_io_netcdf_write_info_cb(self, nc, param)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Write the central body info to file
      implicit none
      class(swiftest_cb),               intent(in)    :: self  !! Swiftest particle object
      class(swiftest_netcdf_parameters), intent(inout) :: nc      !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),           intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B)                              :: idslot, old_mode, tmp
      character(len=NAMELEN) :: charstring

      ! This string of spaces of length NAMELEN is used to clear out any old data left behind inside the string variables
      call netcdf_io_check( nf90_set_fill(nc%id, NF90_NOFILL, old_mode), &
                                  "netcdf_io_write_info_cb nf90_set_fill NF90_NOFILL"  )

      call nc%find_idslot(self%id, idslot) 

      call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid, self%id, start=[idslot]), &
                                  "netcdf_io_write_info_cb nf90_put_var id_varid"  )

      charstring = trim(adjustl(self%info%name))
      call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                  "netcdf_io_write_info_cb nf90_put_var name_varid"  )

      charstring = trim(adjustl(self%info%particle_type))
      call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                  "netcdf_io_write_info_cb nf90_put_var ptype_varid"  )

      if (param%lclose) then
         charstring = trim(adjustl(self%info%origin_type))
         call netcdf_io_check( nf90_put_var(nc%id, nc%origin_type_varid, charstring, start=[1, idslot], count=[NAMELEN, 1]), &
                                  "netcdf_io_write_info_body nf90_put_var cb origin_type_varid"  )

         call netcdf_io_check( nf90_put_var(nc%id, nc%origin_time_varid, self%info%origin_time, start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var cb origin_time_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%origin_rh_varid, self%info%origin_rh(:), start=[1, idslot], count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var cb origin_rh_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%origin_vh_varid, self%info%origin_vh(:), start=[1, idslot], count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var cb origin_vh_varid"  )

         call netcdf_io_check( nf90_put_var(nc%id, nc%collision_id_varid, self%info%collision_id, start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var cb collision_id_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%discard_time_varid, self%info%discard_time, start=[idslot]), &
                                  "netcdf_io_write_info_body nf90_put_var cb discard_time_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%discard_rh_varid, self%info%discard_rh(:), start=[1, idslot], &
                                            count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var cb discard_rh_varid"  )
         call netcdf_io_check( nf90_put_var(nc%id, nc%discard_vh_varid, self%info%discard_vh(:), start=[1, idslot], &
                                            count=[NDIM,1]), &
                                  "netcdf_io_write_info_body nf90_put_var cb discard_vh_varid"  )
      end if
      call netcdf_io_check( nf90_set_fill(nc%id, old_mode, tmp) )

      return
   end subroutine swiftest_io_netcdf_write_info_cb


   module subroutine swiftest_io_remove_nul_char(string)
      !! author: David A. Minton
      !!
      !! Remove spaces and trailing NUL characters that are introduced by NetCDF strings
      implicit none
      ! Arguments
      character(len=*), intent(inout) :: string !! String to make upper case
      ! Internals
      integer(I4B) :: pos
  
      pos = index(string, achar(0)) - 1
      if (pos > 0) then
         string = trim(adjustl(string(1:pos)))
      else
         string = trim(adjustl(string))
      end if

      return
   end subroutine swiftest_io_remove_nul_char


   module subroutine swiftest_io_param_reader(self, unit, iotype, v_list, iostat, iomsg) 
      !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Read in parameters for the integration
      !! as the newline characters are ignored in the input file when compiled in ifort.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine io_init_param.f90
      !! Adapted from Martin Duncan's Swift routine io_init_param.f
      implicit none
      ! Arguments
      class(swiftest_parameters), intent(inout) :: self       !! Collection of parameters
      integer(I4B),               intent(in)    :: unit       !! File unit number
      character(len=*),           intent(in)    :: iotype     !! Dummy argument passed to the  input/output procedure contains the 
                                                              !!    text from the char-literal-constant, prefixed with DT. 
                                                              !!    If you do not include a char-literal-constant, the iotype 
                                                              !!    argument contains only DT.
      character(len=*),           intent(in)    :: v_list(:)  !! The first element passes the integrator code to the reader
      integer(I4B),               intent(out)   :: iostat     !! IO status code
      character(len=*),           intent(inout) :: iomsg      !! Message to pass if iostat /= 0
      ! Internals
      logical                        :: tstart_set = .false.              !! Is the final time set in the input file?
      logical                        :: tstop_set = .false.               !! Is the final time set in the input file?
      logical                        :: dt_set = .false.                  !! Is the step size set in the input file?
      integer(I4B)                   :: ilength, ifirst, ilast, i         !! Variables used to parse input file
      character(STRMAX)              :: line                              !! Line of the input file
      character(len=:), allocatable  :: line_trim,param_name, param_value !! Strings used to parse the param file
      character(*),parameter         :: linefmt = '(A)'                   !! Format code for simple text string
      integer(I4B)                   :: nseeds, nseeds_from_file
      logical                        :: seed_set = .false.      !! Is the random seed set in the input file?
      real(DP)                       :: tratio, y
#ifdef COARRAY
      type(swiftest_parameters), codimension[*], save :: coparam
     
   if (this_image() == 1) then
      coparam = self
      associate(param => coparam) 
#else
      associate(param => self) 
#endif
         ! Parse the file line by line, extracting tokens then matching them up with known parameters if possible
         call random_seed(size = nseeds)
         if (allocated(param%seed)) deallocate(param%seed)
         allocate(param%seed(nseeds))
         open(unit = unit, file = param%param_file_name, status = 'old', err = 667, iomsg = iomsg)
         do
            read(unit = unit, fmt = linefmt, end = 1, err = 667, iomsg = iomsg) line
            line_trim = trim(adjustl(line))
            ilength = len(line_trim)
            if ((ilength /= 0)) then 
               ifirst = 1
               ! Read the pair of tokens. The first one is the parameter name, the second is the value.
               param_name = swiftest_io_get_token(line_trim, ifirst, ilast, iostat)
               if (param_name == '') cycle ! No parameter name (usually because this line is commented out)
               call swiftest_io_toupper(param_name)
               ifirst = ilast + 1
               param_value = swiftest_io_get_token(line_trim, ifirst, ilast, iostat)
               select case (param_name)
               case ("T0")
                  read(param_value, *, err = 667, iomsg = iomsg) param%t0
               case ("TSTART")
                  read(param_value, *, err = 667, iomsg = iomsg) param%tstart
                  tstart_set = .true.                  
               case ("TSTOP")
                  read(param_value, *, err = 667, iomsg = iomsg) param%tstop
                  tstop_set = .true.
               case ("DT")
                  read(param_value, *, err = 667, iomsg = iomsg) param%dt
                  dt_set = .true.
               case ("CB_IN")
                  param%incbfile = param_value
               case ("PL_IN")
                  param%inplfile = param_value
               case ("TP_IN")
                  param%intpfile = param_value
               case ("NC_IN")
                  param%nc_in = param_value
               case ("IN_TYPE")
                  call swiftest_io_toupper(param_value)
                  param%in_type = param_value
               case ("IN_FORM")
                  call swiftest_io_toupper(param_value)
                  param%in_form = param_value
               case ("ISTEP_OUT")
                  read(param_value, *) param%istep_out
               case ("NSTEP_OUT")
                  read(param_value, *) param%nstep_out
               case ("BIN_OUT")
                  param%outfile = param_value
               case ("OUT_TYPE")
                  call swiftest_io_toupper(param_value)
                  param%out_type = param_value
               case ("OUT_FORM")
                  call swiftest_io_toupper(param_value)
                  param%out_form = param_value
               case ("OUT_STAT")
                  call swiftest_io_toupper(param_value)
                  param%out_stat = param_value
               case ("DUMP_CADENCE")
                  read(param_value, *, err = 667, iomsg = iomsg) param%dump_cadence
               case ("CHK_CLOSE")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%lclose = .true.
               case ("CHK_RMIN")
                  read(param_value, *, err = 667, iomsg = iomsg) param%rmin
               case ("CHK_RMAX")
                  read(param_value, *, err = 667, iomsg = iomsg) param%rmax
               case ("CHK_EJECT")
                  read(param_value, *, err = 667, iomsg = iomsg) param%rmaxu
               case ("CHK_QMIN")
                  read(param_value, *, err = 667, iomsg = iomsg) param%qmin
               case ("CHK_QMIN_COORD")
                  call swiftest_io_toupper(param_value)
                  param%qmin_coord = param_value
               case ("CHK_QMIN_RANGE")
                  read(param_value, *, err = 667, iomsg = iomsg) param%qmin_alo
                  ifirst = ilast + 2
                  param_value = swiftest_io_get_token(line, ifirst, ilast, iostat)
                  read(param_value, *, err = 667, iomsg = iomsg) param%qmin_ahi
               case ("EXTRA_FORCE")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%lextra_force = .true.
               case ("BIG_DISCARD")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T' ) param%lbig_discard = .true.
               case ("RHILL_PRESENT")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T' ) param%lrhill_present = .true.
               case ("MU2KG")
                  read(param_value, *, err = 667, iomsg = iomsg) param%MU2KG
               case ("TU2S")
                  read(param_value, *, err = 667, iomsg = iomsg) param%TU2S
               case ("DU2M")
                  read(param_value, *, err = 667, iomsg = iomsg) param%DU2M
               case ("ENERGY")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%lenergy = .true.
               case ("GR")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%lgr = .true. 
               case ("ROTATION")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%lrotation = .true. 
               case ("TIDES")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%ltides = .true. 
               case ("INTERACTION_LOOPS")
                  call swiftest_io_toupper(param_value)
                  param%interaction_loops = param_value
               case ("ENCOUNTER_CHECK_PLPL")
                  call swiftest_io_toupper(param_value)
                  param%encounter_check_plpl = param_value
               case ("ENCOUNTER_CHECK_PLTP")
                  call swiftest_io_toupper(param_value)
                  param%encounter_check_pltp = param_value
               case ("ENCOUNTER_CHECK")
                  call swiftest_io_toupper(param_value)
                  param%encounter_check_plpl = param_value
                  param%encounter_check_pltp = param_value
               case ("FIRSTKICK")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "NO" .or. param_value == 'F') param%lfirstkick = .false. 
               case ("FIRSTENERGY")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "NO" .or. param_value == 'F') param%lfirstenergy = .false. 
               case("EORBIT_ORIG")
                  read(param_value, *, err = 667, iomsg = iomsg) param%E_orbit_orig 
               case("GMTOT_ORIG")
                  read(param_value, *, err = 667, iomsg = iomsg) param%GMtot_orig 
               case("LTOT_ORIG")
                  read(param_value, *, err = 667, iomsg = iomsg) param%L_total_orig(1)
                  do i = 2, NDIM
                     ifirst = ilast + 2
                     param_value = swiftest_io_get_token(line, ifirst, ilast, iostat) 
                     read(param_value, *, err = 667, iomsg = iomsg) param%L_total_orig(i)
                  end do
               case("LORBIT_ORIG")
                  read(param_value, *, err = 667, iomsg = iomsg) param%L_orbit_orig(1)
                  do i = 2, NDIM
                     ifirst = ilast + 2
                     param_value = swiftest_io_get_token(line, ifirst, ilast, iostat) 
                     read(param_value, *, err = 667, iomsg = iomsg) param%L_orbit_orig(i)
                  end do
               case("LSPIN_ORIG")
                  read(param_value, *, err = 667, iomsg = iomsg) param%L_spin_orig(1)
                  do i = 2, NDIM
                     ifirst = ilast + 2
                     param_value = swiftest_io_get_token(line, ifirst, ilast, iostat) 
                     read(param_value, *, err = 667, iomsg = iomsg) param%L_spin_orig(i)
                  end do
               case("LESCAPE")
                  read(param_value, *, err = 667, iomsg = iomsg) param%L_escape(1)
                  do i = 2, NDIM
                     ifirst = ilast + 2
                     param_value = swiftest_io_get_token(line, ifirst, ilast, iostat) 
                     read(param_value, *, err = 667, iomsg = iomsg) param%L_escape(i)
                  end do
               case("GMESCAPE")
                  read(param_value, *, err = 667, iomsg = iomsg) param%GMescape 
               case("ECOLLISIONS")
                  read(param_value, *, err = 667, iomsg = iomsg) param%E_collisions
               case("EUNTRACKED")
                  read(param_value, *, err = 667, iomsg = iomsg) param%E_untracked
               case ("COLLISION_MODEL")
                  call swiftest_io_toupper(param_value)
                  read(param_value, *) param%collision_model
               case ("GMTINY")
                  read(param_value, *) param%GMTINY
               case ("MIN_GMFRAG")
                  read(param_value, *) param%min_GMfrag
               case ("NFRAG_REDUCTION")
                  read(param_value, *) param%nfrag_reduction
               case ("ENCOUNTER_SAVE")
                  call swiftest_io_toupper(param_value)
                  read(param_value, *) param%encounter_save
               case ("COARRAY")
                  call swiftest_io_toupper(param_value)
                  if (param_value == "YES" .or. param_value == 'T') param%lcoarray = .true. 
               case("SEED")
                  read(param_value, *) nseeds_from_file
                  ! Because the number of seeds can vary between compilers/systems, we need to make sure we can handle cases in 
                  ! which the input file has a different number of seeds than the current nbody_system. If the number of seeds in 
                  ! the file is smaller than required, we will use them as a source to fill in the missing elements.
                  ! If the number of seeds in the file is larger than required, we will truncate the seed array.
                  if (nseeds_from_file > nseeds) then
                     nseeds = nseeds_from_file
                     deallocate(param%seed)
                     allocate(param%seed(nseeds))
                     do i = 1, nseeds
                        ifirst = ilast + 2
                        param_value = swiftest_io_get_token(line, ifirst, ilast, iostat) 
                        read(param_value, *) param%seed(i)
                     end do
                  else ! Seed array in file is too small
                     do i = 1, nseeds_from_file
                        ifirst = ilast + 2
                        param_value = swiftest_io_get_token(line, ifirst, ilast, iostat) 
                        read(param_value, *) param%seed(i)
                     end do
                     param%seed(nseeds_from_file+1:nseeds) = [(param%seed(1) - param%seed(nseeds_from_file) + i, &
                                                               i=nseeds_from_file+1, nseeds)]
                  end if
                  seed_set = .true.
               case ("RESTART")
                  if (param_value == "NO" .or. param_value == 'F') then
                     param%lrestart = .false. 
                  else if (param_value == "YES" .or. param_value == 'T') then
                     param%lrestart = .true.
                  end if 
               ! Ignore SyMBA-specific, not-yet-implemented, or obsolete input parameters
               case ("NPLMAX", "NTPMAX", "YARKOVSKY", "YORP")
               case default
                  write(*,*) "Ignoring unknown parameter -> ",param_name
               end select
            end if
         end do
         1 continue
         close(unit)
         iostat = 0

         ! Do basic sanity checks on the input values
         if ((.not. tstart_set) .or. (.not. tstop_set) .or. (.not. dt_set)) then
            write(iomsg,*) 'Valid simulation time not set'
            iostat = -1
            return
         end if
         if (param%dt <= 0.0_DP) then
            write(iomsg,*) 'Invalid timestep: '
            iostat = -1
            return
         end if
         if (param%inplfile == "") then
            write(iomsg,*) 'No valid massive body file in input file'
            iostat = -1
            return
         end if
         if ((param%in_type /= "ASCII") .and. (param%in_type /= "NETCDF_FLOAT") .and. (param%in_type /= "NETCDF_DOUBLE"))  then
            write(iomsg,*) 'Invalid input file type:',trim(adjustl(param%in_type))
            iostat = -1
            return
         end if
         if (param%istep_out <= 0) then
            write(iomsg,*) 'Invalid ISTEP_OUT. Must be a positive integer'
            iostat = -1
            return
         end if
         if (param%nstep_out <= 0) then
            param%nstep_out = int((param%tstop - param%t0) / (param%istep_out * param%dt))
            param%fstep_out = 1.0_DP ! Linear output time
            param%ltstretch = .false.
         else
            param%fstep_out = 1._DP
            tratio = (param%TSTOP - param%T0) / (param%istep_out * param%dt)
            if (int(tratio) == param%nstep_out) then
               param%ltstretch = .false.
            else
               param%ltstretch = .true.
               y = time_stretcher(param%fstep_out) 
               call solve_roots(time_stretcher,param%fstep_out)
            end if
         end if
         if (param%dump_cadence < 0) then
            write(iomsg,*) 'Invalid DUMP_CADENCE. Must be a positive integer or 0.'
            iostat = -1
            return
         end if
         if ((param%istep_out > 0) .and. (param%outfile == "")) then
            write(iomsg,*) 'Invalid outfile'
            iostat = -1
            return
         end if
         param%lrestart = (param%out_stat == "APPEND")
         if (param%outfile /= "") then
            if ((param%out_type /= "NETCDF_FLOAT") .and. (param%out_type /= "NETCDF_DOUBLE")) then
               write(iomsg,*) 'Invalid out_type: ',trim(adjustl(param%out_type))
               iostat = -1
               return
            end if
            if ((param%out_form /= "EL") .and. (param%out_form /= "XV") .and. (param%out_form /= "XVEL")) then
               write(iomsg,*) 'Invalid out_form: ',trim(adjustl(param%out_form))
               iostat = -1
               return
            end if
            if ((param%out_stat /= "NEW") .and. (param%out_stat /= "REPLACE") .and. (param%out_stat /= "APPEND")  &
          .and. (param%out_stat /= "UNKNOWN")) then
               write(iomsg,*) 'Invalid out_stat: ',trim(adjustl(param%out_stat))
               iostat = -1
               return
            end if
         end if
         if (param%qmin > 0.0_DP) then
            if ((param%qmin_coord /= "HELIO") .and. (param%qmin_coord /= "BARY")) then
               write(iomsg,*) 'Invalid qmin_coord: ',trim(adjustl(param%qmin_coord))
               iostat = -1
               return
            end if
            if ((param%qmin_alo <= 0.0_DP) .or. (param%qmin_ahi <= 0.0_DP)) then
               write(iomsg,*) 'Invalid qmin vals'
               iostat = -1
               return
            end if
         end if
         if (param%ltides .and. .not. param%lrotation) then
            write(iomsg,*) 'Tides require rotation to be turned on'
            iostat = -1
            return
         end if

         if ((param%MU2KG < 0.0_DP) .or. (param%TU2S < 0.0_DP) .or. (param%DU2M < 0.0_DP)) then
            write(iomsg,*) 'Invalid unit conversion factor'
            iostat = -1
            return
         end if

         ! Calculate the G for the nbody_system units
         param%GU = GC / (param%DU2M**3 / (param%MU2KG * param%TU2S**2))


         if ((param%encounter_save /= "NONE")       .and. &
             (param%encounter_save /= "TRAJECTORY") .and. &
             (param%encounter_save /= "CLOSEST")    .and. &
             (param%encounter_save /= "BOTH")) then
            write(iomsg,*) 'Invalid encounter_save parameter: ',trim(adjustl(param%out_type))
            write(iomsg,*) 'Valid options are NONE, TRAJECTORY, CLOSEST, or BOTH'
            iostat = -1
            return
         end if

         param%lenc_save_trajectory = (param%encounter_save == "TRAJECTORY") .or. (param%encounter_save == "BOTH")
         param%lenc_save_closest = (param%encounter_save == "CLOSEST") .or. (param%encounter_save == "BOTH")

         if ((param%integrator == INT_RMVS) .or. (param%integrator == INT_SYMBA)) then
            if (.not.param%lclose) then
               write(iomsg,*) 'This integrator requires CHK_CLOSE to be enabled.'
               iostat = -1
               return
            end if
         end if

         param%lmtiny_pl = (param%integrator == INT_SYMBA) 

         if (param%lmtiny_pl .and. param%GMTINY < 0.0_DP) then
            write(iomsg,*) "GMTINY invalid or not set: ", param%GMTINY
            iostat = -1
            return
         end if

         if ((param%collision_model /= "MERGE")       .and. &
             (param%collision_model /= "BOUNCE")    .and. &
             (param%collision_model /= "FRAGGLE")) then
            write(iomsg,*) 'Invalid collision_model parameter: ',trim(adjustl(param%out_type))
            write(iomsg,*) 'Valid options are MERGE, BOUNCE, or FRAGGLE'
            iostat = -1
            return
         end if

         if (param%collision_model == "FRAGGLE" ) then
            if (seed_set) then
               call random_seed(put = param%seed)
            else
               call random_seed(get = param%seed)
            end if
            if (param%min_GMfrag < 0.0_DP) param%min_GMfrag = param%GMTINY
            if (param%nfrag_reduction < 1.0_DP) then
               write(iomsg,*) "Warning: NFRAG_REDUCTION value invalid. Setting to 1.0" 
               param%nfrag_reduction = 1.0_DP
            end if
         end if
   
         ! Determine if the GR flag is set correctly for this integrator
         select case(param%integrator)
         case(INT_WHM, INT_RMVS, INT_HELIO, INT_SYMBA)
         case default   
            if (param%lgr) write(iomsg, *) 'GR is not yet implemented for this integrator. This parameter will be ignored.'
            param%lgr = .false.
         end select

         if (param%lgr) then
            ! Calculate the inverse speed of light in the nbody_system units
            param%inv_c2 = einsteinC * param%TU2S / param%DU2M
            param%inv_c2 = (param%inv_c2)**(-2)
         end if

         select case(trim(adjustl(param%interaction_loops)))
         case("TRIANGULAR")
            param%lflatten_interactions = .false.
         case("FLAT")
            param%lflatten_interactions = .true.
         case default
            write(*,*) "Unknown value for parameter INTERACTION_LOOPS: -> ",trim(adjustl(param%interaction_loops))
            write(*,*) "Must be one of the following: TRIANGULAR or FLAT"
            write(*,*) "Using default value of TRIANGULAR"
            param%interaction_loops = "TRIANGULAR"
            param%lflatten_interactions = .false.
         end select

         select case(trim(adjustl(param%encounter_check_plpl)))
         case("TRIANGULAR")
            param%lencounter_sas_plpl = .false.
         case("SORTSWEEP")
            param%lencounter_sas_plpl = .true.
         case default
            write(*,*) "Unknown value for parameter ENCOUNTER_CHECK_PLPL: -> ",trim(adjustl(param%encounter_check_plpl))
            write(*,*) "Must be one of the following: TRIANGULAR or SORTSWEEP"
            write(*,*) "Using default value of TRIANGULAR"
            param%encounter_check_plpl = "TRIANGULAR"
            param%lencounter_sas_plpl = .false.
         end select

         select case(trim(adjustl(param%encounter_check_pltp)))
         case("TRIANGULAR")
            param%lencounter_sas_pltp = .false.
         case("SORTSWEEP")
            param%lencounter_sas_pltp = .true.
         case default
            write(*,*) "Unknown value for parameter ENCOUNTER_CHECK_PLTP: -> ",trim(adjustl(param%encounter_check_pltp))
            write(*,*) "Must be one of the following: TRIANGULAR or SORTSWEEP"
            write(*,*) "Using default value of TRIANGULAR"
            param%encounter_check_pltp = "TRIANGULAR"
            param%lencounter_sas_pltp = .false.
         end select


         if (param%lcoarray) then
#ifdef COARRAY
            if (num_images() == 1) then
               write(iomsg, *) "Only one Coarray image detected. Coarrays will not be used."
               param%lcoarray = .false.
            end if

            select case(param%integrator)
            case(INT_WHM, INT_RMVS, INT_HELIO)
            case default   
               write(iomsg, *) "Coarray-based parallelization of test particles are not compatible with this integrator. " &
                            // "This parameter will be ignored."
               param%lcoarray = .false.
            end select
#else
            write(iomsg,*) "Coarray capability not detected. Swiftest must be compiled with Coarrays enabled. to use this feature."
            param%lcoarray = .false.
#endif
         end if

         iostat = 0

      end associate

#ifdef COARRAY
   end if ! this_image() == 1
      call coparam%coclone()
#endif
      select type(param => self)
      type is (swiftest_parameters)
#ifdef COARRAY
         param = coparam
#endif
         call param%set_display(param%display_style)

         if (.not.param%lrestart) then
#ifdef COARRAY
            if (this_image() == 1 .or. param%log_output) then
#endif
               call param%writer(unit = param%display_unit, iotype = "none", v_list = [0], iostat = iostat, iomsg = iomsg)
               if (param%log_output) flush(param%display_unit) 
#ifdef COARRAY
            end if !(this_image() == 1)
            write(COLLISION_LOG_OUT,'("collision_coimage",I0.3,".log")') this_image()
#endif
            ! A minimal log of collision outcomes is stored in the following log file
            ! More complete data on collisions is stored in the NetCDF output files
            call swiftest_io_log_start(param, COLLISION_LOG_OUT, "Collision logfile")
         end if
         ! Print the contents of the parameter file to standard output
      end select

      return 
      667 continue
      write(*,*) "Error reading param file: ", trim(adjustl(iomsg))

      contains
         function time_stretcher(fstep_out) result(ans)
            !! author: David A. Minton
            !!
            !! Equation for the time stretchinf function. Solving the roots of this equation gives the time stretching factor for 
            !! non-linear file output cadence.
            implicit none
            ! Arguments
            real(DP), intent(in) :: fstep_out
            ! Result
            real(DP)             :: ans

            if (abs(fstep_out-1.0_DP) < epsilon(1.0_DP)) then
               ans = self%nstep_out - tratio
            else
               ans = (1.0_DP - fstep_out**(self%nstep_out))/ (1.0_DP - fstep_out) - tratio
            end if

            return
         end function time_stretcher

   end subroutine swiftest_io_param_reader


   module subroutine swiftest_io_param_writer(self, unit, iotype, v_list, iostat, iomsg) 
      !! author: David A. Minton
      !!
      !! Dump integration parameters to file
      !!
      !! Adapted from David E. Kaufmann's Swifter routine io_param_restart.f90
      !! Adapted from Martin Duncan's Swift routine io_param_restart.f
      implicit none
      ! Arguments
      class(swiftest_parameters),intent(in)     :: self       !! Collection of parameters
      integer, intent(in)                       :: unit       !! File unit number
      character(len=*), intent(in)              :: iotype     !! Dummy argument passed to the  input/output procedure contains the 
                                                              !! text from the char-literal-constant, prefixed with DT. 
                                                              !!    If you do not include a char-literal-constant, the iotype 
                                                              !!    argument contains only DT.
      integer, intent(in)                       :: v_list(:)  !! Not used in this procedure
      integer, intent(out)                      :: iostat     !! IO status code
      character(len=*), intent(inout)           :: iomsg      !! Message to pass if iostat /= 0
      ! Internals
      integer(I4B)                   :: nseeds

      associate(param => self)
         call io_param_writer_one("T0", param%t0, unit)
         call io_param_writer_one("TSTART", param%tstart, unit)
         call io_param_writer_one("TSTOP", param%tstop, unit)
         call io_param_writer_one("DT", param%dt, unit)
         call io_param_writer_one("IN_TYPE", param%in_type, unit)
         if (param%in_type == "ASCII") then
            call io_param_writer_one("CB_IN", param%incbfile, unit)
            call io_param_writer_one("PL_IN", param%inplfile, unit)
            call io_param_writer_one("TP_IN", param%intpfile, unit)
         else 
            call io_param_writer_one("NC_IN", param%nc_in, unit)
         end if

         call io_param_writer_one("IN_FORM", param%in_form, unit)
         if (param%dump_cadence > 0) call io_param_writer_one("DUMP_CADENCE",param%dump_cadence, unit)
         if (param%istep_out > 0) then
            call io_param_writer_one("ISTEP_OUT", param%istep_out, unit)
            call io_param_writer_one("BIN_OUT", param%outfile, unit)
            call io_param_writer_one("OUT_TYPE", param%out_type, unit)
            call io_param_writer_one("OUT_FORM", param%out_form, unit)
            call io_param_writer_one("OUT_STAT", "APPEND", unit) 
         end if
         call io_param_writer_one("CHK_RMIN", param%rmin, unit)
         call io_param_writer_one("CHK_RMAX", param%rmax, unit)
         call io_param_writer_one("CHK_EJECT", param%rmaxu, unit)
         call io_param_writer_one("CHK_QMIN", param%qmin, unit)
         if (param%qmin >= 0.0_DP) then
            call io_param_writer_one("CHK_QMIN_COORD", param%qmin_coord, unit)
            call io_param_writer_one("CHK_QMIN_RANGE", [param%qmin_alo, param%qmin_ahi], unit)
         end if
         call io_param_writer_one("MU2KG", param%MU2KG, unit)
         call io_param_writer_one("TU2S", param%TU2S , unit)
         call io_param_writer_one("DU2M", param%DU2M, unit)
         call io_param_writer_one("RHILL_PRESENT", param%lrhill_present, unit)
         call io_param_writer_one("EXTRA_FORCE", param%lextra_force, unit)
         call io_param_writer_one("CHK_CLOSE", param%lclose, unit)
         call io_param_writer_one("ENERGY", param%lenergy, unit)
         call io_param_writer_one("GR", param%lgr, unit)
         call io_param_writer_one("ROTATION", param%lrotation, unit)
         call io_param_writer_one("TIDES", param%ltides, unit)
         call io_param_writer_one("INTERACTION_LOOPS", param%interaction_loops, unit)
         call io_param_writer_one("ENCOUNTER_CHECK_PLPL", param%encounter_check_plpl, unit)
         call io_param_writer_one("ENCOUNTER_CHECK_PLTP", param%encounter_check_pltp, unit)
         call io_param_writer_one("ENCOUNTER_SAVE", param%encounter_save, unit)
         call io_param_writer_one("COARRAY", param%lcoarray, unit)

         if (param%lenergy) then
            call io_param_writer_one("FIRSTENERGY", param%lfirstenergy, unit)
         end if
         call io_param_writer_one("FIRSTKICK",param%lfirstkick, unit)

         if (param%GMTINY >= 0.0_DP) call io_param_writer_one("GMTINY",param%GMTINY, unit)
         if (param%min_GMfrag >= 0.0_DP) call io_param_writer_one("MIN_GMFRAG",param%min_GMfrag, unit)
         call io_param_writer_one("COLLISION_MODEL",param%collision_model, unit)
         if (param%collision_model == "FRAGGLE" ) then
            call io_param_writer_one("NFRAG_REDUCTION",param%nfrag_reduction, unit)
            nseeds = size(param%seed)
            call random_seed(get = param%seed)
            call io_param_writer_one("SEED", [nseeds, param%seed(:)], unit)
         end if
   
         iostat = 0
         iomsg = "UDIO not implemented"
      end associate

      return
   end subroutine swiftest_io_param_writer


   module subroutine swiftest_io_param_writer_one_char(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for character param_value type
      implicit none
      ! Arguments
      character(len=*), intent(in) :: param_name  !! Name of parameter to print
      character(len=*), intent(in) :: param_value !! Value of parameter to print
      integer(I4B),     intent(in) :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=NAMELEN) :: param_name_fixed_width !! Parameter label converted to fixed-width string
      character(len=STRMAX)  :: iomsg             !! Message to pass if iostat /= 0

      write(param_name_fixed_width, *) param_name
      write(unit, *, err = 667, iomsg = iomsg) adjustl(param_name_fixed_width) // " " // trim(adjustl(param_value)) 

      return
      667 continue
      write(*,*) 'Error writing parameter: ',trim(adjustl(iomsg))
   end subroutine swiftest_io_param_writer_one_char


   module subroutine swiftest_io_param_writer_one_DP(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for real(DP) param_value type
      implicit none
      ! Arguments
      character(len=*), intent(in)    :: param_name  !! Name of parameter to print
      real(DP),         intent(in)    :: param_value !! Value of parameter to print
      integer(I4B),     intent(in)    :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string   !! Parameter value converted to a string
      character(*),parameter :: Rfmt  = '(ES25.17)' !! Format label for real values 

      write(param_value_string,Rfmt) param_value
      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_DP


   module subroutine swiftest_io_param_writer_one_DParr(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for real(DP) arrays () param_value type
      implicit none
      ! Arguments
      character(len=*),       intent(in) :: param_name  !! Name of parameter to print
      real(DP), dimension(:), intent(in) :: param_value !! Value of parameter to print
      integer(I4B),           intent(in) :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string   !! Parameter value converted to a string
      character(*),parameter :: Rfmt  = '(ES25.17)' !! Format label for real values 
      character(len=25) :: arr_val
      integer(I4B) :: i, narr

      narr = size(param_value)
      do i = 1, narr
         write(arr_val, Rfmt) param_value(i)
         if (i == 1) then
            write(param_value_string, *) arr_val
         else
            param_value_string = trim(adjustl(param_value_string)) // " " // arr_val
         end if
      end do

      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_DParr


   module subroutine swiftest_io_param_writer_one_I4B(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for integer(I4B) param_value type
      implicit none
      ! Arguments
      character(len=*), intent(in) :: param_name  !! Name of parameter to print
      integer(I4B),     intent(in) :: param_value !! Value of parameter to print
      integer(I4B),     intent(in) :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string   !! Parameter value converted to a string
      character(*),parameter :: Ifmt  = '(I0)'      !! Format label for integer values

      write(param_value_string,Ifmt) param_value
      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_I4B


   module subroutine swiftest_io_param_writer_one_I8B(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for integer(I8B) param_value type
      implicit none
      ! Arguments
      character(len=*), intent(in)    :: param_name  !! Name of parameter to print
      integer(I8B),     intent(in)    :: param_value !! Value of parameter to print
      integer(I4B),     intent(in)    :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string   !! Parameter value converted to a string
      character(*),parameter :: Ifmt  = '(I0)'      !! Format label for integer values

      write(param_value_string,Ifmt) param_value
      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_I8B


   module subroutine swiftest_io_param_writer_one_I4Barr(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for integer(I4B) arrays param_value type
      implicit none
      ! Arguments
      character(len=*),           intent(in) :: param_name  !! Name of parameter to print
      integer(I4B), dimension(:), intent(in) :: param_value !! Value of parameter to print
      integer(I4B),               intent(in) :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string !! Parameter value converted to a string
      character(*),parameter :: Ifmt  = '(I0)'    !! Format label for integer values
      character(len=25) :: arr_val
      integer(I4B) :: i, narr

      narr = size(param_value)
      do i = 1, narr
         write(arr_val, Ifmt) param_value(i)
         if (i == 1) then
            write(param_value_string, *) trim(adjustl(arr_val))
         else
            param_value_string = trim(adjustl(param_value_string)) // " " // trim(adjustl(arr_val))
         end if
      end do

      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_I4Barr


   module subroutine swiftest_io_param_writer_one_logical(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for logical param_value type
      implicit none
      ! Arguments
      character(len=*), intent(in) :: param_name  !! Name of parameter to print
      logical,          intent(in) :: param_value !! Value of parameter to print
      integer(I4B),     intent(in) :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string   !! Parameter value converted to a string
      character(*),parameter :: Lfmt  = '(L1)'         !! Format label for logical values 

      write(param_value_string,Lfmt) param_value
      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_logical

#ifdef QUADPREC
   module subroutine swiftest_io_param_writer_one_QP(param_name, param_value, unit)
      !! author: David A. Minton
      !!
      !! Writes a single parameter name/value pair to a file unit. 
      !! This version is for real(QP) param_value type
      implicit none
      ! Arguments
      character(len=*), intent(in) :: param_name  !! Name of parameter to print
      real(QP),         intent(in) :: param_value !! Value of parameter to print
      integer(I4B),     intent(in) :: unit        !! Open file unit number to print parameter to
      ! Internals
      character(len=STRMAX) :: param_value_string   !! Parameter value converted to a string
      character(*),parameter :: Rfmt  = '(ES25.17)' !! Format label for real values 

      write(param_value_string,Rfmt) param_value
      call io_param_writer_one(param_name, param_value_string, unit)

      return
   end subroutine swiftest_io_param_writer_one_QP
#endif

   module subroutine swiftest_io_read_in_body(self, param) 
      !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Read in either test particle or massive body data 
      !!
      !! Adapted from David E. Kaufmann's Swifter routine swiftest_init_pl.f90 and swiftest_init_tp.f90
      !! Adapted from Martin Duncan's Swift routine swiftest_init_pl.f and swiftest_init_tp.f
      implicit none
      ! Arguments
      class(swiftest_body),       intent(inout) :: self   !! Swiftest particle object
      class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B)                  :: iu = LUN
      integer(I4B)                  :: i, nbody
      character(len=:), allocatable :: infile
      character(STRMAX)             :: errmsg
      ! Internals
      integer(I4B)                                :: ierr  !! Error code: returns 0 if the read is successful

      ! Select the appropriate polymorphic class (test particle or massive body)
      if (param%in_type /= "ASCII") return ! Not for NetCDF

      select type(self)
      class is (swiftest_pl)
         infile = param%inplfile
      class is (swiftest_tp)
         infile = param%intpfile
      end select

      open(unit = iu, file = infile, status = 'old', form = 'FORMATTED', err = 667, iomsg = errmsg)
      read(iu, *, err = 667, iomsg = errmsg) nbody

      call self%setup(nbody, param)
      ierr = 0
      if (nbody > 0) then
         ierr = self%read_frame(iu, param)
         self%status(:) = ACTIVE
         self%lmask(:) = .true.
         do i = 1, nbody
            call self%info(i)%set_value(status="ACTIVE")
         end do
      end if
      close(iu, err = 667, iomsg = errmsg)

      if (ierr == 0) return

      667 continue
      write(*,*) 'Error reading in initial conditions file: ',trim(adjustl(errmsg))
      return
   end subroutine swiftest_io_read_in_body


   module subroutine swiftest_io_read_in_cb(self, param) 
      !! author: David A. Minton
      !!
      !! Reads in central body data 
      !!
      !! Adapted from David E. Kaufmann's Swifter routine swiftest_init_pl.f90
      !! Adapted from Martin Duncan's Swift routine swiftest_init_pl.f
      implicit none
      ! Arguments
      class(swiftest_cb),         intent(inout) :: self
      class(swiftest_parameters), intent(inout) :: param
      ! Internals
      integer(I4B)            :: iu = LUN
      character(len=STRMAX)   :: errmsg
      integer(I4B)            :: ierr
      character(len=NAMELEN)  :: name

      if (param%in_type /= "ASCII") return ! Not for NetCDF

      self%id = 0
      open(unit = iu, file = param%incbfile, status = 'old', form = 'FORMATTED', err = 667, iomsg = errmsg)
      read(iu, *, err = 667, iomsg = errmsg) name
      call self%info%set_value(name=name)
      read(iu, *, err = 667, iomsg = errmsg) self%Gmass
      self%mass = real(self%Gmass / param%GU, kind=DP)
      read(iu, *, err = 667, iomsg = errmsg) self%radius
      read(iu, *, err = 667, iomsg = errmsg) self%j2rp2
      read(iu, *, err = 667, iomsg = errmsg) self%j4rp4
      if (param%lrotation) then
         read(iu, *, err = 667, iomsg = errmsg) self%Ip(1), self%Ip(2), self%Ip(3)
         read(iu, *, err = 667, iomsg = errmsg) self%rot(1), self%rot(2), self%rot(3)
         self%rot(:) = self%rot(:) * DEG2RAD
      end if
      ierr = 0
      close(iu, err = 667, iomsg = errmsg)

      if (ierr == 0) then
   
         if (param%rmin < 0.0) param%rmin = self%radius
         
         self%GM0 = self%Gmass
         self%dGM = 0.0_DP
         self%R0 = self%radius
         if (param%lrotation) then
            self%L0(:) = self%Ip(3) * self%mass * self%radius**2 * self%rot(:)
            self%dL(:) = 0.0_DP
         end if
      end if
      return

      667 continue
      write(*,*) "Error reading central body file: " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,param%display_unit)
   end subroutine swiftest_io_read_in_cb


   module subroutine swiftest_io_read_in_system(self, nc, param)
      !! author: David A. Minton and Carlisle A. Wishard
      !!
      !! Reads in the nbody_system from input files
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self
      class(swiftest_netcdf_parameters), intent(inout) :: nc     !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param
      ! Internals
      integer(I4B) :: ierr, i
      class(swiftest_parameters), allocatable :: tmp_param

      if (param%in_type == "ASCII") then
         call self%cb%read_in(param)
         call self%pl%read_in(param)
         if (self%pl%nbody > 0) self%pl%id(:) = [(i, i = 1, self%pl%nbody)]
         call self%tp%read_in(param)
         if (self%tp%nbody > 0) self%tp%id(:) = [(i, i = self%pl%nbody + 1, self%pl%nbody + 1 + self%tp%nbody)]
         self%maxid = self%pl%nbody + self%tp%nbody
         ! Copy over param file variable inputs
         self%E_orbit_orig = param%E_orbit_orig
         self%GMtot_orig = param%GMtot_orig
         self%L_total_orig(:) = param%L_total_orig(:)
         self%L_orbit_orig(:) = param%L_orbit_orig(:)
         self%L_spin_orig(:) = param%L_spin_orig(:)
         self%L_escape(:) = param%L_escape(:)
         self%E_collisions = param%E_collisions
         self%E_untracked = param%E_untracked
      else
         allocate(tmp_param, source=param)
         nc%file_name = param%nc_in
         tmp_param%out_form = param%in_form
         if (.not. param%lrestart) then
            ! Turn off energy computation so we don't have to feed it into the initial conditions
            tmp_param%lenergy = .false.
         end if
         ierr = self%read_frame(nc, tmp_param)
         deallocate(tmp_param)
         if (ierr /=0) call base_util_exit(FAILURE,param%display_unit)
      end if

      param%lnon_spherical_cb = (self%cb%j2rp2 /= 0.0_DP) .or. (self%cb%j4rp4 /= 0.0_DP) .or. allocated(self%cb%c_lm)
      if (.not.param%lnon_spherical_cb) then
         if (allocated(self%pl%aobl)) deallocate(self%pl%aobl)
         if (allocated(self%tp%aobl)) deallocate(self%tp%aobl)
      else
         if (self%pl%nbody > 0) then
            if (.not. allocated(self%pl%aobl)) allocate(self%pl%aobl(NDIM,self%pl%nbody))
            self%pl%aobl(:,:) = 0.0_DP
         end if
         if (self%tp%nbody > 0) then
            if (.not. allocated(self%tp%aobl)) allocate(self%tp%aobl(NDIM,self%tp%nbody))
            self%tp%aobl(:,:) = 0.0_DP
         end if
      
      
      end if

      return
   end subroutine swiftest_io_read_in_system


   module function swiftest_io_read_frame_body(self, iu, param) result(ierr)
      !! author: David A. Minton
      !!
      !! Reads a frame of output of either test particle or massive body data from a binary output file
      !!
      !! Adapted from David E. Kaufmann's Swifter routine  io_read_frame.f90
      !! Adapted from Hal Levison's Swift routine io_read_frame.f
      implicit none
      ! Arguments
      class(swiftest_body),       intent(inout) :: self   !! Swiftest particle object
      integer(I4B),               intent(inout) :: iu     !! Unit number for the output file to write frame to
      class(swiftest_parameters), intent(inout) :: param  !! Current run configuration parameters 
      ! Result
      integer(I4B)                              :: ierr  !! Error code: returns 0 if the read is successful
      ! Internals
      character(len=STRMAX)   :: errmsg
      character(len=NAMELEN), dimension(self%nbody)  :: name
      integer(I4B) :: i
      real(QP)                      :: val

      if (self%nbody == 0) return

      if ((param%in_form /= "EL") .and. (param%in_form /= "XV")) then
         write(errmsg, *) trim(adjustl(param%in_form)) // " is not a recognized format code for input files."
         goto 667
      end if

      associate(n => self%nbody)

         if (param%in_form == "EL") then
            if (.not.allocated(self%a))     allocate(self%a(n))
            if (.not.allocated(self%e))     allocate(self%e(n))
            if (.not.allocated(self%inc))   allocate(self%inc(n))
            if (.not.allocated(self%capom)) allocate(self%capom(n))
            if (.not.allocated(self%omega)) allocate(self%omega(n))
            if (.not.allocated(self%capm))  allocate(self%capm(n))
         end if

         select case(param%in_type)
         case ("ASCII")
            do i = 1, n
               select type(self)
               class is (swiftest_pl)
                  if (param%lrhill_present) then
                     read(iu, *, err = 667, iomsg = errmsg) name(i), val, self%rhill(i)
                  else
                     read(iu, *, err = 667, iomsg = errmsg) name(i), val
                  end if
                  self%Gmass(i) = real(val, kind=DP)
                  self%mass(i) = real(val / param%GU, kind=DP)
                  if (param%lclose) read(iu, *, err = 667, iomsg = errmsg) self%radius(i)
               class is (swiftest_tp)
                  read(iu, *, err = 667, iomsg = errmsg) name(i)
               end select
               call self%info(i)%set_value(name=name(i))

               select case(param%in_form)
               case ("XV")
                  read(iu, *, err = 667, iomsg = errmsg) self%rh(1, i), self%rh(2, i), self%rh(3, i)
                  read(iu, *, err = 667, iomsg = errmsg) self%vh(1, i), self%vh(2, i), self%vh(3, i)
               case ("EL")
                  read(iu, *, err = 667, iomsg = errmsg) self%a(i), self%e(i), self%inc(i)
                  read(iu, *, err = 667, iomsg = errmsg) self%capom(i), self%omega(i), self%capm(i)
               end select

               select type (self)
               class is (swiftest_pl)
                  if (param%lrotation) then
                     read(iu, *, err = 667, iomsg = errmsg) self%Ip(1, i), self%Ip(2, i), self%Ip(3, i)
                     read(iu, *, err = 667, iomsg = errmsg) self%rot(1, i), self%rot(2, i), self%rot(3, i)
                     self%rot(:,i) = self%rot(:,i) * DEG2RAD 
                  end if
                  ! if (param%ltides) then
                  !    read(iu, *, err = 667, iomsg = errmsg) self%k2(i)
                  !    read(iu, *, err = 667, iomsg = errmsg) self%Q(i)
                  ! end if
               end select
            end do
         end select

         if (param%in_form == "EL") then
            self%inc(1:n)   = self%inc(1:n) * DEG2RAD
            self%capom(1:n) = self%capom(1:n) * DEG2RAD
            self%omega(1:n) = self%omega(1:n) * DEG2RAD
            self%capm(1:n)  = self%capm(1:n) * DEG2RAD
         end if
      end associate

      ierr = 0
      return

      667 continue
      select type (self)
      class is (swiftest_pl)
         write(*,*) "Error reading massive body file: " // trim(adjustl(errmsg))
      class is (swiftest_tp)
         write(*,*) "Error reading test particle file: " // trim(adjustl(errmsg))
      class default
         write(*,*) "Error reading body file: " // trim(adjustl(errmsg))
      end select
      call base_util_exit(FAILURE,param%display_unit)
   end function swiftest_io_read_frame_body


   module subroutine swiftest_io_read_in_param(self, param_file_name) 
      !! author: David A. Minton
      !!
      !! Read in parameters for the integration
      !!
      !! Adapted from David E. Kaufmann's Swifter routine io_init_param.f90
      !! Adapted from Martin Duncan's Swift routine io_init_param.f
      implicit none
      ! Arguments
      class(swiftest_parameters),intent(inout) :: self             !! Current run configuration parameters
      character(len=*), intent(in)             :: param_file_name !! Parameter input file name (i.e. param.in)
      ! Internals
      integer(I4B)      :: ierr = 0 !! Input error code
      character(STRMAX) :: errmsg   !! Error message in UDIO procedure

      ! Read in name of parameter file
      self%param_file_name = trim(adjustl(param_file_name))

      !! todo: Currently this procedure does not work in user-defined derived-type input mode 
      !!    as the newline characters are ignored in the input file when compiled in ifort.

      !read(LUN,'(DT)', iostat= ierr, iomsg = errmsg) self
      call self%reader(LUN, iotype= "none", v_list=[""], iostat = ierr, iomsg = errmsg)
      if (ierr == 0) return

      write(self%display_unit,*) "Error reading parameter file: " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE)
   end subroutine swiftest_io_read_in_param


   module subroutine swiftest_io_set_display_param(self, display_style)
      !! author: David A. Minton
      !!
      !! Sets the display style parameters. If display is "STANDARD" then output goes to stdout. If display is "COMPACT" 
      !! then it is redirected to a log file and a progress-bar is used for stdout
      implicit none
      ! Arguments
      class(swiftest_parameters), intent(inout) :: self            !! Current run configuration parameters
      character(*),               intent(in)    :: display_style   !! Style of the output display 
      ! Internals
      character(STRMAX) :: errmsg
      logical           :: fileExists   

      select case(display_style)
      case ('STANDARD')
         self%display_unit = OUTPUT_UNIT !! stdout from iso_fortran_env
         self%log_output = .false.
      case ('COMPACT', 'PROGRESS')
#ifdef COARRAY
         if (self%lcoarray) then
            write(SWIFTEST_LOG_FILE,'("swiftest_coimage",I0.3,".log")') this_image()
         else
            write(SWIFTEST_LOG_FILE,'("swiftest.log")')
         end if 
#endif
         inquire(file=SWIFTEST_LOG_FILE, exist=fileExists)
         if (self%lrestart.and.fileExists) then
            open(unit=SWIFTEST_LOG_OUT, file=SWIFTEST_LOG_FILE, status="OLD", position="APPEND", err = 667, iomsg = errmsg)
         else
            open(unit=SWIFTEST_LOG_OUT, file=SWIFTEST_LOG_FILE, status="REPLACE", err = 667, iomsg = errmsg)
         end if
         self%display_unit = SWIFTEST_LOG_OUT 
         self%log_output = .true.
      case default
         write(*,*) display_style, " is an unknown display style"
         call base_util_exit(USAGE)
      end select

      self%display_style = display_style

      return

      667 continue
      write(*,*) "Error opening swiftest log file: " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,self%display_unit)
   end subroutine swiftest_io_set_display_param


   module subroutine swiftest_io_toupper(string)
      !! author: David A. Minton
      !!
      !! Convert string to uppercase
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: util_toupper.f90
      implicit none
      ! Arguments
      character(*), intent(inout) :: string !! String to make upper case
      ! Internals
      integer(I4B) :: i, length, idx
   
      length = len(string)
      do i = 1, length
         idx = iachar(string(i:i))
         if ((idx >= lowercase_begin) .and. (idx <= lowercase_end)) then
            idx = idx + uppercase_offset
            string(i:i) = achar(idx)
         end if
      end do
   
      return
   end subroutine swiftest_io_toupper


   module subroutine swiftest_io_initialize_output_file_system(self, nc, param)
      !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Write a frame (header plus records for each massive body and active test particle) to output binary file
      !! There is no direct file output from this subroutine
      !!
      !! Adapted from David E. Kaufmann's Swifter routine  io_write_frame.f90
      !! Adapted from Hal Levison's Swift routine io_write_frame.f
      implicit none
      ! Arguments
      class(swiftest_nbody_system),      intent(inout) :: self   !! Swiftest nbody_system object
      class(swiftest_netcdf_parameters), intent(inout) :: nc     !! Parameters used to identify a particular NetCDF dataset
      class(swiftest_parameters),        intent(inout) :: param !! Current run configuration parameters 
      ! Internals

      character(len=2*STRMAX)          :: errmsg
      logical                          :: fileExists

      associate (pl => self%pl, tp => self%tp, npl => self%pl%nbody, ntp => self%tp%nbody, lfirst => self%lfirst_io)
         nc%file_name = param%outfile
         if (lfirst) then
            inquire(file=param%outfile, exist=fileExists)
#ifdef COARRAY
            if (this_image() /= 1) param%out_stat = 'APPEND'
#endif
            
            select case(param%out_stat)
            case('APPEND')
               if (.not.fileExists) then
                  errmsg = trim(adjustl(param%outfile)) // " not found! You must specify OUT_STAT = NEW, REPLACE, or UNKNOWN"
                  goto 667
               end if
               call nc%open(param)
            case('NEW')
               if (fileExists) then
                  errmsg = trim(adjustl(param%outfile))// " already exists! You must specify OUT_STAT = APPEND, REPLACE, or UNKNOWN"
                  goto 667
               end if
               call nc%initialize(param)
            case('REPLACE', 'UNKNOWN')
               call nc%initialize(param)
            end select

            lfirst = .false.
         end if

      end associate

      return

      667 continue
      write(*,*) "Error writing nbody_system frame: " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,param%display_unit)
   end subroutine swiftest_io_initialize_output_file_system

end submodule s_swiftest_io

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (coarray) s_coarray_collect
   use swiftest
contains

   module subroutine coarray_component_collect_DP_arr1D(var,dest_img)
      !! author: David A. Minton
      !!
      !! Collects components of a coarray derived type from all images and combines them into destination image component. 
      !! The default destination image is 1
      !! real(DP) 1D allocatable array version
      implicit none
      ! Arguments
      real(DP), dimension(:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: dest_img
      ! Internals
      real(DP), dimension(:), codimension[:], allocatable :: tmp
      integer(I4B) :: i,img, ti, di, istart, iend
      integer(I4B), allocatable :: n[:],nmax[:]
      logical, allocatable :: isalloc[:]
      real(DP), dimension(:), allocatable :: vari1

      allocate(isalloc[*])
      allocate(n[*])
      allocate(nmax[*])

      if (present(dest_img)) then
         di = dest_img
      else
         di = 1
      end if

      isalloc = allocated(var)
      if (isalloc) then
         n = size(var)
      else
         n = 0
      end if

      nmax = n
      call co_max(nmax)

      allocate(tmp(nmax)[*])
      if (isalloc) tmp(1:n) = var(1:n)

      if (this_image() == di) then
         do img = 1, num_images()
            if (img /= di) then
               if (allocated(vari1)) deallocate(vari1)
               allocate(vari1, source=tmp(1:n[img])[img])
               call util_append(var, vari1)
               n = n + n[img]
            end if
         end do
         sync images(*)
      else
         sync images(di)
         if (allocated(var)) deallocate(var)
      end if

      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_collect_DP_arr1D


   module subroutine coarray_component_collect_DP_vec2D(var,dest_img)
      !! author: David A. Minton
      !!
      !! Collects components of a coarray derived type from all images and combines them into destination image component . The default destination image is 1
      !! real(DP) 2D allocatable array version
      implicit none
      ! Arguments
      real(DP), dimension(:,:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: dest_img
      ! Internals
      real(DP), dimension(:,:), codimension[:], allocatable :: tmp
      integer(I4B) :: i, img, ti, di, istart, iend
      integer(I4B), allocatable :: n[:], nmax[:]
      logical, allocatable :: isalloc[:]
      real(DP), dimension(:,:), allocatable :: vari1

      allocate(n[*])
      allocate(nmax[*])
      allocate(isalloc[*])

      if (present(dest_img)) then
         di = dest_img
      else
         di = 1
      end if

      isalloc = allocated(var)
      if (isalloc) then
         n = size(var,dim=2)
      else
         n = 0
      end if
      nmax = n
      call co_max(nmax)

      allocate(tmp(NDIM,nmax)[*])
      if (isalloc) tmp(:,1:n) = var(:,1:n)

      if (this_image() == di) then
         do img = 1, num_images()
            if ((img /= di).and.(isalloc[img])) then
               if (allocated(vari1)) deallocate(vari1)
               allocate(vari1,source=tmp(:,1:n[img])[img])
               call util_append(var, vari1)
               n = n + n[img]
            end if
         end do
         sync images(*)
      else
         sync images(di)
         if (allocated(var)) deallocate(var)
      end if

      deallocate(isalloc,n,nmax,tmp)

      return
   end subroutine coarray_component_collect_DP_vec2D


   module subroutine coarray_component_collect_I4B_arr1D(var,dest_img)
      !! author: David A. Minton
      !!
      !! Collects components of a coarray derived type from all images and combines them into destination image component. 
      !! The default destination image is 1
      !! integer(I4B) 1D allocatable array version
      implicit none
      ! Arguments
      integer(I4B), dimension(:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: dest_img
      ! Internals
      integer(I4B), dimension(:), codimension[:], allocatable :: tmp
      integer(I4B) :: i,img, ti, di, istart, iend
      integer(I4B), allocatable, codimension[:] :: n, nmax
      logical, allocatable, codimension[:] :: isalloc[:]
      integer(I4B), dimension(:), allocatable :: vari1

      allocate(isalloc[*])
      allocate(n[*])
      allocate(nmax[*])

      if (present(dest_img)) then
         di = dest_img
      else
         di = 1
      end if

      isalloc = allocated(var)
      if (isalloc) then
         n = size(var)
      else
         n = 0
      end if
      nmax = n
      sync all
      call co_max(nmax)

      allocate(tmp(nmax)[*])
      if (isalloc) tmp(1:n) = var(1:n)

      if (this_image() == di) then
         do img = 1, num_images()
            if (img /= di) then
               if (allocated(vari1)) deallocate(vari1)
               allocate(vari1, source=tmp(1:n[img])[img])
               call util_append(var, vari1)
               n = n + n[img]
            end if
         end do
         sync images(*)
      else
         sync images(di)
         if (allocated(var)) deallocate(var)
      end if

      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_collect_I4B_arr1D


   module subroutine coarray_component_collect_lgt_arr1D(var,dest_img)
      !! author: David A. Minton
      !!
      !! Collects components of a coarray derived type from all images and combines them into destination image component. 
      !! The default destination image is 1
      !! logical 1D allocatable array version
      implicit none
      ! Arguments
      logical, dimension(:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: dest_img
      ! Internals
      logical, dimension(:), codimension[:], allocatable :: tmp
      integer(I4B) :: i,img, ti, di, ntot, istart, iend
      integer(I4B), allocatable :: n[:], nmax[:]
      logical, allocatable :: isalloc[:]
      logical, dimension(:), allocatable :: vari1

      allocate(isalloc[*])
      allocate(n[*])
      allocate(nmax[*])

      if (present(dest_img)) then
         di = dest_img
      else
         di = 1
      end if

      isalloc = allocated(var)
      if (isalloc) then
         n = size(var)
      else
         n = 0
      end if
      nmax = n
      call co_max(nmax)
      allocate(tmp(nmax)[*])
      if (isalloc) tmp(1:n) = var(1:n)

      if (this_image() == di) then
         do img = 1, num_images()
            if (img /= di) then
               if (allocated(vari1)) deallocate(vari1)
               allocate(vari1, source=tmp(1:n[img])[img])
               call util_append(var, vari1)
               n = n + n[img]
            end if
         end do
         sync images(*)
      else
         sync images(di)
         if (allocated(var)) deallocate(var)
      end if

      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_collect_lgt_arr1D

end submodule s_coarray_collect

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module encounter
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods used to determine close encounters
   use globals
   use base
   use netcdf_io
   implicit none
   public

   character(len=*), parameter :: ENCOUNTER_OUTFILE = 'encounters.nc'  !! Name of NetCDF output file for encounter information
   real(DP), parameter :: RSWEEP_FACTOR = 1.1_DP

   type, abstract :: encounter_list
      integer(I8B)                              :: nenc = 0   !! Total number of encounters
      real(DP)                                  :: t          !! Time of encounter
      logical                                   :: lcollision !! Indicates if the encounter resulted in at least one collision
      real(DP),     dimension(:),   allocatable :: tcollision !! Time of collision
      logical,      dimension(:),   allocatable :: lclosest   !! indicates that thie pair of bodies is in currently at its closest approach point
      logical,      dimension(:),   allocatable :: lvdotr     !! relative vdotr flag
      integer(I4B), dimension(:),   allocatable :: status     !! status of the interaction
      integer(I4B), dimension(:),   allocatable :: index1     !! position of the first body in the encounter
      integer(I4B), dimension(:),   allocatable :: index2     !! position of the second body in the encounter
      integer(I4B), dimension(:),   allocatable :: id1        !! id of the first body in the encounter
      integer(I4B), dimension(:),   allocatable :: id2        !! id of the second body in the encounter
      real(DP),     dimension(:,:), allocatable :: r1         !! the position of body 1 in the encounter
      real(DP),     dimension(:,:), allocatable :: r2         !! the position of body 2 in the encounter
      real(DP),     dimension(:,:), allocatable :: v1         !! the velocity of body 1 in the encounter
      real(DP),     dimension(:,:), allocatable :: v2         !! the velocity of body 2 in the encounter
      integer(I4B), dimension(:),   allocatable :: level      !! Recursion level (used in SyMBA)
   contains
      procedure :: setup   => encounter_util_setup_list        !! A constructor that sets the number of encounters and allocates and initializes all arrays  
      procedure :: append  => encounter_util_append_list  !! Appends elements from one structure to another
      procedure :: copy    => encounter_util_copy_list    !! Copies elements from the source encounter list into self.
      procedure :: dealloc => encounter_util_dealloc_list !! Deallocates all allocatables
      procedure :: spill   => encounter_util_spill_list   !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
      procedure :: resize  => encounter_util_resize_list  !! Checks the current size of the encounter list against the required size and extends it by a factor of 2 more than requested if it is too small.
   end type encounter_list
   

   type, extends(base_object) :: encounter_snapshot
      !! A simplified version of a SyMBA nbody system object for storing minimal snapshots of the system state during encounters
      class(base_object), allocatable :: pl    !! Massive body data structure
      class(base_object), allocatable :: tp    !! Test particle data structure
      real(DP)                        :: t     !! Simulation time when snapshot was taken
      integer(I8B)                    :: iloop !! Loop number at time of snapshot
   contains
      procedure :: write_frame => encounter_io_netcdf_write_frame_snapshot !! Writes a frame of encounter data to file 
      procedure :: dealloc     => encounter_util_dealloc_snapshot          !! Deallocates all allocatables
      procedure :: get_idvals  => encounter_util_get_idvalues_snapshot     !! Gets an array of all id values saved in this snapshot
      final     ::                encounter_final_snapshot
   end type encounter_snapshot

   !> NetCDF dimension and variable names for the enounter save object
   type, extends(netcdf_parameters) :: encounter_netcdf_parameters
   contains
      procedure :: initialize => encounter_io_netcdf_initialize_output !! Initialize a set of parameters used to identify a NetCDF output object
      procedure :: open       => encounter_io_netcdf_open              !! Open an encounter NetCDF file
      final     ::               encounter_final_netcdf_parameters     !! Finalizer will close the NetCDF file
   end type encounter_netcdf_parameters


   !> A class that that is used to store simulation history data between file output
   type, extends(base_storage) :: encounter_storage
      class(encounter_netcdf_parameters), allocatable :: nc             !! NetCDF object attached to this storage object
   contains
      procedure :: dump             => encounter_io_netcdf_dump        !! Dumps contents of encounter history to file
      procedure :: dealloc          => encounter_util_dealloc_storage  !! Deallocates all allocatables
      procedure :: get_index_values => encounter_util_get_vals_storage !! Gets the unique values of the indices of a storage object (i.e. body id or time value)
      procedure :: make_index_map   => encounter_util_index_map        !! Maps body id values to storage index values so we don't have to use unlimited dimensions for id
      procedure :: take_snapshot    => encounter_util_snapshot         !! Take a minimal snapshot of the system through an encounter
      final     ::                     encounter_final_storage
   end type encounter_storage


   type encounter_bounding_box_1D
      integer(I4B)                            :: n    !! Number of bodies with extents
      integer(I4B), dimension(:), allocatable :: ind  !! Sorted minimum/maximum extent indices (value > n indicates an ending index)
      integer(I8B), dimension(:), allocatable :: ibeg !! Beginning index for box
      integer(I8B), dimension(:), allocatable :: iend !! Ending index for box
   contains
      procedure :: sort    => encounter_check_sort_aabb_1D !! Sorts the bounding box extents along a single dimension prior to the sweep phase
      procedure :: dealloc => encounter_util_dealloc_aabb  !! Deallocates all allocatables
      final     ::            encounter_final_aabb    !! Finalize the axis-aligned bounding box (1D) - deallocates all allocatables
   end type


   type encounter_bounding_box
      type(encounter_bounding_box_1D) :: aabb
   contains
      procedure :: dealloc      => encounter_util_dealloc_bounding_box    !! Deallocates all allocatables
      procedure :: setup        => encounter_util_setup_aabb              !! Setup a new axis-aligned bounding box structure
      procedure :: sweep_single => encounter_check_sweep_aabb_single_list !! Sweeps the sorted bounding box extents and returns the encounter candidates
      procedure :: sweep_double => encounter_check_sweep_aabb_double_list !! Sweeps the sorted bounding box extents and returns the encounter candidates
      generic   :: sweep        => sweep_single, sweep_double
      final     ::                 encounter_final_bounding_box
   end type


   interface
      module subroutine encounter_check_all_plpl(param, npl, r, v, renc, dt, nenc, index1, index2, lvdotr)
         use base, only: base_parameters
         implicit none
         class(base_parameters),                  intent(inout) :: param  !! Current Swiftest run configuration parameter5s
         integer(I4B),                            intent(in)    :: npl    !! Total number of massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: r      !! Position vectors of massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: v      !! Velocity vectors of massive bodies
         real(DP),     dimension(:),              intent(in)    :: renc   !! Critical radii of massive bodies that defines an encounter 
         real(DP),                                intent(in)    :: dt     !! Step size
         logical,      dimension(:), allocatable, intent(out)   :: lvdotr !! Logical flag indicating the sign of v .dot. x
         integer(I4B), dimension(:), allocatable, intent(out)   :: index1 !! List of indices for body 1 in each encounter
         integer(I4B), dimension(:), allocatable, intent(out)   :: index2 !! List of indices for body 2 in each encounter
         integer(I8B),                            intent(out)   :: nenc   !! Total number of encounters
      end subroutine encounter_check_all_plpl

      module subroutine encounter_check_all_plplm(param, nplm, nplt, rplm, vplm, rplt, vplt, rencm, renct, dt, &
                                                  nenc, index1, index2, lvdotr)
         use base, only: base_parameters
         implicit none
         class(base_parameters),                  intent(inout) :: param  !! Current Swiftest run configuration parameter5s
         integer(I4B),                            intent(in)    :: nplm   !! Total number of fully interacting massive bodies 
         integer(I4B),                            intent(in)    :: nplt   !! Total number of partially interacting masive bodies (GM < GMTINY) 
         real(DP),     dimension(:,:),            intent(in)    :: rplm   !! Position vectors of fully interacting massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: vplm   !! Velocity vectors of fully interacting massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: rplt   !! Position vectors of partially interacting massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: vplt   !! Velocity vectors of partially interacting massive bodies
         real(DP),     dimension(:),              intent(in)    :: rencm  !! Critical radii of fully interacting massive bodies that defines an encounter
         real(DP),     dimension(:),              intent(in)    :: renct  !! Critical radii of partially interacting massive bodies that defines an encounter
         real(DP),                                intent(in)    :: dt     !! Step size
         integer(I8B),                            intent(out)   :: nenc   !! Total number of encounters
         integer(I4B), dimension(:), allocatable, intent(out)   :: index1 !! List of indices for body 1 in each encounter
         integer(I4B), dimension(:), allocatable, intent(out)   :: index2 !! List of indices for body 2 in each encounter
         logical,      dimension(:), allocatable, intent(out)   :: lvdotr !! Logical flag indicating the sign of v .dot. x
      end subroutine encounter_check_all_plplm

      module subroutine encounter_check_all_pltp(param, npl, ntp, rpl, vpl, rtp, vtp, renc, dt, nenc, index1, index2, lvdotr)
         use base, only: base_parameters
         implicit none
         class(base_parameters),                  intent(inout) :: param  !! Current Swiftest run configuration parameter5s
         integer(I4B),                            intent(in)    :: npl    !! Total number of massive bodies 
         integer(I4B),                            intent(in)    :: ntp    !! Total number of test particles 
         real(DP),     dimension(:,:),            intent(in)    :: rpl    !! Position vectors of massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: vpl    !! Velocity vectors of massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: rtp    !! Position vectors of massive bodies
         real(DP),     dimension(:,:),            intent(in)    :: vtp    !! Velocity vectors of massive bodies
         real(DP),     dimension(:),              intent(in)    :: renc   !! Critical radii of massive bodies that defines an encounter
         real(DP),                                intent(in)    :: dt     !! Step size
         integer(I8B),                            intent(out)   :: nenc   !! Total number of encounters
         integer(I4B), dimension(:), allocatable, intent(out)   :: index1 !! List of indices for body 1 in each encounter
         integer(I4B), dimension(:), allocatable, intent(out)   :: index2 !! List of indices for body 2 in each encounter
         logical,      dimension(:), allocatable, intent(out)   :: lvdotr !! Logical flag indicating the sign of v .dot. x
      end subroutine encounter_check_all_pltp

      elemental module subroutine encounter_check_one(xr, yr, zr, vxr, vyr, vzr, renc, dt, lencounter, lvdotr)
         !$omp declare simd(encounter_check_one)
         implicit none
         real(DP), intent(in)  :: xr, yr, zr    !! Relative distance vector components
         real(DP), intent(in)  :: vxr, vyr, vzr !! Relative velocity vector components
         real(DP), intent(in)  :: renc          !! Critical encounter distance
         real(DP), intent(in)  :: dt            !! Step size
         logical,  intent(out) :: lencounter    !! Flag indicating that an encounter has occurred
         logical,  intent(out) :: lvdotr        !! Logical flag indicating the direction of the v .dot. r vector
      end subroutine encounter_check_one

      module subroutine encounter_check_collapse_ragged_list(ragged_list, n1, nenc, index1, index2, lvdotr)
         implicit none
         class(encounter_list), dimension(:),             intent(in)            :: ragged_list !! The ragged encounter list
         integer(I4B),                                    intent(in)            :: n1          !! Number of bodies 1
         integer(I8B),                                    intent(out)           :: nenc        !! Total number of encountersj 
         integer(I4B),         dimension(:), allocatable, intent(out)           :: index1      !! Array of indices for body 1
         integer(I4B),         dimension(:), allocatable, intent(out)           :: index2      !! Array of indices for body 1
         logical,              dimension(:), allocatable, intent(out), optional :: lvdotr      !! Array indicating which bodies are approaching
      end subroutine encounter_check_collapse_ragged_list

      pure module subroutine encounter_check_sort_aabb_1D(self, n, extent_arr)
         implicit none
         class(encounter_bounding_box_1D), intent(inout) :: self       !! Bounding box structure along a single dimension
         integer(I4B),                     intent(in)    :: n          !! Number of bodies with extents
         real(DP), dimension(:),           intent(in)    :: extent_arr !! Array of extents of size 2*n
      end subroutine encounter_check_sort_aabb_1D

      module subroutine encounter_check_sweep_aabb_double_list(self, n1, n2, r1, v1, r2, v2, renc1, renc2, dt, &
                                                               nenc, index1, index2, lvdotr)
         implicit none
         class(encounter_bounding_box),           intent(inout) :: self       !! Multi-dimensional bounding box structure
         integer(I4B),                            intent(in)    :: n1         !! Number of bodies 1
         integer(I4B),                            intent(in)    :: n2         !! Number of bodies 2
         real(DP),     dimension(:,:),            intent(in)    :: r1, v1     !! Array of indices of bodies 1
         real(DP),     dimension(:,:),            intent(in)    :: r2, v2     !! Array of indices of bodies 2
         real(DP),     dimension(:),              intent(in)    :: renc1      !! Radius of encounter regions of bodies 1
         real(DP),     dimension(:),              intent(in)    :: renc2      !! Radius of encounter regions of bodies 2
         real(DP),                                intent(in)    :: dt         !! Step size
         integer(I8B),                            intent(out)   :: nenc       !! Total number of encounter candidates
         integer(I4B), dimension(:), allocatable, intent(out)   :: index1     !! List of indices for body 1 in each encounter candidate pair
         integer(I4B), dimension(:), allocatable, intent(out)   :: index2     !! List of indices for body 2 in each encounter candidate pair
         logical,      dimension(:), allocatable, intent(out)   :: lvdotr     !! Logical array indicating which pairs are approaching
      end subroutine encounter_check_sweep_aabb_double_list

      module subroutine encounter_check_sweep_aabb_single_list(self, n, r, v, renc, dt, nenc, index1, index2, lvdotr)
         implicit none
         class(encounter_bounding_box),           intent(inout) :: self       !! Multi-dimensional bounding box structure
         integer(I4B),                            intent(in)    :: n          !! Number of bodies
         real(DP),     dimension(:,:),            intent(in)    :: r, v       !! Array of position and velocity vectors 
         real(DP),     dimension(:),              intent(in)    :: renc       !! Radius of encounter regions of bodies 1
         real(DP),                                intent(in)    :: dt         !! Step size
         integer(I8B),                            intent(out)   :: nenc       !! Total number of encounter candidates
         integer(I4B), dimension(:), allocatable, intent(out)   :: index1     !! List of indices for one body in each encounter candidate pair
         integer(I4B), dimension(:), allocatable, intent(out)   :: index2     !! List of indices for the other body in each encounter candidate pair
         logical,      dimension(:), allocatable, intent(out)   :: lvdotr     !! Logical array indicating which pairs are approaching
      end subroutine encounter_check_sweep_aabb_single_list

      module subroutine encounter_io_netcdf_dump(self, param)
         implicit none
         class(encounter_storage), intent(inout)        :: self   !! Encounter storage object
         class(base_parameters),   intent(inout)        :: param  !! Current run configuration parameters 
      end subroutine encounter_io_netcdf_dump

      module subroutine encounter_io_netcdf_initialize_output(self, param)
         implicit none
         class(encounter_netcdf_parameters), intent(inout) :: self    !! Parameters used to identify a particular NetCDF dataset
         class(base_parameters),             intent(in)    :: param   
      end subroutine encounter_io_netcdf_initialize_output

      module subroutine encounter_io_netcdf_open(self, param, readonly)
         implicit none
         class(encounter_netcdf_parameters), intent(inout) :: self     !! Parameters used to identify a particular NetCDF dataset
         class(base_parameters),             intent(in)    :: param    !! Current run configuration parameters
         logical, optional,                  intent(in)    :: readonly !! Logical flag indicating that this should be open read only
      end subroutine encounter_io_netcdf_open

      module subroutine encounter_io_netcdf_write_frame_snapshot(self, history, param)
         implicit none
         class(encounter_snapshot), intent(in)    :: self    !! Swiftest encounter structure
         class(encounter_storage),  intent(inout) :: history !! Encounter storage object
         class(base_parameters),    intent(inout) :: param   !! Current run configuration parameters
      end subroutine encounter_io_netcdf_write_frame_snapshot

      module subroutine encounter_util_setup_aabb(self, n, n_last)
         implicit none
         class(encounter_bounding_box), intent(inout) :: self   !! Swiftest encounter structure
         integer(I4B),                  intent(in)    :: n      !! Number of objects with bounding box extents
         integer(I4B),                  intent(in)    :: n_last !! Number of objects with bounding box extents the previous time this was called
      end subroutine encounter_util_setup_aabb

      module subroutine encounter_util_setup_list(self, n)
         implicit none
         class(encounter_list), intent(inout) :: self !! Swiftest encounter structure
         integer(I8B),          intent(in)    :: n    !! Number of encounters to allocate space for
      end subroutine encounter_util_setup_list

      module subroutine encounter_util_append_list(self, source, lsource_mask)
         implicit none
         class(encounter_list), intent(inout)        :: self         !! Swiftest encounter list object
         class(encounter_list), intent(in)           :: source       !! Source object to append
         logical, dimension(:), intent(in)           :: lsource_mask !! Logical mask indicating which elements to append to
      end subroutine encounter_util_append_list

      module subroutine encounter_util_copy_list(self, source)
         implicit none
         class(encounter_list), intent(inout) :: self   !! Encounter list 
         class(encounter_list), intent(in)    :: source !! Source object to copy into
      end subroutine encounter_util_copy_list

      module subroutine encounter_util_dealloc_aabb(self)
         implicit none
         class(encounter_bounding_box_1D), intent(inout) :: self !!Bounding box structure along a single dimension
      end subroutine encounter_util_dealloc_aabb

      module subroutine encounter_util_dealloc_bounding_box(self)
         implicit none
         class(encounter_bounding_box), intent(inout) :: self !! Bounding box structure
      end subroutine encounter_util_dealloc_bounding_box

      module subroutine encounter_util_dealloc_list(self)
         implicit none
         class(encounter_list), intent(inout) :: self !! Swiftest encounter list object
      end subroutine encounter_util_dealloc_list

      module subroutine encounter_util_dealloc_snapshot(self)
         implicit none
         class(encounter_snapshot), intent(inout) :: self !! Encounter shapshot object
      end subroutine encounter_util_dealloc_snapshot

      module subroutine encounter_util_dealloc_storage(self)
         implicit none
         class(encounter_storage), intent(inout) :: self !! Swiftest storage object
      end subroutine encounter_util_dealloc_storage

      module subroutine encounter_util_get_idvalues_snapshot(self, idvals)
         implicit none
         class(encounter_snapshot),               intent(in)  :: self   !! Encounter snapshot object
         integer(I4B), dimension(:), allocatable, intent(out) :: idvals !! Array of all id values saved in this snapshot
      end subroutine encounter_util_get_idvalues_snapshot

      module subroutine encounter_util_get_vals_storage(self, idvals, tvals)
         class(encounter_storage), intent(in)               :: self   !! Encounter storages object
         integer(I4B), dimension(:),  allocatable, intent(out) :: idvals !! Array of all id values in all snapshots
         real(DP),     dimension(:),  allocatable, intent(out) :: tvals  !! Array of all time values in all snapshots
      end subroutine encounter_util_get_vals_storage 

      module subroutine encounter_util_index_map(self)
         implicit none
         class(encounter_storage), intent(inout) :: self  !! Encounter storage object
      end subroutine encounter_util_index_map

      module subroutine encounter_util_resize_list(self, nnew)
         implicit none
         class(encounter_list), intent(inout) :: self !! Swiftest encounter list 
         integer(I8B),          intent(in)    :: nnew !! New size of list needed
      end subroutine encounter_util_resize_list

      module subroutine encounter_util_snapshot(self, param, nbody_system, t, arg)
         implicit none
         class(encounter_storage),  intent(inout)        :: self         !! Swiftest storage object
         class(base_parameters),    intent(inout)        :: param        !! Current run configuration parameters
         class(base_nbody_system),  intent(inout)        :: nbody_system !! Swiftest nbody system object to store
         real(DP),                  intent(in), optional :: t            !! Time of snapshot if different from system time
         character(*),              intent(in), optional :: arg          !! Optional argument (needed for extended storage type used in collision snapshots)
      end subroutine encounter_util_snapshot

      module subroutine encounter_util_spill_list(self, discards, lspill_list, ldestructive)
         implicit none
         class(encounter_list), intent(inout) :: self         !! Swiftest encounter list 
         class(encounter_list), intent(inout) :: discards     !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter body by removing the discard list
      end subroutine encounter_util_spill_list

   end interface

   contains

      subroutine encounter_final_aabb(self)
         !! author: David A. Minton
         !!
         !! Finalize the axis aligned bounding box (1D) - deallocates all allocatables
         implicit none
         ! Arguments
         type(encounter_bounding_box_1D), intent(inout) :: self

         call self%dealloc()

         return
      end subroutine encounter_final_aabb

      subroutine encounter_final_bounding_box(self)
         !! author: David A. Minton
         !!
         !! Finalize the bounding box object
         implicit none
         ! Arguments
         type(encounter_bounding_box), intent(inout) :: self

         call self%dealloc()

         return
      end subroutine encounter_final_bounding_box


      subroutine encounter_final_netcdf_parameters(self)
         !! author: David A. Minton
         !!
         !! Finalize the NetCDF by closing the file
         implicit none
         ! Arguments
         type(encounter_netcdf_parameters), intent(inout) :: self

         call self%close()

         return
      end subroutine encounter_final_netcdf_parameters


      subroutine encounter_final_snapshot(self)
         !! author: David A. Minton
         !!
         !! Deallocates allocatable arrays in an encounter snapshot
         implicit none
         ! Arguments
         type(encounter_snapshot),  intent(inout) :: self !! Encounter storage object

         if (allocated(self%pl)) deallocate(self%pl)
         if (allocated(self%tp)) deallocate(self%tp)
         self%t = 0.0_DP

         return
      end subroutine encounter_final_snapshot


      subroutine encounter_final_storage(self)
         !! author: David A. Minton
         !!
         !! Deallocates allocatable arrays in an encounter snapshot
         implicit none
         ! Arguments
         type(encounter_storage),  intent(inout) :: self !! Encounter storage object

         call self%dealloc()

         return
      end subroutine encounter_final_storage

end module encounter

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (swiftest) s_swiftest_discard
contains

   module subroutine swiftest_discard_system(self, param)
      !! author: David A. Minton
      !!
      !! Calls the discard methods for each body class and then the write method if any discards were detected
      !!
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self   
         !! Swiftest nbody_system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters
      ! Internals
      logical :: lpl_check, ltp_check
      logical :: ldiscard_pl = .false. 
      logical :: ldiscard_tp = .false.

      lpl_check = allocated(self%pl_discards) .and. self%pl%nbody > 0
      ltp_check = allocated(self%tp_discards) .and. self%tp%nbody > 0

      associate(nbody_system => self,&
                tp => self%tp, &
                pl => self%pl,&
                npl => self%pl%nbody, &
                ntp => self%tp%nbody)
         if (lpl_check .and. npl > 0) then
            call pl%discard(nbody_system, param)
            ldiscard_pl = any(pl%ldiscard(:))
         end if
            
         if (ltp_check .and. ntp > 0) then
            call tp%discard(nbody_system, param)
            ldiscard_tp = any(tp%ldiscard(:)) 
         end if

         if (ldiscard_pl) call pl%rearray(nbody_system, param) 
         if (ldiscard_tp) call tp%rearray(nbody_system, param)
      end associate

      return
   end subroutine swiftest_discard_system


   module subroutine swiftest_discard_pl(self, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Placeholder method for discarding massive bodies. This method does nothing except to ensure that the discard flag is set 
      !! to false. This method is intended to be overridden by more advanced integrators.
      implicit none
      ! Arguments
      class(swiftest_pl),           intent(inout) :: self   
         !! Swiftest massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameter

      if (self%nbody == 0) return
      associate(pl => self, cb => nbody_system%cb)
         pl%ldiscard = pl%status(:) /= ACTIVE
         if ((param%rmin >= 0.0_DP) .or. (param%rmax >= 0.0_DP) .or. &
             (param%rmaxu >= 0.0_DP) .or. ((param%qmin >= 0.0_DP) .and. (param%qmin_coord == "BARY"))) call pl%h2b(cb) 

         if ((param%rmin >= 0.0_DP) .or. &
             (param%rmax >= 0.0_DP) .or. & 
             (param%rmaxu >= 0.0_DP)) call swiftest_discard_cb_body(pl, nbody_system, param)
         if (param%qmin >= 0.0_DP) call swiftest_discard_peri_body(pl, nbody_system, param)
      end associate

      return
   end subroutine swiftest_discard_pl


   module subroutine swiftest_discard_tp(self, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if particles should be discarded based on their positions relative to the massive bodies
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine: discard.f90
      !! Adapted from Hal Levison's Swift routine discard.
      implicit none
      ! Arguments
      class(swiftest_tp),           intent(inout) :: self   
         !! Swiftest test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameter

      if (self%nbody == 0) return

      associate(tp => self, cb => nbody_system%cb, pl => nbody_system%pl)
         tp%ldiscard = tp%status(:) /= ACTIVE
         if ((param%rmin >= 0.0_DP) .or. (param%rmax >= 0.0_DP) .or. &
             (param%rmaxu >= 0.0_DP) .or. ((param%qmin >= 0.0_DP) .and. (param%qmin_coord == "BARY"))) then
            call pl%h2b(cb) 
            call tp%h2b(cb) 
         end if

         if ((param%rmin >= 0.0_DP) .or. &
             (param%rmax >= 0.0_DP) .or. & 
             (param%rmaxu >= 0.0_DP)) call swiftest_discard_cb_body(tp, nbody_system, param)
         if (param%qmin >= 0.0_DP) call swiftest_discard_peri_body(tp, nbody_system, param)
         if (param%lclose) call swiftest_discard_pl_tp(tp, nbody_system, param)
      end associate

      return
   end subroutine swiftest_discard_tp


   subroutine swiftest_discard_cb_body(body, nbody_system, param)
      !! author: David A. Minton
      !!
      !!  Check to see if bodies (massive or test particle) should be discarded based on their positions relative to the Sun or 
      !!  because they are unbound from the nbody_system
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: discard_sun.f90
      !! Adapted from Hal Levison's Swift routine discard_sun.f
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: body   
         !! Swiftest body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters
      ! Internals
      integer(I4B)        :: i
      real(DP)            :: energy, vb2, rb2, rh2, rmin2, rmax2, rmaxu2
      character(len=STRMAX) :: idstr, timestr, message
      logical, allocatable, dimension(:) :: ldiscard

      associate(nbody => body%nbody, &
                cb => nbody_system%cb, &
                Gmtot => nbody_system%Gmtot, &
                t => nbody_system%t, &
                collider => nbody_system%collider, &
                impactors => nbody_system%collider%impactors, &
                collision_history => nbody_system%collision_history)

         rmin2 = max(param%rmin * param%rmin, cb%radius * cb%radius)
         rmax2 = param%rmax**2
         rmaxu2 = param%rmaxu**2
         do i = 1, nbody
            if (body%status(i) == ACTIVE) then
               rh2 = dot_product(body%rh(:, i), body%rh(:, i))
               if ((param%rmax >= 0.0_DP) .and. (rh2 > rmax2)) then
                  body%status(i) = DISCARDED_RMAX
                  write(idstr, *) body%id(i)
                  write(timestr, *) t
                  write(message, *) "Body " // trim(adjustl(body%info(i)%name)) // " ("  // trim(adjustl(idstr)) // ")" // &
                              " too far from the central body at t = " // trim(adjustl(timestr))
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                  body%ldiscard(i) = .true.
                  body%lmask(i) = .false.
                  call body%info(i)%set_value(status="DISCARDED_RMAX", discard_time=nbody_system%t, discard_rh=body%rh(:,i), &
                                            discard_vh=body%vh(:,i))
                  impactors%regime = REGIME_EJECTED 
               else if ((param%rmin >= 0.0_DP) .and. (rh2 < rmin2)) then
                  body%status(i) = DISCARDED_RMIN
                  write(idstr, *) body%id(i)
                  write(timestr, *) t
                  write(message, *) "Body " // trim(adjustl(body%info(i)%name)) // " ("  // trim(adjustl(idstr)) // ")" // &
                              " too close to the central body at t = " // trim(adjustl(timestr))
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                  body%ldiscard(i) = .true.
                  body%lmask(i) = .false.
                  call body%info(i)%set_value(status="DISCARDED_RMIN", discard_time=nbody_system%t, discard_rh=body%rh(:,i), &
                                            discard_vh=body%vh(:,i), discard_body_id=cb%id)
                  impactors%regime = REGIME_CB_IMPACT
               else if (param%rmaxu >= 0.0_DP) then
                  rb2 = dot_product(body%rb(:, i),  body%rb(:, i))
                  vb2 = dot_product(body%vb(:, i), body%vb(:, i))
                  energy = 0.5_DP * vb2 - Gmtot / sqrt(rb2)
                  if ((energy > 0.0_DP) .and. (rb2 > rmaxu2)) then
                     body%status(i) = DISCARDED_RMAXU
                     write(idstr, *) body%id(i)
                     write(timestr, *) t
                     write(message, *) "Body " // trim(adjustl(body%info(i)%name)) // " ("  // trim(adjustl(idstr)) // ")" // &
                                 " is unbound and too far from barycenter at t = " // trim(adjustl(timestr))
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                     body%ldiscard(i) = .true.
                     body%lmask(i) = .false.
                     call body%info(i)%set_value(status="DISCARDED_RMAXU", discard_time=nbody_system%t, discard_rh=body%rh(:,i), &
                                               discard_vh=body%vh(:,i))
                     impactors%regime = REGIME_EJECTED
                  end if
               end if

               ! Save the system snapshot
               if (body%ldiscard(i)) then
                  allocate(ldiscard, mold=body%ldiscard(:))
                  ldiscard(:) = .false.
                  ldiscard(i) = .true.
                  call body%save_discard(ldiscard,nbody_system,collider%before)
                  ! The base class doesn't do a before/after comparison, so we just save the before snapshot
                  call collision_history%take_snapshot(param,nbody_system, t, "particle") 
                  deallocate(ldiscard)
               end if
            end if
         end do
      end associate

      return
   end subroutine swiftest_discard_cb_body


   subroutine swiftest_discard_peri_body(body, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if a body (massive or test particle) should be discarded because its perihelion distance becomes too small
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: discard_peri.f90
      !! Adapted from Hal Levison's Swift routine discard_peri.f
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: body 
         !! Swiftest body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameterss
      ! Internals
      integer(I4B)              :: i, j, ih
      real(DP)                  :: r2
      real(DP), dimension(NDIM) :: dx
      character(len=STRMAX) :: idstr, timestr, message
      logical, allocatable, dimension(:) :: ldiscard
   
      associate(cb => nbody_system%cb, &
                nbody => body%nbody, &
                pl => nbody_system%pl, &
                npl => nbody_system%pl%nbody, &
                t => nbody_system%t, &
                collider => nbody_system%collider, &
                impactors => nbody_system%collider%impactors, &
                collision_history => nbody_system%collision_history)
         call body%get_peri(nbody_system, param)
         do i = 1, nbody
            if (body%status(i) == ACTIVE) then
               if (body%isperi(i) == 0) then
                  ! Check to make sure the body isn't too close to any of the planets, as this case will be handled elsewhere
                  ih = 1
                  do j = 1, npl
                     dx(:) = body%rh(:, i) - pl%rh(:, j)
                     r2 = dot_product(dx(:), dx(:))
                     if (r2 <= (pl%rhill(j))**2) ih = 0
                  end do
                  if (ih == 1) then
                     if ((body%atp(i) >= param%qmin_alo) .and.    &
                        (body%atp(i) <= param%qmin_ahi) .and.    &           
                        (body%peri(i) <= param%qmin)) then
                        body%status(i) = DISCARDED_PERI
                        write(idstr, *) body%id(i)
                        write(timestr, *) nbody_system%t
                        write(message, *) "Body " // trim(adjustl(body%info(i)%name)) // " ("  // trim(adjustl(idstr)) // ")" // &
                                    " perihelion distance too small at t = " // trim(adjustl(timestr))
                        
                        call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                        body%ldiscard(i) = .true.
                        call body%info(i)%set_value(status="DISCARDED_PERI", discard_time=nbody_system%t, discard_rh=body%rh(:,i), &
                                                  discard_vh=body%vh(:,i), discard_body_id=cb%id)

                        ! Save the system snapshot
                        impactors%regime = REGIME_CB_IMPACT
                        allocate(ldiscard, mold=body%ldiscard(:))
                        ldiscard(:) = .false.
                        ldiscard(i) = .true.
                        call body%save_discard(ldiscard,nbody_system,collider%before)
                        deallocate(ldiscard)
                        call collision_history%take_snapshot(param,nbody_system, t, "particle") 
                     end if
                  end if
               end if
            end if
         end do
      end associate

      return
   end subroutine swiftest_discard_peri_body


   subroutine swiftest_discard_pl_tp(tp, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Check to see if test particles should be discarded based on their positions relative to the massive bodies
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: discard_pl.f90
      !! Adapted from Hal Levison's Swift routine discard_pl.f
      implicit none
      ! Arguments
      class(swiftest_tp),           intent(inout) :: tp     
         !! Swiftest test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters
      ! Internals 
      integer(I4B)              :: i, j, isp
      real(DP)                  :: r2min, radius
      real(DP), dimension(NDIM) :: dx, dv
      character(len=STRMAX) :: idstri, idstrj, timestr, message
      logical, allocatable, dimension(:) :: ldiscard_tp, ldiscard_pl
   
      associate(ntp => tp%nbody, &
                pl => nbody_system%pl, &
                npl => nbody_system%pl%nbody, &
                t => nbody_system%t, &
                dt => param%dt, &
                collider => nbody_system%collider, &
                impactors => nbody_system%collider%impactors, &
                collision_history => nbody_system%collision_history)
         do i = 1, ntp
            if (tp%status(i) == ACTIVE) then
               do j = 1, npl
                  dx(:) = tp%rh(:, i) - pl%rh(:, j)
                  dv(:) = tp%vh(:, i) - pl%vh(:, j)
                  radius = pl%radius(j)
                  call swiftest_discard_pl_close(dx(:), dv(:), dt, radius**2, isp, r2min)
                  if (isp /= 0) then
                     tp%status(i) = DISCARDED_PLR
                     tp%lmask(i) = .false.
                     pl%ldiscard(j) = .true.
                     write(idstri, *) tp%id(i)
                     write(idstrj, *) pl%id(j)
                     write(timestr, *) nbody_system%t
                     write(message, *) "Particle " // trim(adjustl(tp%info(i)%name)) // " ("  // trim(adjustl(idstri)) // ")" &
                                                   // "  too close to massive body " // trim(adjustl(pl%info(j)%name)) // " (" &
                                                   // trim(adjustl(idstrj)) // ")" &
                                                   // " at t = " // trim(adjustl(timestr))
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
                     tp%ldiscard(i) = .true.
                     call tp%info(i)%set_value(status="DISCARDED_PLR", discard_time=nbody_system%t, discard_rh=tp%rh(:,i), &
                                               discard_vh=tp%vh(:,i), discard_body_id=pl%id(j))

                     ! Save the system snapshot
                     impactors%regime = COLLRESOLVE_REGIME_MERGE
                     allocate(ldiscard_tp, mold=tp%ldiscard(:))
                     allocate(ldiscard_pl, mold=pl%ldiscard(:))
                     ldiscard_tp(:) = .false.
                     ldiscard_pl(:) = .false.
                     ldiscard_tp(i) = .true.
                     ldiscard_pl(j) = .true.
                     call tp%save_discard(ldiscard_tp,nbody_system,collider%before)
                     call pl%save_discard(ldiscard_pl,nbody_system,collider%before)
                     call collision_history%take_snapshot(param,nbody_system, t, "before") 
                     call pl%save_discard(ldiscard_pl,nbody_system,collider%after)
                     call collision_history%take_snapshot(param,nbody_system, t, "after") 
                     deallocate(ldiscard_tp, ldiscard_pl)
                     exit
                  end if
               end do
            end if
         end do
      end associate

      return
   end subroutine swiftest_discard_pl_tp
   

   subroutine swiftest_discard_pl_close(dx, dv, dt, r2crit, iflag, r2min)
      !! author: David A. Minton
      !!
      !!  Check to see if a test particle and massive body are having, or will have within the next time step, an encounter such
      !!          that the separation distance r is less than some critical radius rcrit (or r**2 < rcrit**2 = r2crit)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: discard_pl_close.f90
      !! Adapted from Hal Levison's Swift routine discard_pl_close.f
      implicit none
      ! Arguments
      real(DP), dimension(:), intent(in)    :: dx
         !! Difference in distance vectors
      real(DP), dimension(:), intent(in)    :: dv 
         !! Difference in velocity vectors
      real(DP), intent(in)                  :: dt 
         !! Time step
      real(DP), intent(in)                  :: r2crit 
         !! Square of the critical radius at which the test particle and massive body are considered to be in close proximity
      integer(I4B), intent(out)             :: iflag 
         !! Flag indicating whether the test particle and massive body are in close proximity. 
         !! iflag == 1 means they are considered close
         !! iflag == 0 means they are not considered close
      real(DP), intent(out)                 :: r2min 
         !! Minimum separation distance between the test particle and massive body within the next time step
      ! Internals
      real(DP) :: r2, v2, vdotr, tmin
      
      r2 = dot_product(dx(:), dx(:))
      if (r2 <= r2crit) then
         iflag = 1
      else
         vdotr = dot_product(dx(:), dv(:))
         if (vdotr > 0.0_DP) then
            iflag = 0
         else
            v2 = dot_product(dv(:), dv(:))
            tmin = -vdotr / v2
            if (tmin < dt) then
               r2min = r2 - vdotr * vdotr / v2
            else
               r2min = r2 + 2 * vdotr * dt + v2 * dt**2
            end if
            r2min = min(r2min, r2)
            if (r2min <= r2crit) then
               iflag = 1
            else
               iflag = 0
            end if
         end if
      end if
   
      return
   end subroutine swiftest_discard_pl_close

end submodule s_swiftest_discard

module bindings_module
   use iso_c_binding, only : c_char, c_null_char, c_int
   use swiftest 
   implicit none
   contains

      subroutine bindings_c2f_string(c_string, f_string)
         implicit none
         ! Arguments
         character(len=1,kind=c_char),              intent(in)  :: c_string(*)
         character(len=:),             allocatable, intent(out) :: f_string
         ! Internals
         integer :: i
         character(len=STRMAX) :: tmp_string

         i=1
         tmp_string = ''
         do while(c_string(i) /= c_null_char .and. i <= STRMAX)
            tmp_string(i:i) = c_string(i)
            i=i+1
         end do

         if (i > 1) then
            f_string = trim(tmp_string)
         else
            f_string = ""
         end if

         return
      end subroutine bindings_c2f_string

      subroutine bindings_c_driver(c_integrator, c_param_file_name, c_display_style) bind(c, name="bindings_c_driver")
         implicit none
         character(kind=c_char), dimension(*), intent(in) :: c_integrator, c_param_file_name, c_display_style
         character(len=:), allocatable :: integrator, param_file_name, display_style

         call bindings_c2f_string(c_integrator, integrator)
         call bindings_c2f_string(c_param_file_name, param_file_name)
         call bindings_c2f_string(c_display_style, display_style)

         call swiftest_io_get_args(integrator,param_file_name,display_style,from_cli=.false.)
         call swiftest_driver(integrator,param_file_name,display_style)
      end subroutine bindings_c_driver


      subroutine bindings_orbel_el2xv(nbody, c_mu, c_a, c_e, c_inc, c_capom, c_omega, c_capm, &
                                      c_rx, c_ry, c_rz, c_vx, c_vy, c_vz) &
         bind(c, name="bindings_orbel_el2xv")
         !! author: David A. Minton
         !!
         !! Implements a bindings version of swiftest_orbel_el2xv to be called from Python via Cython
         implicit none
         ! Arguments
         integer(I4B), intent(in), value :: nbody !! The number of bodies
         type(c_ptr), intent(in), value :: c_mu !! The gravitational parameter G*(M+m)
         type(c_ptr), intent(in), value :: c_a !! The semi-major axis
         type(c_ptr), intent(in), value :: c_e !! The eccentricity
         type(c_ptr), intent(in), value :: c_inc !! The inclination
         type(c_ptr), intent(in), value :: c_capom !! The longitude of the ascending node
         type(c_ptr), intent(in), value :: c_omega !! The argument of periapsis
         type(c_ptr), intent(in), value :: c_capm !! The mean anomaly
         type(c_ptr), intent(in), value :: c_rx !! The x-component of the position vector
         type(c_ptr), intent(in), value :: c_ry !! The y-component of the position vector
         type(c_ptr), intent(in), value :: c_rz !! The z-component of the position vector
         type(c_ptr), intent(in), value :: c_vx !! The x-component of the velocity vector
         type(c_ptr), intent(in), value :: c_vy !! The y-component of the velocity vector
         type(c_ptr), intent(in), value :: c_vz !! The z-component of the velocity vector
         ! Internals
         real(DP), dimension(:), pointer :: mu, a, e, inc, capom, omega, capm, rx, ry, rz, vx, vy, vz
         integer(I4B) :: i

         if (c_associated(c_mu)) then
            call c_f_pointer(c_mu, mu, shape=[nbody])
         else
            error stop "c_mu is not associated"
         end if

         if (c_associated(c_a)) then
            call c_f_pointer(c_a, a, shape=[nbody])
         else
            error stop "c_a is not associated"
         end if

         if (c_associated(c_e)) then
            call c_f_pointer(c_e, e, shape=[nbody])
         else
            error stop "c_e is not associated"
         end if

         if (c_associated(c_inc)) then
            call c_f_pointer(c_inc, inc, shape=[nbody])
         else
            error stop "c_inc is not associated"
         end if

         if (c_associated(c_capom)) then
            call c_f_pointer(c_capom, capom, shape=[nbody])
         else
            error stop "c_capom is not associated"
         end if

         if (c_associated(c_omega)) then
            call c_f_pointer(c_omega, omega, shape=[nbody])
         else
            error stop "c_omega is not associated"
         end if

         if (c_associated(c_capm)) then
            call c_f_pointer(c_capm, capm, shape=[nbody])
         else
            error stop "c_capm is not associated"
         end if

         allocate(rx(nbody))
         if (c_associated(c_rx)) then
            call c_f_pointer(c_rx, rx, shape=[nbody])
         else
            error stop "c_rx is not associated"
         end if

         allocate(ry(nbody))
         if (c_associated(c_ry)) then
            call c_f_pointer(c_ry, ry, shape=[nbody])
         else
            error stop "c_ry is not associated"
         end if

         allocate(rz(nbody))
         if (c_associated(c_rz)) then
            call c_f_pointer(c_rz, rz, shape=[nbody])
         else
            error stop "c_rz is not associated"
         end if

         allocate(vx(nbody))
         if (c_associated(c_vx)) then
            call c_f_pointer(c_vx, vx, shape=[nbody])
         else
            error stop "c_vx is not associated"
         end if   

         allocate(vy(nbody))
         if (c_associated(c_vy)) then
            call c_f_pointer(c_vy, vy, shape=[nbody])
         else
            error stop "c_vy is not associated"
         end if

         allocate(vz(nbody))
         if (c_associated(c_vz)) then
            call c_f_pointer(c_vz, vz, shape=[nbody])
         else
            error stop "c_vz is not associated"
         end if

#ifdef DOCONLOC
         do concurrent (i = 1:nbody) shared(mu, a, e, inc, capom, omega, capm, rx, ry, rz, vx, vy, vz)
#else
         do concurrent (i = 1:nbody)
#endif
            call swiftest_orbel_el2xv(mu(i), a(i), e(i), inc(i), capom(i), omega(i), capm(i), &
                                      rx(i), ry(i), rz(i), vx(i), vy(i), vz(i))
         end do

         return
      end subroutine bindings_orbel_el2xv

      subroutine bindings_orbel_xv2el(nbody, c_mu, c_rx, c_ry, c_rz, c_vx, c_vy, c_vz, &
                                      c_a, c_e, c_inc, c_capom, c_omega, c_capm, c_varpi, c_lam, c_f, c_cape, c_capf) &
         bind(c, name="bindings_orbel_xv2el")
         !! author: David A. Minton
         !!
         !! Implements a bindings version of swiftest_orbel_xv2el to be called from Python via Cython
         implicit none
         ! Arguments
         integer(I4B), intent(in), value :: nbody !! The number of bodies
         type(c_ptr), intent(in), value :: c_mu !! The gravitational parameter G*(M+m)
         type(c_ptr), intent(in), value :: c_rx !! The x-component of the position vector
         type(c_ptr), intent(in), value :: c_ry !! The y-component of the position vector
         type(c_ptr), intent(in), value :: c_rz !! The z-component of the position vector
         type(c_ptr), intent(in), value :: c_vx !! The x-component of the velocity vector
         type(c_ptr), intent(in), value :: c_vy !! The y-component of the velocity vector
         type(c_ptr), intent(in), value :: c_vz !! The z-component of the velocity vector
         type(c_ptr), intent(in), value :: c_a !! The semi-major axis
         type(c_ptr), intent(in), value :: c_e !! The eccentricity
         type(c_ptr), intent(in), value :: c_inc !! The inclination
         type(c_ptr), intent(in), value :: c_capom !! The longitude of the ascending node
         type(c_ptr), intent(in), value :: c_omega !! The argument of periapsis
         type(c_ptr), intent(in), value :: c_capm !! The mean anomaly
         type(c_ptr), intent(in), value :: c_varpi !! The longitude of periapsis
         type(c_ptr), intent(in), value :: c_lam !! The mean longitude
         type(c_ptr), intent(in), value :: c_f !! The true anomaly
         type(c_ptr), intent(in), value :: c_cape !! The eccentric anomaly (elliptical orbits)
         type(c_ptr), intent(in), value :: c_capf !! The hyperbolic anomaly (hyperbolic orbits)
         ! Internals
         real(DP), dimension(:), pointer :: mu, rx, ry, rz, vx, vy, vz, a, e, inc, capom, omega, capm, varpi, lam, f, cape, capf
         integer(I4B) :: i

         if (c_associated(c_mu)) then
            call c_f_pointer(c_mu, mu, shape=[nbody])
         else
            error stop "c_mu is not associated"
         end if

         if (c_associated(c_rx)) then
            call c_f_pointer(c_rx, rx, shape=[nbody])
         else
            error stop "c_rx is not associated"
         end if   

         if (c_associated(c_ry)) then
            call c_f_pointer(c_ry, ry, shape=[nbody])
         else
            error stop "c_ry is not associated"
         end if

         if (c_associated(c_rz)) then
            call c_f_pointer(c_rz, rz, shape=[nbody])
         else
            error stop "c_rz is not associated"
         end if   

         if (c_associated(c_vx)) then
            call c_f_pointer(c_vx, vx, shape=[nbody])
         else
            error stop "c_vx is not associated"
         end if

         if (c_associated(c_vy)) then
            call c_f_pointer(c_vy, vy, shape=[nbody])
         else
            error stop "c_vy is not associated"
         end if

         if (c_associated(c_vz)) then
            call c_f_pointer(c_vz, vz, shape=[nbody])
         else
            error stop "c_vz is not associated"
         end if

         allocate(a(nbody))
         if (c_associated(c_a)) then
            call c_f_pointer(c_a, a, shape=[nbody])
         else
            error stop "c_a is not associated"
         end if

         allocate(e(nbody))
         if (c_associated(c_e)) then
            call c_f_pointer(c_e, e, shape=[nbody])
         else
            error stop "c_e is not associated"
         end if

         allocate(inc(nbody))
         if (c_associated(c_inc)) then
            call c_f_pointer(c_inc, inc, shape=[nbody])
         else
            error stop "c_inc is not associated"
         end if   

         allocate(capom(nbody))
         if (c_associated(c_capom)) then
            call c_f_pointer(c_capom, capom, shape=[nbody])
         else
            error stop "c_capom is not associated"
         end if

         allocate(omega(nbody))
         if (c_associated(c_omega)) then
            call c_f_pointer(c_omega, omega, shape=[nbody])
         else
            error stop "c_omega is not associated"
         end if

         allocate(capm(nbody))
         if (c_associated(c_capm)) then
            call c_f_pointer(c_capm, capm, shape=[nbody])
         else
            error stop "c_capm is not associated"
         end if

         allocate(varpi(nbody))
         if (c_associated(c_varpi)) then
            call c_f_pointer(c_varpi, varpi, shape=[nbody])
         else
            error stop "c_varpi is not associated"
         end if

         allocate(lam(nbody))
         if (c_associated(c_lam)) then
            call c_f_pointer(c_lam, lam, shape=[nbody])
         else
            error stop "c_lam is not associated"
         end if

         allocate(f(nbody))
         if (c_associated(c_f)) then
            call c_f_pointer(c_f, f, shape=[nbody])
         else
            error stop "c_f is not associated"
         end if

         allocate(cape(nbody))
         if (c_associated(c_cape)) then
            call c_f_pointer(c_cape, cape, shape=[nbody])
         else
            error stop "c_cape is not associated"
         end if

         allocate(capf(nbody))
         if (c_associated(c_capf)) then
            call c_f_pointer(c_capf, capf, shape=[nbody])
         else
            error stop "c_capf is not associated"
         end if

#ifdef DOCONLOC
         do concurrent (i = 1:nbody) shared(mu, rx, ry, rz, vx, vy, vz, a, e, inc, capom, omega, capm, varpi, lam, f, cape, capf) 
#else
         do concurrent (i = 1:nbody)
#endif
            call swiftest_orbel_xv2el(mu(i), rx(i), ry(i), rz(i), vx(i), vy(i), vz(i), &
                                      a(i), e(i), inc(i), capom(i), omega(i), capm(i), varpi(i), lam(i), f(i), cape(i), capf(i))
         end do


         return
      end subroutine bindings_orbel_xv2el

end module bindings_module 

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module swiftest
   !! author: David A. Minton
   !!
   !! This module serves to combine all of the Swiftest project modules under a single umbrella so that they can be accessed from 
   !! individual submodule implementations with a simple "use swiftest" line.
   !! 
   !! The project structure is divided into a heirarchy of modules. The lowest level of the heirarchy are the modules called in the
   !! "use" statements below. Next the "swiftest" modules (this one), and finally each individual integrator (and potential future 
   !! integrators) sit at the top. This structure is a consequence of two competing constraints:
   !! 1) The desire that much of the basic functionality of the code is modular, such that new functionality can be easily added 
   !!    without altering too much of the basic code.
   !! 2) Adhering to Modern Fortran's typing rules.
   !!  
   !! A set of "base" types is defined in the base module. These define classes of objects, (i.e. central body, massive body, and 
   !! test particles) and other major types used throughout the project. However, none of the derived data types are defined with 
   !! concrete type-bound procedures attached (only abstract procedures). However, the *interfaces* of type-bound procedures are 
   !! defined using the base types as arguments. Because of the typing rules of Modern Fortran's type-bound procedure overrides, any
   !! non-pass arguments(i.e. arguments not named self) must be identical in all extended types. Because some of the basic 
   !! functionality in the project is split across multiple modules, we cannot define type-bound procedures in base class objects 
   !! until the all interfaces are defined. In order to avoid these dependency issues and not end up with a massive base class with
   !! every possibly type-bound procedure interface in the project (thus reducing the modularity of the project), the type-bound 
   !! procedures are added to the base types here. 
   !!
   !! Structuring this code this way adds somewhat to the verbosity of the code. The main thing that has to happen is that for any 
   !! procedures where one wishes to make use of an type-bound procedures defined for arguments at the swiftest-type level or 
   !! higher, but that are passsed to base-level procedures, must have their arguments wrapped in a select type(...); class is(...) 
   !! construct in order to "reveal" the procedures. This is done throughout the project at the beginning of many procedures (along 
   !! with copious amounts of associate(...) statements, in order to help with code readibility)
   !!
   !! Adapted from David E. Kaufmann's Swifter routine: module_swifter.f90
   use globals
   use operators
   use lambda_function
   use base
   use encounter
   use collision
   use walltime
   use io_progress_bar
   use netcdf_io
   use solver
#ifdef COARRAY
   use coarray
#endif
   !use advisor_annotate
   !$ use omp_lib
   implicit none
   public

   type, extends(netcdf_parameters) :: swiftest_netcdf_parameters
   contains
      procedure :: initialize => swiftest_io_netcdf_initialize_output 
         !! Initialize a set of parameters used to identify a NetCDF output object
      procedure :: get_valid_masks => swiftest_io_netcdf_get_valid_masks   
         !! Gets logical masks indicating which bodies are valid pl and tp type at the current time
      procedure :: open            => swiftest_io_netcdf_open 
         !! Opens a NetCDF file and does the variable inquiries to activate variable ids
      procedure :: flush           => swiftest_io_netcdf_flush 
         !! Flushes a NetCDF file by closing it then opening it again
#ifdef COARRAY
      procedure :: coclone   => swiftest_coarray_coclone_nc
#endif
   end type swiftest_netcdf_parameters


   type, extends(base_storage) :: swiftest_storage
      class(swiftest_netcdf_parameters), allocatable :: nc 
         !! NetCDF object attached to this storage object
   contains
      procedure :: dump             => swiftest_io_dump_storage 
         !! Dumps storage object contents to file
      procedure :: dealloc          => swiftest_util_dealloc_storage
         !! Resets a storage object by deallocating all items and resetting the frame counter to 0
      procedure :: get_index_values => swiftest_util_get_vals_storage
         !! Gets the unique values of the indices of a storage object (i.e. body id or time value)
      procedure :: make_index_map   => swiftest_util_index_map_storage
         !! Maps body id values to storage index values so we don't have to use unlimited dimensions for id
      procedure :: take_snapshot    => swiftest_util_snapshot_system 
         !! Takes a snapshot of the nbody_system for later file storage
      final     ::                     swiftest_final_storage
   end type swiftest_storage


   ! The following extended types or their children should be used, where possible, as the base of any types defined in additional 
   ! modules, such as new integrators. 
   type, extends(base_parameters) :: swiftest_parameters
   contains
      procedure :: dump        => swiftest_io_dump_param
      procedure :: reader      => swiftest_io_param_reader
      procedure :: writer      => swiftest_io_param_writer
      procedure :: read_in     => swiftest_io_read_in_param
      procedure :: set_display => swiftest_io_set_display_param
   end type swiftest_parameters


   !> Class definition for the kinship relationships used in bookkeeping multiple collisions bodies in a single time step.
   type, extends(base_kinship) :: swiftest_kinship
      integer(I4B)                            :: parent 
         !! Index of parent particle
      integer(I4B)                            :: nchild
         !! number of children in merger list
      integer(I4B), dimension(:), allocatable :: child
         !! Index of children particles
   contains
      procedure :: dealloc  => swiftest_util_dealloc_kin 
         !! Deallocates all allocatable arrays
#ifdef COARRAY
      procedure :: coclone => swiftest_coarray_coclone_kin 
         !! Clones the image 1 body object to all other images in the coarray structure.
#endif
      final :: swiftest_final_kin
         !! Finalizes the Swiftest kinship object - deallocates all allocatables
   end type swiftest_kinship


   type, extends(base_particle_info) :: swiftest_particle_info
      character(len=NAMELEN)    :: name            
         !! Non-unique name
      character(len=NAMELEN)    :: particle_type   
         !! String containing a description of the particle type (e.g. Central Body,  Massive Body, Test Particle)
      character(len=NAMELEN)    :: origin_type     
         !! String containing a description of the origin of the particle (e.g. Initial  Conditions, Disruption, etc.)
      real(DP)                  :: origin_time     
         !! The time of the particle's formation
      integer(I4B)              :: collision_id    
         !! The ID of the collision that formed the particle
      real(DP), dimension(NDIM) :: origin_rh       
         !! The heliocentric distance vector at the time of the particle's formation
      real(DP), dimension(NDIM) :: origin_vh       
         !! The heliocentric velocity vector at the time of the particle's formation
      real(DP)                  :: discard_time    
         !! The time of the particle's discard
      character(len=NAMELEN)    :: status          
         !! Particle status description: Active, Merged, Fragmented, etc.
      real(DP), dimension(NDIM) :: discard_rh      
         !! The heliocentric distance vector at the time of the particle's discard
      real(DP), dimension(NDIM) :: discard_vh      
         !! The heliocentric velocity vector at the time of the particle's discard
      integer(I4B)              :: discard_body_id 
         !! The id of the other body involved in the discard (0 if no other body involved)
   contains
      procedure :: copy      => swiftest_util_copy_particle_info  
         !! Copies one set of information object components into another,  component-by-component
      procedure :: set_value => swiftest_util_set_particle_info   
         !! Sets one or more values of the particle information metadata object
   end type swiftest_particle_info


   !> An abstract class for a generic collection of Swiftest bodies
   type, abstract, extends(base_object) :: swiftest_body
         !! Superclass that defines the generic elements of a Swiftest particle 
      logical                                                    :: lfirst = .true. 
         !! Run the current step as a first
      integer(I4B)                                               :: nbody = 0       
         !! Number of bodies
      integer(I4B),                  dimension(:),   allocatable :: id              
         !! Identifier 
      type(swiftest_particle_info),  dimension(:),   allocatable :: info            
         !! Particle metadata information
      logical,                       dimension(:),   allocatable :: lmask           
         !! Logical mask used to select a subset of bodies when performing certain operations (drift, kick, accel, etc.)
      integer(I4B),                  dimension(:),   allocatable :: status          
         !! An integrator-specific status indicator 
      logical,                       dimension(:),   allocatable :: ldiscard        
         !! Body should be discarded
      logical,                       dimension(:),   allocatable :: lcollision      
         !! flag indicating whether body has merged with another this time step
      logical,                       dimension(:),   allocatable :: lencounter      
         !! flag indicating whether body is part of an encounter this time step
      real(DP),                      dimension(:),   allocatable :: mu              
         !! G * (Mcb + [m])
      real(DP),                      dimension(:,:), allocatable :: rh              
         !! Heliocentric position
      real(DP),                      dimension(:,:), allocatable :: vh              
         !! Heliocentric velocity
      real(DP),                      dimension(:,:), allocatable :: rb              
         !! Barycentric position
      real(DP),                      dimension(:,:), allocatable :: vb              
         !! Barycentric velocity
      real(DP),                      dimension(:,:), allocatable :: ah              
         !! Total heliocentric acceleration
      real(DP),                      dimension(:,:), allocatable :: aobl            
         !! Barycentric accelerations of bodies due to central body oblatenes
      real(DP),                      dimension(:,:), allocatable :: agr             
         !! Acceleration due to post-Newtonian correction
      real(DP),                      dimension(:,:), allocatable :: atide           
         !! Tanngential component of acceleration of bodies due to tides
      real(DP),                      dimension(:),   allocatable :: ir3h            
         !! Inverse heliocentric radius term (1/rh**3)
      integer(I4B),                  dimension(:),   allocatable :: isperi          
         !! perihelion passage flag
      real(DP),                      dimension(:),   allocatable :: peri            
         !! perihelion distance
      real(DP),                      dimension(:),   allocatable :: atp             
         !! semimajor axis following perihelion passage
      real(DP),                      dimension(:),   allocatable :: a               
         !! Semimajor axis (pericentric distance for a parabolic orbit)
      real(DP),                      dimension(:),   allocatable :: e               
         !! Eccentricity
      real(DP),                      dimension(:),   allocatable :: inc             
         !! Inclination
      real(DP),                      dimension(:),   allocatable :: capom           
         !! Longitude of ascending node
      real(DP),                      dimension(:),   allocatable :: omega           
         !! Argument of pericenter
      real(DP),                      dimension(:),   allocatable :: capm            
         !! Mean anomaly
      ! Note to developers: If you add components to this class, be sure to update methods and subroutines that traverse the
      ! component list, such as setup_body and util_spill
   contains
      procedure(abstract_discard_body), deferred :: discard
      procedure(abstract_kick_body),    deferred :: kick     
      procedure(abstract_set_mu),       deferred :: set_mu
      procedure(abstract_step_body),    deferred :: step
      procedure(abstract_accel),        deferred :: accel

      ! These are concrete because the implementation is the same for all types of particles
      procedure :: drift           => swiftest_drift_body                   
         !! Loop through bodies and call Danby drift routine on heliocentric variables
      procedure :: v2pv            => swiftest_gr_vh2pv_body                
         !! Converts from velocity to psudeovelocity for GR calculations using symplectic integrators
      procedure :: pv2v            => swiftest_gr_pv2vh_body                
         !! Converts from psudeovelocity to velocity for GR calculations using symplectic integrators
      procedure :: read_frame_bin  => swiftest_io_read_frame_body           
         !! I/O routine for writing out a single frame of time-series data for the central body
      procedure :: read_in         => swiftest_io_read_in_body              
         !! Read in body initial conditions from an ascii file
      procedure :: write_frame     => swiftest_io_netcdf_write_frame_body   
         !! I/O routine for writing out a single frame of time-series data for all bodies in the nbody_system in NetCDF format  
      procedure :: write_info      => swiftest_io_netcdf_write_info_body    
         !! Dump contents of particle information metadata to file
      procedure :: el2xv           => swiftest_orbel_el2xv_vec              
         !! Convert orbital elements to position and velocity vectors
      procedure :: xv2el           => swiftest_orbel_xv2el_vec              
         !! Convert position and velocity vectors to orbital elements 
      procedure :: setup           => swiftest_util_setup_body              
         !! A constructor that sets the number of bodies and allocates all allocatable arrays
      procedure :: accel_user      => swiftest_user_kick_getacch_body       
         !! Add user-supplied heliocentric accelerations to planets
      procedure :: append          => swiftest_util_append_body             
         !! Appends elements from one structure to another
      procedure :: dealloc         => swiftest_util_dealloc_body            
         !! Deallocates all allocatable arrays
      procedure :: fill            => swiftest_util_fill_body               
         !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: get_peri        => swiftest_util_peri_body               
         !! Determine nbody_system pericenter passages for test particles 
      procedure :: resize          => swiftest_util_resize_body             
         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: set_ir3         => swiftest_util_set_ir3h                
         !! Sets the inverse heliocentric radius term (1/rh**3)
      procedure :: sort            => swiftest_util_sort_body               
         !! Sorts body arrays by a sortable componen
      procedure :: rearrange       => swiftest_util_sort_rearrange_body     
         !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill           => swiftest_util_spill_body              
         !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
      generic   :: read_frame      => read_frame_bin                        
         !! Add the generic read frame for Fortran binary files
#ifdef COARRAY
      procedure :: coclone         => swiftest_coarray_coclone_body         
         !! Clones the image 1 body object to all other images in the coarray structure.
      procedure :: cocollect       => swiftest_coarray_cocollect_body       
         !! Collects all body object array components from all images and combines them into the image 1 body object
#endif
   end type swiftest_body


   type, abstract, extends(base_object) :: swiftest_cb
   !> An abstract class for a generic central body in a Swiftest simulation
      class(swiftest_particle_info), allocatable  :: info              
         !! Particle metadata information
      integer(I4B)                                :: id       = 0      
         !! External identifier (unique)
      real(DP)                                    :: mass     = 0.0_DP 
         !! Central body mass (units MU)
      real(DP)                                    :: Gmass    = 0.0_DP 
         !! Central mass gravitational term G * mass (units GU * MU)
      real(DP)                                    :: radius   = 0.0_DP 
         !! Central body radius (units DU)
      real(DP)                                    :: density  = 1.0_DP 
         !! Central body mass density - calculated internally (units MU / DU**3)
      real(DP)                                    :: j2rp2    = 0.0_DP 
         !! J2*R^2 term for central body
      real(DP)                                    :: j4rp4    = 0.0_DP 
         !! J4*R^4 term for central body
      real(DP), dimension(:,:,:), allocatable     :: c_lm              
         !! Spherical Harmonics coefficients for the central body
      real(DP), dimension(NDIM)                   :: aobl     = 0.0_DP 
         !! Barycentric acceleration due to central body oblatenes
      real(DP), dimension(NDIM)                   :: atide    = 0.0_DP 
         !! Barycentric acceleration due to central body oblatenes
      real(DP), dimension(NDIM)                   :: aoblbeg  = 0.0_DP 
         !! Barycentric acceleration due to central body oblatenes at beginning of step
      real(DP), dimension(NDIM)                   :: aoblend  = 0.0_DP 
         !! Barycentric acceleration due to central body oblatenes at end of step
      real(DP), dimension(NDIM)                   :: atidebeg = 0.0_DP 
         !! Barycentric acceleration due to central body oblatenes at beginning of step
      real(DP), dimension(NDIM)                   :: atideend = 0.0_DP 
         !! Barycentric acceleration due to central body oblatenes at end of step
      real(DP), dimension(NDIM)                   :: rb       = 0.0_DP 
         !! Barycentric position (units DU)
      real(DP), dimension(NDIM)                   :: vb       = 0.0_DP 
         !! Barycentric velocity (units DU / TU)
      real(DP), dimension(NDIM)                   :: agr      = 0.0_DP 
         !! Acceleration due to post-Newtonian correction
      real(DP), dimension(NDIM)                   :: Ip       = 0.0_DP 
         !! Unitless principal moments of inertia (I1, I2, I3) / (MR**2). Principal axis rotation assumed. 
      real(DP), dimension(NDIM)                   :: rot      = 0.0_DP 
         !! Body rotation vector in inertial coordinate frame (units rad / TU)
      real(DP)                                    :: rotphase = 0.0_DP 
         !! Body rotation phase about the rotation pole (0 to 1)
      real(DP)                                    :: k2       = 0.0_DP 
         !! Tidal Love number
      real(DP)                                    :: Q        = 0.0_DP 
         !! Tidal quality factor
      real(DP)                                    :: tlag     = 0.0_DP 
         !! Tidal phase lag angle
      real(DP), dimension(NDIM)                   :: L0       = 0.0_DP 
         !! Initial angular momentum of the central body
      real(DP), dimension(NDIM)                   :: dL       = 0.0_DP 
         !! Change in angular momentum of the central body
      real(DP)                                    :: GM0      = 0.0_DP 
         !! Initial G*mass of the central body
      real(DP)                                    :: dGM      = 0.0_DP 
         !! Change in G*mass of the central body
      real(DP)                                    :: R0       = 0.0_DP 
         !! Initial radius of the central body
      real(DP)                                    :: dR       = 0.0_DP 
         !! Change in the radius of the central body
   contains
      procedure :: rotphase_update => swiftest_drift_cb_rotphase_update 
         !! updates the central body rotation phase
      procedure :: dealloc      => swiftest_util_dealloc_cb          
         !! Deallocates all allocatables and resets all values to defaults 
      procedure :: read_in      => swiftest_io_read_in_cb            
         !! Read in central body initial conditions from an ASCII file
      procedure :: write_frame  => swiftest_io_netcdf_write_frame_cb 
         !! I/O routine for writing out a single frame of time-series data for all bodies in the system in NetCDF format  
      procedure :: write_info   => swiftest_io_netcdf_write_info_cb  
         !! Dump contents of particle information metadata to file

#ifdef COARRAY
      procedure :: coclone      => swiftest_coarray_coclone_cb       
         !! Clones the image 1 body object to all other images in the coarray structure.
#endif
   end type swiftest_cb


   type, abstract, extends(swiftest_body) :: swiftest_pl
         !! Superclass that defines the generic elements of a Swiftest particle 
      real(DP),                dimension(:),   allocatable :: mass    
         !! Body mass (units MU)
      real(DP),                dimension(:),   allocatable :: Gmass   
         !! Mass gravitational term G * mass (units GU * MU)
      real(DP),                dimension(:),   allocatable :: rhill   
         !! Body mass (units MU)
      real(DP),                dimension(:),   allocatable :: renc    
         !! Critical radius for close encounters
      real(DP),                dimension(:),   allocatable :: radius  
         !! Body radius (units DU)
      real(DP),                dimension(:),   allocatable :: density 
         !! Body mass density - calculated internally (units MU / DU**3)
      real(DP),                dimension(:,:), allocatable :: rbeg    
         !! Position at beginning of step
      real(DP),                dimension(:,:), allocatable :: rend    
         !! Position at end of step
      real(DP),                dimension(:,:), allocatable :: vbeg    
         !! Velocity at beginning of step
      real(DP),                dimension(:,:), allocatable :: Ip      
         !! Unitless principal moments of inertia (I1, I2, I3) / (MR**2). Principal axis rotation assumed. 
      real(DP),                dimension(:,:), allocatable :: rot     
         !! Body rotation vector in inertial coordinate frame (units rad / TU)
      real(DP),                dimension(:),   allocatable :: k2      
         !! Tidal Love number
      real(DP),                dimension(:),   allocatable :: Q       
         !! Tidal quality factor
      real(DP),                dimension(:),   allocatable :: tlag    
         !! Tidal phase lag
      integer(I4B),            dimension(:,:), allocatable :: k_plpl  
         !! Index array used to convert flattened the body-body comparison upper triangular matrix
      integer(I8B)                                         :: nplpl   
         !! Number of body-body comparisons in the flattened upper triangular matrix
      type(swiftest_kinship),  dimension(:),   allocatable :: kin        
         !! Array of merger relationship structures that can account for multiple pairwise mergers in a single step
      logical,                 dimension(:),   allocatable :: lmtiny     
         !! flag indicating whether this body is below the GMTINY cutoff value
      integer(I4B)                                         :: nplm = 0   
         !! number of bodies above the GMTINY limit
      integer(I8B)                                         :: nplplm     
         !! Number of body (all massive)-body (only those above GMTINY) comparisons in the flattened upper triangular matrix 
      integer(I4B),            dimension(:),   allocatable :: nplenc     
         !! number of encounters with other planets this time step
      integer(I4B),            dimension(:),   allocatable :: ntpenc     
         !! number of encounters with test particles this time step

      ! Note to developers: If you add components to this class, be sure to update methods and subroutines that traverse the
      !    component list, such as setup_pl and util_spill_pl
   contains
      ! Massive body-specific concrete methods 
      ! These are concrete because they are the same implemenation for all integrators
      procedure :: make_impactors => swiftest_util_make_impactors_pl 
         !! Make impactors out of the current kinship relationships
      procedure :: discard => swiftest_discard_pl             
         !! Placeholder method for discarding massive bodies 
      procedure :: accel_int => swiftest_kick_getacch_int_pl    
         !! Compute direct cross (third) term heliocentric accelerations of massive bodies
      procedure :: accel_non_spherical_cb => swiftest_non_spherical_cb_acc_pl             
         !! Compute the barycentric accelerations of bodies due to the oblateness of the central body
      procedure :: setup => swiftest_util_setup_pl          
         !! A base constructor that sets the number of bodies and allocates and initializes all arrays  
      ! procedure :: accel_tides    => tides_kick_getacch_pl           
         !! Compute the accelerations of bodies due to tidal interactions with the central body
      procedure :: append => swiftest_util_append_pl         
         !! Appends elements from one structure to another
      procedure :: h2b  => swiftest_util_coord_h2b_pl      
         !! Convert massive bodies from heliocentric to barycentric coordinates (position and velocity)
      procedure :: b2h => swiftest_util_coord_b2h_pl      
         !! Convert massive bodies from barycentric to heliocentric coordinates (position and velocity)
      procedure :: vh2vb  => swiftest_util_coord_vh2vb_pl    
         !! Convert massive bodies from heliocentric to barycentric coordinates (velocity only)
      procedure :: vb2vh          => swiftest_util_coord_vb2vh_pl    
         !! Convert massive bodies from barycentric to heliocentric coordinates (velocity only)
      procedure :: rh2rb          => swiftest_util_coord_rh2rb_pl    
         !! Convert massive bodies from heliocentric to barycentric coordinates (position only)
      procedure :: dealloc        => swiftest_util_dealloc_pl        
         !! Deallocates all allocatable arrays
      procedure :: fill           => swiftest_util_fill_pl           
         !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: flatten        => swiftest_util_flatten_eucl_plpl 
         !! Sets up the (i, j) -> k indexing used for the single-loop blocking Euclidean distance matrix
      procedure :: rearray        => swiftest_util_rearray_pl        
         !! Clean up the massive body structures to remove discarded bodies and add new bodies
      procedure :: resize         => swiftest_util_resize_pl         
         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: reset_kinship  => swiftest_util_reset_kinship_pl  
         !! Resets the kinship status of bodies
      procedure :: set_beg_end    => swiftest_util_set_beg_end_pl    
         !! Sets the beginning and ending positions and velocities of planets.
      procedure :: set_mu         => swiftest_util_set_mu_pl         
         !! Method used to construct the vectorized form of the central body mass
      procedure :: set_rhill      => swiftest_util_set_rhill         
         !! Calculates the Hill's radii for each body
      procedure :: set_renc_I4B   => swiftest_util_set_renc_I4B      
         !! Sets the critical radius for encounter given an inpput integer scale factor
      procedure :: set_renc_DP    => swiftest_util_set_renc_DP       
         !! Sets the critical radius for encounter given an input real scale factor
      procedure :: sort           => swiftest_util_sort_pl           
         !! Sorts body arrays by a sortable component
      procedure :: rearrange      => swiftest_util_sort_rearrange_pl 
         !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill          => swiftest_util_spill_pl          
         !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
      generic   :: set_renc       => set_renc_I4B, set_renc_DP 
#ifdef COARRAY
      procedure :: coclone      => swiftest_coarray_coclone_pl       
         !! Clones the image 1 body object to all other images in the coarray structure.
#endif
   end type swiftest_pl


   type, abstract, extends(swiftest_body) :: swiftest_tp
      
         !! Superclass that defines the generic elements of a Swiftest test particle 
      integer(I4B), dimension(:,:), allocatable :: k_pltp 
         !! Index array used to convert flattened the body-body comparison upper triangular matrix
      integer(I8B)                              :: npltp  
         !! Number of pl-tp comparisons in the flattened upper triangular matrix
      integer(I4B), dimension(:),   allocatable :: nplenc 
         !! number of encounters with planets this time step
      
      ! Note to developers: If you add components to this class, be sure to update methods and subroutines that traverse the
      ! component list, such as swiftest_util_setup_tp and util_spill_tp
   contains
      ! Test particle-specific concrete methods 
      ! These are concrete because they are the same implemenation for all integrators
      procedure :: discard   => swiftest_discard_tp             
         !! Check to see if test particles should be discarded based on their positions relative to the massive bodies
      procedure :: accel_int => swiftest_kick_getacch_int_tp    
         !! Compute direct cross (third) term heliocentric accelerations of test particles by massive bodies
      procedure :: accel_non_spherical_cb => swiftest_non_spherical_cb_acc_tp             
         !! Compute the barycentric accelerations of bodies due to the oblateness of the central body
      procedure :: setup     => swiftest_util_setup_tp          
         !! A base constructor that sets the number of bodies and 
      procedure :: append    => swiftest_util_append_tp         
         !! Appends elements from one structure to another
      procedure :: h2b       => swiftest_util_coord_h2b_tp      
         !! Convert test particles from heliocentric to barycentric coordinates (position and velocity)
      procedure :: b2h       => swiftest_util_coord_b2h_tp      
         !! Convert test particles from barycentric to heliocentric coordinates (position and velocity)
      procedure :: vb2vh     => swiftest_util_coord_vb2vh_tp    
         !! Convert test particles from barycentric to heliocentric coordinates (velocity only)
      procedure :: vh2vb     => swiftest_util_coord_vh2vb_tp    
         !! Convert test particles from heliocentric to barycentric coordinates (velocity only)
      procedure :: rh2rb     => swiftest_util_coord_rh2rb_tp    
         !! Convert test particles from heliocentric to barycentric coordinates (position only)
      procedure :: dealloc   => swiftest_util_dealloc_tp        
         !! Deallocates all allocatable arrays
      procedure :: fill      => swiftest_util_fill_tp           
         !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: rearray   => swiftest_util_rearray_tp        
         !! Clean up the test particle structures to remove discarded bodies 
      procedure :: resize    => swiftest_util_resize_tp         
         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: set_mu    => swiftest_util_set_mu_tp         
         !! Method used to construct the vectorized form of the central body mass
      procedure :: sort      => swiftest_util_sort_tp           
         !! Sorts body arrays by a sortable component
      procedure :: rearrange => swiftest_util_sort_rearrange_tp 
         !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill     => swiftest_util_spill_tp          
         !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
#ifdef COARRAY
      procedure :: coclone      => swiftest_coarray_coclone_tp    
         !! Clones the image 1 object to all other images in the coarray structure.
      procedure :: cocollect    => swiftest_coarray_cocollect_tp  
         !! Collects all object array components from all images and combines them into the image 1 object
#endif
   end type swiftest_tp


   !> An abstract class for a basic Swiftest nbody system 
   type, abstract, extends(base_nbody_system) :: swiftest_nbody_system
         !! This superclass contains a minimial nbody_system of a set of test particles (tp), massive bodies (pl), and a central 
         !! body (cb). 
      class(swiftest_cb),         allocatable :: cb                
         !! Central body data structure
      class(swiftest_pl),         allocatable :: pl                
         !! Massive body data structure
      class(swiftest_tp),         allocatable :: tp                
         !! Test particle data structure
      class(swiftest_tp),         allocatable :: tp_discards       
         !! Discarded test particle data structure
      class(swiftest_pl),         allocatable :: pl_discards       
         !! Discarded massive body particle data structure
      class(swiftest_pl),         allocatable :: pl_adds           
         !! List of added bodies in mergers or collisions
      class(swiftest_tp),         allocatable :: tp_adds           
         !! List of added bodies in mergers or collisions
      class(encounter_list),      allocatable :: pltp_encounter    
         !! List of massive body-test particle encounters in a single step
      class(encounter_list),      allocatable :: plpl_encounter    
         !! List of massive body-massive body encounters in a single step
      class(collision_list_plpl), allocatable :: plpl_collision    
         !! List of massive body-massive body collisions in a single step
      class(collision_list_pltp), allocatable :: pltp_collision    
         !! List of massive body-test particle collisions in a single step
      class(collision_basic),     allocatable :: collider          
         !! Collision system object
      class(encounter_storage),   allocatable :: encounter_history 
         !! Stores encounter history for later retrieval and saving to file
      class(collision_storage),   allocatable :: collision_history 
         !! Stores encounter history for later retrieval and saving to file
      integer(I4B)                    :: maxid = -1             
         !! The current maximum particle id number 
      real(DP)                        :: t = -1.0_DP            
         !! Integration current time
      real(DP)                        :: GMtot = 0.0_DP         
         !! Total nbody_system mass - used for barycentric coordinate conversion
      real(DP)                        :: ke_orbit = 0.0_DP      
         !! nbody_system orbital kinetic energy
      real(DP)                        :: ke_spin = 0.0_DP       
         !! nbody_system spin kinetic energy
      real(DP)                        :: pe = 0.0_DP            
         !! nbody_system potential energy
      real(DP)                        :: be = 0.0_DP            
         !! nbody_system binding energy of all bodies
      real(DP)                        :: te = 0.0_DP            
         !! nbody_system total energy
      real(DP)                        :: oblpot = 0.0_DP        
         !! nbody_system potential energy due to oblateness of the central body
      real(DP), dimension(NDIM)       :: L_orbit = 0.0_DP       
         !! nbody_system orbital angular momentum vector
      real(DP), dimension(NDIM)       :: L_spin = 0.0_DP        
         !! nbody_system spin angular momentum vector
      real(DP), dimension(NDIM)       :: L_total = 0.0_DP       
         !! nbody_system angular momentum vector
      real(DP)                        :: ke_orbit_orig = 0.0_DP 
         !! Initial orbital kinetic energy
      real(DP)                        :: ke_spin_orig = 0.0_DP  
         !! Initial spin kinetic energy
      real(DP)                        :: pe_orig = 0.0_DP       
         !! Initial potential energy
      real(DP)                        :: be_orig = 0.0_DP       
         !! Initial gravitational binding energy
      real(DP)                        :: te_orig = 0.0_DP       
         !! Initial total energy (sum of all sources of energy tracked)
      real(DP)                        :: be_cb   = 0.0_DP       
         !! Binding energy of central body (usually orders of magnitude larger than the rest of the system, and therefore tracked 
         !! seperately)
      real(DP)                        :: E_orbit_orig = 0.0_DP  
         !! Initial orbital energy
      real(DP)                        :: GMtot_orig = 0.0_DP    
         !! Initial nbody_system mass
      real(DP), dimension(NDIM)       :: L_total_orig = 0.0_DP  
         !! Initial total angular momentum vector
      real(DP), dimension(NDIM)       :: L_orbit_orig = 0.0_DP  
         !! Initial orbital angular momentum
      real(DP), dimension(NDIM)       :: L_spin_orig = 0.0_DP   
         !! Initial spin angular momentum vector
      real(DP), dimension(NDIM)       :: L_escape = 0.0_DP      
         !! Angular momentum of bodies that escaped the nbody_system (used for bookeeping)
      real(DP)                        :: GMescape = 0.0_DP      
         !! Mass of bodies that escaped the nbody_system (used for bookeeping)
      real(DP)                        :: E_collisions = 0.0_DP  
         !! Energy lost from nbody_system due to collisions
      real(DP)                        :: E_untracked = 0.0_DP   
         !! Energy gained from nbody_system due to escaped bodies

      ! Energy, momentum, and mass errors (used in error reporting)
      real(DP)                        :: ke_orbit_error    = 0.0_DP
      real(DP)                        :: ke_spin_error     = 0.0_DP
      real(DP)                        :: pe_error          = 0.0_DP
      real(DP)                        :: be_error          = 0.0_DP
      real(DP)                        :: E_orbit_error     = 0.0_DP
      real(DP)                        :: Ecoll_error       = 0.0_DP
      real(DP)                        :: E_untracked_error = 0.0_DP
      real(DP)                        :: te_error          = 0.0_DP
      real(DP)                        :: L_orbit_error     = 0.0_DP
      real(DP)                        :: L_spin_error      = 0.0_DP
      real(DP)                        :: L_escape_error    = 0.0_DP
      real(DP)                        :: L_total_error     = 0.0_DP
      real(DP)                        :: Mtot_error        = 0.0_DP
      real(DP)                        :: Mescape_error     = 0.0_DP

      logical                         :: lbeg                 
         !! True if this is the beginning of a step. This is used so that test particle steps can be calculated separately from 
         !! massive bodies.  Massive body variables are saved at half steps, and passed to the test particles
      logical                         :: lfirst_io   = .true.  
         !! Flag to indicate that this is the first time to write to a file
      logical                         :: lfirst_peri = .true.  
         !! Flag to indicate that this is the first pericenter passage
   contains
      !> Each integrator will have its own version of the step
      procedure(abstract_step_system), deferred :: step

      ! Concrete classes that are common to the basic integrator (only test particles considered for discard)
      procedure :: discard                 => swiftest_discard_system                              
         !! Perform a discard step on the nbody_system
      procedure :: compact_output          => swiftest_io_compact_output                           
         !! Prints out out terminal output when display_style is set to COMPACT
      procedure :: conservation_report     => swiftest_io_conservation_report                      
         !! Compute energy and momentum and print out the change with time
      procedure :: display_run_information => swiftest_io_display_run_information                  
         !! Displays helpful information about the run
      procedure :: dump                    => swiftest_io_dump_system                              
         !! Dump the state of the nbody_system to a file
      procedure :: get_t0_values           => swiftest_io_netcdf_get_t0_values_system              
         !! Validates the dump file to check whether the dump file initial conditions duplicate the last frame of the netcdf output.
      procedure :: read_frame              => swiftest_io_netcdf_read_frame_system                 
         !! Read in a frame of input data from file
      procedure :: read_hdr                => swiftest_io_netcdf_read_hdr_system                   
         !! Read a header for an output frame in NetCDF format
      procedure :: write_hdr               => swiftest_io_netcdf_write_hdr_system                  
         !! Write a header for an output frame in NetCDF format
      procedure :: read_particle_info      => swiftest_io_netcdf_read_particle_info_system         
         !! Read in particle metadata from file
      procedure :: read_in                 => swiftest_io_read_in_system                           
         !! Reads the initial conditions for an nbody system
      procedure :: write_frame             => swiftest_io_netcdf_write_frame_system                
         !! Write a frame of input data from file
      procedure :: obl_pot                 => swiftest_obl_pot_system                              
         !! Compute the contribution to the total gravitational potential due solely to the oblateness of the central body
      procedure :: dealloc                 => swiftest_util_dealloc_system                         
         !! Deallocates all allocatables and resets all values to defaults. Acts as a base for a finalizer
      procedure :: get_energy_and_momentum => swiftest_util_get_energy_and_momentum_system         
         !! Calculates the total nbody_system energy and momentum
      procedure :: get_idvals              => swiftest_util_get_idvalues_system                    
         !! Returns an array of all id values in use in the nbody_system
      procedure :: rescale                 => swiftest_util_rescale_system                         
         !! Rescales the nbody_system into a new set of units
      procedure :: initialize_output_file  => swiftest_io_initialize_output_file_system                  
         !! Write a frame of input data from file
      procedure :: initialize              => swiftest_util_setup_initialize_system                
         !! Initialize the nbody_system from input files
      procedure :: init_particle_info      => swiftest_util_setup_initialize_particle_info_system  
         !! Initialize the nbody_system from input files
    ! procedure :: step_spin               => tides_step_spin_system                               
         !! Steps the spins of the massive & central bodies due to tides.
      procedure :: set_msys                => swiftest_util_set_msys                               
         !! Sets the value of msys from the masses of nbody_system bodies.
      procedure :: validate_ids            => swiftest_util_valid_id_system                        
         !! Validate the numerical ids passed to the nbody_system and save the maximum value
#ifdef COARRAY
      procedure :: coclone                 => swiftest_coarray_coclone_system                      
         !! Clones the image 1 body object to all other images in the coarray structure.
      procedure :: coarray_collect         => swiftest_coarray_collect_system                      
         !! Collects all the test particles from other images into the image #1 test particle system
      procedure :: coarray_distribute      => swiftest_coarray_distribute_system                   
         !! Distributes test particles from image #1 out to all images.
      procedure :: coarray_balance         => swiftest_coarray_balance_system                      
         !! Checks whether or not the test particle coarrays need to be rebalanced.
#endif
   end type swiftest_nbody_system


   abstract interface

      subroutine abstract_accel(self, nbody_system, param, t, lbeg)
         import swiftest_body, swiftest_nbody_system, swiftest_parameters, DP
         class(swiftest_body),         intent(inout) :: self   
            !! Swiftest body data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      
            !! Current simulation time
         logical,                      intent(in)    :: lbeg   
            !! Optional argument that determines whether or not this is the beginning or end of the step
      end subroutine abstract_accel

      subroutine abstract_discard_body(self, nbody_system, param) 
         import swiftest_body, swiftest_nbody_system, swiftest_parameters
         class(swiftest_body),              intent(inout) :: self   
            !! Swiftest body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(inout) :: param  
            !! Current run configuration parameters 
      end subroutine abstract_discard_body

      subroutine abstract_kick_body(self, nbody_system, param, t, dt, lbeg)
         import swiftest_body, swiftest_nbody_system, swiftest_parameters, DP
         implicit none
         class(swiftest_body),              intent(inout) :: self   
            !! Swiftest generic body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system objec
         class(swiftest_parameters),        intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                          intent(in)    :: t      
            !! Current time
         real(DP),                          intent(in)    :: dt     
            !! Stepsize
         logical,                           intent(in)    :: lbeg   
            !! Logical flag indicating whether this is the beginning of the half step or not. 
      end subroutine abstract_kick_body

      subroutine abstract_set_mu(self, cb) 
         import swiftest_body, swiftest_cb
         class(swiftest_body), intent(inout) :: self 
            !! Swiftest body object
         class(swiftest_cb),   intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine abstract_set_mu

      subroutine abstract_step_body(self, nbody_system, param, t, dt)
         import DP, swiftest_body, swiftest_nbody_system, swiftest_parameters
         implicit none
         class(swiftest_body),         intent(inout) :: self         
            !! Swiftest body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody_system object
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t            
            !! Simulation time
         real(DP),                     intent(in)    :: dt           
            !! Current stepsize
      end subroutine abstract_step_body

      subroutine abstract_step_system(self, param, t, dt)
         import DP, swiftest_nbody_system, swiftest_parameters
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self  
            !! Swiftest nbody_system object
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
         real(DP),                          intent(in)    :: t     
            !! Simulation time
         real(DP),                          intent(in)    :: dt    
            !! Current stepsize
      end subroutine abstract_step_system
   end interface

   interface
      module subroutine swiftest_discard_pl(self, nbody_system, param)
         implicit none
         class(swiftest_pl),           intent(inout) :: self   
            !! Swiftest massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameter
      end subroutine swiftest_discard_pl

      module subroutine swiftest_discard_system(self, param)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self  
            !! Swiftest nbody_system object
         class(swiftest_parameters),   intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_discard_system

      module subroutine swiftest_discard_tp(self, nbody_system, param)
         implicit none
         class(swiftest_tp),           intent(inout) :: self   
            !! Swiftest test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters
      end subroutine swiftest_discard_tp

      module subroutine swiftest_drift_all(mu, x, v, n, param, dt, lmask, iflag)
         implicit none
         real(DP), dimension(:),     intent(in)    :: mu    
            !! Vector of gravitational constants
         real(DP), dimension(:,:),   intent(inout) :: x, v  
            !! Position and velocity vectors
         integer(I4B),               intent(in)    :: n     
            !! number of bodies
         class(swiftest_parameters),     intent(in)    :: param 
            !! Current run configuration parameters
         real(DP),                   intent(in)    :: dt    
            !! Stepsize
         logical, dimension(:),      intent(in)    :: lmask 
            !! Logical mask of size self%nbody that determines which bodies to drift.
         integer(I4B), dimension(:), intent(out)   :: iflag 
            !! Vector of error flags. 0 means no problem
      end subroutine swiftest_drift_all

      module subroutine swiftest_drift_body(self, nbody_system, param, dt)
         implicit none
         class(swiftest_body),              intent(inout) :: self   
            !! Swiftest particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(in)    :: param  
            !! Current run configuration parameters
         real(DP),                          intent(in)    :: dt     
            !! Stepsize
      end subroutine swiftest_drift_body

      pure elemental module subroutine swiftest_drift_one(mu, rx, ry, rz, vx, vy, vz, dt, iflag)
         !$omp declare simd(swiftest_drift_one)
         implicit none
         real(DP),     intent(in)       :: mu    
            !! G * (Mcb + m), G = gravitational constant, Mcb = mass of central body, m = mass of body to drift
         real(DP),     intent(inout)    :: rx, ry, rz, vx, vy, vz  
            !! Position and velocity of body to drift
         real(DP),     intent(in)       :: dt    
            !! Step size
         integer(I4B), intent(out)      :: iflag 
            !! iflag : error status flag for Danby drift (0 = OK, nonzero = ERROR)
      end subroutine swiftest_drift_one

      module subroutine swiftest_drift_cb_rotphase_update(self, param, dt)
         
            !! Author : Kaustub Anand
         
            !! subroutine to update the rotation phase of the central body
         
            !! Units: radians
         
            !! initial 0 is set at the x-axis 
   
         ! Arguments
         class(swiftest_cb),           intent(inout) :: self   
            !! Swiftest central body data structure
         class(swiftest_parameters),   intent(in)    :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     
            !! Stepsize
      end subroutine

      module subroutine swiftest_driver(integrator, param_file_name, display_style)
         implicit none
         character(len=:), intent(in), allocatable :: integrator      
            !! Symbolic code of the requested integrator  
         character(len=:), intent(in), allocatable :: param_file_name 
            !! Name of the input parameters file
         character(len=:), intent(in), allocatable :: display_style   
            !! Style of the output display {"STANDARD", "COMPACT", "PROGRESS"}). Default is "STANDARD" 
      end subroutine swiftest_driver

      pure module subroutine swiftest_gr_kick_getaccb_ns_body(self, nbody_system, param)
         implicit none
         class(swiftest_body),              intent(inout) :: self   
            !! Swiftest generic body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(in)    :: param  
            !! Current run configuration parameters 
      end subroutine swiftest_gr_kick_getaccb_ns_body

      pure module subroutine swiftest_gr_kick_getacch(mu, x, lmask, n, inv_c2, agr) 
         implicit none
         real(DP), dimension(:),     intent(in)  :: mu     
            !! Gravitational constant
         real(DP), dimension(:,:),   intent(in)  :: x      
            !! Position vectors
         logical,  dimension(:),     intent(in)  :: lmask  
            !! Logical mask indicating which bodies to compute
         integer(I4B),               intent(in)  :: n      
            !! Total number of bodies
         real(DP),                   intent(in)  :: inv_c2 
            !! Inverse speed of light squared: 1 / c**2
         real(DP), dimension(:,:),   intent(out) :: agr    
            !! Accelerations
      end subroutine swiftest_gr_kick_getacch

      pure elemental module subroutine swiftest_gr_p4_pos_kick(inv_c2, rx, ry, rz, vx, vy, vz, dt)
         implicit none
         real(DP),  intent(in)    :: inv_c2     
            !! One over speed of light squared (1/c**2)
         real(DP),  intent(inout) :: rx, ry, rz 
            !! Position vector
         real(DP),  intent(in)    :: vx, vy, vz 
            !! Velocity vector
         real(DP),  intent(in)    :: dt         
            !! Step size
      end subroutine swiftest_gr_p4_pos_kick

      pure module subroutine swiftest_gr_pseudovel2vel(param, mu, rh, pv, vh) 
         implicit none
         class(swiftest_parameters), intent(in)  :: param 
            !! Current run configuration parameters 
         real(DP),                   intent(in)  :: mu    
            !! G * (Mcb + m), G = gravitational constant, Mcb = mass of central body, m = mass of body
         real(DP), dimension(:),     intent(in)  :: rh    
            !! Swiftestcentric position vector 
         real(DP), dimension(:),     intent(in)  :: pv    
            !! Pseudovelocity velocity vector - see Saha & Tremain (1994), eq. (32)
         real(DP), dimension(:),     intent(out) :: vh    
            !! Swiftestcentric velocity vector 
      end subroutine swiftest_gr_pseudovel2vel

      pure module subroutine swiftest_gr_pv2vh_body(self, param)
         implicit none
         class(swiftest_body),       intent(inout) :: self  
            !! Swiftest particle object
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_gr_pv2vh_body

      pure module subroutine swiftest_gr_vel2pseudovel(param, mu, rh, vh, pv)
         implicit none
         class(swiftest_parameters), intent(in)  :: param 
            !! Current run configuration parameters 
         real(DP),                   intent(in)  :: mu    
            !! G * (Mcb + m), G = gravitational constant, Mcb = mass of central body, m = mass of body
         real(DP), dimension(:),     intent(in)  :: rh    
            !! Swiftestcentric position vector 
         real(DP), dimension(:),     intent(in)  :: vh    
            !! Swiftestcentric velocity vector 
         real(DP), dimension(:),     intent(out) :: pv    
            !! Pseudovelocity vector - see Saha & Tremain (1994), eq. (32)
      end subroutine swiftest_gr_vel2pseudovel

      pure module subroutine swiftest_gr_vh2pv_body(self, param)
         implicit none
         class(swiftest_body),       intent(inout) :: self  
            !! Swiftest particle object
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters
      end subroutine swiftest_gr_vh2pv_body

      module subroutine swiftest_io_compact_output(self, param, timer)
         implicit none
         class(swiftest_nbody_system), intent(in) :: self  
            !! Swiftest nbody system object   
         class(swiftest_parameters),        intent(in) :: param 
            !! Input colleciton of user-defined parameters
         class(*),                          intent(in) :: timer 
            !! Object used for computing elapsed wall time
      end subroutine swiftest_io_compact_output

      module subroutine swiftest_io_conservation_report(self, param, lterminal)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self      
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(inout) :: param     
            !! Input colleciton of user-defined parameters
         logical,                           intent(in)    :: lterminal 
            !! Indicates whether to output information to the terminal screen
      end subroutine swiftest_io_conservation_report

      module subroutine swiftest_io_display_run_information(self, param, integration_timer, phase)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param 
            !! Current run configuration parameters 
         type(walltimer),              intent(inout) :: integration_timer 
            !! Object used for computing elapsed wall time
         character(len=*), optional,   intent(in)    :: phase 
            !! One of "first" or "last" 
      end subroutine swiftest_io_display_run_information

      module subroutine swiftest_io_dump_param(self, param_file_name)
         implicit none
         class(swiftest_parameters),intent(in)    :: self            
            !! Output collection of parameters
         character(len=*),          intent(in)    :: param_file_name 
            !! Parameter input file name (i.e. param.in)
      end subroutine swiftest_io_dump_param

      module subroutine swiftest_io_dump_system(self, param, system_history)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self   
            !! Swiftest nbody_system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
         class(swiftest_storage),      intent(inout) :: system_history    
            !! Stores the system history between output dumps
      end subroutine swiftest_io_dump_system

      module subroutine swiftest_io_dump_storage(self, param)
         implicit none
         class(swiftest_storage), intent(inout) :: self   
            !! Swiftest simulation history storage object
         class(swiftest_parameters), intent(inout) :: param  
            !! Current run configuration parameters 
      end subroutine swiftest_io_dump_storage

      module subroutine swiftest_io_get_args(integrator, param_file_name, display_style, from_cli) 
         implicit none
         character(len=:), allocatable, intent(inout) :: integrator      
            !! Symbolic code of the requested integrator  
         character(len=:), allocatable, intent(inout) :: param_file_name 
            !! Name of the input parameters file
         character(len=:), allocatable, intent(inout) :: display_style   
            !! Style of the output display {"STANDARD", "COMPACT"}). Default is "STANDARD"
         logical,                       intent(in)    :: from_cli        
            !! If true, get command-line arguments. Otherwise, use the values of the input variables
      end subroutine swiftest_io_get_args

      module function swiftest_io_get_token(buffer, ifirst, ilast, ierr) result(token)
         implicit none
         character(len=*), intent(in)    :: buffer         
            !! Input string buffer
         integer(I4B),     intent(inout) :: ifirst         
            !! Index of the buffer at which to start the search for a token
         integer(I4B),     intent(out)   :: ilast          
            !! Index of the buffer at the end of the returned token
         integer(I4B),     intent(out)   :: ierr           
            !! Error code
         character(len=:), allocatable   :: token          
            !! Returned token string
      end function swiftest_io_get_token

      module subroutine swiftest_io_log_one_message(file, message)
         implicit none
         character(len=*), intent(in) :: file   
            !! Name of file to log
         character(len=*), intent(in) :: message
      end subroutine swiftest_io_log_one_message
   
      module subroutine swiftest_io_log_start(param, file, header)
         implicit none
         class(swiftest_parameters), intent(in) :: param  
            !! Current Swiftest run configuration parameters
         character(len=*),           intent(in) :: file   
            !! Name of file to log
         character(len=*),           intent(in) :: header 
            !! Header to print at top of log file
      end subroutine swiftest_io_log_start

      module subroutine swiftest_io_netcdf_flush(self, param)
         implicit none
         class(swiftest_netcdf_parameters), intent(inout) :: self  
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_netcdf_flush

      module subroutine swiftest_io_netcdf_get_t0_values_system(self, nc, param) 
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self  
            !! Swiftest nbody system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc     
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_netcdf_get_t0_values_system

      module subroutine swiftest_io_netcdf_get_valid_masks(self, plmask, tpmask, plmmask, Gmtiny)
         implicit none
         class(swiftest_netcdf_parameters),  intent(inout)          :: self    
            !! Parameters used to identify a particular NetCDF dataset
         logical, dimension(:), allocatable, intent(out)            :: plmask  
            !! Logical mask indicating which bodies are massive bodies
         logical, dimension(:), allocatable, intent(out)            :: tpmask  
            !! Logical mask indicating which bodies are test particles
         logical, dimension(:), allocatable, intent(out), optional  :: plmmask 
            !! Logical mask indicating which bodies are fully interacting massive bodies
         real(DP),                           intent(in),  optional  :: Gmtiny  
            !! The cutoff G*mass between semi-interacting and fully interacting massive bodies
      end subroutine swiftest_io_netcdf_get_valid_masks

      module subroutine swiftest_io_netcdf_initialize_output(self, param)
         implicit none
         class(swiftest_netcdf_parameters), intent(inout) :: self  
            !! Parameters used to for writing a NetCDF dataset to file
         class(swiftest_parameters),        intent(in)    :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_netcdf_initialize_output

      module subroutine swiftest_io_netcdf_open(self, param, readonly)
         implicit none
         class(swiftest_netcdf_parameters), intent(inout) :: self     
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param    
            !! Current run configuration parameters
         logical, optional,                 intent(in)    :: readonly 
            !! Logical flag indicating that this should be open read only
      end subroutine swiftest_io_netcdf_open

      module function swiftest_io_netcdf_read_frame_system(self, nc, param) result(ierr)
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self  
            !! Swiftest nbody_system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to for reading a NetCDF dataset to file
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
         integer(I4B)                                     :: ierr  
            !! Error code: returns 0 if the read is successful
      end function swiftest_io_netcdf_read_frame_system

      module subroutine swiftest_io_netcdf_read_hdr_system(self, nc, param) 
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self  
            !! Swiftest nbody system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to for reading a NetCDF dataset to file
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine swiftest_io_netcdf_read_hdr_system

      module subroutine swiftest_io_netcdf_read_particle_info_system(self, nc, param, plmask, tpmask)
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self   
            !! Swiftest nbody system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc     
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param  
            !! Current run configuration parameters
         logical, dimension(:),             intent(in)    :: plmask 
            !! Logical array indicating which index values belong to massive bodies
         logical, dimension(:),             intent(in)    :: tpmask 
            !! Logical array indicating which index values belong to test particles
      end subroutine swiftest_io_netcdf_read_particle_info_system

      module subroutine swiftest_io_netcdf_write_frame_body(self, nc, param)
         implicit none
         class(swiftest_body),              intent(in)    :: self  
            !! Swiftest base object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to for writing a NetCDF dataset to file
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_netcdf_write_frame_body

      module subroutine swiftest_io_netcdf_write_frame_cb(self, nc, param)
         implicit none
         class(swiftest_cb),                intent(inout)    :: self  
            !! Swiftest base object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to for writing a NetCDF dataset to file
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_netcdf_write_frame_cb

      module subroutine swiftest_io_netcdf_write_frame_system(self, nc, param)
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self  
            !! Swiftest nbody_system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to for writing a NetCDF dataset to file
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_netcdf_write_frame_system

      module subroutine swiftest_io_netcdf_write_hdr_system(self, nc, param) 
         implicit none
         class(swiftest_nbody_system),      intent(in)    :: self  
            !! Swiftest nbody system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to for writing a NetCDF dataset to file
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine swiftest_io_netcdf_write_hdr_system

      module subroutine swiftest_io_netcdf_write_info_body(self, nc, param)
         implicit none
         class(swiftest_body),              intent(in)    :: self  
            !! Swiftest particle object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine swiftest_io_netcdf_write_info_body

      module subroutine swiftest_io_netcdf_write_info_cb(self, nc, param)
         implicit none
         class(swiftest_cb),                intent(in)    :: self  
            !! Swiftest particle object
         class(swiftest_netcdf_parameters), intent(inout) :: nc    
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine swiftest_io_netcdf_write_info_cb

      module subroutine swiftest_io_remove_nul_char(string)
         implicit none
         character(len=*), intent(inout) :: string 
            !! String to remove nul characters from
      end subroutine swiftest_io_remove_nul_char

      module subroutine swiftest_io_param_reader(self, unit, iotype, v_list, iostat, iomsg) 
         implicit none
         class(swiftest_parameters), intent(inout) :: self       
            !! Collection of parameters
         integer(I4B),               intent(in)    :: unit       
            !! File unit number
         character(len=*),           intent(in)    :: iotype     
            !! Dummy argument passed to the  input/output procedure contains the text from the char-literal-constant, prefixed 
            !! with DT. If you do not include a char-literal-constant, the iotype argument contains only DT.
         character(len=*),           intent(in)    :: v_list(:)  
            !! The first element passes the integrator code to the reader
         integer(I4B),               intent(out)   :: iostat     
            !! IO status code
         character(len=*),           intent(inout) :: iomsg      
            !! Message to pass if iostat /= 0
      end subroutine swiftest_io_param_reader

      module subroutine swiftest_io_param_writer(self, unit, iotype, v_list, iostat, iomsg) 
         implicit none
         class(swiftest_parameters), intent(in)    :: self      
            !! Collection of parameters
         integer(I4B),               intent(in)    :: unit      
            !! File unit number
         character(len=*),           intent(in)    :: iotype    
            !! Dummy argument passed to the  input/output procedure contains the text from the char-literal-constant, prefixed 
            !! with DT. If you do not include a char-literal-constant, the iotype argument contains only DT.
         integer(I4B),               intent(in)    :: v_list(:) 
            !! Not used in this procedure
         integer(I4B),               intent(out)   :: iostat    
            !! IO status code
         character(len=*),           intent(inout) :: iomsg     
            !! Message to pass if iostat /= 0
      end subroutine swiftest_io_param_writer
   end interface

   interface io_param_writer_one
      module subroutine swiftest_io_param_writer_one_char(param_name, param_value, unit)
         implicit none
         character(len=*), intent(in)    :: param_name  
            !! Name of parameter to print
         character(len=*), intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),     intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_char

      module subroutine swiftest_io_param_writer_one_DP(param_name, param_value, unit)
         implicit none
         character(len=*), intent(in)    :: param_name  
            !! Name of parameter to print
         real(DP),         intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),     intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_DP

      module subroutine swiftest_io_param_writer_one_DParr(param_name, param_value, unit)
         implicit none
         character(len=*),       intent(in)    :: param_name  
            !! Name of parameter to print
         real(DP), dimension(:), intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),           intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_DParr

      module subroutine swiftest_io_param_writer_one_I4B(param_name, param_value, unit)
         implicit none
         character(len=*), intent(in)    :: param_name  
            !! Name of parameter to print
         integer(I4B),     intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),     intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_I4B

      module subroutine swiftest_io_param_writer_one_I4Barr(param_name, param_value, unit)
         implicit none
         character(len=*),           intent(in)    :: param_name  
            !! Name of parameter to print
         integer(I4B), dimension(:), intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),               intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_I4Barr

      module subroutine swiftest_io_param_writer_one_I8B(param_name, param_value, unit)
         implicit none
         character(len=*), intent(in)    :: param_name  
            !! Name of parameter to print
         integer(I8B),     intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),     intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_I8B

      module subroutine swiftest_io_param_writer_one_logical(param_name, param_value, unit)
         implicit none
         character(len=*), intent(in)    :: param_name  
            !! Name of parameter to print
         logical,          intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),     intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_logical

#ifdef QUADPREC
      module subroutine swiftest_io_param_writer_one_QP(param_name, param_value, unit)
         implicit none
         character(len=*), intent(in)    :: param_name  
            !! Name of parameter to print
         real(QP),         intent(in)    :: param_value 
            !! Value of parameter to print
         integer(I4B),     intent(in)    :: unit        
            !! Open file unit number to print parameter to
      end subroutine swiftest_io_param_writer_one_QP
#endif
   end interface io_param_writer_one

   interface

      module subroutine swiftest_io_read_in_body(self,param)
         implicit none
         class(swiftest_body),       intent(inout) :: self  
            !! Swiftest base object
         class(swiftest_parameters), intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_read_in_body

      module subroutine swiftest_io_read_in_cb(self,param)
         implicit none
         class(swiftest_cb),         intent(inout) :: self  
            !! Swiftest base object
         class(swiftest_parameters), intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_read_in_cb

      module subroutine swiftest_io_read_in_param(self, param_file_name) 
         implicit none
         class(swiftest_parameters), intent(inout) :: self            
            !! Current run configuration parameters
         character(len=*),           intent(in)    :: param_file_name 
            !! Parameter input file name (i.e. param.in)
      end subroutine swiftest_io_read_in_param

      module subroutine swiftest_io_read_in_system(self, nc, param)
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self
         class(swiftest_netcdf_parameters), intent(inout) :: nc     
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param
      end subroutine swiftest_io_read_in_system

      module function swiftest_io_read_frame_body(self, iu, param) result(ierr)
         implicit none
         class(swiftest_body),       intent(inout) :: self  
            !! Swiftest body object
         integer(I4B),               intent(inout) :: iu    
            !! Unit number for the output file to write frame to
         class(swiftest_parameters), intent(inout) :: param 
            !! Current run configuration parameters 
         integer(I4B)                              :: ierr  
            !! Error code: returns 0 if the read is successful
      end function swiftest_io_read_frame_body

      module function swiftest_io_read_frame_system(self, iu, param) result(ierr)
         implicit none
         class(swiftest_nbody_system),intent(inout) :: self  
            !! Swiftest nbody_system object
         integer(I4B),                     intent(inout) :: iu    
            !! Unit number for the output file to read frame from
         class(swiftest_parameters),       intent(inout) :: param 
            !! Current run configuration parameters 
         integer(I4B)                               :: ierr  
            !! Error code: returns 0 if the read is successful
      end function swiftest_io_read_frame_system

      module subroutine swiftest_io_set_display_param(self, display_style)
         implicit none
         class(swiftest_parameters), intent(inout) :: self            
            !! Current run configuration parameters
         character(*),               intent(in)    :: display_style   
            !! Style of the output display 
      end subroutine swiftest_io_set_display_param

      module subroutine swiftest_io_toupper(string)
         implicit none
         character(*), intent(inout) :: string 
            !! String to make upper case
      end subroutine swiftest_io_toupper

      module subroutine swiftest_io_initialize_output_file_system(self, nc, param)
         implicit none
         class(swiftest_nbody_system),      intent(inout) :: self   
            !! Swiftest nbody_system object
         class(swiftest_netcdf_parameters), intent(inout) :: nc     
            !! Parameters used to identify a particular NetCDF dataset
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters 
      end subroutine swiftest_io_initialize_output_file_system

      module subroutine swiftest_kick_getacch_int_pl(self, param)
         implicit none
         class(swiftest_pl),         intent(inout) :: self  
            !! Swiftest massive body object
         class(swiftest_parameters), intent(inout) :: param 
            !! Current swiftest run configuration parameters
      end subroutine swiftest_kick_getacch_int_pl

      module subroutine swiftest_kick_getacch_int_tp(self, param, GMpl, rhp, npl)
         implicit none
         class(swiftest_tp),         intent(inout) :: self  
            !! Swiftest test particle object
         class(swiftest_parameters), intent(inout) :: param 
            !! Current swiftest run configuration parameters
         real(DP), dimension(:),     intent(in)    :: GMpl  
            !! Massive body masses
         real(DP), dimension(:,:),   intent(in)    :: rhp   
            !! Massive body position vectors
         integer(I4B),               intent(in)    :: npl   
            !! Number of active massive bodies
      end subroutine swiftest_kick_getacch_int_tp
   end interface

   interface swiftest_kick_getacch_int_all
      module subroutine swiftest_kick_getacch_int_all_flat_rad_pl(npl, nplpl, k_plpl, r, Gmass, radius, acc)
         implicit none
         integer(I4B),                 intent(in)             :: npl    
            !! Number of massive bodies
         integer(I8B),                 intent(in)             :: nplpl  
            !! Number of massive body interactions to compute
         integer(I4B), dimension(:,:), intent(in)             :: k_plpl 
            !! Array of interaction pair indices (flattened upper triangular matrix)
         real(DP),     dimension(:,:), intent(in)             :: r      
            !! Position vector array
         real(DP),     dimension(:),   intent(in)             :: Gmass  
            !! Array of massive body G*mass
         real(DP),     dimension(:),   intent(in)             :: radius 
            !! Array of massive body radii
         real(DP),     dimension(:,:), intent(inout)          :: acc    
            !! Acceleration vector array 
      end subroutine swiftest_kick_getacch_int_all_flat_rad_pl

      module subroutine swiftest_kick_getacch_int_all_flat_norad_pl(npl, nplpl, k_plpl, r, Gmass, acc)
         implicit none
         integer(I4B),                 intent(in)             :: npl    
            !! Number of massive bodies
         integer(I8B),                 intent(in)             :: nplpl  
            !! Number of massive body interactions to compute
         integer(I4B), dimension(:,:), intent(in)             :: k_plpl 
            !! Array of interaction pair indices (flattened upper triangular matrix)
         real(DP),     dimension(:,:), intent(in)             :: r      
            !! Position vector array
         real(DP),     dimension(:),   intent(in)             :: Gmass  
            !! Array of massive body G*mass
         real(DP),     dimension(:,:), intent(inout)          :: acc    
            !! Acceleration vector array 
      end subroutine swiftest_kick_getacch_int_all_flat_norad_pl

      module subroutine swiftest_kick_getacch_int_all_tri_rad_pl(npl, nplm, r, Gmass, radius, acc)
         implicit none
         integer(I4B),                 intent(in)             :: npl    
            !! Total number of massive bodies
         integer(I4B),                 intent(in)             :: nplm   
            !! Number of fully interacting massive bodies
         real(DP),     dimension(:,:), intent(in)             :: r      
            !! Position vector array
         real(DP),     dimension(:),   intent(in)             :: Gmass  
            !! Array of massive body G*mass
         real(DP),     dimension(:),   intent(in)             :: radius 
            !! Array of massive body radii
         real(DP),     dimension(:,:), intent(inout)          :: acc    
            !! Acceleration vector array 
      end subroutine swiftest_kick_getacch_int_all_tri_rad_pl

      module subroutine swiftest_kick_getacch_int_all_tri_norad_pl(npl, nplm, r, Gmass, acc)
         implicit none
         integer(I4B),                 intent(in)             :: npl    
            !! Total number of massive bodies
         integer(I4B),                 intent(in)             :: nplm   
            !! Number of fully interacting massive bodies
         real(DP),     dimension(:,:), intent(in)             :: r      
            !! Position vector array
         real(DP),     dimension(:),   intent(in)             :: Gmass  
            !! Array of massive body G*mass
         real(DP),     dimension(:,:), intent(inout)          :: acc    
            !! Acceleration vector array 
      end subroutine swiftest_kick_getacch_int_all_tri_norad_pl

      module subroutine swiftest_kick_getacch_int_all_tp(ntp, npl, rtp, rpl, GMpl, lmask, acc)
         implicit none
         integer(I4B),                 intent(in)    :: ntp   
            !! Number of test particles
         integer(I4B),                 intent(in)    :: npl   
            !! Number of massive bodies
         real(DP),     dimension(:,:), intent(in)    :: rtp   
            !! Test particle position vector array
         real(DP),     dimension(:,:), intent(in)    :: rpl   
            !! Massive body particle position vector array
         real(DP),     dimension(:),   intent(in)    :: GMpl  
            !! Array of massive body G*mass
         logical,      dimension(:),   intent(in)    :: lmask 
            !! Logical mask indicating which test particles should be computed
         real(DP),     dimension(:,:), intent(inout) :: acc   
            !! Acceleration vector array 
      end subroutine swiftest_kick_getacch_int_all_tp
   end interface

   interface
      pure module subroutine swiftest_kick_getacch_int_one_pl(rji2, xr, yr, zr, Gmi, Gmj, axi, ayi, azi, axj, ayj, azj)
         !$omp declare simd(swiftest_kick_getacch_int_one_pl)
         implicit none
         real(DP), intent(in)  :: rji2            
            !! Square of distance between the two bodies
         real(DP), intent(in)  :: xr, yr, zr      
            !! Distances between the two bodies in x, y, and z directions
         real(DP), intent(in)  :: Gmi             
            !! G*mass of body i
         real(DP), intent(in)  :: Gmj             
            !! G*mass of body j
         real(DP), intent(inout) :: axi, ayi, azi 
            !! Acceleration vector components of body i
         real(DP), intent(inout) :: axj, ayj, azj 
            !! Acceleration vector components of body j
      end subroutine swiftest_kick_getacch_int_one_pl

      pure module subroutine swiftest_kick_getacch_int_one_tp(rji2, xr, yr, zr, Gmpl, ax, ay, az)
         !$omp declare simd(swiftest_kick_getacch_int_one_tp)
         implicit none
         real(DP), intent(in)  :: rji2         
            !! Square of distance between the test particle and massive body
         real(DP), intent(in)  :: xr, yr, zr   
            !! Distances between the two bodies in x, y, and z directions
         real(DP), intent(in)  :: Gmpl         
            !! G*mass of massive body
         real(DP), intent(inout) :: ax, ay, az 
            !! Acceleration vector components of test particle
      end subroutine swiftest_kick_getacch_int_one_tp

      module subroutine swiftest_obl_rot_matrix(n, rot, rot_matrix, rot_matrix_inv)
         implicit none
         integer(I4B),             intent(in)           :: n              
            !! Number of bodies
         real(DP), dimension(NDIM), intent(in)       :: rot               
            !! Central body rotation vector
         real(DP), dimension(NDIM, NDIM), intent(inout) :: rot_matrix     
            !! rotation matrix 
         real(DP), dimension(NDIM, NDIM), intent(inout) :: rot_matrix_inv 
            !! inverse of the rotation matrix
      end subroutine swiftest_obl_rot_matrix

      module subroutine swiftest_obl_acc(n, GMcb, j2rp2, j4rp4, rh, lmask, aobl, rot, GMpl, aoblcb)
         implicit none
         integer(I4B),             intent(in)            :: n      
            !! Number of bodies
         real(DP),                 intent(in)            :: GMcb   
            !! Central body G*Mass
         real(DP),                 intent(in)            :: j2rp2  
            !! J2 * R**2 for the central body
         real(DP),                 intent(in)            :: j4rp4  
            !! J4 * R**4 for the central body
         real(DP), dimension(:,:), intent(in)            :: rh     
            !! Heliocentric positions of bodies
         logical,  dimension(:),   intent(in)            :: lmask  
            !! Logical mask of bodies to compute aobl
         real(DP), dimension(:,:), intent(out)           :: aobl   
            !! Barycentric acceleration of bodies due to central body oblateness
         real(DP), dimension(NDIM), intent(in)        :: rot    
            !! Central body rotation matrix
         real(DP), dimension(:),   intent(in),  optional :: GMpl   
            !! Masses of input bodies if they are not test particles
         real(DP), dimension(:),   intent(out), optional :: aoblcb 
            !! Barycentric acceleration of central body (only needed if input bodies are massive)
      end subroutine swiftest_obl_acc

      module subroutine swiftest_non_spherical_cb_acc_pl(self, nbody_system)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
      end subroutine swiftest_non_spherical_cb_acc_pl

      module subroutine swiftest_non_spherical_cb_acc_tp(self, nbody_system)
         implicit none
         class(swiftest_tp), intent(inout) :: self  
            !! Swiftest test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
      end subroutine swiftest_non_spherical_cb_acc_tp

      module subroutine swiftest_obl_pot_system(self)
         implicit none
         class(swiftest_nbody_system), intent(inout)  :: self   
            !! Swiftest nbody system object
      end subroutine swiftest_obl_pot_system

      module subroutine swiftest_orbel_el2xv_vec(self, cb)
         implicit none
         class(swiftest_body), intent(inout) :: self 
            !! Swiftest body object
         class(swiftest_cb),   intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_orbel_el2xv_vec

      pure module subroutine swiftest_orbel_scget(angle, sx, cx)
         !$omp declare simd(swiftest_orbel_scget)
         implicit none
         real(DP), intent(in)  :: angle
         real(DP), intent(out) :: sx, cx
      end subroutine swiftest_orbel_scget

      pure elemental module subroutine swiftest_orbel_xv2aeq(mu, rx, ry, rz, vx, vy, vz, a, e, q)
         !$omp declare simd(swiftest_orbel_xv2aeq)
         implicit none
         real(DP), intent(in)  :: mu       
            !! Gravitational constant
         real(DP), intent(in)  :: rx,ry,rz 
            !! Position vector
         real(DP), intent(in)  :: vx,vy,vz 
            !! Velocity vector
         real(DP), intent(out) :: a        
            !! semimajor axis
         real(DP), intent(out) :: e        
            !! eccentricity
         real(DP), intent(out) :: q        
            !! periapsis
      end subroutine swiftest_orbel_xv2aeq

      pure module subroutine swiftest_orbel_xv2aqt(mu, rx, ry, rz, vx, vy, vz, a, q, capm, tperi)
         !$omp declare simd(swiftest_orbel_xv2aqt)
         implicit none
         real(DP), intent(in)  :: mu       
            !! Gravitational constant
         real(DP), intent(in)  :: rx,ry,rz 
            !! Position vector
         real(DP), intent(in)  :: vx,vy,vz 
            !! Velocity vector
         real(DP), intent(out) :: a        
            !! semimajor axis
         real(DP), intent(out) :: q        
            !! periapsis
         real(DP), intent(out) :: capm     
            !! mean anomaly
         real(DP), intent(out) :: tperi    
            !! time of pericenter passage
      end subroutine swiftest_orbel_xv2aqt

      pure module subroutine swiftest_orbel_xv2el(mu, rx, ry, rz, vx, vy, vz, &
                                                      a, e, inc, capom, omega, capm, varpi, lam, f, cape, capf)
         implicit none
         real(DP), intent(in)  :: mu    
            !! Gravitational constant
         real(DP), intent(in)  :: rx,ry,rz 
            !! Position vector
         real(DP), intent(in)  :: vx,vy,vz 
            !! Velocity vector
         real(DP), intent(out) :: a     
            !! semimajor axis
         real(DP), intent(out) :: e     
            !! eccentricity
         real(DP), intent(out) :: inc   
            !! inclination
         real(DP), intent(out) :: capom 
            !! longitude of ascending node
         real(DP), intent(out) :: omega 
            !! argument of periapsis
         real(DP), intent(out) :: capm  
            !! mean anomaly
         real(DP), intent(out) :: varpi 
            !! longitude of periapsis
         real(DP), intent(out) :: lam   
            !! mean longitude
         real(DP), intent(out) :: f     
            !! true anomaly
         real(DP), intent(out) :: cape  
            !! eccentric anomaly (eccentric orbits)
         real(DP), intent(out) :: capf  
            !! hyperbolic anomaly (hyperbolic orbits)
      end subroutine swiftest_orbel_xv2el

      module subroutine swiftest_orbel_xv2el_vec(self, cb)
         implicit none
         class(swiftest_body), intent(inout) :: self 
            !! Swiftest body object
         class(swiftest_cb),   intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_orbel_xv2el_vec

      module subroutine swiftest_util_setup_body(self, n, param)
         implicit none
         class(swiftest_body),       intent(inout) :: self  
            !! Swiftest body object
         integer(I4B),               intent(in)    :: n     
            !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters
      end subroutine swiftest_util_setup_body

      module subroutine swiftest_util_setup_construct_system(nbody_system, param)
         implicit none
         class(swiftest_nbody_system), allocatable, intent(inout) :: nbody_system 
            !! Swiftest nbody_system object
         class(swiftest_parameters),                intent(inout) :: param        
            !! Current run configuration parameters
      end subroutine swiftest_util_setup_construct_system

      module subroutine swiftest_util_setup_initialize_particle_info_system(self, param)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self  
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine swiftest_util_setup_initialize_particle_info_system

      module subroutine swiftest_util_setup_initialize_system(self, system_history, param)
         implicit none
         class(swiftest_nbody_system),              intent(inout) :: self           
            !! Swiftest nbody_system object
         class(swiftest_storage),      allocatable, intent(inout) :: system_history 
            !! Stores the system history between output dumps
         class(swiftest_parameters),                intent(inout) :: param          
            !! Current run configuration parameters
      end subroutine swiftest_util_setup_initialize_system

      module subroutine swiftest_util_setup_pl(self, n, param)
         implicit none
         class(swiftest_pl),         intent(inout) :: self  
            !! Swiftest massive body object
         integer(I4B),               intent(in)    :: n     
            !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters
      end subroutine swiftest_util_setup_pl

      module subroutine swiftest_util_setup_tp(self, n, param)
         implicit none
         class(swiftest_tp),         intent(inout) :: self  
            !! Swiftest test particle object
         integer(I4B),               intent(in)    :: n     
            !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parametersr
      end subroutine swiftest_util_setup_tp

      module subroutine swiftest_user_kick_getacch_body(self, nbody_system, param, t, lbeg)
         implicit none
         class(swiftest_body),              intent(inout) :: self   
            !! Swiftest massive body particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody_system_object
         class(swiftest_parameters),        intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                          intent(in)    :: t      
            !! Current time
         logical,                           intent(in)    :: lbeg   
            !! Optional argument that determines whether or not this is the beginning or end of the step
      end subroutine swiftest_user_kick_getacch_body
   end interface

   interface util_append
      module subroutine swiftest_util_append_arr_info(arr, source, nold, lsource_mask)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout)        :: arr          
            !! Destination array 
         type(swiftest_particle_info), dimension(:), allocatable, intent(in)           :: source       
            !! Array to append 
         integer(I4B),                                            intent(in), optional :: nold         
            !! Extent of original array. If passed, the source array will begin at arr(nold+1). 
            !! Otherwise, the size of arr will be used.
         logical,                      dimension(:),              intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine swiftest_util_append_arr_info

      module subroutine swiftest_util_append_arr_kin(arr, source, nold, lsource_mask)
         implicit none
         type(swiftest_kinship), dimension(:), allocatable, intent(inout)        :: arr          
            !! Destination array 
         type(swiftest_kinship), dimension(:), allocatable, intent(in)           :: source       
            !! Array to append 
         integer(I4B),                                      intent(in), optional :: nold         
            !! Extent of original array. If passed, the source array will begin at arr(nold+1). 
            !! Otherwise, the size of arr will be used.
         logical,                dimension(:),              intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine swiftest_util_append_arr_kin
   end interface

   interface
      module subroutine swiftest_util_append_body(self, source, lsource_mask)
         implicit none
         class(swiftest_body),  intent(inout) :: self          
            !! Swiftest body object
         class(swiftest_body),  intent(in)    :: source        
            !! Source object to append
         logical, dimension(:), intent(in)    :: lsource_mask  
            !! Logical mask indicating which elements to append to
      end subroutine swiftest_util_append_body

      module subroutine swiftest_util_append_pl(self, source, lsource_mask)
         implicit none
         class(swiftest_pl),    intent(inout) :: self         
            !! Swiftest massive body object
         class(swiftest_body),  intent(in)    :: source       
            !! Source object to append
         logical, dimension(:), intent(in)    :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine swiftest_util_append_pl
   
      module subroutine swiftest_util_append_tp(self, source, lsource_mask)
         implicit none
         class(swiftest_tp),    intent(inout) :: self         
            !! Swiftest test particle object
         class(swiftest_body),  intent(in)    :: source       
            !! Source object to append
         logical, dimension(:), intent(in)    :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine swiftest_util_append_tp

      module subroutine swiftest_util_coord_b2h_pl(self, cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_b2h_pl

      module subroutine swiftest_util_coord_b2h_tp(self, cb)
         implicit none
         class(swiftest_tp), intent(inout) :: self 
            !! Swiftest test particle object
         class(swiftest_cb), intent(in)    :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_b2h_tp

      module subroutine swiftest_util_coord_h2b_pl(self, cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_h2b_pl

      module subroutine swiftest_util_coord_h2b_tp(self, cb)
         implicit none
         class(swiftest_tp), intent(inout) :: self 
            !! Swiftest test particle object
         class(swiftest_cb), intent(in)    :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_h2b_tp

      module subroutine swiftest_util_coord_vb2vh_pl(self, cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_vb2vh_pl
   
      module subroutine swiftest_util_coord_vb2vh_tp(self, vbcb)
         implicit none
         class(swiftest_tp),     intent(inout) :: self 
            !! Swiftest test particle object
         real(DP), dimension(:), intent(in)    :: vbcb 
            !! Barycentric velocity of the central body
      end subroutine swiftest_util_coord_vb2vh_tp
   
      module subroutine swiftest_util_coord_vh2vb_pl(self, cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_vh2vb_pl
   
      module subroutine swiftest_util_coord_vh2vb_tp(self, vbcb)
         implicit none
         class(swiftest_tp),     intent(inout) :: self 
            !! Swiftest test particle object
         real(DP), dimension(:), intent(in)    :: vbcb 
            !! Barycentric velocity of the central body
      end subroutine swiftest_util_coord_vh2vb_tp

      module subroutine swiftest_util_coord_rh2rb_pl(self, cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_coord_rh2rb_pl

      module subroutine swiftest_util_coord_rh2rb_tp(self, cb)
         implicit none
         class(swiftest_tp), intent(inout) :: self 
            !! Swiftest test particle object
         class(swiftest_cb), intent(in) :: cb      
            !! Swiftest central body object
      end subroutine swiftest_util_coord_rh2rb_tp

      module subroutine swiftest_util_copy_particle_info(self, source)
         implicit none
         class(swiftest_particle_info),  intent(inout) :: self
         class(swiftest_particle_info),  intent(in)    :: source
      end subroutine swiftest_util_copy_particle_info

      module subroutine swiftest_util_copy_particle_info_arr(source, dest, idx)
         implicit none
         class(swiftest_particle_info), dimension(:), intent(in)             :: source 
            !! Source object to copy into
         class(swiftest_particle_info), dimension(:), intent(inout)          :: dest   
            !! Swiftest body object with particle metadata information object
         integer(I4B),                  dimension(:), intent(in),   optional :: idx    
            !! Optional array of indices to draw the source object
      end subroutine swiftest_util_copy_particle_info_arr

      module subroutine swiftest_util_dealloc_body(self)
         implicit none
         class(swiftest_body),  intent(inout) :: self
      end subroutine swiftest_util_dealloc_body

      module subroutine swiftest_util_dealloc_kin(self)
         implicit none
         class(swiftest_kinship), intent(inout) :: self 
            !! Swiftest kinship object
      end subroutine swiftest_util_dealloc_kin

      module subroutine swiftest_util_dealloc_cb(self)
         implicit none
         class(swiftest_cb), intent(inout) :: self 
            !! Swiftest central body object
      end subroutine swiftest_util_dealloc_cb

      module subroutine swiftest_util_dealloc_pl(self)
         implicit none
         class(swiftest_pl), intent(inout) :: self
      end subroutine swiftest_util_dealloc_pl

      module subroutine swiftest_util_dealloc_storage(self)
         implicit none
         class(swiftest_storage), intent(inout) :: self 
            !! Swiftest storage object
      end subroutine swiftest_util_dealloc_storage

      module subroutine swiftest_util_dealloc_system(self)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self
      end subroutine swiftest_util_dealloc_system

      module subroutine swiftest_util_dealloc_tp(self)
         implicit none
         class(swiftest_tp), intent(inout) :: self
      end subroutine swiftest_util_dealloc_tp

      module subroutine swiftest_util_fill_body(self, inserts, lfill_list)
         implicit none
         class(swiftest_body),  intent(inout) :: self       
            !! Swiftest body object
         class(swiftest_body),  intent(in)    :: inserts    
            !! Swiftest body object to be inserted
         logical, dimension(:), intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine swiftest_util_fill_body

      module subroutine swiftest_util_fill_pl(self, inserts, lfill_list)
         implicit none
         class(swiftest_pl),    intent(inout) :: self       
            !! Swiftest massive body object
         class(swiftest_body),  intent(in)    :: inserts    
            !! Swiftest body object to be inserted
         logical, dimension(:), intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine swiftest_util_fill_pl

      module subroutine swiftest_util_fill_tp(self, inserts, lfill_list)
         implicit none
         class(swiftest_tp),    intent(inout) :: self       
            !! Swiftest test particle object
         class(swiftest_body),  intent(in)    :: inserts    
            !! Swiftest body object to be inserted
         logical, dimension(:), intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine swiftest_util_fill_tp
   end interface

   interface util_fill
      module subroutine swiftest_util_fill_arr_info(keeps, inserts, lfill_list)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: keeps      
            !! Array of values to keep 
         type(swiftest_particle_info), dimension(:), allocatable, intent(in)    :: inserts    
            !! Array of values to insert into keep
         logical,                      dimension(:),              intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine swiftest_util_fill_arr_info

      module subroutine swiftest_util_fill_arr_kin(keeps, inserts, lfill_list)
         implicit none
         type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: keeps      
            !! Array of values to keep 
         type(swiftest_kinship), dimension(:), allocatable, intent(in)    :: inserts    
            !! Array of values to insert into keep
         logical,                dimension(:),              intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine swiftest_util_fill_arr_kin
   end interface

   interface
      pure module subroutine swiftest_util_flatten_eucl_ij_to_k(n, i, j, k)
         !$omp declare simd(swiftest_util_flatten_eucl_ij_to_k)
         implicit none
         integer(I4B), intent(in)  :: n 
            !! Number of bodies
         integer(I4B), intent(in)  :: i 
            !! Index of the ith body
         integer(I4B), intent(in)  :: j 
            !! Index of the jth body
         integer(I8B), intent(out) :: k 
            !! Index of the flattened matrix
      end subroutine swiftest_util_flatten_eucl_ij_to_k

      pure module subroutine swiftest_util_flatten_eucl_k_to_ij(n, k, i, j)
         implicit none
         integer(I4B), intent(in)  :: n 
            !! Number of bodies
         integer(I8B), intent(in)  :: k 
            !! Index of the flattened matrix
         integer(I4B), intent(out) :: i 
            !! Index of the ith body
         integer(I4B), intent(out) :: j 
            !! Index of the jth body
      end subroutine swiftest_util_flatten_eucl_k_to_ij

      module subroutine swiftest_util_flatten_eucl_plpl(self, param)
         implicit none
         class(swiftest_pl),         intent(inout) :: self  
            !! Swiftest massive body object
         class(swiftest_parameters), intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine

      module subroutine swiftest_util_flatten_eucl_pltp(self, pl, param)
         implicit none
         class(swiftest_tp),         intent(inout) :: self  
            !! Swiftest test particle object
         class(swiftest_pl),         intent(in)    :: pl    
            !! Swiftest massive body object
         class(swiftest_parameters), intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine

      module subroutine swiftest_util_get_energy_and_momentum_system(self, param)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self     
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(in)    :: param    
            !! Current run configuration parameters
      end subroutine swiftest_util_get_energy_and_momentum_system

      module subroutine swiftest_util_get_idvalues_system(self, idvals)
         implicit none
         class(swiftest_nbody_system),       intent(in)  :: self   
            !! Encounter snapshot object
         integer(I4B), dimension(:), allocatable, intent(out) :: idvals 
            !! Array of all id values saved in this snapshot
      end subroutine swiftest_util_get_idvalues_system
   end interface

   interface swiftest_util_get_potential_energy
      module subroutine swiftest_util_get_potential_energy_flat(npl, nplpl, k_plpl, lmask, GMcb, Gmass, mass, rb, pe)
         implicit none
         integer(I4B),                 intent(in)  :: npl
         integer(I8B),                 intent(in)  :: nplpl
         integer(I4B), dimension(:,:), intent(in)  :: k_plpl
         logical,      dimension(:),   intent(in)  :: lmask
         real(DP),                     intent(in)  :: GMcb
         real(DP),     dimension(:),   intent(in)  :: Gmass
         real(DP),     dimension(:),   intent(in)  :: mass
         real(DP),     dimension(:,:), intent(in)  :: rb
         real(DP),                     intent(out) :: pe
      end subroutine swiftest_util_get_potential_energy_flat
   
      module subroutine swiftest_util_get_potential_energy_triangular(npl, lmask, GMcb, Gmass, mass, rb, pe)
         implicit none
         integer(I4B),                 intent(in)  :: npl
         logical,      dimension(:),   intent(in)  :: lmask
         real(DP),                     intent(in)  :: GMcb
         real(DP),     dimension(:),   intent(in)  :: Gmass
         real(DP),     dimension(:),   intent(in)  :: mass
         real(DP),     dimension(:,:), intent(in)  :: rb
         real(DP),                     intent(out) :: pe
      end subroutine swiftest_util_get_potential_energy_triangular
   end interface

   interface
      module subroutine swiftest_util_get_vals_storage(self, idvals, tvals)
         class(swiftest_storage),              intent(in)  :: self   
            !! Swiftest storage object
         integer(I4B), dimension(:), allocatable, intent(out) :: idvals 
            !! Array of all id values in all snapshots
         real(DP),     dimension(:), allocatable, intent(out) :: tvals  
            !! Array of all time values in all snapshots
      end subroutine swiftest_util_get_vals_storage

      module subroutine swiftest_util_index_array(ind_arr, n)
         implicit none
         integer(I4B), dimension(:), allocatable, intent(inout) :: ind_arr 
            !! Index array. Input is a pre-existing index array where n /= size(ind_arr). 
            !! Output is a new index array ind_arr = [1, 2, ... n]
         integer(I4B),                            intent(in)    :: n       
            !! The new size of the index array
      end subroutine swiftest_util_index_array

      module subroutine swiftest_util_index_map_storage(self)
         implicit none
         class(swiftest_storage), intent(inout) :: self 
            !! Swiftest storage object
      end subroutine swiftest_util_index_map_storage

      module subroutine swiftest_util_make_impactors_pl(self, idx)
         implicit none
         class(swiftest_pl),         intent(inout) :: self  
            !! Massive body object
         integer(I4B), dimension(:), intent(in)    :: idx 
            !! Array holding the indices of the two bodies involved in the collision)
      end subroutine swiftest_util_make_impactors_pl

      module subroutine swiftest_util_peri(n,m, r, v, atp, q, isperi)
         implicit none
         integer(I4B),                 intent(in)    :: n      
            !! Number of bodies
         real(DP),     dimension(:),   intent(in)    :: m      
            !! Mass term (mu for HELIO coordinates, and Gmtot for BARY)
         real(DP),     dimension(:,:), intent(in)    :: r      
            !! Position vectors (rh for HELIO coordinates, rb for BARY)
         real(DP),     dimension(:,:), intent(in)    :: v      
            !! Position vectors (vh for HELIO coordinates, rb for BARY)
         real(DP),     dimension(:),   intent(out)   :: atp    
            !! Semimajor axis 
         real(DP),     dimension(:),   intent(out)   :: q      
            !! Periapsis
         integer(I4B), dimension(:),   intent(inout) :: isperi 
            !! Periapsis passage flag
      end subroutine swiftest_util_peri

      module subroutine swiftest_util_peri_body(self, nbody_system, param)
         implicit none
         class(swiftest_body),         intent(inout) :: self   
            !! SyMBA massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  
            !! Current run configuration parameters
      end subroutine swiftest_util_peri_body

      module subroutine swiftest_util_peri_tp(self, nbody_system, param) 
         implicit none
         class(swiftest_tp),                intent(inout) :: self   
            !! Swiftest test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(in)    :: param  
            !! Current run configuration parameters
      end subroutine swiftest_util_peri_tp

      module subroutine swiftest_util_rearray_pl(self, nbody_system, param)
         implicit none
         class(swiftest_pl),           intent(inout) :: self   
            !! Swiftest massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
      end subroutine swiftest_util_rearray_pl

      module subroutine swiftest_util_rearray_tp(self, nbody_system, param)
         implicit none
         class(swiftest_tp),           intent(inout) :: self   
            !! Swiftest test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
      end subroutine swiftest_util_rearray_tp

      module subroutine swiftest_util_rescale_system(self, param, mscale, dscale, tscale)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self   
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(inout) :: param  
            !! Current run configuration parameters. Returns with new values of the scale vactors and GU
         real(DP),                          intent(in)    :: mscale, dscale, tscale 
            !! Scale factors for mass, distance, and time units, respectively. 
      end subroutine swiftest_util_rescale_system

      module subroutine swiftest_util_reset_kinship_pl(self, idx)
         implicit none
         class(swiftest_pl),         intent(inout) :: self 
            !! SyMBA massive body object
         integer(I4B), dimension(:), intent(in)    :: idx  
            !! Index array of bodies to reset
      end subroutine swiftest_util_reset_kinship_pl

   end interface


   interface util_resize
      module subroutine swiftest_util_resize_arr_info(arr, nnew)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: arr  
            !! Array to resize
         integer(I4B),                                            intent(in)    :: nnew 
            !! New size
      end subroutine swiftest_util_resize_arr_info

      module subroutine swiftest_util_resize_arr_kin(arr, nnew)
         implicit none
         type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: arr  
            !! Array to resize
         integer(I4B),                                       intent(in)    :: nnew 
            !! New size
      end subroutine swiftest_util_resize_arr_kin
   end interface

   interface
      module subroutine swiftest_util_resize_body(self, nnew)
         implicit none
         class(swiftest_body), intent(inout) :: self 
            !! Swiftest body object
         integer(I4B),         intent(in)    :: nnew 
            !! New size neded
      end subroutine swiftest_util_resize_body

      module subroutine swiftest_util_resize_pl(self, nnew)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         integer(I4B),       intent(in)    :: nnew 
            !! New size neded
      end subroutine swiftest_util_resize_pl

      module subroutine swiftest_util_resize_storage(storage, nold, nnew)
         use base, only : base_storage
         implicit none
         class(base_storage), allocatable, intent(inout) :: storage 
            !! Original storage object
         integer(I4B),                        intent(in)    :: nold    
            !! Old size
         integer(I4B),                        intent(in)    :: nnew    
            !! New size
      end subroutine swiftest_util_resize_storage 

      module subroutine swiftest_util_resize_tp(self, nnew)
         implicit none
         class(swiftest_tp), intent(inout) :: self 
            !! Swiftest test particle object
         integer(I4B),       intent(in)    :: nnew 
            !! New size neded
      end subroutine swiftest_util_resize_tp

      module subroutine swiftest_util_set_beg_end_pl(self, rbeg, rend, vbeg)
         implicit none
         class(swiftest_pl),       intent(inout)          :: self 
            !! Swiftest massive body object
         real(DP), dimension(:,:), intent(in),   optional :: rbeg 
            !! Position vectors at beginning of step
         real(DP), dimension(:,:), intent(in),   optional :: rend 
            !! Positions vectors at end of step
         real(DP), dimension(:,:), intent(in),   optional :: vbeg 
            !! vbeg is an unused variable to keep this method forward compatible with RMVS
      end subroutine swiftest_util_set_beg_end_pl

      module subroutine swiftest_util_set_ir3h(self)
         implicit none
         class(swiftest_body), intent(inout) :: self 
            !! Swiftest body object
      end subroutine swiftest_util_set_ir3h

      module subroutine swiftest_util_set_msys(self)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self 
            !! Swiftest nbody_system object
      end subroutine swiftest_util_set_msys

      module subroutine swiftest_util_set_mu_pl(self, cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_set_mu_pl

      module subroutine swiftest_util_set_mu_tp(self, cb)
         implicit none
         class(swiftest_tp), intent(inout) :: self 
            !! Swiftest test particle object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_set_mu_tp

      module subroutine swiftest_util_set_particle_info(self, name, particle_type, status, origin_type, origin_time, collision_id, &
                                               origin_rh, origin_vh, discard_time, discard_rh, discard_vh, discard_body_id)
         implicit none
         class(swiftest_particle_info), intent(inout)           :: self
         character(len=*),              intent(in),    optional :: name            
            !! Non-unique name
         character(len=*),              intent(in),    optional :: particle_type   
            !! String containing a description of the particle type (e.g. Central Body, Massive Body, Test Particle)
         character(len=*),              intent(in),    optional :: status          
            !! Particle status description: Active, Merged, Fragmented, etc.
         character(len=*),              intent(in),    optional :: origin_type     
            !! String containing a description of the origin of the particle (e.g. Initial Conditions, Disruption, etc.)
         real(DP),                      intent(in),    optional :: origin_time     
            !! The time of the particle's formation
         integer(I4B),                  intent(in),    optional :: collision_id    
            !! The ID fo the collision that formed the particle
         real(DP), dimension(:),        intent(in),    optional :: origin_rh       
            !! The heliocentric distance vector at the time of the particle's formation
         real(DP), dimension(:),        intent(in),    optional :: origin_vh       
            !! The heliocentric velocity vector at the time of the particle's formation
         real(DP),                      intent(in),    optional :: discard_time    
            !! The time of the particle's discard
         real(DP), dimension(:),        intent(in),    optional :: discard_rh      
            !! The heliocentric distance vector at the time of the particle's discard
         real(DP), dimension(:),        intent(in),    optional :: discard_vh      
            !! The heliocentric velocity vector at the time of the particle's discard
         integer(I4B),                  intent(in),    optional :: discard_body_id 
            !! The id of the other body involved in the discard (0 if no other body involved)
      end subroutine swiftest_util_set_particle_info

      module subroutine swiftest_util_set_rhill(self,cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_set_rhill

      module subroutine swiftest_util_set_renc_I4B(self, scale)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         integer(I4B),       intent(in)    :: scale 
            !! Input scale factor (multiplier of Hill's sphere size)
      end subroutine swiftest_util_set_renc_I4B

      module subroutine swiftest_util_set_renc_DP(self, scale)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         real(DP),           intent(in)    :: scale 
            !! Input scale factor (multiplier of Hill's sphere size)
      end subroutine swiftest_util_set_renc_DP

      module subroutine swiftest_util_set_rhill_approximate(self,cb)
         implicit none
         class(swiftest_pl), intent(inout) :: self 
            !! Swiftest massive body object
         class(swiftest_cb), intent(inout) :: cb   
            !! Swiftest central body object
      end subroutine swiftest_util_set_rhill_approximate

      module subroutine swiftest_util_snapshot_save(storage, snapshot)
         use base, only : base_storage
         implicit none
         class(base_storage), allocatable, intent(inout) :: storage  
            !! Storage ncounter storage object
         class(*),                         intent(in)    :: snapshot 
            !! Object to snapshot
      end subroutine swiftest_util_snapshot_save

      module subroutine swiftest_util_snapshot_system(self, param, nbody_system, t, arg)
         implicit none
         class(swiftest_storage),      intent(inout)        :: self            
            !! Swiftest storage object
         class(swiftest_parameters),   intent(inout)        :: param           
            !! Current run configuration parameters
         class(swiftest_nbody_system), intent(inout)        :: nbody_system    
            !! Swiftest nbody system object to store
         real(DP),                     intent(in), optional :: t               
            !! Time of snapshot if different from nbody_system time
         character(*),                 intent(in), optional :: arg             
            !! Optional argument (needed for extended storage type used in collision snapshots)
      end subroutine swiftest_util_snapshot_system
   end interface


   interface util_sort_rearrange
      module subroutine swiftest_util_sort_rearrange_arr_info(arr, ind, n)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array 
         integer(I4B),                 dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against
         integer(I4B),                                            intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange
      end subroutine swiftest_util_sort_rearrange_arr_info

      pure module subroutine swiftest_util_sort_rearrange_arr_kin(arr, ind, n)
         implicit none
         type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array 
         integer(I4B),           dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against
         integer(I4B),                                      intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange
      end subroutine swiftest_util_sort_rearrange_arr_kin

   end interface util_sort_rearrange

   interface
      module subroutine swiftest_util_sort_rearrange_body(self, ind)
         implicit none
         class(swiftest_body),               intent(inout) :: self 
            !! Swiftest body object
         integer(I4B),         dimension(:), intent(in)    :: ind  
            !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine swiftest_util_sort_rearrange_body

      module subroutine swiftest_util_sort_rearrange_pl(self, ind)
         implicit none
         class(swiftest_pl),                 intent(inout) :: self 
            !! Swiftest massive body object
         integer(I4B),         dimension(:), intent(in)    :: ind  
            !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine swiftest_util_sort_rearrange_pl

      module subroutine swiftest_util_sort_rearrange_tp(self, ind)
         implicit none
         class(swiftest_tp),                 intent(inout) :: self 
            !! Swiftest test particle object
         integer(I4B),         dimension(:), intent(in)    :: ind  
            !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine swiftest_util_sort_rearrange_tp

      module subroutine swiftest_util_sort_body(self, sortby, ascending)
         implicit none
         class(swiftest_body), intent(inout) :: self      
            !! Swiftest body object
         character(*),         intent(in)    :: sortby    
            !! Sorting attribute
         logical,              intent(in)    :: ascending 
            !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine swiftest_util_sort_body

      module subroutine swiftest_util_sort_pl(self, sortby, ascending)
         implicit none
         class(swiftest_pl), intent(inout) :: self      
            !! Swiftest body object
         character(*),       intent(in)    :: sortby    
            !! Sorting attribute
         logical,            intent(in)    :: ascending 
            !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine swiftest_util_sort_pl

      module subroutine swiftest_util_sort_tp(self, sortby, ascending)
         implicit none
         class(swiftest_tp), intent(inout) :: self      
            !! Swiftest body object
         character(*),       intent(in)    :: sortby    
            !! Sorting attribute
         logical,            intent(in)    :: ascending 
            !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine swiftest_util_sort_tp

   end interface

   interface util_spill
      module subroutine swiftest_util_spill_arr_info(keeps, discards, lspill_list, ldestructive)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: keeps        
            !! Array of values to keep 
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: discards     
            !! Array of discards
         logical,                      dimension(:),              intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discardss
         logical,                                                 intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine swiftest_util_spill_arr_info

      module subroutine swiftest_util_spill_arr_kin(keeps, discards, lspill_list, ldestructive)
         implicit none
         type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: keeps        
            !! Array of values to keep 
         type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: discards     
            !! Array of discards
         logical,                dimension(:),              intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discardss
         logical,                                           intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine swiftest_util_spill_arr_kin
   end interface

   interface 
      module subroutine swiftest_util_spill_body(self, discards, lspill_list, ldestructive)
         implicit none
         class(swiftest_body),  intent(inout) :: self         
            !! Swiftest body object
         class(swiftest_body),  intent(inout) :: discards     
            !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine swiftest_util_spill_body

      module subroutine swiftest_util_spill_pl(self, discards, lspill_list, ldestructive)
         implicit none
         class(swiftest_pl),    intent(inout) :: self         
            !! Swiftest massive body object
         class(swiftest_body),  intent(inout) :: discards     
            !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine swiftest_util_spill_pl

      module subroutine swiftest_util_spill_tp(self, discards, lspill_list, ldestructive)
         implicit none
         class(swiftest_tp),    intent(inout) :: self         
            !! Swiftest test particle object
         class(swiftest_body),  intent(inout) :: discards     
            !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine swiftest_util_spill_tp

   end interface

   interface
      module subroutine swiftest_util_valid_id_system(self, param)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: self  
            !! Swiftest nbody system object
         class(swiftest_parameters),        intent(inout) :: param 
            !! Current run configuration parameters
      end subroutine swiftest_util_valid_id_system

      module subroutine swiftest_util_version()
         implicit none
      end subroutine swiftest_util_version
   end interface

#ifdef COARRAY
   interface
      module subroutine swiftest_coarray_balance_system(nbody_system, param)
         !! author: David A. Minton
         !!
         !! Checks whether or not the system needs to be rebalance. Rebalancing occurs when the image with the smallest number of 
         !! test particles has <90% of that of the image with the largest number of test particles.
         implicit none
         ! Arguments
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system 
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
      end subroutine swiftest_coarray_balance_system

      module subroutine swiftest_coarray_collect_system(nbody_system, param)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system 
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
      end subroutine swiftest_coarray_collect_system

      module subroutine swiftest_coarray_distribute_system(nbody_system, param)
         implicit none
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system 
         class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
      end subroutine swiftest_coarray_distribute_system
   end interface

   interface coclone
      module subroutine swiftest_coarray_component_clone_info(var,src_img)
         implicit none
         type(swiftest_particle_info), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine swiftest_coarray_component_clone_info

      module subroutine swiftest_coarray_component_clone_info_arr1D(var,src_img)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine swiftest_coarray_component_clone_info_arr1D

      module subroutine swiftest_coarray_component_clone_kin_arr1D(var,src_img)
         implicit none
         type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine swiftest_coarray_component_clone_kin_arr1D
   end interface

   interface cocollect
      module subroutine swiftest_coarray_component_collect_info_arr1D(var,dest_img)
         implicit none
         type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine
   end interface

   interface 
      module subroutine swiftest_coarray_coclone_body(self)
         implicit none
         class(swiftest_body),intent(inout),codimension[*]  :: self  
            !! Swiftest body object
      end subroutine swiftest_coarray_coclone_body

      module subroutine swiftest_coarray_coclone_cb(self)
         implicit none
         class(swiftest_cb),intent(inout),codimension[*]  :: self  
            !! Swiftest cb object
      end subroutine swiftest_coarray_coclone_cb

      module subroutine swiftest_coarray_coclone_kin(self)
         implicit none
         class(swiftest_kinship),intent(inout),codimension[*]  :: self  
            !! Swiftest kinship object
      end subroutine swiftest_coarray_coclone_kin

      module subroutine swiftest_coarray_coclone_nc(self)
         implicit none
         class(swiftest_netcdf_parameters),intent(inout),codimension[*]  :: self  
            !! Swiftest body object
      end subroutine swiftest_coarray_coclone_nc

      module subroutine swiftest_coarray_coclone_pl(self)
         implicit none
         class(swiftest_pl),intent(inout),codimension[*]  :: self  
            !! Swiftest pl object
      end subroutine swiftest_coarray_coclone_pl

      module subroutine swiftest_coarray_coclone_tp(self)
         implicit none
         class(swiftest_tp),intent(inout),codimension[*]  :: self  
            !! Swiftest tp object
      end subroutine swiftest_coarray_coclone_tp

      module subroutine swiftest_coarray_coclone_system(self)
         implicit none
         class(swiftest_nbody_system),intent(inout),codimension[*]  :: self  
            !! Swiftest nbody system object
      end subroutine swiftest_coarray_coclone_system

      module subroutine swiftest_coarray_cocollect_body(self)
         implicit none
         class(swiftest_body),intent(inout), codimension[*] :: self 
            !! Swiftest body object
      end subroutine swiftest_coarray_cocollect_body

      module subroutine swiftest_coarray_cocollect_tp(self)
         implicit none
         class(swiftest_tp),intent(inout), codimension[*] :: self 
            !! Swiftest tp object
      end subroutine swiftest_coarray_cocollect_tp
   end interface

#endif

   contains
      subroutine swiftest_final_kin(self)
         
            !! author: David A. Minton
         
            !!
         
            !! Finalize the swiftest kinship object - deallocates all allocatables
         implicit none
         ! Argument
         type(swiftest_kinship),  intent(inout) :: self 
            !! SyMBA kinship object
   
         call self%dealloc()
   
         return
      end subroutine swiftest_final_kin


      subroutine swiftest_final_storage(self)
         
            !! author: David A. Minton
         
            !!
         
            !! Finalizer for the storage data type
         implicit none
         ! Arguments
         type(swiftest_storage) :: self

         call self%dealloc()
   
         return
      end subroutine swiftest_final_storage
   

end module swiftest

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(walltime) s_walltime
   use swiftest
contains

   module subroutine walltime_stop(self)
      !! author: David A. Minton
      !!
      !! Pauses the step timer (but not the main timer). 
      implicit none
      ! Arguments
      class(walltimer),           intent(inout) :: self  
         !! Walltimer object
      ! Internals
      integer(I8B) :: count_delta

      if (self%is_paused) then
         write(*,*) "Wall timer error: Timer is already paused!"
         return
      end if

      call system_clock(self%count_pause)
      self%is_paused = .true.

      self%count_stop_step = self%count_pause

      count_delta = self%count_stop_step - self%count_start_step
      self%wall_step = count_delta / (self%count_rate * 1.0_DP)

      return 
   end subroutine walltime_stop


   module subroutine walltime_report(self, message, unit)
      !! author: David A. Minton
      !!
      !! Prints the elapsed time information to the terminal
      implicit none
      ! Arguments
      class(walltimer),           intent(inout) :: self      
         !! Walltimer object
      character(len=*),           intent(in)    :: message   
         !! Message to prepend to the wall time terminal output
      integer(I4B),               intent(in)    :: unit      
         !! Output file unit for report text to be directed
      ! Internals
      character(len=*), parameter     :: substepfmt   = '" Total wall time: ", es12.5, "; Interval wall time: ", es12.5, ";' //&
                                                        ' Interval wall time/step:  ", es12.5'
      character(len=STRMAX)           :: fmt
      integer(I8B)                    :: count_delta_step, count_delta_main, count_now

      if (.not.self%main_is_started) then
         write(*,*) "Wall timer error: The step finish time cannot be calculated because the timer is not started!"
         return
      end if

      call system_clock(count_now)
      count_delta_main = count_now - self%count_start_main
      self%wall_main = count_delta_main / (self%count_rate * 1.0_DP)

      count_delta_step = self%count_stop_step - self%count_start_step
      self%wall_step = count_delta_step / (self%count_rate * 1.0_DP)
      self%wall_per_substep = self%wall_step / self%nsubsteps

      fmt = '("' //  adjustl(message) // '",' // substepfmt // ')'
      write(unit,trim(adjustl(fmt))) self%wall_main, self%wall_step, self%wall_per_substep

      return
   end subroutine walltime_report


   module subroutine walltime_reset(self)
      !! author: David A. Minton
      !!
      !! Resets the step timer
      implicit none
      ! Arguments
      class(walltimer),  intent(inout) :: self  
         !! Walltimer object
      ! Internals

      self%is_paused = .false.
      self%wall_step = 0.0_DP
      self%wall_per_substep = 0.0_DP
      self%nsubsteps = 0

      return 
   end subroutine walltime_reset


   module subroutine walltime_start_main(self)
      !! author: David A. Minton
      !!
      !! Resets the clock ticker, settting main_start to the current ticker value
      implicit none
      ! Arguments
      class(walltimer),           intent(inout) :: self  
         !! Walltimer object
      
      call system_clock(self%count_start_main, self%count_rate, self%count_max)
      self%main_is_started = .true.
      self%wall_main = 0.0_DP

      return
   end subroutine walltime_start_main


   module subroutine walltime_start(self)
      !! author: David A. Minton
      !!
      !! Starts or resumes the step timer
      !!
      implicit none
      ! Arguments
      class(walltimer),           intent(inout) :: self  
         !! Walltimer object
      ! Internals
      integer(I8B) :: count_resume, count_delta

      if (.not.self%main_is_started) then
         call self%reset()
         call self%start_main()
      end if

      if (self%is_paused) then ! Resume a paused step timer
         call system_clock(count_resume)
         count_delta = count_resume - self%count_pause 
         self%count_pause = 0_I8B 
         self%count_start_step = self%count_start_step + count_delta
         self%is_paused = .false.
      else ! Start a new step timer
         call system_clock(self%count_start_step)
      end if
      self%nsubsteps = self%nsubsteps + 1

      return 
   end subroutine walltime_start

end submodule s_walltime

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(collision) s_collision_io
   use swiftest

contains

   module subroutine collision_io_collider_message(pl, collidx, collider_message)
      !! author: David A. Minton
      !!
      !! Prints a nicely formatted message about which bodies collided, including their names
      !! This subroutine appends the body names and ids to an input message.
      implicit none
      ! Arguments
      class(base_object),            intent(in)    :: pl            !! Swiftest massive body object
      integer(I4B),    dimension(:), intent(in)    :: collidx           !! Index of collisional colliders%idx members
      character(*),                  intent(inout) :: collider_message !! The message to print to the screen.
      ! Internals
      integer(I4B) :: i, n
      character(len=STRMAX) :: idstr
      
      n = size(collidx)
      if (n == 0) return

      select type(pl)
      class is (swiftest_pl)
         do i = 1, n
            if (i > 1) collider_message = trim(adjustl(collider_message)) // " and "
            collider_message = " " // trim(adjustl(collider_message)) // " " // trim(adjustl(pl%info(collidx(i))%name))
            write(idstr, '(I10)') pl%id(collidx(i))
            collider_message = trim(adjustl(collider_message)) // " (" // trim(adjustl(idstr)) // ") "
         end do

      end select

      return
   end subroutine collision_io_collider_message


   module subroutine collision_io_log_regime(impactors)
      !! author: David A. Minton
      !!
      !! Writes a log of the results of the collisional regime determination
      implicit none
      ! Arguments
      class(collision_impactors), intent(inout) :: impactors  !! Collision system object
      ! Internals
      character(STRMAX) :: errmsg

      open(unit=LUN, file=COLLISION_LOG_OUT, status = 'OLD', position = 'APPEND', form = 'FORMATTED', err = 667, iomsg = errmsg)
      write(LUN, *, err = 667, iomsg = errmsg)
      write(LUN, *) "--------------------------------------------------------------------"
      write(LUN, *) "           Collisional regime determination results"
      write(LUN, *) "--------------------------------------------------------------------"
      write(LUN, *) "True number of impactors : ",impactors%ncoll
      write(LUN, *) "Index list of true impactors  : ",impactors%id(1:impactors%ncoll)
      select case(impactors%regime) 
      case(COLLRESOLVE_REGIME_MERGE)
         write(LUN, *) "Regime: Merge"
      case(COLLRESOLVE_REGIME_DISRUPTION)
         write(LUN, *) "Regime: Disruption"
      case(COLLRESOLVE_REGIME_SUPERCATASTROPHIC)
         write(LUN, *) "Regime: Supercatastrophic disruption"
      case(COLLRESOLVE_REGIME_GRAZE_AND_MERGE)
         write(LUN, *) "Regime: Graze and merge"
      case(COLLRESOLVE_REGIME_HIT_AND_RUN)
         write(LUN, *) "Regime: Hit and run"
      end select
      write(LUN, *) "Expected energy change       : ", -impactors%Qloss
      write(LUN, *) "--------------------------------------------------------------------"
      close(LUN)

      return
      667 continue
      write(*,*) "Error writing collision regime information to log file: " // trim(adjustl(errmsg))
   end subroutine collision_io_log_regime


   module subroutine collision_io_netcdf_dump(self, param)
      !! author: David A. Minton
      !!
      !! Dumps the time history of an encounter to file.
      implicit none
      ! Arguments
      class(collision_storage),  intent(inout)  :: self   !! Encounter storage object
      class(base_parameters), intent(inout)    :: param  !! Current run configuration parameters 
      ! Internals
      integer(I4B) :: i

      select type(nc => self%nc)
      class is (collision_netcdf_parameters)
      select type(param)
      class is (base_parameters)
         if (self%iframe > 0) then
            call self%make_index_map()
            call nc%open(param)
            do i = 1, self%iframe
               if (allocated(self%frame(i)%item)) then
                  select type(snapshot => self%frame(i)%item)
                  class is (collision_snapshot)
                     call snapshot%write_frame(self,param)
                  end select
               else
                  exit
               end if
            end do

            call nc%close()
            call self%reset()
         end if
      end select
      end select

      return
   end subroutine collision_io_netcdf_dump


   module subroutine collision_io_netcdf_initialize_output(self, param)
      !! author: David A. Minton
      !!
      !! Initialize a NetCDF fragment history file system. This is a simplified version of the main simulation output NetCDF file, 
      !! but with fewer variables.
      use, intrinsic :: ieee_arithmetic
      use netcdf
      implicit none
      ! Arguments
      class(collision_netcdf_parameters), intent(inout) :: self    !! Parameters used to identify a particular NetCDF dataset
      class(base_parameters),     intent(in)    :: param   
      ! Internals
      integer(I4B) :: nvar, varid, vartype
      real(DP) :: dfill
      real(SP) :: sfill
      integer(I4B), parameter :: NO_FILL = 0
      logical :: fileExists
      character(len=STRMAX) :: errmsg
      integer(I4B) :: ndims

      select type(param)
      class is (base_parameters)
         associate(nc => self)
            dfill = ieee_value(dfill, IEEE_QUIET_NAN)
            sfill = ieee_value(sfill, IEEE_QUIET_NAN)

            select case (param%out_type)
            case("NETCDF_FLOAT")
               self%out_type = NF90_FLOAT
            case("NETCDF_DOUBLE")
               self%out_type = NF90_DOUBLE
            case default
               write(*,*) trim(adjustl(param%out_type)), " is an invalid OUT_TYPE"
            end select

            ! Check if the file exists, and if it does, delete it
            inquire(file=nc%file_name, exist=fileExists)
            if (fileExists) then
               open(unit=LUN, file=nc%file_name, status="old", err=667, iomsg=errmsg)
               close(unit=LUN, status="delete")
            end if

            call netcdf_io_check( nf90_create(nc%file_name, NF90_NETCDF4, nc%id), &
               "collision_io_netcdf_initialize_output nf90_create" )
            nc%lfile_is_open = .true.

            ! Dimensions
            call netcdf_io_check( nf90_def_dim(nc%id, &
                                               nc%collision_id_dimname, &
                                               NF90_UNLIMITED, &
                                               nc%collision_id_dimid), & 
               "collision_io_netcdf_initialize_output nf90_def_dim collision_id_dimid"  ) ! Dimension to store collision events

            call netcdf_io_check( nf90_def_dim(nc%id, &
                                               nc%collision_body_dimname, &
                                               NF90_UNLIMITED, &
                                               nc%collision_body_dimid), & 
                "collision_io_netcdf_initialize_output nf90_def_dim collision_body_dimid") ! Dimension to store list of bodies

            call netcdf_io_check( nf90_def_dim(nc%id, &
                                               nc%space_dimname, &
                                               NDIM, &
                                               nc%space_dimid), &
               "collision_io_netcdf_initialize_output nf90_def_dim space_dimid") ! 3D space dimension

            call netcdf_io_check( nf90_def_dim(nc%id, &
                                               nc%str_dimname, &
                                               NAMELEN, &
                                               nc%str_dimid), &
               "collision_io_netcdf_initialize_output nf90_def_dim str_dimid") ! Dimension for string variables 

            call netcdf_io_check( nf90_def_dim(nc%id, &
                                               nc%stage_dimname, &
                                               2, &
                                               nc%stage_dimid), &
               "collision_io_netcdf_initialize_output nf90_def_dim stage_dimid"  ) ! Dimension for stage variables 
                                                                                   ! (aka "before" vs. "after")

            ! Dimension coordinates
            call netcdf_io_check( nf90_def_var(nc%id, nc%collision_id_dimname,  NF90_INT,  &
               [nc%collision_id_dimid], nc%collision_id_varid), &
                "collision_io_netcdf_initialize_output nf90_def_var collision_id_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%collision_body_dimname, NF90_INT, &
               nc%collision_body_dimid, nc%collision_body_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var collision_body_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%space_dimname, NF90_CHAR, &
               nc%space_dimid, nc%space_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var space_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%stage_dimname, NF90_CHAR, &
               [nc%str_dimid,   nc%stage_dimid], nc%stage_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var stage_varid")

            ! Variables
            call netcdf_io_check( nf90_def_var(nc%id, nc%name_dimname,    NF90_CHAR,   &
               [nc%str_dimid, nc%collision_body_dimid, nc%stage_dimid, nc%collision_id_dimid], nc%name_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var id_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%id_varname,    NF90_INT,   &
               [nc%collision_body_dimid,  nc%stage_dimid, nc%collision_id_dimid], nc%id_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var id_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%time_dimname,    nc%out_type, &
               nc%collision_id_dimid, nc%time_varid), &   
               "collision_io_netcdf_initialize_output nf90_def_var time_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%regime_varname,  NF90_CHAR, &
               [nc%str_dimid, nc%collision_id_dimid], nc%regime_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var regime_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%Qloss_varname,  nc%out_type, &
               [nc%collision_id_dimid], nc%Qloss_varid),  &
               "collision_io_netcdf_initialize_output nf90_def_var Qloss_varid")
            
            call netcdf_io_check( nf90_def_var(nc%id, nc%ptype_varname,   NF90_CHAR, &
               [nc%str_dimid, nc%collision_body_dimid, nc%stage_dimid, nc%collision_id_dimid], nc%ptype_varid),  &
               "collision_io_netcdf_initialize_output nf90_def_var ptype_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%rh_varname,      nc%out_type, &
               [nc%space_dimid, nc%collision_body_dimid,  nc%stage_dimid, nc%collision_id_dimid], nc%rh_varid),  &
               "collision_io_netcdf_initialize_output nf90_def_var rh_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%vh_varname,      nc%out_type, &
               [nc%space_dimid, nc%collision_body_dimid,  nc%stage_dimid, nc%collision_id_dimid], nc%vh_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var vh_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%Gmass_varname,   nc%out_type, &
               [nc%collision_body_dimid, nc%stage_dimid,  nc%collision_id_dimid], nc%Gmass_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var Gmass_varid")

            call netcdf_io_check( nf90_def_var(nc%id, nc%radius_varname,  nc%out_type, &
               [nc%collision_body_dimid, nc%stage_dimid,  nc%collision_id_dimid], nc%radius_varid), &
               "collision_io_netcdf_initialize_output nf90_def_var radius_varid")

            if (param%lrotation) then
               call netcdf_io_check( nf90_def_var(nc%id, nc%Ip_varname,      nc%out_type,&
                  [nc%space_dimid,  nc%collision_body_dimid,    nc%stage_dimid,  nc%collision_id_dimid], nc%Ip_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var Ip_varid")

               call netcdf_io_check( nf90_def_var(nc%id, nc%rot_varname,     nc%out_type,&
                  [nc%space_dimid, nc%collision_body_dimid, nc%stage_dimid, nc%collision_id_dimid], nc%rot_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var rot_varid")
            end if

            if (param%lenergy) then
               call netcdf_io_check( nf90_def_var(nc%id, nc%ke_orbit_varname,  nc%out_type, &
                  [nc%stage_dimid,  nc%collision_id_dimid], nc%KE_orb_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var KE_orb_varid")

               call netcdf_io_check( nf90_def_var(nc%id, nc%ke_rot_varname, nc%out_type, &
                  [nc%stage_dimid,  nc%collision_id_dimid], nc%KE_rot_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var KE_rot_varid")

               call netcdf_io_check( nf90_def_var(nc%id, nc%pe_varname, nc%out_type, &
                  [nc%stage_dimid,  nc%collision_id_dimid], nc%PE_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var PE_varid")

               call netcdf_io_check( nf90_def_var(nc%id, nc%be_varname, nc%out_type, &
                  [nc%stage_dimid,  nc%collision_id_dimid], nc%BE_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var BE_varid")
               call netcdf_io_check( nf90_def_var(nc%id, nc%te_varname, nc%out_type, &
                  [nc%stage_dimid,  nc%collision_id_dimid], nc%TE_varid), &
                  "collision_io_netcdf_initialize_output nf90_def_var TE_varid")

               if (param%lrotation) then
                  call netcdf_io_check( nf90_def_var(nc%id, nc%L_orbit_varname, nc%out_type, &
                     [nc%space_dimid, nc%stage_dimid, nc%collision_id_dimid], nc%L_orbit_varid), &
                     "collision_io_netcdf_initialize_output nf90_def_var L_orbit_varid")

                  call netcdf_io_check( nf90_def_var(nc%id, nc%L_rot_varname,nc%out_type, &
                     [nc%space_dimid, nc%stage_dimid, nc%collision_id_dimid], nc%L_rot_varid), &
                     "collision_io_netcdf_initialize_output nf90_def_var L_rot_varid")
               end if
            end if 

            call netcdf_io_check( nf90_inquire(nc%id, nVariables=nvar), &
               "collision_io_netcdf_initialize_output nf90_inquire nVariables")
            do varid = 1, nvar
               call netcdf_io_check( nf90_inquire_variable(nc%id, varid, xtype=vartype, ndims=ndims), &
                  "collision_io_netcdf_initialize_output nf90_inquire_variable")
               select case(vartype)
               case(NF90_INT)
                  call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, NF90_FILL_INT), &
                     "collision_io_netcdf_initialize_output nf90_def_var_fill NF90_INT")
               case(NF90_FLOAT)
                  call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, sfill), &
                     "collision_io_netcdf_initialize_output nf90_def_var_fill NF90_FLOAT")
               case(NF90_DOUBLE)
                  call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, dfill), &
                     "collision_io_netcdf_initialize_output nf90_def_var_fill NF90_DOUBLE")
               case(NF90_CHAR)
                  call netcdf_io_check( nf90_def_var_fill(nc%id, varid, NO_FILL, 0), &
                     "collision_io_netcdf_initialize_output nf90_def_var_fill NF90_CHAR")
               end select
            end do

            ! Take the file out of define mode
            call netcdf_io_check( nf90_enddef(nc%id), "collision_io_netcdf_initialize_output nf90_enddef")

            ! Add in the space and stage dimension coordinates
            call netcdf_io_check( nf90_put_var(nc%id, nc%space_varid, nc%space_coords, start=[1], count=[NDIM]), &
               "collision_io_netcdf_initialize_output nf90_put_var space"  )
            call netcdf_io_check( nf90_put_var(nc%id, nc%stage_varid, nc%stage_coords(1), start=[1,1], &
               count=[len(nc%stage_coords(1)),1]), "collision_io_netcdf_initialize_output nf90_put_var stage 1")
            call netcdf_io_check( nf90_put_var(nc%id, nc%stage_varid, nc%stage_coords(2), start=[1,2], &
               count=[len(nc%stage_coords(2)),1]), "collision_io_netcdf_initialize_output nf90_put_var stage 2"  )

         end associate
      end select

      return

      667 continue
      write(*,*) "Error creating fragmentation output file. " // trim(adjustl(errmsg))
      call base_util_exit(FAILURE,unit=param%display_unit)
   end subroutine collision_io_netcdf_initialize_output


   module subroutine collision_io_netcdf_open(self, param, readonly)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Opens a NetCDF file and does the variable inquiries to activate variable ids
      use netcdf
      implicit none
      ! Arguments
      class(collision_netcdf_parameters), intent(inout) :: self     !! Parameters used to identify a particular NetCDF dataset
      class(base_parameters),             intent(in)    :: param    !! Current run configuration parameters
      logical, optional,                  intent(in)    :: readonly !! Logical flag indicating that this should be open read only
      ! Internals
      integer(I4B) :: mode
      character(len=STRMAX) :: errmsg
      logical fileExists

      mode = NF90_WRITE
      if (present(readonly)) then
         if (readonly) mode = NF90_NOWRITE
      end if

      select type(param)
      class is (base_parameters)
         associate(nc => self)

            inquire(file=nc%file_name, exist=fileExists)
            if (.not.fileExists) then
               call nc%initialize(param)
               return
            end if

            write(errmsg,*) "collision_io_netcdf_open nf90_open ",trim(adjustl(nc%file_name))
            call netcdf_io_check( nf90_open(nc%file_name, mode, nc%id), errmsg)
            self%lfile_is_open = .true.

            ! Dimensions
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%collision_id_dimname, nc%collision_id_dimid), &
               "collision_io_netcdf_open nf90_inq_dimid collision_id_dimid"  )
            call netcdf_io_check( nf90_inquire_dimension(nc%id, nc%collision_id_dimid, nc%collision_id_dimname, len=nc%max_idslot),&
               "collision_io_find_idslot nf90_inquire_dimension max_idslot"  )
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%space_dimname, nc%space_dimid), &
               "collision_io_netcdf_open nf90_inq_dimid space_dimid"  )
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%collision_body_dimname, nc%collision_body_dimid), &
               "collision_io_netcdf_open nf90_inq_dimid collision_body_dimid"  )
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%str_dimname, nc%str_dimid), &
               "collision_io_netcdf_open nf90_inq_dimid str_dimid"  )
            call netcdf_io_check( nf90_inq_dimid(nc%id, nc%stage_dimname, nc%stage_dimid), &
               "collision_io_netcdf_open nf90_inq_dimid stage_dimid"  )

            ! Dimension coordinates
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%collision_id_dimname, nc%collision_id_varid), &
               "collision_io_netcdf_open nf90_inq_varid collision_id_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%collision_body_dimname, nc%collision_body_varid), &
               "collision_io_netcdf_open nf90_inq_varid collision_body_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%space_dimname, nc%space_varid), &
               "collision_io_netcdf_open nf90_inq_varid space_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%stage_dimname, nc%stage_varid), &
               "collision_io_netcdf_open nf90_inq_varid stage_varid" )

            ! Required Variables
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%name_dimname, nc%name_varid), &
               "collision_io_netcdf_open nf90_inq_varid name_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%id_varname, nc%id_varid), &
               "collision_io_netcdf_open nf90_inq_varid id_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%time_dimname, nc%time_varid), &
               "collision_io_netcdf_open nf90_inq_varid time_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%regime_varname, nc%regime_varid), &
               "collision_io_netcdf_open nf90_inq_varid regime_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%Qloss_varname, nc%Qloss_varid), &
               "collision_io_netcdf_open nf90_inq_varid Qloss_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%ptype_varname, nc%ptype_varid), &
               "collision_io_netcdf_open nf90_inq_varid ptype_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%rh_varname, nc%rh_varid), &
               "collision_io_netcdf_open nf90_inq_varid rh_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%vh_varname, nc%vh_varid), &
               "collision_io_netcdf_open nf90_inq_varid vh_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%Gmass_varname, nc%Gmass_varid), &
               "collision_io_netcdf_open nf90_inq_varid Gmass_varid" )
            call netcdf_io_check( nf90_inq_varid(nc%id, nc%radius_varname, nc%radius_varid), &
               "collision_io_netcdf_open nf90_inq_varid radius_varid" )
            
            if (param%lrotation) then
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%Ip_varname, nc%Ip_varid), &
                  "collision_io_netcdf_open nf90_inq_varid Ip_varid" )
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%rot_varname, nc%rot_varid), &
                  "collision_io_netcdf_open nf90_inq_varid rot_varid" )
            end if

            if (param%lenergy) then
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%ke_orbit_varname, nc%ke_orb_varid), &
                  "collision_io_netcdf_open nf90_inq_varid ke_orb_varid" )
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%pe_varname, nc%pe_varid), &
                  "collision_io_netcdf_open nf90_inq_varid pe_varid" )
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%be_varname, nc%be_varid), &
                  "collision_io_netcdf_open nf90_inq_varid be_varid" )
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%te_varname, nc%te_varid), &
                  "collision_io_netcdf_open nf90_inq_varid te_varid" )
               call netcdf_io_check( nf90_inq_varid(nc%id, nc%L_orbit_varname, nc%L_orbit_varid), &
                  "collision_io_netcdf_open nf90_inq_varid L_orbit_varid" )
               if (param%lrotation) then
                  call netcdf_io_check( nf90_inq_varid(nc%id, nc%ke_rot_varname, nc%ke_rot_varid), &
                     "collision_io_netcdf_open nf90_inq_varid ke_rot_varid" )
                  call netcdf_io_check( nf90_inq_varid(nc%id, nc%L_rot_varname, nc%L_rot_varid), &
                     "collision_io_netcdf_open nf90_inq_varid L_rot_varid" )
               end if
            end if

         end associate
      end select 

      return
   end subroutine collision_io_netcdf_open


   module subroutine collision_io_netcdf_write_frame_snapshot(self, history, param)
      !! author: David A. Minton
      !!
      !! Write a frame of output of a collision result
      use netcdf
      implicit none
      ! Arguments
      class(collision_snapshot),   intent(in)    :: self    !! Swiftest encounter structure
      class(encounter_storage), intent(inout) :: history !! Collision history object
      class(base_parameters),      intent(inout) :: param   !! Current run configuration parameters
      ! Internals
      integer(I4B)           :: i, idslot, old_mode, stage, tmp
      character(len=NAMELEN) :: charstring
      class(swiftest_cb), allocatable :: cb
      class(swiftest_pl), allocatable :: pl
      class(swiftest_tp), allocatable :: tp 

      select type(nc => history%nc)
      class is (collision_netcdf_parameters)
         associate(collider => self%collider, impactors => self%collider%impactors, fragments => self%collider%fragments, &
                   eslot => self%collider%collision_id)
            call netcdf_io_check( nf90_set_fill(nc%id, NF90_NOFILL, old_mode), &
               "collision_io_netcdf_write_frame_snapshot nf90_set_fill" )

            call netcdf_io_check( nf90_put_var(nc%id, nc%collision_id_varid, eslot,            start=[eslot]), &
               "collision_io_netcdf_write_frame_snapshot nf90_put_var collision_id_varid" )

            call netcdf_io_check( nf90_put_var(nc%id, nc%time_varid, self%t,                   start=[eslot]), &
               "collision_io_netcdf_write_frame_snapshot nf90_put_var time_varid" )

            charstring = trim(adjustl(REGIME_NAMES(impactors%regime)))
            call netcdf_io_check( nf90_put_var(nc%id, nc%regime_varid, charstring,             start=[1, eslot], &
               count=[NAMELEN, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var regime_varid" )

            call netcdf_io_check( nf90_put_var(nc%id, nc%Qloss_varid, impactors%Qloss,         start=[eslot] ), &
               "collision_io_netcdf_write_frame_snapshot nf90_put_var Qloss_varid" )

            select type(before =>self%collider%before)
            class is (swiftest_nbody_system)
            select type(after =>self%collider%after)
            class is (swiftest_nbody_system)
               do stage = 1,2
                  if (allocated(cb)) deallocate(cb)
                  if (allocated(pl)) deallocate(pl)
                  if (allocated(tp)) deallocate(tp)
                  select case(stage)
                  case(1)
                     if (allocated(before%cb)) allocate(cb, source=before%cb)
                     if (allocated(before%pl)) allocate(pl, source=before%pl)
                     if (allocated(before%tp)) allocate(tp, source=before%tp)
                  case(2)
                     if (allocated(after%cb)) allocate(cb, source=after%cb)
                     if (allocated(after%pl)) allocate(pl, source=after%pl)
                     if (allocated(after%tp)) allocate(tp, source=after%tp)
                  end select

                  if (.not. (allocated(pl) .or. allocated(tp) .or. allocated(cb))) cycle

                  idslot = 0
                  if (allocated(cb)) then
                     idslot = idslot + 1
                     call netcdf_io_check( nf90_put_var(nc%id, nc%collision_body_varid, idslot, start=[ idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var collision_body_varid: cb")
                     call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid,     cb%id,     start=[   idslot, stage, eslot]), &
                        "collision_io_netcdf_write_frame_snapshot nf90_put_var id_varid: cb"  )
                     charstring = trim(adjustl(cb%info%name))
                     call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid,   charstring,   start=[1, idslot, stage, eslot], &
                        count=[NAMELEN,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var name_varid: cb"  )
                     charstring = trim(adjustl(cb%info%particle_type))
                     call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid,  charstring,   start=[1, idslot, stage, eslot], &
                        count=[NAMELEN,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var particle_type_varid: cb" )
                     call netcdf_io_check( nf90_put_var(nc%id, nc%Gmass_varid,  cb%Gmass,  start=[   idslot, stage, eslot]), &
                        "collision_io_netcdf_write_frame_snapshot nf90_put_var Gmass_varid: cb")
                     call netcdf_io_check( nf90_put_var(nc%id, nc%radius_varid, cb%radius, start=[   idslot, stage, eslot]), &
                        "collision_io_netcdf_write_frame_snapshot nf90_put_var radius_varid: cb")
                     if (param%lrotation) then
                        call netcdf_io_check( nf90_put_var(nc%id, nc%Ip_varid,  cb%Ip(:),   start=[1, idslot, stage, eslot], &
                           count=[NDIM,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var Ip_varid: cb")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%rot_varid,    cb%rot(:),  &
                           start=[1, idslot, stage, eslot], count=[NDIM,1,1,1]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var rotx_varid: cb")
                     end if                    
                  end if

                  if (allocated(pl)) then
                     call pl%sort("mass", ascending=.false.)
                     do i = 1, pl%nbody
                        idslot = idslot + 1
                        call netcdf_io_check( nf90_put_var(nc%id, nc%collision_body_varid, idslot, start=[ idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var collision_body_varid: pl")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid, pl%id(i), start=[idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var id_varid: pl")
                        charstring = trim(adjustl(pl%info(i)%name))
                        call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid,   charstring,   start=[1, idslot, stage, eslot], &
                           count=[NAMELEN,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var name_varid: pl")
                        charstring = trim(adjustl(pl%info(i)%particle_type))
                        call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid,  charstring,   start=[1, idslot, stage, eslot], &
                           count=[NAMELEN,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var particle_type_varid: pl")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%rh_varid,     pl%rh(:,i),   start=[1, idslot, stage, eslot], &
                           count=[NDIM,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var rh_varid: pl")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%vh_varid,     pl%vh(:,i),   start=[1, idslot, stage, eslot], &
                           count=[NDIM,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var vh_varid: pl")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%Gmass_varid,  pl%Gmass(i),  start=[   idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var Gmass_varid: pl")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%radius_varid, pl%radius(i), start=[   idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var radius_varid: pl")
                        if (param%lrotation) then
                           call netcdf_io_check( nf90_put_var(nc%id, nc%Ip_varid,  pl%Ip(:,i),   start=[1, idslot, stage, eslot], &
                              count=[NDIM,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var Ip_varid: pl")
                           call netcdf_io_check( nf90_put_var(nc%id, nc%rot_varid,    pl%rot(:,i),  &
                              start=[1, idslot, stage, eslot], count=[NDIM,1,1,1]), &
                              "collision_io_netcdf_write_frame_snapshot nf90_put_var rotx_varid: pl")
                        end if
                     end do
                  end if

                  if (allocated(tp)) then
                     call tp%sort("id", ascending=.true.)
                     do i = 1, tp%nbody
                        idslot = idslot + 1
                        call netcdf_io_check( nf90_put_var(nc%id, nc%collision_body_varid, idslot, start=[ idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var collision_body_varid: tp")
                        call netcdf_io_check( nf90_put_var(nc%id, nc%id_varid,     tp%id(i),     start=[idslot, stage, eslot]), &
                           "collision_io_netcdf_write_frame_snapshot nf90_put_var id_varid: tp"  )
                        charstring = trim(adjustl(tp%info(i)%name))
                        call netcdf_io_check( nf90_put_var(nc%id, nc%name_varid,   charstring,   start=[1, idslot, stage, eslot], &
                           count=[NAMELEN,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var name_varid: tp"  )
                        charstring = trim(adjustl(tp%info(i)%particle_type))
                        call netcdf_io_check( nf90_put_var(nc%id, nc%ptype_varid,  charstring,   start=[1, idslot, stage, eslot], &
                           count=[NAMELEN,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var particle_type_varid: tp" )
                        call netcdf_io_check( nf90_put_var(nc%id, nc%rh_varid,     tp%rh(:,i),   start=[1, idslot, stage, eslot], &
                           count=[NDIM,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var rh_varid: tp"  )
                        call netcdf_io_check( nf90_put_var(nc%id, nc%vh_varid,     tp%vh(:,i),   start=[1, idslot, stage, eslot], &
                           count=[NDIM,1,1,1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var vh_varid: tp"  )
                     end do
                  end if

               end do
            end select
            end select

            if (param%lenergy) then
               call netcdf_io_check( nf90_put_var(nc%id, nc%ke_orb_varid,  collider%ke_orbit(:), start=[   1, eslot], &
                  count=[      2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var ke_orb_varid before" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%ke_rot_varid, collider%ke_rot(:),  start=[   1, eslot], &
                  count=[      2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var ke_rot_varid before" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%pe_varid,      collider%pe(:),       start=[   1, eslot], &
                  count=[      2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var pe_varid before" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%be_varid,      collider%be(:),       start=[   1, eslot], &
                  count=[      2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var pe_varid before" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%te_varid,      collider%te(:),       start=[   1, eslot], &
                  count=[      2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var pe_varid tefore" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%L_orbit_varid,   collider%L_orbit(:,:), start=[1, 1, eslot], &
                  count=[NDIM, 2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var L_orbit_varid before" )
               call netcdf_io_check( nf90_put_var(nc%id, nc%L_rot_varid,   collider%L_rot(:,:),  start=[1, 1, eslot], &
                  count=[NDIM, 2, 1]), "collision_io_netcdf_write_frame_snapshot nf90_put_var L_rot_varid before" )
            end if
      
            call netcdf_io_check( nf90_set_fill(nc%id, old_mode, tmp) )
         end associate
      end select
      return
   end subroutine collision_io_netcdf_write_frame_snapshot

end submodule s_collision_io

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(helio) s_helio_step
   use swiftest
contains

   module subroutine helio_step_system(self, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step massive bodies and and active test particles ahead in heliocentric coordinates.
      !!
      !! Currently there's no difference between this and the WHM nbody_system stepper, so this is just
      !! a wrapper function to keep the method calls consistent for inherited types.
      !! 
      !! Adapted from Hal Levison's Swift routine step_kdk.f
      !! Adapted from David E. Kaufmann's Swifter routine helio_step.f90
      implicit none
      ! Arguments
      class(helio_nbody_system),  intent(inout) :: self   
         !! Helio nbody system object
      class(swiftest_parameters), intent(inout) :: param  
         !! Current run configuration parameters
      real(DP),                   intent(in)    :: t      
         !! Simulation time
      real(DP),                   intent(in)    :: dt     
         !! Current stepsize

      call whm_step_system(self, param, t, dt)

      return
   end subroutine helio_step_system 


   module subroutine helio_step_pl(self, nbody_system, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step massive bodies ahead Democratic Heliocentric method
      !!
      !! Adapted from David E. Kaufmann's Swifter helio_step_pl.f90
      !! Adapted from Hal Levison's Swift routine helio_step_pl.f
      implicit none
      ! Arguments
      class(helio_pl),              intent(inout) :: self   
         !! Helio massive body particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current simulation time
      real(DP),                     intent(in)    :: dt     
         !! Stepsize
      ! Internals 
      real(DP) :: dth   !! Half step size 

      if (self%nbody == 0) return

      associate(pl => self)
         select type(cb => nbody_system%cb)
         class is (helio_cb)
            dth = 0.5_DP * dt
            if (pl%lfirst) then
               call pl%vh2vb(cb)
               pl%lfirst = .false.
            end if
            call pl%lindrift(cb, dth, lbeg=.true.)
            call pl%kick(nbody_system, param, t, dth, lbeg=.true.)
            if (param%lgr) call pl%gr_pos_kick(nbody_system, param, dth)
            call pl%drift(nbody_system, param, dt)
            if (param%lgr) call pl%gr_pos_kick(nbody_system, param, dth)
            call pl%kick(nbody_system, param, t + dt, dth, lbeg=.false.)
            call pl%lindrift(cb, dth, lbeg=.false.)
            call pl%vb2vh(cb)
         end select
      end associate
   
      return
   end subroutine helio_step_pl


   module subroutine helio_step_tp(self, nbody_system, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step active test particles ahead using Democratic Heliocentric method
      !!
      !! Adapted from David E. Kaufmann's Swifter routine helio_step_tp.f90
      !! Adapted from Hal Levison's Swift routine helio_step_tp.f
      implicit none
      ! Arguments
      class(helio_tp),              intent(inout) :: self    
         !! Helio test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current simulation time
      real(DP),                     intent(in)    :: dt     
         !! Stepsize
      ! Internals
      real(DP) :: dth   !! Half step size 
   
      if (self%nbody == 0) return

      associate(tp => self)
         select type(cb => nbody_system%cb)
         class is (helio_cb)
            dth = 0.5_DP * dt
            if (tp%lfirst) then
               call tp%vh2vb(vbcb = -cb%ptbeg)
               tp%lfirst = .false.
            end if
            call tp%lindrift(cb, dth, lbeg=.true.)
            call tp%kick(nbody_system, param, t, dth, lbeg=.true.)
            if (param%lgr) call tp%gr_pos_kick(nbody_system, param, dth)
            call tp%drift(nbody_system, param, dt)
            if (param%lgr) call tp%gr_pos_kick(nbody_system, param, dth)
            call tp%kick(nbody_system, param, t + dt, dth, lbeg=.false.)
            call tp%lindrift(cb, dth, lbeg=.false.)
            call tp%vb2vh(vbcb = -cb%ptend)
         end select
      end associate
   
      return
   end subroutine helio_step_tp

end submodule s_helio_step

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(operators) s_operator_mag
   use, intrinsic :: ieee_exceptions
   !! author: David A. Minton
   !!
   !! Contains implementations for the .mag. operator for all defined real types
   !! Computes the magnitude of a vector or array of vectors using norm2
   !! Single vector implementations:  B   = .mag. A(1:3)
   !! Vector list implementations:   B(:) = .mag. A(1:3, :)
contains

   pure module function operator_mag_sp(A) result(B)
      implicit none
      real(SP), dimension(:), intent(in) :: A
      real(SP)                           :: B
      call ieee_set_halting_mode(ieee_underflow, .false.)
      B = norm2(A(:))
      return
   end function operator_mag_sp

   pure module function operator_mag_dp(A) result(B)
      implicit none
      real(DP), dimension(:), intent(in) :: A
      real(DP)                           :: B
      call ieee_set_halting_mode(ieee_underflow, .false.)
      B = norm2(A(:))
      return
   end function operator_mag_dp

   pure module function operator_mag_el_sp(A) result(B)
      implicit none
      real(SP), dimension(:,:), intent(in) :: A
      real(SP), dimension(:), allocatable  :: B
      integer(I4B)  :: i,n
      n = size(A, 2)
      if (allocated(B)) deallocate(B)
      allocate(B(n))
      call ieee_set_halting_mode(ieee_underflow, .false.)
      do i = 1,n 
         B(i) = norm2(A(:, i)) 
      end do
      return
   end function operator_mag_el_sp

   pure module function operator_mag_el_dp(A) result(B)
      implicit none
      real(DP), dimension(:,:), intent(in) :: A
      real(DP), dimension(:), allocatable  :: B
      integer(I4B)  :: i,n
      n = size(A, 2)
      if (allocated(B)) deallocate(B)
      allocate(B(n))
      call ieee_set_halting_mode(ieee_underflow, .false.)
      do i = 1,n 
         B(i) = norm2(A(:, i)) 
      end do
      return 
   end function operator_mag_el_dp

#ifdef QUADPREC
   pure module function operator_mag_el_qp(A) result(B)
      implicit none
      real(QP), dimension(:,:), intent(in) :: A
      real(QP), dimension(:), allocatable  :: B
      integer(I4B)  :: i,n
      n = size(A, 2)
      if (allocated(B)) deallocate(B)
      allocate(B(n))
      call ieee_set_halting_mode(ieee_underflow, .false.)
      do i = 1,n 
         B(i) = norm2(A(:, i)) 
      end do
      return 
   end function operator_mag_el_qp
#endif

end submodule s_operator_mag

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (symba) s_symba_step
   use swiftest
contains

   module subroutine symba_step_system(self, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step planets and active test particles ahead in democratic heliocentric coordinates, descending the recursive
      !!   branch if necessary to handle possible close encounters
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_step.f90
      !! Adapted from Hal Levison's Swift routine symba5_step_pl.f
      implicit none
      ! Arguments
      class(symba_nbody_system),  intent(inout) :: self   !! SyMBA nbody system object
      class(swiftest_parameters), intent(inout) :: param  !! Current run configuration parameters
      real(DP),                   intent(in)    :: t      !! Simulation time
      real(DP),                   intent(in)    :: dt     !! Current stepsize
      ! Internals
      logical :: lencounter
     
      select type(pl => self%pl)
      class is (symba_pl)
      select type(tp => self%tp)
      class is (symba_tp)
      select type(param)
      class is (swiftest_parameters)
         call self%reset(param)
         lencounter = pl%encounter_check(param, self, dt, 0) .or. tp%encounter_check(param, self, dt, 0)
         if (lencounter) then
            if (param%lenc_save_trajectory) call self%encounter_history%take_snapshot(param, self, t, "trajectory") 
            call self%interp(param, t, dt)
            if (param%lenc_save_trajectory) call self%encounter_history%take_snapshot(param, self, t+dt, "trajectory") 
         else
            self%irec = -1
            call helio_step_system(self, param, t, dt)
         end if
         param%lfirstkick = pl%lfirst
      end select
      end select
      end select
      return
   end subroutine symba_step_system


   module subroutine symba_step_interp_system(self, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step planets and active test particles ahead in democratic heliocentric coordinates, calling the recursive
      !!         subroutine to descend to the appropriate level to handle close encounters
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_step_interp.f90
      !! Adapted from Hal Levison's Swift routine symba5_step_interp.f
      implicit none
      ! Arguments
      class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system object
      class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters 
      real(DP),                   intent(in)    :: t     !! Simulation time
      real(DP),                   intent(in)    :: dt    !! Current stepsize
      ! Internals
      real(DP)                                  :: dth   !! Half step size

      select type(pl => self%pl)
      class is (symba_pl)
      select type(tp => self%tp)
      class is (symba_tp)
      select type(cb => self%cb)
      class is (symba_cb)
         associate(nbody_system => self)
            dth = 0.5_DP * dt
            nbody_system%irec = -1
            if (pl%lfirst) call pl%vh2vb(cb)
            call pl%lindrift(cb, dth, lbeg=.true.)
            call pl%kick(nbody_system, param, t, dth, lbeg=.true.)
            if (param%lgr) call pl%gr_pos_kick(nbody_system, param, dth)
            call pl%drift(nbody_system, param, dt)

            if (tp%nbody > 0) then
               if (tp%lfirst) call tp%vh2vb(vbcb = -cb%ptbeg)
               call tp%lindrift(cb, dth, lbeg=.true.)
               call tp%kick(nbody_system, param, t, dth, lbeg=.true.)
               if (param%lgr) call tp%gr_pos_kick(nbody_system, param, dth)
               call tp%drift(nbody_system, param, dt)
            end if

            call nbody_system%recursive_step(param, t, 0)
            nbody_system%irec = -1

            if (param%lgr) call pl%gr_pos_kick(nbody_system, param, dth)
            call pl%kick(nbody_system, param, t, dth, lbeg=.false.)
            call pl%lindrift(cb, dth, lbeg=.false.)
            call pl%vb2vh(cb)

            if (tp%nbody > 0) then
               if (param%lgr) call tp%gr_pos_kick(nbody_system, param, dth)
               call tp%kick(nbody_system, param, t, dth, lbeg=.false.)
               call tp%lindrift(cb, dth, lbeg=.false.)
               call tp%vb2vh(vbcb = -cb%ptend)
            end if
         end associate
      end select
      end select
      end select

      return
   end subroutine symba_step_interp_system


   module subroutine symba_step_set_recur_levels_system(self, ireci)
      !! author: David A. Minton
      !!
      !! Resets pl, tp,and encounter structures at the start of a new step
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine: symba_step_recur.f90
      !! Adapted from Hal Levison's Swift routine symba5_step_recur.f
      implicit none
      ! Arguments
      class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system object
      integer(I4B),               intent(in)    :: ireci !! Input recursion level 
      ! Internals
      integer(I4B) :: irecp

      select type(pl => self%pl)
      class is (symba_pl)
      select type(tp => self%tp)
      class is (symba_tp)
         associate(nbody_system => self, plpl_encounter => self%plpl_encounter, pltp_encounter => self%pltp_encounter, npl => self%pl%nbody, ntp => self%tp%nbody)

            irecp = ireci + 1

            if (npl >0) where(pl%levelg(1:npl) == irecp) pl%levelg(1:npl) = ireci
            if (ntp > 0) where(tp%levelg(1:ntp) == irecp) tp%levelg(1:ntp) = ireci
            if (plpl_encounter%nenc > 0) then
               where(plpl_encounter%level(1:plpl_encounter%nenc) == irecp) 
                  plpl_encounter%level(1:plpl_encounter%nenc) = ireci
               endwhere
            end if
            if (pltp_encounter%nenc > 0) then
               where(pltp_encounter%level(1:pltp_encounter%nenc) == irecp) 
                  pltp_encounter%level(1:pltp_encounter%nenc) = ireci
               endwhere
            end if

            nbody_system%irec = ireci

         end associate
      end select
      end select

      return
   end subroutine symba_step_set_recur_levels_system


   recursive module subroutine symba_step_recur_system(self, param, t, ireci)
      !! author: David A. Minton
      !!
      !! Step interacting planets and active test particles ahead in democratic heliocentric coordinates at the current
      !!         recursion level, if applicable, and descend to the next deeper level if necessarys
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_step_recur.f90
      !! Adapted from Hal Levison's Swift routine symba5_step_recur.f
      implicit none
      ! Arguments
      class(symba_nbody_system),  intent(inout) :: self  !! SyMBA nbody system object
      class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters 
      real(DP),                   intent(in)    :: t
      integer(I4B),               intent(in)    :: ireci !! input recursion level
      ! Internals
      integer(I4B) :: j, irecp, nloops
      real(DP) :: dtl, dth
      logical :: lencounter

      select type(param)
      class is (swiftest_parameters)
      select type(pl => self%pl)
      class is (symba_pl)
      select type(tp => self%tp)
      class is (symba_tp)
      select type(plpl_encounter => self%plpl_encounter)
      class is (symba_list_plpl)
      select type(pltp_encounter => self%pltp_encounter)
      class is (symba_list_pltp)
         associate(nbody_system => self, lplpl_collision => plpl_encounter%lcollision, lpltp_collision => pltp_encounter%lcollision)
            nbody_system%irec = ireci
            dtl = param%dt / (NTENC**ireci)
            dth = 0.5_DP * dtl
            IF (dtl / param%dt < epsilon(1.0_DP)) THEN
               write(*, *) "SWIFTEST Warning:"
               write(*, *) "   In symba_step_recur_system, local time step is too small"
               write(*, *) "   Roundoff error will be important!"
               call base_util_exit(FAILURE,param%display_unit)
            END IF
            irecp = ireci + 1
            if (ireci == 0) then
               nloops = 1
            else
               nloops = NTENC
            end if
            do j = 1, nloops
               lencounter = plpl_encounter%encounter_check(param, nbody_system, dtl, irecp) &
                     .or. pltp_encounter%encounter_check(param, nbody_system, dtl, irecp)
               
               call plpl_encounter%kick(nbody_system, dth, irecp, 1)
               call pltp_encounter%kick(nbody_system, dth, irecp, 1)
               if (ireci /= 0) then
                  call plpl_encounter%kick(nbody_system, dth, irecp, -1)
                  call pltp_encounter%kick(nbody_system, dth, irecp, -1)
               end if

               if (param%lgr) then
                  call pl%gr_pos_kick(nbody_system, param, dth)
                  call tp%gr_pos_kick(nbody_system, param, dth)
               end if

               call pl%drift(nbody_system, param, dtl)
               call tp%drift(nbody_system, param, dtl)

               if (lencounter) call nbody_system%recursive_step(param, t+(j-1)*dtl, irecp)
               nbody_system%irec = ireci

               if (param%lgr) then
                  call pl%gr_pos_kick(nbody_system, param, dth)
                  call tp%gr_pos_kick(nbody_system, param, dth)
               end if

               call plpl_encounter%kick(nbody_system, dth, irecp, 1)
               call pltp_encounter%kick(nbody_system, dth, irecp, 1)
               if (ireci /= 0) then
                  call plpl_encounter%kick(nbody_system, dth, irecp, -1)
                  call pltp_encounter%kick(nbody_system, dth, irecp, -1)
               end if

               if (param%lclose) then
                  call plpl_encounter%collision_check(nbody_system, param, t+j*dtl, dtl, ireci, lplpl_collision) 
                  call pltp_encounter%collision_check(nbody_system, param, t+j*dtl, dtl, ireci, lpltp_collision) 

                  if (lplpl_collision) call plpl_encounter%resolve_collision(nbody_system, param, t+j*dtl, dtl, ireci)
                  if (lpltp_collision) call pltp_encounter%resolve_collision(nbody_system, param, t+j*dtl, dtl, ireci)
               end if
               if (param%lenc_save_trajectory) call self%encounter_history%take_snapshot(param, self, t+j*dtl, "trajectory") 

               call self%set_recur_levels(ireci)

            end do
         end associate
      end select
      end select
      end select
      end select
      end select

      return
   end subroutine symba_step_recur_system


   module subroutine symba_step_reset_system(self, param)
      !! author: David A. Minton
      !!
      !! Resets pl, tp,and encounter structures at the start of a new step
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine: symba_step.f90
      !! Adapted from Hal Levison's Swift routine symba5_step.f
      implicit none
      ! Arguments
      class(symba_nbody_system), intent(inout) :: self  !! SyMBA nbody system object
      class(swiftest_parameters),   intent(in)    :: param !! Current run configuration parameters with SyMBA additions
      ! Internals
      integer(I4B) :: i
      integer(I8B) :: nenc_old

      associate(nbody_system => self)
      select type(pl => nbody_system%pl)
      class is (symba_pl)
      select type(tp => nbody_system%tp)
      class is (symba_tp)
         associate(npl => pl%nbody, ntp => tp%nbody)
            nenc_old = nbody_system%plpl_encounter%nenc
            call nbody_system%plpl_encounter%setup(0_I8B)
            call nbody_system%plpl_collision%setup(0_I8B)
            if (npl > 0) then
               pl%lcollision(1:npl) = .false.
               call pl%reset_kinship([(i, i=1, npl)])
               pl%nplenc(1:npl) = 0
               pl%ntpenc(1:npl) = 0
               pl%levelg(1:npl) = -1
               pl%levelm(1:npl) = -1
               pl%lencounter(1:npl) = .false.
               pl%lcollision(1:npl) = .false.
               pl%ldiscard(1:npl) = .false.
               pl%lmask(1:npl) = .true.
               call pl%set_renc(0)
               call nbody_system%plpl_encounter%setup(nenc_old) ! This resizes the pl-pl encounter list to be the same size as it was the last step, to decrease the number of potential resize operations that have to be one inside the step
               nbody_system%plpl_encounter%nenc = 0 ! Sets the true number of encounters back to 0 after resizing
               nbody_system%plpl_encounter%lcollision = .false.
            end if
      
            nenc_old = nbody_system%pltp_encounter%nenc
            call nbody_system%pltp_encounter%setup(0_I8B)
            call nbody_system%pltp_collision%setup(0_I8B)
            if (ntp > 0) then
               tp%lcollision(1:ntp) = .false.
               tp%nplenc(1:ntp) = 0 
               tp%levelg(1:ntp) = -1
               tp%levelm(1:ntp) = -1
               tp%lmask(1:ntp) = .true.
               tp%ldiscard(1:ntp) = .false.
               call nbody_system%pltp_encounter%setup(nenc_old)! This resizes the pl-tp encounter list to be the same size as it was the last step, to decrease the number of potential resize operations that have to be one inside the step
               nbody_system%pltp_encounter%nenc = 0 ! Sets the true number of encounters back to 0 after resizing
               nbody_system%pltp_encounter%lcollision = .false.
            end if

            call nbody_system%pl_adds%setup(0, param)
            call nbody_system%pl_discards%setup(0, param)

            tp%lfirst = param%lfirstkick
            pl%lfirst = param%lfirstkick

         end associate
      end select
      end select
      end associate

      return
   end subroutine symba_step_reset_system

end submodule s_symba_step

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(whm) s_whm_step
   use swiftest
contains

   module subroutine whm_step_system(self, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step massive bodies and and active test particles ahead in heliocentric coordinates
      !! 
      !! Adapted from Hal Levison's Swift routine step_kdk.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_step.f90
      implicit none
      ! Arguments
      class(whm_nbody_system),    intent(inout) :: self  !! WHM nbody system object
      class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters 
      real(DP),                   intent(in)    :: t     !! Current simulation time
      real(DP),                   intent(in)    :: dt    !! Current stepsize

      associate(nbody_system => self, cb => self%cb, pl => self%pl, tp => self%tp)
         tp%lfirst = pl%lfirst
         call pl%step(nbody_system, param, t, dt)
         call tp%step(nbody_system, param, t, dt)
         call cb%rotphase_update(param, dt)
         ! if (param%ltides) call nbody_system%step_spin(param, t, dt)

      end associate
      return
   end subroutine whm_step_system 


   module subroutine whm_step_pl(self, nbody_system, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step planets ahead using kick-drift-kick algorithm
      !! 
      !! Adapted from Hal Levison's Swift routine step_kdk_pl.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_step_pl.f90
      implicit none
      ! Arguments
      class(whm_pl),                intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody_system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t     !! Current simulation time
      real(DP),                     intent(in)    :: dt    !! Current stepsize
      ! Internals
      real(DP)                                    :: dth
      
      if (self%nbody == 0) return

      associate(pl => self, cb => nbody_system%cb)
         dth = 0.5_DP * dt
         call pl%kick(nbody_system, param, t, dth,lbeg=.true.)
         call pl%vh2vj(cb) 
         if (param%lgr) call pl%gr_pos_kick(nbody_system, param, dth)
         call pl%drift(nbody_system, param, dt)
         if (param%lgr) call pl%gr_pos_kick(nbody_system, param, dth)
         call pl%j2h(cb)
         call pl%kick(nbody_system, param, t + dt, dth, lbeg=.false.)
      end associate

      return
   end subroutine whm_step_pl


   module subroutine whm_step_tp(self, nbody_system, param, t, dt)
      !! author: David A. Minton
      !!
      !! Step active test particles ahead using kick-drift-kick algorithm
      !! 
      !! Adapted from Hal Levison's Swift routine step_kdk_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_step_tp.f90
      implicit none
      ! Arguments
      class(whm_tp),                intent(inout) :: self   !! WHM test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody_system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t     !! Current simulation time
      real(DP),                     intent(in)    :: dt    !! Current stepsize
      ! Internals
      real(DP)                                    :: dth

      if (self%nbody == 0) return

      select type(nbody_system)
      class is (whm_nbody_system)
         associate(tp => self, cb => nbody_system%cb, pl => nbody_system%pl)
            dth = 0.5_DP * dt
            call tp%kick(nbody_system, param, t, dth, lbeg=.true.)
            if (param%lgr) call tp%gr_pos_kick(nbody_system, param, dth)
            call tp%drift(nbody_system, param, dt)
            if (param%lgr) call tp%gr_pos_kick(nbody_system, param, dth)
            call tp%kick(nbody_system, param, t + dt, dth, lbeg=.false.)
         end associate
      end select

      return
   end subroutine whm_step_tp   

end submodule s_whm_step

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(rmvs) s_rmvs_util
   use swiftest
contains

   module subroutine rmvs_util_append_pl(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one massive body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      !! Arguments
      class(rmvs_pl),                  intent(inout) :: self         
         !! RMVS massive body object
      class(swiftest_body),            intent(in)    :: source       
         !! Source object to append
      logical, dimension(:),           intent(in)    :: lsource_mask 
         !! Logical mask indicating which elements to append to

      select type(source)
      class is (rmvs_pl)
         call util_append(self%nenc, source%nenc, lsource_mask=lsource_mask)
         call util_append(self%tpenc1P, source%tpenc1P, lsource_mask=lsource_mask)
         call util_append(self%plind, source%plind, lsource_mask=lsource_mask)

         ! The following are not implemented as RMVS doesn't make use of fill operations on pl type
         ! So they are here as a placeholder in case someone wants to extend the RMVS class for some reason
         !call util_append(self%outer, source%outer, lsource_mask=lsource_mask)
         !call util_append(self%inner, source%inner, lsource_mask=lsource_mask)
         !call util_append(self%planetocentric, source%planetocentric, lsource_mask)

         call whm_util_append_pl(self, source, lsource_mask)
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class rmvs_pl or its descendents!"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine rmvs_util_append_pl


   module subroutine rmvs_util_append_tp(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from test particle object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      !! Arguments
      class(rmvs_tp),                  intent(inout) :: self         
         !! RMVS test particle object
      class(swiftest_body),            intent(in)    :: source       
         !! Source object to append
      logical, dimension(:),           intent(in)    :: lsource_mask 
         !! Logical mask indicating which elements to append to

      select type(source)
      class is (rmvs_tp)
         call util_append(self%lperi, source%lperi, lsource_mask=lsource_mask)
         call util_append(self%plperP, source%plperP, lsource_mask=lsource_mask)
         call util_append(self%plencP, source%plencP, lsource_mask=lsource_mask)

         call swiftest_util_append_tp(self, source, lsource_mask)  ! Note: whm_tp does not have its own append method, so we skip 
                                                                   ! back to the base class
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class rmvs_tp or its descendents!"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine rmvs_util_append_tp


   module subroutine rmvs_util_dealloc_cb(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Argument
      class(rmvs_cb),  intent(inout) :: self 
         !! RMVS central body object

      if (allocated(self%outer)) deallocate(self%outer)
      if (allocated(self%inner)) deallocate(self%inner)

      return
   end subroutine rmvs_util_dealloc_cb


   module subroutine rmvs_util_dealloc_interp(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Argument
      class(rmvs_interp),  intent(inout) :: self 
         !! RMVS interpolated nbody_system variables object
      
      if (allocated(self%x)) deallocate(self%x)
      if (allocated(self%v)) deallocate(self%v)
      if (allocated(self%aobl)) deallocate(self%aobl)
      if (allocated(self%atide)) deallocate(self%atide)

      return
   end subroutine rmvs_util_dealloc_interp


   module subroutine rmvs_util_dealloc_pl(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Argumente
      class(rmvs_pl),  intent(inout) :: self 
         !! RMVS massive body object

      if (allocated(self%outer)) deallocate(self%outer)
      if (allocated(self%inner)) deallocate(self%inner)
      if (allocated(self%nenc))  deallocate(self%nenc)
      if (allocated(self%planetocentric)) deallocate(self%planetocentric)

      call whm_util_dealloc_pl(self)

      return
   end subroutine rmvs_util_dealloc_pl


   module subroutine rmvs_util_dealloc_system(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables and resets all values to defaults. Acts as a base for a finalizer
      implicit none
      ! Arguments
      class(rmvs_nbody_system), intent(inout) :: self
         !! RMVS nbody system object

      self%lplanetocentric = .false.
      if (allocated(self%vbeg)) deallocate(self%vbeg)
      call self%whm_nbody_system%dealloc()

      return
   end subroutine rmvs_util_dealloc_system


   module subroutine rmvs_util_dealloc_tp(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Argument
      class(rmvs_tp),  intent(inout) :: self !! RMVS test particle object

      if (allocated(self%lperi)) deallocate(self%lperi)
      if (allocated(self%plperP)) deallocate(self%plperP)
      if (allocated(self%plencP)) deallocate(self%plencP)
      if (allocated(self%rheliocentric)) deallocate(self%rheliocentric)
      call self%cb_heliocentric%dealloc()

      call swiftest_util_dealloc_tp(self)

      return
   end subroutine rmvs_util_dealloc_tp


   module subroutine rmvs_util_fill_pl(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new RMVS massive body structure into an old one. 
      !! This is the inverse of a fill operation.
      !! 
      implicit none
      ! Arguments
      class(rmvs_pl),        intent(inout) :: self       
         !! RMVS massive body object
      class(swiftest_body),  intent(in)    :: inserts    
         !! Inserted object 
      logical, dimension(:), intent(in)    :: lfill_list 
         !! Logical array of bodies to merge into the keeps

      associate(keeps => self)
         select type(inserts)
         class is (rmvs_pl)
            call util_fill(keeps%nenc, inserts%nenc, lfill_list)
            call util_fill(keeps%tpenc1P, inserts%tpenc1P, lfill_list)
            call util_fill(keeps%plind, inserts%plind, lfill_list)

            ! The following are not implemented as RMVS doesn't make use of fill operations on pl type
            ! So they are here as a placeholder in case someone wants to extend the RMVS class for some reason
            !call util_fill(keeps%outer, inserts%outer, lfill_list)
            !call util_fill(keeps%inner, inserts%inner, lfill_list)
            !call util_fill(keeps%planetocentric, inserts%planetocentric, lfill_list)

            call whm_util_fill_pl(keeps, inserts, lfill_list)
         class default
            write(*,*) "Invalid object passed to the fill method. Source must be of class rmvs_pl or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine rmvs_util_fill_pl

   
   module subroutine rmvs_util_fill_tp(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new RMVS test particle structure into an old one. 
      !! This is the inverse of a fill operation.
      !! 
      implicit none
      ! Arguments
      class(rmvs_tp),        intent(inout) :: self       
         !! RMVS test particle object
      class(swiftest_body),  intent(in)    :: inserts    
         !! Inserted object 
      logical, dimension(:), intent(in)    :: lfill_list 
         !! Logical array of bodies to merge into the keeps

      associate(keeps => self)
         select type(inserts)
         class is (rmvs_tp)
            call util_fill(keeps%lperi, inserts%lperi, lfill_list)
            call util_fill(keeps%plperP, inserts%plperP, lfill_list)
            call util_fill(keeps%plencP, inserts%plencP, lfill_list)
            
            call swiftest_util_fill_tp(keeps, inserts, lfill_list) ! Note: whm_tp does not have its own fill method, so we skip back
                                                                   ! to the base class
         class default
            write(*,*) "Invalid object passed to the fill method. Source must be of class rmvs_tp or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine rmvs_util_fill_tp


   module subroutine rmvs_util_resize_pl(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a massive body object against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(rmvs_pl), intent(inout) :: self  
         !! RMVS massive body object
      integer(I4B),   intent(in)    :: nnew  
         !! New size neded

      call util_resize(self%nenc, nnew)
      call util_resize(self%tpenc1P, nnew)
      call util_resize(self%plind, nnew)

      ! The following are not implemented as RMVS doesn't make use of resize operations on pl type
      ! So they are here as a placeholder in case someone wants to extend the RMVS class for some reason
      !call util_resize(self%outer, nnew)
      !call util_resize(self%inner, nnew)
      !call util_resize(self%planetocentric, nnew)

      call whm_util_resize_pl(self, nnew)
      return
   end subroutine rmvs_util_resize_pl


   module subroutine rmvs_util_resize_tp(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a test particle object against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(rmvs_tp), intent(inout) :: self  
         !! RMVS test particle object
      integer(I4B),   intent(in)    :: nnew  
         !! New size neded

      call util_resize(self%lperi, nnew)
      call util_resize(self%plperP, nnew)
      call util_resize(self%plencP, nnew)
      call util_resize(self%rheliocentric, nnew)

      call swiftest_util_resize_tp(self, nnew)

      return
   end subroutine rmvs_util_resize_tp


   module subroutine rmvs_util_setup_pl(self, n, param)
      !! author: David A. Minton
      !!
      !! Allocate RMVS test particle structure
      !!
      !! Equivalent in functionality to David E. Kaufmann's Swifter routine rmvs_util_setup.f90
      implicit none
      ! Arguments
      class(rmvs_pl),            intent(inout) :: self  
         !! RMVS test particle object
      integer(I4B),              intent(in)    :: n     
         !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in)   :: param 
         !! Current run configuration parameter
      ! Internals
      integer(I4B) :: i

      !> Call allocation method for parent class
      associate(pl => self)
         call whm_util_setup_pl(pl, n, param) 
         if (n == 0) return

         allocate(pl%outer(0:NTENC))
         allocate(pl%inner(0:NTPHENC))
         if (.not.pl%lplanetocentric) then
            allocate(pl%nenc(n))
            pl%nenc(:) = 0
            ! Set up inner and outer planet interpolation vector storage containers
            do i = 0, NTENC
               allocate(pl%outer(i)%x(NDIM, n))
               allocate(pl%outer(i)%v(NDIM, n))
               pl%outer(i)%x(:,:) = 0.0_DP
               pl%outer(i)%v(:,:) = 0.0_DP
               allocate(pl%outer(i)%aobl(NDIM, n))
               pl%outer(i)%aobl(:,:) = 0.0_DP
            end do
            do i = 0, NTPHENC
               allocate(pl%inner(i)%x(NDIM, n))
               allocate(pl%inner(i)%v(NDIM, n))
               pl%inner(i)%x(:,:) = 0.0_DP
               pl%inner(i)%v(:,:) = 0.0_DP
               allocate(pl%inner(i)%aobl(NDIM, n))
               pl%inner(i)%aobl(:,:) = 0.0_DP
            end do
            ! if (param%ltides) then
            !    do i = 0, NTPHENC
            !       allocate(pl%inner(i)%atide(NDIM, n))
            !       pl%inner(i)%atide(:,:) = 0.0_DP
            !    end do
            ! end if
         end if
      end associate
      return
   end subroutine rmvs_util_setup_pl 


   module subroutine rmvs_util_setup_initialize_system(self, system_history, param)
      !! author: David A. Minton
      !!
      !! Initialize an RMVS nbody system from files and sets up the planetocentric structures.
      !! 
      !! We currently rearrange the pl order to keep it consistent with the way Swifter does it 
      !! In Swifter, the central body occupies the first position in the pl list, and during
      !! encounters, the encountering planet is skipped in loops. In Swiftest, we instantiate an
      !! RMVS nbody system object attached to each pl to store planetocentric versions of the nbody_system
      !! to use during close encounters. 
      implicit none
      ! Arguments
      class(rmvs_nbody_system),                intent(inout) :: self           
         !! RMVS system object
      class(swiftest_storage),    allocatable, intent(inout) :: system_history 
         !! Stores the system history between output dumps
      class(swiftest_parameters),              intent(inout) :: param          
         !! Current run configuration parameters 
      ! Internals
      integer(I4B) :: i, j

      ! Call parent method
      call whm_util_setup_initialize_system(self, system_history, param)

      ! Set up the pl-tp planetocentric encounter structures for pl and cb. The planetocentric tp structures are 
      ! generated as necessary during close encounter steps.
      select type(pl => self%pl)
      class is(rmvs_pl)
         select type(cb => self%cb)
         class is (rmvs_cb)
            select type (tp => self%tp)
            class is (rmvs_tp)
               tp%cb_heliocentric = cb
               pl%lplanetocentric = .false.
               tp%lplanetocentric = .false.
               cb%lplanetocentric = .false.
               associate(npl => pl%nbody)
                  allocate(pl%planetocentric(npl))
                  pl%planetocentric(:)%lplanetocentric = .true.
                  do i = 1, npl
                     allocate(pl%planetocentric(i)%cb, source=cb)
                     allocate(rmvs_pl :: pl%planetocentric(i)%pl)
                     select type(cbenci => pl%planetocentric(i)%cb)
                     class is (rmvs_cb)
                        select type(plenci => pl%planetocentric(i)%pl)
                        class is (rmvs_pl)
                           cbenci%lplanetocentric = .true.
                           plenci%lplanetocentric = .true.
                           call plenci%setup(npl, param)
                           plenci%status(:) = ACTIVE
                           plenci%lmask(:) = .true.
                           ! plind stores the heliocentric index value of a planetocentric planet
                           ! e.g. Consider an encounter with planet 3.  
                           ! Then the following will be the values of plind:
                           ! pl%planetocentric(3)%pl%plind(1) = 0 (central body - never used)  
                           ! pl%planetocentric(3)%pl%plind(2) = 1  
                           ! pl%planetocentric(3)%pl%plind(3) = 2
                           ! pl%planetocentric(3)%pl%plind(4) = 4
                           ! pl%planetocentric(3)%pl%plind(5) = 5
                           ! etc.  
                           allocate(plenci%plind(npl))
                           plenci%plind(1:npl) = [(j,j=1,npl)] 
                           plenci%plind(2:npl) = pack(plenci%plind(1:npl), plenci%plind(1:npl) /= i)
                           plenci%plind(1)     = 0
                           plenci%Gmass(1)     = cb%Gmass
                           plenci%Gmass(2:npl) = pl%Gmass(plenci%plind(2:npl))
                           cbenci%Gmass        = pl%Gmass(i)
                        end select
                     end select
                  end do
               end associate
            end select
         end select
      end select
      return
   end subroutine rmvs_util_setup_initialize_system


   module subroutine rmvs_util_setup_tp(self, n, param)
      !! author: David A. Minton
      !!
      !! Allocate WHM test particle structure
      !!
      !! Equivalent in functionality to David E. Kaufmann's Swifter routine whm_util_setup.f90
      implicit none
      ! Arguments
      class(rmvs_tp),             intent(inout) :: self  
         !! RMVS test particle object
      integer(I4B),               intent(in)    :: n     
         !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in)    :: param 
         !! Current run configuration parameter

      !> Call allocation method for parent class. 
      call self%whm_tp%setup(n, param) 
      if (n <= 0) return

      if (allocated(self%lperi)) deallocate(self%lperi); allocate(self%lperi(n))
      if (allocated(self%plperP)) deallocate(self%plperP); allocate(self%plperP(n))
      if (allocated(self%plencP)) deallocate(self%plencP); allocate(self%plencP(n))

      if (self%lplanetocentric) then
         if (allocated(self%rheliocentric)) deallocate(self%rheliocentric); allocate(self%rheliocentric(NDIM, n))
      end if

      self%lperi(:)  = .false.

      return
   end subroutine rmvs_util_setup_tp


   module subroutine rmvs_util_sort_pl(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a RMVS massive body object in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(rmvs_pl), intent(inout) :: self       
         !! RMVS massive body object
      character(*),   intent(in)     :: sortby    
         !! Sorting attribute
      logical,        intent(in)     :: ascending 
         !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B) :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(pl => self, npl => self%nbody)
         select case(sortby)
         case("nenc")
            call util_sort(direction * pl%nenc(1:npl), ind)
         case("tpenc1P")
            call util_sort(direction * pl%tpenc1P(1:npl), ind)
         case("plind")
            call util_sort(direction * pl%plind(1:npl), ind)
         case("outer", "inner", "planetocentric", "lplanetocentric")
            write(*,*) 'Cannot sort by ' // trim(adjustl(sortby)) // '. Component not sortable!'
         case default ! Look for components in the parent class
            call whm_util_sort_pl(pl, sortby, ascending)
            return
         end select

         call pl%rearrange(ind)

      end associate
      return
   end subroutine rmvs_util_sort_pl


   module subroutine rmvs_util_sort_tp(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a RMVS test particle object in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(rmvs_tp), intent(inout) :: self      
         !! RMVS test particle object
      character(*),   intent(in)    :: sortby    
         !! Sorting attribute
      logical,        intent(in)    :: ascending 
         !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B)                            :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(tp => self, ntp => self%nbody)
         select case(sortby)
         case("plperP")
            call util_sort(direction * tp%plperP(1:ntp), ind)
         case("plencP")
            call util_sort(direction * tp%plencP(1:ntp), ind)
         case("lperi", "cb_heliocentric", "rheliocentric", "index", "ipleP", "lplanetocentric")
            write(*,*) 'Cannot sort by ' // trim(adjustl(sortby)) // '. Component not sortable!'
         case default ! Look for components in the parent class (*NOTE whm_tp does not need its own sort method, so we go straight 
                      ! to the swiftest_tp method)
            call swiftest_util_sort_tp(tp, sortby, ascending)
            return
         end select

         call tp%rearrange(ind)

      end associate
      return
   end subroutine rmvs_util_sort_tp

   module subroutine rmvs_util_sort_rearrange_pl(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange RMVS massive body structure in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(rmvs_pl),               intent(inout) :: self 
         !! RMVS massive body object
      integer(I4B),   dimension(:), intent(in)    :: ind  
         !! Index array used to restructure the body (should contain all 1:n index values in the desired order)

      if (self%nbody == 0) return

      associate(pl => self, npl => self%nbody)
         call util_sort_rearrange(pl%nenc, ind, npl)
         call util_sort_rearrange(pl%tpenc1P, ind, npl)
         call util_sort_rearrange(pl%plind, ind, npl)
         call swiftest_util_sort_rearrange_pl(pl,ind)
      end associate

      return
   end subroutine rmvs_util_sort_rearrange_pl


   module subroutine rmvs_util_sort_rearrange_tp(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange RMVS test particle object in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(rmvs_tp),                intent(inout) :: self 
         !! RMVS test particle object
      integer(I4B),    dimension(:), intent(in)    :: ind  
         !! Index array used to restructure the body (should contain all 1:n index values in the desired order)

      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody)
         call util_sort_rearrange(tp%lperi, ind, ntp)
         call util_sort_rearrange(tp%plperP, ind, ntp)
         call util_sort_rearrange(tp%plencP, ind, ntp)
         call util_sort_rearrange(tp%rheliocentric, ind, ntp)
         call swiftest_util_sort_rearrange_tp(tp,ind)
      end associate

      return
   end subroutine rmvs_util_sort_rearrange_tp
   

   module subroutine rmvs_util_spill_pl(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) RMVS test particle structure from active list to discard list
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine discard_discard_spill.f90
      implicit none
      ! Arguments
      class(rmvs_pl),        intent(inout) :: self         
         !! RMVS massive body body object
      class(swiftest_body),  intent(inout) :: discards     
         !! Discarded object 
      logical, dimension(:), intent(in)    :: lspill_list  
         !! Logical array of bodies to spill into the discards
      logical,               intent(in)    :: ldestructive 
         !! Logical flag indicating whether or not this operation should alter the keeps array or not

      associate(keeps => self)
         select type(discards)
         class is (rmvs_pl)
            call util_spill(keeps%nenc, discards%nenc, lspill_list, ldestructive)
            call util_spill(keeps%tpenc1P, discards%tpenc1P, lspill_list, ldestructive)
            call util_spill(keeps%plind, discards%plind, lspill_list, ldestructive)

            call whm_util_spill_pl(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) "Invalid object passed to the spill method. Source must be of class rmvs_pl or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine rmvs_util_spill_pl

   
   module subroutine rmvs_util_spill_tp(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) RMVS test particle structure from active list to discard list
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(rmvs_tp),        intent(inout) :: self        
         !! RMVS test particle object
      class(swiftest_body),  intent(inout) :: discards    
         !! Discarded object 
      logical, dimension(:), intent(in)    :: lspill_list 
         !! Logical array of bodies to spill into the discards
      logical,               intent(in)    :: ldestructive 
         !! Logical flag indicating whether or not this operation should alter the keeps array or not

      associate(keeps => self)
         select type(discards)
         class is (rmvs_tp)
            call util_spill(keeps%lperi, discards%lperi, lspill_list, ldestructive)
            call util_spill(keeps%plperP, discards%plperP, lspill_list, ldestructive)
            call util_spill(keeps%plencP, discards%plencP, lspill_list, ldestructive)

            call swiftest_util_spill_tp(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) "Invalid object passed to the spill method. Source must be of class rmvs_tp or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine rmvs_util_spill_tp

end submodule s_rmvs_util

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(operators) s_operator_cross
   use, intrinsic :: ieee_exceptions
   use swiftest
   !! author: David A. Minton
   !!
   !! Contains implementations for the .cross. operator for all defined integer and real types
   !! Computes the cross product of two (3) vectors or (3,:) arrays 
   !! Single vector implementations: C(1:3)   = A(1:3)   .cross. B(1:3) 
   !! Vector list implementations:   C(1:3, :) = A(1:3, :) .cross. B(1:3, :)
contains

   pure module function operator_cross_sp(A, B) result(C)
      implicit none
      real(SP), dimension(:), intent(in) :: A, B
      real(SP), dimension(3) :: C

      call ieee_set_halting_mode(ieee_underflow, .false.)
      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_sp

   pure module function operator_cross_dp(A, B) result(C)
      implicit none
      real(DP), dimension(:), intent(in) :: A, B
      real(DP), dimension(3) :: C

      call ieee_set_halting_mode(ieee_underflow, .false.)
      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_dp

#ifdef QUADPREC
   pure module function operator_cross_qp(A, B) result(C)
      implicit none
      real(QP), dimension(:), intent(in) :: A, B
      real(QP), dimension(3) :: C

      call ieee_set_halting_mode(ieee_underflow, .false.)
      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_qp
#endif

   pure module function operator_cross_i1b(A, B) result(C)
      implicit none
      integer(I1B), dimension(:), intent(in) :: A, B
      integer(I1B), dimension(3) :: C

      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_i1b

   pure module function operator_cross_i2b(A, B) result(C)
      implicit none
      integer(I2B), dimension(:), intent(in) :: A, B
      integer(I2B), dimension(3) :: C

      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_i2b

   pure module function operator_cross_i4b(A, B) result(C)
      implicit none
      integer(I4B), dimension(:), intent(in) :: A, B
      integer(I4B), dimension(3) :: C
      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_i4b

   pure module function operator_cross_i8b(A, B) result(C)     
      implicit none
      integer(I8B), dimension(:), intent(in) :: A, B
      integer(I8B), dimension(3) :: C
      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)
      return
   end function operator_cross_i8b

   pure module function operator_cross_el_sp(A, B) result(C)
      implicit none
      real(SP), dimension(:,:), intent(in)  :: A, B
      real(SP), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_sp(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_sp

   pure module function operator_cross_el_dp(A, B) result(C)
      implicit none
      real(DP), dimension(:,:), intent(in)  :: A, B
      real(DP), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_dp(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_dp

#ifdef QUADPREC
   pure module function operator_cross_el_qp(A, B) result(C)
      implicit none
      real(QP), dimension(:,:), intent(in)  :: A, B
      real(QP), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_qp(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_qp
#endif 

   pure module function operator_cross_el_i1b(A, B) result(C)
      implicit none
      integer(I1B), dimension(:,:), intent(in)  :: A, B
      integer(I1B), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_i1b(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_i1b

   pure module function operator_cross_el_i2b(A, B) result(C)
      implicit none
      integer(I2B), dimension(:,:), intent(in)  :: A, B
      integer(I2B), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_i2b(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_i2b

   pure module function operator_cross_el_i4b(A, B) result(C)
      implicit none
      integer(I4B), dimension(:,:), intent(in)  :: A, B
      integer(I4B), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_i4b(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_i4b

   pure module function operator_cross_el_i8b(A, B) result(C)
      implicit none
      integer(I8B), dimension(:,:), intent(in)  :: A, B
      integer(I8B), dimension(:,:), allocatable :: C
      integer(I4B) :: i, n
      n = size(A, 2)
      if (allocated(C)) deallocate(C)
      allocate(C, mold = A)
      do i = 1,n 
         C(:,i) = operator_cross_i8b(A(:,i), B(:,i))
      end do
      return
   end function operator_cross_el_i8b

end submodule s_operator_cross

submodule(tides) s_tides_step_spin
   use swiftest

contains

   module subroutine tides_step_spin_system(self, param, t, dt)
      !! author: Jennifer L.L. Pouplin and David A. Minton
      !!
      !! Integrates the spin equations for central and massive bodies of the nbody_system subjected to tides.
      implicit none
      ! Arguments
      class(base_nbody_system), intent(inout) :: self   !! Swiftest nbody system object
      class(base_parameters),   intent(in)    :: param  !! Current run configuration parameters  
      real(DP),                     intent(in)    :: t     !! Simulation time
      real(DP),                     intent(in)    :: dt    !! Current stepsize
      ! Internals
      real(DP), dimension(:), allocatable       :: rot0, rot1
      real(DP)                                  :: subt
      real(DP), parameter                       :: tol=1e-6_DP !! Just a guess at the moment
      real(DP)                                  :: subdt 

      select type(self)
      class is (swiftest_nbody_system)
         associate(pl => self%pl, npl => self%pl%nbody, cb => self%cb)
            allocate(rot0(NDIM*(npl+1)))
            ! rot0 = [pack(pl%rot(:,1:npl),.true.), pack(cb%rot(:),.true.)]
            ! Use this space call the ode_solver, passing tides_spin_derivs as the function:
            ! subdt = dt / 20._DP
            ! rot1(:) = swiftest_util_solve_rkf45(lambda_obj(tides_spin_derivs, subdt, pl%rbeg, pl%rend), rot0, dt, subdt,tol)
            ! ! Recover with unpack
            ! pl%rot(:,1:npl) = unpack(rot1...
            ! cb%rot(:) = unpack(rot1...
         end associate
      end select

      return
   end subroutine tides_step_spin_system


   module function tides_spin_derivs(rot_pl_cb, t, dt, rbeg, rend) result(drot) !! Need to add more arguments so we can pull in mass, radius, Ip, J2, etc...
      !! author: Jennifer L.L. Pouplin and David A. Minton
      !!
      !! function used to calculate the derivatives that are fed to the ODE solver
      implicit none
      ! Arguments
      real(DP), dimension(:,:),     intent(in) :: rot_pl_cb !! Array of rotations. The last element is the central body, and all others are massive bodies
      real(DP),                     intent(in) :: t         !! Current time, which is used to interpolate the massive body positions
      real(DP),                     intent(in) :: dt        !! Total step size
      real(DP), dimension(:,:),     intent(in) :: rbeg
      real(DP), dimension(:,:),     intent(in) :: rend
      ! Internals
      real(DP), dimension(:,:), allocatable    :: drot
      real(DP), dimension(:), allocatable      :: flatrot
      real(DP), dimension(NDIM)                :: N_Tcb, N_Rcb, N_Tpl, N_Rpl, xinterp
      real(DP)                                 :: C_cb, C_pl, r_dot_rot_cb, r_dot_rot_pl, rmag
      integer(I4B)                             :: i, n


      n = size(rot_pl_cb,2)
      if (allocated(drot)) deallocate(drot) 
      allocate(drot, mold=rot_pl_cb)
      drot(:,:) = 0.0_DP
      do i = 1,n-1
         xinterp(:) = rbeg(:,i) + t / dt * (rend(:,i) - rbeg(:,i))
         ! Calculate Ncb and Npl as a function of xinterp
         !drot(:,i) = -Mcb / (Mcb + Mpl(i)) * (N_Tpl + N_Rpl)
         !drot(:,n) = drot(:,n) - Mcb / (Mcb + Mpl(i) * (N_Tcb + N_Rcb)
         !
      end do

      return
   end function tides_spin_derivs

   module function tides_derivs_eval(self, x, t) result(y)
      implicit none
      ! Arguments
      class(tides_derivs_func), intent(inout) :: self
      real(DP), dimension(:), intent(in) :: x
      real(DP),                 intent(in) :: t
      ! Result
      real(DP), dimension(:), allocatable  :: y
      if (associated(self%lambdaptr_tides_deriv)) then
         y = self%lambdaptr_tides_deriv(x, t, self%dt, self%rbeg, self%rend)
      else
         stop "Lambda function was not initialized"
      end if

      return
   end function tides_derivs_eval

   module function tides_derivs_init(lambda, dt, rbeg, rend) result(f)
      implicit none
      ! Arguments
      procedure(tidederiv)                     :: lambda
      real(DP),                     intent(in) :: dt
      real(DP), dimension(:,:),     intent(in) :: rbeg
      real(DP), dimension(:,:),     intent(in) :: rend
      ! Result
      type(tides_derivs_func)                  :: f
      f%lambdaptr_tides_deriv => lambda
      f%dt = dt
      allocate(f%rbeg, source = rbeg)
      allocate(f%rend, source = rend)

      return
   end function tides_derivs_init

end submodule s_tides_step_spin

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module tides
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods used to determine close encounters
   use base
   use lambda_function
   implicit none
   public


   type, extends(lambda_obj_tvar) :: tides_derivs_func 
      !! Base class for an lambda function object. This object takes no additional arguments other than the dependent variable x, an array of real numbers
      procedure(tidederiv), pointer, nopass :: lambdaptr_tides_deriv 
      real(DP), dimension(:,:), allocatable :: rbeg
      real(DP), dimension(:,:), allocatable :: rend
      real(DP)                              :: dt
   contains
      generic   :: init => tides_derivs_init
      procedure :: evalt => tides_derivs_eval
      procedure, nopass :: tides_derivs_init
   end type
   interface lambda_obj
      module procedure tides_derivs_init
   end interface

   abstract interface
      function tidederiv(x, t, dt, rbeg, rend) result(y)
         ! Template for a 0 argument function
         import DP, base_nbody_system
         real(DP), dimension(:),     intent(in) :: x
         real(DP),                     intent(in) :: t
         real(DP),                     intent(in) :: dt
         real(DP), dimension(:,:),     intent(in) :: rbeg
         real(DP), dimension(:,:),     intent(in) :: rend
         real(DP), dimension(:), allocatable    :: y
      end function
   end interface


   interface
      module subroutine tides_kick_getacch_pl(self, nbody_system)
         implicit none
         class(base_object),         intent(inout) :: self   !! Swiftest massive body object
         class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      end subroutine tides_kick_getacch_pl

      module function tides_derivs_init(lambda, dt, rbeg, rend) result(f)
         implicit none
         procedure(tidederiv)                     :: lambda
         real(DP),                     intent(in) :: dt
         real(DP), dimension(:,:),     intent(in) :: rbeg
         real(DP), dimension(:,:),     intent(in) :: rend
         type(tides_derivs_func)                  :: f
      end function tides_derivs_init

      module function tides_derivs_eval(self, x, t) result(y)
         class(tides_derivs_func), intent(inout) :: self
         real(DP), dimension(:), intent(in) :: x
         real(DP),                 intent(in) :: t
         real(DP), dimension(:), allocatable  :: y
      end function tides_derivs_eval

      module function tides_rot_derivs(rot_pl_cb, t, dt, rbeg, rend) result(drot) !! Need to add more arguments so we can pull in mass, radius, Ip, J2, etc...
         real(DP), dimension(:,:),     intent(in) :: rot_pl_cb !! Array of rotations. The last element is the central body, and all others are massive bodies
         real(DP),                     intent(in) :: t         !! Current time, which is used to interpolate the massive body positions
         real(DP),                     intent(in) :: dt        !! Total step size
         real(DP), dimension(:,:),     intent(in) :: rbeg
         real(DP), dimension(:,:),     intent(in) :: rend
         real(DP), dimension(:,:), allocatable    :: drot
      end function tides_rot_derivs

      module subroutine tides_step_rot_system(self, param, t, dt)
         implicit none
         class(base_nbody_system), intent(inout) :: self   !! Swiftest nbody system object
         class(base_parameters),   intent(in)    :: param  !! Current run configuration parameters  
         real(DP),                     intent(in)    :: t     !! Simulation time
         real(DP),                     intent(in)    :: dt    !! Current stepsize
      end subroutine tides_step_rot_system
   
   end interface


end module 

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (swiftest) s_swiftest_coarray
    use coarray
contains

    module subroutine swiftest_coarray_balance_system(self, param)
        !! author: David A. Minton
        !!
        !! Checks whether or not the system needs to be rebalance. Rebalancing occurs when the sum of the absolute difference 
        !! between !! the number of test particles on each image and the average number distributed across all images is larger than
        !! the number of images. 
        implicit none
        ! Arguments
        class(swiftest_nbody_system), intent(inout) :: self
            !! Swiftest nbody system 
        class(swiftest_parameters),   intent(inout) :: param       
             !! Current run configuration parameters 
        ! Internals
        integer(I4B), codimension[*], save :: ntp, nsum, ndiff
        integer(I4B) :: img, nimg, navg
        character(len=NAMELEN) :: ntp_str, nsum_str, ndiff_str, navg_str, nimg_str

        if (.not.param%lcoarray) return
        img = this_image()
        nimg = num_images()
        ntp = self%tp%nbody
        sync all
        write(param%display_unit,*) "Checking whether test particles need to be reblanced."
        nsum = ntp
        ndiff = ntp
        call co_sum(nsum)
        navg = floor(real(nsum) / nimg)
        ndiff = abs(ntp - navg)
        call co_sum(ndiff)

        write(ntp_str,*) ntp
        write(nsum_str,*) nsum
        write(ndiff_str,*) ndiff
        write(navg_str,*) navg
        write(nimg_str,*) nimg

        if (ndiff >= nimg) then
            write(param%display_unit,*) trim(adjustl(ndiff_str)) // ">=" // trim(adjustl(nimg_str)) // ": Rebalancing"
            flush(param%display_unit)
            call self%coarray_collect(param)
            call self%coarray_distribute(param)
            sync all
            write(param%display_unit,*) "Rebalancing complete"
        else
            write(param%display_unit,*) trim(adjustl(ndiff_str)) // "<" // trim(adjustl(nimg_str)) // ": No rebalancing needed"
        end if
        flush(param%display_unit)
        return
    end subroutine swiftest_coarray_balance_system


    module subroutine swiftest_coarray_coclone_param(param)
        !! author: David A. Minton 
        !! 
        !! Broadcasts the image 1 parameter to all other images in a parameter coarray 
        implicit none
        ! Arguments
        type(swiftest_parameters),intent(inout),codimension[*]  :: param  
            !! Collection of parameters 


        call co_broadcast(param%integrator,1)
        call co_broadcast(param%param_file_name,1)
        call co_broadcast(param%t0,1)
        call co_broadcast(param%tstart,1)
        call co_broadcast(param%tstop,1)
        call co_broadcast(param%dt,1)
        call co_broadcast(param%iloop,1)
        call co_broadcast(param%nloops,1)
        call co_broadcast(param%incbfile,1)
        call co_broadcast(param%inplfile,1)
        call co_broadcast(param%intpfile,1)
        call co_broadcast(param%nc_in,1)
        call co_broadcast(param%in_type,1)
        call co_broadcast(param%in_form,1)
        call co_broadcast(param%istep_out,1)
        call co_broadcast(param%nstep_out,1)
        call co_broadcast(param%fstep_out,1)
        call co_broadcast(param%ltstretch,1)
        call co_broadcast(param%outfile,1)
        call co_broadcast(param%out_type,1)
        call co_broadcast(param%out_form,1)
        call co_broadcast(param%out_stat,1)
        call co_broadcast(param%dump_cadence,1)
        call co_broadcast(param%rmin,1)
        call co_broadcast(param%rmax,1)
        call co_broadcast(param%rmaxu,1)
        call co_broadcast(param%qmin,1)
        call co_broadcast(param%qmin_coord,1)
        call co_broadcast(param%qmin_alo,1)
        call co_broadcast(param%qmin_ahi,1)
        call co_broadcast(param%MU2KG,1)
        call co_broadcast(param%TU2S,1)
        call co_broadcast(param%DU2M,1)
        call co_broadcast(param%GU,1)
        call co_broadcast(param%inv_c2,1)
        call co_broadcast(param%GMTINY,1)
        call co_broadcast(param%min_GMfrag,1)
        call co_broadcast(param%nfrag_reduction,1)
        call co_broadcast(param%lmtiny_pl,1)
        call co_broadcast(param%collision_model,1)
        call co_broadcast(param%encounter_save,1)
        call co_broadcast(param%lenc_save_trajectory,1)
        call co_broadcast(param%lenc_save_closest,1)
        call co_broadcast(param%interaction_loops,1)
        call co_broadcast(param%encounter_check_plpl,1)
        call co_broadcast(param%encounter_check_pltp,1)
        call co_broadcast(param%lflatten_interactions,1)
        call co_broadcast(param%lencounter_sas_plpl,1)
        call co_broadcast(param%lencounter_sas_pltp,1)
        call co_broadcast(param%lrhill_present,1)
        call co_broadcast(param%lextra_force,1)
        call co_broadcast(param%lbig_discard,1)
        call co_broadcast(param%lclose,1)
        call co_broadcast(param%lenergy,1)
        call co_broadcast(param%lnon_spherical_cb,1)
        call co_broadcast(param%lrotation,1)
        call co_broadcast(param%ltides,1)
        call co_broadcast(param%E_orbit_orig,1)
        call co_broadcast(param%GMtot_orig,1)
        call co_broadcast(param%L_total_orig,1)
        call co_broadcast(param%L_orbit_orig,1)
        call co_broadcast(param%L_rot_orig,1)
        call co_broadcast(param%L_escape,1)
        call co_broadcast(param%GMescape,1)
        call co_broadcast(param%E_collisions,1)
        call co_broadcast(param%E_untracked,1)
        call co_broadcast(param%lfirstenergy,1)
        call co_broadcast(param%lfirstkick,1)
        call co_broadcast(param%lrestart,1)
        call co_broadcast(param%display_style,1)
        call co_broadcast(param%display_unit,1)
        call co_broadcast(param%log_output ,1)
        call co_broadcast(param%lgr,1)
        call co_broadcast(param%lyarkovsky,1)
        call co_broadcast(param%lyorp,1)
        call coclone(param%seed)
        call co_broadcast(param%lcoarray,1)

        return
    end subroutine swiftest_coarray_coclone_param 


    module subroutine swiftest_coarray_component_clone_info(var,src_img)
        !! author: David A. Minton
        !!
        !! Copies a component of a coarray derived type from the specified source image to the current local one. 
        !! The default source image is 1
        !! swiftest_particle_info scalar version
        implicit none
        ! Arguments
        type(swiftest_particle_info), intent(inout) :: var
            !! Variable to be cloned
        integer(I4B), intent(in),optional :: src_img
            !! Source image to clone from
        ! Internals
        type(swiftest_particle_info),allocatable :: tmp[:]
        integer(I4B) :: img, si
    
        allocate(tmp[*])
        if (present(src_img)) then
           si = src_img
        else
           si = 1
        end if
   
        if (this_image() == si) then
           do img = 1, num_images()
             tmp[img] = var 
           end do
           sync images(*)
        else
           sync images(si)
           var = tmp[si]
        end if

        deallocate(tmp)
    
        return
    end subroutine swiftest_coarray_component_clone_info

    
    module subroutine swiftest_coarray_component_clone_info_arr1D(var,src_img)
        !! author: David A. Minton
        !!
        !! Copies a component of a coarray derived type from the specified source image to the current local one. 
        !! The default source image is 1
        !! swiftest_particle_info 1D allocatable array version
        implicit none
        ! Arguments
        type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: var
            !! Variable to be cloned
        integer(I4B), intent(in),optional :: src_img
            !! Source image to clone from
        ! Internals
        type(swiftest_particle_info), dimension(:), codimension[:], allocatable :: tmp
        integer(I4B) :: img, si
        integer(I4B), allocatable :: n[:]
        logical, allocatable :: isalloc[:]
    
        allocate(isalloc[*])
        allocate(n[*])
    
        if (present(src_img)) then
           si = src_img
        else
           si = 1
        end if
    
        isalloc = allocated(var)
        if (isalloc) n = size(var)
        sync all 
        if (.not. isalloc[si]) return
    
        allocate(tmp(n[si])[*])
        if (this_image() == si) then
           do img = 1, num_images()
             tmp(:)[img] = var 
           end do
           sync images(*)
        else
           sync images(si)
           if (allocated(var)) deallocate(var)
           allocate(var, source=tmp)
        end if

        deallocate(isalloc,n,tmp)
    
        return
    end subroutine swiftest_coarray_component_clone_info_arr1D


    module subroutine swiftest_coarray_component_collect_info_arr1D(var,dest_img)
        !! author: David A. Minton
        !!
        !! Collects components of a coarray derived type from all images and combines them into destination image component. 
        !! The default destination image is 1
        !! swiftest_particle_info 1D allocatable array version
        implicit none
        ! Arguments
        type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: var
            !! Variable to be collected
        integer(I4B), intent(in),optional :: dest_img
            !! Destination image to collect to
        ! Internals
        type(swiftest_particle_info), dimension(:), codimension[:], allocatable :: tmp
        integer(I4B) :: i,img, ti, di, ntot, istart, iend, nmax
        integer(I4B), allocatable :: n[:]
        logical, allocatable :: isalloc[:]
        type(swiftest_particle_info), dimension(:), allocatable :: vari1
  
        allocate(isalloc[*])
        allocate(n[*])
  
        if (present(dest_img)) then
           di = dest_img
        else
           di = 1
        end if
  
        isalloc = allocated(var)
        if (isalloc) then
           n = size(var)
        else
           n = 0
        end if
        sync all
        nmax = 0
        do img = 1, num_images()
           if (n[img] > nmax) nmax = n[img]
        end do
  
        allocate(tmp(nmax)[*])
        if (isalloc) tmp(1:n) = var(1:n)
  
        if (this_image() == di) then
           do img = 1, num_images()
              if (img /= di) then
                if (allocated(vari1)) deallocate(vari1)
                allocate(vari1, source=tmp(1:n[img])[img])
                call util_append(var, vari1)
                 n = n + n[img]
              end if
           end do
           sync images(*)
        else
           sync images(di)
           if (allocated(var)) deallocate(var)
        end if

        deallocate(isalloc,n,tmp)
  
        return
    end subroutine swiftest_coarray_component_collect_info_arr1D


    module subroutine swiftest_coarray_collect_system(self, param)
        !! author: David A. Minton
        !!
        !! Collects all the test particles from other images into the image #1 test particle system
        use whm, only: whm_tp, cocollect
        use rmvs, only: rmvs_tp, cocollect
        implicit none
        ! Arguments
        class(swiftest_nbody_system), intent(inout) :: self
            !! Swiftest nbody system 
        class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
        ! Internals
        integer(I4B) :: i,j
        type(whm_tp), allocatable, codimension[:] :: whm_cotp
        type(rmvs_tp), allocatable, codimension[:] :: rmvs_cotp
        character(len=NAMELEN) :: image_num_char

        if (.not.param%lcoarray) return

        if (this_image() == 1 .or. param%log_output) then
            write(image_num_char,*) num_images()
            write(param%display_unit,*) " Collecting test particles from " // trim(adjustl(image_num_char)) // " images."
            if (param%log_output) flush(param%display_unit)
        end if

        select type(tp => self%tp)
        class is (rmvs_tp)
            allocate(rmvs_cotp[*], source=tp)
            call cocollect(rmvs_cotp)
            if (this_image() == 1) then
                deallocate(self%tp)
                allocate(self%tp, source=rmvs_cotp)
            end if
            deallocate(rmvs_cotp)
        class is (whm_tp)
            allocate(whm_cotp[*], source=tp)
            call cocollect(whm_cotp)
            if (this_image() == 1) then
                deallocate(self%tp)
                allocate(self%tp, source=whm_cotp)
            end if
            deallocate(whm_cotp)
        end select

        return
    end subroutine swiftest_coarray_collect_system
 
 
    module subroutine swiftest_coarray_distribute_system(self, param)
        !! author: David A. Minton
        !!
        !! Distributes test particles from image #1 out to all images.
        use whm, only: whm_tp, coclone
        use rmvs, only: rmvs_tp, coclone
        implicit none
        ! Arguments
        class(swiftest_nbody_system), intent(inout) :: self
            !! Swiftest nbody system 
        class(swiftest_parameters),   intent(inout) :: param        
            !! Current run configuration parameters 
        ! Internals
        integer(I4B) :: istart, iend, ntot, num_per_image, nremaining, i
        logical, dimension(:), allocatable :: lspill_list
        integer(I4B), codimension[:], allocatable  :: ntp
        character(len=NAMELEN) :: image_num_char, ntp_num_char
        type(whm_tp), allocatable, codimension[:] :: whm_cotp
        type(rmvs_tp), allocatable, codimension[:] :: rmvs_cotp
        class(swiftest_tp), allocatable :: tmp

        if (.not.param%lcoarray) return
        associate(nbody_system => self)

            allocate(ntp[*])
            ntp = nbody_system%tp%nbody
            sync all
            ntot = ntp[1]
            if (ntot == 0) return

            write(image_num_char,*) num_images()

            if (this_image() == 1 .or. param%log_output) then
                write(ntp_num_char,*) ntot
                write(param%display_unit,*) " Distributing " // trim(adjustl(ntp_num_char)) // " test particles across " // &
                                                                trim(adjustl(image_num_char)) // " images."
                if (param%log_output) flush(param%display_unit)
            end if

            allocate(lspill_list(ntot))
            num_per_image = ntot / num_images()
            nremaining = mod(ntot, num_images())
            istart = 1
    
            ! Distribute the particles as evenly as possible
            lspill_list(:) = .true.
            if (this_image() <= nremaining) then
                istart = (this_image() - 1) * (num_per_image + 1) + 1
                iend = istart + num_per_image
            else
                istart = nremaining * (num_per_image + 1) + (this_image() - nremaining - 1) * num_per_image + 1
                iend = istart + num_per_image - 1
            end if
    
            if (istart <= iend) then
                lspill_list(istart:iend) = .false.
            end if

            select type(tp => nbody_system%tp)
            class is (rmvs_tp)
                allocate(rmvs_cotp[*], source=tp)
                call coclone(rmvs_cotp)
                if (this_image() /= 1) then
                    deallocate(nbody_system%tp)
                    allocate(nbody_system%tp, source=rmvs_cotp)
                end if
                deallocate(rmvs_cotp)
                allocate(tmp, mold=tp)
            class is (whm_tp) 
                allocate(whm_cotp[*], source=tp)
                call coclone(whm_cotp)
                if (this_image() /= 1) then
                    deallocate(nbody_system%tp)
                    allocate(nbody_system%tp, source=whm_cotp)
                end if
                deallocate(whm_cotp)
                allocate(tmp, mold=tp)
            end select

            call nbody_system%tp%spill(tmp, lspill_list(:), ldestructive=.true.)

            write(image_num_char,*) this_image()
            write(ntp_num_char,*) nbody_system%tp%nbody
            write(param%display_unit,*) "Image " // trim(adjustl(image_num_char)) // " ntp: " // trim(adjustl(ntp_num_char))
            if (param%log_output) flush(param%display_unit)

            deallocate(ntp, lspill_list, tmp)
            if (param%log_output) flush(param%display_unit)
            sync all
        end associate

        return
    end subroutine swiftest_coarray_distribute_system


end submodule s_swiftest_coarray

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(fraggle) s_fraggle_generate
   use swiftest
   use symba

contains

   module subroutine fraggle_generate(self, nbody_system, param, t)
      !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Create the fragments resulting from a non-catastrophic disruption collision
      !! 
      implicit none
      ! Arguments
      class(collision_fraggle), intent(inout) :: self
         !! Fraggle collisional system object
      class(base_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            
         !! Time of collision
      ! Internals
      integer(I4B)          :: i, ibiggest
      real(DP), dimension(NDIM) :: L_residual, vbcom_orig
      character(len=STRMAX) :: message 
      logical               :: lfailure

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(pl => nbody_system%pl)
      class is (swiftest_pl)
      select type(param)
      class is (swiftest_parameters)
         associate(impactors => self%impactors, status => self%status, maxid => nbody_system%maxid)
            ! Set the coordinate system of the impactors
            call impactors%set_coordinate_system()
            select case (impactors%regime) 
            case (COLLRESOLVE_REGIME_HIT_AND_RUN)
               call self%hitandrun(nbody_system, param, t)
               return
            case (COLLRESOLVE_REGIME_MERGE, COLLRESOLVE_REGIME_GRAZE_AND_MERGE)
               call self%merge(nbody_system, param, t) ! Use the default collision model, which is merge
               return
            case(COLLRESOLVE_REGIME_DISRUPTION)
               message = "Disruption between"
            case(COLLRESOLVE_REGIME_SUPERCATASTROPHIC)
               message = "Supercatastrophic disruption between"
            case default 
               write(*,*) "Error in swiftest_collision, unrecognized collision regime"
               call base_util_exit(FAILURE,param%display_unit)
            end select
            call collision_io_collider_message(pl, impactors%id, message)
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, trim(adjustl(message)))
            call self%set_mass_dist(param) 
            call self%disrupt(nbody_system, param, t, lfailure)
            if (lfailure) then
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, & 
                                          "Fraggle failed to find a solution to match energy constraint. Treating this as a merge.")
               call self%merge(nbody_system, param, t) ! Use the default collision model, which is merge
               return
            end if

            associate (fragments => self%fragments)
               nfrag = fragments%nbody
               select case(impactors%regime)
               case(COLLRESOLVE_REGIME_DISRUPTION)
                  status = DISRUPTED
                  ibiggest = impactors%id(maxloc(pl%Gmass(impactors%id(:)), dim=1))
                  fragments%id(1) = pl%id(ibiggest)
                  fragments%id(2:nfrag) = [(i, i = maxid + 1, maxid + nfrag - 1)]
                  maxid = fragments%id(nfrag)
               case(COLLRESOLVE_REGIME_SUPERCATASTROPHIC)
                  status = SUPERCATASTROPHIC
                  fragments%id(1:nfrag) = [(i, i = maxid + 1, maxid + nfrag)]
                  maxid = fragments%id(nfrag)
               end select

               call collision_resolve_mergeaddsub(nbody_system, param, t, status)
 
            end associate
         end associate
      end select
      end select
      end select
      return
   end subroutine fraggle_generate


   module subroutine fraggle_generate_disrupt(self, nbody_system, param, t, lfailure)
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Generates a nbody_system of fragments in barycentric coordinates that conserves energy and momentum.
      use, intrinsic :: ieee_exceptions
      implicit none
      ! Arguments
      class(collision_fraggle), intent(inout) :: self         
         !! Fraggle system object the outputs will be the fragmentation 
      class(base_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            
         !! Time of collision 
      logical,                  intent(out)   :: lfailure     
         !! Answers the question: Should this have been a merger instead?
       ! Internals
      logical                              :: lk_plpl
      logical, dimension(size(IEEE_ALL))   :: fpe_halting_modes, fpe_quiet_modes
      real(DP)                             :: dE
      real(DP), dimension(NDIM)            :: dL
      character(len=STRMAX)                :: message
      real(DP), parameter                  :: fail_scale_initial = 1.0003_DP
      integer(I4B)                         :: nfrag_start

      ! The minimization and linear solvers can sometimes lead to floating point exceptions. Rather than halting the code entirely 
      ! if this occurs, we can simply fail the attempt and try again. So we need to turn off any floating point exception halting 
      ! modes temporarily 
      call ieee_get_halting_mode(IEEE_ALL,fpe_halting_modes)  ! Save the current halting modes so we can turn them off temporarily
      fpe_quiet_modes(:) = .false.
      call ieee_set_halting_mode(IEEE_ALL,fpe_quiet_modes)

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(param)
      class is (swiftest_parameters)
      associate(impactors => self%impactors, pl => nbody_system%pl)

         nfrag_start = self%fragments%nbody
         write(message,*) nfrag_start
         call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Fraggle generating " // trim(adjustl(message)) // " fragments.")

         if (param%lflatten_interactions) then
            lk_plpl = allocated(pl%k_plpl)
            if (lk_plpl) deallocate(pl%k_plpl)
         else 
            lk_plpl = .false.
         end if
         call ieee_set_flag(ieee_all, .false.) ! Set all fpe flags to quiet

         call self%set_natural_scale()
         lfailure = .false.
         call self%get_energy_and_momentum(nbody_system, param, phase="before")
         self%fail_scale = fail_scale_initial
         call fraggle_generate_pos_vec(self, nbody_system, param, lfailure)
         if (.not.lfailure) then
            call fraggle_generate_rot_vec(self, nbody_system, param)
            call fraggle_generate_vel_vec(self, nbody_system, param, lfailure)
         end if

         if (.not.lfailure) then
            if (self%fragments%nbody /= nfrag_start) then
               write(message,*) self%fragments%nbody
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Fraggle found a solution with " // trim(adjustl(message)) &
                                                                // " fragments" )
            end if
            call self%get_energy_and_momentum(nbody_system, param, phase="after")

            dL = self%L_total(:,2)- self%L_total(:,1)
            dE = self%te(2) - self%te(1) 

            call swiftest_io_log_one_message(COLLISION_LOG_OUT, "All quantities in collision system natural units")
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, & 
                                             "*   Conversion factors (collision system units / nbody system units):")
            write(message,*) "*       Mass: ", self%mscale
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "*   Distance: ", self%dscale
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "*       Time: ", self%tscale
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "*   Velocity: ", self%vscale
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "*     Energy: ",self%Escale
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "*   Momentum: ", self%Lscale
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)

            call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Energy constraint")
            write(message,*) "Expected: Qloss = ", -impactors%Qloss
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "Actual  :    dE = ",dE
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
            write(message,*) "Actual  :    dL = ",dL
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)

         end if
         call self%set_original_scale()
         self%max_rot = MAX_ROT_SI * param%TU2S ! Re-compute the rotation limit from scratch so it doesn't drift due to floating 
                                                ! point errors every time we convert

         ! Restore the big array
         if (lk_plpl) call pl%flatten(param)
      end associate
      end select
      end select
      call ieee_set_halting_mode(IEEE_ALL,fpe_halting_modes)  ! Restore the original halting modes

      return 
   end subroutine fraggle_generate_disrupt


   module subroutine fraggle_generate_hitandrun(self, nbody_system, param, t) 
      !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Create the fragments resulting from a non-catastrophic hit-and-run collision
      implicit none
      ! Arguments
      class(collision_fraggle), intent(inout) :: self         
         !! Collision system object
      class(base_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            
         !! Time of collision
      ! Result
      integer(I4B)                            :: status       
         !! Status flag assigned to this outcome
      ! Internals
      integer(I4B)                            :: i, ibiggest, jtarg, jproj
      logical                                 :: lpure 
      character(len=STRMAX) :: message

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(pl => nbody_system%pl)
      class is (swiftest_pl)
      select type(param)
      class is (swiftest_parameters)
         associate(impactors => self%impactors, maxid => nbody_system%maxid)
            call collision_io_collider_message(nbody_system%pl, impactors%id, message)
            if (impactors%mass(1) > impactors%mass(2)) then
               jtarg = 1
               jproj = 2
            else
               jtarg = 2
               jproj = 1
            end if

            ! The Fraggle disruption model (and its extended types allow for non-pure hit and run. 
            if (impactors%mass_dist(2) > 0.9_DP * impactors%mass(jproj)) then ! Pure hit and run, so we'll just keep the two bodies 
                                                                              ! untouched
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Pure hit and run. No new fragments generated.")
               call self%collision_basic%hitandrun(nbody_system, param, t)
               return
            end if
            call self%set_mass_dist(param)
            message = "Hit and run between"
            call collision_io_collider_message(nbody_system%pl, impactors%id, message)
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, trim(adjustl(message)))
            if (self%fragments%nbody > 2) then ! Hit and run with disruption
               call self%disrupt(nbody_system, param, t, lpure)
            else
               lpure = .true.
            end if
            if (lpure) then ! Disruption failed to find a solution. Convert to pure hit and run
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Pure hit and run. No new fragments generated.")
               call self%collision_basic%hitandrun(nbody_system, param, t)
               return
            end if

            nfrag = self%fragments%nbody

            write(message, *) nfrag
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Generating " // trim(adjustl(message)) // " fragments")

            ibiggest = impactors%id(maxloc(pl%Gmass(impactors%id(:)), dim=1))
            self%fragments%id(1) = pl%id(ibiggest)
            self%fragments%id(2:nfrag) = [(i, i = maxid + 1, maxid + nfrag - 1)]
            maxid = self%fragments%id(nfrag)
            status = HIT_AND_RUN_DISRUPT
            call collision_resolve_mergeaddsub(nbody_system, param, t, status)
         end associate
      end select
      end select
      end select

      return
   end subroutine fraggle_generate_hitandrun


   module subroutine fraggle_generate_merge(self, nbody_system, param, t)
      !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Merge massive bodies in any collisional system. If the rotation is too high, switch to hit and run.
      !! 
      !! Adapted from David E. Kaufmann's Swifter routines symba_merge_pl.f90 and symba_discard_merge_pl.f90
      !!
      !! Adapted from Hal Levison's Swift routines symba5_merge.f and discard_mass_merge.f
      implicit none
      class(collision_fraggle), intent(inout) :: self         
         !! Fraggle system object
      class(base_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      real(DP),                 intent(in)    :: t            
         !! The time of the collision

      ! Internals
      integer(I4B)                              :: i
      real(DP), dimension(NDIM)                 :: L_rot_new, Ip, rot
      real(DP)                                  :: rotmag, mass, volume, radius

      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(impactors => self%impactors)
            mass = sum(impactors%mass(:))
            volume = 4._DP / 3._DP * PI * sum(impactors%radius(:)**3)
            radius = (3._DP * volume / (4._DP * PI))**(THIRD)
#ifdef DOCONLOC
            do concurrent(i = 1:NDIM) shared(impactors, Ip, L_rot_new)
#else
            do concurrent(i = 1:NDIM)
#endif
               Ip(i) = sum(impactors%mass(:) * impactors%Ip(i,:)) 
               L_rot_new(i) = sum(impactors%L_orbit(i,:) + impactors%L_rot(i,:))
            end do
            Ip(:) = Ip(:) / mass
            rot(:) = L_rot_new(:) / (Ip(3) * mass * radius**2)
            rotmag = .mag.rot(:)
            if (rotmag < self%max_rot) then
               call self%collision_basic%merge(nbody_system, param, t)
            else
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                "Merger would break the rotation barrier. Converting to pure hit and run" )
               impactors%mass_dist(1:2) = impactors%mass(1:2)
               call self%hitandrun(nbody_system, param, t)
            end if

         end associate
      end select
      return 
   end subroutine fraggle_generate_merge


   module subroutine fraggle_generate_pos_vec(collider, nbody_system, param, lfailure)
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Initializes the position vectors of the fragments around the center of mass based on the collision style.
      !! For hit and run with disruption, the fragments are generated in a random cloud around the smallest of the two colliders 
      !! (body 2). For disruptive collisions, the fragments are generated in a random cloud around the impact point. Bodies are 
      !! checked for overlap and regenerated if they overlap.
      implicit none
      ! Arguments
      class(collision_fraggle),     intent(inout) :: collider     
         !! Fraggle collision system object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      logical,                      intent(out)   :: lfailure     
         !! Did the velocity computation fail?
      ! Internals
      real(DP)  :: dis, direction, rdistance, bias_factor, rmag
      real(DP), dimension(NDIM,2) :: fragment_cloud_center
      real(DP), dimension(NDIM) :: rwalk, orthogonal_vector
      real(DP), dimension(2) :: fragment_cloud_radius
      logical, dimension(collider%fragments%nbody) :: loverlap
      real(DP), dimension(collider%fragments%nbody) :: mass_rscale, phi, theta, u
      integer(I4B) :: i, j, loop, istart, nfrag, npl, ntp
      logical :: lsupercat, lhitandrun
      integer(I4B), parameter :: MAXLOOP = 10000
      real(DP), parameter :: rbuffer = 1.01_DP ! Body radii are inflated by this scale factor to prevent secondary collisions 
      real(DP), parameter :: pack_density = 0.5236_DP ! packing density of loose spheres

      associate(fragments => collider%fragments, impactors => collider%impactors, pl => nbody_system%pl, tp => nbody_system%tp)
         nfrag = collider%fragments%nbody
         npl = nbody_system%pl%nbody
         ntp = nbody_system%tp%nbody
         lsupercat = (impactors%regime == COLLRESOLVE_REGIME_SUPERCATASTROPHIC) 
         lhitandrun = (impactors%regime == COLLRESOLVE_REGIME_HIT_AND_RUN) 

         ! We will treat the first two fragments of the list as special cases. 
         ! Place the first two bodies at the centers of the two fragment clouds, but be sure they are sufficiently far apart to 
         ! avoid overlap
         if (lhitandrun) then
            rdistance = impactors%radius(2)
            istart = 2
         else if (lsupercat) then
            rdistance = 0.5_DP * sum(impactors%radius(:))
            istart = 3
         else
            rdistance = impactors%radius(2)
            istart = 3
         end if

         mass_rscale(1:istart-1) = 1.0_DP
         ! Give the fragment positions a random value that is scaled with fragment mass so that the more massive bodies tend to be 
         ! closer to the impact point. Later, velocities will be scaled such that the farther away a fragment is placed from the 
         ! impact point, the higher will its velocity be.
         call random_number(mass_rscale(istart:nfrag))
         mass_rscale(istart:nfrag) = (mass_rscale(istart:nfrag) + 1.0_DP) / 2
         ! The power of 0.125 in the scaling below is arbitrary. It just gives the velocity a small mass dependence
         mass_rscale(istart:nfrag) = mass_rscale(istart:nfrag) * (sum(fragments%mass(istart:nfrag)) &
                                                                    / fragments%mass(istart:nfrag))**(0.125_DP) 
         mass_rscale(istart:nfrag) = mass_rscale(istart:nfrag) / minval(mass_rscale(istart:nfrag))

         loverlap(:) = .true.
         do loop = 1, MAXLOOP
            if (.not.any(loverlap(:))) exit
            if (lhitandrun) then  ! Keep the target unchanged and set the 2nd fragment cloud to be centered on the projectile 
               fragment_cloud_radius(1) = rbuffer * max(fragments%radius(1), impactors%radius(1)) 
               fragment_cloud_radius(2) = rbuffer * max(fragments%radius(2), impactors%radius(2)) / pack_density
               fragment_cloud_center(:,1) = impactors%rc(:,1)
               fragment_cloud_center(:,2) = impactors%rc(:,2) 
               fragments%rc(:,1) = fragment_cloud_center(:,1)
            else ! Keep the first and second bodies at approximately their original location, but so as not to be overlapping
               fragment_cloud_center(:,1) = impactors%rcimp(:) - rbuffer * max(fragments%radius(1),& 
                                                                               impactors%radius(1)) * impactors%y_unit(:)
               fragment_cloud_center(:,2) = impactors%rcimp(:) + rbuffer * max(fragments%radius(2), & 
                                                                               impactors%radius(2)) * impactors%y_unit(:)
               fragment_cloud_radius(:) = rdistance / pack_density
               fragments%rc(:,1:2) = fragment_cloud_center(:,1:2)
            end if

            do i = 1, nfrag
               if (loverlap(i)) then
                  call random_number(phi(i))
                  call random_number(theta(i))
                  call random_number(u(i))
                  phi(i) = TWOPI * phi(i)
                  theta(i) = PI * theta(i) 
               end if
            end do

            ! Compute random angles and radial distance for fragment positioning
            do i = istart, nfrag
               if (.not.loverlap(i)) cycle
               j = fragments%origin_body(i)

               rmag = fragment_cloud_radius(j) * mass_rscale(i) * u(i)**(THIRD)

               if (.not.lhitandrun) then
                  orthogonal_vector(1) = sin(theta(i)) * cos(phi(i))
                  orthogonal_vector(2) = sin(theta(i)) * sin(phi(i))
                  orthogonal_vector(3) = cos(theta(i))

                  ! Rotate the orthogonal vector to be perpendicular to the bounce unit
                  orthogonal_vector = orthogonal_vector - dot_product(orthogonal_vector, impactors%bounce_unit(:)) * &
                                        impactors%bounce_unit(:)
                  orthogonal_vector = orthogonal_vector / .mag.(orthogonal_vector)  ! Normalize it

                  ! Calculate the final position by mixing the bounce direction and random orthogonal component
                  bias_factor = mass_rscale(i)**(-2)  ! Bias factor: 0 means random, 1 means fully along bounce_unit
                  fragments%rc(:,i) = rmag * (bias_factor * impactors%bounce_unit(:) + &
                                      (1.0_DP - bias_factor) * orthogonal_vector)
               else
                  fragments%rc(1,i) = rmag * sin(theta(i)) * cos(phi(i))
                  fragments%rc(2,i) = rmag * sin(theta(i)) * sin(phi(i))
                  fragments%rc(3,i) = rmag * cos(theta(i))
               end if

               ! Adjust based on collision type
               if (lhitandrun) then
                  ! Stretch out the hit and run cloud along the flight trajectory
                  fragments%rc(:,i) = fragments%rc(:,i) * (1.0_DP + 2 * fragment_cloud_radius(j) * mass_rscale(i) &
                                                            * impactors%bounce_unit(:))
               end if
               fragments%rc(:,i) = fragments%rc(:,i) + fragment_cloud_center(:,j)

               if (lhitandrun) then
                  ! Shift the stretched cloud downrange
                  fragments%rc(:,i) = fragments%rc(:,i) + 2 * fragment_cloud_radius(j) * mass_rscale(i) * impactors%bounce_unit(:) 
               else
                  ! Make sure that the fragments are positioned away from the impact point
                  direction = dot_product(fragments%rc(:,i) - impactors%rcimp(:), fragment_cloud_center(:,j) - impactors%rcimp(:))
                  if (direction < 0.0_DP) then
                     fragments%rc(:,i) = fragments%rc(:,i) - fragment_cloud_center(:,j)
                     fragments%rc(:,i) = -fragments%rc(:,i) + fragment_cloud_center(:,j)
                  end if
               end if
            end do
            fragments%rmag(:) = .mag.fragments%rc(:,:)

            ! Because body 1 and 2 are initialized near the original impactor positions, then if these bodies are still overlapping
            ! when the rest are not, we will randomly walk their position in space so as not to move them too far from their 
            ! starting  position
            if (all(.not.loverlap(istart:nfrag)) .and. any(loverlap(1:istart-1))) then
               do j = 1, MAXLOOP
#ifdef DOCONLOC
                  do concurrent(i = 1:istart-1,loverlap(i)) shared(fragments,loverlap, u, theta, i) local(rwalk, dis)
#else
                  do concurrent(i = 1:istart-1,loverlap(i))
#endif
                     dis = 0.1_DP * fragments%radius(i) * u(i)**(THIRD)
                     rwalk(1) = dis * sin(theta(i)) * cos(phi(i))
                     rwalk(2) = dis * sin(theta(i)) * sin(phi(i))
                     rwalk(3) = dis * cos(theta(i)) 
                     fragments%rc(:,i) = fragments%rc(:,i) + rwalk(:)
                  end do
                  if (all(.not.loverlap(1:istart-1))) exit
               end do
            end if

            fragments%rmag(:) = .mag. fragments%rc(:,:)

            ! Check for any overlapping bodies.
            do j = nfrag, 1, -1
               if (.not.loverlap(j)) cycle
               loverlap(j) = .false.
               ! Check for overlaps between fragments
               do i = 1,nfrag
                  if (i == j) cycle
                  dis = .mag.(fragments%rc(:,j) - fragments%rc(:,i))
                  loverlap(j) = (dis <= rbuffer * (fragments%radius(i) + fragments%radius(j)))
                  if (loverlap(j)) exit
               end do
               if (loverlap(j)) cycle
               do i = 1, npl
                  if (any(impactors%id(:) == i)) cycle
                  dis = .mag. (fragments%rc(:,j) - (pl%rb(:,i) / collider%dscale - impactors%rbcom(:)))
                  loverlap(j) = loverlap(j) .or. (dis <= rbuffer * (pl%radius(i) / collider%dscale + fragments%radius(j))) 
               end do
            end do
            rdistance = rdistance * collider%fail_scale
         end do

         lfailure = any(loverlap(:))

         call collision_util_shift_vector_to_origin(fragments%mass, fragments%rc)
         call collider%set_coordinate_system()

         do concurrent(i = 1:nfrag)
            fragments%rb(:,i) = fragments%rc(:,i) + impactors%rbcom(:)
         end do

      end associate

      return
   end subroutine fraggle_generate_pos_vec


   module subroutine fraggle_generate_rot_vec(collider, nbody_system, param)
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Computes an initial "guess" for the rotation states of fragments based on angular momentum and energy constraints.
      !! These will be adjusted later when the final fragment velocities are computed in fraggle_generate_vel_vec
      implicit none
      ! Arguments
      class(collision_fraggle),     intent(inout) :: collider     
         !! Fraggle collision system object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      ! Internals
      integer(I4B) :: i
      real(DP), parameter :: FRAG_ROT_FAC = 0.1_DP ! Fraction of projectile rotation magnitude to add as random noise to fragment 
                                                   ! rotation
      real(DP), parameter :: hitandrun_momentum_transfer = 0.01_DP ! Fraction of projectile momentum transfered to target in a hit  
                                                                   ! and run
      real(DP) :: mass_fac
      real(DP), dimension(NDIM) :: drot, dL
      integer(I4B), parameter :: MAXLOOP = 10
      logical :: lhitandrun

      associate(fragments => collider%fragments, impactors => collider%impactors)
         nfrag = collider%fragments%nbody
         lhitandrun = (impactors%regime == COLLRESOLVE_REGIME_HIT_AND_RUN) 

         ! Initialize fragment rotations and velocities to be pre-impact rotation for body 1, and randomized for bodies >1 and 
         ! scaled to the original rotation.  This will get updated later when conserving angular momentum
         mass_fac = fragments%mass(1) / impactors%mass(1)

         ! Estimate the angular momentum transfer to the target from the impactor 
         dL(:) = impactors%mass(2) * (impactors%rc(:,2) - impactors%rc(:,1)) .cross. (impactors%vc(:,2) - impactors%vc(:,1))

         if (lhitandrun) then
            dL(:) = dL(:) * hitandrun_momentum_transfer
         end if
   
         ! Estimate the change in rotation (impulsive torque approximation)
         drot(:) = dL(:) / (fragments%mass(1) * fragments%radius(1)**2 * fragments%Ip(3,1))
   
         ! Ensure the resulting rotation doesn't exceed the allowed maximum rotation
         do i = 1, MAXLOOP
            if (.mag.(fragments%rot(:,1) + drot(:)) < collider%max_rot) exit
            if (i == MAXLOOP) drot(:) = 0.0_DP
            where(abs(drot(:)) > TINY(1.0_DP))
               drot(:) = drot(:) / 2
            elsewhere
               drot(:) = 0.0_DP
            endwhere
         end do
   
         ! Update rotation for body 1 based on impulse
         fragments%rot(:,1) =impactors%rot(:,1) + drot(:)

         call random_number(fragments%rot(:,2:nfrag))
#ifdef DOCONLOC
         do concurrent (i = 2:nfrag) shared(fragments,impactors,drot) local(mass_fac)
#else
         do concurrent (i = 2:nfrag)
#endif
            mass_fac = fragments%mass(i) / impactors%mass(2)
            fragments%rot(:,i) = mass_fac**(5.0_DP/3.0_DP) * impactors%rot(:,2) +  (2 * fragments%rot(:,i) - 1.0_DP) * &
                                 FRAG_ROT_FAC * (.mag.(impactors%rot(:,2) - drot(:)))
         end do
         fragments%rotmag(:) = .mag.fragments%rot(:,:)

      end associate

      return
   end subroutine fraggle_generate_rot_vec


   module subroutine fraggle_generate_vel_vec(collider, nbody_system, param, lfailure)
      !! Author:  David A. Minton
      !!
      !! Generates an initial velocity distribution. For disruptions, the velocity magnitude is set to be
      !! 2x the escape velocity of the colliding pair. For hit and runs the velocity magnitude is set to be
      !! 2x the escape velocity of the smallest of the two bodies.
      implicit none
      ! Arguments
      class(collision_fraggle),     intent(inout) :: collider     
         !! Fraggle collision system object
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param        
         !! Current run configuration parameters 
      logical,                      intent(out)   :: lfailure     
         !! Did the velocity computation fail?
      ! Internals
      real(DP), parameter :: ENERGY_SUCCESS_METRIC = 2.0_DP !! Relative energy error to accept as a success (success also must be 
                                                            !! energy-losing in addition to being within the metric amount)
      real(DP), parameter :: ENERGY_CONVERGENCE_TOL = 1e-3_DP !! Relative change in error before giving up on energy convergence
      real(DP)  :: MOMENTUM_SUCCESS_METRIC = 1e-6_DP !! Relative angular momentum error to accept as a success 
                                                                !! (should be *much* stricter than energy)
      integer(I4B) :: i, j, loop, try, istart, nfrag, nsteps, nsteps_best, posloop
      logical :: lhitandrun, lsupercat
      real(DP), dimension(NDIM) :: vimp_unit, rimp, vrot, vdisp, L_residual, L_residual_unit, L_residual_best, dL, drot, rot_new 
      real(DP), dimension(NDIM) :: dL_metric
      real(DP) :: vimp, vmag, vesc, dE, E_residual, E_residual_best, E_residual_last, ke_avail, ke_remove, dE_best, fscale 
      real(DP) :: dE_metric, mfrag, rn, dL1_mag, dE_conv, vumag, L_mag_factor
      integer(I4B), dimension(:), allocatable :: vsign
      real(DP), dimension(:), allocatable :: vscale
      real(DP), dimension(:), allocatable :: dLi_mag
      ! For the initial "guess" of fragment velocities, this is the minimum and maximum velocity relative to escape velocity that 
      ! the fragments will have
      real(DP), parameter     :: hitandrun_vscale = 0.25_DP 
      real(DP)                :: vmin_guess 
      real(DP)                :: vmax_guess 
      integer(I4B), parameter :: MAXLOOP = 50
      integer(I4B), parameter :: MAXTRY  = 50
      integer(I4B), parameter :: MAXANGMTM = 1000
      class(collision_fraggle), allocatable :: collider_local
      character(len=STRMAX) :: message

      associate(impactors => collider%impactors)
         nfrag = collider%fragments%nbody
         lhitandrun = (impactors%regime == COLLRESOLVE_REGIME_HIT_AND_RUN) 
         lsupercat = (impactors%regime == COLLRESOLVE_REGIME_SUPERCATASTROPHIC) 

         allocate(collider_local, source=collider)
         ! Hit and run collisions should only affect the runners, not the target
         if (lhitandrun) then
            istart = 2
         else 
            istart = 1
         end if

         ! The minimum fragment velocity will be set by the escape velocity
         vimp = .mag. (impactors%vc(:,2) - impactors%vc(:,1))

         E_residual_best = huge(1.0_DP)
         L_residual_best(:) = 0.0_DP
         lfailure = .false.
         dE_metric = huge(1.0_DP)
         dE_best = huge(1.0_DP)
         nsteps_best = 0
         nsteps = 0
         outer: do try = 1, min(nfrag - istart - 1, MAXTRY)
            associate(fragments => collider_local%fragments)
               if (allocated(vsign)) deallocate(vsign); allocate(vsign(fragments%nbody))
               if (allocated(vscale)) deallocate(vscale); allocate(vscale(fragments%nbody))
               if (allocated(dLi_mag)) deallocate(dLi_mag); allocate(dLi_mag(fragments%nbody))

               if (lhitandrun) then
                  vesc = sqrt(2 * sum(fragments%Gmass(istart:fragments%nbody)) / impactors%radius(2))
                  vmin_guess = .mag.impactors%vc(:,2) * (1.0_DP - hitandrun_vscale)
                  vmax_guess = .mag.impactors%vc(:,2) * (1.0_DP + hitandrun_vscale)
               else
                  vesc = sqrt(2 * sum(impactors%Gmass(:)) / sum(impactors%radius(:)))
                  vmin_guess = 1.001_DP * vesc
                  vmax_guess = vimp
               end if

               ! The fragments will be divided into two "clouds" based on identified origin body. 
               ! These clouds will collectively travel like two impactors bouncing off of each other. 
               where(fragments%origin_body(:) == 1)
                  vsign(:) = -1
               elsewhere
                  vsign(:) = 1
               end where

               ! Scale the magnitude of the velocity by the distance from the origin body.
               ! This will reduce the chances of fragments colliding with each other immediately, and is more physically correct  
#ifdef DOCONLOC
               do concurrent(i = 1:fragments%nbody) shared(fragments,impactors,vscale) local(rimp,j)
#else
               do concurrent(i = 1:fragments%nbody) 
#endif
                  j = fragments%origin_body(i)
                  rimp(:) = fragments%rc(:,i) - impactors%rc(:,j)
                  vscale(i) = .mag. rimp(:) / sum(impactors%radius(1:2))
               end do

               vscale(:) = vscale(:) / minval(vscale(:))
               fscale = log(vmax_guess - vmin_guess + 1.0_DP) / log(maxval(vscale(:)))
               vscale(:) = vscale(:)**fscale + vmin_guess - 1.0_DP

               ! Set the velocities of all fragments using all of the scale factors determined above
               if (istart > 1) fragments%vc(:,1) = impactors%vc(:,1) * impactors%mass(1) / fragments%mass(1)
#ifdef DOCONLOC
               do concurrent(i = istart:fragments%nbody) shared(fragments,impactors,lhitandrun, vscale, vesc, vsign) & 
                                                         local(j,vrot,vmag,vdisp,rimp,vimp_unit, vumag)
#else
               do concurrent(i = istart:fragments%nbody)
#endif
                  j = fragments%origin_body(i)
                  vrot(1) = impactors%rot(2,j) * (fragments%rc(3,i) - impactors%rc(3,j)) &
                          - impactors%rot(3,j) * (fragments%rc(2,i) - impactors%rc(2,j))
                  vrot(2) = impactors%rot(3,j) * (fragments%rc(1,i) - impactors%rc(1,j)) &
                          - impactors%rot(1,j) * (fragments%rc(3,i) - impactors%rc(3,j))
                  vrot(3) = impactors%rot(1,j) * (fragments%rc(2,i) - impactors%rc(2,j)) &
                          - impactors%rot(2,j) * (fragments%rc(1,i) - impactors%rc(1,j))
                  if (lhitandrun) then
                     vumag = norm2(fragments%rc(:,i) - impactors%rc(:,2)) 
                     vdisp(:) = (fragments%rc(:,i) - impactors%rc(:,2)) / vumag * vesc
                     fragments%vc(:,i) = vsign(i) * impactors%bounce_unit(:) * vscale(i) + vrot(:) + vdisp(:)
                  else
                     vmag = vscale(i) 
                     rimp(:) = fragments%rc(:,i) - impactors%rcimp(:)
                     vumag = norm2(rimp(:) + vsign(i) * impactors%bounce_unit(:))
                     vimp_unit(:) = (rimp(:) + vsign(i) * impactors%bounce_unit(:)) / vumag
                     fragments%vc(:,i) = vmag * vimp_unit(:) + vrot(:) 
                  end if
               end do
               fragments%vmag(:) = .mag. fragments%vc(:,:)

               ! Every time the collision-frame velocities are altered, we need to be sure to shift everything back to the 
               ! center-of-mass frame
               call collision_util_shift_vector_to_origin(fragments%mass, fragments%vc)            
               call fragments%set_coordinate_system()

               E_residual = huge(1.0_DP)
               inner: do loop = 1, MAXLOOP
                  nsteps = nsteps + 1
                  mfrag = sum(fragments%mass(istart:fragments%nbody))

                  ! Try to put residual angular momentum into the rotation, but if this would go past the rotation barrier, then put
                  ! it into velocity shear instead 
                  call collider_local%get_energy_and_momentum(nbody_system, param, phase="after")
                  L_mag_factor = .mag.(collider_local%L_total(:,1) + collider_local%L_total(:,2))
                  L_residual(:) = (collider_local%L_total(:,2) / L_mag_factor - collider_local%L_total(:,1) / L_mag_factor)
                  L_residual_unit(:) = .unit. L_residual(:)
                  if (nsteps == 1) L_residual_best(:) = L_residual(:) * L_mag_factor

                  angmtm: do j = 1, MAXANGMTM
                     if (j == MAXANGMTM) exit inner

                     ! First try to put residual momentum into the velocity distribution of the fragments
                     do i = istart,fragments%nbody
                        ! Compute the current residual angular momentum and check if the metric has been met yet
                        call collider_local%get_energy_and_momentum(nbody_system, param, phase="after")
                        L_mag_factor = .mag.(collider_local%L_total(:,1) + collider_local%L_total(:,2))
                        L_residual(:) = (collider_local%L_total(:,2) / L_mag_factor - collider_local%L_total(:,1)/L_mag_factor)
                        dL_metric(:) = abs(L_residual(:)) / MOMENTUM_SUCCESS_METRIC
                        if (all(dL_metric(:) <= 1.0_DP)) exit angmtm

                        dL(:) = -L_residual(:) * L_mag_factor  
                        call collision_util_velocity_torque(dL, fragments%mass(i), fragments%rc(:,i), fragments%vc(:,i))
                        call collision_util_shift_vector_to_origin(fragments%mass, fragments%vc)  
                        fragments%vmag(:) = .mag.fragments%vc(:,:)

                        ! Now try to put residual momentum into the rotation of the fragments
                        call collider_local%get_energy_and_momentum(nbody_system, param, phase="after")
                        L_mag_factor = .mag.(collider_local%L_total(:,1) + collider_local%L_total(:,2))
                        L_residual(:) = (collider_local%L_total(:,2) / L_mag_factor - collider_local%L_total(:,1)/L_mag_factor)
                        dL_metric(:) = abs(L_residual(:)) / MOMENTUM_SUCCESS_METRIC
                        if (all(dL_metric(:) <= 1.0_DP)) exit angmtm

                        if (i == istart) then
                           dL(:) = -L_residual(:) * L_mag_factor
                        else
                           dL(:) = -L_residual(:) * L_mag_factor * fragments%mass(i) / sum(fragments%mass(istart+1:fragments%nbody))
                        end if
                        drot(:) = dL(:) / (fragments%mass(i) * fragments%Ip(3,i) * fragments%radius(i)**2)

                        ! Ensure rotation adjustment doesn't exceed allowed limit
                        if (.mag.(fragments%rot(:,i) + drot(:)) <= collider%max_rot) then
                           fragments%rot(:,i) = fragments%rot(:,i) + drot(:)
                        else if (i > istart) then
                           fragments%rotmag(i) = 0.5_DP * collider%max_rot
                           fragments%rot(:,i) = fragments%rotmag(i) * .unit. fragments%rot(:,i)
                        end if  
                        
                        fragments%rotmag(i) = .mag.fragments%rot(:,i)
                     end do
                  end do angmtm

                  call collision_util_shift_vector_to_origin(fragments%mass, fragments%vc)            
                  call fragments%set_coordinate_system()
                  call collider_local%get_energy_and_momentum(nbody_system, param, phase="after")

                  dE = collider_local%te(2) - collider_local%te(1) 
                  E_residual_last = E_residual
                  E_residual = dE + impactors%Qloss

                  L_mag_factor = .mag.(collider_local%L_total(:,1) + collider_local%L_total(:,2))
                  L_residual(:) = (collider_local%L_total(:,2) / L_mag_factor - collider_local%L_total(:,1) / L_mag_factor)
                  dL_metric(:) = abs(L_residual(:)) / MOMENTUM_SUCCESS_METRIC
                  dE_conv = abs(E_residual - E_residual_last) / abs(E_residual_last) 

                  ! Check if we've converged on our constraints
                  if (all(dL_metric(:) <= 1.0_DP)) then
                     if ((abs(E_residual) < abs(E_residual_best)) .or. ((dE < 0.0_DP) .and. (dE_best >= 0.0_DP))) then 
                        ! This is our best case so far. Save it for posterity
                        E_residual_best = E_residual
                        L_residual_best(:) = L_residual(:) * L_mag_factor
                        dE_best = dE
                        nsteps_best = nsteps

                        if (allocated(collider%fragments)) deallocate(collider%fragments)
                        allocate(collider%fragments, source=fragments)
                        dE_metric = abs(E_residual) / impactors%Qloss
                     end if
                     if ((dE_best < 0.0_DP) .and. (dE_metric <= ENERGY_SUCCESS_METRIC)) exit outer 
                     if (dE_conv < ENERGY_CONVERGENCE_TOL) exit inner
                  end if

                  ! Remove a constant amount of velocity from the bodies so we don't shift the center of mass and screw up the 
                  ! momentum 
                  ke_avail = 0.0_DP
                  do i = fragments%nbody, 1, -1
                     ke_avail = ke_avail + 0.5_DP * fragments%mass(i) * max(fragments%vmag(i) - vesc / try,0.0_DP)**2
                  end do

                  ke_remove = min(E_residual, ke_avail)
                  fscale = sqrt((max(fragments%ke_orbit_tot - ke_remove, 0.0_DP))/fragments%ke_orbit_tot)
                  fragments%vc(:,:) = fscale * fragments%vc(:,:)
                  fragments%vmag(:) = .mag.fragments%vc(:,:)
                  fragments%rc(:,:) = 1.0_DP / fscale * fragments%rc(:,:)
                  fragments%rmag(:) = .mag.fragments%rc(:,:)

                  ! Update the unit vectors and magnitudes for the fragments based on their new orbits and rotations
                  call collision_util_shift_vector_to_origin(fragments%mass, fragments%vc)            
                  call fragments%set_coordinate_system()
               end do inner
            end associate

            do posloop = 1, MAXLOOP
               collider_local%fail_scale = collider%fail_scale * posloop
               call collider_local%restructure(nbody_system, param, lfailure)
               if (.not.lfailure) exit
            end do
            if (lfailure) exit outer
         end do outer
         dE_metric = abs(E_residual_best) / impactors%Qloss
         lfailure = lfailure .or. (dE_best > 0.0_DP) .or. (dE_metric > ENERGY_SUCCESS_METRIC)

         write(message, *) nsteps
         if (lfailure) then
            call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Fraggle velocity calculation failed to converge after " & 
                                                               // trim(adjustl(message)) // " steps. The best solution found had:")
         else 
            call swiftest_io_log_one_message(COLLISION_LOG_OUT,"Fraggle velocity calculation converged after " &
                                                              // trim(adjustl(message)) // " steps.")

            call collider%get_energy_and_momentum(nbody_system, param, phase="after")
            L_mag_factor = .mag.(collider%L_total(:,1) + collider%L_total(:,2))
            L_residual(:) = (collider%L_total(:,2) / L_mag_factor - collider%L_total(:,1)) / L_mag_factor
            call collision_util_velocity_torque(-L_residual(:) * L_mag_factor, collider%fragments%mtot, &
                                                impactors%rbcom, impactors%vbcom)
            nfrag = collider%fragments%nbody

#ifdef DOCONLOC
            do concurrent(i = 1:nfrag) shared(collider, impactors)
#else
            do concurrent(i = 1:nfrag)
#endif
               collider%fragments%vb(:,i) = collider%fragments%vc(:,i) + impactors%vbcom(:)
            end do

         end if
         write(message,*) "dL/|L0|  = ",(L_residual_best(:))/.mag.collider_local%L_total(:,1) 
         call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
         write(message,*) "dE/Qloss = ",-dE_best / impactors%Qloss
         call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
         write(message,*) nsteps_best
         call swiftest_io_log_one_message(COLLISION_LOG_OUT,"Best solution came after " // trim(adjustl(message)) // " steps.")

      end associate
      return
   end subroutine fraggle_generate_vel_vec


end submodule s_fraggle_generate

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(symba) s_symba_kick
   use swiftest
contains

   module subroutine symba_kick_getacch_int_pl(self, param)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations of massive bodies, with no mutual interactions between bodies
      !! below GMTINY
      !!
      !! Adapted from Hal Levison's Swift routine symba5_helio_getacch.f
      !! Adapted from David E. Kaufmann's Swifter routine helio_kick_getacch_int.f90
      implicit none
      ! Arguments
      class(symba_pl),            intent(inout) :: self  
         !! SyMBA massive body object
      class(swiftest_parameters), intent(inout) :: param 
         !! Current Swiftest run configuration parameter

      if (param%lflatten_interactions) then
         call swiftest_kick_getacch_int_all(self%nbody, self%nplplm, self%k_plpl, self%rh, self%Gmass, self%radius, self%ah)
      else
         call swiftest_kick_getacch_int_all(self%nbody, self%nplm, self%rh, self%Gmass, self%radius, self%ah)
      end if

      return
   end subroutine symba_kick_getacch_int_pl


   module subroutine symba_kick_getacch_pl(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute heliocentric accelerations of massive bodies
      !!
      !! Adapted from David E. Kaufmann's Swifter routine symba_kick_getacch.f90
      !! Adapted from Hal Levison's Swift routine symba5_kick_getacch.f
      implicit none
      ! Arguments
      class(symba_pl),              intent(inout) :: self   
         !! SyMBA massive body particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current simulation time
      logical,                      intent(in)    :: lbeg   
         !! Logical flag that determines whether or not this is the beginning or end of the step
      ! Internals
      integer(I8B)              :: nplplenc
      real(DP), dimension(NDIM,self%nbody) :: ah_enc
      integer(I4B), dimension(:,:), allocatable :: k_plpl_enc

      if (self%nbody == 0) return
      select type(nbody_system)
      class is (symba_nbody_system)
         associate(pl => self, npl => self%nbody, nplm => self%nplm, plpl_encounter => nbody_system%plpl_encounter, &
                   radius => self%radius)
            ! Apply kicks to all bodies (including those in the encounter list)
            call helio_kick_getacch_pl(pl, nbody_system, param, t, lbeg)
            if (plpl_encounter%nenc > 0) then 
               ! Remove kicks from bodies involved currently in the encounter list, as these are dealt with separately.
               ah_enc(:,:) = 0.0_DP
               nplplenc = int(plpl_encounter%nenc, kind=I8B)
               allocate(k_plpl_enc(2,nplplenc))
               k_plpl_enc(1,1:nplplenc) = plpl_encounter%index1(1:nplplenc)
               k_plpl_enc(2,1:nplplenc) = plpl_encounter%index2(1:nplplenc)
               call swiftest_kick_getacch_int_all(npl, nplplenc, k_plpl_enc, pl%rh, pl%Gmass, pl%radius, ah_enc)
               pl%ah(:,1:npl) = pl%ah(:,1:npl) - ah_enc(:,1:npl)
            end if

         end associate
      end select

      return
   end subroutine symba_kick_getacch_pl


   module subroutine symba_kick_getacch_tp(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute heliocentric accelerations of test particles
      !!
      !! Adapted from David E. Kaufmann's Swifter routine symba_kick_getacch_tp.f90
      !! Adapted from Hal Levison's Swift routine symba5_kick_getacch.f
      implicit none
      ! Arguments
      class(symba_tp),              intent(inout) :: self   
         !! SyMBA test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters 
      real(DP),                     intent(in)    :: t      
         !! Current time
      logical,                      intent(in)    :: lbeg   
         !! Logical flag that determines whether or not this is the beginning or end of the step
      ! Internals
      integer(I4B)              :: i, j
      integer(I8B)              :: k
      real(DP)                  :: rjj, fac
      real(DP), dimension(NDIM) :: dx

      if (self%nbody == 0) return
      select type(nbody_system)
      class is (symba_nbody_system)
         associate(tp => self, cb => nbody_system%cb, pl => nbody_system%pl, &
            pltp_encounter => nbody_system%pltp_encounter, npltpenc => nbody_system%pltp_encounter%nenc)
            call helio_kick_getacch_tp(tp, nbody_system, param, t, lbeg)
            ! Remove accelerations from encountering pairs
            do k = 1, npltpenc
               i = pltp_encounter%index1(k)
               j = pltp_encounter%index2(k)
               if (tp%lmask(j)) then
                  if (lbeg) then
                     dx(:) = tp%rh(:,j) - pl%rbeg(:,i)
                  else
                     dx(:) = tp%rh(:,j) - pl%rend(:,i)
                  end if
                  rjj = dot_product(dx(:), dx(:))
                  fac = pl%Gmass(i) / (rjj * sqrt(rjj))
                  tp%ah(:,j) = tp%ah(:,j) + fac * dx(:)
               end if
            end do
         end associate
      end select
      return
   end subroutine symba_kick_getacch_tp


   module subroutine symba_kick_list_plpl(self, nbody_system, dt, irec, sgn)
      !! author: David A. Minton
      !!
      !! Kick barycentric velocities of massive bodies within SyMBA recursion.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_kick.f90
      !! Adapted from Hal Levison's Swift routine symba5_kick.f
      implicit none
      ! Arguments
      class(symba_list_plpl),    intent(in)    :: self   
         !! SyMBA pl-tp encounter list object
      class(symba_nbody_system), intent(inout) :: nbody_system 
         !! SyMBA nbody system object
      real(DP),                  intent(in)    :: dt     
         !! step size
      integer(I4B),              intent(in)    :: irec   
         !! Current recursion level
      integer(I4B),              intent(in)    :: sgn    
         !! sign to be applied to acceleration
      ! Internals
      integer(I4B)              :: i, j, irm1, irecl, ngood
      integer(I8B)              :: k
      real(DP)                  :: r, rr, ri, ris, rim1, r2, ir3, fac, faci, facj
      real(DP), dimension(NDIM) :: dx
      logical, dimension(:), allocatable :: lgoodlevel
      integer(I8B), dimension(:), allocatable :: good_idx

      if (self%nenc == 0) return

      select type(pl => nbody_system%pl)
      class is (symba_pl)
         associate(npl => pl%nbody, nenc => self%nenc)
            if (npl == 0)  return
            pl%lmask(1:npl) = pl%status(1:npl) /= INACTIVE
            allocate(lgoodlevel(nenc))

            irm1 = irec - 1

            if (sgn < 0) then
               irecl = irec - 1
            else
               irecl = irec
            end if

            do k = 1, nenc
               i = self%index1(k)
               j = self%index2(k)
               lgoodlevel(k) = (pl%levelg(i) >= irm1) .and. (pl%levelg(j) >= irm1)
               lgoodlevel(k) = (self%status(k) == ACTIVE) .and. lgoodlevel(k)
            end do
            ngood = count(lgoodlevel(:))
            if (ngood > 0_I8B) then
               allocate(good_idx(ngood))
               good_idx(:) = pack([(k, k = 1_I8B, nenc)], lgoodlevel(:))

#ifdef DOCONLOC
               do concurrent (k = 1:ngood) shared(self,pl,good_idx) local(i,j)
#else
               do concurrent (k = 1:ngood)
#endif
                  i = self%index1(good_idx(k))
                  j = self%index2(good_idx(k))
                  pl%ah(:,i) = 0.0_DP
                  pl%ah(:,j) = 0.0_DP
               end do

               do k = 1, ngood
                  i = self%index1(good_idx(k))
                  j = self%index2(good_idx(k))
                  ri = ((pl%rhill(i)  + pl%rhill(j))**2) * (RHSCALE**2) * (RSHELL**(2*irecl))
                  rim1 = ri * (RSHELL**2)
                  dx(:) = pl%rh(:,j) - pl%rh(:,i)

                  r2 = dot_product(dx(:), dx(:))
                  if (r2 < rim1) then
                     fac = 0.0_DP
                     lgoodlevel(good_idx(k)) = .false.
                     cycle
                  end if
                  if (r2 < ri) then
                     ris = sqrt(ri)
                     r = sqrt(r2)
                     rr = (ris - r) / (ris * (1.0_DP - RSHELL))
                     fac = (r2**(-1.5_DP)) * (1.0_DP - 3 * (rr**2) + 2 * (rr**3))
                  else
                     ir3 = 1.0_DP / (r2 * sqrt(r2))
                     fac = ir3
                  end if
                  faci = fac * pl%Gmass(i)
                  facj = fac * pl%Gmass(j)
                  pl%ah(:, i) = pl%ah(:, i) + facj * dx(:)
                  pl%ah(:, j) = pl%ah(:, j) - faci * dx(:)
               end do
               ngood = count(lgoodlevel(:))
               if (ngood == 0_I8B) return
               good_idx(1:ngood) = pack([(k, k = 1_I8B, nenc)], lgoodlevel(:))

               do k = 1, ngood
                  i = self%index1(good_idx(k))
                  j = self%index2(good_idx(k))
                  pl%vb(:,i) = pl%vb(:,i) + sgn * dt * pl%ah(:,i)
                  pl%vb(:,j) = pl%vb(:,j) + sgn * dt * pl%ah(:,j)
                  pl%ah(:,i) = 0.0_DP
                  pl%ah(:,j) = 0.0_DP
               end do

            end if
         end associate
      end select
      
      return
   end subroutine symba_kick_list_plpl


   module subroutine symba_kick_list_pltp(self, nbody_system, dt, irec, sgn)
      !! author: David A. Minton
      !!
      !! Kick barycentric velocities of ACTIVE test particles within SyMBA recursion.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_kick.f90
      !! Adapted from Hal Levison's Swift routine symba5_kick.f
      implicit none
      ! Arguments
      class(symba_list_pltp),    intent(in)    :: self   
         !! SyMBA pl-tp encounter list object
      class(symba_nbody_system), intent(inout) :: nbody_system 
         !! SyMBA nbody system object
      real(DP),                  intent(in)    :: dt     
         !! step size
      integer(I4B),              intent(in)    :: irec   
         !! Current recursion level
      integer(I4B),              intent(in)    :: sgn    
         !! sign to be applied to acceleration
      ! Internals
      integer(I4B)              :: i, j, irm1, irecl, ngood
      integer(I8B)              :: k
      real(DP)                  :: r, rr, ri, ris, rim1, r2, ir3, fac, faci
      real(DP), dimension(NDIM) :: dx
      logical, dimension(:), allocatable :: lgoodlevel
      integer(I8B), dimension(:), allocatable :: good_idx

      if (self%nenc == 0) return

      select type(pl => nbody_system%pl)
      class is (symba_pl)
      select type(tp => nbody_system%tp)
      class is (symba_tp)
         associate(npl => pl%nbody, ntp => tp%nbody, nenc => self%nenc)
            if ((npl == 0) .or. (ntp == 0)) return
            pl%lmask(1:npl) = pl%status(1:npl) /= INACTIVE
            tp%lmask(1:ntp) = tp%status(1:ntp) /= INACTIVE
            allocate(lgoodlevel(nenc))

            irm1 = irec - 1

            if (sgn < 0) then
               irecl = irec - 1
            else
               irecl = irec
            end if

            do k = 1, nenc
               i = self%index1(k)
               j = self%index2(k)
               lgoodlevel(k) = (pl%levelg(i) >= irm1) .and. (tp%levelg(j) >= irm1)
               lgoodlevel(k) = (self%status(k) == ACTIVE) .and. lgoodlevel(k)
            end do

            ngood = count(lgoodlevel(:))

            if (ngood > 0_I8B) then
               allocate(good_idx(ngood))
               good_idx(:) = pack([(k, k = 1_I8B, nenc)], lgoodlevel(:))

#ifdef DOCONLOC
               do concurrent (k = 1_I8B:ngood) shared(self,tp,good_idx) local(j)
#else
               do concurrent (k = 1_I8B:ngood)
#endif
                  j = self%index2(good_idx(k))
                  tp%ah(:,j) = 0.0_DP
               end do

               do k = 1, ngood
                  i = self%index1(good_idx(k))
                  j = self%index2(good_idx(k))

                  ri = ((pl%rhill(i))**2) * (RHSCALE**2) * (RSHELL**(2*irecl))
                  rim1 = ri * (RSHELL**2)
                  dx(:) = tp%rh(:,j) - pl%rh(:,i)
                  r2 = dot_product(dx(:), dx(:))
                  if (r2 < rim1) then
                     fac = 0.0_DP
                     lgoodlevel(good_idx(k)) = .false.
                     cycle
                  end if
                  if (r2 < ri) then
                     ris = sqrt(ri)
                     r = sqrt(r2)
                     rr = (ris - r) / (ris * (1.0_DP - RSHELL))
                     fac = (r2**(-1.5_DP)) * (1.0_DP - 3 * (rr**2) + 2 * (rr**3))
                  else
                     ir3 = 1.0_DP / (r2 * sqrt(r2))
                     fac = ir3
                  end if
                  faci = fac * pl%Gmass(i)

                  tp%ah(:, j) = tp%ah(:, j) - faci * dx(:)
               end do
               ngood = count(lgoodlevel(:))
               if (ngood == 0_I8B) return
               good_idx(1:ngood) = pack([(k, k = 1_I8B, nenc)], lgoodlevel(:))

               do k = 1, ngood
                  j = self%index2(good_idx(k))
                  tp%vb(:,j) = tp%vb(:,j) + sgn * dt * tp%ah(:,j)
                  tp%ah(:,j) = 0.0_DP
               end do
            end if
         end associate
      end select
      end select
      
      return
   end subroutine symba_kick_list_pltp


end submodule s_symba_kick

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (swiftest) s_swiftest_orbel
   real(DP), parameter :: TINYVALUE = 4.0e-15_DP !! Tiny value used to prevent floating point errors. Value set based on the Swifter TINY parameter.
contains

   module subroutine swiftest_orbel_el2xv_vec(self, cb)
      !! author: David A. Minton
      !!
      !! A wrapper method that converts all of the orbital element vectors into cartesian position and velocity vectors for a Swiftest body object.
      !! This method deallocates all of the orbital elements after it is finished.
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self !! Swiftest body object
      class(swiftest_cb),           intent(inout) :: cb   !! Swiftest central body objec
      ! Internals
      integer(I4B) :: i, n
   
      if (self%nbody == 0) return
      n = self%nbody

      call self%set_mu(cb)
      associate(mu => self%mu, a => self%a, e => self%e, inc => self%inc, capom => self%capom, omega => self%omega, &
                capm => self%capm, rh => self%rh, vh => self%vh)
#ifdef DOCONLOC
         do concurrent (i = 1:n) shared(mu, a, e, inc, capom, omega, capm, rh, vh)
#else
         do concurrent (i = 1:n)
#endif
            call swiftest_orbel_el2xv(mu(i), a(i), e(i), inc(i), capom(i), omega(i), capm(i), & 
                                      rh(1,i), rh(2,i), rh(3,i), vh(1,i), vh(2,i), vh(3,i))
         end do
      end associate
      return
   end subroutine swiftest_orbel_el2xv_vec


   pure elemental subroutine swiftest_orbel_el2xv(mu, a, ie, inc, capom, omega, capm, rx, ry, rz, vx, vy, vz)
      !! author: David A. Minton
      !!
      !! Compute osculating orbital elements from relative C)rtesian position and velocity
      !!  All angular measures are returned in radians
      !!      If inclination < TINY, longitude of the ascending node is arbitrarily set to 0
      !!
      !!      If eccentricity < sqrt(TINY), argument of pericenter is arbitrarily set to 0
      !!
      !!      ALGORITHM:  See Fitzpatrick "Principles of Cel. Mech."
      !!
      !! Adapted from Martin Duncan's el2xv.f
      !! DATE WRITTEN:  May 11, 1992.
      !! REVISIONS: May 26 - now use better Kepler solver for ellipses
      !!  and hyperbolae called EHYBRID.F and FHYBRID.F
      implicit none
      real(DP), intent(in)  :: mu
      real(DP), intent(in)  :: a, ie, inc, capom, omega, capm
      real(DP), intent(out) :: rx, ry, rz, vx, vy, vz

      integer(I4B) :: iorbit_type
      real(DP) :: e, cape, capf, zpara, em1
      real(DP) :: sip, cip, so, co, si, ci
      real(DP) :: d11, d12, d13, d21, d22, d23
      real(DP) :: scap, ccap, shcap, chcap
      real(DP) :: sqe, sqgma, xfac1, xfac2, ri, vfac1, vfac2


      if(ie < 0.0_DP) then
         !write(*,*) ' ERROR in swiftest_orbel_el2xv: e<0, setting e=0!!1'
         e = 0.0_DP
         iorbit_type = ELLIPSE
      else
         e = ie
         em1 = e - 1._DP
         if (abs(em1) < TINYVALUE) then
            iorbit_type = PARABOLA
         else if (e > 1.0_DP)  then
            iorbit_type = HYPERBOLA
         else
            iorbit_type = ELLIPSE
         end if
      endif

      call swiftest_orbel_scget(omega,sip,cip)
      call swiftest_orbel_scget(capom,so,co)
      call swiftest_orbel_scget(inc,si,ci)
      d11 = cip * co - sip * so * ci
      d12 = cip * so + sip * co * ci
      d13 = sip * si
      d21 = -sip * co - cip * so * ci
      d22 = -sip * so + cip * co * ci
      d23 = cip * si

      !--
      ! Get the other quantities depending on orbit type 
      !
      if (iorbit_type == ELLIPSE) then
         cape = swiftest_orbel_ehybrid(e,capm)
         call swiftest_orbel_scget(cape,scap,ccap)
         sqe = sqrt(1._DP - e**2)
         sqgma = sqrt(mu* a)
         xfac1 = a * (ccap - e)
         xfac2 = a * sqe * scap
         ri = 1._DP / (a * (1._DP - e* ccap))
         vfac1 = -ri *  sqgma *  scap
         vfac2 = ri *  sqgma *  sqe *  ccap
      endif
      !--
      if (iorbit_type == HYPERBOLA) then
         capf = swiftest_orbel_fhybrid(e,capm)
         call swiftest_orbel_schget(capf,shcap,chcap)
         sqe = sqrt(e**2 - 1._DP )
         sqgma = sqrt(mu * a)
         xfac1 = a * (e - chcap)
         xfac2 = a * sqe * shcap
         ri = 1._DP / (a * (e * chcap - 1._DP))
         vfac1 = -ri * sqgma * shcap
         vfac2 = ri * sqgma * sqe * chcap
      endif
      !--
      if (iorbit_type == PARABOLA) then
         zpara = swiftest_orbel_zget(capm)
         sqgma = sqrt(2 * mu * a)
         xfac1 = a * (1._DP - zpara * zpara)
         xfac2 = 2 * a * zpara
         ri = 1._DP / (a * (1._DP + zpara * zpara))
         vfac1 = -ri  *  sqgma  *  zpara
         vfac2 = ri  *  sqgma 
      endif
      !--
      rx = d11 * xfac1 + d21 * xfac2
      ry = d12 * xfac1 + d22 * xfac2
      rz = d13 * xfac1 + d23 * xfac2
      vx = d11 * vfac1 + d21 * vfac2
      vy = d12 * vfac1 + d22 * vfac2
      vz = d13 * vfac1 + d23 * vfac2

      return
   end subroutine swiftest_orbel_el2xv


   pure module subroutine swiftest_orbel_scget(angle, sx, cx)
      !! author: David A. Minton
      !!
      !! Efficiently compute the sine and cosine of an input angle
      !!      Input angle must be in radians
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: orbel_scget.f90
      !! Adapted from Hal Levison's Swift routine orbel_scget.f
      implicit none
      ! Arguments
      real(DP), intent(in)  :: angle
      real(DP), intent(out) :: sx, cx
      ! Internals
      integer(I4B) :: nper
      real(DP)   :: x

      nper = angle / TWOPI
      x = angle - nper * TWOPI
      if (x < 0.0_DP) x = x + TWOPI
      sx = sin(x)
      cx = sqrt(1.0_DP - sx**2)
      if ((x > PIBY2) .and. (x < PI3BY2)) cx = -cx

      return

   end subroutine swiftest_orbel_scget


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !**********************************************************************
   !                   swiftest_orbel_SCHGET.F
   !**********************************************************************
   !     PURPOSE:  Given an angle, efficiently compute sinh and cosh.
   ! 
   !        Input:
   !             angle ==> angle in radians (real scalar)
   !
   !        Output:
   !             shx    ==>  sinh(angle)  (real scalar)
   !             chx    ==>  cosh(angle)  (real scalar)
   !
   !     ALGORITHM: Obvious from the code
   !     REMARKS: Based on the routine SCGET for sine's and cosine's.
   !       We use the sqrt rather than cosh (it's faster)
   !       BE SURE THE ANGLE IS IN RADIANS AND IT CAN'T BE LARGER THAN 300
   !       OR OVERFLOWS WILL OCCUR!
   !     AUTHOR:  M. Duncan.
   !     DATE WRITTEN:  May 6, 1992.
   !     REVISIONS:
   !**********************************************************************
   pure subroutine swiftest_orbel_schget(angle,shx,chx)
      real(DP), intent(in)  ::  angle
      real(DP), intent(out) :: shx,chx
      
      shx = sinh(angle)
      chx= sqrt(1._DP + shx * shx)
      
      return
   end subroutine swiftest_orbel_schget


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !        !                    swiftest_orbel_FLON.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn. for hyperbola using hybrid approach.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                        capn ==> hyperbola mean anomaly. (real scalar)
   !             Returns:
   !                  swiftest_orbel_flon ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: Uses power series for N in terms of F and Newton,s method
   !     REMARKS: ONLY GOOD FOR LOW VALUES OF N (N < 0.636*e -0.6)
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 26, 1992.
   !     REVISIONS:
   !**********************************************************************
   real(DP) pure function swiftest_orbel_flon(e,icapn)
      implicit none
      real(DP), intent(in) ::  e, icapn
      integer(I4B) :: iflag,i
      real(DP) ::  a,b,sq,biga,bigb, capn
      real(DP) ::  x,x2
      real(DP) ::  f,fp,dx
      real(DP) ::  a0,a1
      real(DP) ::  b1
      integer(I4B), parameter :: IMAX = 10
      real(DP), parameter :: a11 = 156._DP, a9 = 17160._DP, a7 = 1235520._DP
      real(DP), parameter :: a5 = 51891840._DP,  a3 = 1037836800._DP
      real(DP), parameter :: b11 = 11 * a11, b9 = 9 * a9, b7 = 7 * a7
      real(DP), parameter :: b5 = 5 * a5, b3 = 3 * a3

      ! Function to solve "Kepler's eqn" for F (here called
      ! x) for given e and CAPN. Only good for smallish CAPN

      iflag = 0
      if (icapn < 0._DP) then
         iflag = 1
         capn = -icapn
      else
         capn = icapn
      end if

      a1 = 6227020800._DP * (1._DP - 1._DP / e)
      a0 = -6227020800._DP * capn / e
      b1 = a1

      !  set iflag nonzero if capn < 0., in which case solve for -capn
      !  and change the sign of the final answer for f.
      !  Begin with a reasonable guess based on solving the cubic for small F
      a = 6 * ( e - 1.d0) / e
      b = -6 * capn / e
      sq = SQRT(0.25_DP * b**2 + a**3 / 27._DP)
      biga =  (-0.5_DP * b + sq)**(1.0_DP / 3.0_DP)
      bigb = -(+0.5_DP * b + sq)**(1.0_DP / 3.0_DP) 
      x = biga + bigb
      swiftest_orbel_flon = x
      ! If capn is TINYVALUE (or zero) no need to go further than cubic even for
      ! e =1.
      if( capn >= TINYVALUE) then
         do i = 1,IMAX
            x2 = x**2
            f = a0 + x * (a1 + x2 * (a3 + x2 * (a5 + x2 * (a7 + x2 * (a9 + x2 * (a11 + x2))))))
            fp = b1 + x2 * (b3 + x2 * (b5 + x2 * (b7 + x2 * (b9 + x2 * (b11 + 13 * x2)))))
            dx = -f / fp
            swiftest_orbel_flon = x + dx
            !   if we have converged here there's no point in going on
            if(abs(dx) <= TINYVALUE) exit
            x = swiftest_orbel_flon
         end do
      end if

      !  normal return here, but check if capn was originally negative
      if(iflag == 1) then
         swiftest_orbel_flon = -swiftest_orbel_flon
         capn = -capn
      end if

      return
   end function swiftest_orbel_flon


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
            !                    swiftest_orbel_FGET.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn. for hyperbola using hybrid approach.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                        capn ==> hyperbola mean anomaly. (real scalar)
   !             Returns:
   !                  swiftest_orbel_fget ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: Based on pp. 70-72 of Fitzpatrick's book "Principles of
   !           Cel. Mech. ".  Quartic convergence from Danby's book.
   !     REMARKS:
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 11, 1992.
   !     REVISIONS: 2/26/93 hfl
   !**********************************************************************
   real(DP) pure function swiftest_orbel_fget(e,capn)
      implicit none

      real(DP), intent(in) ::  e,capn

      integer :: i
      real(DP) ::  tmp,x,shx,chx
      real(DP) ::  esh,ech,f,fp,fpp,fppp,dx
      integer(I4B), parameter :: IMAX = 10

      !----
      !...  executable code

      ! function to solve "kepler's eqn" for f (here called
      ! x) for given e and capn.

      !  begin with a guess proposed by danby
      if( capn < 0.d0) then
         tmp = -2 * capn / e + 1.8_DP
         x = -log(tmp)
      else
         tmp = +2 * capn / e + 1.8_DP
         x = log(tmp)
      end if

      swiftest_orbel_fget = x

      do i = 1, IMAX
         call swiftest_orbel_schget(x,shx,chx)
         esh = e * shx
         ech = e * chx
         f = esh - x - capn
      !   write(6,*) 'i,x,f : ',i,x,f
         fp = ech - 1.d0
         fpp = esh
         fppp = ech
         dx = -f / fp
         dx = -f / (fp + dx * fpp / 2._DP)
         dx = -f / (fp + dx * fpp / 2._DP + dx**2 * fppp / 6._DP)
         swiftest_orbel_fget = x + dx
      !   if we have converged here there's no point in going on
         if(abs(dx) <= TINYVALUE) return
         x = swiftest_orbel_fget
      end do

      !write(*,*) 'fget : returning without complete convergence'
      return
   end function swiftest_orbel_fget


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !                    swiftest_orbel_ZGET.F
   !**********************************************************************
   !     PURPOSE:  Solves the equivalent of Kepler's eqn. for a parabola
   !          given Q (Fitz. notation.)
   !  
   !             Input:
   !                           q ==>  parabola mean anomaly. (real scalar)
   !             Returns:
   !                  swiftest_orbel_zget ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: p. 70-72 of Fitzpatrick's book "Princ. of Cel. Mech."
   !     REMARKS: For a parabola we can solve analytically.
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 11, 1992.
   !     REVISIONS: May 27 - corrected it for negative Q and use power
   !       series for small Q.
   !**********************************************************************
   real(DP) pure function swiftest_orbel_zget(iq)
      implicit none

      real(DP), intent(in)  :: iq

      integer(I4B) :: iflag
      real(DP) ::  x,tmp,q
      
      iflag = 0
      if (iq < 0.0_DP) then
         iflag = 1
         q = -iq
      else
         q = iq
      end if

      if (q < 1.e-3_DP) then
         swiftest_orbel_zget = q * (1._DP - (q**2 / 3._DP) * (1._DP - q**2))
      else
         x = 0.5_DP * (3 * q + sqrt(9 * q**2 + 4._DP))
         tmp = x**(1._DP / 3._DP)
         swiftest_orbel_zget = tmp - 1._DP / tmp
      end if

      if(iflag == 1) then
         swiftest_orbel_zget = -swiftest_orbel_zget
         q = -q
      end if

      return
   end function swiftest_orbel_zget


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !                    swiftest_orbel_ESOLMD.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn.   e is ecc.   m is mean anomaly.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                           m ==> mean anomaly. (real scalar)
   !             Returns:
   !                swiftest_orbel_esolmd ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: Some sort of quartic convergence from Wisdom.
   !     REMARKS: ONLY GOOD FOR SMALL ECCENTRICITY SINCE IT ONLY
   !         ITERATES ONCE. (GOOD FOR PLANET CALCS.)
   !         ALSO DOES NOT PUT M OR E BETWEEN 0. AND 2*PI
   !     INCLUDES: needs SCGET.F
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 7, 1992.
   !     REVISIONS: 2/26/93 hfl
   !**********************************************************************
   real(DP) pure function swiftest_orbel_esolmd(e,m)
      implicit none

      real(DP), intent(in)  :: e
      real(DP), intent(in)  :: m

      real(DP) :: x,sm,cm,sx,cx
      real(DP) :: es,ec,f,fp,fpp,fppp,dx

      !...    function to solve kepler's eqn for e (here called
      !...    x) for given e and m. returns value of x.

      call swiftest_orbel_scget(m,sm,cm)
      x = m + e * sm * (1._DP + e * ( cm + e * (1._DP - 1.5_DP * sm**2)))

      call swiftest_orbel_scget(x,sx,cx)
      es = e * sx
      ec = e * cx
      f = x - es  - m
      fp = 1._DP - ec
      fpp = es
      fppp = ec
      dx = -f / fp
      dx = -f / (fp + dx * fpp / 2._DP)
      dx = -f / (fp + dx * fpp / 2._DP + dx**2 * fppp / 6._DP)

      swiftest_orbel_esolmd = x + dx

      return   
   end function swiftest_orbel_esolmd


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !                    swiftest_orbel_EHIE.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn.   e is ecc.   m is mean anomaly.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                           m ==> mean anomaly. (real scalar)
   !             Returns:
   !              swiftest_orbel_ehybrid ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: Use Danby's quartic for 3 iterations.
   !                Eqn. is f(x) = x - e*sin(x+M). Note  that
   !          E = x + M. First guess is very good for e near 1.
   !          Need to first get M between 0. and PI and use
   !   symmetry to return right answer if M between PI and 2PI
   !     REMARKS: Modifies M so that both E and M are in range (0,TWOPI)
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 25,1992.
   !     REVISIONS:
   !**********************************************************************
   real(DP) pure function swiftest_orbel_ehie(e,im)
      implicit none

      real(DP), intent(in) :: e,im

      integer(I4B) :: iflag,nper,niter
      real(DP) :: dx,x,sa,ca,esa,eca,f,fp,m

      integer(I4B), parameter  :: NMAX = 3

      ! in this section, bring m into the range (0,TWOPI) and if
      ! the result is greater than pi, solve for (TWOPI - m).
      iflag = 0
      nper = im / TWOPI
      m = im - nper * TWOPI
      if (m < 0._DP) m = m + TWOPI

      if (m > PI) then
         m = TWOPI - m
         iflag = 1
      end if

      ! make a first guess that works well for e near 1.
      x = (6 * m)**(1._DP / 3._DP) - m
      niter =0

      ! iteration loop
      do niter =1,NMAX
         call swiftest_orbel_scget(x + m,sa,ca)
         esa = e * sa
         eca = e * ca
         f = x - esa
         fp = 1._DP -eca
         dx = -f / fp
         dx = -f / (fp + 0.5_DP * dx * esa)
         dx = -f / (fp + 0.5_DP * dx * (esa + eca * dx / 3.0_DP))
         x = x + dx
      end do

      swiftest_orbel_ehie = m + x

      if (iflag == 1) then
         swiftest_orbel_ehie = TWOPI - swiftest_orbel_ehie
         m = TWOPI - m
      end if

      return
   end function swiftest_orbel_ehie


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !                             swiftest_orbel_EGET.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn.   e is ecc.   m is mean anomaly.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                           m ==> mean anomaly. (real scalar)
   !             Returns:
   !                  swiftest_orbel_eget ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: Quartic convergence from Danby
   !     REMARKS: For results very near roundoff, give it M between
   !           0 and 2*pi. One can condition M before calling EGET
   !           by calling my double precision function MOD2PI(M).
   !           This is not done within the routine to speed it up
   !           and because it works fine even for large M.
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 7, 1992.
   !     REVISIONS: May 21, 1992.  Now have it go through EXACTLY two iterations
   !                with the premise that it will only be called if
   !          we have an ellipse with e between 0.15 and 0.8
   !**********************************************************************
   real(DP) pure function swiftest_orbel_eget(e,m)
      implicit none
      
      real(DP), intent(in) ::  e,m
      real(DP) ::  x,sm,cm,sx,cx
      real(DP) ::  es,ec,f,fp,fpp,fppp,dx

      ! function to solve kepler's eqn for e (here called
      ! x) for given e and m. returns value of x.
      ! may 21 : for e < 0.18 use esolmd for speed and sufficient accuracy
      ! may 21 : for e > 0.8 use ehie - this one may not converge fast enough.

      call swiftest_orbel_scget(m,sm,cm)

      !  begin with a guess accurate to order ecc**3
      x = m + e * sm * ( 1._DP + e * (cm + e * (1._DP - 1.5_DP * sm * sm)))

      !  go through one iteration for improved estimate
      call swiftest_orbel_scget(x,sx,cx)
      es = e * sx
      ec = e * cx
      f = x - es  - m
      fp = 1._DP - ec
      fpp = es
      fppp = ec
      dx = -f / fp
      dx = -f / (fp + dx * fpp / 2._DP)
      dx = -f / (fp + dx * fpp / 2._DP + dx*2 * fppp / 6._DP)
      swiftest_orbel_eget = x + dx

      ! do another iteration.
      ! for m between 0 and 2*pi this seems to be enough to
      ! get near roundoff error for eccentricities between 0 and 0.8

      x = swiftest_orbel_eget
      call swiftest_orbel_scget(x,sx,cx)
      es = e * sx
      ec = e * cx
      f = x - es  - m
      fp = 1._DP - ec
      fpp = es
      fppp = ec
      dx = -f / fp
      dx = -f / (fp + dx * fpp / 2._DP)
      dx = -f / (fp + dx * fpp / 2._DP + dx**2 * fppp / 6._DP)

      swiftest_orbel_eget = x + dx

      return
   end function swiftest_orbel_eget


   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !                    swiftest_orbel_EHYBRID.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn.   e is ecc.   m is mean anomaly.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                           m ==> mean anomaly. (real scalar)
   !             Returns:
   !              swiftest_orbel_ehybrid ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: For e < 0.18 uses fast routine ESOLMD
   !          For larger e but less than 0.8, uses EGET
   !          For e > 0.8 uses EHIE
   !     REMARKS: Only EHIE brings M and E into range (0,TWOPI)
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 25,1992.
   !     REVISIONS: 2/26/93 hfl
   !**********************************************************************
   real(DP) pure function swiftest_orbel_ehybrid(e,m)
      implicit none

      real(DP), intent(in) :: e,m
      !real(DP) :: swiftest_orbel_esolmd,orbel_eget,orbel_ehie

      if (e < 0.18_DP) then
         swiftest_orbel_ehybrid = swiftest_orbel_esolmd(e,m)
      else
         if( e <= 0.8_DP) then
            swiftest_orbel_ehybrid = swiftest_orbel_eget(e,m)
         else
            swiftest_orbel_ehybrid = swiftest_orbel_ehie(e,m)
         end if
      end if
      return
   end function swiftest_orbel_ehybrid

   !**********************************************************************
   ! Code converted to Modern Fortran by David A. Minton
   ! Date: 2020-06-29  
   !                    swiftest_orbel_FHYBRID.F
   !**********************************************************************
   !     PURPOSE:  Solves Kepler's eqn. for hyperbola using hybrid approach.
   !
   !             Input:
   !                           e ==> eccentricity anomaly. (real scalar)
   !                           n ==> hyperbola mean anomaly. (real scalar)
   !             Returns:
   !               swiftest_orbel_fhybrid ==>  eccentric anomaly. (real scalar)
   !
   !     ALGORITHM: For abs(N) < 0.636*ecc -0.6 , use FLON
   !          For larger N, uses FGET
   !     REMARKS:
   !     AUTHOR: M. Duncan
   !     DATE WRITTEN: May 26,1992.
   !     REVISIONS::
   !     REVISIONS: 2/26/93 hfl
   !**********************************************************************
   real(DP) pure function swiftest_orbel_fhybrid(e,n)
      implicit none
      real(DP), intent(in) :: e,n

      real(DP) :: abn

      abn = n
      if(n < 0._DP) abn = -abn

      if(abn < 0.636_DP * e - 0.6_DP) then
         swiftest_orbel_fhybrid = swiftest_orbel_flon(e,n)
      else
         swiftest_orbel_fhybrid = swiftest_orbel_fget(e,n)
      end if

      return
   end function swiftest_orbel_fhybrid
   

   pure elemental module subroutine swiftest_orbel_xv2aeq(mu, rx, ry, rz, vx, vy, vz, a, e, q)
      !! author: David A. Minton
      !!
      !! Compute semimajor axis, eccentricity, and pericentric distance from relative Cartesian position and velocity
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: orbel_xv2aeq.f90
      !! Adapted from Luke Dones' Swift routine orbel_xv2aeq.f
      implicit none
      !! Arguments
      real(DP), intent(in)  :: mu !! Gravitational constant
      real(DP), intent(in)  :: rx,ry,rz  !! Position vector
      real(DP), intent(in)  :: vx,vy,vz  !! Velocity vector
      real(DP), intent(out) :: a  !! semimajor axis
      real(DP), intent(out) :: e  !! eccentricity
      real(DP), intent(out) :: q  !! periapsis
      ! Internals
      integer(I4B) :: iorbit_type
      real(DP)   :: hx, hy, hz, r, v2, h2, energy, fac

      a = 0.0_DP
      e = 0.0_DP
      q = 0.0_DP

      r = sqrt(rx*rx + ry*ry + rz*rz)
      v2 = vx*vx + vy*vy + vz*vz

      hx = ry*vz - rz*vy
      hy = rz*vx - rx*vz
      hz = rx*vy - ry*vx
      h2 = hx*hx + hy*hy + hz*hz

      if (h2 < tiny(h2)) return
      energy = 0.5_DP * v2 - mu / r
      if (abs(energy * r / mu) < sqrt(TINYVALUE)) then
         iorbit_type = PARABOLA
      else
         a = -0.5_DP * mu / energy
         if (a < 0.0_DP) then
            fac = -h2 / (mu * a)
            if (fac > TINYVALUE) then
               iorbit_type = HYPERBOLA
            else
               iorbit_type = PARABOLA
            end if
         else
            iorbit_type = ELLIPSE
         end if
      end if
      select case (iorbit_type)
      case (ELLIPSE)
         fac = 1.0_DP - h2 / (mu * a)
         if (fac > TINYVALUE) e = sqrt(fac)
         q = a * (1.0_DP - e)
      case (PARABOLA)
         a = 0.5_DP * h2 / mu
         e = 1.0_DP
         q = a
      case (HYPERBOLA)
         e = sqrt(1.0_DP + fac)
         q = a * (1.0_DP - e)
      end select

      return

   end subroutine swiftest_orbel_xv2aeq


   pure module subroutine swiftest_orbel_xv2aqt(mu, rx, ry, rz, vx, vy, vz, a, q, capm, tperi)
      !! author: David A. Minton
      !!
      !! Compute semimajor axis, pericentric distance, mean anomaly, and time to nearest pericenter passage from
      !! relative Cartesian position and velocity
      !!      tperi > 0 means nearest pericenter passage is in the future
      !!      tperi < 0 means nearest pericenter passage is in the past
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: orbel_xv2aqt.f90
      implicit none
      ! Arguments
      real(DP), intent(in)  :: mu    !! Gravitational constant
      real(DP), intent(in)  :: rx,ry,rz !! Position vector
      real(DP), intent(in)  :: vx,vy,vz !! Velocity vector
      real(DP), intent(out) :: a     !! semimajor axis
      real(DP), intent(out) :: q     !! periapsis
      real(DP), intent(out) :: capm  !! mean anomaly
      real(DP), intent(out) :: tperi !! time of pericenter passage
      ! Internals
      integer(I4B) :: iorbit_type
      real(DP)   :: hx, hy, hz, r, v2, h2, rdotv, energy, fac, w, face, cape, e, tmpf, capf, mm

      a = 0.0_DP
      q = 0.0_DP
      capm = 0.0_DP
      tperi = 0.0_DP
      hx = ry*vz - rz*vy
      hy = rz*vx - rx*vz
      hz = rx*vy - ry*vx
      h2 = hx*hx + hy*hy + hz*hz
      if (h2 < tiny(h2)) return

      r = sqrt(rx*rx + ry*ry + rz*rz)
      v2 = vx*vx + vy*vy + vz*vz
      rdotv = rx*vx + ry*vy + rz*vz 
      energy = 0.5_DP * v2 - mu / r
      if (abs(energy * r / mu) < sqrt(TINYVALUE)) then
         iorbit_type = PARABOLA
      else
         a = -0.5_DP * mu / energy
         if (a < 0.0_DP) then
            fac = -h2 / (mu * a)
            if (fac > TINYVALUE) then
               iorbit_type = HYPERBOLA
            else
               iorbit_type = PARABOLA
            end if
         else
            iorbit_type = ELLIPSE
         end if
      end if
      select case (iorbit_type)
      case (ELLIPSE)
         fac = 1.0_DP - h2 / (mu * a)
         if (fac > TINYVALUE) then
            e = sqrt(fac)
            cape = 0.0_DP
            face = (a - r) / (a * e)
            if (face < -1.0_DP) then
               cape = PI
            else if (face < 1.0_DP) then
               cape = acos(face)
            end if
            if (rdotv < 0.0_DP) cape = TWOPI - cape
         else
            e = 0.0_DP
            cape = 0.0_DP
         end if
         capm = cape - e * sin(cape)
         q = a * (1.0_DP - e)
         mm = sqrt(mu / a**3)
         if (capm < PI) then
            tperi = -1.0_DP * capm / mm
         else
            tperi = -1.0_DP * (capm - TWOPI) / mm
         end if
      case (PARABOLA)
         a = 0.5_DP * h2 / mu
         e = 1.0_DP
         w = 0.0_DP
         fac = 2 * a / r - 1.0_DP
         if (fac < -1.0_DP) then
            w = PI
         else if (fac < 1.0_DP) then
            w = acos(fac)
         end if
         if (rdotv < 0.0_DP) w = TWOPI - w
         tmpf = tan(0.5_DP * w)
         capm = tmpf*(1.0_DP + tmpf * tmpf / 3.0_DP)
         q = a
         mm = sqrt(0.5_DP * mu / q**3)
         tperi = -1.0_DP * capm / mm
      case (HYPERBOLA)
         e = sqrt(1.0_DP + fac)
         tmpf = (a - r) / (a * e)
         if (tmpf < 1.0_DP) tmpf = 1.0_DP
         capf = log(tmpf + sqrt(tmpf * tmpf - 1.0_DP))
         if (rdotv < 0.0_DP) capf = -capf
         capm = e * sinh(capf) - capf
         q = a * (1.0_DP - e)
         mm = sqrt(-mu / a**3)
         tperi = -1.0_DP * capm / mm
      end select

      return

   end subroutine swiftest_orbel_xv2aqt


   module subroutine swiftest_orbel_xv2el_vec(self, cb)
      !! author: David A. Minton
      !!
      !! A wrapper method that converts all of the cartesian position and velocity vectors of a Swiftest body object to orbital elements.
      implicit none
      ! Arguments
      class(swiftest_body), intent(inout) :: self !! Swiftest body object
      class(swiftest_cb),   intent(inout) :: cb   !! Swiftest central body object
      ! internals
      integer(I4B) :: i
      real(DP) :: varpi, lam, f, cape, capf
    
      if (self%nbody == 0) return

      call self%set_mu(cb)
      if (allocated(self%a)) deallocate(self%a); allocate(self%a(self%nbody))
      if (allocated(self%e)) deallocate(self%e); allocate(self%e(self%nbody))
      if (allocated(self%inc)) deallocate(self%inc); allocate(self%inc(self%nbody))
      if (allocated(self%capom)) deallocate(self%capom); allocate(self%capom(self%nbody))
      if (allocated(self%omega)) deallocate(self%omega); allocate(self%omega(self%nbody))
      if (allocated(self%capm)) deallocate(self%capm);  allocate(self%capm(self%nbody))
#ifdef DOCONLOC
      do concurrent (i = 1:self%nbody) shared(self) local(varpi,lam,f,cape,capf)
#else
      do concurrent (i = 1:self%nbody)
#endif
         call swiftest_orbel_xv2el(self%mu(i), self%rh(1,i), self%rh(2,i), self%rh(3,i), &
                                      self%vh(1,i), self%vh(2,i), self%vh(3,i), &
                                      self%a(i), self%e(i), self%inc(i),  &
                                      self%capom(i), self%omega(i), self%capm(i), &
                                      varpi, lam, f, cape, capf)
      end do

      return
   end subroutine swiftest_orbel_xv2el_vec 


   pure module subroutine swiftest_orbel_xv2el(mu, rx, ry, rz, vx, vy, vz, a, e, inc, capom, omega, capm, varpi, lam, f, cape, capf)
      !! author: David A. Minton
      !!
      !! Compute osculating orbital elements from relative Cartesian position and velocity
      !!  All angular measures are returned in radians
      !!      If inclination < TINY, longitude of the ascending node is arbitrarily set to 0
      !!
      !!      If eccentricity < sqrt(TINY), argument of pericenter is arbitrarily set to 0
      !!
      !!      References: Danby, J. M. A. 1988. Fundamentals of Celestial Mechanics, (Willmann-Bell, Inc.), 201 - 206.
      !!              Fitzpatrick, P. M. 1970. Principles of Celestial Mechanics, (Academic Press), 69 - 73.
      !!              Roy, A. E. 1982. Orbital Motion, (Adam Hilger, Ltd.), 75 - 95
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: orbel_xv2el.f90
      !! Adapted from Martin Duncan's Swift routine orbel_xv2el.f
      implicit none
      ! Arguments
      real(DP), intent(in)  :: mu    !! Gravitational constant
      real(DP), intent(in)  :: rx,ry,rz    !! Position vector
      real(DP), intent(in)  :: vx,vy,vz !! Velocity vector
      real(DP), intent(out) :: a     !! semimajor axis
      real(DP), intent(out) :: e     !! eccentricity
      real(DP), intent(out) :: inc   !! inclination
      real(DP), intent(out) :: capom !! longitude of ascending node
      real(DP), intent(out) :: omega !! argument of periapsis
      real(DP), intent(out) :: capm  !! mean anomaly
      real(DP), intent(out) :: varpi !! longitude of periapsis
      real(DP), intent(out) :: lam   !! mean longitude
      real(DP), intent(out) :: f     !! true anomaly
      real(DP), intent(out) :: cape  !! eccentric anomaly (eccentric orbits)
      real(DP), intent(out) :: capf  !! hyperbolic anomaly (hyperbolic orbits)
      ! Internals
      integer(I4B) :: iorbit_type
      real(DP)   :: hx, hy, hz, r, v2, h2, h, rdotv, energy, fac, u, w, cw, sw, face, tmpf, sf, cf, rdot

      a = 0.0_DP
      e = 0.0_DP
      inc = 0.0_DP
      capom = 0.0_DP
      omega = 0.0_DP
      capm = 0.0_DP
      varpi = 0.0_DP
      lam = 0.0_DP
      f = 0.0_DP
      cape = 0.0_DP
      capf = 0.0_DP

      hx = ry*vz - rz*vy
      hy = rz*vx - rx*vz
      hz = rx*vy - ry*vx
      h2 = hx*hx + hy*hy +hz*hz
      h  = sqrt(h2)
      if(hz>h) then                 ! Hal's fix
         hz = h
         hx = 0.0_DP
         hy = 0.0_DP
      endif
      if (h2 <= 10 * tiny(0.0_DP)) return
      h = SQRT(h2)

      r = sqrt(rx*rx + ry*ry + rz*rz)
      v2 = vx*vx + vy*vy + vz*vz
      rdotv = rx*vx + ry*vy + rz*vz
      energy = 0.5_DP * v2 - mu / r
      fac = hz / h
      if (fac < -1.0_DP) then
         inc = PI
      else if (fac < 1.0_DP) then
         inc = acos(fac)
      end if
      fac = sqrt(hx**2 + hy**2) / h
      if (fac**2 < TINYVALUE) then
         u = atan2(ry, rx)
         if (hz < 0.0_DP) u = -u
      else
         capom = atan2(hx, -hy)
         u = atan2(rz / sin(inc), rx * cos(capom) + ry * sin(capom))
      end if
      if (capom < 0.0_DP) capom = capom + TWOPI
      if (u < 0.0_DP) u = u + TWOPI
      if (abs(energy * r / mu) < sqrt(TINYVALUE)) then
         iorbit_type = parabola
      else
         a = -0.5_DP * mu / energy
         if (a < 0.0_DP) then
            fac = -h2 / (mu * a)
            if (fac > TINYVALUE) then
               iorbit_type = HYPERBOLA
            else
               iorbit_type = PARABOLA
            end if
         else
            iorbit_type = ELLIPSE
         end if
      end if
      select case (iorbit_type)
         case (ELLIPSE)
            fac = 1.0_DP - h2 / (mu * a)
            if (fac > TINYVALUE) then
               e = sqrt(fac)
               cape = 0.0_DP
               face = (a - r) / (a * e)
               if (face < -1.0_DP) then
                  cape = PI
               else if (face < 1.0_DP) then
                  cape = acos(face)
               end if
               if (rdotv < 0.0_DP) cape = TWOPI - cape
               fac = 1.0_DP - e * cos(cape)
               cw = (cos(cape) - e) / fac
               sw = sqrt(1.0_DP - e**2) * sin(cape) / fac
               w = atan2(sw, cw)
               if (w < 0.0_DP) w = w + TWOPI
            else
               cape = u
               w = u
            end if
            capm = cape - e * sin(cape)
         case (PARABOLA)
            a = 0.5_DP * h2 / mu
            e = 1.0_DP
            w = 0.0_DP
            fac = 2 * a / r - 1.0_DP
            if (fac < -1.0_DP) then
               w = PI
            else if (fac < 1.0_DP) then
               w = acos(fac)
            end if
            if (rdotv < 0.0_DP) w = TWOPI - w
            tmpf = tan(0.5_DP * w)
            capm = tmpf * (1.0_DP + tmpf * tmpf / 3.0_DP)
         case (HYPERBOLA)
            e = sqrt(1.0_DP + fac)
            tmpf = max((a - r) / (a * e), 1.0_DP)
            capf = log(tmpf + sqrt(tmpf**2 - 1.0_DP))
            if (rdotv < 0.0_DP) capf = -capf
            fac = e * cosh(capf) - 1.0_DP
            cw = (e - cosh(capf)) / fac
            sw = sqrt(e * e - 1.0_DP) * sinh(capf) / fac
            w = atan2(sw, cw)
            if (w < 0.0_DP) w = w + TWOPI
            capm = e * sinh(capf) - capf
      end select
      omega = u - w
      if (omega < 0.0_DP) omega = omega + TWOPI
      varpi = mod(omega + capom, TWOPI)
      lam = mod(capm + varpi, TWOPI)
      if (e > TINYVALUE) then
         cf = 1.0_DP / e * (a * (1.0_DP - e**2)/r - 1.0_DP)
         rdot = sign(sqrt(max(v2 - (h / r)**2,0.0_DP)),rdotv)
         sf = a * (1.0_DP - e**2) / (h * e) * rdot
         f = atan2(sf,cf)
         if (f < 0.0_DP) f = f + TWOPI
      else
         f = u
      end if


      return
   end subroutine swiftest_orbel_xv2el

   
end submodule s_swiftest_orbel

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (rmvs) s_rmvs_encounter_check
   use swiftest
contains

   module function rmvs_encounter_check_tp(self, param, nbody_system, dt) result(lencounter)
      !! author: David A. Minton
      !!
      !! Determine whether a test particle and planet are having or will have an encounter within the next time step
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: rmvs_chk.f90
      !! Adapted from Hal Levison's Swift routine rmvs3_chk.f
      implicit none
      ! Arguments
      class(rmvs_tp),             intent(inout) :: self   !! RMVS test particle object  
      class(swiftest_parameters), intent(inout) :: param  !! Current swiftest run configuration parameters
      class(rmvs_nbody_system),   intent(inout) :: nbody_system !! RMVS nbody system object
      real(DP),                   intent(in)    :: dt     !! step size
      ! Result
      logical                                 :: lencounter  !! Returns true if there is at least one close encounter
      ! Internals
      integer(I4B)                            :: i
      integer(I8B)                            :: nenc
      logical, dimension(:),      allocatable :: lvdotr
      integer(I4B), dimension(:), allocatable :: index1, index2

      ! The minimization and linear solvers can sometimes lead to floating point exceptions. Rather than halting the code entirely if this occurs, we
      ! can simply fail the attempt and try again. So we need to turn off any floating point exception halting modes temporarily 

      lencounter = .false.
      if (self%nbody == 0) return

      select type(pl => nbody_system%pl)
      class is (rmvs_pl)
         associate(tp => self, ntp => self%nbody, npl => pl%nbody, cb => nbody_system%cb)
            tp%plencP(1:ntp) = 0
            call encounter_check_all_pltp(param, npl, ntp, pl%rbeg, pl%vbeg, tp%rh, tp%vh, pl%renc, dt, & 
                                          nenc, index1, index2, lvdotr)

            lencounter = (nenc > 0_I8B)
            if (lencounter) then
               tp%plencP(index2(1_I8B:nenc)) = index1(1_I8B:nenc)
               do i = 1, npl
                  pl%nenc(i) = count(tp%plencP(1:ntp) == i)
               end do
            end if
         end associate
      end select

      return
   end function rmvs_encounter_check_tp


end submodule s_rmvs_encounter_check

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module whm
   !! author: David A. Minton
   !!
   !! Definition of classes and methods specific to the Democratic Heliocentric Method
   !! Partially adapted from David E. Kaufmann's Swifter module: module_whm.f90
   use swiftest
   implicit none
   public

   !> Swiftest central body particle class
   type, extends(swiftest_cb) :: whm_cb
   contains
   end type whm_cb


   !> WHM massive body particle class
   type, extends(swiftest_pl) :: whm_pl
      real(DP), dimension(:),   allocatable :: eta    
         !! Jacobi mass
      real(DP), dimension(:,:), allocatable :: xj     
         !! Jacobi position
      real(DP), dimension(:,:), allocatable :: vj     
         !! Jacobi velocity
      real(DP), dimension(:),   allocatable :: muj    
         !! Jacobi mu: GMcb * eta(i) / eta(i - 1) 
      real(DP), dimension(:),   allocatable :: ir3j    
         !! Third term of heliocentric acceleration
      ! Note to developers: If you add componenets to this class, be sure to update methods and subroutines that traverse the
      !    component list, such as whm_util_setup_pl and whm_util_spill_pl
   contains
      procedure :: h2j         => whm_coord_h2j_pl           
         !! Convert position and velcoity vectors from heliocentric to Jacobi coordinates 
      procedure :: j2h         => whm_coord_j2h_pl           
         !! Convert position and velcoity vectors from Jacobi to helliocentric coordinates 
      procedure :: vh2vj       => whm_coord_vh2vj_pl         
         !! Convert velocity vectors from heliocentric to Jacobi coordinates 
      procedure :: drift       => whm_drift_pl               
         !! Loop through massive bodies and call Danby drift routine to jacobi coordinates
      procedure :: accel_gr    => whm_gr_kick_getacch_pl     
         !! Acceleration term arising from the post-Newtonian correction
      procedure :: gr_pos_kick => whm_gr_p4_pl               
         !! Position kick due to p**4 term in the post-Newtonian correction
      procedure :: accel       => whm_kick_getacch_pl        
         !! Compute heliocentric accelerations of massive bodies
      procedure :: kick        => whm_kick_vh_pl             
         !! Kick heliocentric velocities of massive bodies
      procedure :: append      => whm_util_append_pl         
         !! Appends elements from one structure to another
      procedure :: dealloc     => whm_util_dealloc_pl        
         !! Deallocates all allocatable arrays
      procedure :: fill        => whm_util_fill_pl           
         !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: resize      => whm_util_resize_pl         
         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: set_ir3     => whm_util_set_ir3j          
         !! Sets both the heliocentric and jacobi inverse radius terms (1/rj**3 and 1/rh**3)
      procedure :: set_mu      => whm_util_set_mu_eta_pl     
         !! Sets the Jacobi mass value for all massive bodies.
      procedure :: sort        => whm_util_sort_pl           
         !! Sort a WHM massive body object in-place. 
      procedure :: rearrange   => whm_util_sort_rearrange_pl 
         !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill       => whm_util_spill_pl          
         !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
      procedure :: setup       => whm_util_setup_pl          
         !! Constructor method - Allocates space for the input number of bodiess
      procedure :: step        => whm_step_pl                
         !! Steps the body forward one stepsize
      final     ::                whm_final_pl               
         !! Finalizes the WHM massive body object - deallocates all allocatables
   end type whm_pl


   !> WHM test particle class
   type, extends(swiftest_tp) :: whm_tp
      ! Note to developers: If you add componenets to this class, be sure to update methods and subroutines that traverse the
      !    component list, such as whm_util_spill_tp
   contains
      procedure :: accel_gr    => whm_gr_kick_getacch_tp 
         !! Acceleration term arising from the post-Newtonian correction
      procedure :: gr_pos_kick => whm_gr_p4_tp           
         !! Position kick due to p**4 term in the post-Newtonian correction
      procedure :: accel       => whm_kick_getacch_tp    
         !! Compute heliocentric accelerations of test particles
      procedure :: kick        => whm_kick_vh_tp         
         !! Kick heliocentric velocities of test particles
      procedure :: step        => whm_step_tp            
         !! Steps the particle forward one stepsize
      final     ::                whm_final_tp      
         !! Finalizes the WHM test particle object - deallocates all allocatables 
   end type whm_tp

   !> An abstract class for the WHM integrator nbody system 
   type, extends(swiftest_nbody_system) :: whm_nbody_system
   contains
      ! Replace the abstract procedures with concrete ones
      procedure :: initialize   => whm_util_setup_initialize_system 
         !! Performs WHM-specific initilization steps, like calculating the Jacobi masses
      procedure :: step         => whm_step_system             
         !! Advance the WHM nbody system forward in time by one step
      final     ::                 whm_final_system       
         !! Finalizes the WHM nbody_system object - deallocates all allocatables 
   end type whm_nbody_system

   interface
      module subroutine whm_coord_h2j_pl(self, cb)
         implicit none
         class(whm_pl),      intent(inout) :: self   
            !! WHM massive body particle data structure
         class(swiftest_cb), intent(inout) :: cb     
            !! Swiftest central body particle data structuree
      end subroutine whm_coord_h2j_pl

      module subroutine whm_coord_j2h_pl(self, cb)
         implicit none
         class(whm_pl),      intent(inout) :: self   
            !! WHM massive body particle data structure
         class(swiftest_cb), intent(inout) :: cb     
            !! Swiftest central body particle data structuree
      end subroutine whm_coord_j2h_pl

      module subroutine whm_coord_vh2vj_pl(self, cb)
         implicit none
         class(whm_pl),      intent(inout) :: self   
            !! WHM massive body particle data structure
         class(swiftest_cb), intent(inout) :: cb     
            !! Swiftest central body particle data structuree
      end subroutine whm_coord_vh2vj_pl

      module subroutine whm_drift_pl(self, nbody_system, param, dt)
         implicit none
         class(whm_pl),                intent(inout) :: self   
            !! WHM massive body particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! WHM nbody system object
         class(swiftest_parameters),   intent(in)    :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     
            !! Stepsize
      end subroutine whm_drift_pl

      !> Get heliocentric accelration of massive bodies
      module subroutine whm_kick_getacch_pl(self, nbody_system, param, t, lbeg)
         implicit none
         class(whm_pl),                intent(inout) :: self   
            !! WHM massive body particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! WHM nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      
            !! Current simulation time
         logical,                      intent(in)    :: lbeg   
            !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine whm_kick_getacch_pl

      !> Get heliocentric accelration of the test particle
      module subroutine whm_kick_getacch_tp(self, nbody_system, param, t, lbeg)
         implicit none
         class(whm_tp),                intent(inout) :: self   
            !! WHM test particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! WHM nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters
         real(DP),                     intent(in)    :: t      
            !! Current time
         logical,                      intent(in)    :: lbeg   
            !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine whm_kick_getacch_tp

      module subroutine whm_kick_vh_pl(self, nbody_system, param, t, dt, lbeg)
         implicit none
         class(whm_pl),                intent(inout) :: self   
            !! WHM massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      
            !! Current time
         real(DP),                     intent(in)    :: dt     
            !! Stepsize
         logical,                      intent(in)    :: lbeg   
            !! Logical flag indicating whether this is the beginning of the half step or not. 
      end subroutine whm_kick_vh_pl

      module subroutine whm_kick_vh_tp(self, nbody_system, param, t, dt, lbeg)
         implicit none
         class(whm_tp),                intent(inout) :: self   
            !! WHM test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      
            !! Current time
         real(DP),                     intent(in)    :: dt     
            !! Stepsize
         logical,                      intent(in)    :: lbeg   
            !! Logical flag indicating whether this is the beginning of the half step or not. 
      end subroutine whm_kick_vh_tp

      pure module subroutine whm_gr_kick_getacch_pl(self, param)
         implicit none
         class(whm_pl),              intent(inout) :: self  
            !! WHM massive body particle data structure
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters 
      end subroutine whm_gr_kick_getacch_pl

      pure module subroutine whm_gr_kick_getacch_tp(self, param)
         implicit none
         class(whm_tp),              intent(inout) :: self  
            !! WHM test particle data structure
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters
      end subroutine whm_gr_kick_getacch_tp

      pure module subroutine whm_gr_p4_pl(self, nbody_system, param, dt)
         implicit none
         class(whm_pl),                intent(inout) :: self  
            !! WHM massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system
         class(swiftest_parameters),   intent(in)    :: param 
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt    
            !! Step size
      end subroutine whm_gr_p4_pl

      pure module subroutine whm_gr_p4_tp(self, nbody_system, param, dt)
         implicit none
         class(whm_tp),                intent(inout) :: self   
            !! WHM test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system
         class(swiftest_parameters),   intent(in)    :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     
            !! Step size
      end subroutine whm_gr_p4_tp

      !> Reads WHM massive body object in from file
      module subroutine whm_util_setup_pl(self, n, param)
         implicit none
         class(whm_pl),             intent(inout) :: self  
            !! WHM massive body objectobject
         integer(I4B),              intent(in)    :: n     
            !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters
      end subroutine whm_util_setup_pl

      module subroutine whm_util_setup_initialize_system(self, system_history, param)
         implicit none
         class(whm_nbody_system),                 intent(inout) :: self            
            !! WHM nbody system object
         class(swiftest_storage),    allocatable, intent(inout) :: system_history  
            !! Stores the system history between output dumps
         class(swiftest_parameters),              intent(inout) :: param           
            !! Current run configuration parameters 
      end subroutine whm_util_setup_initialize_system

      module subroutine whm_step_pl(self, nbody_system, param, t, dt)
         implicit none
         class(whm_pl),                intent(inout) :: self   
            !! WHM massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody_system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t       
            !! Simulation time
         real(DP),                     intent(in)    :: dt     
            !! Current stepsize
      end subroutine whm_step_pl

      module subroutine whm_step_system(self, param, t, dt)
         implicit none
         class(whm_nbody_system),    intent(inout) :: self    
            !! WHM nbody_system object
         class(swiftest_parameters), intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t      
            !! Simulation time
         real(DP),                   intent(in)    :: dt     
            !! Current stepsize
      end subroutine whm_step_system

      module subroutine whm_step_tp(self, nbody_system, param, t, dt)
         implicit none
         class(whm_tp),                intent(inout) :: self   
            !! WHM test particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters
         real(DP),                     intent(in)    :: t      
            !! Current simulation time
         real(DP),                     intent(in)    :: dt     
            !! Stepsize
      end subroutine whm_step_tp

      module subroutine whm_util_append_pl(self, source, lsource_mask)
         implicit none
         class(whm_pl),                   intent(inout) :: self         
            !! WHM massive body object
         class(swiftest_body),            intent(in)    :: source       
            !! Source object to append
         logical, dimension(:),           intent(in)    :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine whm_util_append_pl

      module subroutine whm_util_dealloc_pl(self)
         implicit none
         class(whm_pl),  intent(inout) :: self 
            !! WHM massive body object
      end subroutine whm_util_dealloc_pl

      module subroutine whm_util_spill_pl(self, discards, lspill_list, ldestructive)
         implicit none
         class(whm_pl),         intent(inout) :: self        
            !! WHM massive body object
         class(swiftest_body),      intent(inout) :: discards    
            !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list 
            !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine whm_util_spill_pl

      module subroutine whm_util_fill_pl(self, inserts, lfill_list)
         implicit none
         class(whm_pl),         intent(inout) :: self       
            !! WHM massive body object
         class(swiftest_body),  intent(in)    :: inserts    
            !! inserted object 
         logical, dimension(:), intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine whm_util_fill_pl

      module subroutine whm_util_resize_pl(self, nnew)
         implicit none
         class(whm_pl), intent(inout) :: self  
            !! WHM massive body object
         integer(I4B),  intent(in)    :: nnew  
            !! New size neded
      end subroutine whm_util_resize_pl

      module subroutine whm_util_set_ir3j(self)
         implicit none
         class(whm_pl),                intent(inout) :: self    
            !! WHM massive body object
      end subroutine whm_util_set_ir3j

      module subroutine whm_util_set_mu_eta_pl(self, cb)
         implicit none
         class(whm_pl),                intent(inout) :: self    
            !! WHM massive body object
         class(swiftest_cb),           intent(inout) :: cb     
            !! Swiftest central body object
      end subroutine whm_util_set_mu_eta_pl

      module subroutine whm_util_sort_pl(self, sortby, ascending)
         implicit none
         class(whm_pl), intent(inout) :: self       
             !! WHM massive body object
         character(*),  intent(in)    :: sortby    
            !! Sorting attribute
         logical,       intent(in)    :: ascending 
            !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine whm_util_sort_pl

      module subroutine whm_util_sort_rearrange_pl(self, ind)
         implicit none
         class(whm_pl),               intent(inout) :: self 
            !! WHM massive body object
         integer(I4B),  dimension(:), intent(in)    :: ind  
            !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine whm_util_sort_rearrange_pl
   end interface

#ifdef COARRAY
   interface coclone
      module procedure whm_coarray_coclone_tp
   end interface

   interface cocollect
      module procedure whm_coarray_cocollect_tp
   end interface
#endif

   contains

      subroutine whm_final_pl(self)
         !! author: David A. Minton
         !!
         !! Finalize the WHM massive body object - deallocates all allocatables
         implicit none
         ! Argument
         type(whm_pl),  intent(inout) :: self 
            !! WHM massive body object
         call self%dealloc()
         return
      end subroutine whm_final_pl


      subroutine whm_final_system(self)
         !! author: David A. Minton
         !!
         !! Finalize the WHM nbody system object - deallocates all allocatables
         implicit none
         ! Arguments
         type(whm_nbody_system),  intent(inout) :: self 
            !! WHM nbody system object
         call self%dealloc()
         return
      end subroutine whm_final_system


      subroutine whm_final_tp(self)
         !! author: David A. Minton
         !!
         !! Finalize the WHM test particle object - deallocates all allocatables
         implicit none
         ! Arguments
         type(whm_tp),  intent(inout) :: self 
            !! WHM test particle object
         call self%dealloc()
         return
      end subroutine whm_final_tp

#ifdef COARRAY

   subroutine whm_coarray_coclone_tp(tp)
      !! author: David A. Minton
      !!
      !! Broadcasts the image 1 object to all other images in a coarray 
      implicit none
      ! Arguments
      type(whm_tp),intent(inout),codimension[*]  :: tp  !! WHM tp object

      call co_broadcast(tp%lfirst,1)
      call co_broadcast(tp%nbody,1)
      call coclone(tp%id)
      call coclone(tp%info)
      call coclone(tp%lmask)
      call coclone(tp%status)
      call coclone(tp%ldiscard)
      call coclone(tp%lcollision)
      call coclone(tp%lencounter)
      call coclone(tp%mu)
      call coclone(tp%rh)
      call coclone(tp%vh)
      call coclone(tp%rb)
      call coclone(tp%vb)
      call coclone(tp%ah)
      call coclone(tp%aobl)
      call coclone(tp%agr)
      call coclone(tp%atide)
      call coclone(tp%isperi)
      call coclone(tp%peri)
      call coclone(tp%atp)
      call coclone(tp%a)
      call coclone(tp%e)
      call coclone(tp%inc)
      call coclone(tp%capom)
      call coclone(tp%omega)
      call coclone(tp%capm) 
      call coclone(tp%nplenc)

      return
   end subroutine whm_coarray_coclone_tp


   subroutine whm_coarray_cocollect_tp(tp)
      !! author: David A. Minton
      !!
      !! Collects all object array components from all images and combines them into the image 1 object
      implicit none
      ! Arguments
      type(whm_tp),intent(inout),codimension[*]  :: tp  !! Swiftest body object

      call co_sum(tp%npltp,1)
      call cocollect(tp%nplenc)
      call co_sum(tp%nbody,1)
      call cocollect(tp%id)
      call cocollect(tp%info)
      call cocollect(tp%lmask)
      call cocollect(tp%status)
      call cocollect(tp%ldiscard)
      call cocollect(tp%lcollision)
      call cocollect(tp%lencounter)
      call cocollect(tp%mu)
      call cocollect(tp%rh)
      call cocollect(tp%vh)
      call cocollect(tp%rb)
      call cocollect(tp%vb)
      call cocollect(tp%ah)
      call cocollect(tp%aobl)
      call cocollect(tp%agr)
      call cocollect(tp%atide)
      call cocollect(tp%ir3h)
      call cocollect(tp%isperi)
      call cocollect(tp%peri)
      call cocollect(tp%atp)
      call cocollect(tp%a)
      call cocollect(tp%e)
      call cocollect(tp%inc)
      call cocollect(tp%capom)
      call cocollect(tp%omega)
      call cocollect(tp%capm)

      return
   end subroutine whm_coarray_cocollect_tp

#endif

end module whm

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module base
         !! author: The Purdue Swiftest Team -  David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott 
         !! 
         !! Base type definitions. This allows the collision and encounter modules to be defined before the swiftest module. 
         !! 
   use globals
#ifdef COARRAY
   use coarray
#endif
   implicit none
   public

   !> User defined parameters that are read in from the parameters input file. 
   !>    Each paramter is initialized to a default values. 
   type, abstract :: base_parameters
      character(STRMAX) :: integrator 
         !! Name of the nbody integrator used  
      character(STRMAX) :: param_file_name                        
         !! The name of the parameter file  
      real(DP)  :: t0 =  0.0_DP 
         !! Integration reference time  
      real(DP) :: tstart = -1.0_DP
         !! Integration start time  
      real(DP) :: tstop = -1.0_DP
         !! Integration stop time  
      real(DP) :: dt = -1.0_DP
         !! Time step 
      integer(I8B) :: iloop = 0_I8B
         !! Main loop counter  
      integer(I8B) :: nloops = 0_I8B
         !! Total number of loops to execute  
      integer(I8B) :: istart = 0_I8B
         !! Starting index for loop counter  
      integer(I4B) :: iout = 0
         !! Output cadence counter  
      integer(I4B) :: idump = 0
         !! Dump cadence counter  
      integer(I4B)      :: nout                 = 0               
         !! Current output step  
      integer(I4B)      :: istep                = 0               
         !! Current value of istep (used for time stretching)  
      character(STRMAX) :: incbfile             = CB_INFILE       
         !! Name of input file for the central body  
      character(STRMAX) :: inplfile             = PL_INFILE       
         !! Name of input file for massive bodies  
      character(STRMAX) :: intpfile             = TP_INFILE       
         !! Name of input file for test particles  
      character(STRMAX) :: nc_in                = NC_INFILE       
         !! Name of system input file for NetCDF input  
      character(STRMAX) :: in_type              = "NETCDF_DOUBLE" 
         !! Data representation type of input data files  
      character(STRMAX) :: in_form              = "XV"            
         !! Format of input data files ("EL" or ["XV"])  
      integer(I4B)      :: istep_out            = -1              
         !! Number of time steps between saved outputs  
      integer(I4B)      :: nstep_out            = -1              
         !! Total number of saved outputs  
      real(DP)          :: fstep_out            = 1.0_DP          
         !! The output step time stretching factor  
      logical           :: ltstretch            = .false.         
         !! Whether to employ time stretching or not  
      character(STRMAX) :: outfile              = BIN_OUTFILE     
         !! Name of output binary file  
      character(STRMAX) :: out_type             = "NETCDF_DOUBLE" 
         !! Binary format of output file  
      character(STRMAX) :: out_form             = "XVEL"          
         !! Data to write to output file  
      character(STRMAX) :: out_stat             = 'NEW'           
         !! Open status for output binary file  
      integer(I4B)      :: dump_cadence         =  10             
         !! Number of output steps between dumping simulation data to file  
      real(DP)          :: rmin                 = -1.0_DP         
         !! Minimum heliocentric radius for test particle  
      real(DP)          :: rmax                 = -1.0_DP         
         !! Maximum heliocentric radius for test particle  
      real(DP)          :: rmaxu                = -1.0_DP         
         !! Maximum unbound heliocentric radius for test particle  
      real(DP)          :: qmin                 = -1.0_DP         
         !! Minimum pericenter distance for test particle 
      character(STRMAX) :: qmin_coord           = "HELIO"         
         !! Coordinate frame to use for qmin (["HELIO"] or "BARY") 
      real(DP)          :: qmin_alo             = -1.0_DP         
         !! Minimum semimajor axis for qmin 
      real(DP)          :: qmin_ahi             = -1.0_DP         
         !! Maximum semimajor axis for qmin 
      real(QP)          :: MU2KG                = -1.0_QP         
         !! Converts mass units to grams 
      real(QP)          :: TU2S                 = -1.0_QP         
         !! Converts time units to seconds 
      real(QP)          :: DU2M                 = -1.0_QP         
         !! Converts distance unit to centimeters 
      real(DP)          :: GU                   = -1.0_DP         
         !! Universal gravitational constant in the system units 
      real(DP)          :: inv_c2               = -1.0_DP         
         !! Inverse speed of light squared in the system units 
      real(DP)          :: GMTINY               = -1.0_DP         
         !! Smallest G*mass that is fully gravitating 
      real(DP)          :: min_GMfrag           = -1.0_DP         
         !! Smallest G*mass that can be produced in a fragmentation event 
      real(DP)          :: nfrag_reduction      =  30.0_DP        
         !! Reduction factor for limiting the number of collision fragments  
      integer(I4B), dimension(:), allocatable :: seed             
         !! Random seeds for fragmentation modeling 
      logical           :: lmtiny_pl            = .false.         
         !! Include semi-interacting massive bodies 
      character(STRMAX) :: collision_model      = "MERGE"         
         !! The Coll 
      character(STRMAX) :: encounter_save       = "NONE"          
         !! Indicate if and how encounter data should be saved 
      logical           :: lenc_save_trajectory = .false.         
         !! Indicates that when encounters are saved, the full trajectory through recursion steps are saved 
      logical           :: lenc_save_closest    = .false.         
         !! Indicates that when encounters are saved, the closest approach distance between pairs of bodies is saved 
      character(NAMELEN):: interaction_loops    = "ADAPTIVE"      
         !! Method used to compute interaction loops.  
         !!    Options are "TRIANGULAR", "FLAT", or "ADAPTIVE"  
      character(NAMELEN):: encounter_check_plpl = "ADAPTIVE"      
         !! Method used to compute pl-pl encounter checks.  
         !!    Options are "TRIANGULAR", "SORTSWEEP", or "ADAPTIVE"  
      character(NAMELEN):: encounter_check_pltp = "ADAPTIVE"      
         !! Method used to compute pl-tp encounter checks.  
         !!    Options are "TRIANGULAR", "SORTSWEEP", or "ADAPTIVE"  
      logical           :: lcoarray             = .false.         
         !! Use Coarrays for test particle parallelization. 

      ! The following are not set by the user, but instead are determined by the input value of INTERACTION_LOOPS
      logical :: lflatten_interactions     = .false. 
         !! Use the flattened upper triangular matrix for pl-pl interaction loops 
      logical :: lencounter_sas_plpl       = .false. 
         !! Use the Sort and Sweep algorithm to prune the encounter list before checking for close encounters 
      logical :: lencounter_sas_pltp       = .false. 
         !! Use the Sort and Sweep algorithm to prune the encounter list before checking for close encounters 

      ! Logical flags to turn on or off various features of the code
      logical :: lrhill_present = .false. 
         !! Hill radii are given as an input rather than calculated by the code (can be used to  inflate close encounter regions 
         !! manually) 
      logical :: lextra_force   = .false. 
         !! User defined force function turned on 
      logical :: lbig_discard   = .false. 
         !! Save big bodies on every discard 
      logical :: lclose         = .false. 
         !! Turn on close encounters 
      logical :: lenergy        = .false. 
         !! Track the total energy of the system 
      logical :: lnon_spherical_cb = .false. 
         !! Calculate acceleration from oblate central body (automatically turns true if nonzero J2, J4, or c_lm is input) 
      logical :: lrotation      = .false. 
         !! Include rotation states of big bodies 
      logical :: ltides         = .false. 
         !! Include tidal dissipation  

      ! Initial values to pass to the energy report subroutine (usually only used in the case of a restart, otherwise these will be 
      ! updated with initial conditions values)
      real(DP)                  :: E_orbit_orig = 0.0_DP  
         !! Initial orbital energy 
      real(DP)                  :: GMtot_orig   = 0.0_DP  
         !! Initial system mass 
      real(DP), dimension(NDIM) :: L_total_orig = 0.0_DP  
         !! Initial total angular momentum vector 
      real(DP), dimension(NDIM) :: L_orbit_orig = 0.0_DP  
         !! Initial orbital angular momentum 
      real(DP), dimension(NDIM) :: L_spin_orig  = 0.0_DP  
         !! Initial spin angular momentum vector 
      real(DP), dimension(NDIM) :: L_escape     = 0.0_DP  
         !! Angular momentum of escaped bodies (used for bookeeping) 
      real(DP)                  :: GMescape     = 0.0_DP  
         !! Mass of bodies that escaped the system (used for bookeeping) 
      real(DP)                  :: E_collisions = 0.0_DP  
         !! Energy lost from system due to collisions 
      real(DP)                  :: E_untracked  = 0.0_DP  
         !! Energy gained from system due to escaped bodies 
      logical                   :: lfirstenergy = .true.  
         !! This is the first time computing energe 
      logical                   :: lfirstkick   = .true.  
         !! Initiate the first kick in a symplectic step 
      logical                   :: lrestart     = .false. 
         !! Indicates whether or not this is a restarted run 

      character(NAMELEN)       :: display_style        
         !! Style of the output display {["STANDARD"], "COMPACT"}).  
      integer(I4B)             :: display_unit = OUTPUT_UNIT  
         !! File unit number for display (either to stdout or to a log file) 
      logical                  :: log_output  = .false. 
         !! Logs the output to file instead of displaying it on the terminal 

      ! Future features not implemented or in development
      logical :: lgr        = .false. 
         !! Turn on GR 
      logical :: lyarkovsky = .false. 
         !! Turn on Yarkovsky effect 
      logical :: lyorp      = .false. 
         !! Turn on YORP effect 
   contains
      procedure :: dealloc => base_util_dealloc_param
      procedure(abstract_io_dump_param),      deferred :: dump
      procedure(abstract_io_param_reader),    deferred :: reader
      procedure(abstract_io_param_writer),    deferred :: writer    
      procedure(abstract_io_read_in_param),   deferred :: read_in 
#ifdef COARRAY
      procedure :: coclone => base_coclone_param
#endif
   end type base_parameters

   abstract interface
      subroutine abstract_io_dump_param(self, param_file_name)
         import base_parameters
         implicit none
         class(base_parameters),intent(in)    :: self            
            !! Output collection of parameters 
         character(len=*),      intent(in)    :: param_file_name 
            !! Parameter input file name (i.e. param.in) 
      end subroutine abstract_io_dump_param

      subroutine abstract_io_param_reader(self, unit, iotype, v_list, iostat, iomsg) 
         import base_parameters, I4B
         implicit none
         class(base_parameters), intent(inout) :: self       
            !! Collection of parameters 
         integer(I4B),           intent(in)    :: unit       
            !! File unit number 
         character(len=*),       intent(in)    :: iotype     
            !! Dummy argument passed to the  input/output procedure contains the  text from the char-literal-constant, prefixed with
            !! DT. If you do not include a char-literal-constant, the iotype argument contains  only DT. 
         character(len=*),       intent(in)    :: v_list(:)  
            !! The first element passes the integrator code to the reader 
         integer(I4B),           intent(out)   :: iostat     
               !! IO status code 
         character(len=*),       intent(inout) :: iomsg      
            !! Message to pass if iostat /= 0 
      end subroutine abstract_io_param_reader

      subroutine abstract_io_param_writer(self, unit, iotype, v_list, iostat, iomsg) 
         import base_parameters, I4B
         implicit none
         class(base_parameters), intent(in)    :: self      
            !! Collection of parameters 
         integer(I4B),           intent(in)    :: unit      
            !! File unit number 
         character(len=*),       intent(in)    :: iotype    
            !! Dummy argument passed to the  input/output procedure contains the  
                                                            
            !!    text from the char-literal-constant, prefixed with DT. If you do  
                                                            
            !!    not include a char-literal-constant, the iotype argument contains  
                                                            
            !!    only DT. 
         integer(I4B),           intent(in)    :: v_list(:) 
            !! Not used in this procedure 
         integer(I4B),           intent(out)   :: iostat    
            !! IO status code 
         character(len=*),       intent(inout) :: iomsg     
            !! Message to pass if iostat /= 0 
      end subroutine abstract_io_param_writer

      subroutine abstract_io_read_in_param(self, param_file_name) 
         import base_parameters
         implicit none
         class(base_parameters), intent(inout) :: self            
            !! Current run configuration parameters 
         character(len=*),       intent(in)    :: param_file_name 
            !! Parameter input file name (i.e. param.in) 
      end subroutine abstract_io_read_in_param
   end interface


   type :: base_storage_frame
      class(*), allocatable :: item
   contains
      procedure :: store         => base_util_copy_store       
            !! Stores a snapshot of the nbody system so that later it can be  
                                                               
            !!    retrieved for saving to file. 
      generic   :: assignment(=) => store
      final     ::                  base_final_storage_frame
   end type


   type, abstract :: base_storage
      
         !! An class that establishes the pattern for various storage objects 
      integer(I4B) :: nframes 
         !! Total number of frames that can be stored An class that establishes the pattern for various storage objects 
      type(base_storage_frame), dimension(:), allocatable :: frame      
         !! Array of stored frames 
      integer(I4B)                                        :: iframe = 0 
         !! Index of the last frame stored in the system 
      integer(I4B)                                        :: nid        
         !! Number of unique id values in all saved snapshots 
      integer(I4B),             dimension(:), allocatable :: idvals     
         !! The set of unique id values contained in the snapshots 
      integer(I4B),             dimension(:), allocatable :: idmap      
         !! The id value -> index map   
      integer(I4B)                                        :: nt         
         !! Number of unique time values in all saved snapshots 
      real(DP),                 dimension(:), allocatable :: tvals      
         !! The set of unique time values contained in the snapshots 
      integer(I4B),             dimension(:), allocatable :: tmap       
         !! The t value -> index map 
   contains
      procedure :: dealloc => base_util_dealloc_storage 
         !! Deallocates all allocatables 
      procedure :: reset   => base_util_reset_storage   
         !! Resets the storage object back to its original state by removing all of the saved items from the storage frames 
      procedure :: resize  => base_util_resize_storage  
         !! Resizes storage if it is too small  
      procedure :: setup   => base_util_setup_storage   
         !! Sets up a storage system with a set number of frames 
      procedure :: save    => base_util_snapshot_save   
         !! Takes a snapshot of the current system 
   end type base_storage


   !> Class definition for the particle origin information object. This object is used to track time, location, and collisional 
   !> regime of fragments produced in collisional events.
   type, abstract :: base_particle_info
   end type base_particle_info


   !> An abstract class for a generic collection of Swiftest bodies
   type, abstract :: base_object
   contains
      procedure(abstract_util_dealloc_object), deferred :: dealloc
   end type base_object

   abstract interface
      subroutine abstract_util_dealloc_object(self)
         import base_object
         implicit none
         class(base_object), intent(inout) :: self 
            !! Generic Swiftest object type 
      end subroutine abstract_util_dealloc_object
   end interface


   !> Class definition for the kinship relationships used in bookkeeping multiple collisions bodies in a single time step.
   type, abstract :: base_kinship
   end type base_kinship
      

   !> An abstract class for a basic Swiftest nbody system 
   type, abstract :: base_nbody_system
   end type base_nbody_system


   interface util_append
      module procedure base_util_append_arr_char_string
      module procedure base_util_append_arr_DP
      module procedure base_util_append_arr_DPvec
      module procedure base_util_append_arr_I4B
      module procedure base_util_append_arr_logical
   end interface

   interface util_fill
      module procedure base_util_fill_arr_char_string
      module procedure base_util_fill_arr_DP
      module procedure base_util_fill_arr_DPvec
      module procedure base_util_fill_arr_I4B
      module procedure base_util_fill_arr_logical
   end interface

   interface util_resize
      module procedure base_util_resize_arr_char_string
      module procedure base_util_resize_arr_DP
      module procedure base_util_resize_arr_DPvec
      module procedure base_util_resize_arr_I4B
      module procedure base_util_resize_arr_logical
   end interface

   interface util_sort      
      module procedure base_util_sort_i4b
      module procedure base_util_sort_index_i4b
      module procedure base_util_sort_index_I4B_I8Bind
      module procedure base_util_sort_index_I8B_I8Bind
      module procedure base_util_sort_sp
      module procedure base_util_sort_index_sp
      module procedure base_util_sort_dp
      module procedure base_util_sort_index_dp
   end interface 

   interface util_sort_rearrange
      module procedure base_util_sort_rearrange_arr_char_string
      module procedure base_util_sort_rearrange_arr_DP
      module procedure base_util_sort_rearrange_arr_DPvec
      module procedure base_util_sort_rearrange_arr_I4B
      module procedure base_util_sort_rearrange_arr_I4B_I8Bind
      module procedure base_util_sort_rearrange_arr_logical
      module procedure base_util_sort_rearrange_arr_logical_I8Bind
   end interface

   interface util_spill
      module procedure base_util_spill_arr_char_string
      module procedure base_util_spill_arr_DP
      module procedure base_util_spill_arr_DPvec
      module procedure base_util_spill_arr_I4B
      module procedure base_util_spill_arr_I8B
      module procedure base_util_spill_arr_logical
   end interface

   interface util_unique
      module procedure base_util_unique_DP
      module procedure base_util_unique_I4B
   end interface

   contains

      subroutine base_util_append_arr_char_string(arr, source, nold, lsource_mask)
         
         !! author: David A. Minton 
         !! 
         !! Append a single array of character string type onto another. If the destination array is not allocated, or is not big  
         !! enough, this will allocate space for it. 
         implicit none
         ! Arguments
         character(len=STRMAX), dimension(:), allocatable, intent(inout) :: arr    
            !! Destination array  
         character(len=STRMAX), dimension(:), allocatable, intent(in)    :: source 
            !! Array to append  
         integer(I4B), intent(in), optional :: nold 
            !! Extent of original array. If passed, the source array will begin at  arr(nold+1). 
            !! Otherwise, the size of arr will be used. 
         logical, dimension(:), intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to 
         ! Internals
         integer(I4B) :: nnew, nsrc, nend_orig

         if (.not.allocated(source)) return

         if (present(lsource_mask)) then
            nsrc = count(lsource_mask(:))
         else
            nsrc = size(source)
         end if
         if (nsrc == 0) return

         if (.not.allocated(arr)) then
            nend_orig = 0
            allocate(arr(nsrc))
         else
            if (present(nold)) then
               nend_orig = nold
            else
               nend_orig = size(arr)
            end if
            call util_resize(arr, nend_orig + nsrc)
         end if
         nnew = nend_orig + nsrc

         if (present(lsource_mask)) then
            arr(nend_orig + 1:nnew) = pack(source(1:nsrc), lsource_mask(1:nsrc))
         else
            arr(nend_orig + 1:nnew) = source(1:nsrc)
         end if

         return
      end subroutine base_util_append_arr_char_string


      subroutine base_util_append_arr_DP(arr, source, nold, lsource_mask)
         !! author: David A. Minton 
         !! 
         !! Append a single array of double precision type onto another. If the destination array is not allocated, or is not big  
         !! enough, this will allocate space for it. 
         implicit none
         ! Arguments
         real(DP), dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         real(DP), dimension(:), allocatable, intent(in) :: source 
            !! Array to append  
         integer(I4B), intent(in), optional :: nold 
            !! Extent of original array. If passed, the source array will begin at  
                                                    
            !!   arr(nold+1). Otherwise, the size of arr will be used. 
         logical,  dimension(:), intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to 
         ! Internals
         integer(I4B) :: nnew, nsrc, nend_orig

         if (.not.allocated(source)) return

         if (present(lsource_mask)) then
            nsrc = count(lsource_mask(:))
         else
            nsrc = size(source)
         end if
         if (nsrc == 0) return

         if (.not.allocated(arr)) then
            nend_orig = 0
            allocate(arr(nsrc))
         else
            if (present(nold)) then
               nend_orig = nold
            else
               nend_orig = size(arr)
            end if
            call util_resize(arr, nend_orig + nsrc)
         end if
         nnew = nend_orig + nsrc

         if (present(lsource_mask)) then
            arr(nend_orig + 1:nnew) = pack(source(1:nsrc), lsource_mask(1:nsrc))
         else
            arr(nend_orig + 1:nnew) = source(1:nsrc)
         end if

         return
      end subroutine base_util_append_arr_DP


      subroutine base_util_append_arr_DPvec(arr, source, nold, lsource_mask)
         !! author: David A. Minton 
         !! 
         !! Append a single array of double precision vector type of size (NDIM, n) onto another. If the destination array is not  
         !! allocated, or is not big enough, this will allocate space for it. 
         implicit none
         ! Arguments
         real(DP), dimension(:,:), allocatable, intent(inout) :: arr       
            !! Destination array  
         real(DP), dimension(:,:), allocatable, intent(in) :: source       
            !! Array to append  
         integer(I4B), intent(in), optional :: nold 
            !! Extent of original array. If passed, the source array will begin at arr(nold+1). 
            !! Otherwise, the size of arr will be used. 
         logical,  dimension(:), intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to 
         ! Internals
         integer(I4B) :: nnew, nsrc, nend_orig

         if (.not.allocated(source)) return

         if (present(lsource_mask)) then
            nsrc = count(lsource_mask(:))
         else
            nsrc = size(source,dim=2)
         end if
         if (nsrc == 0) return

         if (.not.allocated(arr)) then
            nend_orig = 0
            allocate(arr(NDIM,nsrc))
         else
            if (present(nold)) then
               nend_orig = nold
            else
               nend_orig = size(arr,dim=2)
            end if
            call util_resize(arr, nend_orig + nsrc)
         end if
         nnew = nend_orig + nsrc

         if (present(lsource_mask)) then
            arr(1, nend_orig + 1:nnew) = pack(source(1,1:nsrc), lsource_mask(1:nsrc))
            arr(2, nend_orig + 1:nnew) = pack(source(2,1:nsrc), lsource_mask(1:nsrc))
            arr(3, nend_orig + 1:nnew) = pack(source(3,1:nsrc), lsource_mask(1:nsrc))
         else
            arr(:,nend_orig + 1:nnew) = source(:,1:nsrc)
         end if

         return
      end subroutine base_util_append_arr_DPvec


      subroutine base_util_append_arr_I4B(arr, source, nold, lsource_mask)
         !! author: David A. Minton 
         !! 
         !! Append a single array of integer(I4B) onto another. If the destination array is not allocated, or is not big enough,
         !! this will allocate space for it. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), allocatable, intent(inout) :: arr          
            !! Destination array  
         integer(I4B), dimension(:), allocatable, intent(in)    :: source       
            !! Array to append  
         integer(I4B), intent(in), optional :: nold 
            !! Extent of original array. If passed, the source array will begin at arr(nold+1).
            !! Otherwise, the size of arr will be used. 
         logical, dimension(:), intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to 
         ! Internals
         integer(I4B) :: nnew, nsrc, nend_orig

         if (.not.allocated(source)) return

         if (present(lsource_mask)) then
            nsrc = count(lsource_mask(:))
         else
            nsrc = size(source)
         end if
         if (nsrc == 0) return

         if (.not.allocated(arr)) then
            nend_orig = 0
            allocate(arr(nsrc))
         else
            if (present(nold)) then
               nend_orig = nold
            else
               nend_orig = size(arr)
            end if
            call util_resize(arr, nend_orig + nsrc)
         end if
         nnew = nend_orig + nsrc

         if (present(lsource_mask)) then
            arr(nend_orig + 1:nnew) = pack(source(1:nsrc), lsource_mask(1:nsrc))
         else
            arr(nend_orig + 1:nnew) = source(1:nsrc)
         end if

         return
      end subroutine base_util_append_arr_I4B


      subroutine base_util_append_arr_logical(arr, source, nold, lsource_mask)
         !! author: David A. Minton 
         !! 
         !! Append a single array of logical type onto another. If the destination array is not allocated, or is not big enough,
         !! this will allocate space for it. 
         implicit none
         ! Arguments
         logical, dimension(:), allocatable, intent(inout) :: arr          
            !! Destination array  
         logical, dimension(:), allocatable, intent(in)    :: source       
            !! Array to append  
         integer(I4B), intent(in), optional :: nold   
            !! Extent of original array. If passed, the source array will begin at arr(nold+1). 
            !! Otherwise, the size of arr will be used. 
         logical, dimension(:), intent(in), optional :: lsource_mask 
            !! Logical mask indicating which elements to append to 
         ! Internals
         integer(I4B) :: nnew, nsrc, nend_orig

         if (.not.allocated(source)) return

         if (present(lsource_mask)) then
            nsrc = count(lsource_mask(:))
         else
            nsrc = size(source)
         end if
         if (nsrc == 0) return

         if (.not.allocated(arr)) then
            nend_orig = 0
            allocate(arr(nsrc))
         else
            if (present(nold)) then
               nend_orig = nold
            else
               nend_orig = size(arr)
            end if
            call util_resize(arr, nend_orig + nsrc)
         end if
         nnew = nend_orig + nsrc
         
         if (present(lsource_mask)) then
            arr(nend_orig + 1:nnew) = pack(source(1:nsrc), lsource_mask(1:nsrc))
         else
            arr(nend_orig + 1:nnew) = source(:)
         end if

         return
      end subroutine base_util_append_arr_logical


      subroutine base_util_copy_store(self, source)
         !! author: David A. Minton 
         !! 
         !! Stores a snapshot of the nbody system so that later it can be retrieved for saving to file. 
         implicit none
         class(base_storage_frame),  intent(inout) :: self   
            !! Swiftest storage frame object 
         class(*),                   intent(in)    :: source 
            !! Swiftest n-body system object 

         if (allocated(self%item)) deallocate(self%item)
         allocate(self%item, source=source)
         
         return
      end subroutine base_util_copy_store 


      subroutine base_util_dealloc_param(self)
         !! author: David A. Minton 
         !! 
         !! Deallocates all allocatables 
         implicit none
         ! Arguments
         class(base_parameters),intent(inout)  :: self  
            !! Collection of parameters 

         if (allocated(self%seed)) deallocate(self%seed)

         return
      end subroutine base_util_dealloc_param


      subroutine base_util_dealloc_storage(self)
         !! author: David A. Minton 
         !! 
         !! Resets a storage object by deallocating all items and resetting the frame counter to 0 
         implicit none
         ! Arguments
         class(base_storage), intent(inout) :: self 
            !! Swiftest storage object 

         call self%reset()
         if (allocated(self%frame)) deallocate(self%frame)
         self%nframes = 0
   
         return
      end subroutine base_util_dealloc_storage


      subroutine base_util_exit(code,unit)
         !! author: David A. Minton 
         !! 
         !! Print termination message and exit program 
         !! 
         !! Adapted from David E. Kaufmann's Swifter routine: base_util_exit.f90 
         !! Adapted from Hal Levison's Swift routine base_util_exit.f 
         implicit none
         ! Arguments
         integer(I4B), intent(in) :: code
         integer(I4B), intent(in), optional :: unit
         ! Internals
         character(*), parameter :: BAR = '("---------------------------------------------------")'
         character(*), parameter :: SUCCESS_MSG = '(/, "Normal termination of Swiftest (version ", A, ")")'
         character(*), parameter :: FAIL_MSG = '(/, "Terminating Swiftest (version ", A, ") due to error!")' 
         character(*), parameter :: USAGE_MSG = '("Usage: swiftest_driver <whm|helio|rmvs|symba> <paramfile> ' // &
                                                '[{standard}|compact|progress]")'
         character(*), parameter :: HELP_MSG  = USAGE_MSG
         integer(I4B) :: iu

         if (present(unit)) then
            iu = unit
         else
            iu = OUTPUT_UNIT
         end if
   
         select case(code)
         case(SUCCESS)
            write(iu, SUCCESS_MSG) VERSION
            write(iu, BAR)
         case(USAGE) 
            write(iu, USAGE_MSG)
         case(HELP)
            write(iu, HELP_MSG)
         case default
            write(iu, FAIL_MSG) VERSION
            write(iu, BAR)
            stop 
         end select
   
         stop
   
      end subroutine base_util_exit


      subroutine base_util_fill_arr_char_string(keeps, inserts, lfill_list)
         !! author: David A. Minton 
         !! 
         !! Performs a fill operation on a single array of type character strings.
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         character(len=STRMAX), dimension(:), allocatable, intent(inout) :: keeps      
         !! Array of values to keep  
         character(len=STRMAX), dimension(:), allocatable, intent(in)    :: inserts    
         !! Array of values to insert into keep 
         logical,               dimension(:),              intent(in)    :: lfill_list 
         !! Logical array of bodies to merge into the  
                                                                                       
         !!    keeps 
   
         if (.not.allocated(keeps) .or. .not.allocated(inserts)) return
   
         keeps(:) = unpack(keeps(:),   .not.lfill_list(:), keeps(:))
         keeps(:) = unpack(inserts(:),      lfill_list(:), keeps(:))
   
         return
      end subroutine base_util_fill_arr_char_string
   
   
      subroutine base_util_fill_arr_DP(keeps, inserts, lfill_list)
         !! author: David A. Minton 
         !! 
         !! Performs a fill operation on a single array of type DP.
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         real(DP), dimension(:), allocatable, intent(inout) :: keeps      
            !! Array of values to keep  
         real(DP), dimension(:), allocatable, intent(in)    :: inserts    
            !! Array of values to insert into keep 
         logical,  dimension(:),              intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps 
   
         if (.not.allocated(keeps) .or. .not.allocated(inserts)) return
   
         keeps(:) = unpack(keeps(:),   .not.lfill_list(:), keeps(:))
         keeps(:) = unpack(inserts(:),      lfill_list(:), keeps(:))
   
         return
      end subroutine base_util_fill_arr_DP
   
   
      subroutine base_util_fill_arr_DPvec(keeps, inserts, lfill_list)
         !! author: David A. Minton 
         !! 
         !! Performs a fill operation on a single array of DP vectors with shape (NDIM, n) 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         real(DP), dimension(:,:), allocatable, intent(inout) :: keeps      
            !! Array of values to keep  
         real(DP), dimension(:,:), allocatable, intent(in)    :: inserts    
            !! Array of values to insert into keep 
         logical,  dimension(:),                intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps 
         ! Internals
         integer(I4B) :: i
   
         if (.not.allocated(keeps) .or. .not.allocated(inserts)) return
   
         do i = 1, NDIM
            keeps(i,:) = unpack(keeps(i,:),   .not.lfill_list(:), keeps(i,:))
            keeps(i,:) = unpack(inserts(i,:),      lfill_list(:), keeps(i,:))
         end do
   
         return
      end subroutine base_util_fill_arr_DPvec
   
   
      subroutine base_util_fill_arr_I4B(keeps, inserts, lfill_list)
         !! author: David A. Minton 
         !! 
         !! Performs a fill operation on a single array of type I4B 
                  !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), allocatable, intent(inout) :: keeps      
            !! Array of values to keep  
         integer(I4B), dimension(:), allocatable, intent(in)    :: inserts    
            !! Array of values to insert into keep 
         logical,      dimension(:),              intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps 
   
         if (.not.allocated(keeps) .or. .not.allocated(inserts)) return
   
         keeps(:) = unpack(keeps(:),   .not.lfill_list(:), keeps(:))
         keeps(:) = unpack(inserts(:),      lfill_list(:), keeps(:))
   
         return
      end subroutine base_util_fill_arr_I4B
   
   
      subroutine base_util_fill_arr_logical(keeps, inserts, lfill_list)
         !! author: David A. Minton 
         !! 
         !! Performs a fill operation on a single array of logicals 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         logical, dimension(:), allocatable, intent(inout) :: keeps      
            !! Array of values to keep  
         logical, dimension(:), allocatable, intent(in)    :: inserts    
            !! Array of values to insert into keep 
         logical, dimension(:),              intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps 
   
         if (.not.allocated(keeps) .or. .not.allocated(inserts)) return
   
         keeps(:) = unpack(keeps(:),   .not.lfill_list(:), keeps(:))
         keeps(:) = unpack(inserts(:),      lfill_list(:), keeps(:))
   
         return
      end subroutine base_util_fill_arr_logical      

      subroutine base_util_reset_storage(self)
         !! author: David A. Minton 
         !! 
         !! Resets the storage object back to its original state by removing all of the saved items from the storage frames, but  
         !! does not deallocate the frames 
         implicit none
         ! Arguments
         class(base_storage), intent(inout) :: self
         ! Internals
         integer(I4B) :: i
 
         if (allocated(self%frame)) then
            do i = 1, self%nframes
               if (allocated(self%frame(i)%item)) deallocate(self%frame(i)%item)
            end do
         end if

         if (allocated(self%idmap)) deallocate(self%idmap)
         if (allocated(self%idvals)) deallocate(self%idvals)
         if (allocated(self%tmap)) deallocate(self%tmap)
         if (allocated(self%tvals)) deallocate(self%tvals)
         self%nid = 0
         self%nt = 0
         self%iframe = 0

         return
      end subroutine base_util_reset_storage 


      subroutine base_util_resize_arr_char_string(arr, nnew)
         !! author: David A. Minton 
         !! 
         !! Resizes an array component of type character string. nnew = 0 will deallocate. 
         implicit none
         ! Arguments
         character(len=STRMAX), dimension(:), allocatable, intent(inout) :: arr  
            !! Array to resize 
         integer(I4B),                                     intent(in)    :: nnew 
            !! New size 
         ! Internals
         character(len=STRMAX), dimension(:), allocatable :: tmp 
            !! Temp. storage array in case the input array is already allocated 
         integer(I4B) :: nold 
            !! Old size 
   
         if (nnew < 0) return
   
         if (nnew == 0) then
            if (allocated(arr)) deallocate(arr)
            return
         end if
         
         if (allocated(arr)) then
            nold = size(arr)
         else
            nold = 0
         end if
   
         if (nnew == nold) return
         
         allocate(tmp(nnew))
         if (nold > 0) then
            if (nnew > nold) then
               tmp(1:nold) = arr(1:nold)
               tmp(nold+1:nnew) = ""
            else
               tmp(1:nnew) = arr(1:nnew)
            end if
         else
            tmp(1:nnew) = ""
         end if
         call move_alloc(tmp, arr)
   
         return
      end subroutine base_util_resize_arr_char_string
   
   
      subroutine base_util_resize_arr_DP(arr, nnew)
         !! author: David A. Minton 
         !! 
         !! Resizes an array component of double precision type. Passing nnew = 0 will deallocate. 
         implicit none
         ! Arguments
         real(DP), dimension(:), allocatable, intent(inout) :: arr  
            !! Array to resize 
         integer(I4B),                        intent(in)    :: nnew 
            !! New size 
         ! Internals
         real(DP), dimension(:), allocatable :: tmp 
            !! Temporary storage array in case the input array is already allocated 
         integer(I4B) :: nold 
            !! Old size 
         real(DP), parameter :: init_val = 0.0_DP
   
         if (nnew < 0) return
   
         if (nnew == 0) then
            if (allocated(arr)) deallocate(arr)
            return
         end if
         
         if (allocated(arr)) then
            nold = size(arr)
         else
            nold = 0
         end if
   
         if (nnew == nold) return
         
         allocate(tmp(nnew))
         if (nold > 0) then
            if (nnew > nold) then
               tmp(1:nold) = arr(1:nold)
               tmp(nold+1:nnew) = init_val
            else
               tmp(1:nnew) = arr(1:nnew)
            end if
         else
            tmp(1:nnew) = init_val
         end if
         call move_alloc(tmp, arr)
   
         return
      end subroutine base_util_resize_arr_DP
   
   
      subroutine base_util_resize_arr_DPvec(arr, nnew)
         !! author: David A. Minton 
         !! 
         !! Resizes an array component of double precision vectors of size (NDIM, n). Passing nnew = 0 will deallocate. 
         implicit none
         ! Arguments
         real(DP), dimension(:,:), allocatable, intent(inout) :: arr  
            !! Array to resize 
         integer(I4B),                          intent(in)    :: nnew 
            !! New size 
         ! Internals
         real(DP), dimension(:,:), allocatable :: tmp 
            !! Temporary storage array in case the input array is already allocated 
         integer(I4B) :: nold 
            !! Old size 
         real(DP), dimension(NDIM), parameter :: init_val = 0.0_DP
         integer(I4B) :: i
   
         if (nnew < 0) return
   
         if (nnew == 0) then
            if (allocated(arr)) deallocate(arr)
            return
         end if
         
         if (allocated(arr)) then
            nold = size(arr, dim=2)
         else
            nold = 0
         end if
   
         if (nnew == nold) return
         
         allocate(tmp(NDIM, nnew))
         if (nold > 0) then
            if (nnew > nold) then
               tmp(:,1:nold) = arr(:,1:nold)
               do i = nold+1, nnew
                  tmp(:,i) = init_val(:)
               end do
            else
               tmp(:,1:nnew) = arr(:,1:nnew)
            end if
         else
            do i = 1, nnew
               tmp(:, i) = init_val(:)
            end do
         end if
         call move_alloc(tmp, arr)
   
         return
   
         return
      end subroutine base_util_resize_arr_DPvec
   
   
      subroutine base_util_resize_arr_I4B(arr, nnew)
         !! author: David A. Minton 
         !! 
         !! Resizes an array component of integer type. Passing nnew = 0 will deallocate. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), allocatable, intent(inout) :: arr  
            !! Array to resize 
         integer(I4B),                            intent(in)    :: nnew 
            !! New size 
         ! Internals
         integer(I4B), dimension(:), allocatable :: tmp 
            !! Temporary storage array in case the input array is already allocated 
         integer(I4B) :: nold 
            !! Old size 
         integer(I4B), parameter :: init_val = -1
   
         if (nnew < 0) return
   
         if (nnew == 0) then
            if (allocated(arr)) deallocate(arr)
            return
         end if
         
         if (allocated(arr)) then
            nold = size(arr)
         else
            nold = 0
         end if
   
         if (nnew == nold) return
         
         allocate(tmp(nnew))
         if (nold > 0) then
            if (nnew > nold) then
               tmp(1:nold) = arr(1:nold)
               tmp(nold+1:nnew) = init_val
            else
               tmp(1:nnew) = arr(1:nnew)
            end if
         else
            tmp(1:nnew) = init_val
         end if
         call move_alloc(tmp, arr)
   
         return
      end subroutine base_util_resize_arr_I4B
   

      subroutine base_util_resize_arr_logical(arr, nnew)
         !! author: David A. Minton 
         !! 
         !! Resizes an array component of logical type. Passing nnew = 0 will deallocate. 
         implicit none
         ! Arguments
         logical, dimension(:), allocatable, intent(inout) :: arr  
            !! Array to resize 
         integer(I4B),                       intent(in)    :: nnew 
            !! New size 
         ! Internals
         logical, dimension(:), allocatable :: tmp 
            !! Temporary storage array in case the input array is already allocated 
         integer(I4B) :: nold 
            !! Old size 
         logical, parameter :: init_val = .false.
 
         if (nnew < 0) return
   
         if (nnew == 0) then
            if (allocated(arr)) deallocate(arr)
            return
         end if
         
         if (allocated(arr)) then
            nold = size(arr)
         else
            nold = 0
         end if
   
         if (nnew == nold) return
         
         allocate(tmp(nnew))
         if (nold > 0) then
            if (nnew > nold) then
               tmp(1:nold) = arr(1:nold)
               tmp(nold+1:nnew) = init_val
            else
               tmp(1:nnew) = arr(1:nnew)
            end if
         else
            tmp = init_val
         end if
         call move_alloc(tmp, arr)
   
         return
      end subroutine base_util_resize_arr_logical
   
      
      subroutine base_util_resize_storage(self, nnew)
         !! author: David A. Minton 
         !! 
         !! Checks the current size of a Swiftest against the requested size and resizes it if it is too small. 
         implicit none
         ! Arguments
         class(base_storage), intent(inout) :: self 
            !! Storage object 
         integer(I4B),        intent(in)    :: nnew 
            !! New size 
         ! Internals
         class(base_storage_frame), dimension(:), allocatable :: tmp
         integer(I4B) :: i, nold, nbig
  
         nold = self%nframes
         if (nnew <= nold) return
   
         nbig = nold
         do while (nbig < nnew)
            nbig = nbig * 2
         end do
         call move_alloc(self%frame, tmp)
         allocate(self%frame(nbig))
         self%nframes = nbig
         do i = 1, nold
            if (allocated(tmp(i)%item)) call move_alloc(tmp(i)%item, self%frame(i)%item)
         end do
   
         return
      end subroutine base_util_resize_storage 


      subroutine base_util_setup_storage(self, n)
         !! author: David A. Minton 
         !! 
         !! Checks the current size of a Swiftest against the requested size and resizes it if it is too small. 
         implicit none
         ! Arguments
         class(base_storage), intent(inout) :: self 
            !! Storage object 
         integer(I4B),        intent(in)    :: n    
            !! New size 

         if (allocated(self%frame)) deallocate(self%frame)
         allocate(self%frame(n))
         self%nframes = n
   
         return
      end subroutine base_util_setup_storage 
  
      
      subroutine base_util_snapshot_save(self, snapshot)
         !! author: David A. Minton 
         !! 
         !! Checks the current size of the storage object against the required size and extends it by a factor of 2 more than  
         !! requested if it is too small.   
         !! Note: The reason to extend it by a factor of 2 is for performance. When there are many enounters per step, resizing  
         !! every time you want to add an encounter takes significant computational effort. Resizing by a factor of 2 is a tradeoff  
         !! between performance (fewer resize calls) and memory managment. Memory usage grows by a factor of 2 each time it fills  
         !! up, but no more.  
         implicit none
         ! Arguments
         class(base_storage), intent(inout) :: self     
            !! Storage encounter storage object 
         class(*),            intent(in)    :: snapshot 
            !! Object to snapshot 
         ! Internals
         integer(I4B) :: nnew, nold

         ! Advance the snapshot frame counter
         self%iframe = self%iframe + 1

         nnew = self%iframe
         nold = self%nframes

         ! Check to make sure the current storage  object is big enough. If not, grow it by a factor of 2
         if (nnew > nold) call self%resize(nnew)

         self%frame(nnew) = snapshot
      
         return
      end subroutine base_util_snapshot_save


      subroutine base_util_spill_arr_char_string(keeps, discards, lspill_list, ldestructive)
         !! author: David A. Minton 
         !! 
         !! Performs a spill operation on a single array of type character strings 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         character(len=STRMAX), dimension(:), allocatable, intent(inout) :: keeps        
            !! Array of values to keep  
         character(len=STRMAX), dimension(:), allocatable, intent(inout) :: discards     
            !! Array of discards 
         logical,               dimension(:),              intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards 
         logical,                                          intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not 
         ! Internals
         integer(I4B) :: nspill, nkeep, nlist
         character(len=STRMAX), dimension(:), allocatable                :: tmp          
            !! Array of values to keep  

         nkeep = count(.not.lspill_list(:))
         nspill = count(lspill_list(:))
         nlist = size(lspill_list(:))

         if (.not.allocated(keeps) .or. nspill == 0) return
         if (size(keeps) < nkeep) return
         if (.not.allocated(discards)) then
            allocate(discards(nspill))
         else if (size(discards) /= nspill) then
            deallocate(discards)
            allocate(discards(nspill))
         end if

         discards(:) = pack(keeps(1:nlist), lspill_list(1:nlist))
         if (ldestructive) then
            if (nkeep > 0) then
               allocate(tmp(nkeep))
               tmp(:) = pack(keeps(1:nlist), .not. lspill_list(1:nlist))
               call move_alloc(tmp, keeps)
            else
               deallocate(keeps)
            end if
         end if

         return
      end subroutine base_util_spill_arr_char_string
      

      subroutine base_util_spill_arr_DP(keeps, discards, lspill_list, ldestructive)
         !! author: David A. Minton 
         !! 
         !! Performs a spill operation on a single array of type DP 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         real(DP), dimension(:), allocatable, intent(inout) :: keeps        
            !! Array of values to keep  
         real(DP), dimension(:), allocatable, intent(inout) :: discards     
            !! Array of discards 
         logical,  dimension(:),              intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discardss 
         logical,                             intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation  
                                                                            
            !!    should alter the keeps array or not 
         ! Internals
         integer(I4B) :: nspill, nkeep, nlist
         real(DP), dimension(:), allocatable                :: tmp          
            !! Array of values to keep  

         nkeep = count(.not.lspill_list(:))
         nspill = count(lspill_list(:))
         nlist = size(lspill_list(:))

         if (.not.allocated(keeps) .or. nspill == 0) return
         if (size(keeps) < nkeep) return
         if (.not.allocated(discards)) then
            allocate(discards(nspill))
         else if (size(discards) /= nspill) then
            deallocate(discards)
            allocate(discards(nspill))
         end if

         discards(:) = pack(keeps(1:nlist), lspill_list(1:nlist))
         if (ldestructive) then
            if (nkeep > 0) then
               allocate(tmp(nkeep))
               tmp(:) = pack(keeps(1:nlist), .not. lspill_list(1:nlist))
               call move_alloc(tmp, keeps)
            else
               deallocate(keeps)
            end if
         end if

         return
      end subroutine base_util_spill_arr_DP


      subroutine base_util_spill_arr_DPvec(keeps, discards, lspill_list, ldestructive)
         !! author: David A. Minton 
         !! 
         !! Performs a spill operation on a single array of DP vectors with shape (NDIM, n) 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         real(DP), dimension(:,:), allocatable, intent(inout) :: keeps        
            !! Array of values to keep  
         real(DP), dimension(:,:), allocatable, intent(inout) :: discards     
            !! Array discards 
         logical,  dimension(:),                intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards 
         logical,                               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not 
         ! Internals
         integer(I4B) :: i, nspill, nkeep, nlist
         real(DP), dimension(:,:), allocatable                :: tmp          
            !! Array of values to keep  

         nkeep = count(.not.lspill_list(:))
         nspill = count(lspill_list(:))
         nlist = size(lspill_list(:))

         if (.not.allocated(keeps) .or. nspill == 0) return
         if (size(keeps) < nkeep) return
         if (.not.allocated(discards)) then
            allocate(discards(NDIM, nspill))
         else if (size(discards, dim=2) /= nspill) then
            deallocate(discards)
            allocate(discards(NDIM, nspill))
         end if

         do i = 1, NDIM
            discards(i,:) = pack(keeps(i,1:nlist), lspill_list(1:nlist))
         end do
         if (ldestructive) then
            if (nkeep > 0) then
               allocate(tmp(NDIM, nkeep))
               do i = 1, NDIM
                  tmp(i, :) = pack(keeps(i, 1:nlist), .not. lspill_list(1:nlist))
               end do
               call move_alloc(tmp, keeps)
            else
               deallocate(keeps)
            end if
         end if

         return
      end subroutine base_util_spill_arr_DPvec


      subroutine base_util_spill_arr_I4B(keeps, discards, lspill_list, ldestructive)
         !! author: David A. Minton 
         !! 
         !! Performs a spill operation on a single array of type I4B 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), allocatable, intent(inout) :: keeps       
            !! Array of values to keep  
         integer(I4B), dimension(:), allocatable, intent(inout) :: discards    
            !! Array of discards 
         logical,      dimension(:),              intent(in)    :: lspill_list 
            !! Logical array of bodies to spill into the discards 
         logical,                                 intent(in)    :: ldestructive
            !! Logical flag indicating whether or not this  operation should alter the keeps array or not 
         ! Internals
         integer(I4B) :: nspill, nkeep, nlist
         integer(I4B), dimension(:), allocatable                :: tmp         
            !! Array of values to keep  

         nkeep = count(.not.lspill_list(:))
         nspill = count(lspill_list(:))
         nlist = size(lspill_list(:))

         if (.not.allocated(keeps) .or. nspill == 0) return
         if (size(keeps) < nkeep) return
         if (.not.allocated(discards)) then
            allocate(discards(nspill))
         else if (size(discards) /= nspill) then
            deallocate(discards)
            allocate(discards(nspill))
         end if

         discards(:) = pack(keeps(1:nlist), lspill_list(1:nlist))
         if (ldestructive) then
            if (nkeep > 0) then
               allocate(tmp(nkeep))
               tmp(:) = pack(keeps(1:nlist), .not. lspill_list(1:nlist))
               call move_alloc(tmp, keeps)
            else
               deallocate(keeps)
            end if
         end if

         return
      end subroutine base_util_spill_arr_I4B


      subroutine base_util_spill_arr_I8B(keeps, discards, lspill_list, ldestructive)
         !! author: David A. Minton 
         !! 
         !! Performs a spill operation on a single array of type I4B 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         integer(I8B), dimension(:), allocatable, intent(inout) :: keeps       
            !! Array of values to keep  
         integer(I8B), dimension(:), allocatable, intent(inout) :: discards    
            !! Array of discards 
         logical,      dimension(:),              intent(in)    :: lspill_list 
            !! Logical array of bodies to spill into the discards 
         logical,                                 intent(in)    :: ldestructive
            !! Logical flag indicating whether or not this  
                                                                               
            !!   operation should alter the keeps array or not 
         ! Internals
         integer(I4B) :: nspill, nkeep, nlist
         integer(I8B), dimension(:), allocatable                :: tmp          
            !! Array of values to keep  

         nkeep = count(.not.lspill_list(:))
         nspill = count(lspill_list(:))
         nlist = size(lspill_list(:))

         if (.not.allocated(keeps) .or. nspill == 0) return
         if (size(keeps) < nkeep) return
         if (.not.allocated(discards)) then
            allocate(discards(nspill))
         else if (size(discards) /= nspill) then
            deallocate(discards)
            allocate(discards(nspill))
         end if

         discards(:) = pack(keeps(1:nlist), lspill_list(1:nlist))
         if (ldestructive) then
            if (nkeep > 0) then
               allocate(tmp(nkeep))
               tmp(:) = pack(keeps(1:nlist), .not. lspill_list(1:nlist))
               call move_alloc(tmp, keeps)
            else
               deallocate(keeps)
            end if
         end if

         return
      end subroutine base_util_spill_arr_I8B


      subroutine base_util_spill_arr_logical(keeps, discards, lspill_list, ldestructive)
         !! author: David A. Minton 
         !! 
         !! Performs a spill operation on a single array of logicals 
         !! This is the inverse of a spill operation 
         implicit none
         ! Arguments
         logical, dimension(:), allocatable, intent(inout) :: keeps        
            !! Array of values to keep  
         logical, dimension(:), allocatable, intent(inout) :: discards     
            !! Array of discards 
         logical, dimension(:),              intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards 
         logical,                            intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation  
                                                                           
            !!    should alter the keeps array or no 
         ! Internals
         integer(I4B) :: nspill, nkeep, nlist
         logical, dimension(:), allocatable                :: tmp          
            !! Array of values to keep  

         nkeep = count(.not.lspill_list(:))
         nspill = count(lspill_list(:))
         nlist = size(lspill_list(:))

         if (.not.allocated(keeps) .or. nspill == 0) return
         if (size(keeps) < nkeep) return
         if (.not.allocated(discards)) then
            allocate(discards(nspill))
         else if (size(discards) /= nspill) then
            deallocate(discards)
            allocate(discards(nspill))
         end if

         discards(:) = pack(keeps(1:nlist), lspill_list(1:nlist))
         if (ldestructive) then
            if (nkeep > 0) then
               allocate(tmp(nkeep))
               tmp(:) = pack(keeps(1:nlist), .not. lspill_list(1:nlist))
               call move_alloc(tmp, keeps)
            else
               deallocate(keeps)
            end if
         end if

         return
      end subroutine base_util_spill_arr_logical


      pure subroutine base_util_sort_dp(arr)
         !! author: David A. Minton 
         !! 
         !! Sort input DP precision array in place into ascending numerical order using quicksort. 
         implicit none
         ! Arguments
         real(DP), dimension(:), intent(inout) :: arr

         call base_util_sort_qsort_DP(arr)

         return
      end subroutine base_util_sort_dp


      pure subroutine base_util_sort_index_dp(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input DP precision array by index in ascending numerical order using quick sort. 
         !! This algorithm works well for partially sorted arrays (which is usually the case here). 
         !! If ind is supplied already allocated, we assume it is an existing index array (e.g. a previously 
         !! sorted array). If it is not allocated, this subroutine swiftest_allocates it. 
         implicit none
         ! Arguments
         real(DP),     dimension(:),              intent(in)    :: arr
         integer(I4B), dimension(:), allocatable, intent(inout) :: ind
         ! Internals
         integer(I4B) :: n, i
         real(DP), dimension(:), allocatable :: tmparr

         n = size(arr)
         if (.not.allocated(ind)) then
            allocate(ind(n))
            ind = [(i, i=1, n)]
         end if
         allocate(tmparr, mold=arr)
         tmparr(:) = arr(ind(:))
         call base_util_sort_qsort_DP(tmparr, ind)
      
         return
      end subroutine base_util_sort_index_dp


      recursive pure subroutine base_util_sort_qsort_DP(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input DP precision array by index in ascending numerical order using quicksort sort. 
         implicit none
         ! Arguments
         real(DP), dimension(:), intent(inout)           :: arr
         integer(I4B),dimension(:),intent(out), optional :: ind
         
            !! Internals 
         integer :: iq

         if (size(arr) > 1) then
            if (present(ind)) then
               call base_util_sort_partition_DP(arr, iq, ind)
               call base_util_sort_qsort_DP(arr(:iq-1),ind(:iq-1))
               call base_util_sort_qsort_DP(arr(iq:),  ind(iq:))
            else
               call base_util_sort_partition_DP(arr, iq)
               call base_util_sort_qsort_DP(arr(:iq-1))
               call base_util_sort_qsort_DP(arr(iq:))
            end if
         end if

         return
      end subroutine base_util_sort_qsort_DP

   
      pure subroutine base_util_sort_partition_DP(arr, marker, ind)
         !! author: David A. Minton 
         !! 
         !! Partition function for quicksort on DP type 
         !! 
         implicit none
         ! Arguments
         real(DP),     intent(inout), dimension(:)           :: arr
         integer(I4B), intent(inout), dimension(:), optional :: ind
         integer(I4B), intent(out)                           :: marker
         ! Internals
         integer(I4B) :: i, j, itmp, narr, ipiv
         real(DP) :: temp
         real(DP) :: x   ! pivot point

         narr = size(arr)

         ! Get center as pivot, as this is likely partially sorted
         ipiv = narr / 2
         x = arr(ipiv)
         i = 0
         j = narr + 1
      
         do
            j = j - 1
            do
               if (arr(j) <= x) exit
               j = j - 1
            end do
            i = i + 1
            do
               if (arr(i) >= x) exit
               i = i + 1
            end do
            if (i < j) then
               ! exchange A(i) and A(j)
               temp = arr(i)
               arr(i) = arr(j)
               arr(j) = temp
               if (present(ind)) then
                  itmp = ind(i)
                  ind(i) = ind(j)
                  ind(j) = itmp
               end if
            else if (i == j) then
               marker = i + 1
               return
            else
               marker = i
               return
            endif
         end do
   
         return
      end subroutine base_util_sort_partition_DP
   

      pure subroutine base_util_sort_i4b(arr)
         !! author: David A. Minton 
         !! 
         !! Sort input integer array in place into ascending numerical order using quick sort. 
         !! This algorithm works well for partially sorted arrays (which is usually the case here) 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), intent(inout) :: arr

         call base_util_sort_qsort_I4B(arr)

         return
      end subroutine base_util_sort_i4b


      pure subroutine base_util_sort_index_I4B(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input integer array by index in ascending numerical order using quicksort. 
         !! If ind is supplied already allocated, we assume it is an existing index array (e.g. a previously 
         !! sorted array). If it is not allocated, this subroutine swiftest_allocates it. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:),              intent(in)  :: arr
         integer(I4B), dimension(:), allocatable, intent(inout) :: ind
         ! Internals
         integer(I4B) :: n, i
         integer(I4B), dimension(:), allocatable :: tmparr

         n = size(arr)
         if (.not.allocated(ind)) then
            allocate(ind(n))
            ind = [(i, i=1, n)]
         end if
         allocate(tmparr, mold=arr)
         tmparr(:) = arr(ind(:))
         call base_util_sort_qsort_I4B(tmparr, ind)

         return
      end subroutine base_util_sort_index_I4B


      pure subroutine base_util_sort_index_I4B_I8Bind(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input integer array by index in ascending numerical order using quicksort. 
         !! If ind is supplied already allocated, we assume it is an existing index array (e.g. a previously 
         !! sorted array). If it is not allocated, this subroutine swiftest_allocates it. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:),              intent(in)  :: arr
         integer(I8B), dimension(:), allocatable, intent(inout) :: ind
         ! Internals
         integer(I8B) :: n, i
         integer(I4B), dimension(:), allocatable :: tmparr

         n = size(arr)
         if (.not.allocated(ind)) then
            allocate(ind(n))
            ind = [(i, i=1_I8B, n)]
         end if
         allocate(tmparr, mold=arr)
         tmparr(:) = arr(ind(:))
         call base_util_sort_qsort_I4B_I8Bind(tmparr, ind)

         return
      end subroutine base_util_sort_index_I4B_I8Bind


      pure subroutine base_util_sort_index_I8B_I8Bind(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input integer array by index in ascending numerical order using quicksort. 
         !! If ind is supplied already allocated, we assume it is an existing index array (e.g. a previously 
         !! sorted array). If it is not allocated, this subroutine swiftest_allocates it. 
         implicit none
         ! Arguments
         integer(I8B), dimension(:),              intent(in)  :: arr
         integer(I8B), dimension(:), allocatable, intent(inout) :: ind
         ! Internals
         integer(I8B) :: n, i
         integer(I8B), dimension(:), allocatable :: tmparr

         n = size(arr)
         if (.not.allocated(ind)) then
            allocate(ind(n))
            ind = [(i, i=1_I8B, n)]
         end if
         allocate(tmparr, mold=arr)
         tmparr(:) = arr(ind(:))
         call base_util_sort_qsort_I8B_I8Bind(tmparr, ind)

         return
      end subroutine base_util_sort_index_I8B_I8Bind


      recursive pure subroutine base_util_sort_qsort_I4B(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input I4B array by index in ascending numerical order using quicksort. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), intent(inout)          :: arr
         integer(I4B), dimension(:), intent(out),  optional :: ind
         ! Internals
         integer(I4B) :: iq

         if (size(arr) > 1) then
            if (present(ind)) then
               call base_util_sort_partition_I4B(arr, iq, ind)
               call base_util_sort_qsort_I4B(arr(:iq-1),ind(:iq-1))
               call base_util_sort_qsort_I4B(arr(iq:),  ind(iq:))
            else
               call base_util_sort_partition_I4B(arr, iq)
               call base_util_sort_qsort_I4B(arr(:iq-1))
               call base_util_sort_qsort_I4B(arr(iq:))
            end if
         end if

         return
      end subroutine base_util_sort_qsort_I4B


      recursive pure subroutine base_util_sort_qsort_I4B_I8Bind(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input I4B array by index in ascending numerical order using quicksort. 
         !! 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), intent(inout)          :: arr
         integer(I8B), dimension(:), intent(out),  optional :: ind
         ! Internals
         integer(I8B) :: iq

         if (size(arr) > 1_I8B) then
            if (present(ind)) then
               call base_util_sort_partition_I4B_I8Bind(arr, iq, ind)
               call base_util_sort_qsort_I4B_I8Bind(arr(:iq-1_I8B),ind(:iq-1_I8B))
               call base_util_sort_qsort_I4B_I8Bind(arr(iq:),  ind(iq:))
            else
               call base_util_sort_partition_I4B_I8Bind(arr, iq)
               call base_util_sort_qsort_I4B_I8Bind(arr(:iq-1_I8B))
               call base_util_sort_qsort_I4B_I8Bind(arr(iq:))
            end if
         end if

         return
      end subroutine base_util_sort_qsort_I4B_I8Bind


      recursive pure subroutine base_util_sort_qsort_I8B_I8Bind(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input I8B array by index in ascending numerical order using quicksort. 
         implicit none
         ! Arguments
         integer(I8B), dimension(:), intent(inout)          :: arr
         integer(I8B), dimension(:), intent(out),  optional :: ind
         ! Internals
         integer(I8B) :: iq

         if (size(arr) > 1_I8B) then
            if (present(ind)) then
               call base_util_sort_partition_I8B_I8Bind(arr, iq, ind)
               call base_util_sort_qsort_I8B_I8Bind(arr(:iq-1_I8B),ind(:iq-1_I8B))
               call base_util_sort_qsort_I8B_I8Bind(arr(iq:),  ind(iq:))
            else
               call base_util_sort_partition_I8B_I8Bind(arr, iq)
               call base_util_sort_qsort_I8B_I8Bind(arr(:iq-1_I8B))
               call base_util_sort_qsort_I8B_I8Bind(arr(iq:))
            end if
         end if

         return
      end subroutine base_util_sort_qsort_I8B_I8Bind

   
      pure subroutine base_util_sort_partition_I4B(arr, marker, ind)
         
            !! author: David A. Minton 
         
            !! 
         
            !! Partition function for quicksort on I4B type 
         
            !! 
         implicit none
         ! Arguments
         integer(I4B), intent(inout), dimension(:)           :: arr
         integer(I4B), intent(inout), dimension(:), optional :: ind
         integer(I4B), intent(out)                           :: marker
         ! Internals
         integer(I4B) :: i, j, itmp, narr, ipiv
         integer(I4B) :: temp
         integer(I4B) :: x   ! pivot point

         narr = size(arr)

         ! Get center as pivot, as this is likely partially sorted
         ipiv = narr / 2
         x = arr(ipiv)
         i = 0
         j = narr + 1
      
         do
            j = j - 1
            do
               if (arr(j) <= x) exit
               j = j - 1
            end do
            i = i + 1
            do
               if (arr(i) >= x) exit
               i = i + 1
            end do
            if (i < j) then
               ! exchange A(i) and A(j)
               temp = arr(i)
               arr(i) = arr(j)
               arr(j) = temp
               if (present(ind)) then
                  itmp = ind(i)
                  ind(i) = ind(j)
                  ind(j) = itmp
               end if
            else if (i == j) then
               marker = i + 1
               return
            else
               marker = i
               return
            endif
         end do
   
         return
      end subroutine base_util_sort_partition_I4B


      pure subroutine base_util_sort_partition_I4B_I8Bind(arr, marker, ind)
         !! author: David A. Minton 
         !! 
         !! Partition function for quicksort on I4B type 
         implicit none
         ! Arguments
         integer(I4B), intent(inout), dimension(:)           :: arr
         integer(I8B), intent(inout), dimension(:), optional :: ind
         integer(I8B), intent(out)                           :: marker
         ! Internals
         integer(I8B) :: i, j, itmp, narr, ipiv
         integer(I4B) :: temp
         integer(I8B) :: x   ! pivot point

         narr = size(arr)

         ! Get center as pivot, as this is likely partially sorted
         ipiv = narr / 2_I8B
         x = arr(ipiv)
         i = 0_I8B
         j = narr + 1_I8B
      
         do
            j = j - 1_I8B
            do
               if (arr(j) <= x) exit
               j = j - 1_I8B
            end do
            i = i + 1_I8B
            do
               if (arr(i) >= x) exit
               i = i + 1_I8B
            end do
            if (i < j) then
               ! exchange A(i) and A(j)
               temp = arr(i)
               arr(i) = arr(j)
               arr(j) = temp
               if (present(ind)) then
                  itmp = ind(i)
                  ind(i) = ind(j)
                  ind(j) = itmp
               end if
            else if (i == j) then
               marker = i + 1_I8B
               return
            else
               marker = i
               return
            endif
         end do
   
         return
      end subroutine base_util_sort_partition_I4B_I8Bind


      pure subroutine base_util_sort_partition_I8B_I8Bind(arr, marker, ind)
         !! author: David A. Minton 
         !! 
         !! Partition function for quicksort on I8B type with I8B index 
         implicit none
         ! Arguments
         integer(I8B), intent(inout), dimension(:)           :: arr
         integer(I8B), intent(inout), dimension(:), optional :: ind
         integer(I8B), intent(out)                           :: marker
         ! Internals
         integer(I8B) :: i, j, itmp, narr, ipiv
         integer(I8B) :: temp
         integer(I8B) :: x   ! pivot point

         narr = size(arr)

         ! Get center as pivot, as this is likely partially sorted
         ipiv = narr / 2_I8B
         x = arr(ipiv)
         i = 0_I8B
         j = narr + 1_I8B
      
         do
            j = j - 1_I8B
            do
               if (arr(j) <= x) exit
               j = j - 1_I8B
            end do
            i = i + 1_I8B
            do
               if (arr(i) >= x) exit
               i = i + 1_I8B
            end do
            if (i < j) then
               ! exchange A(i) and A(j)
               temp = arr(i)
               arr(i) = arr(j)
               arr(j) = temp
               if (present(ind)) then
                  itmp = ind(i)
                  ind(i) = ind(j)
                  ind(j) = itmp
               end if
            else if (i == j) then
               marker = i + 1_I8B
               return
            else
               marker = i
               return
            endif
         end do
   
         return
      end subroutine base_util_sort_partition_I8B_I8Bind


      pure subroutine base_util_sort_sp(arr)
         !! author: David A. Minton 
         !! 
         !! Sort input DP precision array in place into ascending numerical order using quicksort. 
         !! 
         implicit none
         ! Arguments
         real(SP), dimension(:), intent(inout) :: arr

         call base_util_sort_qsort_SP(arr)

         return
      end subroutine base_util_sort_sp


      pure subroutine base_util_sort_index_sp(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input DP precision array by index in ascending numerical order using quicksort. 
         !! If ind is supplied already allocated, we assume it is an existing index array (e.g. a previously 
         !! sorted array). If it is not allocated, this subroutine swiftest_allocates it. 
         implicit none
         ! Arguments
         real(SP),     dimension(:),              intent(in)    :: arr
         integer(I4B), dimension(:), allocatable, intent(inout) :: ind
         ! Internals
         integer(I4B) :: n, i
         real(SP), dimension(:), allocatable :: tmparr

         n = size(arr)
         if (.not.allocated(ind)) then
            allocate(ind(n))
            ind = [(i, i=1, n)]
         end if
         allocate(tmparr, mold=arr)
         tmparr(:) = arr(ind(:))
         call base_util_sort_qsort_SP(tmparr, ind)
      
         return
      end subroutine base_util_sort_index_sp


      recursive pure subroutine base_util_sort_qsort_SP(arr, ind)
         !! author: David A. Minton 
         !! 
         !! Sort input DP precision array by index in ascending numerical order using quicksort. 
         implicit none
         ! Arguments
         real(SP), dimension(:), intent(inout)           :: arr
         integer(I4B),dimension(:),intent(out), optional :: ind
         
         ! Internals 
         integer :: iq

         if (size(arr) > 1) then
            if (present(ind)) then
               call base_util_sort_partition_SP(arr, iq, ind)
               call base_util_sort_qsort_SP(arr(:iq-1),ind(:iq-1))
               call base_util_sort_qsort_SP(arr(iq:),  ind(iq:))
            else
               call base_util_sort_partition_SP(arr, iq)
               call base_util_sort_qsort_SP(arr(:iq-1))
               call base_util_sort_qsort_SP(arr(iq:))
            end if
         end if

         return
      end subroutine base_util_sort_qsort_SP


      pure subroutine base_util_sort_partition_SP(arr, marker, ind)
         !! author: David A. Minton 
         !! 
         !! Partition function for quicksort on SP type 
         implicit none
         ! Arguments
         real(SP),     intent(inout), dimension(:)           :: arr
         integer(I4B), intent(inout), dimension(:), optional :: ind
         integer(I4B), intent(out)                           :: marker
         ! Internals
         integer(I4B) :: i, j, itmp, narr, ipiv
         real(SP) :: temp
         real(SP) :: x   ! pivot point

         narr = size(arr)

         ! Get center as pivot, as this is likely partially sorted
         ipiv = narr / 2
         x = arr(ipiv)
         i = 0
         j = narr + 1
      
         do
            j = j - 1
            do
               if (arr(j) <= x) exit
               j = j - 1
            end do
            i = i + 1
            do
               if (arr(i) >= x) exit
               i = i + 1
            end do
            if (i < j) then
               ! exchange A(i) and A(j)
               temp = arr(i)
               arr(i) = arr(j)
               arr(j) = temp
               if (present(ind)) then
                  itmp = ind(i)
                  ind(i) = ind(j)
                  ind(j) = itmp
               end if
            else if (i == j) then
               marker = i + 1
               return
            else
               marker = i
               return
            endif
         end do
   
         return
      end subroutine base_util_sort_partition_SP


      pure subroutine base_util_sort_rearrange_arr_char_string(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of character string in-place from an index list. 
         implicit none
         ! Arguments
         character(len=STRMAX), dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I4B),          dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against 
         integer(I4B),                                     intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         character(len=STRMAX), dimension(:), allocatable  :: tmp 
            !! Temporary copy of arry used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0) return
         allocate(tmp, mold=arr)
         tmp(1:n) = arr(ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_char_string


      pure subroutine base_util_sort_rearrange_arr_DP(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of DP type in-place from an index list. 
         implicit none
         ! Arguments
         real(DP),     dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I4B), dimension(:),              intent(in)  :: ind 
            !! Index to rearrange against 
         integer(I4B),                            intent(in)  :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         real(DP), dimension(:), allocatable :: tmp 
            !! Temporary copy of array used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0) return
         allocate(tmp, mold=arr)
         tmp(1:n) = arr(ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_DP


      pure subroutine base_util_sort_rearrange_arr_DPvec(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of (NDIM,n) DP-type vectors in-place from an index list. 
         implicit none
         ! Arguments
         real(DP),     dimension(:,:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I4B), dimension(:),                intent(in)    :: ind 
            !! Index to rearrange against 
         integer(I4B),                              intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         real(DP), dimension(:,:), allocatable :: tmp 
            !! Temporary copy of array used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0) return
         allocate(tmp, mold=arr)
         tmp(:,1:n) = arr(:, ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_DPvec


      pure subroutine base_util_sort_rearrange_arr_I4B(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of integers in-place from an index list. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I4B), dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against 
         integer(I4B),                             intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         integer(I4B), dimension(:), allocatable                :: tmp 
            !! Temporary copy of array used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0) return
         allocate(tmp, mold=arr)
         tmp(1:n) = arr(ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_I4B

      pure subroutine base_util_sort_rearrange_arr_I4B_I8Bind(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of integers in-place from an index list. 
         implicit none
         ! Arguments
         integer(I4B), dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I8B), dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against 
         integer(I8B),                            intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         integer(I4B), dimension(:), allocatable                :: tmp 
            !! Temporary copy of array used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0_I8B) return
         allocate(tmp, mold=arr)
         tmp(1:n) = arr(ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_I4B_I8Bind


      pure subroutine base_util_sort_rearrange_arr_logical_I8Bind(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of logicals in-place from an index list. 
         implicit none
         ! Arguments
         logical,      dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I8B), dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against 
         integer(I8B),                            intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         logical, dimension(:), allocatable                :: tmp 
            !! Temporary copy of array used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0) return
         allocate(tmp, mold=arr)
         tmp(1:n) = arr(ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_logical_I8Bind


      pure subroutine base_util_sort_rearrange_arr_logical(arr, ind, n)
         !! author: David A. Minton 
         !! 
         !! Rearrange a single array of logicals in-place from an index list. 
         implicit none
         ! Arguments
         logical,      dimension(:), allocatable, intent(inout) :: arr 
            !! Destination array  
         integer(I4B), dimension(:),              intent(in)    :: ind 
            !! Index to rearrange against 
         integer(I4B),                            intent(in)    :: n   
            !! Number of elements in arr and ind to rearrange 
         ! Internals
         logical, dimension(:), allocatable                :: tmp 
            !! Temporary copy of array used during rearrange operation 

         if (.not. allocated(arr) .or. n <= 0) return
         allocate(tmp, mold=arr)
         tmp(1:n) = arr(ind)
         call move_alloc(tmp, arr)

         return
      end subroutine base_util_sort_rearrange_arr_logical


      subroutine base_util_unique_DP(input_array, output_array, index_map)
         !! author: David A. Minton 
         !! 
         !! Takes an input unsorted integer array and returns a new array of sorted, unique values (DP version) 
         implicit none
         ! Arguments
         real(DP),     dimension(:),              intent(in)  :: input_array  
            !! Unsorted input array  
         real(DP),     dimension(:), allocatable, intent(out) :: output_array 
            !! Sorted array of unique values  
         integer(I4B), dimension(:), allocatable, intent(out) :: index_map    
            !! An array of the same size as input_array that such  that any for any index i,  
            !!    output_array(index_map(i)) = input_array(i) 
         ! Internals
         real(DP), dimension(:), allocatable :: unique_array
         integer(I4B) :: n
         real(DP) :: lo, hi
   
         allocate(unique_array, mold=input_array)
         allocate(index_map(size(input_array)))
         lo = minval(input_array) - 1
         hi = maxval(input_array)
   
         n = 0
         do 
            n = n + 1
            lo = minval(input_array(:), mask=input_array(:) > lo)
            unique_array(n) = lo
            where(abs(input_array(:) - lo) < epsilon(1.0_DP) * lo) index_map(:) = n
            if (lo >= hi) exit
         enddo
         allocate(output_array(n), source=unique_array(1:n)) 
   
         return
      end subroutine base_util_unique_DP
   

      subroutine base_util_unique_I4B(input_array, output_array, index_map)
         !! author: David A. Minton 
         !! 
         !! Takes an input unsorted integer array and returns a new array of sorted, unique values (I4B version)
         implicit none
         ! Arguments
         integer(I4B), dimension(:),              intent(in)  :: input_array  
            !! Unsorted input array  
         integer(I4B), dimension(:), allocatable, intent(out) :: output_array 
            !! Sorted array of unique values 
         integer(I4B), dimension(:), allocatable, intent(out) :: index_map    
            !! An array of the same size as input_array that such  that any for any index i,  
            !! output_array(index_map(i)) = input_array(i)      
         ! Internals
         integer(I4B), dimension(:), allocatable :: unique_array
         integer(I4B) :: n, lo, hi
   
         allocate(unique_array, mold=input_array)
         allocate(index_map, mold=input_array)
         lo = minval(input_array) - 1
         hi = maxval(input_array)
   
         n = 0
         do 
            n = n + 1
            lo = minval(input_array(:), mask=input_array(:) > lo)
            unique_array(n) = lo
            where(input_array(:) == lo) index_map(:) = n
            if (lo >= hi) exit
         enddo
         allocate(output_array(n), source=unique_array(1:n)) 
   
         return
      end subroutine base_util_unique_I4B


      subroutine base_final_storage(self)
         !! author: David A. Minton 
         !! 
         !! Finalizer for the storage object 
         implicit none
         ! Arguments
         class(base_storage), intent(inout) :: self

         call self%dealloc()
         return
      end subroutine base_final_storage


      subroutine base_final_storage_frame(self)
         !! author: David A. Minton 
         !! 
         !! Finalizer for the storage frame data type 
         implicit none
         type(base_storage_frame) :: self
   
         if (allocated(self%item)) deallocate(self%item)
   
         return
      end subroutine base_final_storage_frame

#ifdef COARRAY
      subroutine base_coclone_param(self)
         !! author: David A. Minton 
         !! 
         !! Broadcasts the image 1 parameter to all other images in a parameter coarray 
         implicit none
         ! Arguments
         class(base_parameters),intent(inout),codimension[*]  :: self  
            !! Collection of parameters 
         ! Internals

         call coclone(self%integrator)
         call coclone(self%param_file_name)
         call coclone(self%t0)
         call coclone(self%tstart)
         call coclone(self%tstop)
         call coclone(self%dt)
         call coclone(self%iloop)
         call coclone(self%nloops)
         call coclone(self%incbfile)
         call coclone(self%inplfile)
         call coclone(self%intpfile)
         call coclone(self%nc_in)
         call coclone(self%in_type)
         call coclone(self%in_form)
         call coclone(self%istep_out)
         call coclone(self%nstep_out)
         call coclone(self%fstep_out)
         call coclone(self%ltstretch)
         call coclone(self%outfile)
         call coclone(self%out_type)
         call coclone(self%out_form)
         call coclone(self%out_stat)
         call coclone(self%dump_cadence)
         call coclone(self%rmin)
         call coclone(self%rmax)
         call coclone(self%rmaxu)
         call coclone(self%qmin)
         call coclone(self%qmin_coord)
         call coclone(self%qmin_alo)
         call coclone(self%qmin_ahi)
         call coclone(self%MU2KG)
         call coclone(self%TU2S)
         call coclone(self%DU2M)
         call coclone(self%GU)
         call coclone(self%inv_c2)
         call coclone(self%GMTINY)
         call coclone(self%min_GMfrag)
         call coclone(self%nfrag_reduction)
         call coclone(self%lmtiny_pl)
         call coclone(self%collision_model)
         call coclone(self%encounter_save)
         call coclone(self%lenc_save_trajectory)
         call coclone(self%lenc_save_closest)
         call coclone(self%interaction_loops)
         call coclone(self%encounter_check_plpl)
         call coclone(self%encounter_check_pltp)
         call coclone(self%lflatten_interactions)
         call coclone(self%lencounter_sas_plpl)
         call coclone(self%lencounter_sas_pltp)
         call coclone(self%lrhill_present)
         call coclone(self%lextra_force)
         call coclone(self%lbig_discard)
         call coclone(self%lclose)
         call coclone(self%lenergy)
         call coclone(self%lnon_spherical_cb)
         call coclone(self%lrotation)
         call coclone(self%ltides)
         call coclone(self%E_orbit_orig)
         call coclone(self%GMtot_orig)
         call coclonevec(self%L_total_orig)
         call coclonevec(self%L_orbit_orig)
         call coclonevec(self%L_spin_orig)
         call coclonevec(self%L_escape)
         call coclone(self%GMescape)
         call coclone(self%E_collisions)
         call coclone(self%E_untracked)
         call coclone(self%lfirstenergy)
         call coclone(self%lfirstkick)
         call coclone(self%lrestart)
         call coclone(self%display_style)
         call coclone(self%display_unit)
         call coclone(self%log_output )
         call coclone(self%lgr)
         call coclone(self%lyarkovsky)
         call coclone(self%lyorp)
         call coclone(self%seed)
         call coclone(self%lcoarray)

         return
      end subroutine base_coclone_param 
#endif
    

end module base

!! Copyright 2024 - The Minton Group at Purdue University
!! This file is part of Swiftest.
!! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
!! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
!! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
!! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
!! You should have received a copy of the GNU General Public License along with Swiftest. 
!! If not, see: https://www.gnu.org/licenses. 


!! Swiftest submodule to calculate higher order terms for gravitational acceleration given spherical harmonic coefficients (c_lm)

submodule (shgrav) s_shgrav_accel
use swiftest
use SHTOOLS

contains

    subroutine shgrav_g_acc_one(GMcb, r_0, phi_cb, rh, c_lm, g_sph, GMpl, aoblcb)
        !! author: Kaustub P. Anand
        !!
        !! Calculate the acceleration terms for one pair of bodies given c_lm, theta, phi, r
        implicit none
        ! Arguments
        real(DP), intent(in) :: GMcb 
            !! GMass of the central body
        real(DP), intent(in) :: r_0 
            !! radius of the central body
        real(DP), intent(in) :: phi_cb 
            !! rotation phase angle of the central body
        real(DP), intent(in), dimension(:) :: rh 
            !! distance vector of body
        real(DP), intent(in), dimension(:, :, :) :: c_lm 
            !! Spherical Harmonic coefficients
        real(DP), intent(out), dimension(NDIM) :: g_sph 
            !! acceleration vector
        real(DP), intent(in),  optional :: GMpl 
            !! Mass of input body if it is not a test particle
        real(DP), dimension(:), intent(inout), optional :: aoblcb
            !! Barycentric acceleration of central body (only for massive input bodies)
     
        ! Internals
        integer :: l, m 
            !! SPH coefficients
        integer :: l_max 
            !! max Spherical Harmonic l order value
        integer(I4B) :: N, lmindex 
            !! Length of Legendre polynomials and index at a given l, m
        real(DP) :: r_mag  
            !! magnitude of rh
        real(DP) :: phi, phi_bar 
            !! Azimuthal/Phase angle (radians) wrt coordinate axes, and central body rotation phase
        real(DP) :: theta 
            !! Inclination/Zenith angle (radians)
        real(DP) :: plm, plm1 
            !! Associated Legendre polynomials at a given l, m
        real(DP) :: ccss, cssc 
            !! See definition in source code
        real(DP) :: cos_theta, sin_theta 
            !! cos(theta) and sin(theta)
        real(DP), dimension(:), allocatable  :: p 
            !! Associated Lengendre Polynomials at a given cos(theta)
        real(DP) :: fac1, fac2, r_fac 
            !! calculation factors 

        g_sph(:) = 0.0_DP
        theta = atan2(sqrt(rh(1)**2 + rh(2)**2), rh(3))
        phi = atan2(rh(2), rh(1)) 
        phi_bar = MOD(phi - phi_cb, 2 * PI) ! represents the phase difference between the central body's and the particle's phase
        r_mag = sqrt(dot_product(rh(:), rh(:)))
        l_max = size(c_lm, 2) - 1
        N = (l_max + 1) * (l_max + 2) / 2
        allocate(p(N))

        cos_theta = cos(theta)
        sin_theta = sin(theta)

        ! check if cos_theta is too small to avoid floating underflow error
        if (abs(cos_theta) < EPSILON(0.0_DP)) then
            call PlmBar(p, l_max, 0.0_DP)
        else
            call PlmBar(p, l_max, cos_theta)
        end if

        do l = 1, l_max ! skipping the l = 0 term; It is the spherical body term
            do m = 0, l

                ! If c_lm is too small, skip the iteration to improve performance
                if (abs(c_lm(m+1, l+1, 1)) < epsilon(0.0_DP) .and. abs(c_lm(m+1, l+1, 2)) < epsilon(0.0_DP)) then
                    cycle  
                endif

                ! Associated Legendre Polynomials 
                lmindex = PlmIndex(l, m)  
                plm = p(lmindex)                  ! p_l,m

                ! C_lm and S_lm with Cos and Sin of m * phi
                ccss = c_lm(m+1, l+1, 1) * cos(m * phi_bar) & 
                        + c_lm(m+1, l+1, 2) * sin(m * phi_bar)      ! C_lm * cos(m * phi_bar) + S_lm * sin(m * phi_bar)
                cssc = -1 * c_lm(m+1, l+1, 1) * sin(m * phi_bar) & 
                        + c_lm(m+1, l+1, 2) * cos(m * phi_bar)      ! - C_lm * sin(m * phi_bar) + S_lm * cos(m * phi_bar) 
                                                                    ! cssc * m = first derivative of ccss with respect to phi

                if ((m+1) <= l) then
                    lmindex = PlmIndex(l, m+1) 
                    plm1 = p(lmindex) 
                    if(m == 0) then
                        plm1 = plm1 * sqrt(((l + m + 1) * (l - m)) / 2.0) ! renormalize plm1 to the norm of plm
                    else 
                        plm1 = plm1 * sqrt((l + m + 1) * (l - m) * 1.0)       ! renormalize plm1 to the norm of plm
                    end if
                else
                    plm1 = 0.0_DP  
                end if 
                                                                      
                if(abs(sin_theta) < epsilon(1.0_DP)) then
                    fac1 = 0.0_DP
                else
                    fac1 = m * plm / sin_theta
                end if

                fac2 = plm * (l + m + 1) * sin_theta + plm1 * cos_theta
                r_fac = -GMcb * r_0**l / r_mag**(l + 2)

                g_sph(1) = g_sph(1) + r_fac * (cssc * fac1 * sin(phi) + ccss * (fac2 - fac1) * cos(phi))
                g_sph(2) = g_sph(2) + r_fac * (-cssc * fac1 * cos(phi) + ccss * (fac2 - fac1) * sin(phi))
                g_sph(3) = g_sph(3) + r_fac * ccss * (plm * (l + m + 1) * cos_theta - plm1 * sin_theta)
          
            end do
        end do

        if (present(GMpl) .and. present(aoblcb)) then
            aoblcb(:) = aoblcb(:) - GMpl * g_sph(:) / GMcb
        end if

        return
    end subroutine shgrav_g_acc_one

    module subroutine shgrav_acc(body, nbody_system)
        !! author: Kaustub P. Anand
        !!
        !! Calculate the acceleration terms for bodies given c_lm values for the central body
        !!
        implicit none
        ! Arguments
        class(swiftest_body), intent(inout) :: body
            !! Swiftest body object
        class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
        ! Internals
        integer(I4B)    :: i 

        associate(cb => nbody_system%cb)
            cb%aobl(:) = 0.0_DP
            select type(body)
            class is (swiftest_pl)
                do i = 1, body%nbody
                    if (body%lmask(i)) then
                        call shgrav_g_acc_one(cb%Gmass, cb%radius, cb%rotphase*DEG2RAD, body%rh(:,i), cb%c_lm, body%aobl(:,i), &
                            GMpl=body%Gmass(i), aoblcb=cb%aobl)
                    end if
                end do
            class is (swiftest_tp)
                do i = 1, body%nbody
                    if (body%lmask(i)) then
                        call shgrav_g_acc_one(cb%Gmass, cb%radius, cb%rotphase*DEG2RAD, body%rh(:,i), cb%c_lm, body%aobl(:,i))
                    end if
                end do
            end select
        end associate
        return 
    end subroutine shgrav_acc
    
end submodule s_shgrav_accel

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (encounter) s_encounter_util
   use swiftest
contains

   module subroutine encounter_util_append_list(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one Swiftest body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      ! Arguments
      class(encounter_list), intent(inout)        :: self         !! Swiftest encounter list object
      class(encounter_list), intent(in)           :: source       !! Source object to append
      logical, dimension(:), intent(in)           :: lsource_mask !! Logical mask indicating which elements to append to
      ! Internals
      integer(I4B) :: nold

      nold = int(self%nenc, kind=I4B)
      call util_append(self%tcollision, source%tcollision,   nold, lsource_mask)
      call util_append(self%lclosest,   source%lclosest,     nold, lsource_mask)
      call util_append(self%lvdotr,     source%lvdotr,       nold, lsource_mask)
      call util_append(self%status,     source%status,       nold, lsource_mask)
      call util_append(self%index1,     source%index1,       nold, lsource_mask)
      call util_append(self%index2,     source%index2,       nold, lsource_mask)
      call util_append(self%id1,        source%id1,          nold, lsource_mask)
      call util_append(self%id2,        source%id2,          nold, lsource_mask)
      call util_append(self%r1,         source%r1,           nold, lsource_mask)
      call util_append(self%r2,         source%r2,           nold, lsource_mask)
      call util_append(self%v1,         source%v1,           nold, lsource_mask)
      call util_append(self%v2,         source%v2,           nold, lsource_mask)
      call util_append(self%level,      source%level,        nold, lsource_mask)
      self%nenc = nold + count(lsource_mask(:))

      return
   end subroutine encounter_util_append_list


   module subroutine encounter_util_copy_list(self, source)
      !! author: David A. Minton
      !!
      !! Copies elements from the source encounter list into self.
      implicit none
      ! Arguments
      class(encounter_list), intent(inout) :: self   !! Encounter list 
      class(encounter_list), intent(in)    :: source !! Source object to copy into

      associate(n => source%nenc)
         self%nenc = n
         self%t = source%t
         self%lcollision = source%lcollision
         self%tcollision(1:n) = source%tcollision(1:n) 
         self%lclosest(1:n) = source%lclosest(1:n) 
         self%lvdotr(1:n)   = source%lvdotr(1:n) 
         self%status(1:n) = source%status(1:n) 
         self%index1(1:n) = source%index1(1:n)
         self%index2(1:n) = source%index2(1:n)
         self%id1(1:n) = source%id1(1:n)
         self%id2(1:n) = source%id2(1:n)
         self%r1(:,1:n) = source%r1(:,1:n)
         self%r2(:,1:n) = source%r2(:,1:n)
         self%v1(:,1:n) = source%v1(:,1:n)
         self%v2(:,1:n) = source%v2(:,1:n)
         self%level(1:n) = source%level(1:n)
      end associate

      return
   end subroutine encounter_util_copy_list


   module subroutine encounter_util_dealloc_aabb(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables
      implicit none
      ! Arguments
      class(encounter_bounding_box_1D), intent(inout) :: self

      self%n = 0
      if (allocated(self%ind)) deallocate(self%ind)
      if (allocated(self%ibeg)) deallocate(self%ibeg)
      if (allocated(self%iend)) deallocate(self%iend)

      return
   end subroutine encounter_util_dealloc_aabb


   module subroutine encounter_util_dealloc_bounding_box(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables
      implicit none
      ! Arguments
      class(encounter_bounding_box), intent(inout) :: self !! Bounding box structure

      call self%aabb%dealloc()

      return
   end subroutine encounter_util_dealloc_bounding_box


   module subroutine encounter_util_dealloc_list(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables
      implicit none
      ! Arguments
      class(encounter_list), intent(inout) :: self

      self%nenc = 0

      if (allocated(self%tcollision)) deallocate(self%tcollision)
      if (allocated(self%lclosest)) deallocate(self%lclosest)
      if (allocated(self%lvdotr)) deallocate(self%lvdotr)
      if (allocated(self%status)) deallocate(self%status)
      if (allocated(self%index1)) deallocate(self%index1)
      if (allocated(self%index2)) deallocate(self%index2)
      if (allocated(self%id1)) deallocate(self%id1)
      if (allocated(self%id2)) deallocate(self%id2)
      if (allocated(self%r1)) deallocate(self%r1)
      if (allocated(self%r2)) deallocate(self%r2)
      if (allocated(self%v1)) deallocate(self%v1)
      if (allocated(self%v2)) deallocate(self%v2)
      if (allocated(self%level)) deallocate(self%level)

      return
   end subroutine encounter_util_dealloc_list


   module subroutine encounter_util_dealloc_snapshot(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables
      implicit none
      ! Arguments
      class(encounter_snapshot), intent(inout) :: self !! Encounter shapshot object

      if (allocated(self%pl)) deallocate(self%pl)
      if (allocated(self%tp)) deallocate(self%tp)

      return
   end subroutine encounter_util_dealloc_snapshot


   module subroutine encounter_util_dealloc_storage(self)
      !! author: David A. Minton
      !!
      !! Resets a storage object by deallocating all items and resetting the frame counter to 0
      use base, only : base_util_dealloc_storage
      implicit none
      ! Arguments
      class(encounter_storage), intent(inout) :: self !! Swiftest storage object

      if (allocated(self%nc)) deallocate(self%nc)

      call base_util_dealloc_storage(self)

      return
   end subroutine encounter_util_dealloc_storage


   module subroutine encounter_util_get_idvalues_snapshot(self, idvals)
      !! author: David A. Minton
      !!
      !! Returns an array of all id values saved in this snapshot
      implicit none
      ! Arguments
      class(encounter_snapshot),               intent(in)  :: self   !! Encounter snapshot object
      integer(I4B), dimension(:), allocatable, intent(out) :: idvals !! Array of all id values saved in this snapshot
      ! Internals
      integer(I4B) :: npl, ntp

      select type(pl => self%pl)
      class is (swiftest_pl)
      select type(tp => self%tp)
      class is (swiftest_tp)
         if (allocated(self%pl)) then
            npl = pl%nbody
         else
            npl = 0
         end if 

         if (allocated(self%tp)) then
            ntp = tp%nbody
         else
            ntp = 0
         end if

         if (npl + ntp == 0) return
         allocate(idvals(npl+ntp))

         if (npl > 0) idvals(1:npl) = pl%id(:)
         if (ntp >0) idvals(npl+1:npl+ntp) = tp%id(:)
      end select
      end select

      return

   end subroutine encounter_util_get_idvalues_snapshot


   module subroutine encounter_util_get_vals_storage(self, idvals, tvals)
      !! author: David A. Minton
      !!
      !! Gets the id values in a self object, regardless of whether it is encounter of collision
      ! Argument
      class(encounter_storage), intent(in)               :: self   !! Encounter storages object
      integer(I4B), dimension(:),  allocatable, intent(out) :: idvals !! Array of all id values in all snapshots
      real(DP),     dimension(:),  allocatable, intent(out) :: tvals  !! Array of all time values in all snapshots
      ! Internals
      integer(I4B) :: i, n, nlo, nhi, ntotal
      integer(I4B), dimension(:), allocatable :: itmp

      associate(nsnaps => self%iframe)

         allocate(tvals(nsnaps))

         tvals(:) = 0.0_DP

         ! First pass to get total number of ids
         ntotal = 0
         do i = 1, nsnaps
            if (allocated(self%frame(i)%item)) then
               select type(snapshot => self%frame(i)%item)
               class is (encounter_snapshot)
                  tvals(i) = snapshot%t
                  call snapshot%get_idvals(itmp)
                  if (allocated(itmp)) then
                     n = size(itmp)
                     ntotal = ntotal + n
                  end if
               end select
            end if
         end do

         allocate(idvals(ntotal))
         nlo = 1
         ! Second pass to get all of the ids stored
         do i = 1, nsnaps
            if (allocated(self%frame(i)%item)) then
               select type(snapshot => self%frame(i)%item)
               class is (encounter_snapshot)
                  tvals(i) = snapshot%t
                  call snapshot%get_idvals(itmp)
                  if (allocated(itmp)) then
                     n = size(itmp)
                     nhi = nlo + n - 1
                     idvals(nlo:nhi) = itmp(1:n)
                     nlo = nhi + 1 
                  end if
               end select
            end if
         end do

      end associate 
      return
   end subroutine encounter_util_get_vals_storage


   module subroutine encounter_util_index_map(self)
      !! author: David A. Minton
      !!
      !! Maps body id values to storage index values so we don't have to use unlimited dimensions for id.
      !! Basically this will make a unique list of ids that exist in all of the saved snapshots
      implicit none
      ! Arguments
      class(encounter_storage), intent(inout) :: self !! Swiftest storage object
      ! Internals
      integer(I4B), dimension(:), allocatable :: idvals
      real(DP), dimension(:), allocatable :: tvals

      call encounter_util_get_vals_storage(self, idvals, tvals)

      ! Consolidate ids to only unique values
      call util_unique(idvals,self%idvals,self%idmap)
      self%nid = size(self%idvals)

      ! Consolidate time values to only unique values
      call util_unique(tvals,self%tvals,self%tmap)
      self%nt = size(self%tvals)

      return
   end subroutine encounter_util_index_map


   module subroutine encounter_util_resize_list(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of the encounter list against the required size and extends it by a factor of 2 more than requested if it is too small.
      !! Note: The reason to extend it by a factor of 2 is for performance. When there are many enounters per step, resizing every time you want to add an 
      !! encounter takes significant computational effort. Resizing by a factor of 2 is a tradeoff between performance (fewer resize calls) and memory managment
      !! Memory usage grows by a factor of 2 each time it fills up, but no more. 
      implicit none
      ! Arguments
      class(encounter_list), intent(inout) :: self !! Swiftest encounter list 
      integer(I8B),          intent(in)    :: nnew !! New size of list needed
      ! Internals
      class(encounter_list), allocatable :: enc_temp
      integer(I8B)                       :: nold
      logical                            :: lmalloc

      lmalloc = allocated(self%status)
      if (lmalloc) then
         nold = size(self%status)
      else
         nold = 0_I8B
      end if
      if (nnew > nold) then
         if (lmalloc) allocate(enc_temp, source=self)
         call self%setup(2_I8B * nnew)
         if (lmalloc) then
            call self%copy(enc_temp)
            deallocate(enc_temp)
         end if
      else
         self%status(nnew+1_I8B:nold) = INACTIVE
      end if
      self%nenc = nnew

      return
   end subroutine encounter_util_resize_list


   module subroutine encounter_util_setup_aabb(self, n, n_last)
      !! author: David A. Minton
      !!
      !! Sets up or modifies an axis-aligned bounding box structure.
      implicit none
      ! Arguments
      class(encounter_bounding_box), intent(inout) :: self   !! Swiftest encounter structure
      integer(I4B),                  intent(in)    :: n      !! Number of objects with bounding box extents
      integer(I4B),                  intent(in)    :: n_last !! Number of objects with bounding box extents the previous time this was called
      ! Internals
      integer(I4B) :: next, next_last, k
      integer(I4B), dimension(:), allocatable :: itmp

      next = 2 * n
      next_last = 2 * n_last

      if (n > n_last) then ! The number of bodies has grown. Resize and append the new bodies
         allocate(itmp(next))
         if (n_last > 0) itmp(1:next_last) = self%aabb%ind(1:next_last)
         call move_alloc(itmp, self%aabb%ind)
         self%aabb%ind(next_last+1:next) = [(k, k = next_last+1, next)]
      else ! The number of bodies has gone down. Resize and chop of the old indices
         allocate(itmp(next))
         itmp(1:next) = pack(self%aabb%ind(1:next_last), self%aabb%ind(1:next_last) <= next)
         call move_alloc(itmp, self%aabb%ind)
      end if

      if (allocated(self%aabb%ibeg)) deallocate(self%aabb%ibeg)
      allocate(self%aabb%ibeg(n))
      if (allocated(self%aabb%iend)) deallocate(self%aabb%iend)
      allocate(self%aabb%iend(n))

      return
   end subroutine encounter_util_setup_aabb


   module subroutine encounter_util_setup_list(self, n)
      !! author: David A. Minton
      !!
      !! A constructor that sets the number of encounters and allocates and initializes all arrays  
      !!
      implicit none
      ! Arguments
      class(encounter_list), intent(inout) :: self !! Swiftest encounter structure
      integer(I8B),          intent(in)    :: n    !! Number of encounters to allocate space for

      if (n < 0) return
      call self%dealloc()

      self%nenc = n
      if (n == 0_I8B) return
      self%t = 0.0_DP

      allocate(self%tcollision(n))
      allocate(self%lvdotr(n))
      allocate(self%lclosest(n))
      allocate(self%status(n))
      allocate(self%index1(n))
      allocate(self%index2(n))
      allocate(self%id1(n))
      allocate(self%id2(n))
      allocate(self%r1(NDIM,n))
      allocate(self%r2(NDIM,n))
      allocate(self%v1(NDIM,n))
      allocate(self%v2(NDIM,n))
      allocate(self%level(n))

      self%tcollision(:) = 0.0_DP
      self%lvdotr(:) = .false.
      self%lclosest(:) = .false.
      self%status(:) = INACTIVE
      self%index1(:) = 0
      self%index2(:) = 0
      self%id1(:) = 0
      self%id2(:) = 0
      self%r1(:,:) = 0.0_DP
      self%r2(:,:) = 0.0_DP
      self%v1(:,:) = 0.0_DP
      self%v2(:,:) = 0.0_DP
      self%level(:) = 0

      return
   end subroutine encounter_util_setup_list

   
   module subroutine encounter_util_spill_list(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) Swiftest encounter structure from active list to discard list
      implicit none
      ! Arguments
      class(encounter_list), intent(inout) :: self         !! Swiftest encounter list 
      class(encounter_list), intent(inout) :: discards     !! Discarded object 
      logical, dimension(:), intent(in)    :: lspill_list  !! Logical array of bodies to spill into the discards
      logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter body by removing the discard list
      ! Internals
      integer(I8B) :: nenc_old
  
      associate(keeps => self)
         call util_spill(keeps%tcollision, discards%tcollision, lspill_list, ldestructive)
         call util_spill(keeps%lvdotr,     discards%lvdotr,     lspill_list, ldestructive)
         call util_spill(keeps%lclosest,   discards%lclosest,   lspill_list, ldestructive)
         call util_spill(keeps%status,     discards%status,     lspill_list, ldestructive)
         call util_spill(keeps%index1,     discards%index1,     lspill_list, ldestructive)
         call util_spill(keeps%index2,     discards%index2,     lspill_list, ldestructive)
         call util_spill(keeps%id1,        discards%id1,        lspill_list, ldestructive)
         call util_spill(keeps%id2,        discards%id2,        lspill_list, ldestructive)
         call util_spill(keeps%r1,         discards%r1,         lspill_list, ldestructive)
         call util_spill(keeps%r2,         discards%r2,         lspill_list, ldestructive)
         call util_spill(keeps%v1,         discards%v1,         lspill_list, ldestructive)
         call util_spill(keeps%v2,         discards%v2,         lspill_list, ldestructive)
         call util_spill(keeps%level,      discards%level,      lspill_list, ldestructive)

         nenc_old = keeps%nenc

         ! This is the base class, so will be the last to be called in the cascade. 
         ! Therefore we need to set the nenc values for both the keeps and discareds
         discards%nenc = count(lspill_list(1:nenc_old))
         if (ldestructive) keeps%nenc = nenc_old - discards%nenc
      end associate
   
      return
   end subroutine encounter_util_spill_list


   module subroutine encounter_util_snapshot(self, param, nbody_system, t, arg)
      !! author: David A. Minton
      !!
      !! Takes a minimal snapshot of the state of the system during an encounter so that the trajectories
      !! can be played back through the encounter
      use symba, only : symba_pl, symba_tp, symba_nbody_system
      implicit none
      ! Internals
      class(encounter_storage),  intent(inout)        :: self         !! Swiftest storage object
      class(base_parameters),    intent(inout)        :: param        !! Current run configuration parameters
      class(base_nbody_system),  intent(inout)        :: nbody_system !! Swiftest nbody system object to store
      real(DP),                  intent(in), optional :: t            !! Time of snapshot if different from system time
      character(*),              intent(in), optional :: arg          !! Optional argument (needed for extended storage type used in collision snapshots)
      ! Arguments
      class(encounter_snapshot), allocatable :: snapshot
      integer(I4B) :: i, pii, pjj, npl_snap, ntp_snap, iflag
      integer(I8B) :: k
      real(DP), dimension(NDIM) :: rrel, vrel, rcom, vcom
      real(DP) :: Gmtot, a, q, capm, tperi
      real(DP), dimension(NDIM,2) :: rb,vb

      if (.not.present(t)) then
         write(*,*) "encounter_util_snapshot_encounter requires `t` to be passed"
         return
      end if

      if (.not.present(arg)) then
         write(*,*) "encounter_util_snapshot_encounter requires `arg` to be passed"
         return
      end if

      select type(param)
      class is (swiftest_parameters)
      select type (nbody_system)
      class is (swiftest_nbody_system)
      select type (pl => nbody_system%pl)
      class is (swiftest_pl)
      select type (tp => nbody_system%tp)
      class is (swiftest_tp)
         associate(npl => pl%nbody,  ntp => tp%nbody)
            if (npl + ntp == 0) return
            allocate(encounter_snapshot :: snapshot)
            allocate(snapshot%pl, mold=pl)
            allocate(snapshot%tp, mold=tp)
            snapshot%iloop = param%iloop

            select type(pl_snap => snapshot%pl)
            class is (swiftest_pl)
               select type(tp_snap => snapshot%tp)
               class is (swiftest_tp)

                  select case(arg)
                  case("trajectory")
                     snapshot%t = t

                     npl_snap = npl
                     ntp_snap = ntp

                     if (npl > 0) then
                        pl%lmask(1:npl) = pl%status(1:npl) /= INACTIVE 
                        select type(pl)
                        class is (symba_pl)
                        select type(nbody_system)
                        class is (symba_nbody_system)
                           pl%lmask(1:npl) = pl%lmask(1:npl) .and. pl%levelg(1:npl) == nbody_system%irec
                        end select
                        end select
                        npl_snap = count(pl%lmask(1:npl))
                     end if
                     if (ntp > 0) then
                        tp%lmask(1:ntp) = tp%status(1:ntp) /= INACTIVE 
                        select type(tp)
                        class is (symba_tp)
                        select type(nbody_system)
                        class is (symba_nbody_system)
                           tp%lmask(1:ntp) = tp%lmask(1:ntp) .and. tp%levelg(1:ntp) == nbody_system%irec
                        end select
                        end select
                        ntp_snap = count(tp%lmask(1:ntp))
                     end if

                     if (npl_snap + ntp_snap == 0) return ! Nothing to snapshot

                     pl_snap%nbody = npl_snap

                     ! Take snapshot of the currently encountering massive bodies
                     if (npl_snap > 0) then
                        call pl_snap%setup(npl_snap, param)
                        select type (pl)
                        class is (symba_pl)
                           select type(pl_snap)
                           class is (symba_pl)
                              pl_snap%levelg(:) = pack(pl%levelg(1:npl), pl%lmask(1:npl))
                           end select
                        end select

                        pl_snap%id(:) = pack(pl%id(1:npl), pl%lmask(1:npl))
                        pl_snap%info(:) = pack(pl%info(1:npl), pl%lmask(1:npl))
                        pl_snap%Gmass(:) = pack(pl%Gmass(1:npl), pl%lmask(1:npl))
                        do i = 1, NDIM
                           pl_snap%rh(i,:) = pack(pl%rh(i,1:npl), pl%lmask(1:npl))
                           pl_snap%vh(i,:) = pack(pl%vb(i,1:npl), pl%lmask(1:npl))
                        end do
                        if (param%lclose) then
                           pl_snap%radius(:) = pack(pl%radius(1:npl), pl%lmask(1:npl))
                        end if

                        if (param%lrotation) then
                           do i = 1, NDIM
                              pl_snap%Ip(i,:) = pack(pl%Ip(i,1:npl), pl%lmask(1:npl))
                              pl_snap%rot(i,:) = pack(pl%rot(i,1:npl), pl%lmask(1:npl))
                           end do
                        end if
                        call pl_snap%sort("id", ascending=.true.)
                     end if

                     ! Take snapshot of the currently encountering test particles
                     tp_snap%nbody = ntp_snap
                     if (ntp_snap > 0) then
                        call tp_snap%setup(ntp_snap, param)
                        tp_snap%id(:) = pack(tp%id(1:ntp), tp%lmask(1:ntp))
                        tp_snap%info(:) = pack(tp%info(1:ntp), tp%lmask(1:ntp))
                        do i = 1, NDIM
                           tp_snap%rh(i,:) = pack(tp%rh(i,1:ntp), tp%lmask(1:ntp))
                           tp_snap%vh(i,:) = pack(tp%vh(i,1:ntp), tp%lmask(1:ntp))
                        end do
                     end if

                     ! Save the snapshot
                     self%nid = self%nid + ntp_snap + npl_snap
                     call self%save(snapshot)
                  case("closest")
                     associate(plpl_encounter => nbody_system%plpl_encounter, pltp_encounter => nbody_system%pltp_encounter)
                        if (plpl_encounter%nenc > 0) then
                           if (any(plpl_encounter%lclosest(:))) then
                              call pl_snap%setup(2, param)
                              do k = 1_I8B, plpl_encounter%nenc
                                 if (plpl_encounter%lclosest(k)) then
                                    pii = plpl_encounter%index1(k)
                                    pjj = plpl_encounter%index2(k)
                                    select type(pl_snap)
                                    class is (symba_pl)
                                    select type(pl)
                                    class is (symba_pl)
                                       pl_snap%levelg(:) = pl%levelg([pii,pjj])
                                    end select
                                    end select
                                    pl_snap%id(:) = pl%id([pii,pjj])
                                    pl_snap%info(:) = pl%info([pii,pjj])
                                    pl_snap%Gmass(:) = pl%Gmass([pii,pjj])
                                    Gmtot = sum(pl_snap%Gmass(:))
                                    if (param%lclose) pl_snap%radius(:) = pl%radius([pii,pjj])
                                    if (param%lrotation) then
                                       do i = 1, NDIM
                                          pl_snap%Ip(i,:) = pl%Ip(i,[pii,pjj])
                                          pl_snap%rot(i,:) = pl%rot(i,[pii,pjj])
                                       end do
                                    end if

                                    ! Compute pericenter passage time to get the closest approach parameters
                                    rrel(:) = plpl_encounter%r2(:,k) - plpl_encounter%r1(:,k)
                                    vrel(:) = plpl_encounter%v2(:,k) - plpl_encounter%v1(:,k)
                                    call swiftest_orbel_xv2aqt(Gmtot, rrel(1), rrel(2), rrel(3), vrel(1), vrel(2), vrel(3), a, q, capm, tperi)
                                    snapshot%t = t + tperi
                                    if ((snapshot%t < maxval(pl_snap%info(:)%origin_time)) .or. &
                                          (snapshot%t > minval(pl_snap%info(:)%discard_time))) cycle

                                    ! Computer the center mass of the pair
                                    rcom(:) = (plpl_encounter%r1(:,k) * pl_snap%Gmass(1) + plpl_encounter%r2(:,k) * pl_snap%Gmass(2)) / Gmtot
                                    vcom(:) = (plpl_encounter%v1(:,k) * pl_snap%Gmass(1) + plpl_encounter%v2(:,k) * pl_snap%Gmass(2)) / Gmtot
                                    rb(:,1) = plpl_encounter%r1(:,k) - rcom(:)
                                    rb(:,2) = plpl_encounter%r2(:,k) - rcom(:)
                                    vb(:,1) = plpl_encounter%v1(:,k) - vcom(:)
                                    vb(:,2) = plpl_encounter%v2(:,k) - vcom(:)

                                    ! Drift the relative orbit to get the new relative position and velocity
                                    call swiftest_drift_one(Gmtot, rrel(1), rrel(2), rrel(3), vrel(1), vrel(2), vrel(3), tperi, iflag)
                                    if (iflag /= 0) write(*,*) "Danby error in encounter_util_snapshot_encounter. Closest approach positions and vectors may not be accurate."

                                    ! Get the new position and velocity vectors
                                    rb(:,1) = -(pl_snap%Gmass(2) / Gmtot) * rrel(:)
                                    rb(:,2) =  (pl_snap%Gmass(1)) / Gmtot * rrel(:)

                                    vb(:,1) = -(pl_snap%Gmass(2) / Gmtot) * vrel(:)
                                    vb(:,2) =  (pl_snap%Gmass(1)) / Gmtot * vrel(:)

                                    ! Move the CoM assuming constant velocity over the time it takes to reach periapsis
                                    rcom(:) = rcom(:) + vcom(:) * tperi

                                    ! Compute the heliocentric position and velocity vector at periapsis
                                    pl_snap%rh(:,1) = rb(:,1) + rcom(:)
                                    pl_snap%rh(:,2) = rb(:,2) + rcom(:)
                                    pl_snap%vh(:,1) = vb(:,1) + vcom(:)
                                    pl_snap%vh(:,2) = vb(:,2) + vcom(:)

                                    call pl_snap%sort("id", ascending=.true.)
                                    call self%save(snapshot)
                                 end if
                              end do

                              plpl_encounter%lclosest(:) = .false.
                           end if
                        end if

                        if (pltp_encounter%nenc > 0) then
                           if (any(pltp_encounter%lclosest(:))) then
                              do k = 1_I8B, pltp_encounter%nenc
                              end do
                              pltp_encounter%lclosest(:) = .false.
                           end if
                        end if
                     end associate
                  case default
                     write(*,*) "encounter_util_snapshot_encounter requires `arg` to be either `trajectory` or `closest`"
                  end select
               end select
            end select
         end associate
      end select
      end select
      end select
      end select

      return
   end subroutine encounter_util_snapshot


end submodule s_encounter_util

submodule(tides) s_tides_kick_getacch
   use swiftest
contains

   module subroutine tides_kick_getacch_pl(self, nbody_system)
      !! author: Jennifer L.L. Pouplin, Carlisle A. wishard, and David A. Minton
      !!
      !! Calculated tidal torques from central body to any planet and from any planet to central body
      !! planet - planet interactions are considered negligable.
      !! This is a constant time lag model.
      !! 
      !! Adapted from Mercury-T code from Bolmont et al. (2015)
      !!
      !! Reference:
      !!    Bolmont, E., Raymond, S.N., Leconte, J., Hersant, F., Correia, A.C.M., 2015. 
      !!       Mercury-T : A new code to study tidally evolving multi-planet systems. 
      !!       Applications to Kepler-62. A&A 583, A116. https://doi.org/10.1051/0004-6361/201525909
      implicit none
      ! Arguments
      class(base_object),           intent(inout) :: self   !! Swiftest massive body object
      class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      ! Internals
      integer(I4B)                          :: i
      real(DP)                              :: rmag, vmag
      real(DP), dimension(NDIM)             :: r_unit, v_unit, h_unit, theta_unit, theta_dot, F_T
      real(DP)                              :: Ftr, Ptopl, Ptocb, r5cbterm, r5plterm

      select type(pl => self)
      class is (swiftest_pl)
      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(npl => pl%nbody, cb => nbody_system%cb)
            pl%atide(:,:) = 0.0_DP
            cb%atide(:) = 0.0_DP
            do i = 1, npl
               rmag = norm2(pl%rh(:,i))
               vmag = norm2(pl%vh(:,i))
               r_unit(:) = pl%rh(:,i) / rmag
               v_unit(:) = pl%vh(:,i) / vmag
               h_unit(:) = r_unit(:) .cross. v_unit(:)
               theta_unit(:) = h_unit(:) .cross. r_unit(:)
               theta_dot = dot_product(pl%vh(:,i), theta_unit(:))

               ! First calculate the tangential component of the force vector (eq. 5 & 6 of Bolmont et al. 2015)
               ! The radial component is already computed in the obl_acc methods
               r5cbterm = pl%Gmass(i)**2 * cb%k2 * cb%radius**5
               r5plterm = cb%Gmass**2 * pl%k2(i) * pl%radius(i)**5

               Ptopl = 3 * r5plterm * pl%tlag(i) / rmag**7
               Ptocb = 3 * r5cbterm * cb%tlag / rmag**7

               Ftr = -3 / rmag**7 * (r5cbterm + r5plterm) - 3 * vmag / rmag * (Ptocb + Ptopl)

               F_T(:) = (Ftr + (Ptocb + Ptopl) * dot_product(v_unit, r_unit) / rmag) * r_unit(:)  &
                        + Ptopl * ((pl%rot(:,i) - theta_dot(:)) .cross. r_unit(:))  &
                        + Ptocb * ((cb%rot(:)   - theta_dot(:)) .cross. r_unit(:))
               cb%atide(:) = cb%atide(:) + F_T(:) / cb%Gmass
               pl%atide(:,i) = F_T(:) / pl%Gmass(i) 
            end do 

            do i = 1, npl
               pl%ah(:,i) = pl%ah(:,i) + pl%atide(:,i) + cb%atide(:)
            end do 
         end associate
      end select
      end select

      return
   end subroutine tides_kick_getacch_pl
   
end submodule s_tides_kick_getacch

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(swiftest) s_swiftest_user
   use swiftest
contains
   module subroutine swiftest_user_kick_getacch_body(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Add user-supplied heliocentric accelerations to planets.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine whm_user_kick_getacch.f90
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self   
         !! Swiftest massive body particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system 
         !! Swiftest nbody_system_object
      class(swiftest_parameters),   intent(inout) :: param  
         !! Current run configuration parameters user parameters
      real(DP),                     intent(in)    :: t      
         !! Current time
      logical,                      intent(in)    :: lbeg   
         !! Logical flag that determines whether or not this is the beginning or end of the ste

      return
   end subroutine swiftest_user_kick_getacch_body

end submodule s_swiftest_user

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(rmvs) s_rmvs_kick
   use swiftest
contains  

   module subroutine rmvs_kick_getacch_tp(self, nbody_system, param, t, lbeg)
      !! author: David A. Minton
      !!
      !! Compute the oblateness acceleration in the inner encounter region with planets 
      !! 
      !! Performs a similar task as David E. Kaufmann's Swifter routine rmvs_kick_getacch_tp.f90, but 
      !! uses object polymorphism, and so is not directly adapted.
      implicit none
      ! Arguments
      class(rmvs_tp),               intent(inout) :: self   !! RMVS test particle data structure
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest central body particle data structuree 
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters
      real(DP),                     intent(in)    :: t      !! Current time
      logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      ! Internals
      class(swiftest_parameters), allocatable   :: param_planetocen
      real(DP), dimension(:, :), allocatable    :: rh_original
      real(DP)                                  :: GMcb_original
      integer(I4B)                              :: i, ntp, inner_index

      if (self%nbody == 0) return

      associate(tp => self, ipleP => self%ipleP)
         ntp = self%nbody
         inner_index = self%index
         select type(nbody_system)
         class is (rmvs_nbody_system)
            if (nbody_system%lplanetocentric) then  ! This is a close encounter step, so any accelerations requiring heliocentric position values
                                              ! must be handeled outside the normal WHM method call
               select type(pl => nbody_system%pl)
               class is (rmvs_pl)
                  select type (cb => nbody_system%cb)
                  class is (rmvs_cb)
                     associate(xpc => pl%rh, xpct => self%rh, apct => self%ah, system_planetocen => nbody_system)
                        system_planetocen%lbeg = lbeg

                        ! Save the original heliocentric position for later
                        allocate(rh_original, source=tp%rh)

                        ! Temporarily turn off the heliocentric-dependent acceleration terms during an inner encounter using a copy of the parameter list with all of the heliocentric-specific acceleration terms turned off
                        allocate(param_planetocen, source=param)
                        param_planetocen%loblatecb = .false.
                        param_planetocen%lextra_force = .false.
                        param_planetocen%lgr = .false.

                        ! Compute the planetocentric values of acceleration
                        call whm_kick_getacch_tp(tp, system_planetocen, param_planetocen, t, lbeg)

                        ! Now compute any heliocentric values of acceleration 
                        if (tp%lfirst) then
#ifdef DOCONLOC
                           do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp)
#else
                           do concurrent(i = 1:ntp, tp%lmask(i))
#endif
                              tp%rheliocentric(:,i) = tp%rh(:,i) + cb%inner(inner_index - 1)%x(:,1)
                           end do
                        else
#ifdef DOCONLOC
                           do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp)
#else
                           do concurrent(i = 1:ntp, tp%lmask(i))
#endif
                              tp%rheliocentric(:,i) = tp%rh(:,i) + cb%inner(inner_index    )%x(:,1)
                           end do
                        end if

                        ! Swap the planetocentric and heliocentric position vectors and central body masses
#ifdef DOCONLOC
                        do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp)
#else
                        do concurrent(i = 1:ntp, tp%lmask(i))
#endif
                           tp%rh(:, i) = tp%rheliocentric(:, i)
                        end do
                        GMcb_original = cb%Gmass
                        cb%Gmass = tp%cb_heliocentric%Gmass

                        ! If the heliocentric-specifc acceleration terms are requested, compute those now
                        if (param%loblatecb) call tp%accel_obl(system_planetocen)
                        if (param%lextra_force) call tp%accel_user(system_planetocen, param, t, lbeg)
                        if (param%lgr) call tp%accel_gr(param)

                        ! Put everything back the way we found it
                        call move_alloc(rh_original, tp%rh)
                        cb%Gmass = GMcb_original

                     end associate
                  end select
               end select
            else ! Not a close encounter, so just proceded with the standard WHM method
               call whm_kick_getacch_tp(tp, nbody_system, param, t, lbeg)
            end if
         end select
      end associate

      return
   end subroutine rmvs_kick_getacch_tp

end submodule s_rmvs_kick

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(operators) s_operator_unit
   use, intrinsic :: ieee_exceptions
   !! author: David A. Minton
   !!
   !! Contains implementations for the .unit. operator for all defined real types
   !! Returns a unit vector or array of unit vectors from an input vector or array of vectors
   !! Single vector implementations:  B   = .unit. A(1:NDIM)
   !! Vector list implementations:   B(:) = .unit. A(1:NDIM, :)
contains

   pure module function operator_unit_sp(A) result(B)
      implicit none
      ! Arguments
      real(SP), dimension(:), intent(in) :: A
      real(SP), dimension(NDIM)          :: B
      ! Internals
      real(SP)  :: Amag

      call ieee_set_halting_mode(ieee_underflow, .false.)
      Amag = norm2(A(:))
      if (Amag > tiny(1._SP)) then
         B(:) = A(:) / Amag
      else
         B(:) = 0.0_SP
      end if

      return
   end function operator_unit_sp


   pure module function operator_unit_dp(A) result(B)
      implicit none
      ! Arguments
      real(DP), dimension(:), intent(in) :: A
      real(DP), dimension(NDIM)             :: B
      ! Internals
      real(DP)  :: Amag

      call ieee_set_halting_mode(ieee_underflow, .false.)
      Amag = norm2(A(:))
      if (Amag > tiny(1._DP)) then
         B(:) = A(:) / Amag
      else
         B(:) = 0.0_DP
      end if

      return
   end function operator_unit_dp

#ifdef QUADPREC
   pure module function operator_unit_qp(A) result(B)
      implicit none
      ! Arguments
      real(QP), dimension(:), intent(in) :: A
      real(QP), dimension(NDIM)             :: B
      ! Internals
      real(QP)  :: Amag

      call ieee_set_halting_mode(ieee_underflow, .false.)
      Amag = norm2(A(:))
      if (Amag > tiny(1._QP)) then
         B(:) = A(:) / Amag
      else
         B(:) = 0.0_QP
      end if

      return
   end function operator_unit_qp
#endif

   pure module function operator_unit_el_sp(A) result(B)
      implicit none
      ! Arguments
      real(SP), dimension(:,:), intent(in)   :: A
      real(SP), dimension(:,:), allocatable  :: B
      ! Internals
      integer(I4B)  :: i,n

      n = size(A, 2)
      if (allocated(B)) deallocate(B)
      allocate(B(NDIM,n))

      do i=1,n
         B(:,i) = operator_unit_sp(A(:,i))
      end do

      return
   end function operator_unit_el_sp


   pure module function operator_unit_el_dp(A) result(B)
      implicit none
      ! Arguments
      real(DP), dimension(:,:), intent(in)   :: A
      real(DP), dimension(:,:), allocatable  :: B
      ! Internals
      integer(I4B)  :: i,n

      n = size(A, 2)
      if (allocated(B)) deallocate(B)
      allocate(B(NDIM,n))

      do i=1,n
         B(:,i) = operator_unit_dp(A(:,i))
      end do

      return
   end function operator_unit_el_dp

#ifdef QUADPREC
   pure module function operator_unit_el_qp(A) result(B)
      implicit none
      ! Arguments
      real(QP), dimension(:,:), intent(in)   :: A
      real(QP), dimension(:,:), allocatable  :: B
      ! Internals
      integer(I4B)  :: i,n

      n = size(A, 2)
      if (allocated(B)) deallocate(B)
      allocate(B(NDIM,n))

      do i=1,n
         B(:,i) = operator_unit_qp(A(:,i))
      end do

      return 
   end function operator_unit_el_qp
#endif

end submodule s_operator_unit

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module solver
   !! author: David A. Minton
   !! 
   !! Contains a 4th order Runge-Kutta-Fehlberg ODE solver and a linear system of equations solver
   use globals
   use base
   use lambda_function
   use, intrinsic :: ieee_exceptions
   private
   public :: solve_linear_system, solve_roots 

   interface solve_linear_system
      module procedure solve_linear_system_dp
#ifdef QUADPREC
      module procedure solve_linear_system_qp
#endif
   end interface

   interface solve_roots
      module procedure solve_roots_dp
   end interface

   contains

      function solve_linear_system_dp(A,b,n,lerr) result(x)
         !! Author: David A. Minton
         !!
         !! Solves the linear equation of the form A*x = b for x. 
         !!   A is an (n,n) arrays
         !!   x and b are (n) arrays
         !! Uses Gaussian elimination, so will have issues if nbody_system is ill-conditioned.
         !! Uses quad precision intermidiate values, so works best on small arrays.
         implicit none
         ! Arguments
         integer(I4B),             intent(in)  :: n
         real(DP), dimension(:,:), intent(in)  :: A
         real(DP), dimension(:),   intent(in)  :: b
         logical,                  intent(out) :: lerr
         ! Result
         real(DP), dimension(n)                :: x
         ! Internals
         real(QP), dimension(:), allocatable :: qx
         type(ieee_status_type) :: original_fpe_status
         logical, dimension(:), allocatable :: fpe_flag 
         real(QP), dimension(:,:), allocatable :: u

         call ieee_get_status(original_fpe_status) ! Save the original floating point exception status
         call ieee_set_flag(ieee_all, .false.) ! Set all flags to quiet
         allocate(fpe_flag(size(ieee_usual)))

         u = ge_wpp(real(A, kind=QP), real(b, kind=QP))
         qx = solve_wbs(u)

         call ieee_get_flag(ieee_usual, fpe_flag)
         lerr = any(fpe_flag) 
         if (lerr .or. (any(abs(qx) > huge(x))) .or. (any(abs(qx) < tiny(x)))) then
            x = 0.0_DP
         else
            x = real(qx, kind=DP)
         end if
         call ieee_set_status(original_fpe_status)

         return
      end function solve_linear_system_dp

#ifdef QUADPREC
      function solve_linear_system_qp(A,b,n,lerr) result(x)
         !! Author: David A. Minton
         !!
         !! Solves the linear equation of the form A*x = b for x. 
         !!   A is an (n,n) arrays
         !!   x and b are (n) arrays
         !! Uses Gaussian elimination, so will have issues if nbody_system is ill-conditioned.
         !! Uses quad precision intermidiate values, so works best on small arrays.
         implicit none
         ! Arguments
         integer(I4B),             intent(in) :: n
         real(QP), dimension(:,:), intent(in) :: A
         real(QP), dimension(:),   intent(in) :: b
         logical,                  intent(out) :: lerr
         ! Result
         real(QP), dimension(n)  :: x
         ! Internals
         type(ieee_status_type) :: original_fpe_status
         logical, dimension(:), allocatable :: fpe_flag 
         real(QP), dimension(:,:), allocatable :: u

         call ieee_get_status(original_fpe_status) ! Save the original floating point exception status
         call ieee_set_flag(ieee_all, .false.) ! Set all flags to quiet
         allocate(fpe_flag(size(ieee_usual)))

         u = ge_wpp(A, b)
         x = solve_wbs(u)

         call ieee_get_flag(ieee_usual, fpe_flag)
         lerr = any(fpe_flag) 
         if (lerr) x = 0.0_DP
         call ieee_set_status(original_fpe_status) 

         return
      end function solve_linear_system_qp
#endif

      function solve_wbs(u) result(x) ! solve with backward substitution
         !! Based on code available on Rosetta Code: https://rosettacode.org/wiki/Gaussian_elimination#Fortran
         implicit none
         ! Arguments
         real(QP), intent(in), dimension(:,:), allocatable  :: u
         ! Result
         real(QP), dimension(:), allocatable :: x
         ! Internals
         integer(I4B)             :: i,n

         n = size(u, 1)
         if (allocated(x)) deallocate(x)
         if (.not.allocated(x)) allocate(x(n))
         if (any(abs(u) < tiny(1._DP)) .or. any(abs(u) > huge(1._DP))) then 
            x(:) = 0._DP
            return
         end if
         call ieee_set_halting_mode(ieee_divide_by_zero, .false.)
         do i = n, 1, -1 
            x(i) = (u(i, n + 1) - sum(u(i, i + 1:n) * x(i + 1:n))) / u(i, i)
         end do   
         return
      end function solve_wbs


      function ge_wpp(A, b) result(u) ! gaussian eliminate with partial pivoting
         !! Solve  Ax=b  using Gaussian elimination then backwards substitution.
         !!   A being an n by n matrix.
         !!   x and b are n by 1 vectors. 
         !! Based on code available on Rosetta Code: https://rosettacode.org/wiki/Gaussian_elimination#Fortran
         implicit none
         ! Arguments
         real(QP), dimension(:,:), intent(in) :: A
         real(QP), dimension(:),   intent(in) :: b
         ! Result
         real(QP), dimension(:,:), allocatable :: u
         ! Internals
         integer(I4B) :: i,j,n,p
         real(QP)     ::  upi

         n = size(a, 1)
         allocate(u(n, (n + 1)))
         u = reshape([A, b], [n, n + 1])
         call ieee_set_halting_mode(ieee_divide_by_zero, .false.)
         do j = 1, n
            p = maxloc(abs(u(j:n, j)), 1) + j - 1 ! maxloc returns indices between (1, n - j + 1)
            if (p /= j) u([p, j], j) = u([j, p], j)
            u(j + 1:, j) = u(j + 1:, j) / u(j, j)
            do i = j + 1, n + 1
               upi = u(p, i)
               if (p /= j) u([p, j], i) = u([j, p], i)
               u(j + 1:n, i) = u(j + 1:n, i) - upi * u(j + 1:n, j)
            end do
         end do
         return
      end function ge_wpp


      subroutine solve_roots_dp(f,x,tol,lerr)
         !! author: David A. Minton
         !! 
         !! Uses Brent's method to find the root of a function f
         implicit none
         ! Arguments
         interface
            function f(x) result(y)
               import DP
               real(DP), intent(in) :: x
               real(DP)             :: y
            end function f
         end interface
         real(DP),           intent(inout) :: x    
            !! Initial guess and also the final answer
         real(DP), optional, intent(in)    :: tol  
            !! The relative tolerance on the solution
         logical, optional,  intent(out)   :: lerr 
            !! Returns .true. if a root was found, otherwise returns .false.
         ! Internals
         real(DP),parameter :: TOL_DEFAULT = 1.e-7_DP
         integer(I4B),parameter :: maxIterations=100
         real(DP) :: valueAtRoot, x1, startx1, x2, factor, Tolerance
         real(DP),parameter :: FPP = 1.e-11_DP
         real(DP),parameter :: nearzero = 1.e-20_DP
         real(DP) :: resultat,AA,BB,CC,DD,EE,FA,FB,FC,Tol1,PP,QQ,RR,SS,xm
         integer(I4B) :: i,j, ev,br, niter, error
         integer(I4B),parameter :: NTRY = 50
         integer(I4B),parameter :: NBRACKET =20 
         real(DP),parameter :: FIRSTFACTOR = 1.1_DP
         real(DP) :: f1, f2, fmin
         integer(I4B) :: numev,numbr
      
         if (present(tol)) then
            Tolerance = tol
         else
            Tolerance = TOL_DEFAULT
         end if

         factor=FIRSTFACTOR
         numev = 0
         numbr = 0
         startx1 = x
         everything: do ev = 1, NTRY
            numev = numev + 1
            if (ev == NTRY) then
               if (present(lerr)) lerr = .true.
               return
            end if
            bracket: do br = 1, NBRACKET
               numbr = numbr + 1
               x1 = startx1
               x2 = startx1 + abs(startx1 * (1.0_DP - factor))

               ! First bracket the root
               f1 = f(x1)
               f2 = f(x2)
               fmin = abs(f1)
               do j = 1, NTRY
                  if ((f1 * f2 < 0._DP)) exit bracket
                  if (abs(f1) < abs(f2)) then
                     x1 = x1 + factor * (x1 - x2)
                     f1 = f(x1)
                     if (abs(f1) < fmin) then
                        fmin = abs(f1)
                        startx1 = x1
                     end if
                  else
                     x2 = x2 + factor * (x2 - x1)
                     if (x2 < 0.0_DP) exit
                     f2 = f(x2)
                     if (abs(f2) < fmin) then
                        fmin = abs(f2)
                        startx1 = x2
                     end if
                  end if
               end do
               x1 = x2
               factor = factor + 0.5_DP * (factor - 1._DP)
            end do bracket

            ! Now do a Brent's method to find the root
            error = 0
            AA = x1
            BB = x2
            FA = f1
            FB = f2
            CC = AA; FC = FA; DD = BB - AA; EE = DD
            if (.not.RootBracketed(FA,FB)) then 
               error = -1
               resultat = x1
            else 
               FC = FB 
               do i = 1, maxIterations 
                  if (.not.RootBracketed(FC,FB)) then
                     CC = AA; FC = FA; DD = BB - AA; EE = DD
                  end if
                  if (abs(FC) < abs(FB)) then
                     AA = BB; BB = CC; CC = AA
                     FA = FB; FB = FC; FC = FA
                  end if
                  Tol1 = 2 * FPP * abs(BB) + 0.5_DP * Tolerance
                  xm = 0.5_DP * (CC-BB)
                  if ((abs(xm) <= Tol1).or.(abs(FA) < nearzero)) then
                     ! A root has been found
                     resultat = BB 
                     valueAtRoot = f(resultat)
                     exit
                  else 
                     if ((abs(EE) >= Tol1).and.(abs(FA) > abs(FB))) then
                        SS = FB / FA 
                        if (abs(AA - CC) < nearzero) then
                           PP = 2 * xm * SS 
                           QQ = 1._DP - SS 
                        else 
                           QQ = FA / FC 
                           RR = FB / FC 
                           PP = SS * (2 * xm * QQ * (QQ - RR) - (BB-AA) * (RR - 1._DP)) 
                           QQ = (QQ - 1._DP) * (RR - 1._DP) * (SS - 1._DP) 
                        end if
                        if (PP > nearzero) QQ = -QQ 
                        PP = abs(PP) 
                        if ((2*PP)<min(3*xm *QQ-abs(Tol1*QQ),abs(EE*QQ))) then
                           EE = DD   
                           DD = PP / QQ 
                        else 
                           DD = xm   
                           EE = DD 
                        end if
                     else 
                        DD = xm 
                        EE = DD 
                     end if
                     AA = BB 
                     FA = FB 
                     if (abs(DD) > Tol1) then 
                       BB = BB + DD 
                     else 
                        if (xm > 0) then 
                           BB = BB + abs(Tol1)
                        else 
                           BB = BB - abs(Tol1)
                        end if
                     end if
                     FB = f(BB)
                  end if
               end do
               if (i >= maxIterations) error = -2
            end if
            niter = i
            x = resultat
            if (error == 0) exit
            factor = 0.5_DP  * (factor + 1.0_DP) ! Failed. Try again with a new factor
         end do everything 

         if (present(lerr)) lerr = (error /= 0)

         return
      
         contains
            ! returns the minimum of two real numbers
            real(DP) Function Minimum(x1,x2) 
               real(DP) x1,x2,resultat

               if (x1 < x2) then
                  resultat = x1
               else 
                  resultat = x2
               endif

               Minimum = resultat
            end function Minimum
            
            ! TRUE if x1*x2 negative
            logical Function RootBracketed(x1,x2)
               real(DP) x1,x2 
               logical resultat

               if ((x1 > 0.and.x2 > 0).or.(x1 < 0.and.x2 < 0)) then 
                  resultat = .false.
               else
                  resultat = .true.
               endif
               RootBracketed = resultat
            end function RootBracketed
         
          
                
         end subroutine solve_roots_dp


end module solver

! Copyight 2023 - David Minton
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (whm) s_whm_coarray
use coarray
use swiftest
contains

    module subroutine whm_coarray_coclone_pl(self)
        !! author: David A. Minton
        !!
        !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(whm_pl),intent(inout),codimension[*]  :: self  !! WHM pl object

        call coclone(self%eta)
        call coclone(self%xj)
        call coclone(self%vj)
        call coclone(self%muj)
        call coclone(self%ir3j)

        call swiftest_coarray_coclone_pl(self)

        return
    end subroutine whm_coarray_coclone_pl

end submodule s_whm_coarray

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (swiftest) s_swiftest_obl
   use swiftest
   use shgrav

contains

   pure function matinv3(A) result(B)
      !! Performs a direct calculation of the inverse of a 3×3 matrix.
      !!
      !! from https://fortranwiki.org/fortran/show/Matrix+inversion
      !!

      real(DP), intent(in) :: A(3,3)   !! Matrix
      real(DP)             :: B(3,3)   !! Inverse matrix
      real(DP)             :: detinv

      ! Calculate the inverse determinant of the matrix
      detinv = 1.0_DP/(A(1,1)*A(2,2)*A(3,3) - A(1,1)*A(2,3)*A(3,2)&
               - A(1,2)*A(2,1)*A(3,3) + A(1,2)*A(2,3)*A(3,1)&
               + A(1,3)*A(2,1)*A(3,2) - A(1,3)*A(2,2)*A(3,1))

      ! Calculate the inverse of the matrix
      B(1,1) = +detinv * (A(2,2)*A(3,3) - A(2,3)*A(3,2))
      B(2,1) = -detinv * (A(2,1)*A(3,3) - A(2,3)*A(3,1))
      B(3,1) = +detinv * (A(2,1)*A(3,2) - A(2,2)*A(3,1))
      B(1,2) = -detinv * (A(1,2)*A(3,3) - A(1,3)*A(3,2))
      B(2,2) = +detinv * (A(1,1)*A(3,3) - A(1,3)*A(3,1))
      B(3,2) = -detinv * (A(1,1)*A(3,2) - A(1,2)*A(3,1))
      B(1,3) = +detinv * (A(1,2)*A(2,3) - A(1,3)*A(2,2))
      B(2,3) = -detinv * (A(1,1)*A(2,3) - A(1,3)*A(2,1))
      B(3,3) = +detinv * (A(1,1)*A(2,2) - A(1,2)*A(2,1))
   end function


   module subroutine swiftest_obl_rot_matrix(n, rot, rot_matrix, rot_matrix_inv)
      !! author: Kaustub P. Anand
      !! 
      !! Generate a rotation matrix and its inverse to rotate the coordinate frame to align the rotation axis along the z axis for 
      !! correct spin calculation
      !! 

      implicit none
      ! Arguments
      integer(I4B),             intent(in)           :: n               !! Number of bodies
      real(DP), dimension(NDIM), intent(in)          :: rot             !! Central body rotation vector
      real(DP), dimension(NDIM, NDIM), intent(inout) :: rot_matrix      !! rotation matrix
      real(DP), dimension(NDIM, NDIM), intent(inout) :: rot_matrix_inv  !! inverse of the rotation matrix

      ! Internals
      real(DP)     :: theta !! angle to rotate it through
      real(DP), dimension(3) :: u, z_hat, check !! unit vector about which we rotate, z_hat, and a check variable
      real(DP), dimension(3, 3) :: S_matrix, temp !! rotation matrices, and a temporary variable
      integer        :: i, j !! dummy variable

      ! Assumed that NDIM = 3
      
      rot_matrix(:, :) = 0.0_DP
      rot_matrix_inv(:, :) = 0.0_DP
      z_hat(:) = [0.0_DP, 0.0_DP, 1.0_DP]

      if (n == 0) return

      if ((abs(rot(1)) < 10*tiny(1.0_DP)) .and. (abs(rot(2)) < 10*tiny(1.0_DP))) then
         do i = 1, NDIM
            rot_matrix_inv(i, i) = 1.0_DP
            rot_matrix(i, i) = 1.0_DP
         end do

         return ! rotation axis is about the z-axis, no need to change
      end if
      
      u(:) = rot(:) .cross. z_hat(:)
      u(:) = .unit. u(:)
      theta = acos(dot_product((.unit. rot(:)), z_hat(:)))
      
      ! S_matrix(:, :) = [[0.0_DP, -u(3), u(2)], [u(3), 0.0_DP, -u(1)], [-u(2), u(1), 0.0_DP]] ! skew-symmetric matrix
      S_matrix(1, :) = [0.0_DP, -u(3), u(2)]
      S_matrix(2, :) = [u(3), 0.0_DP, -u(1)]
      S_matrix(3, :) = [-u(2), u(1), 0.0_DP]
      ! assuming NDIM = 3
      ! CHECK for a general formula for the skew-symmetric matrix

      do j = 1, NDIM
         do i = 1, NDIM
            if (i == j) then
               rot_matrix_inv(i, j) = rot_matrix_inv(i, j) + cos(theta) ! identity matrix
               continue
            end if

            ! Skew-symmetric matrix + Tensor product matrix
            rot_matrix_inv(i, j) = rot_matrix_inv(i, j) + u(i) * u(j) * (1 - cos(theta)) + S_matrix(i, j) * sin(theta) 

         end do
      end do

      rot_matrix = matinv3(rot_matrix_inv)
      
      ! Check that the correct rotation matrix is used
      ! rot_matrix * rot should be in the z_hat direction
      check = matmul(rot, rot_matrix) ! 1x3 matrix x 3x3 matrix
      check = .unit. check(:)
      
      if((abs(check(1)) > epsilon(0.0_DP)) .or. (abs(check(2)) > epsilon(0.0_DP))) then
         temp = rot_matrix
         rot_matrix = rot_matrix_inv
         rot_matrix_inv = temp
      end if
      
      return
   end subroutine swiftest_obl_rot_matrix

   
   module subroutine swiftest_obl_acc(n, GMcb, j2rp2, j4rp4, rh, lmask, aobl, rot, GMpl, aoblcb)
      !! author: David A. Minton, Kaustub Anand (2023)
      !!
      !! Compute the barycentric accelerations of bodies due to the oblateness of the central body
      !!      Returned values do not include monopole term or terms higher than J4
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: obl_acc.f90 and obl_acc_tp.f90
      !! Adapted from Hal Levison's Swift routine obl_acc.f and obl_acc_tp.f
      implicit none
      ! Arguments
      integer(I4B),             intent(in)            :: n      !! Number of bodies
      real(DP),                 intent(in)            :: GMcb   !! Central body G*Mass
      real(DP),                 intent(in)            :: j2rp2  !! J2 * R**2 for the central body
      real(DP),                 intent(in)            :: j4rp4  !! J4 * R**4 for the central body
      real(DP), dimension(:,:), intent(in)            :: rh     !! Heliocentric positions of bodies
      logical,  dimension(:),   intent(in)            :: lmask  !! Logical mask of bodies to compute aobl
      real(DP), dimension(:,:), intent(out)           :: aobl   !! Barycentric acceleration of bodies due to central body oblateness
      real(DP), dimension(NDIM), intent(in)           :: rot    !! Central body rotation matrix
      real(DP), dimension(:),   intent(in),  optional :: GMpl   !! Masses of input bodies if they are not test particles
      real(DP), dimension(:),   intent(out), optional :: aoblcb 
         !! Barycentric acceleration of central body (only needed if input bodies are massive)
   
      ! Internals
      integer(I4B) :: i
      real(DP)     :: r2, irh, rinv2, t0, t1, t2, t3, fac1, fac2
      real(DP), dimension(NDIM)       :: rh_transformed ! rotated position vector
      real(DP), dimension(NDIM, NDIM) :: rot_matrix, rot_matrix_inv ! rotation matrix and its inverse

      if (n == 0) return

      aobl(:,:) = 0.0_DP

      ! If the rotation axis is along the z-axis, skip calculating the rotation matrix
      if ((abs(rot(1)) < 10*tiny(1.0_DP)) .and. (abs(rot(2)) < 10*tiny(1.0_DP))) then
#ifdef DOCONLOC
         do concurrent(i = 1:n, lmask(i)) shared(lmask,rh,aobl,j2rp2,j4rp4) &
                                          local(r2,irh,rinv2,t0,t1,t2,t3,fac1,fac2)
#else
         do concurrent(i = 1:n, lmask(i))
#endif
            r2 = dot_product(rh(:, i), rh(:, i))
            irh = 1.0_DP / sqrt(r2)
            rinv2 = irh**2
            t0 = -GMcb * rinv2 * rinv2 * irh
            t1 = 1.5_DP * j2rp2
            t2 = rh(3, i) * rh(3, i) * rinv2
            t3 = 1.875_DP * j4rp4 * rinv2
            fac1 = t0 * (t1 - t3 - (5 * t1 - (14.0_DP - 21.0_DP * t2) * t3) * t2)
            fac2 = 2 * t0 * (t1 - (2.0_DP - (14.0_DP * t2 / 3.0_DP)) * t3)
            aobl(:, i) = fac1 * rh(:, i)
            aobl(3, i) = fac2 * rh(3, i) + aobl(3, i)
         end do
      else 
         ! generate the rotation matrix
         call swiftest_obl_rot_matrix(n, rot, rot_matrix, rot_matrix_inv)

#ifdef DOCONLOC
         do concurrent(i = 1:n, lmask(i)) shared(lmask,rh,aobl,rot_matrix,rot_matrix_inv,j2rp2,j4rp4) &
                                          local(r2,irh,rinv2,t0,t1,t2,t3,fac1,fac2,rh_transformed)
#else
         do concurrent(i = 1:n, lmask(i))
#endif
            ! rotate the position vectors
            rh_transformed = matmul(rh(:, i), rot_matrix) ! 1x3 vector * 3x3 matrix
            r2 = dot_product(rh_transformed, rh_transformed)
            irh = 1.0_DP / sqrt(r2)
            rinv2 = irh**2
            t0 = -GMcb * rinv2 * rinv2 * irh
            t1 = 1.5_DP * j2rp2
            t2 = rh_transformed(3) * rh_transformed(3) * rinv2
            t3 = 1.875_DP * j4rp4 * rinv2
            fac1 = t0 * (t1 - t3 - (5 * t1 - (14.0_DP - 21.0_DP * t2) * t3) * t2)
            fac2 = 2 * t0 * (t1 - (2.0_DP - (14.0_DP * t2 / 3.0_DP)) * t3)
            aobl(:, i) = fac1 * rh_transformed(:)
            aobl(3, i) = fac2 * rh_transformed(3) + aobl(3, i)

            ! rotate the acceleration and position vectors back to the original coordinate frame
            aobl(:, i) = matmul(aobl(:, i), rot_matrix_inv)
         end do
      end if

      if (present(GMpl) .and. present(aoblcb)) then
         aoblcb(:) = 0.0_DP
         do i = n, 1, -1
            if (lmask(i)) aoblcb(:) = aoblcb(:) - GMpl(i) * aobl(:, i) / GMcb
         end do
      end if

      return

   end subroutine swiftest_obl_acc


   module subroutine swiftest_non_spherical_cb_acc_pl(self, nbody_system)
      !! author: David A. Minton
      !!
      !! Compute the barycentric accelerations of massive bodies due to the oblateness of the central body
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: obl_acc.f90 and obl_acc_tp.f90
      !! Adapted from Hal Levison's Swift routine obl_acc.f and obl_acc_tp.f
      implicit none
      ! Arguments
      class(swiftest_pl),           intent(inout) :: self   !! Swiftest massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      ! Internals
      integer(I4B) :: i, npl

      if (self%nbody == 0) return

      associate(pl => self, cb => nbody_system%cb)
         npl = self%nbody
         if (allocated(cb%c_lm)) then
            call shgrav_acc(self, nbody_system)
         else
            call swiftest_obl_acc(npl, cb%Gmass, cb%j2rp2, cb%j4rp4, pl%rh, pl%lmask, pl%aobl, cb%rot, pl%Gmass, cb%aobl)
         end if

#ifdef DOCONLOC
         do concurrent(i = 1:npl, pl%lmask(i)) shared(cb,pl)
#else
         do concurrent(i = 1:npl, pl%lmask(i))
#endif
            pl%ah(:, i) = pl%ah(:, i) + pl%aobl(:, i) - cb%aobl(:)
         end do
      end associate

      return
   end subroutine swiftest_non_spherical_cb_acc_pl


   module subroutine swiftest_non_spherical_cb_acc_tp(self, nbody_system)
      !! author: David A. Minton
      !!
      !! Compute the barycentric accelerations of massive bodies due to the oblateness of the central body
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: obl_acc.f90 and obl_acc_tp.f90
      !! Adapted from Hal Levison's Swift routine obl_acc.f and obl_acc_tp.f
      implicit none
      ! Arguments
      class(swiftest_tp),           intent(inout) :: self   !! Swiftest test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      ! Internals
      real(DP), dimension(NDIM)                   :: aoblcb
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return

      associate(tp => self, cb => nbody_system%cb)
         ntp = self%nbody
         if (allocated(cb%c_lm)) then
            call shgrav_acc(self, nbody_system)
         else
            call swiftest_obl_acc(ntp, cb%Gmass, cb%j2rp2, cb%j4rp4, tp%rh, tp%lmask, tp%aobl, cb%rot)
         end if
         if (nbody_system%lbeg) then
            aoblcb = cb%aoblbeg
         else
            aoblcb = cb%aoblend
         end if

#ifdef DOCONLOC
         do concurrent(i = 1:ntp, tp%lmask(i)) shared(tp,aoblcb)
#else
         do concurrent(i = 1:ntp, tp%lmask(i))
#endif
            tp%ah(:, i) = tp%ah(:, i) + tp%aobl(:, i) - aoblcb(:)
         end do

      end associate

      return
   end subroutine swiftest_non_spherical_cb_acc_tp


   module subroutine swiftest_obl_pot_system(self) 
      !! author: David A. Minton
      !!
      !! Compute the contribution to the total gravitational potential due solely to the oblateness of the central body
      !!    Returned value does not include monopole term or terms higher than J4
      !!
      !!    Reference: MacMillan, W. D. 1958. The Theory of the Potential, (Dover Publications), 363.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: obl_pot.f90 
      !! Adapted from Hal Levison's Swift routine obl_pot.f 
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout)  :: self   !! Swiftest nbody system object
      ! Internals
      integer(I4B) :: i, npl
      real(DP), dimension(self%pl%nbody) :: oblpot_arr

      associate(nbody_system => self, pl => self%pl, cb => self%cb)
         npl = self%pl%nbody
         if (npl == 0) return
         if (.not. any(pl%lmask(1:npl))) return
#ifdef DOCONLOC
         do concurrent (i = 1:npl, pl%lmask(i)) shared(cb,pl,oblpot_arr)
#else
         do concurrent (i = 1:npl, pl%lmask(i))
#endif
            oblpot_arr(i) = swiftest_obl_pot_one(cb%Gmass, pl%Gmass(i), cb%j2rp2, cb%j4rp4, pl%rh(3,i), 1.0_DP / norm2(pl%rh(:,i)))
         end do
         nbody_system%oblpot = sum(oblpot_arr, pl%lmask(1:npl))
      end associate
         
      return
   end subroutine swiftest_obl_pot_system


   elemental function swiftest_obl_pot_one(GMcb, GMpl, j2rp2, j4rp4, zh, irh) result(oblpot)
      !! author: David A. Minton
      !!
      !! Compute the contribution to the total gravitational potential due solely to the oblateness of the central body from a 
      !! single massive body
      !!    Returned value does not include monopole term or terms higher than J4
      !!
      !!    Reference: MacMillan, W. D. 1958. The Theory of the Potential, (Dover Publications), 363.
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: obl_pot.f90 
      !! Adapted from Hal Levison's Swift routine obl_pot.f 
      implicit none
      ! Arguments
      real(DP),     intent(in)  :: GMcb   !! G*mass of the central body
      real(DP),     intent(in)  :: GMpl   !! G*mass of the massive body
      real(DP),     intent(in)  :: j2rp2  !! J_2 / R**2 of the central body
      real(DP),     intent(in)  :: j4rp4  !! J_2 / R**4 of the central body
      real(DP),     intent(in)  :: zh     !! z-component of the heliocentric distance vector of the massive body
      real(DP),     intent(in)  :: irh    !! Inverse of the heliocentric distance magnitude of the massive body
      ! Result
      real(DP)                  :: oblpot !! Gravitational potential
         
      ! Internals
      real(DP)                  :: rinv2, t0, t1, t2, t3, p2, p4
         
      rinv2 = irh**2
      t0 = GMcb * GMpl * rinv2 * irh
      t1 = j2rp2
      t2 = zh**2 * rinv2
      t3 = j4rp4 * rinv2
      p2 = 0.5_DP * (3 * t2 - 1.0_DP)
      p4 = 0.125_DP * ((35 * t2 - 30.0_DP) * t2 + 3.0_DP)
      oblpot = t0 * (t1 * p2 + t3 * p4)
         
      return
   end function swiftest_obl_pot_one

end submodule s_swiftest_obl

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module shgrav
    !! author: David A. Minton and Kaustub Anand
    !!
    !! This module defines functions used for the computation of accelerations based on spherical harmonics representation of the
    !! gravitational potential of the central body. It uses the SHTOOLS library https://shtools.github.io/SHTOOLS/
    use swiftest
    implicit none
    public

    interface
        module subroutine shgrav_acc(body, nbody_system)
            implicit none
            class(swiftest_body), intent(inout) :: body
                !! Swiftest body object
            class(swiftest_nbody_system), intent(inout) :: nbody_system 
                !! Swiftest nbody system object
        end subroutine shgrav_acc

        module subroutine shgrav_pot_system(self)
            implicit none
            class(swiftest_nbody_system), intent(inout) :: self
                !! Swiftest nbody system object
        end subroutine shgrav_pot_system
        
    end interface

end module shgrav
 

! Copyight 2023 - David Minton
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module coarray
   !! author: David A. Minton
   !!
   !! Utilities that are used for coarray test particles
   !!
   use globals
   implicit none
   public

   interface coclone
      module subroutine coarray_component_clone_char(var,src_img)
         implicit none
         character(len=*), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_char

      module subroutine coarray_component_clone_DP(var,src_img)
         implicit none
         real(DP), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_DP 

      module subroutine coarray_component_clone_DP_arr1D(var,src_img)
         implicit none
         real(DP), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_DP_arr1D

      module subroutine coarray_component_clone_DP_arr2D(var,src_img)
         implicit none
         real(DP), dimension(:,:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_DP_arr2D

      module subroutine coarray_component_clone_I4B(var,src_img)
         implicit none
         integer(I4B), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_I4B

      module subroutine coarray_component_clone_I4B_arr1D(var,src_img)
         implicit none
         integer(I4B), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_I4B_arr1D

      module subroutine coarray_component_clone_I8B(var,src_img)
         implicit none
         integer(I8B), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_I8B

      module subroutine coarray_component_clone_lgt(var,src_img)
         implicit none
         logical, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_lgt

      module subroutine coarray_component_clone_lgt_arr1D(var,src_img)
         implicit none
         logical, dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_lgt_arr1D

#ifdef QUADPREC
      module subroutine coarray_component_clone_QP(var,src_img)
         implicit none
         real(QP), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_QP 
#endif
   end interface


   interface coclonevec
      module subroutine coarray_component_clone_DP_vec1D(var,src_img)
         implicit none
         real(DP), dimension(:), intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_DP_vec1D

      module subroutine coarray_component_clone_DP_vec2D(var,src_img)
         implicit none
         real(DP), dimension(:,:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: src_img
      end subroutine coarray_component_clone_DP_vec2D
   end interface coclonevec


   interface cocollect
      module subroutine coarray_component_collect_DP_arr1D(var,dest_img)
         implicit none
         real(DP), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine coarray_component_collect_DP_arr1D


      module subroutine coarray_component_collect_DP_arr2D(var,dest_img)
         implicit none
         real(DP), dimension(:,:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine coarray_component_collect_DP_arr2D


      module subroutine coarray_component_collect_I4B(var,dest_img)
         implicit none
         integer(I4B), intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine coarray_component_collect_I4B


      module subroutine coarray_component_collect_I8B(var,dest_img)
         implicit none
         integer(I8B), intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine coarray_component_collect_I8B


      module subroutine coarray_component_collect_I4B_arr1D(var,dest_img)
         implicit none
         integer(I4B), dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine coarray_component_collect_I4B_arr1D


      module subroutine coarray_component_collect_lgt_arr1D(var,dest_img)
         implicit none
         logical, dimension(:), allocatable, intent(inout) :: var
         integer(I4B), intent(in),optional :: dest_img
      end subroutine coarray_component_collect_lgt_arr1D
   end interface



end module coarray

module io_progress_bar
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods used to determine close encounters
   use globals
   use base
   implicit none
   public

   character(len=1),parameter, private                :: barchar = "#" 
         !! The progress bar character

   type :: progress_bar
      !! author: David A. Minton
      !! 
      !! Implements a class for a simple progress bar that can print on the screen.
      integer(I4B)                  :: PBARSIZE = 80 
         !! Number of characters acros for a whole progress bar
      integer(I8B)                  :: loop_length   
         !! The total number of loops that the progrees bar is executing
      character(len=:), allocatable :: barstr        
         !! The string that prints out as the progress bar
      integer(I4B)                  :: bar_pos       
         !! The current position of the progress bar
      character(len=32)             :: fmt           
         !! The format string that is used to define the progress bar itself
      character(len=64)             :: message       
         !! The current message displayed at the end of the progress bar
   contains
      procedure :: reset  => io_progress_bar_reset   
         !! Resets the progress bar to the beginning
      procedure :: update => io_progress_bar_update 
         !! Updates the progress bar with new values 
   end type progress_bar

contains

   subroutine io_progress_bar_reset(self, loop_length)
      !! author: David A. Minton
      !! 
      !! Resets the progress bar to the beginning
      implicit none
      ! Arguments
      class(progress_bar),intent(inout)        :: self         
         !! The progress bar object
      integer(I8B),       intent(in)           :: loop_length  
         !! The length of the loop that the progress bar is attached to
      ! Internals
      character(len=2) :: numchar
      integer(I4B) :: k

      if (.not.allocated(self%barstr)) then
         allocate(character(self%PBARSIZE) :: self%barstr)
      end if
      do k = 1, self%PBARSIZE
         self%barstr(k:k) = " "
      end do
      write(numchar,'(I2)') self%PBARSIZE
      self%fmt  = '(A1,"[",A' // numchar // ',"] ",A,$)'
      self%loop_length = loop_length
      self%bar_pos = 0
      self%message = ""

      write(*,fmt=self%fmt) char(13),self%barstr,trim(adjustl(self%message))

      return
   end subroutine io_progress_bar_reset


   subroutine io_progress_bar_update(self,i,message)
      !! author: David A. Minton
      !! 
      !! Updates the progress bar with new values 
      implicit none
      ! Arguments
      class(progress_bar), intent(inout)        :: self    
         !! Progres bar object
      integer(I8B),        intent(in)           :: i       
         !! The current loop index of the progress loop
      character(len=*),    intent(in), optional :: message 
         !! An optional message to display to the right of the progress bar
      ! Internals
      real(DP)     :: frac
      integer(I4B) :: bar_pos  
         !! The current integer position of the progress bar 
      logical :: update = .false.

      ! Compute the current position
      frac = real(i,kind=DP) / real(self%loop_length,kind=DP)
      bar_pos = min(int(ceiling(frac * self%PBARSIZE),kind=I4B),self%PBARSIZE)

      if (bar_pos /= self%bar_pos) then
         ! Fill in the bar character up to the current position
         self%barstr(bar_pos:bar_pos) = barchar
         update = .true.
         self%bar_pos = bar_pos
      end if

      if (present(message)) then
         if (message /= self%message) then
            update = .true.
            self%message = message 
         end if
      end if

      if (update) write(*,fmt=self%fmt) char(13),self%barstr,trim(adjustl(self%message))


      return
   end subroutine io_progress_bar_update


end module io_progress_bar

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(whm) s_whm_gr
   use swiftest
contains

   pure module subroutine whm_gr_kick_getacch_pl(self, param) 
      !! author: David A. Minton
      !!
      !! Compute relativisitic accelerations of massive bodies
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_whm_kick_getacch.f90
      implicit none
      ! Arguments
      class(whm_pl),              intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters 
      ! Internals
      integer(I4B)                                 :: i
      real(DP), dimension(NDIM)                    :: suma
      
      if (self%nbody == 0) return

      associate(pl => self, npl => self%nbody, inv_c2 => param%inv_c2)
         call swiftest_gr_kick_getacch(pl%muj, pl%xj, pl%lmask, npl, param%inv_c2, pl%agr) 
         suma(:) = 0.0_DP
         pl%ah(:, 1) = pl%ah(:, 1) + pl%agr(:, 1)
         do i = 2, npl
            suma(:) = suma(:) + pl%Gmass(i) * pl%agr(:, i) / pl%eta(i)
            pl%ah(:, i) = pl%ah(:, i) + pl%agr(:, i) + suma(:)
         end do
      end associate

      return
   end subroutine whm_gr_kick_getacch_pl


   pure module subroutine whm_gr_kick_getacch_tp(self, param)
      !! author: David A. Minton
      !!
      !! Compute relativisitic accelerations of test particles
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_whm_kick_getacch.f90
      implicit none
      ! Arguments
      class(whm_tp),              intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_parameters), intent(in)    :: param  !! Current run configuration parameters 
      ! Internals
      
      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody, inv_c2 => param%inv_c2)
         call swiftest_gr_kick_getacch(tp%mu, tp%rh, tp%lmask, ntp, param%inv_c2, tp%agr) 
         tp%ah(:,1:ntp) = tp%ah(:,1:ntp) + tp%agr(:,1:ntp)
      end associate

      return
   end subroutine whm_gr_kick_getacch_tp
   

   pure module subroutine whm_gr_p4_pl(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Position kick to massive bodies due to p**4 term in the post-Newtonian correction
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_whm_p4.f90
      implicit none
      ! Arguments
      class(whm_pl),                intent(inout) :: self   !! Swiftest particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system
      class(swiftest_parameters),   intent(in)    :: param !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Step size
      ! Internals
      integer(I4B) :: i, npl

      if (self%nbody == 0) return

      associate(xj => self%xj, vj => self%vj, lmask => self%lmask, inv_c2 => param%inv_c2)
         npl = self%nbody
#ifdef DOCONLOC
         do concurrent(i = 1:npl, lmask(i)) shared(lmask, inv_c2, xj, vj,dt)
#else
         do concurrent(i = 1:npl, lmask(i))
#endif
            call swiftest_gr_p4_pos_kick(inv_c2, xj(1,i), xj(2,i), xj(3,i), vj(1,i), vj(2,i), vj(3,i), dt)
         end do
      end associate
 
     return
   end subroutine whm_gr_p4_pl


   pure module subroutine whm_gr_p4_tp(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Position kick to test particles due to p**4 term in the post-Newtonian correction
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_whm_p4.f90
      implicit none
      ! Arguments
      class(whm_tp),                intent(inout) :: self  !! Swiftest particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system
      class(swiftest_parameters),   intent(in)    :: param !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt    !! Step size
      ! Internals
      integer(I4B) :: i, ntp

      associate(rh => self%rh, vh => self%vh, lmask => self%lmask, inv_c2 => param%inv_c2)
         ntp = self%nbody
         if (ntp == 0) return
#ifdef DOCONLOC
         do concurrent(i = 1:ntp, lmask(i)) shared(lmask, rh, vh, inv_c2, dt)
#else
         do concurrent(i = 1:ntp, lmask(i))
#endif
            call swiftest_gr_p4_pos_kick(inv_c2, rh(1,i), rh(2,i), rh(3,i), vh(1,i), vh(2,i), vh(3,i), dt)
         end do
      end associate
 
     return
   end subroutine whm_gr_p4_tp

end submodule s_whm_gr

!! Copyright 2024 - The Minton Group at Purdue University
!! This file is part of Swiftest.
!! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
!! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
!! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
!! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
!! You should have received a copy of the GNU General Public License along with Swiftest. 
!! If not, see: https://www.gnu.org/licenses. 


!! Swiftest submodule to calculate higher order terms for gravitational potential given spherical harmonic coefficients (c_lm)

submodule (shgrav) s_shgrav_pot
use swiftest
use SHTOOLS

contains

    module subroutine shgrav_pot_system(self)
        !! author: Kaustub P. Anand
        !!
        !! Compute the gravitational potential energy for a given system of bodies solely due to the gravitational harmonics terms
        !!
        implicit none
        ! Arguments
        class(swiftest_nbody_system), intent(inout) :: self
            !! Swiftest nbody system object
        ! Internals
        integer(I4B) :: i, npl
        real(DP), dimension(self%pl%nbody) :: oblpot_arr

        associate(nbody_system => self, pl => self%pl, cb => self%cb)
            npl = self%pl%nbody

            do i = 1, npl
                if (pl%lmask(i)) then
                    oblpot_arr(i) = shgrav_pot_one(cb%Gmass,  pl%mass(i), cb%radius, cb%rotphase*DEG2RAD, pl%rh(:,i), cb%c_lm) 
                endif
            end do

            nbody_system%oblpot = sum(oblpot_arr, pl%lmask(1:npl)) 
        end associate

        return
    end subroutine shgrav_pot_system

    function shgrav_pot_one(GMcb, Mpl, r_0, phi_cb, rh, c_lm) result(oblpot)
        !! author: Kaustub P. Anand
        !!
        !! Calculate the gravitational potential energy for one pair of bodies given c_lm, theta, phi, r
        !! Similar to shgrav_g_acc_one and swiftest_obl_pot_one
        !!
        implicit none
        ! Arguments
        real(DP), intent(in) :: GMcb 
            !! GMass of the central body
        real(DP), intent(in), optional :: Mpl
            !! Mass of input body
        real(DP), intent(in) :: r_0
            !! radius of the central body
        real(DP), intent(in) :: phi_cb
            !! rotation phase angle of the central body
        real(DP), intent(in), dimension(:) :: rh
            !! distance vector of body
        real(DP), intent(in), dimension(:, :, :) :: c_lm
            !! Spherical Harmonic coefficients

        ! Result
        real(DP) :: oblpot
            !! Gravitational potential energy

        ! Internals
        integer :: l, m 
            !! SPH coefficients
        integer :: l_max 
            !! max Spherical Harmonic l order value
        integer(I4B) :: N, lmindex 
            !! Length of Legendre polynomials and index at a given l, m
        real(DP) :: r_mag  
            !! magnitude of rh
        real(DP) :: phi, phi_bar 
            !! Azimuthal/Phase angle (radians) wrt coordinate axes, and central body rotation phase
        real(DP) :: theta 
            !! Inclination/Zenith angle (radians)
        real(DP) :: plm, plm1 
            !! Associated Legendre polynomials at a given l, m
        real(DP) :: ccss
            !! See definition in source code
        real(DP) :: cos_theta, sin_theta 
            !! cos(theta) and sin(theta)
        real(DP), dimension(:), allocatable  :: p 
            !! Associated Lengendre Polynomials at a given cos(theta)
        real(DP) :: r_fac 
            !! calculation factors

        theta = atan2(sqrt(rh(1)**2 + rh(2)**2), rh(3))
        phi = atan2(rh(2), rh(1)) 
        phi_bar = MOD(phi - phi_cb, 2 * PI) ! represents the phase difference between the central body's and the particle's phase
        r_mag = sqrt(dot_product(rh(:), rh(:)))
        l_max = size(c_lm, 2) - 1
        N = (l_max + 1) * (l_max + 2) / 2
        allocate(p(N))

        cos_theta = cos(theta)
        sin_theta = sin(theta)

        ! check if cos_theta is too small to avoid floating underflow error
        if (abs(cos_theta) < EPSILON(0.0_DP)) then
            call PlmBar(p, l_max, 0.0_DP)
        else
            call PlmBar(p, l_max, cos_theta)
        end if

        oblpot = 0.0_DP
        do l = 1, l_max ! skipping the l = 0 term; It is the spherical body term
            do m = 0, l

                ! If c_lm is too small, skip the iteration to improve performance
                if (abs(c_lm(m+1, l+1, 1)) < epsilon(0.0_DP) .and. abs(c_lm(m+1, l+1, 2)) < epsilon(0.0_DP)) then
                    cycle  
                endif

                ! Associated Legendre Polynomials 
                lmindex = PlmIndex(l, m)  
                plm = p(lmindex)                  ! p_l,m

                r_fac = GMcb * Mpl * r_0**l / r_mag**(l + 1)
                ccss = cos(m * phi_bar) * c_lm(m+1, l+1, 1) &
                        + sin(m * phi_bar) * c_lm(m+1, l+1, 2) ! C_lm * cos(m * phi_bar) + S_lm * sin(m * phi_bar)
                
                oblpot = oblpot + r_fac * plm * ccss
            end do
        end do

        ! deallocate(p)

        return
    end function shgrav_pot_one

end submodule s_shgrav_pot

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (coarray) s_coarray_clone
   use swiftest
contains


   module subroutine coarray_component_clone_char(var,src_img)
      !! author: David A. Minton
      !!
      !! Copies a component of a coarray derived type from the specified source image to the current local one. 
      !! The default source image is 1
      !! character scalar version
      implicit none
      ! Arguments
      character(len=*), intent(inout) :: var
      integer(I4B), intent(in),optional :: src_img
      ! Internals
      character(len=STRMAX),allocatable :: tmp[:]
      integer(I4B) :: img, si

      allocate(tmp[*])
      if (present(src_img)) then
         si = src_img
      else
         si = 1
      end if

      sync all
      if (this_image() == si) then
         do img = 1, num_images()
         tmp[img] = var 
         end do
         sync images(*)
      else
         sync images(si)
         var = tmp[si]
      end if
      deallocate(tmp)

      return
   end subroutine coarray_component_clone_char


   module subroutine coarray_component_clone_DP_arr1D(var,src_img)
      !! author: David A. Minton
      !!
      !! Copies a component of a coarray derived type from the specified source image to the current local one. 
      !! The default source image is 1
      !! real(DP) 1D allocatable array version
      implicit none
      ! Arguments
      real(DP), dimension(:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: src_img
      ! Internals
      real(DP), dimension(:), codimension[:], allocatable :: tmp
      integer(I4B) :: img, si
      integer(I4B), allocatable :: n[:]
      logical, allocatable :: isalloc[:]

      allocate(isalloc[*])
      allocate(n[*])

      if (present(src_img)) then
         si = src_img
      else
         si = 1
      end if

      isalloc = allocated(var)
      if (isalloc) n = size(var)
      sync all 
      if (.not. isalloc[si]) return

      allocate(tmp(n[si])[*])
      if (this_image() == si) then
         do img = 1, num_images()
            tmp(:)[img] = var 
         end do
         sync images(*)
      else
         sync images(si) 
         if (allocated(var)) deallocate(var)
         allocate(var, source=tmp)
      end if
      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_clone_DP_arr1D


   module subroutine coarray_component_clone_DP_vec2D(var,src_img)
      !! author: David A. Minton
      !!
      !! Copies a component of a coarray derived type from the specified source image to the current local one. 
      !! The default source image is 1
      !! real(DP) 2D allocatable array version
      implicit none
      ! Arguments
      real(DP), dimension(:,:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: src_img
      ! Internals
      real(DP), dimension(:,:), codimension[:], allocatable :: tmp
      integer(I4B) :: img, si
      integer(I4B), allocatable :: n[:]
      logical, allocatable :: isalloc[:]

      allocate(isalloc[*])
      allocate(n[*])

      if (present(src_img)) then
         si = src_img
      else
         si = 1
      end if

      isalloc = allocated(var)
      if (isalloc) n = size(var,dim=2)
      sync all 
      if (.not. isalloc[si]) return

      allocate(tmp(NDIM,n[si])[*])
      if (this_image() == si) then
         do img = 1, num_images()
            tmp(:,:)[img] = var(:,:)
         end do
         sync images(*)
      else
         sync images(si) 
         if (allocated(var)) deallocate(var)
         allocate(var, source=tmp)
      end if

      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_clone_DP_vec2D


   module subroutine coarray_component_clone_I4B_arr1D(var,src_img)
      !! author: David A. Minton
      !!
      !! Copies a component of a coarray derived type from the specified source image to the current local one. 
      !! The default source image is 1
      !! integer(I4B) 1D allocatable array version
      implicit none
      ! Arguments
      integer(I4B), dimension(:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: src_img
      ! Internals
      integer(I4B), dimension(:), codimension[:], allocatable :: tmp
      integer(I4B) :: img, si
      integer(I4B), allocatable :: n[:]
      logical, allocatable :: isalloc[:]

      allocate(isalloc[*])
      allocate(n[*])
      if (present(src_img)) then
         si = src_img
      else
         si = 1
      end if

      isalloc = allocated(var)
      if (isalloc) n = size(var)
      sync all 
      if (.not. isalloc[si]) return

      allocate(tmp(n[si])[*])
      if (this_image() == si) then
         do img = 1, num_images()
            tmp(:)[img] = var 
         end do
         sync images(*)
      else
         sync images(si)
         if (allocated(var)) deallocate(var)
         allocate(var, source=tmp)
      end if

      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_clone_I4B_arr1D


   module subroutine coarray_component_clone_lgt_arr1D(var,src_img)
      !! author: David A. Minton
      !!
      !! Copies a component of a coarray derived type from the specified source image to the current local one. 
      !! The default source image is 1
      !! logical 1D allocatable array version
      implicit none
      ! Arguments
      logical, dimension(:), allocatable, intent(inout) :: var
      integer(I4B), intent(in),optional :: src_img
      ! Internals
      logical, dimension(:), codimension[:], allocatable :: tmp
      integer(I4B) :: img, si
      integer(I4B), allocatable :: n[:]
      logical, allocatable :: isalloc[:]

      allocate(isalloc[*])
      allocate(n[*])
      if (present(src_img)) then
         si = src_img
      else
         si = 1
      end if

      isalloc = allocated(var)
      if (isalloc) n = size(var)
      sync all 
      if (.not. isalloc[si]) return

      allocate(tmp(n[si])[*])
      if (this_image() == si) then
         do img = 1, num_images()
            tmp(:)[img] = var 
         end do
         sync images(*)
      else
         sync images(si)
         if (allocated(var)) deallocate(var)
         allocate(var, source=tmp)
      end if

      deallocate(isalloc,n,tmp)

      return
   end subroutine coarray_component_clone_lgt_arr1D

end submodule s_coarray_clone

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(helio) s_helio_gr
   use swiftest
contains

   pure module subroutine helio_gr_kick_getacch_pl(self, param) 
      !! author: David A. Minton
      !!
      !! Compute relativisitic accelerations of massive bodies
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_whm_kick_getacch.f90
      implicit none
      ! Arguments
      class(helio_pl),            intent(inout) :: self   !! Helio massive body particle data structure
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters 
      
      if (self%nbody == 0) return

      associate(pl => self, npl => self%nbody)
         call swiftest_gr_kick_getacch(pl%mu, pl%rh, pl%lmask, npl, param%inv_c2, pl%agr) 
         pl%ah(:,1:npl) = pl%ah(:,1:npl) + pl%agr(:,1:npl)
      end associate

      return
   end subroutine helio_gr_kick_getacch_pl


   pure module subroutine helio_gr_kick_getacch_tp(self, param)
      !! author: David A. Minton
      !!
      !! Compute relativisitic accelerations of test particles
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_helio_kick_getacch.f90
      implicit none
      ! Arguments
      class(helio_tp),            intent(inout) :: self   !! Helio massive body particle data structure
      class(swiftest_parameters), intent(in)    :: param  !! Current run configuration parameters 
      
      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody)
         call swiftest_gr_kick_getacch(tp%mu, tp%rh, tp%lmask, ntp, param%inv_c2, tp%agr) 
         tp%ah(:,1:ntp) = tp%ah(:,1:ntp) + tp%agr(:,1:ntp)
      end associate

      return
   end subroutine helio_gr_kick_getacch_tp
   

   pure module subroutine helio_gr_p4_pl(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Position kick to massive bodies due to p**4 term in the post-Newtonian correction
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_helio_p4.f90
      implicit none
      ! Arguments
      class(helio_pl),              intent(inout) :: self   !! Swiftest particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Step size
      ! Internals
      integer(I4B) :: i, npl

      if (self%nbody == 0) return

      associate(lmask => self%lmask, rh => self%rh, vb => self%vb, inv_c2 => param%inv_c2)
         npl = self%nbody
#ifdef DOCONLOC
         do concurrent(i = 1:npl, lmask(i)) shared(inv_c2, lmask, rh, vb, dt)
#else
         do concurrent(i = 1:npl, lmask(i))
#endif
            call swiftest_gr_p4_pos_kick(inv_c2, rh(1,i), rh(2,i), rh(3,i), vb(1,i), vb(2,i), vb(3,i), dt)
         end do
      end associate
 
     return
   end subroutine helio_gr_p4_pl


   pure module subroutine helio_gr_p4_tp(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Position kick to test particles due to p**4 term in the post-Newtonian correction
      !!    Based on Saha & Tremaine (1994) Eq. 28
      !!
      !! Adapted from David A. Minton's Swifter routine routine gr_helio_p4.f90
      implicit none
      ! Arguments
      class(helio_tp),              intent(inout) :: self   !! Swiftest particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                     intent(in)    :: dt     !! Step size
      ! Internals
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return

      associate(rh => self%rh, vb => self%vb, lmask => self%lmask, inv_c2 => param%inv_c2)
         ntp = self%nbody
#ifdef DOCONLOC
         do concurrent(i = 1:ntp, lmask(i)) shared(inv_c2, lmask, rh, vb, dt)
#else
         do concurrent(i = 1:ntp, lmask(i))
#endif
            call swiftest_gr_p4_pos_kick(inv_c2, rh(1,i), rh(2,i), rh(3,i), vb(1,i), vb(2,i), vb(3,i), dt)
         end do
      end associate
 
     return
   end subroutine helio_gr_p4_tp

end submodule s_helio_gr

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (symba) s_symba_encounter_check
   use swiftest
contains

   module function symba_encounter_check_pl(self, param, nbody_system, dt, irec) result(lany_encounter)
      !! author: David A. Minton
      !!
      !! Check for an encounter between massive bodies.
      !!
      implicit none
      ! Arguments
      class(symba_pl),            intent(inout)  :: self   !! SyMBA test particle object  
      class(swiftest_parameters), intent(inout)  :: param  !! Current Swiftest run configuration parameters
      class(symba_nbody_system),  intent(inout)  :: nbody_system !! SyMBA nbody system object
      real(DP),                   intent(in)     :: dt     !! step size
      integer(I4B),               intent(in)     :: irec   !! Current recursion level
      ! Result
      logical                                   :: lany_encounter !! Returns true if there is at least one close encounter      
      ! Internals
      integer(I8B) :: k, nenc
      integer(I4B) :: i, j, npl, nplm, nplt
      logical, dimension(:), allocatable :: lvdotr
      integer(I4B), dimension(:), allocatable :: index1, index2
 
      lany_encounter = .false.
      if (self%nbody == 0) return

      associate(pl => self, plpl_encounter => nbody_system%plpl_encounter, cb => nbody_system%cb)

         npl = pl%nbody
         nplm = pl%nplm
         nplt = npl - nplm

         call pl%set_renc(irec)

         if (nplt == 0) then
            call encounter_check_all_plpl(param, npl, pl%rh, pl%vb, pl%renc, dt, nenc, index1, index2, lvdotr)
         else
            call encounter_check_all_plplm(param, nplm, nplt, pl%rh(:,1:nplm), pl%vb(:,1:nplm), pl%rh(:,nplm+1:npl), &
                  pl%vb(:,nplm+1:npl), pl%renc(1:nplm), pl%renc(nplm+1:npl), dt, nenc, index1, index2, lvdotr)
         end if
         
         lany_encounter = nenc > 0_I8B
         if (lany_encounter) then
            call plpl_encounter%resize(nenc)
            call move_alloc(lvdotr, plpl_encounter%lvdotr)
            call move_alloc(index1, plpl_encounter%index1)
            call move_alloc(index2, plpl_encounter%index2)
         end if

         if (lany_encounter) then
            do k = 1_I8B, nenc
               plpl_encounter%t = nbody_system%t
               i = plpl_encounter%index1(k)
               j = plpl_encounter%index2(k)
               plpl_encounter%id1(k) = pl%id(i)
               plpl_encounter%id2(k) = pl%id(j)
               plpl_encounter%status(k) = ACTIVE
               plpl_encounter%level(k) = irec
               plpl_encounter%r1(:,k) = pl%rh(:,i)
               plpl_encounter%r2(:,k) = pl%rh(:,j)
               plpl_encounter%v1(:,k) = pl%vb(:,i) - cb%vb(:)
               plpl_encounter%v2(:,k) = pl%vb(:,j) - cb%vb(:)
               pl%lencounter(i) = .true.
               pl%lencounter(j) = .true.
               pl%levelg(i) = irec
               pl%levelm(i) = irec
               pl%levelg(j) = irec
               pl%levelm(j) = irec
               pl%nplenc(i) = pl%nplenc(i) + 1
               pl%nplenc(j) = pl%nplenc(j) + 1
            end do
         end if

      end associate

      return
   end function symba_encounter_check_pl


   module function symba_encounter_check_list_plpl(self, param, nbody_system, dt, irec) result(lany_encounter)
      implicit none
      class(symba_list_plpl),     intent(inout) :: self           !! SyMBA pl-pl encounter list object
      class(swiftest_parameters), intent(inout) :: param          !! Current Swiftest run configuration parameters
      class(symba_nbody_system),  intent(inout) :: nbody_system         !! SyMBA nbody system object
      real(DP),                   intent(in)    :: dt             !! step size
      integer(I4B),               intent(in)    :: irec           !! Current recursion level 
      logical                                   :: lany_encounter !! Returns true if there is at least one close encounter  
      ! Internals
      integer(I4B)              :: i, j, nenc_enc
      integer(I8B)              :: k, lidx
      real(DP), dimension(NDIM) :: xr, vr
      real(DP)                  :: rlim2, rji2, rcrit12
      logical, dimension(:), allocatable :: lencmask, lencounter
      integer(I8B), dimension(:), allocatable :: eidx

      lany_encounter = .false.
      if (self%nenc == 0) return

      select type(pl => nbody_system%pl)
      class is (symba_pl)
         allocate(lencmask(self%nenc))
         lencmask(:) = (self%status(1:self%nenc) == ACTIVE) .and. (self%level(1:self%nenc) == irec - 1)
         nenc_enc = count(lencmask(:))
         if (nenc_enc == 0) return

         call pl%set_renc(irec)

         allocate(eidx(nenc_enc))
         allocate(lencounter(nenc_enc))
         eidx(:) = pack([(k, k = 1_I8B, self%nenc)], lencmask(:))
         lencounter(:) = .false.

#ifdef DOCONLOC
         do concurrent(lidx = 1_I8B:nenc_enc) shared(self,pl,eidx,lencounter,dt) local(i,j,k,xr,vr,rcrit12,rlim2,rji2)
#else
         do concurrent(lidx = 1_I8B:nenc_enc)
#endif
            k = eidx(lidx)
            i = self%index1(k)
            j = self%index2(k)
            xr(:) = pl%rh(:,j) - pl%rh(:,i)
            vr(:) = pl%vb(:,j) - pl%vb(:,i)
            rcrit12 = pl%renc(i) + pl%renc(j)
            call encounter_check_one(xr(1), xr(2), xr(3), vr(1), vr(2), vr(3), rcrit12, dt, lencounter(lidx), self%lvdotr(k))
            if (lencounter(lidx)) then
               rlim2 = (pl%radius(i) + pl%radius(j))**2
               rji2 = dot_product(xr(:), xr(:))! Check to see if these are physically overlapping bodies first, which we should ignore
               lencounter(lidx) = rji2 > rlim2
            end if
         end do

         lany_encounter = any(lencounter(:))
         if (lany_encounter) then
            nenc_enc = count(lencounter(:))
            eidx(1_I8B:nenc_enc) = pack(eidx(:), lencounter(:))
            do lidx = 1_I8B, nenc_enc
               k = eidx(lidx)
               i = self%index1(k)
               j = self%index2(k)
               pl%levelg(i) = irec
               pl%levelm(i) = MAX(irec, pl%levelm(i))
               pl%levelg(j) = irec
               pl%levelm(j) = MAX(irec, pl%levelm(j))
               self%level(k) = irec
            end do
         end if   
      end select

      return      
   end function symba_encounter_check_list_plpl


   module function symba_encounter_check_list_pltp(self, param, nbody_system, dt, irec) result(lany_encounter)
      implicit none
      class(symba_list_pltp),     intent(inout) :: self           !! SyMBA pl-tp encounter list object
      class(swiftest_parameters), intent(inout) :: param          !! Current Swiftest run configuration parameters
      class(symba_nbody_system),  intent(inout) :: nbody_system         !! SyMBA nbody system object
      real(DP),                   intent(in)    :: dt             !! step size
      integer(I4B),               intent(in)    :: irec           !! Current recursion level 
      logical                                   :: lany_encounter !! Returns true if there is at least one close encounter     
      ! Internals
      integer(I4B)              :: i, j, nenc_enc
      integer(I8B)              :: k, lidx
      real(DP), dimension(NDIM) :: xr, vr
      real(DP)                  :: rlim2, rji2
      logical, dimension(:), allocatable :: lencmask, lencounter
      integer(I8B), dimension(:), allocatable :: eidx

      lany_encounter = .false.
      if (self%nenc == 0) return

      select type(pl => nbody_system%pl)
      class is (symba_pl)
      select type(tp => nbody_system%tp)
      class is (symba_tp)
         allocate(lencmask(self%nenc))
         lencmask(:) = (self%status(1:self%nenc) == ACTIVE) .and. (self%level(1:self%nenc) == irec - 1)
         nenc_enc = count(lencmask(:))
         if (nenc_enc == 0) return

         call pl%set_renc(irec)

         allocate(eidx(nenc_enc))
         allocate(lencounter(nenc_enc))
         eidx(:) = pack([(k, k = 1_I8B, self%nenc)], lencmask(:))
         lencounter(:) = .false.
#ifdef DOCONLOC
         do concurrent(lidx = 1_I8B:nenc_enc) shared(self,pl,tp,eidx,lencounter,dt) local(i,j,k,xr,vr,rlim2,rji2)
#else
         do concurrent(lidx = 1_I8B:nenc_enc)
#endif
            k = eidx(lidx)
            i = self%index1(k)
            j = self%index2(k)
            xr(:) = tp%rh(:,j) - pl%rh(:,i)
            vr(:) = tp%vb(:,j) - pl%vb(:,i)
            call encounter_check_one(xr(1), xr(2), xr(3), vr(1), vr(2), vr(3), pl%renc(i), dt, &
                                       lencounter(lidx), self%lvdotr(k))
            if (lencounter(lidx)) then
               rlim2 = (pl%radius(i))**2
               rji2 = dot_product(xr(:), xr(:))! Check to see if these are physically overlapping bodies first, which we should ignore
               lencounter(lidx) = rji2 > rlim2
            end if
         end do

         lany_encounter = any(lencounter(:))
         if (lany_encounter) then
            nenc_enc = count(lencounter(:))
            eidx(1_I8B:nenc_enc) = pack(eidx(:), lencounter(:))
            do lidx = 1_I8B, nenc_enc
               k = eidx(lidx)
               i = self%index1(k)
               j = self%index2(k)
               pl%levelg(i) = irec
               pl%levelm(i) = MAX(irec, pl%levelm(i))
               tp%levelg(j) = irec
               tp%levelm(j) = MAX(irec, tp%levelm(j))
               self%level(k) = irec
            end do
         end if   
      end select
      end select

      return
   end function symba_encounter_check_list_pltp


   module function symba_encounter_check_tp(self, param, nbody_system, dt, irec) result(lany_encounter)
      !! author: David A. Minton
      !!
      !! Check for an encounter between test particles and massive bodies.
      !!
      implicit none
      ! Arguments
      class(symba_tp),            intent(inout) :: self   !! SyMBA test particle object  
      class(swiftest_parameters), intent(inout) :: param  !! Current Swiftest run configuration parameters
      class(symba_nbody_system),  intent(inout) :: nbody_system !! SyMBA nbody system object
      real(DP),                   intent(in)    :: dt     !! step size
      integer(I4B),               intent(in)    :: irec   !! Current recursion level
      ! Result
      logical                                   :: lany_encounter !! Returns true if there is at least one close encounter      
      ! Internals
      integer(I4B)                              :: plind, tpind
      integer(I8B)                              :: k, nenc
      logical,      dimension(:),   allocatable :: lvdotr
      integer(I4B), dimension(:),   allocatable :: index1, index2
 
      lany_encounter = .false.
      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody, pl => nbody_system%pl, npl => nbody_system%pl%nbody, cb => nbody_system%cb)
         call pl%set_renc(irec)
         call encounter_check_all_pltp(param, npl, ntp, pl%rh, pl%vb, tp%rh, tp%vb, pl%renc, dt, nenc, index1, index2, lvdotr) 
   
         lany_encounter = nenc > 0
         if (lany_encounter) then 
            associate(pltp_encounter => nbody_system%pltp_encounter)
               call pltp_encounter%resize(nenc)
               pltp_encounter%status(1:nenc) = ACTIVE
               pltp_encounter%level(1:nenc) = irec
               call move_alloc(index1, pltp_encounter%index1)
               call move_alloc(index2, pltp_encounter%index2)
               call move_alloc(lvdotr, pltp_encounter%lvdotr)
               pltp_encounter%id1(1:nenc) = pl%id(pltp_encounter%index1(1:nenc))
               pltp_encounter%id2(1:nenc) = tp%id(pltp_encounter%index2(1:nenc))
               select type(pl)
               class is (symba_pl)
                  pl%lencounter(1:npl) = .false.
                  do k = 1_I8B, nenc
                     plind = pltp_encounter%index1(k)
                     tpind = pltp_encounter%index2(k)
                     pl%lencounter(plind) = .true.
                     pl%levelg(plind) = irec
                     pl%levelm(plind) = irec
                     tp%levelg(tpind) = irec
                     tp%levelm(tpind) = irec
                     pl%ntpenc(plind) = pl%ntpenc(plind) + 1
                     tp%nplenc(tpind) = tp%nplenc(tpind) + 1
                  end do
               end select
            end associate
         end if
      end associate

      return
   end function symba_encounter_check_tp

end submodule s_symba_encounter_check

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(collision) s_collision_regime
   use swiftest
contains

   module subroutine collision_regime_collider(self, nbody_system, param)
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton 
      !!
      !! Determine which fragmentation regime the set of impactors will be. This subroutine is a wrapper for the non-polymorphic 
      !! fraggle_regime_collresolve subroutine.
      !! It converts to SI units prior to calling
      implicit none 
      ! Arguments
      class(collision_basic),   intent(inout) :: self         
         !! Collision system impactors object
      class(base_nbody_system), intent(in)    :: nbody_system 
         !! Swiftest nbody system object
      class(base_parameters),   intent(in)    :: param        
         !! Current Swiftest run configuration parameters
      ! Internals
      real (DP) :: mtot
      integer(I4B) :: i,jtarg, jproj
        
      associate(impactors => self%impactors)
      select type (nbody_system)
      class is (swiftest_nbody_system)
      select type(param)
      class is (swiftest_parameters)

         select case(param%collision_model)
         case("MERGE")
            impactors%regime = COLLRESOLVE_REGIME_MERGE
            if (allocated(impactors%mass_dist)) deallocate(impactors%mass_dist)
            allocate(impactors%mass_dist(1))
            impactors%mass_dist(1) = mtot
         case default
            if (impactors%mass(1) > impactors%mass(2)) then
               jtarg = 1
               jproj = 2
            else
               jtarg = 2
               jproj = 1
            end if

            if (impactors%mass(jtarg) / impactors%mass(jproj) > 500.0_DP) then
               call collision_regime_HG20(self, nbody_system, param) ! Cratering collisions. Mass ratio (proj:target) <~ 1:500 
            else 
               call collision_regime_LS12(self, nbody_system, param) ! Large planetary collisions. Mass ratio (proj:target) >= 1:500
            end if
            call collision_io_log_regime(self%impactors)
            
         end select
      end select
      end select
      end associate

      return
   end subroutine collision_regime_collider

   subroutine collision_regime_HG20(collider, nbody_system, param)
      !! Author: Kaustub P. Anand, David A. Minton
      !!
      !! Determine the collisional regime of two colliding bodies based on the model by Hyodo and Genda (2020)
      !!
      !! This is a wrapper subroutine that converts quantities to SI units and calls the main HG20 subroutine
      !! NOTE: Impact angle is converted to degrees
      !! structured similar to collision_regime_LS12

      implicit none
      ! Arguments
      class(collision_basic),       intent(inout) :: collider     
         !! The impactors to determine the regime for
      class(swiftest_nbody_system), intent(in)    :: nbody_system
         !! Swiftest n-body system object
      class(swiftest_parameters),   intent(in)    :: param        
         !! The current parameters

      ! Internals
      integer(I4B) :: i,jtarg, jproj
      real(DP), dimension(2) :: radius_si, mass_si
      real(DP) :: min_mfrag_si
      real(DP), dimension(NDIM)  :: x_tar_si, v_tar_si, x_imp_si, v_imp_si
      real(DP) :: mlr, mslr, mtot, Qloss, Qmerge
      integer(I4B), parameter :: NMASS_DIST = 3   ! Number of mass bins returned by the regime calculation (largest fragment, second
                                                  ! largest, and remainder)  
      real(DP), dimension(NDIM) :: Ip, rot, L_rot
      real(DP) :: radius, volume


      associate(impactors => collider%impactors)

         ! Convert all quantities to SI units and determine which of the pair is the projectile vs. target before sending them to 
         ! the regime determination subroutine
         if (impactors%mass(1) > impactors%mass(2)) then
            jtarg = 1
            jproj = 2
         else
            jtarg = 2
            jproj = 1
         end if
         ! The two-body equivalent masses of the collider system
         mass_si(:)    = impactors%mass([jtarg, jproj]) * param%MU2KG 
         
         ! The two-body equivalent radii of the collider system
         radius_si(:)  = impactors%radius([jtarg, jproj]) * param%DU2M 

         ! The first body of the two-body equivalent position vector the collider system
         x_tar_si(:)      = impactors%rb(:,jtarg) * param%DU2M                   

         ! The first body of the two-body equivalent velocity vector the collider system
         v_tar_si(:)      = impactors%vb(:,jtarg) * param%DU2M / param%TU2S      

         ! The second body of the two-body equivalent position vector the collider system
         x_imp_si(:)      = impactors%rb(:,jproj) * param%DU2M                   

         ! The second body of the two-body equivalent velocity vector the collider system
         v_imp_si(:)      = impactors%vb(:,jproj) * param%DU2M / param%TU2S           
         
         ! The minimum fragment mass to generate. Collider systems that would otherwise generate less massive fragments than this 
         ! value will be forced to merge instead
         min_mfrag_si  = (param%min_GMfrag / param%GU) * param%MU2KG 
      
         mtot = sum(mass_si(:)) 

         ! Use the positions and velocities of the parents from indside the step (at collision) to calculate the collisional regime
         call collision_regime_HG20_SI(mass_si(jtarg), mass_si(jproj), radius_si(jtarg), &
                                       x_tar_si(:), x_imp_si(:), v_tar_si(:), v_imp_si(:), &
                                       min_mfrag_si, impactors%regime, mlr, mslr, Qloss, Qmerge)

         ! Convert back from SI to system units
         mlr = mlr / param%MU2KG
         mslr = mslr / param%MU2kg
         Qloss = Qloss * (param%TU2S / param%DU2M)**2 / param%MU2KG
         Qmerge = Qmerge * (param%TU2S / param%DU2M)**2 / param%MU2KG
         mtot = mtot / param%MU2kg

         ! If this is came back as a merger, check to make sure that the rotation of the merged body doesn't exceed the rotation 
         ! barrier
         if (impactors%regime == COLLRESOLVE_REGIME_MERGE) then
            volume = 4._DP / 3._DP * PI * sum(impactors%radius(:)**3)
            radius = (3._DP * volume / (4._DP * PI))**(THIRD)
#ifdef DOCONLOC
            do concurrent(i = 1:NDIM) shared(impactors,Ip,L_rot)
#else
            do concurrent(i = 1:NDIM)
#endif
               Ip(i) = sum(impactors%mass(:) * impactors%Ip(i,:)) 
               L_rot(i) = sum(impactors%L_orbit(i,:) + impactors%L_rot(i,:))
            end do
            Ip(:) = Ip(:) / mtot
            rot(:) = L_rot(:) * RAD2DEG / (Ip(3) * mtot * radius**2)
            if (.mag.rot(:) > collider%max_rot) then ! The merged body would rotation too fast, so reclasify this as a hit and run
               mlr = impactors%mass(jtarg)
               mslr = impactors%mass(jproj)
               impactors%regime = COLLRESOLVE_REGIME_HIT_AND_RUN
               impactors%Qloss = 0.0_DP
            else
               mlr =  mtot
               mslr = 0.0_DP
               impactors%Qloss = Qmerge
            end if
         else
            impactors%Qloss = Qloss
         end if

         if (allocated(impactors%mass_dist)) deallocate(impactors%mass_dist)
         allocate(impactors%mass_dist(NMASS_DIST))
         impactors%mass_dist(1) = min(max(mlr, 0.0_DP), mtot)
         impactors%mass_dist(2) = min(max(mslr, 0.0_DP), mtot)
         impactors%mass_dist(3) = min(max(mtot - mlr - mslr, 0.0_DP), mtot)

      end associate

      return

   end subroutine collision_regime_HG20

   subroutine collision_regime_HG20_SI(M_tar, M_imp, rad_tar, & 
                                          rh_tar, rh_imp, vb_tar, vb_imp, &
                                          min_mfrag, regime, Mlr, Mslr, Qloss, Qmerge)
      !! Author: Kaustub P. Anand, David A. Minton
      !!
      !! Determine the collisional regime of two colliding bodies when projectile mass is very small compared to target mass
      !! Current version requires all values to be converted to SI units prior to calling the function
      !!       References:
      !!       Hyodo, R., Genda, H., 2020. Escape and Accretion by Cratering Impacts: Formulation of Scaling Relations for 
      !!          High-speed Ejecta. ApJ 898 30. https://doi.org/10.3847/1538-4357/ab9897
      !!       Housen, K., Holsapple, K., 2011. Ejecta from Impact Craters. Icarus, Volume 211, Issue 1, 2011.
      !!          https://doi.org/10.1016/j.icarus.2010.09.017
      !!       Leinhardt, Z.M., Stewart, S.T., 2012. Collisions between Gravity-dominated Bodies. I. Outcome Regimes and 
      !!          Scaling Laws 745, 79. https://doi.org/10.1088/0004-637X/745/1/79
      !!

      implicit none
      ! Arguments
      real(DP), intent(in)           :: M_tar, M_imp, rad_tar, min_mfrag 
      real(DP), dimension(:), intent(in)  :: rh_tar, rh_imp, vb_tar, vb_imp
      real(DP), intent(out) :: Mlr, Mslr
         !! Largest and second-largest remnant defined for various regimes
      real(DP), intent(out)          :: Qloss
         !! The energy lost in the collision if it was a fragmentation event
      real(DP), intent(out)          :: Qmerge 
         !! The energy lost in the collision if it was a perfect merger
      integer(I4B), intent(out) :: regime
         !! The collisional regime

      ! Constants
      real(DP), parameter :: a_tar = 4.12e-5_DP
         !! Best-fit parameter for ejection velocity mu_HG20(theta) for the target body (Table 1 in HG20) 
      real(DP), parameter :: b_tar = 2.71e-3_DP
         !! Best-fit parameter for ejection velocity mu_HG20(theta) for the target body (Table 1 in HG20)
      real(DP), parameter :: c_tar = 5.13e-1_DP
         !! Best-fit parameter for ejection velocity mu_HG20(theta) for the target body (Table 1 in HG20)
      real(DP), parameter :: d_tar = 1.52e-5_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the target body (Table 1 in HG20)
      real(DP), parameter :: e_tar = -3.21e-3_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the target body (Table 1 in HG20)
      real(DP), parameter :: f_tar = 1.41e-1_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the target body (Table 1 in HG20)
      real(DP), parameter :: g_tar = -4.02_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the target body (Table 1 in HG20)

      real(DP), parameter :: a_imp = -7.06e-5_DP
         !! Best-fit parameter for ejection velocity mu_HG20(theta) for the impactor body (Table 1 in HG20)
      real(DP), parameter :: b_imp = 1.54e-2_DP
         !! Best-fit parameter for ejection velocity mu_HG20(theta) for the impactor body (Table 1 in HG20)
      real(DP), parameter :: c_imp = -1.93e-1_DP
         !! Best-fit parameter for ejection velocity mu_HG20(theta) for the impactor body (Table 1 in HG20)
      real(DP), parameter :: d_imp = 3.34e-5_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the impactor body (Table 1 in HG20)
      real(DP), parameter :: e_imp = -5.13e-3_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the impactor body (Table 1 in HG20)
      real(DP), parameter :: f_imp = 1.28e-1_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the impactor body (Table 1 in HG20)
      real(DP), parameter :: g_imp = -8.71e-1_DP
         !! Best-fit parameter for ejecta C_HG20(theta) for the impactor body (Table 1 in HG20)

      real(DP), parameter :: k = 0.3_DP
         !! material property constant from Housen and Holsapple (2011) (HH11)
      real(DP), parameter :: C_0 = 1.5_DP
         !! material property constant from Housen and Holsapple (2011) (HH11)
      real(DP), parameter :: mu_HH11 = 0.55_DP
         !! material property constant from Housen and Holsapple (2011) (HH11)
         !! 0.55 for nonporous rocky and icy materials

      real(DP), parameter   :: BETA = 2.85_DP 
         !! slope of sfd for remnants from LS12 2.85
      integer(I4B), parameter :: N1 = 1 
          !!number of objects with mass equal to the largest remnant from LS12
      integer(I4B), parameter :: N2 = 2  
         !! number of objects with mass larger than second largest remnant from LS12
      real(DP), parameter   :: DENSITY1 = 1000.0_DP 
         !! standard density parameter from LS12 [kg/m3]

      ! Internals
      real(DP) :: M_tot, M_esc_tar_HG20, M_esc_tar_HH11, M_esc_tar, M_esc_imp, M_acc_imp, M_esc_total, M_tmp
      real(DP) :: Rc1, c_star, ke, pe, U_binding
      real(DP) :: V_imp, V_esc
      real(DP) :: theta_rad, theta
      real(DP) :: C_HH11, C_HG20_tar, C_HG20_imp, mu_HG20_tar, mu_HG20_imp
      
      M_tot = M_tar + M_imp
      Rc1 = (3 * M_tot / (4 * PI * DENSITY1))**THIRD ! Stewart and Leinhardt (2009) 
      c_star = calc_c_star(Rc1)

      V_imp = norm2(vb_imp(:) - vb_tar(:)) ! Impact velocity
      theta_rad = calc_theta(rh_tar, vb_tar, rh_imp, vb_imp) ! Impact angle in radians
      theta = theta_rad * RAD2DEG ! Impact angle in degrees
      V_esc = sqrt(2 * GC * M_tar / rad_tar) ! Escape velocity of the target body

      ! Specific binding energy
      U_binding = (3 * GC * M_tot) / (5 * Rc1) ! LS12 eq. 27
      ke = 0.5_DP * V_imp**2
      pe = - GC * M_tar * M_imp / (M_tot * norm2(rh_imp - rh_tar))

      ! Calculate target body ejecta mass that escapes from the target body 

      mu_HG20_tar = a_tar * theta**2 + b_tar * theta + c_tar
      C_HG20_tar = exp(d_tar * theta**3 + e_tar * theta**2 + f_tar * theta + g_tar)
      M_esc_tar_HG20 = C_HG20_tar * (V_esc / (V_imp * sin(theta_rad)))**(-3.0_DP * mu_HG20_tar) ! impactor mass units

      C_HH11 = 3 * k / (4 * PI) * C_0**(3.0_DP * mu_HH11)
      M_esc_tar_HH11 = C_HH11 * (V_esc / (V_imp * sin(theta_rad)))**(-3.0_DP * mu_HH11) ! impactor mass units

      M_esc_tar = min(M_esc_tar_HG20, M_esc_tar_HH11) ! impactor mass units
      M_esc_tar = max(M_esc_tar, 0.0_DP) ! Min value of M_esc_tar is 0.0 (impactor mass units)

      ! Calculate impactor body ejecta mass that escapes from the target

      if (theta < 15.0_DP) then ! Below table 1
         mu_HG20_imp = 0.0_DP
         C_HG20_imp = 1.0_DP
      else
         mu_HG20_imp = a_imp * theta**2 + b_imp * theta + c_imp
         C_HG20_imp = exp(d_imp * theta**3 + e_imp * theta**2 + f_imp * theta + g_imp) 
      end if

      M_esc_imp = C_HG20_imp * (V_esc / (V_imp * sin(theta_rad)))**(-3.0_DP * mu_HG20_imp) ! impactor mass units
      M_esc_imp = min(M_esc_imp, 1.0_DP) ! Max value of M_esc_imp is 1.0 (impactor mass units)
      M_esc_imp = max(M_esc_imp, 0.0_DP) ! Min value of M_esc_imp is 0.0 (impactor mass units)

      M_esc_total = M_esc_tar + M_esc_imp ! impactor mass units

      ! Find collisional regime (MERGE or EROSION/DISRUPTION)

      if ((M_tar < min_mfrag).or.(M_imp < min_mfrag)) then 
         regime = COLLRESOLVE_REGIME_MERGE !perfect merging regime
         call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                 "Fragments would have mass below the minimum. Converting this collision into a merger.")
      else 
         if (M_esc_total < 1.0_DP) then 
            regime = COLLRESOLVE_REGIME_MERGE ! Net accretion regime       ! does partial accretion need a separate check?
         else if (M_esc_total >= 1.0_DP) then
            regime = COLLRESOLVE_REGIME_DISRUPTION ! Net erosion regime
         else 
            call swiftest_io_log_one_message(COLLISION_LOG_OUT,"Error no regime found in symba_regime")
         end if
      end if
      
      ! Convert from impactor mass units to system mass units
      M_esc_total = M_esc_total * M_imp
      M_esc_tar = M_esc_tar * M_imp
      M_esc_imp = M_esc_imp * M_imp

      M_acc_imp = M_imp - M_esc_imp ! impactor material accreted by the target body

      ! Calculate largest and second-largest remnant masses and energy loss
      Mlr = M_tar - M_esc_tar + M_acc_imp

      Mslr = max(M_tot * (3.0_DP - BETA) * (1.0_DP - N1 * Mlr / M_tot) / (N2 * BETA), min_mfrag)  !LS12 eq (37)

      if (Mslr > Mlr) then ! The second-largest fragment is actually larger than the largest, so we will swap them
         M_tmp = Mlr
         Mlr = Mslr
         Mslr = M_tmp
      end if
      
      Qloss = (c_star - 1.0_DP) * U_binding * M_tot ! Convert specific energy loss to total energy loss in the system
      Qmerge = (ke + pe + U_binding) * M_tot ! The  energy lost if this were a perfect merger

      return
      
      contains

         function calc_theta(r_tar, v_tar, r_imp, v_imp) result(theta)
            !! author: Kaustub P. Anand, Jennifer L. L. Pouplin, David A. Minton
            !!
            !! Calculate the impact angle between two colliding bodies
            !! For HG20, theta = 90 degrees - asin(b) where b is the impact parameter 
            !! (if impactor radius << target radius)
            !! 90 degrees is a head-on collision, angle calculated from horizon
            !!
            implicit none
            ! Arguments
            real(DP), dimension(NDIM), intent(in) :: r_tar, v_tar, r_imp, v_imp
            ! Result
            real(DP) :: theta ! radians
            ! Internals
            real(DP), dimension(NDIM)  :: imp_vel, distance

            imp_vel(:) = v_imp(:) - v_tar(:)
            distance(:) = r_imp(:) - r_tar(:)

            theta = PIBY2 - acos(dot_product(distance(:), imp_vel(:)) / (.mag.distance(:) * .mag.imp_vel(:)))

            return
         end function calc_theta

         function calc_c_star(Rc1) result(c_star)
            !! author: David A. Minton
            !!
            !! Calculates c_star as a function of impact equivalent radius. It interpolates between 5 for ~1 km sized bodies to
            !! 1.8 for ~10000 km sized bodies. See LS12 Fig. 4 for details.
            !! 
            implicit none
            ! Arguments
            real(DP), intent(in) :: Rc1
            ! Result
            real(DP)             :: c_star
            ! Internals
            real(DP), parameter  :: loR   = 1.0e3_DP ! Lower bound of interpolation size (m)
            real(DP), parameter  :: hiR   = 1.0e7_DP ! Upper bound of interpolation size (m)
            real(DP), parameter  :: loval = 5.0_DP   ! Value of C* at lower bound
            real(DP), parameter  :: hival = 1.9_DP   ! Value of C* at upper bound

            if (Rc1 < loR) then
               c_star = loval
            else if (Rc1 < hiR) then
               c_star = loval + (hival - loval) * log(Rc1 / loR) / log(hiR /loR)
            else
               c_star = hival
            end if
            return
         end function calc_c_star 

   end subroutine collision_regime_HG20_SI


   subroutine collision_regime_LS12(collider, nbody_system, param) 
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton 
      !!
      !! Determine the collisional regime of two colliding bodies based on the model by Leinhard and Stewart (2012)
      !!
      !! This is a wrapper subroutine that converts quantities to SI units and calls the main LS12 subroutine
      implicit none
      ! Arguments
      class(collision_basic),       intent(inout) :: collider     
         !! The impactors to determine the regime for
      class(swiftest_nbody_system), intent(in)    :: nbody_system 
         !! Swiftest n-body system object
      class(swiftest_parameters),   intent(in)    :: param        
         !! The current parameters
      ! Internals
      integer(I4B) :: i,jtarg, jproj
      real(DP), dimension(2) :: radius_si, mass_si, density_si
      real(DP) :: min_mfrag_si, Mcb_si
      real(DP), dimension(NDIM)  :: x1_si, v1_si, x2_si, v2_si
      real(DP) :: mlr, mslr, mslr_hr, mtot, dentot, Qloss, Qmerge
      integer(I4B), parameter :: NMASS_DIST = 3   ! Number of mass bins returned by the regime calculation (largest fragment, second
                                                  ! largest, and remainder)  
      real(DP), dimension(NDIM) :: Ip, rot, L_rot
      real(DP) :: radius, volume
      
      associate(impactors => collider%impactors)

         ! Convert all quantities to SI units and determine which of the pair is the projectile vs. target before sending them to 
         ! the regime determination subroutine
         if (impactors%mass(1) > impactors%mass(2)) then
            jtarg = 1
            jproj = 2
         else
            jtarg = 2
            jproj = 1
         end if
         ! The two-body equivalent masses of the collider system
         mass_si(:)    = impactors%mass([jtarg, jproj]) * param%MU2KG 
         
         ! The two-body equivalent radii of the collider system
         radius_si(:)  = impactors%radius([jtarg, jproj]) * param%DU2M 

         ! The two-body equivalent density of the collider system
         density_si(:) = mass_si(:) / (4.0_DP / 3._DP * PI * radius_si(:)**3) 

         ! The first body of the two-body equivalent position vector the collider system
         x1_si(:)      = impactors%rb(:,jtarg) * param%DU2M                   

         ! The first body of the two-body equivalent velocity vector the collider system
         v1_si(:)      = impactors%vb(:,jtarg) * param%DU2M / param%TU2S      

         ! The second body of the two-body equivalent position vector the collider system
         x2_si(:)      = impactors%rb(:,jproj) * param%DU2M                   

         ! The second body of the two-body equivalent velocity vector the collider system
         v2_si(:)      = impactors%vb(:,jproj) * param%DU2M / param%TU2S      

         ! The central body mass of the system
         Mcb_si        = nbody_system%cb%mass * param%MU2KG           
         
         ! The minimum fragment mass to generate. Collider systems that would otherwise generate less massive fragments than this 
         ! value will be forced to merge instead
         min_mfrag_si  = (param%min_GMfrag / param%GU) * param%MU2KG 
      
         mtot = sum(mass_si(:)) 
         dentot = sum(mass_si(:) * density_si(:)) / mtot 

         ! Use the positions and velocities of the parents from indside the step (at collision) to calculate the collisional regime
         call collision_regime_LS12_SI(Mcb_si, mass_si(jtarg), mass_si(jproj), radius_si(jtarg), radius_si(jproj), &
                                       x1_si(:), x2_si(:), v1_si(:), v2_si(:), density_si(jtarg), density_si(jproj), &
                                       min_mfrag_si, impactors%regime, mlr, mslr, mslr_hr, Qloss, Qmerge)

         ! Convert back from SI to system units
         mlr = mlr / param%MU2KG
         mslr = mslr / param%MU2kg
         mslr_hr = mslr_hr / param%MU2kg
         Qloss = Qloss * (param%TU2S / param%DU2M)**2 / param%MU2KG
         Qmerge = Qmerge * (param%TU2S / param%DU2M)**2 / param%MU2KG
         mtot = mtot / param%MU2kg

         ! If this is came back as a merger, check to make sure that the rotation of the merged body doesn't exceed the rotation 
         ! barrier
         if (impactors%regime == COLLRESOLVE_REGIME_MERGE) then
            volume = 4._DP / 3._DP * PI * sum(impactors%radius(:)**3)
            radius = (3._DP * volume / (4._DP * PI))**(THIRD)
#ifdef DOCONLOC
            do concurrent(i = 1:NDIM) shared(impactors,Ip,L_rot)
#else
            do concurrent(i = 1:NDIM)
#endif
               Ip(i) = sum(impactors%mass(:) * impactors%Ip(i,:)) 
               L_rot(i) = sum(impactors%L_orbit(i,:) + impactors%L_rot(i,:))
            end do
            Ip(:) = Ip(:) / mtot
            rot(:) = L_rot(:) * RAD2DEG / (Ip(3) * mtot * radius**2)
            if (.mag.rot(:) > collider%max_rot) then ! The merged body would rotation too fast, so reclasify this as a hit and run
               mlr = impactors%mass(jtarg)
               mslr = impactors%mass(jproj)
               impactors%regime = COLLRESOLVE_REGIME_HIT_AND_RUN
               impactors%Qloss = 0.0_DP
            else
               mlr =  mtot
               mslr = 0.0_DP
               impactors%Qloss = Qmerge
            end if
         else
            impactors%Qloss = Qloss
         end if

         if (allocated(impactors%mass_dist)) deallocate(impactors%mass_dist)
         allocate(impactors%mass_dist(NMASS_DIST))
         impactors%mass_dist(1) = min(max(mlr, 0.0_DP), mtot)
         impactors%mass_dist(2) = min(max(mslr, 0.0_DP), mtot)
         impactors%mass_dist(3) = min(max(mtot - mlr - mslr, 0.0_DP), mtot)

      end associate

      return
   end subroutine collision_regime_LS12
   

   subroutine collision_regime_LS12_SI(Mcb, m1, m2, rad1, rad2, rh1, rh2, vb1, vb2, den1, den2, min_mfrag, &
                                                regime, Mlr, Mslr, Mslr_hitandrun, Qloss, Qmerge)
      !! Author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
      !!
      !! Determine the collisional regime of two colliding bodies. 
      !! Current version requires all values to be converted to SI units prior to calling the function
      !!       References:
      !!       Kokubo, E., Genda, H., 2010. Formation of Terrestrial Planets from Protoplanets Under a Realistic Accretion 
      !!          Condition. ApJL 714, L21. https://doi.org/10.1088/2041-8205/714/1/L21
      !!       Leinhardt, Z.M., Stewart, S.T., 2012. Collisions between Gravity-dominated Bodies. I. Outcome Regimes and Scaling 
      !!          Laws 745, 79. https://doi.org/10.1088/0004-637X/745/1/79
      !!       Mustill, A.J., Davies, M.B., Johansen, A., 2018. The dynamical evolution of transiting planetary systems including 
      !!          a realistic collision prescription. Mon Not R Astron Soc 478, 2896–2908. https://doi.org/10.1093/mnras/sty1273
      !!       Rufu, R., Aharonson, O., 2019. Impact Dynamics of Moons Within a Planetary Potential. J. Geophys. Res. Planets 124, 
      !!          1008–1019. https://doi.org/10.1029/2018JE005798
      !!       Stewart, S.T., Leinhardt, Z.M., 2012. Collisions between Gravity-dominated Bodies. II. The Diversity of Impact 
      !!          Outcomes during the End Stage of Planet Formation. ApJ 751, 32. https://doi.org/10.1088/0004-637X/751/1/32
      !!
      implicit none
      ! Arguments
      real(DP), intent(in)           :: Mcb, m1, m2, rad1, rad2, den1, den2, min_mfrag 
      real(DP), dimension(:), intent(in)  :: rh1, rh2, vb1, vb2
      integer(I4B), intent(out)         :: regime
      real(DP), intent(out)          :: Mlr, Mslr, Mslr_hitandrun 
         !! Largest and second-largest remnant defined for various regimes
      real(DP), intent(out)          :: Qloss  
         !! The energy lost in the collision if it was a fragmentation event
      real(DP), intent(out)          :: Qmerge 
         !! The energy lost in the collision if it was a perfect merger
      ! Constants
      integer(I4B), parameter :: N1 = 1 
          !!number of objects with mass equal to the largest remnant from LS12
      integer(I4B), parameter :: N2 = 2  
         !! number of objects with mass larger than second largest remnant from LS12
      real(DP), parameter   :: DENSITY1 = 1000.0_DP 
         !! standard density parameter from LS12 [kg/m3]
      real(DP), parameter   :: MU_BAR = 0.37_DP 
         !!0.385#0.37#0.3333# 3.978 # 1/3 material parameter for hydrodynamic planet-size bodies (LS12)
      real(DP), parameter   :: BETA = 2.85_DP 
         !! slope of sfd for remnants from LS12 2.85
      real(DP), parameter   :: ETA = -1.50_DP 
         !! LS12 eq. (44)
      real(DP), parameter   :: C1 = 2.43_DP 
         !! Kokubo & Genda (2010) eq. (3)
      real(DP), parameter   :: C2 = -0.0408_DP 
         !! Kokubo & Genda (2010) eq. (3)
      real(DP), parameter   :: C3 = 1.86_DP 
         !! Kokubo & Genda (2010) eq. (3)
      real(DP), parameter   :: C4 = 1.08_DP 
         !! Kokubo & Genda (2010) eq. (3)
      real(DP), parameter   :: CRUFU = 2.0_DP - 3 * MU_BAR 
         !! central potential variable from Rufu and Aharonson (2019)
      real(DP), parameter   :: SUPERCAT_QRATIO = 1.8_DP 
         !! See Section 4.1 of LS12
      ! Internals
      real(DP)           :: a1, alpha, aint, b, bcrit, c_star, egy, zeta, l, lint, mu, phi, theta, ke, pe
      real(DP)           :: Qr, Qrd_pstar, Qr_erosion, Qr_supercat
      real(DP)           :: Vhr, Verosion, Vescp, Vhill, Vimp, Vsupercat
      real(DP)           :: Mint, Mtot, Mtmp, Mbig, Msmall
      real(DP)           :: Rc1, rhill 
      real(DP)           :: Mresidual
      real(DP)           :: U_binding

      Vimp = norm2(vb2(:) - vb1(:))
      b = calc_b(rh2, vb2, rh1, vb1)
      l = (rad1 + rad2) * (1 - b)
      egy = 0.5_DP * dot_product(vb1, vb1) - GC * Mcb / norm2(rh1)
      a1 = - GC * Mcb / 2.0_DP / egy
      Mtot = m1 + m2 
      mu = (m1 * m2) / Mtot
      if (l < 2 * rad2) then
         !calculate Mint
         phi = 2 * acos((l - rad2) / rad2)
         aint = rad2**2 * (PI - (phi - sin(phi)) / 2.0_DP)
         lint = 2 * sqrt(rad2**2 - (rad2 - l / 2.0_DP) ** 2) 
         Mint = aint * lint  ![kg]
         alpha = (l**2) * (3 * rad2 - l) / (4 * (rad2**3))
      else
         alpha = 1.0_DP
         Mint = m2
      end if 
      Rc1 = (3 * Mtot / (4 * PI * DENSITY1))**THIRD ! Stewart and Leinhardt (2009) 
      c_star = calc_c_star(Rc1)

      !calculate Vescp
      Vescp = sqrt(2 * GC * Mtot / Rc1) ! Steward and Leinhardt (2012) e.g. Fig. 7 caption.

      !calculate rhill
      rhill = a1 * (m1 / (3 *(Mcb + m1)))**(1.0_DP/3.0_DP)

      !calculate Vhill
      if ((rad2 + rad1) < rhill) then 
         Vhill = sqrt(2 * GC * m1 * ((rhill**2 - rhill * (rad1 + rad2)) / &
         (rhill**2 - 0.5_DP * (rad1 + rad2)**2)) / (rad1 + rad2))
      else
         Vhill = Vescp
      end if 

      !calculate Qr_pstar
      Qrd_pstar = calc_Qrd_pstar(m1, m2, alpha, c_star) * (Vhill / Vescp)**CRUFU !Rufu and Aharaonson eq (3)

      !calculate Verosion
      Qr_erosion = 2 * (1.0_DP - m1 / Mtot) * Qrd_pstar
      Verosion = (2 * Qr_erosion * Mtot / mu)** (1.0_DP / 2.0_DP)
      Qr = mu*(Vimp**2) / Mtot / 2.0_DP

      !calculate mass largest remnant Mlr 
      !calculate Vsupercat
      Qr_supercat = SUPERCAT_QRATIO * Qrd_pstar ! See LS12 Section 4.1 
      Vsupercat = sqrt(2 * Qr_supercat * Mtot / mu)

      !calculate Vhr
      zeta = (m1 - m2) / Mtot
      theta = 1.0_DP - b
      Vhr = Vescp * (C1 * zeta**2 * theta**(2.5_DP) + C2 * zeta**2 + C3 * theta**(2.5_DP) + C4) ! Kokubo & Genda (2010) eq. (3)
      bcrit = rad1 / (rad1 + rad2)
      ! Specific binding energy
      U_binding = (3 * GC * Mtot) / (5 * Rc1) ! LS12 eq. 27
      ke = 0.5_DP * Vimp**2
      pe = - GC * m1 * m2 / (Mtot * norm2(rh2 - rh1))

      if ((m1 < min_mfrag).or.(m2 < min_mfrag)) then 
         regime = COLLRESOLVE_REGIME_MERGE !perfect merging regime
         call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                 "Fragments would have mass below the minimum. Converting this collision into a merger.")
      else 
         if( Vimp < Vescp) then
            regime = COLLRESOLVE_REGIME_MERGE !perfect merging regime
         else if (Vimp < Verosion) then 
            if (b < bcrit) then
               regime = COLLRESOLVE_REGIME_MERGE !partial accretion regime"
            else if ((b > bcrit) .and. (Vimp < Vhr)) then
               regime = COLLRESOLVE_REGIME_MERGE ! graze and merge
            else
               regime = COLLRESOLVE_REGIME_HIT_AND_RUN !hit and run
            end if 
         else if (Vimp > Verosion .and. Vimp < Vsupercat) then
            regime = COLLRESOLVE_REGIME_DISRUPTION !disruption
         else if (Vimp > Vsupercat) then 
            regime = COLLRESOLVE_REGIME_SUPERCATASTROPHIC ! supercatastrophic
         else 
            call swiftest_io_log_one_message(COLLISION_LOG_OUT,"Error no regime found in symba_regime")
         end if 
      end if 

      if (regime == COLLRESOLVE_REGIME_SUPERCATASTROPHIC) then
         Mlr  = max(Mtot * 0.1_DP * (Qr / (Qrd_pstar * SUPERCAT_QRATIO))**(ETA), min_mfrag)   !LS12 eq (44)
      else if (regime == COLLRESOLVE_REGIME_HIT_AND_RUN) then
         Mlr = m1
      else 
         Mlr = max((1.0_DP - Qr / Qrd_pstar / 2.0_DP) * Mtot, min_mfrag) ! [kg] # LS12 eq (5)
      end if
      Mbig = max(m1,Mlr)
      Msmall = mtot - Mbig
      Mslr_hitandrun = max(calc_Qrd_rev(Msmall, Mbig, Mint, den1, den2, Vimp, c_star), min_mfrag)
      if (regime == COLLRESOLVE_REGIME_HIT_AND_RUN ) then
         Mslr = Mslr_hitandrun
      else
         Mslr = max(Mtot * (3.0_DP - BETA) * (1.0_DP - N1 * Mlr / Mtot) / (N2 * BETA), min_mfrag)  !LS12 eq (37)
      end if

      Mresidual = Mtot - Mlr - Mslr
      if (Mresidual < 0.0_DP) then ! prevents final masses from going negative
         Mlr = Mlr + Mresidual
      end if

      if (Mslr > Mlr) then ! The second-largest fragment is actually larger than the largest, so we will swap them
         Mtmp = Mlr
         Mlr = Mslr
         Mslr = Mtmp
      end if

      Qloss = (c_star - 1.0_DP) * U_binding * Mtot ! Convert specific energy loss to total energy loss in the system
      Qmerge = (ke + pe + U_binding) * Mtot ! The  energy lost if this were a perfect merger
         
      return 

      contains

         function calc_Qrd_pstar(Mtarg, Mp, alpha, c_star) result(Qrd_pstar)
            !! author: Jennifer L.L. Pouplin and Carlisle A. Wishard
            !!
            !! Calculates the corrected Q* for oblique impacts. See Eq. (15) of LS12.
            !!       Reference:
            !!       Leinhardt, Z.M., Stewart, S.T., 2012. Collisions between Gravity-dominated Bodies. I. Outcome Regimes and 
            !!          Scaling Laws 745, 79. https://doi.org/10.1088/0004-637X/745/1/79
            !! 
            implicit none
            ! Arguments
            real(DP),intent(in) :: Mtarg, Mp, alpha, c_star
            ! Result
            real(DP)      :: Qrd_pstar
            ! Internals
            real(DP)      :: Qrd_star1, mu_alpha, mu, Qrd_star, gamma

            ! calc mu, mu_alpha
            mu = (Mtarg * Mp) / (Mtarg + Mp)  ! [kg]
            mu_alpha = (Mtarg * alpha * Mp) / (Mtarg + alpha * Mp)  ! [kg]
            gamma = Mp / Mtarg
            ! calc Qrd_star1
            Qrd_star1 = (c_star * 4 * PI * DENSITY1 * GC * Rc1**2) / 5.0_DP ! LS12 eq. 28
            ! calc Qrd_star
            Qrd_star = Qrd_star1 * (((gamma + 1.0_DP)**2) / (4 * gamma))**(2.0_DP / (3 * MU_BAR) - 1.0_DP)  !(eq 23)
            ! calc Qrd_pstar, v_pstar
            Qrd_pstar = ((mu / mu_alpha)**(2.0_DP - 3 * MU_BAR / 2.0_DP)) * Qrd_star  ! (eq 15)

            return
         end function calc_Qrd_pstar

         function calc_Qrd_rev(Mp, Mtarg, Mint, den1, den2, Vimp, c_star) result(Mslr)
            !! author: Jennifer L.L. Pouplin and Carlisle A. Wishard
            !!
            !! Calculates mass of second largest fragment.
            !! 
            implicit none
            ! Arguments
            real(DP),intent(in) :: Mp, Mtarg, Mint, den1, den2, Vimp, c_star
            ! Result
            real(DP) :: Mslr
            ! Internals
            real(DP) :: mtot_rev, mu_rev, gamma_rev, Qrd_star1, Qrd_star, mu_alpha_rev
            real(DP) :: Qrd_pstar, Rc1, Qr_rev, Qrd_pstar_rev, Qr_supercat_rev

            ! calc Mslr, Rc1, mu, gammalr
            mtot_rev =  Mint + Mp
            Rc1 = (3 * (Mint / den1 + Mp / den2) / (4 * PI))**(1.0_DP/3.0_DP) ! [m] Mustill et al 2018
            mu_rev = (Mint * Mp) / mtot_rev ! [kg] eq 49 LS12
            mu_alpha_rev = (Mtarg * alpha * Mp) / (Mtarg + alpha * Mp)
            gamma_rev = Mint / Mp ! eq 50 LS12
            !calc Qr_rev
            Qr_rev = mu_rev * (Vimp**2) / (2 * mtot_rev)
            ! calc Qrd_star1, v_star1
            Qrd_star1 = (c_star * 4 * PI * mtot_rev * GC ) / Rc1 / 5.0_DP
            ! calc Qrd_pstar_rev
            Qrd_star = Qrd_star1 * (((gamma_rev + 1.0_DP)**2) / (4 * gamma_rev)) ** (2.0_DP / (3 * MU_BAR) - 1.0_DP) !(eq 52)
            Qrd_pstar = Qrd_star * ((mu_rev / mu_alpha_rev)**(2.0_DP - 3 * MU_BAR / 2.0_DP))
            Qrd_pstar_rev = Qrd_pstar * (Vhill / Vescp)**CRUFU !Rufu and Aharaonson eq (3)
            !calc Qr_supercat_rev
            Qr_supercat_rev = 1.8_DP * Qrd_pstar_rev 
            if (Qr_rev > Qr_supercat_rev ) then 
               Mslr = mtot_rev * (0.1_DP * ((Qr_rev / (Qrd_pstar_rev * 1.8_DP))**(-1.5_DP)))   !eq (44)
            else if ( Qr_rev < Qrd_pstar_rev ) then 
               Mslr = Mp 
            else 
               Mslr = (1.0_DP - Qr_rev / Qrd_pstar_rev / 2.0_DP) * (mtot_rev)  ! [kg] #(eq 5)
            end if 

            if ( Mslr > Mp ) Mslr = Mp !check conservation of mass

            return
         end function calc_Qrd_rev

         function calc_b(proj_pos, proj_vel, targ_pos, targ_vel) result(sintheta)
            !! author: Jennifer L.L. Pouplin, Carlisle A. Wishard, and David A. Minton
            !!
            !! Calculates the impact factor b = sin(theta), where theta is the angle between the relative velocity
            !! and distance vectors of the target and projectile bodies. See Fig. 2 of Leinhardt and Stewart (2012)
            !! 
            implicit none
            ! Arguments
            real(DP), dimension(:), intent(in) :: proj_pos, proj_vel, targ_pos, targ_vel
            ! Result
            real(DP)             :: sintheta
            ! Internals
            real(DP), dimension(NDIM)     :: imp_vel, distance, x_cross_v      

            imp_vel(:) = proj_vel(:) - targ_vel(:)
            distance(:) = proj_pos(:) - targ_pos(:)
            x_cross_v(:) = distance(:) .cross. imp_vel(:) 
            sintheta = norm2(x_cross_v(:)) / norm2(distance(:)) / norm2(imp_vel(:))
            return 
         end function calc_b


         function calc_c_star(Rc1) result(c_star)
            !! author: David A. Minton
            !!
            !! Calculates c_star as a function of impact equivalent radius. It interpolates between 5 for ~1 km sized bodies to
            !! 1.8 for ~10000 km sized bodies. See LS12 Fig. 4 for details.
            !! 
            implicit none
            ! Arguments
            real(DP), intent(in) :: Rc1
            ! Result
            real(DP)             :: c_star
            ! Internals
            real(DP), parameter  :: loR   = 1.0e3_DP ! Lower bound of interpolation size (m)
            real(DP), parameter  :: hiR   = 1.0e7_DP ! Upper bound of interpolation size (m)
            real(DP), parameter  :: loval = 5.0_DP   ! Value of C* at lower bound
            real(DP), parameter  :: hival = 1.9_DP   ! Value of C* at upper bound

            if (Rc1 < loR) then
               c_star = loval
            else if (Rc1 < hiR) then
               c_star = loval + (hival - loval) * log(Rc1 / loR) / log(hiR /loR)
            else
               c_star = hival
            end if
            return
         end function calc_c_star 

   end subroutine collision_regime_LS12_SI

end submodule s_collision_regime

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module lambda_function
   !! author: David A. Minton
   !!
   !! Defines a class that can enable objects that behave like lambda functions.
   !! 
   !! To use this class, define a type of either lambda_obj or lambda_obj_err, or extend the lambda_obj class as necessary, such 
   !! that an interface that matches the function you wish to lambdafy.
   !! Once defined, the lambda object can evaluate itself by calling the type-bound procedure eval. e.g. f%eval(x) 
   !! (or f%eval(x, lerr), f%eval(x, [argument list], etc)) 
   !! 
   !! ******************************************************************************************************************************
   !! Example - Defining a lambda function f(x,rval,ival) where rval and ival are a real and integer argument, respectively. 
   !! This implementation uses an abstract interface, though this is not
   !! strictly necessary unless you want to bind more than one function with the same interface.
   !! ******************************************************************************************************************************
   !!
   !! module lambda_new 
   !!    use swiftest ! This will bring in the lambda_function module
   !!    ! Define types in a module
   !!
   !!    type, extends(lambda_obj) :: lambda_obj_ri_args
   !!       procedure(abstract_lambda_ri_args), pointer, nopass :: lambdaptr_ri_args => null()
   !!       real(DP)                                            :: rval     !! Real parameter
   !!       integer(I4B)                                        :: ival     !! Integer paramete
   !!    contains
   !!       generic           :: init => lambda_ri_args_init
   !!       procedure         :: eval => lambda_ri_args_eval
   !!       procedure, nopass :: lambda_ri_args_init
   !!       final             :: lambda_ri_args_destroy
   !!    end type
   !!    interface lambda_obj
   !!       module procedure lambda_ri_args_init
   !!    end interface
   !! 
   !!    abstract interface
   !!       function abstract_lambda_ri_args(x, rval, ival) result(y)
   !!          !Template for the lambda function
   !!          import DP, I4B
   !!          real(DP), dimension(:), intent(in) :: x        !! Dependent variable
   !!          real(DP),               intent(in) :: rval     !! Real parameter
   !!          integer(I4B),           intent(in) :: ival     !! Integer parameter
   !!          real(DP)                           :: y        !! Real result
   !!       end function
   !!    end interface
   !! 
   !! contains
   !!    type(lambda_obj_ri_args) function lambda_ri_args_init(lambda, rval, ival)
   !!       !! Initializes the lambda function parameters (can be used as a structure constructor)
   !!       implicit none
   !!       procedure(abstract_lambda_ri_args)  :: lambda !! The lambda function that will be passed
   !!       real(DP),     intent(in)            :: rval     !! Real parameter
   !!       integer(I4B), intent(in)            :: ival     !! Integer parameter     
   !!    
   !!       ! Assign the procedure passed to this function to the procedure pointer 
   !!       lambda_ri_args_init%lambdaptr_ri_args => lambda 
   !! 
   !!       ! Assign the argument values
   !!       lambda_ri_args_init%rval = rval 
   !!       lambda_ri_args_init%ival = ival
   !!       return
   !!    end function lambda_ri_args_init
   !!
   !!    function lambda_ri_args_eval(self, x) result(y)
   !!       !! Defines the evaluation method, allowing the lambda function to be called with a single argument
   !!       implicit none
   !!       class(lambda_obj_ri_args),      intent(inout) :: self
   !!       real(DP), dimension(:),         intent(in) :: x
   !!       real(DP)                                   :: y
   !!    
   !!      if (associated(self%lambdaptr_ri_args)) then
   !!         y = self%lambdaptr_ri_args(x, self%rval, self%ival)
   !!          self%lastval = y
   !!          if (allocated(self%lastarg)) deallocate(self%lastarg)
   !!          allocate(self%lastarg, source=x)
   !!       else
   !!          stop "Lambda function was not initialized"
   !!       end if
   !!    end function lambda_ri_args_eval
   !!
   !!    subroutine lambda_ri_args_destroy(self)
   !!       !! Finalizer method. Use this as a template for cleaning up the object upon destruction, such as nullifying pointers 
   !!       implicit none
   !!       type(lambda_obj_ri_args) :: self
   !!       if (associated(self%lambdaptr_ri_args)) nullify(self%lambdaptr_ri_args)
   !!    end subroutine lambda_ri_args_destroy
   !!
   !!    function example_function(x, rval, ival) result(y)
   !!       ! This is the actual function you are going to use as the lambda function. Its interface must match the abstract 
   !!       ! interface previously defined
   !!       implicit none
   !!       ! Arguments
   !!       real(DP), dimension(:), intent(in) :: x
   !!       real(DP),               intent(in) :: rval
   !!       integer(I4B),           intent(in) :: ival 
   !!       ! Result
   !!       real(DP)                           :: y
   !!       ! Internals
   !!       integer(I4B) :: i, n
   !!       n = size(x)
   !!       y = 42._DP * ival
   !!       do i = 1, n
   !!          y = y + x(i)**2
   !!       end do
   !!       return
   !!    end function example_function
   !! end module lambda_new
   !!
   !! program usage
   !!    use swiftest
   !!    use lambda_new
   !!    implicit none
   !!    type(lambda_obj_ri_args) :: f
   !!    real(DP) :: sigma_par
   !!    integer(I4B) :: iwonky, i,j
   !!    real(DP), dimension(12) :: xarr
   !!   
   !!    sigma_par = 3.14_DP
   !!    iwonky = 13
   !!
   !!    f = lambda_obj(example_function, sigma_par, iwonky)
   !!    do i = 1, 10
   !!       xarr(:) = [(j * 0.25_DP / i, j=1, 12)]
   !!       write(*,*) i,f%eval(xarr)
   !!    end do
   !! end program usage
   !! ******************************************************************************************************************************
   
   use globals
   implicit none
   public

   type :: lambda_obj 
      !! Base class for an lambda function object. This object takes no additional arguments other than the dependent variable x, an
      !! array of real numbers
      procedure(lambda0), pointer, nopass :: lambdaptr => null()
      real(DP) :: lastval
      real(DP),dimension(:), allocatable :: lastarg
   contains
      generic   :: init => lambda_init_0
      procedure :: eval => lambda_eval_0
      procedure, nopass :: lambda_init_0
      final     :: lambda_destroy
   end type

   type, extends(lambda_obj) :: lambda_obj_err
      !! Extended class for an lambda function object. This object takes allows for the return of a logical error flag during 
      !! evaluation of the function.
      procedure(lambda0err), pointer, nopass :: lambdaptr_err => null()
      logical   :: lerr     
   contains
      generic   :: init => lambda_init_0_err
      procedure :: eval => lambda_eval_0_err
      procedure, nopass :: lambda_init_0_err
   end type

   type, extends(lambda_obj) :: lambda_obj_tvar
      !! Base class for an lambda function object. This object takes no additional arguments other than the dependent variable x, an
      !! array of real numbers
      procedure(lambda0tvar), pointer, nopass :: lambdaptr_tvar => null()
      real(DP) :: t 
   contains
      generic   :: init => lambda_init_tvar
      procedure :: evalt => lambda_eval_tvar
      procedure, nopass :: lambda_init_tvar
   end type
   interface lambda_obj
      module procedure lambda_init_0
      module procedure lambda_init_0_err
      module procedure lambda_init_tvar
   end interface

   abstract interface
      function lambda0(x) result(y)
         ! Template for a 0 argument function
         import DP
         real(DP), dimension(:), intent(in) :: x
         real(DP)                           :: y
      end function

      function lambda0err(x, lerr) result(y)
         ! Template for a 0 argument function that returns an error value
         import DP
         real(DP), dimension(:), intent(in)  :: x
         logical,                intent(out) :: lerr
         real(DP)                            :: y
      end function

      function lambda0tvar(x, t) result(y)
         ! Template for a 0 argument function that returns an error value
         import DP
         real(DP), dimension(:), intent(in)  :: x
         real(DP),               intent(in)  :: t
         real(DP), dimension(:), allocatable :: y
      end function
   end interface

   contains
      type(lambda_obj) function lambda_init_0(lambda)
         implicit none
         ! Arguments
         procedure(lambda0)             :: lambda
         lambda_init_0%lambdaptr => lambda
         return
      end function lambda_init_0

      type(lambda_obj_err) function lambda_init_0_err(lambda, lerr)
         implicit none
         ! Arguments
         procedure(lambda0err)  :: lambda
         logical, intent(in) :: lerr
         lambda_init_0_err%lambdaptr_err => lambda
         lambda_init_0_err%lerr = lerr
         return
      end function lambda_init_0_err

      type(lambda_obj_tvar) function lambda_init_tvar(lambda, t)
         implicit none
         ! Arguments
         procedure(lambda0tvar)             :: lambda
         real(DP), intent(in)               :: t
         lambda_init_tvar%lambdaptr_tvar => lambda
         lambda_init_tvar%t = t
         return
      end function lambda_init_tvar
   
      function lambda_eval_0(self, x) result(y)
         implicit none
         ! Arguments
         class(lambda_obj),      intent(inout) :: self
         real(DP), dimension(:), intent(in) :: x
         ! Result
         real(DP)                      :: y
         if (associated(self%lambdaptr)) then
            y = self%lambdaptr(x)
            self%lastval = y
            if (allocated(self%lastarg)) deallocate(self%lastarg)
            allocate(self%lastarg, source=x)
         else
            stop "Lambda function was not initialized"
         end if
      end function lambda_eval_0

      function lambda_eval_0_err(self, x) result(y)
         implicit none
         ! Arguments
         class(lambda_obj_err),  intent(inout) :: self
         real(DP), dimension(:), intent(in) :: x
         ! Result
         real(DP)                      :: y
         if (associated(self%lambdaptr_err)) then
            y = self%lambdaptr_err(x, self%lerr)
            self%lastval = y
            if (allocated(self%lastarg)) deallocate(self%lastarg)
            allocate(self%lastarg, source=x)
         else
            stop "Lambda function was not initialized"
         end if
      end function lambda_eval_0_err

      function lambda_eval_tvar(self, x, t) result(y)
         implicit none
         ! Arguments
         class(lambda_obj_tvar), intent(inout) :: self
         real(DP), dimension(:), intent(in) :: x
         real(DP),               intent(in) :: t
         ! Result
         real(DP), dimension(:), allocatable :: y
         if (associated(self%lambdaptr_tvar)) then
            y = self%lambdaptr_tvar(x,t)
         else
            stop "Lambda function was not initialized"
         end if
      end function lambda_eval_tvar

      subroutine lambda_destroy(self)
         implicit none
         type(lambda_obj) :: self
         if (associated(self%lambdaptr)) nullify(self%lambdaptr)
      end subroutine lambda_destroy

end module lambda_function

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module walltime
   !! author: David A. Minton
   !!
   !! Classes and methods used to compute elasped wall time
   use globals
   use base
   implicit none
   public

   integer(I4B) :: INTERACTION_TIMER_CADENCE = 1000 !! Minimum number of steps to wait before timing an interaction loop in ADAPTIVE mode
   character(len=*), parameter :: INTERACTION_TIMER_LOG_OUT  = "interaction_timer.log" !! Name of log file for recording results of interaction loop timing
   character(len=*), parameter :: ENCOUNTER_PLPL_TIMER_LOG_OUT  = "encounter_check_plpl_timer.log" !! Name of log file for recording results of encounter check method timing
   character(len=*), parameter :: ENCOUNTER_PLTP_TIMER_LOG_OUT  = "encounter_check_pltp_timer.log" !! Name of log file for recording results of encounter check method timing

   type :: walltimer
      integer(I8B) :: count_rate                 !! Rate at wich the clock ticks
      integer(I8B) :: count_max                  !! Maximum value of the clock ticker
      integer(I8B) :: count_start_main           !! Value of the clock ticker at when the timer is first called
      integer(I8B) :: count_start_step           !! Value of the clock ticker at the start of a timed step
      integer(I8B) :: count_stop_step            !! Value of the clock ticker at the end of a timed step
      integer(I8B) :: count_pause                !! Value of the clock ticker at the end of a timed step
      integer(I4B) :: nsubsteps                  !! Number of substeps in an interval (number of times the timer is turned off and back on again)
      real(DP)     :: wall_step                  !! Value of the step elapsed time
      real(DP)     :: wall_main                  !! Value of the main clock elapsed time
      real(DP)     :: wall_per_substep           !! Value of time per substep 
      logical      :: main_is_started = .false. !! Logical flag indicating whether or not the main timer has been reset or not
      logical      :: is_paused = .false. !! Logical flag indicating whether or not the timer is paused

   contains
      procedure :: reset       => walltime_reset      !! Resets the clock ticker, settting main_start to the current ticker value
      procedure :: start       => walltime_start      !! Starts or resumes the step timer
      procedure :: start_main  => walltime_start_main !! Starts the main timer
      procedure :: stop        => walltime_stop       !! Pauses the step timer
      procedure :: report      => walltime_report     !! Prints the elapsed time information to the terminal
   end type walltimer


   interface
      module subroutine walltime_report(self, message, unit)
         implicit none
         class(walltimer),           intent(inout) :: self      !! Walltimer object
         character(len=*),           intent(in)    :: message   !! Message to prepend to the wall time terminal output
         integer(I4B),               intent(in)    :: unit      !! Output file unit for report text to be directed
      end subroutine walltime_report

      module subroutine walltime_reset(self)
         implicit none
         class(walltimer),           intent(inout) :: self  !! Walltimer object
      end subroutine walltime_reset 

      module subroutine walltime_start(self)
         implicit none
         class(walltimer),           intent(inout) :: self  !! Walltimer object
      end subroutine walltime_start

      module subroutine walltime_start_main(self)
         implicit none
         class(walltimer),           intent(inout) :: self  !! Walltimer object
      end subroutine walltime_start_main

      module subroutine walltime_stop(self)
         implicit none
         class(walltimer),           intent(inout) :: self  !! Walltimer object
      end subroutine walltime_stop
   end interface

end module walltime

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(whm) whm_drift
   use swiftest
contains

   module subroutine whm_drift_pl(self, nbody_system, param, dt)
      !! author: David A. Minton
      !!
      !! Loop through planets and call Danby drift routine
      !!
      !! Adapted from Hal Levison's Swift routine drift.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_drift.f90
      implicit none
      ! Arguments
      class(whm_pl),                 intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_nbody_system),  intent(inout) :: nbody_system !! WHM nbody system object
      class(swiftest_parameters),    intent(in)    :: param  !! Current run configuration parameters 
      real(DP),                      intent(in)    :: dt     !! Stepsize
      ! Internals
      integer(I4B)                              :: i
      integer(I4B), dimension(:), allocatable   :: iflag
      character(len=STRMAX) :: message

      if (self%nbody == 0) return

      associate(pl => self, npl => self%nbody)
         allocate(iflag(npl))
         iflag(:) = 0
         call swiftest_drift_all(pl%muj, pl%xj, pl%vj, npl, param, dt, pl%lmask, iflag)
         if (any(iflag(1:npl) /= 0)) then
            where(iflag(1:npl) /= 0) 
               pl%status(1:npl) = DISCARDED_DRIFTERR
               pl%lmask(1:npl) = .false.
            end where
            do i = 1, npl
               if (iflag(i) /= 0) then 
                  write(message, *) " Planet ", pl%id(i), " is lost!!!!!!!!!!!!",new_line('A'), &
                                      pl%muj(i), dt, new_line('A'), &
                                      pl%xj(:,i),new_line('A'), &
                                      pl%vj(:,i),new_line('A'), &
                                    " STOPPING "
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, message)
               end if
            end do
            call base_util_exit(FAILURE,param%display_unit)
         end if
      end associate

      return
   end subroutine whm_drift_pl

end submodule whm_drift

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (collision) s_collision_resolve
   use swiftest
contains

   module subroutine collision_resolve_consolidate_impactors(self, nbody_system, param, idx_parent, lflag)
      !! author: David A. Minton
      !! 
      !! Loops through the pl-pl collision list and groups families together by index. Outputs the indices of all impactors%id 
      !! members, and pairs of quantities (x and v vectors, mass, radius, L_spin, and Ip) that can be used to resolve the 
      !! collisional outcome.
      implicit none
      ! Arguments
      class(collision_impactors),intent(out) :: self !! Collision impactors object
      class(base_nbody_system),intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters), intent(in) :: param !! Current run configuration parameters with Swiftest additions
      integer(I4B), dimension(:), intent(inout) :: idx_parent !! Index of the two bodies considered the "parents" of the collision
      logical, intent(out) :: lflag !! Logical flag indicating whether a impactors%id was successfully created or not
      ! Internals
      type collidx_array
         integer(I4B), dimension(:), allocatable :: id
         integer(I4B), dimension(:), allocatable :: idx
      end type collidx_array
      type(collidx_array), dimension(2) :: parent_child_index_array
      integer(I4B), dimension(2)       :: nchild
      integer(I4B)                     :: i, j, nimpactors, idx_child
      real(DP), dimension(2)           :: volume, density
      real(DP)                         :: mchild, volchild, rrel_mag, rlim, mtot, vdotr
      real(DP), dimension(NDIM)        :: xc, vc, xcom, vcom, xchild, vchild, xcrossv, rrel, vrel, rrel_unit, vrel_unit, dr
      real(DP), dimension(NDIM,2)      :: mxc, vcc

      select type(nbody_system)
      class is (swiftest_nbody_system)
         associate(impactors => self, pl => nbody_system%pl, cb => nbody_system%cb)

            nchild(:) = pl%kin(idx_parent(:))%nchild 
            ! If all of these bodies share a parent, but this is still a unique collision, move the last child
            ! out of the parent's position and make it the secondary body
            if (idx_parent(1) == idx_parent(2)) then
               if (nchild(1) == 0) then ! There is only one valid body recorded in this pair (this could happen due to restructuring
                                        ! of the kinship relationships, though it should be rare)
                  lflag = .false. 
                  call pl%reset_kinship([idx_parent(1)])
                  return
               end if
               idx_parent(2) = pl%kin(idx_parent(1))%child(nchild(1))
               nchild(1) = nchild(1) - 1
               nchild(2) = 0
               pl%kin(idx_parent(:))%nchild = nchild(:)
               pl%kin(idx_parent(2))%parent = idx_parent(1)
            end if

            impactors%Gmass(:) = pl%Gmass(idx_parent(:)) 
            impactors%mass(:)  = pl%mass(idx_parent(:)) 
            impactors%radius(:) = pl%radius(idx_parent(:))
            volume(:) =  (4.0_DP / 3.0_DP) * PI * impactors%radius(:)**3
      
            ! Group together the ids and indexes of each collisional parent and its children
            do j = 1, 2
               allocate(parent_child_index_array(j)%idx(nchild(j)+ 1))
               allocate(parent_child_index_array(j)%id(nchild(j)+ 1))
               associate(idx_arr => parent_child_index_array(j)%idx, &
                        id_arr => parent_child_index_array(j)%id, &
                        ncj => nchild(j), &
                        plkinj => pl%kin(idx_parent(j)))
                  idx_arr(1) = idx_parent(j)
                  if (ncj > 0) idx_arr(2:ncj + 1) = plkinj%child(1:ncj)
                  id_arr(:) = pl%id(idx_arr(:))
               end associate
            end do

            ! Consolidate the groups of collsional parents with any children they may have into a single "impactors%id" index array
            nimpactors = 2 + sum(nchild(:))
            allocate(impactors%id(nimpactors))
            impactors%id = [parent_child_index_array(1)%idx(:),parent_child_index_array(2)%idx(:)]

            impactors%ncoll = count(pl%lcollision(impactors%id(:)))
            impactors%id = pack(impactors%id(:), pl%lcollision(impactors%id(:)))
            impactors%L_spin(:,:) = 0.0_DP
            impactors%Ip(:,:) = 0.0_DP

            ! Find the barycenter of each body along with its children, if it has any
            do j = 1, 2
               impactors%rb(:, j)  = pl%rh(:, idx_parent(j)) + cb%rb(:)
               impactors%vb(:, j)  = pl%vb(:, idx_parent(j))
               ! Assume principal axis rotation about axis corresponding to highest moment of inertia (3rd Ip)
               if (param%lrotation) then
                  impactors%Ip(:, j) = impactors%mass(j) * pl%Ip(:, idx_parent(j))
                  impactors%L_spin(:, j) = impactors%Ip(3, j) * impactors%radius(j)**2 * pl%rot(:, idx_parent(j))
               end if

               if (nchild(j) > 0) then
                  do i = 1, nchild(j) ! Loop over all children and take the mass weighted mean of the properties
                     idx_child = parent_child_index_array(j)%idx(i + 1)
                     if (.not. pl%lcollision(idx_child)) cycle
                     mchild = pl%mass(idx_child)
                     xchild(:) = pl%rh(:, idx_child) + cb%rb(:)
                     vchild(:) = pl%vb(:, idx_child)
                     volchild = (4.0_DP / 3.0_DP) * PI * pl%radius(idx_child)**3
                     volume(j) = volume(j) + volchild
                     ! Get angular momentum of the child-parent pair and add that to the spin
                     ! Add the child's spin
                     if (param%lrotation) then
                        xcom(:) = (impactors%mass(j) * impactors%rb(:,j) + mchild * xchild(:)) / (impactors%mass(j) + mchild)
                        vcom(:) = (impactors%mass(j) * impactors%vb(:,j) + mchild * vchild(:)) / (impactors%mass(j) + mchild)
                        xc(:) = impactors%rb(:, j) - xcom(:)
                        vc(:) = impactors%vb(:, j) - vcom(:)
                        xcrossv(:) = xc(:) .cross. vc(:) 
                        impactors%L_spin(:, j) = impactors%L_spin(:, j) + impactors%mass(j) * xcrossv(:)
         
                        xc(:) = xchild(:) - xcom(:)
                        vc(:) = vchild(:) - vcom(:)
                        xcrossv(:) = xc(:) .cross. vc(:) 
                        impactors%L_spin(:, j) = impactors%L_spin(:, j) + mchild * xcrossv(:)

                        impactors%L_spin(:, j) = impactors%L_spin(:, j) + mchild * pl%Ip(3, idx_child)  &
                                                                                 * pl%radius(idx_child)**2 &
                                                                                 * pl%rot(:, idx_child)
                        impactors%Ip(:, j) = impactors%Ip(:, j) + mchild * pl%Ip(:, idx_child)
                     end if

                     ! Merge the child and parent
                     impactors%mass(j) = impactors%mass(j) + mchild
                     impactors%rb(:, j) = xcom(:)
                     impactors%vb(:, j) = vcom(:)
                  end do
               end if
               density(j) = impactors%mass(j) / volume(j)
               impactors%radius(j) = (3 * volume(j) / (4 * PI))**(1.0_DP / 3.0_DP)
               if (param%lrotation) then
                  impactors%Ip(:, j) = impactors%Ip(:, j) / impactors%mass(j)
                  impactors%rot(:,j) = impactors%L_spin(:, j) / (impactors%Ip(3,j) * impactors%mass(j) * impactors%radius(j)**2)
               end if
            end do
            lflag = .true.

            mtot = sum(impactors%mass(:))
            xcom(:) = (impactors%mass(1) * impactors%rb(:, 1) + impactors%mass(2) * impactors%rb(:, 2)) / mtot
            vcom(:) = (impactors%mass(1) * impactors%vb(:, 1) + impactors%mass(2) * impactors%vb(:, 2)) / mtot

            ! Shift the impactors so that they are not overlapping
            rlim = sum(impactors%radius(1:2))
            rrel = impactors%rb(:,2) - impactors%rb(:,1)
            rrel_mag = .mag. rrel 
            if (rrel_mag < rlim) then
               rrel_unit = .unit.rrel
               vrel = impactors%vb(:,2) - impactors%vb(:,1)
               vrel_unit = .unit.vrel
               vdotr = dot_product(vrel_unit, rrel)
               dr(:) = -(vdotr - sign(1.0_DP, vdotr) * sqrt(rlim**2 - rrel_mag**2 + vdotr**2)) * vrel_unit(:)
               dr(:) = (1.0_DP + 2*epsilon(1.0_DP)) * dr(:)
               impactors%rb(:,1) = impactors%rb(:,1) - dr(:) *  impactors%mass(2) / mtot
               impactors%rb(:,2) = impactors%rb(:,2) + dr(:) *  impactors%mass(1) / mtot
               rrel = impactors%rb(:,2) - impactors%rb(:,1)
               rrel_mag = .mag. rrel 
            end if

            mxc(:, 1) = impactors%mass(1) * (impactors%rb(:, 1) - xcom(:))
            mxc(:, 2) = impactors%mass(2) * (impactors%rb(:, 2) - xcom(:))
            vcc(:, 1) = impactors%vb(:, 1) - vcom(:)
            vcc(:, 2) = impactors%vb(:, 2) - vcom(:)
            impactors%L_orbit(:,:) = mxc(:,:) .cross. vcc(:,:)

            ! Destroy the kinship relationships for all members of this impactors%id
            call pl%reset_kinship(impactors%id(:))

         end associate
      end select
      return
   end subroutine collision_resolve_consolidate_impactors


   module subroutine collision_resolve_extract_plpl(self, nbody_system, param)
      !! author: David A. Minton
      !! 
      !! Processes the pl-pl encounter list remove only those encounters that led to a collision
      !!
      implicit none
      ! Arguments
      class(collision_list_plpl), intent(inout) :: self         !! pl-pl encounter list
      class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),     intent(in)    :: param        !! Current run configuration parameters
      ! Internals
      logical,      dimension(:), allocatable :: lplpl_collision
      logical,      dimension(:), allocatable :: lplpl_unique_parent
      integer(I4B), dimension(:), pointer     :: plparent
      integer(I4B)                            :: nunique_parent
      integer(I8B)                            :: ncollisions, index_coll, k, nplplenc
      integer(I8B), dimension(:), allocatable :: unique_parent_idx, collision_idx

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type (pl => nbody_system%pl)
      class is (swiftest_pl)
         associate(idx1 => self%index1, idx2 => self%index2, plparent => pl%kin%parent)
            nplplenc = self%nenc
            allocate(lplpl_collision(nplplenc))
            lplpl_collision(:) = self%status(1_I8B:nplplenc) == COLLIDED
            if (.not.any(lplpl_collision)) return 
            ! Collisions have been detected in this step. So we need to determine which of them are between unique bodies.

            ! Get the subset of pl-pl encounters that lead to a collision
            ncollisions = count(lplpl_collision(:))
            allocate(collision_idx(ncollisions))
            collision_idx = pack([(k, k=1_I8B, nplplenc)], lplpl_collision)

            ! Get the subset of collisions that involve a unique pair of parents
            allocate(lplpl_unique_parent(ncollisions))

            lplpl_unique_parent(:) = plparent(idx1(collision_idx(:))) /= plparent(idx2(collision_idx(:)))
            nunique_parent = count(lplpl_unique_parent(:))
            allocate(unique_parent_idx(nunique_parent))
            unique_parent_idx = pack(collision_idx(:), lplpl_unique_parent(:))

            ! Scrub all pl-pl collisions involving unique pairs of parents, which will remove all duplicates and leave behind
            ! all pairs that have themselves as parents but are not part of the unique parent list. This can happen in rare cases
            ! due to restructuring of parent/child relationships when there are large numbers of multi-body collisions in a single
            ! step
            lplpl_unique_parent(:) = .true.
            do index_coll = 1_I8B, ncollisions
               associate(ip1 => plparent(idx1(collision_idx(index_coll))), ip2 => plparent(idx2(collision_idx(index_coll))))
                  lplpl_unique_parent(:) = .not. ( any(plparent(idx1(unique_parent_idx(:))) == ip1) .or. &
                                                   any(plparent(idx2(unique_parent_idx(:))) == ip1) .or. &
                                                   any(plparent(idx1(unique_parent_idx(:))) == ip2) .or. &
                                                   any(plparent(idx2(unique_parent_idx(:))) == ip2) )
               end associate
            end do

            ! Reassemble collision index list to include only those containing the unique pairs of parents, plus all the non-unique
            ! pairs that don't contain a parent body on the unique parent list.
            ncollisions = nunique_parent + count(lplpl_unique_parent)
            collision_idx = [unique_parent_idx(:), pack(collision_idx(:), lplpl_unique_parent(:))]

            ! Create a mask that contains only the pl-pl encounters that did not result in a collision, and then discard them
            lplpl_collision(:) = .false.
            lplpl_collision(collision_idx(:)) = .true.
            ! Extract any encounters that are not collisions from the list.
            call self%spill(nbody_system%plpl_collision, lplpl_collision, ldestructive=.true.) 
         end associate
      end select
      end select

      return
   end subroutine collision_resolve_extract_plpl


   module subroutine collision_resolve_extract_pltp(self, nbody_system, param)
      implicit none
      class(collision_list_pltp), intent(inout) :: self   !! pl-tp encounter list
      class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),     intent(in)    :: param  !! Current run configuration parameters
      ! Internals
      logical,      dimension(:), allocatable :: lpltp_collision
      integer(I8B)                            :: ncollisions, index_coll, k, npltpenc
      integer(I8B), dimension(:), allocatable :: collision_idx

      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type (pl => nbody_system%pl)
      class is (swiftest_pl)
      select type (tp => nbody_system%tp)
      class is (swiftest_tp)
         associate(idx1 => self%index1, idx2 => self%index2)
            npltpenc = self%nenc
            allocate(lpltp_collision(npltpenc))
            lpltp_collision(:) = self%status(1_I8B:npltpenc) == COLLIDED
            if (.not.any(lpltp_collision)) return 
            ! Collisions have been detected in this step. So we need to determine which of them are between unique bodies.

            ! Get the subset of pl-tp encounters that lead to a collision
            ncollisions = count(lpltp_collision(:))
            allocate(collision_idx(ncollisions))
            collision_idx = pack([(k, k=1_I8B, npltpenc)], lpltp_collision)

            ! Create a mask that contains only the pl-tp encounters that did not result in a collision, and then discard them
            lpltp_collision(:) = .false.
            lpltp_collision(collision_idx(:)) = .true.
            ! Extract any encounters that are not collisions from the list.
            call self%spill(nbody_system%pltp_collision, lpltp_collision, ldestructive=.true.) 
         end associate
      end select
      end select
      end select


      return
   end subroutine collision_resolve_extract_pltp


   module subroutine collision_resolve_make_impactors_pl(pl, idx)
      !! author: Jennifer L.L. Pouplin, Carlisle A. wishard, and David A. Minton
      !!
      !! When a single body is involved in more than one collision in a single step, it becomes part of a collision family
      !! The largest body involved in a multi-body collision is the "parent" and all bodies that collide with it are its "children,"
      !! including those that collide with the children.
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine swiftest_merge_pl.f90
      !!
      !! Adapted from Hal Levison's Swift routine symba5_merge.f
      implicit none
      ! Arguments
      class(base_object),           intent(inout) :: pl !! Swiftest massive body object
      integer(I4B), dimension(:), intent(in)      :: idx  !! Array holding the indices of the two bodies involved in the collision
      ! Internals
      integer(I4B)                              :: i, j, index_parent, index_child, p1, p2
      integer(I4B)                              :: nchild_inherit, nchild_orig, nchild_new
      integer(I4B), dimension(:), allocatable   :: temp

      select type(pl)
      class is (swiftest_pl)

         p1 = pl%kin(idx(1))%parent
         p2 = pl%kin(idx(2))%parent
         if (p1 == p2) return ! This is a collision between to children of a shared parent. We will ignore it.

         if (pl%mass(p1) > pl%mass(p2)) then
            index_parent = p1
            index_child = p2
         else
            index_parent = p2
            index_child = p1
         end if

         ! Expand the child array (or create it if necessary) and copy over the previous lists of children
         nchild_orig = pl%kin(index_parent)%nchild
         nchild_inherit = pl%kin(index_child)%nchild
         nchild_new = nchild_orig + nchild_inherit + 1
         allocate(temp(nchild_new))

         if (nchild_orig > 0) temp(1:nchild_orig) = pl%kin(index_parent)%child(1:nchild_orig)
         ! Find out if the child body has any children of its own. The new parent wil inherit these children
         if (nchild_inherit > 0) then
            temp(nchild_orig+1:nchild_orig+nchild_inherit) = pl%kin(index_child)%child(1:nchild_inherit)
            do i = 1, nchild_inherit
               j = pl%kin(index_child)%child(i)
               ! Set the childrens' parent to the new parent
               pl%kin(j)%parent = index_parent
            end do
         end if
         call pl%reset_kinship([index_child])
         ! Add the new child to its parent
         pl%kin(index_child)%parent = index_parent
         temp(nchild_new) = index_child
         ! Save the new child array to the parent
         pl%kin(index_parent)%nchild = nchild_new
         call move_alloc(from=temp, to=pl%kin(index_parent)%child)
      end select

      return
   end subroutine collision_resolve_make_impactors_pl


   module subroutine collision_resolve_mergeaddsub(nbody_system, param, t, status)
      !! author:  David A. Minton
      !!
      !! Fills the pl_discards and pl_adds with removed and added bodies
      !!  
      use symba, only : symba_pl
      implicit none
      ! Arguments
      class(base_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),   intent(inout) :: param        !! Current run configuration parameters with Swiftest additions
      real(DP),                 intent(in)    :: t            !! Time of collision
      integer(I4B),             intent(in)    :: status       !! Status flag to assign to adds
      ! Internals
      integer(I4B) :: i, ibiggest, ismallest, iother, nimpactors, nfrag, nameidx
      logical, dimension(:), allocatable  :: lmask
      class(swiftest_pl), allocatable :: plnew, plsub
      character(*), parameter :: FRAGFMT = '("Newbody",I0.7)'
      character(*), parameter :: MERGEFMT = '(A,I0.7)'
      character(*), parameter :: MERGE_PREPEND_TEXT = "_MERGE"
      integer(I4B) :: merge_text_length 
      character(len=NAMELEN) :: merge_text
      character(len=NAMELEN) :: newname, origin_type
      real(DP) :: volume
  
      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(param)
      class is (swiftest_parameters)
         associate(pl => nbody_system%pl, pl_discards => nbody_system%pl_discards, info => nbody_system%pl%info, &
                   pl_adds => nbody_system%pl_adds, cb => nbody_system%cb, collider => nbody_system%collider,  &
                   impactors => nbody_system%collider%impactors,fragments => nbody_system%collider%fragments)

            ! Add the impactors%id bodies to the subtraction list
            nimpactors = impactors%ncoll
            nfrag = fragments%nbody

            ! Setup new bodies
            allocate(plnew, mold=pl)
            call plnew%setup(nfrag, param)
            ibiggest  = impactors%id(maxloc(pl%Gmass(impactors%id(:)), dim=1))
            ismallest = impactors%id(minloc(pl%Gmass(impactors%id(:)), dim=1))

            ! Copy over identification, information, and physical properties of the new bodies from the fragment list
            plnew%id(1:nfrag) = fragments%id(1:nfrag) 
            plnew%rb(:, 1:nfrag) = fragments%rb(:, 1:nfrag) 
            plnew%vb(:, 1:nfrag) = fragments%vb(:, 1:nfrag)
            plnew%status(1:nfrag) = ACTIVE
            call plnew%b2h(cb)
            plnew%mass(1:nfrag) = fragments%mass(1:nfrag)
            plnew%Gmass(1:nfrag) = param%GU * fragments%mass(1:nfrag)
            plnew%radius(1:nfrag) = fragments%radius(1:nfrag)
            if (allocated(pl%a)) call plnew%xv2el(cb)

            if (param%lrotation) then
               plnew%Ip(:, 1:nfrag) = fragments%Ip(:, 1:nfrag)
               plnew%rot(:, 1:nfrag) = fragments%rot(:, 1:nfrag)
            end if

            call plnew%set_rhill(cb)

            ! if (param%ltides) then
            !    plnew%Q = pl%Q(ibiggest)
            !    plnew%k2 = pl%k2(ibiggest)
            !    plnew%tlag = pl%tlag(ibiggest)
            ! end if

#ifdef DOCONLOC
            do concurrent(i = 1:nfrag) shared(plnew,fragments) local(volume)
#else
            do concurrent(i = 1:nfrag)
#endif
               volume = 4.0_DP/3.0_DP * PI * plnew%radius(i)**3
               plnew%density(i) = fragments%mass(i) / volume
            end do

            select case(status)
            case(SUPERCATASTROPHIC)
               plnew%status(1:nfrag) = NEW_PARTICLE
               do i = 1, nfrag
                  write(newname, FRAGFMT) fragments%id(i)
                  call plnew%info(i)%set_value(origin_type="Supercatastrophic", origin_time=t, name=newname, &
                                                origin_rh=plnew%rh(:,i), origin_vh=plnew%vh(:,i), &
                                                collision_id=collider%maxid_collision)
               end do
               do i = 1, nimpactors
                  if (impactors%id(i) == ibiggest) then
                     iother = ismallest
                  else
                     iother = ibiggest
                  end if
                  call pl%info(impactors%id(i))%set_value(status="Supercatastrophic", discard_time=t, &
                                                            discard_rh=pl%rh(:,i), discard_vh=pl%vh(:,i), &
                                                            discard_body_id=iother)
               end do
            case(DISRUPTED,HIT_AND_RUN_DISRUPT)
               if (status == DISRUPTED) then
                  write(origin_type,*) "Disruption"
               else if (status == HIT_AND_RUN_DISRUPT) then
                  write(origin_type,*) "Hit and run fragmentation"
               end if
               call plnew%info(1)%copy(pl%info(ibiggest))
               plnew%status(1) = OLD_PARTICLE
               do i = 2, nfrag
                  write(newname, FRAGFMT) fragments%id(i)
                  call plnew%info(i)%set_value(origin_type=origin_type, origin_time=t, name=newname, &
                                                origin_rh=plnew%rh(:,i), origin_vh=plnew%vh(:,i), &
                                                collision_id=collider%maxid_collision)
               end do
               do i = 1, nimpactors
                  if (impactors%id(i) == ibiggest) cycle
                  iother = ibiggest
                  call pl%info(impactors%id(i))%set_value(status=origin_type, discard_time=t, &
                                                            discard_rh=pl%rh(:,i), discard_vh=pl%vh(:,i), &
                                                            discard_body_id=iother)
               end do 
            case(MERGED)
               write(origin_type,*) "Merger"
               call plnew%info(1)%copy(pl%info(ibiggest))
               nbody_system%maxid = nbody_system%maxid + 1
               plnew%id(1) = nbody_system%maxid

               ! Appends an index number to the end of the original name to make it unique, but still identifiable as the original.
               ! If there is already an index number appended, replace it
               write(merge_text,MERGEFMT) MERGE_PREPEND_TEXT,plnew%id(1)
               merge_text_length = len(trim(adjustl(merge_text)))
               nameidx = index(plnew%info(1)%name, MERGE_PREPEND_TEXT) - 1
               if (nameidx < 0) nameidx = min(len(trim(adjustl(plnew%info(1)%name))), NAMELEN - merge_text_length)
               write(newname,*) trim(adjustl(plnew%info(1)%name(1:nameidx))) // trim(adjustl(merge_text))
               plnew%status(1) = NEW_PARTICLE
               call plnew%info(1)%set_value(origin_type=origin_type, origin_time=t, name=newname, &
                                            origin_rh=plnew%rh(:,1), origin_vh=plnew%vh(:,1), &
                                            collision_id=collider%maxid_collision)
               do i = 1, nimpactors
                  if (impactors%id(i) == ibiggest) cycle

                  iother = ibiggest
                  call pl%info(impactors%id(i))%set_value(status="MERGED", discard_time=t, discard_rh=pl%rh(:,i), &
                                                            discard_vh=pl%vh(:,i), discard_body_id=iother)
               end do 
            end select

            !Copy over or set integration parameters for new bodies
            plnew%lcollision(1:nfrag) = .false.
            plnew%ldiscard(1:nfrag) = .false.
            select type(pl)
            class is (symba_pl)
            select type(plnew)
            class is (symba_pl)
               plnew%levelg(1:nfrag) = pl%levelg(ibiggest)
               plnew%levelm(1:nfrag) = pl%levelm(ibiggest)
            end select
            end select

            plnew%lmtiny(1:nfrag) = plnew%Gmass(1:nfrag) < param%GMTINY
            where(plnew%lmtiny(1:nfrag))
               plnew%info(1:nfrag)%particle_type = PL_TINY_TYPE_NAME 
            elsewhere
               plnew%info(1:nfrag)%particle_type = PL_TYPE_NAME 
            end where

            ! Append the new merged body to the list 
            call pl_adds%append(plnew, lsource_mask=[(.true., i=1, nfrag)])

            ! Add the discarded bodies to the discard list
            pl%status(impactors%id(:)) = MERGED
            pl%ldiscard(impactors%id(:)) = .true.
            pl%lcollision(impactors%id(:)) = .true.
            allocate(lmask, mold=pl%lmask)
            lmask(:) = .false.
            lmask(impactors%id(:)) = .true.
            
            allocate(plsub, mold=pl)
            call pl%spill(plsub, lmask, ldestructive=.false.)

            ! call pl_discards%append(plsub, lsource_mask=[(.true., i = 1, nimpactors)])

            ! Save the before/after snapshots
            select type(before => collider%before)
            class is (swiftest_nbody_system)
               call move_alloc(plsub, before%pl)
            end select

            select type(after => collider%after)
            class is (swiftest_nbody_system)
               call move_alloc(plnew, after%pl)
            end select

         end associate

      end select
      end select 
   
      return
   end subroutine collision_resolve_mergeaddsub


   module subroutine collision_resolve_plpl(self, nbody_system, param, t, dt, irec)
      !! author: David A. Minton
      !! 
      !! Process the pl-pl collision list, then modifiy the massive bodies based on the outcome of the collision
      !! 
      implicit none
      ! Arguments
      class(collision_list_plpl), intent(inout) :: self   !! Swiftest pl-pl encounter list
      class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),     intent(inout) :: param  !! Current run configuration parameters with Swiftest additions
      real(DP),                   intent(in)    :: t      !! Current simulation time
      real(DP),                   intent(in)    :: dt     !! Current simulation step size
      integer(I4B),               intent(in)    :: irec   !! Current recursion level
      ! Internals
      real(DP) :: E_before, E_after, mnew
      real(DP), dimension(NDIM) ::L_before, L_after, dL
      logical :: lplpl_collision
      character(len=STRMAX) :: timestr, idstr
      integer(I4B), dimension(2) :: idx_parent       !! Index of the two bodies considered the "parents" of the collision
      logical  :: lgoodcollision
      integer(I4B) :: i, j, nnew, loop
      integer(I8B) :: k, ncollisions
      integer(I4B), dimension(:), allocatable :: idnew
      integer(I4B), parameter :: MAXCASCADE = 1000
  
      select type (nbody_system)
      class is (swiftest_nbody_system)
      select type(pl => nbody_system%pl)
      class is (swiftest_pl)
      select type(param)
      class is (swiftest_parameters)
         associate(plpl_collision => nbody_system%plpl_collision, &
                   collision_history => nbody_system%collision_history, pl => nbody_system%pl, cb => nbody_system%cb, &
                   collider => nbody_system%collider, fragments => nbody_system%collider%fragments, &
                   impactors => nbody_system%collider%impactors)
            if (plpl_collision%nenc == 0) return ! No collisions to resolve


            ! Make sure that the heliocentric and barycentric coordinates are consistent with each other
            call pl%vb2vh(nbody_system%cb) 
            call pl%rh2rb(nbody_system%cb)

            ! Get the energy before the collision is resolved
            if (param%lenergy) then
               call nbody_system%get_energy_and_momentum(param)
               E_before = nbody_system%te
               L_before(:) = nbody_system%L_total(:)
            end if

            do loop = 1, MAXCASCADE
               associate( idx1 => plpl_collision%index1, idx2 => plpl_collision%index2)
                  ncollisions = plpl_collision%nenc
                  write(timestr,*) t
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT,&
                                                            "***********************************************************" // &
                                                            "***********************************************************")
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Collision between massive bodies detected at time t = " // &
                                                            trim(adjustl(timestr)))
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, &
                                                            "***********************************************************" // &
                                                            "***********************************************************")

                  do k = 1_I8B, ncollisions
                     idx_parent(1) = pl%kin(idx1(k))%parent
                     idx_parent(2) = pl%kin(idx2(k))%parent
                     call impactors%consolidate(nbody_system, param, idx_parent, lgoodcollision)
                     if ((.not. lgoodcollision) .or. any(pl%status(idx_parent(:)) /= COLLIDED)) cycle

                     ! Advance the collision id number and save it
                     collider%maxid_collision = max(collider%maxid_collision, maxval(nbody_system%pl%info(:)%collision_id))
                     collider%maxid_collision = collider%maxid_collision + 1
                     collider%collision_id = collider%maxid_collision
                     write(idstr,*) collider%collision_id
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT, "collision_id " // trim(adjustl(idstr)))

                     ! Get the collision regime
                     call collider%get_regime(nbody_system, param)

                     call collision_history%take_snapshot(param,nbody_system, t, "before") 

                     ! Generate the new bodies resulting from the collision
                     call collider%generate(nbody_system, param, t)

                     call collision_history%take_snapshot(param,nbody_system, t, "after") 

                     plpl_collision%status(k) = collider%status
                     call impactors%dealloc()
                  end do

                  ! Destroy the collision list now that the collisions are resolved
                  call plpl_collision%setup(0_I8B)

                  if ((nbody_system%pl_adds%nbody == 0) .and. (.not.any(pl%ldiscard(:)))) exit
                  if (allocated(idnew)) deallocate(idnew)
                  nnew = nbody_system%pl_adds%nbody
                  allocate(idnew, source=nbody_system%pl_adds%id)
                  mnew = sum(nbody_system%pl_adds%mass(:))

                  ! Rearrange the arrays: Remove discarded bodies, add any new bodies, re-sort, and recompute all indices and 
                  ! encounter lists
                  call pl%rearray(nbody_system, param)

                  ! Destroy the add/discard list so that we don't append the same body multiple times if another collision 
                  ! is detected
                  call nbody_system%pl_discards%setup(0, param)
                  call nbody_system%pl_adds%setup(0, param)

                  if (param%lenergy) then
                     call nbody_system%get_energy_and_momentum(param)
                     L_after(:) = nbody_system%L_total(:)
                     dL = L_after(:) - L_before(:)

                     ! Add some velocity torque to the new bodies to remove residual angular momentum difference
                     do j = 1, nnew
                        i = findloc(pl%id,idnew(j),dim=1)
                        if (i == 0) cycle
                        call collision_util_velocity_torque(-dL * pl%mass(i)/mnew, pl%mass(i), pl%rb(:,i), pl%vb(:,i)) 
                     end do

                     call nbody_system%get_energy_and_momentum(param)
                     E_after = nbody_system%te
                     nbody_system%E_collisions = nbody_system%E_collisions + (E_after - E_before)
                     L_after(:) = nbody_system%L_total(:)
                     dL = L_after(:) - L_before(:)
                  end if


                  ! Check whether or not any of the particles that were just added are themselves in a collision state. This will 
                  ! generate a new plpl_collision 
                  call self%collision_check(nbody_system, param, t, dt, irec, lplpl_collision)

                  if (.not.lplpl_collision) exit
                  if (loop == MAXCASCADE) then
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT,"A runaway collisional cascade has been detected in " // &
                                                                        "collision_resolve_plpl.")
                     call swiftest_io_log_one_message(COLLISION_LOG_OUT,"Consider reducing the step size or changing the " // &
                                                                        "parameters in the collisional model to reduce the " // &
                                                                        "number of fragments.")
                     call base_util_exit(FAILURE,unit=param%display_unit)
                  end if
               end associate
            end do

         end associate
      end select
      end select
      end select

      return
   end subroutine collision_resolve_plpl


   module subroutine collision_resolve_pltp(self, nbody_system, param, t, dt, irec)
      !! author: David A. Minton
      !! 
      !! Process the pl-tp collision list, then modifiy the massive bodies based on the outcome of the collision
      !! 
      implicit none
      ! Arguments
      class(collision_list_pltp), intent(inout) :: self   !! Swiftest pl-pl encounter list
      class(base_nbody_system),   intent(inout) :: nbody_system !! Swiftest nbody system object
      class(base_parameters),     intent(inout) :: param  !! Current run configuration parameters with Swiftest additions
      real(DP),                   intent(in)    :: t      !! Current simulation tim
      real(DP),                   intent(in)    :: dt     !! Current simulation step size
      integer(I4B),               intent(in)    :: irec   !! Current recursion level
      ! Internals
      class(swiftest_pl), allocatable :: plsub
      class(swiftest_tp), allocatable :: tpsub
      logical :: lpltp_collision
      character(len=STRMAX) :: timestr, idstr
      integer(I4B) :: i, j, nnew, loop
      integer(I8B) :: k, ncollisions
      integer(I4B), dimension(:), allocatable :: idnew      
      logical, dimension(:), allocatable :: lmask
     
      ! Make sure coordinate systems are all synced up due to being inside the recursion at this point
      select type(nbody_system)
      class is (swiftest_nbody_system)
      select type(param)
      class is (swiftest_parameters)
         associate(pltp_collision => nbody_system%pltp_collision, &
            collision_history => nbody_system%collision_history, pl => nbody_system%pl, cb => nbody_system%cb, &
            tp => nbody_system%tp, collider => nbody_system%collider, impactors => nbody_system%collider%impactors)
            call pl%vb2vh(nbody_system%cb)
            call tp%vb2vh(nbody_system%cb%vb)
            call pl%b2h(nbody_system%cb)
            call tp%b2h(nbody_system%cb)

            ! Restructure the massive bodies based on the outcome of the collision
            call tp%rearray(nbody_system, param)

            ! Check for discards
            call nbody_system%tp%discard(nbody_system, param)

            associate(idx1 => pltp_collision%index1, idx2 => pltp_collision%index2)
               ncollisions = pltp_collision%nenc
               write(timestr,*) t
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, "")
               call swiftest_io_log_one_message(COLLISION_LOG_OUT,"***********************************************************" // &
                                                                  "***********************************************************")
               call swiftest_io_log_one_message(COLLISION_LOG_OUT, "Collision between test particle and massive body detected " // &
                                                                   "at time t = " // trim(adjustl(timestr)))
               call swiftest_io_log_one_message(COLLISION_LOG_OUT,"***********************************************************" // &
                                                                  "***********************************************************")

               do k = 1_I8B, ncollisions
                  ! Advance the collision id number and save it
                  collider%maxid_collision = max(collider%maxid_collision, maxval(nbody_system%pl%info(:)%collision_id))
                  collider%maxid_collision = collider%maxid_collision + 1
                  collider%collision_id = collider%maxid_collision
                  write(idstr,*) collider%collision_id
                  call swiftest_io_log_one_message(COLLISION_LOG_OUT, "collision_id " // trim(adjustl(idstr)))
                  collider%impactors%regime = COLLRESOLVE_REGIME_MERGE
                  allocate(lmask, mold=pl%lmask)
                  lmask(:) = .false.
                  lmask(idx1(k)) = .true.
                  
                  allocate(plsub, mold=pl)
                  call pl%spill(plsub, lmask, ldestructive=.false.)
      
                  ! Save the before snapshots
                  select type(before => collider%before)
                  class is (swiftest_nbody_system)
                     call move_alloc(plsub, before%pl)
                  end select

                  deallocate(lmask)
                  allocate(lmask, mold=tp%lmask)
                  lmask(:) = .false.
                  lmask(idx2(k)) = .true.
                  
                  allocate(tpsub, mold=tp)
                  call tp%spill(tpsub, lmask, ldestructive=.false.)
      
                  ! Save the before snapshots
                  select type(before => collider%before)
                  class is (swiftest_nbody_system)
                     call move_alloc(tpsub, before%tp)
                  end select

                  call collision_history%take_snapshot(param,nbody_system, t, "particle") 

                  call impactors%dealloc()
               end do

               ! Destroy the collision list now that the collisions are resolved
               call pltp_collision%setup(0_I8B)

            end associate

         end associate
      end select
      end select

      return
   end subroutine collision_resolve_pltp

end submodule s_collision_resolve

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (whm) s_whm_coord
   use swiftest
contains

   module subroutine whm_coord_h2j_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert from heliocentric to Jacobi coordinates, massive bodies only
      !!
      !! Uses pre-computed eta rather than computing it each time
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_h2j.f90 
      !!
      !! Adapted from Hal Levison's Swift routine coord_h2j.f 
      implicit none
      ! Arguments
      class(whm_pl),         intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_cb),    intent(inout) :: cb     !! Swiftest central body particle data structuree
      ! Internals
      integer(I4B)                                 :: i
      real(DP), dimension(NDIM)                    :: sumx, sumv, cap, capv

      if (self%nbody == 0) return

      associate(npl => self%nbody, GMpl => self%Gmass, eta => self%eta, rh => self%rh, vh => self%vh, &
                xj => self%xj, vj => self%vj)
         xj(:, 1) = rh(:, 1)
         vj(:, 1) = vh(:, 1)
         sumx(:) = 0.0_DP
         sumv(:) = 0.0_DP
         do i = 2, npl
            sumx(:) = sumx(:) + GMpl(i - 1) * rh(:, i - 1)
            sumv(:) = sumv(:) + GMpl(i - 1) * vh(:, i - 1)
            cap(:) = sumx(:) / eta(i - 1)
            capv(:) = sumv(:) / eta(i - 1)
            xj(:, i) = rh(:, i) - cap(:)
            vj(:, i) = vh(:, i) - capv(:)
         end do
      end associate
    
      return
   end subroutine whm_coord_h2j_pl


   module subroutine whm_coord_j2h_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert from Jacobi to heliocentric coordinates, massive bodies only.
      !! 
      !! Uses pre-computed eta rather than computing it each time
      !!
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_j2h.f90 
      !!
      !! Adapted from Hal Levison's Swift routine coord_j2h.f 
      implicit none
      ! Arguments
      class(whm_pl),                 intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_cb),                 intent(inout) :: cb     !! Swiftest central body particle data structuree
      ! Internals
      integer(I4B)                                 :: i
      real(DP), dimension(NDIM)                    :: sumx, sumv

      if (self%nbody == 0) return

      associate(npl => self%nbody, GMpl => self%Gmass, eta => self%eta, rh => self%rh, vh => self%vh, &
                xj => self%xj, vj => self%vj)
         rh(:, 1) = xj(:, 1)
         vh(:, 1) = vj(:, 1)
         sumx(:) = 0.0_DP
         sumv(:) = 0.0_DP
         do i = 2, npl 
            sumx(:) = sumx(:) + GMpl(i - 1) * xj(:, i - 1) / eta(i - 1)
            sumv(:) = sumv(:) + GMpl(i - 1) * vj(:, i - 1) / eta(i - 1)
            rh(:, i) = xj(:, i) + sumx(:)
            vh(:, i) = vj(:, i) + sumv(:)
         end do
      end associate
    
      return
   end subroutine whm_coord_j2h_pl


   module subroutine whm_coord_vh2vj_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert from heliocentric to Jadcobi coordinates, massive body velocities only
      !! 
      !! Uses pre-computed eta rather than computing it each time
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_vh2vj.f90 
      !!
      !! Adapted from Hal Levison's Swift routine coord_vh2vj.f 
      implicit none
      ! Arguments
      class(whm_pl),                 intent(inout) :: self   !! WHM massive body particle data structure
      class(swiftest_cb),                 intent(inout) :: cb     !! Swiftest central body particle data structuree
      ! Internals
      integer(I4B)                                 :: i
      real(DP), dimension(NDIM)                    :: sumv, capv

      if (self%nbody == 0) return

      associate(npl => self%nbody, GMpl => self%Gmass, vh => self%vh, vj => self%vj, eta => self%eta)
         vj(:, 1) = vh(:, 1)
         sumv(:) = 0.0_DP
         do i = 2, npl
            sumv(:) = sumv(:) + GMpl(i - 1) * vh(:, i - 1)
            capv(:) = sumv(:) / eta(i - 1)
            vj(:, i) = vh(:, i) - capv(:)
         end do
      end associate
    
      return
   end subroutine whm_coord_vh2vj_pl

end submodule s_whm_coord

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 
submodule(swiftest) s_swiftest_driver
contains

   module subroutine swiftest_driver(integrator, param_file_name, display_style)

      !! author: David A. Minton
      !!
      !! Driver program for the Swiftest integrators. Unlike the earlier Swift and Swifter drivers, in Swiftest all integrators 
      !!    are run from this single program. 
      !!
      !! Adapted from Swifter by David E. Kaufmann's Swifter driver programs swifter_[bs,helio,ra15,rmvs,symba,tu4,whm].f90
      !! Adapted from Hal Levison and Martin Duncan's Swift driver programs
      implicit none

      ! Arguments
      character(len=:), intent(in), allocatable :: integrator      !! Symbolic code of the requested integrator  
      character(len=:), intent(in), allocatable :: param_file_name !! Name of the input parameters file
      character(len=:), intent(in), allocatable :: display_style   !! Style of the output display 
                                                                   !! {"PROGRESS", "CLASSIC", "COMPACT", "QUIET"}). 
                                                                   !! Default is "PROGRESS"   

      ! Internals
      class(swiftest_nbody_system), allocatable :: nbody_system !! Polymorphic object containing the nbody system to be integrated
      type(swiftest_parameters)                 :: param             !! Run configuration parameters
      class(swiftest_storage),      allocatable :: system_history    !! Stores the system history between output dumps
      type(walltimer)                           :: integration_timer !! Object used for computing elapsed wall time
      !> Read in the user-defined parameters file and the initial conditions of the nbody_system
      param%integrator = trim(adjustl(integrator))
      param%display_style = trim(adjustl(display_style))
      call param%read_in(param_file_name)
#ifdef COARRAY  
      if (.not.param%lcoarray .and. (this_image() /= 1)) stop ! Single image mode
      sync all
#endif

      associate(t0       => param%t0, &
         tstart          => param%tstart, &
         dt              => param%dt, &
         tstop           => param%tstop, &
         iloop           => param%iloop, &
         istart          => param%istart, &
         iout            => param%iout, &
         idump           => param%idump, &
         nout            => param%nout, &
         istep           => param%istep, &
         nloops          => param%nloops, &
         istep_out       => param%istep_out, &
         fstep_out       => param%fstep_out, &
         ltstretch       => param%ltstretch, &
         dump_cadence    => param%dump_cadence, &
         display_unit    => param%display_unit)

         ! Set up loop and output cadence variables
         nloops = ceiling((tstop - t0) / dt, kind=I8B)
         istart =  ceiling((tstart - t0) / dt + 1.0_DP, kind=I8B)
         iloop = istart - 1
         iout = 0
         idump = 0
         if (ltstretch) then
            nout = floor(log(1.0_DP + iloop * (fstep_out - 1.0_DP) / istep_out) / log(fstep_out)) 
            istep = floor(istep_out * fstep_out**nout, kind=I4B)
         else
            nout = 1
            istep = istep_out
         end if

         ! Set up nbody_system storage for intermittent file dumps
         if (dump_cadence == 0) dump_cadence = int(ceiling(nloops / (1.0_DP * istep_out), kind=I8B), kind=I4B)

         ! Construct the main n-body nbody_system using the user-input integrator to choose the type of nbody_system
         call swiftest_util_setup_construct_system(nbody_system, param)

         !> Define the maximum number of threads
         nthreads = 1            ! In the *serial* case
         !$ nthreads = omp_get_max_threads() ! In the *parallel* case
#ifdef COARRAY
         if (this_image() == 1 .or. param%log_output) then
#endif 
            !$ write(param%display_unit,'(a)')   ' OpenMP parameters:'
            !$ write(param%display_unit,'(a)')   ' ------------------'
            !$ write(param%display_unit,'(a,i3,/)') ' Number of threads = ', nthreads 
#ifdef COARRAY
            if (this_image() ==1) then
#endif
               !$ if (param%log_output.and.(param%display_style /= "QUIET")) then
               !$    write(*,'(a,i3)') ' OpenMP: Number of threads = ',nthreads
               !$ end if
#ifdef COARRAY
            end if
            if (param%lcoarray) then
               write(param%display_unit,*)   ' Coarray parameters:'
               write(param%display_unit,*)   ' -------------------'
               write(param%display_unit,*) ' Number of images = ', num_images()
               if (param%log_output .and. (this_image() == 1) .and. (param%display_style /= "QUIET")) then
                  write(*,'(a,i3)') ' Coarray: Number of images = ',num_images()
               end if
            else
               write(param%display_unit,*)   ' Coarrays disabled.'
               if (param%log_output) write(*,*)   ' Coarrays disabled.'
            end if
         end if
#endif 
         if (param%log_output) flush(param%display_unit)

#ifdef COARRAY  
         ! The following line lets us read in the input files one image at a time. Letting each image read the input in is faster 
         ! than broadcasting all of the data
         if (param%lcoarray) then
            if (this_image() > 1) sync images(this_image() - 1)
         end if
#endif 
         call nbody_system%initialize(system_history, param)
         nbody_system%t = t0 + iloop * dt
#ifdef COARRAY  
         if (param%lcoarray .and. (this_image() < num_images())) sync images(this_image() + 1)

         ! Distribute test particles to the various images
         if (param%lcoarray) call nbody_system%coarray_distribute(param)
#endif

         ! If this is a new run, compute energy initial conditions (if energy tracking is turned on) and write the initial 
         ! conditions to file.
         call nbody_system%display_run_information(param, integration_timer, phase="first")

         if (param%lenergy) then
            if (param%lrestart) then
               call nbody_system%get_t0_values(system_history%nc, param)
            else
               call nbody_system%conservation_report(param, lterminal=.false.) ! This will save the initial values of energy and 
                                                                               ! momentum
            end if
            call nbody_system%conservation_report(param, lterminal=.true.)
         end if

         call system_history%take_snapshot(param,nbody_system)
         call nbody_system%dump(param, system_history)


         do iloop = istart, nloops
            !> Step the nbody_system forward in time
            call integration_timer%start()
            call nbody_system%step(param, nbody_system%t, dt)
            call integration_timer%stop()

            nbody_system%t = t0 + iloop * dt

            !> Evaluate any discards or collisional outcomes
            call nbody_system%discard(param)

            !> If the loop counter is at the output cadence value, append the data file with a single frame
            if (istep_out > 0) then
               iout = iout + 1
               if ((iout == istep) .or. (iloop == nloops)) then
                  iout = 0
                  idump = idump + 1
                  if (ltstretch) then 
                     nout = nout + 1
                     istep = floor(istep_out * fstep_out**nout, kind=I4B)
                  end if

#ifdef COARRAY
                  if (this_image() == 1 .or. param%log_output) then
#endif
                     call integration_timer%report(message="Integration steps:", unit=display_unit)
#ifdef COARRAY  
                  end if 
#endif
                  call nbody_system%display_run_information(param, integration_timer)
                  call integration_timer%reset()
#ifdef COARRAY
                  if (this_image() == 1 .or. param%log_output) then
#endif
                     if (param%lenergy) call nbody_system%conservation_report(param, lterminal=.true.)
#ifdef COARRAY
                  end if 
#endif

                  call system_history%take_snapshot(param,nbody_system)

                  if (idump == dump_cadence) then
                     idump = 0
                     call nbody_system%dump(param, system_history)
#ifdef COARRAY
                     if (param%lcoarray) call nbody_system%coarray_balance(param)
#endif
                  end if
               end if
            end if

         end do
         ! Dump any remaining history if it exists
         call nbody_system%dump(param, system_history)
         call nbody_system%display_run_information(param, integration_timer, phase="last")
      end associate
   return
   end subroutine swiftest_driver

end submodule s_swiftest_driver

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (netcdf_io) s_netcdf_io_implementations
   use netcdf
contains

   module subroutine netcdf_io_check(status, call_identifier)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Checks the status of all NetCDF operations to catch errors
      implicit none
      ! Arguments
      integer, intent (in) :: status 
         !! The status code returned by a NetCDF function
      character(len=*), intent(in), optional :: call_identifier 
         !! String that indicates which calling function caused the error for diagnostic purposes

      if(status /= NF90_NOERR) then
         if (present(call_identifier)) write(*,*) "NetCDF error in ",trim(call_identifier)
         write(*,*) trim(nf90_strerror(status))
         call base_util_exit(FAILURE)
      end if

      return
   end subroutine netcdf_io_check


   module subroutine netcdf_io_close(self)
      !! author: Carlisle A. Wishard, Dana Singh, and David A. Minton
      !!
      !! Closes a NetCDF file
      implicit none
      ! Arguments
      class(netcdf_parameters),   intent(inout) :: self   !! Parameters used to identify a particular NetCDF dataset
      character(namelen) :: message

      if (self%lfile_is_open) then
#ifdef COARRAY
         write(message,*) this_image()
         message = "netcdf_io_close on image " // trim(adjustl(message))
#else
         message = "netcdf_io_close"
#endif
         call netcdf_io_check( nf90_close(self%id), message)
         self%lfile_is_open = .false.
      end if

      return
   end subroutine netcdf_io_close


   module subroutine netcdf_io_find_tslot(self, t, tslot)
      !! author: David A. Minton
      !! 
      !! Given an open NetCDF file and a value of time t, finds the index of the time value (aka the time slot) to place a new set 
      !! of data.  The returned value of tslot will correspond to the first index value where the value of t is greater than or 
      !! equal to the saved time value.
      use, intrinsic :: ieee_exceptions
      use, intrinsic :: ieee_arithmetic
      implicit none
      ! Arguments
      class(netcdf_parameters), intent(inout) :: self  !! Parameters used to identify a particular NetCDF dataset
      real(DP),                 intent(in)    :: t     !! The value of time to search for
      integer(I4B),             intent(out)   :: tslot !! The index of the time slot where this data belongs
      ! Internals
      real(DP), dimension(:), allocatable :: tvals
      integer(I4B) :: i
      logical, dimension(size(IEEE_ALL))      :: fpe_halting_modes

      call ieee_get_halting_mode(IEEE_ALL,fpe_halting_modes)  ! Save the current halting modes so we can turn them off temporarily
      call ieee_set_halting_mode(IEEE_ALL,.false.)

      if (.not.self%lfile_is_open) return
      tslot = 0

      call netcdf_io_check( nf90_inquire_dimension(self%id, self%time_dimid, self%time_dimname, len=self%max_tslot), &
                             "netcdf_io_find_tslot nf90_inquire_dimension max_tslot"  )
      if (self%max_tslot > 0) then
         allocate(tvals(self%max_tslot))
         call netcdf_io_check( nf90_get_var(self%id, self%time_varid, tvals(:), start=[1]), "netcdf_io_find_tslot get_var"  )
         where(.not.ieee_is_normal(tvals(:))) tvals(:) = huge(1.0_DP)
      else
         allocate(tvals(1))
         tvals(1) = huge(1.0_DP)
         self%max_tslot = 1
      end if

      tslot = 1
      do i = 1, self%max_tslot
         if (t <= tvals(tslot)) exit
         tslot = tslot + 1
      end do
      self%max_tslot = max(self%max_tslot, tslot)
      self%tslot = tslot

      call ieee_set_halting_mode(IEEE_ALL,fpe_halting_modes)

      return
   end subroutine netcdf_io_find_tslot


   module subroutine netcdf_io_find_idslot(self, id, idslot)
      !! author: David A. Minton
      !! 
      !! Given an open NetCDF file and a value of id, finds the index of the id value (aka the id slot) to place a new set of data.
      !! The returned value of idslot will correspond to the first index value where the value of id is greater than or equal to the
      !! saved id value.
      implicit none
      ! Arguments
      class(netcdf_parameters), intent(inout) :: self   !! Parameters used to identify a particular NetCDF dataset
      integer(I4B),             intent(in)    :: id     !! The value of id to search for
      integer(I4B),             intent(out)   :: idslot !! The index of the id slot where this data belongs
      ! Internals
      integer(I4B), dimension(:), allocatable :: idvals

      if (.not.self%lfile_is_open) return

      if (.not.allocated(self%idvals)) call self%get_idvals()
      self%max_idslot = size(self%idvals)
      idslot = id + 1 
      if (idslot > self%max_idslot) then

         ! Update the idvals array
         allocate(idvals(idslot))
         idvals(:) = NF90_FILL_INT 
         idvals(1:self%max_idslot) = self%idvals(1:self%max_idslot)
         idvals(idslot) = id
         call move_alloc(idvals, self%idvals) 
         self%max_idslot = idslot
      end if

      self%idslot = idslot

      return
   end subroutine netcdf_io_find_idslot


   module subroutine netcdf_io_get_idvals(self)
      !! author: David A. Minton
      !! 
      !! Gets a full list of id values 
      implicit none
      ! Arguments
      class(netcdf_parameters), intent(inout) :: self   
         !! Parameters used to identify a particular NetCDF dataset
      ! Internals

      if (.not.self%lfile_is_open) return

      if (allocated(self%idvals)) deallocate(self%idvals)
      call netcdf_io_check( nf90_inquire_dimension(self%id, self%name_dimid, self%name_dimname, len=self%max_idslot), &
                           "netcdf_io_find_tslot nf90_inquire_dimension max_tslot"  )
      if (self%max_idslot > 0) then
         allocate(self%idvals(self%max_idslot))
         call netcdf_io_check( nf90_get_var(self%id, self%id_varid, self%idvals(:), start=[1]), "netcdf_io_find_idslot get_var" )
      else
         allocate(self%idvals(1))
         self%idvals(1) = 0
      end if

      return
   end subroutine netcdf_io_get_idvals


   module subroutine netcdf_io_sync(self)
      !! author: David A. Minton
      !!
      !! Syncrhonize the disk and memory buffer of the NetCDF file (e.g. commit the frame files stored in memory to disk) 
      !!    
      implicit none
      ! Arguments
      class(netcdf_parameters), intent(inout) :: self !! Parameters used to identify a particular NetCDF dataset

      call netcdf_io_check( nf90_sync(self%id), "netcdf_io_sync nf90_sync"  )

      return
   end subroutine netcdf_io_sync



end submodule s_netcdf_io_implementations

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(whm) s_whm_util
   use swiftest
contains

   module subroutine whm_util_append_pl(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one massive body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      !! Arguments
      class(whm_pl),                   intent(inout) :: self         
         !! WHM massive body object
      class(swiftest_body),            intent(in)    :: source       
         !! Source object to append
      logical, dimension(:),           intent(in)    :: lsource_mask 
         !! Logical mask indicating which elements to append to

      select type(source)
      class is (whm_pl)
         call util_append(self%eta, source%eta, lsource_mask=lsource_mask)
         call util_append(self%muj, source%muj, lsource_mask=lsource_mask)
         call util_append(self%ir3j, source%ir3j, lsource_mask=lsource_mask)
         call util_append(self%xj, source%xj, lsource_mask=lsource_mask)
         call util_append(self%vj, source%vj, lsource_mask=lsource_mask)

         call swiftest_util_append_pl(self, source, lsource_mask)
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class whm_pl or its descendents"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine whm_util_append_pl


   module subroutine whm_util_dealloc_pl(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Arguments
      class(whm_pl),  intent(inout) :: self 
         !! WHM massive body object

      if (allocated(self%eta)) deallocate(self%eta)
      if (allocated(self%muj)) deallocate(self%muj)
      if (allocated(self%xj)) deallocate(self%xj)
      if (allocated(self%vj)) deallocate(self%vj)
      if (allocated(self%ir3j)) deallocate(self%ir3j)

      call swiftest_util_dealloc_pl(self)

      return
   end subroutine whm_util_dealloc_pl


   module subroutine whm_util_fill_pl(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new WHM test particle structure into an old one. 
      !! This is the inverse of a fill operation.
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(whm_pl),                      intent(inout) :: self       
         !! WHM massive body object
      class(swiftest_body),               intent(in)    :: inserts    
         !! inserted object 
      logical, dimension(:),              intent(in)    :: lfill_list 
         !! Logical array of bodies to merge into the keeps
   
      associate(keeps => self)
         select type(inserts)
         class is (whm_pl)
            call util_fill(keeps%eta, inserts%eta, lfill_list)
            call util_fill(keeps%muj, inserts%muj, lfill_list)
            call util_fill(keeps%ir3j, inserts%ir3j, lfill_list)
            call util_fill(keeps%xj, inserts%xj, lfill_list)
            call util_fill(keeps%vj, inserts%vj, lfill_list)

            call swiftest_util_fill_pl(keeps, inserts, lfill_list)
         class default
            write(*,*) "Invalid object passed to the fill method. Inserts must be of class whm_pl or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate
   
      return
   end subroutine whm_util_fill_pl


   module subroutine whm_util_resize_pl(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a massive body against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(whm_pl), intent(inout) :: self  
         !! WHM massive body object
      integer(I4B),  intent(in)    :: nnew  
         !! New size neded

      call util_resize(self%eta, nnew)
      call util_resize(self%xj, nnew)
      call util_resize(self%vj, nnew)
      call util_resize(self%muj, nnew)
      call util_resize(self%ir3j, nnew)

      call swiftest_util_resize_pl(self, nnew)

      return
   end subroutine whm_util_resize_pl


   module subroutine whm_util_set_ir3j(self)
      !! author: David A. Minton
      !!
      !! Sets the inverse Jacobi and heliocentric radii cubed (1/rj**3 and 1/rh**3)
      implicit none
      ! Arguments
      class(whm_pl),  intent(inout) :: self    
         !! WHM massive body object
      ! Internals
      integer(I4B)                                 :: i
      real(DP)                                     :: r2, ir

      if (self%nbody > 0) then
         do i = 1, self%nbody
            r2 = dot_product(self%rh(:, i), self%rh(:, i))
            ir = 1.0_DP / sqrt(r2)
            self%ir3h(i) = ir / r2
            r2 = dot_product(self%xj(:, i), self%xj(:, i))
            ir = 1.0_DP / sqrt(r2)
            self%ir3j(i) = ir / r2
         end do
      end if

      return
   end subroutine whm_util_set_ir3j


   module subroutine whm_util_setup_pl(self, n, param)
      !! author: David A. Minton
      !!
      !! Allocate WHM planet structure
      !!
      !! Equivalent in functionality to David E. Kaufmann's Swifter routine whm_util_setup.f90
      implicit none
      ! Arguments
      class(whm_pl), intent(inout) :: self  
         !! Swiftest test particle object
      integer(I4B), intent(in) :: n     
         !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in) :: param 
         !! Current run configuration parameter

      !> Call allocation method for parent class
      call swiftest_util_setup_pl(self, n, param) 
      if (n == 0) return

      allocate(self%eta(n))
      allocate(self%muj(n))
      allocate(self%xj(NDIM, n))
      allocate(self%vj(NDIM, n))
      allocate(self%ir3j(n))

      self%eta(:)   = 0.0_DP
      self%muj(:)   = 0.0_DP
      self%xj(:,:)  = 0.0_DP
      self%vj(:,:)  = 0.0_DP
      self%ir3j(:) = 0.0_DP

      return
   end subroutine whm_util_setup_pl 


   module subroutine whm_util_set_mu_eta_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Sets the Jacobi mass value eta for all massive bodies
      implicit none
      ! Arguments
      class(whm_pl),      intent(inout) :: self   
         !! WHM nbody_system object
      class(swiftest_cb), intent(inout) :: cb     
         !! Swiftest central body object
      ! Internals
      integer(I4B)                                 :: i

      associate(pl => self, npl => self%nbody)
         if (npl == 0) return
         call swiftest_util_set_mu_pl(pl, cb)
         pl%eta(1) = cb%Gmass + pl%Gmass(1)
         pl%muj(1) = pl%eta(1)
         do i = 2, npl
            pl%eta(i) = pl%eta(i - 1) + pl%Gmass(i)
            pl%muj(i) = cb%Gmass * pl%eta(i) / pl%eta(i - 1)
         end do
      end associate

      return
   end subroutine whm_util_set_mu_eta_pl


   module subroutine whm_util_setup_initialize_system(self, system_history, param)
      !! author: David A. Minton
      !!
      !! Initialize a WHM nbody system from files
      !!
      implicit none
      ! Arguments
      class(whm_nbody_system),                 intent(inout) :: self            
         !! WHM nbody system object
      class(swiftest_storage),    allocatable, intent(inout) :: system_history  
         !! Stores the system history between output dumps
      class(swiftest_parameters),              intent(inout) :: param           
         !! Current run configuration parameters 

      call swiftest_util_setup_initialize_system(self, system_history, param)
      ! First we need to make sure that the massive bodies are sorted by heliocentric distance before computing jacobies
      call swiftest_util_set_ir3h(self%pl)
      call self%pl%sort("ir3h", ascending=.false.)
      call self%pl%flatten(param)

      ! Make sure that the discard list gets allocated initially
      call self%pl_discards%setup(0, param)
      call self%tp_discards%setup(0, param)
      call self%pl%set_mu(self%cb)
      call self%tp%set_mu(self%cb)
      if (param%lgr .and. param%in_type == "ASCII") then 
         ! pseudovelocity conversion for NetCDF input files is handled by NetCDF routines
         call self%pl%v2pv(param)
         call self%tp%v2pv(param)
      end if

      return
   end subroutine whm_util_setup_initialize_system


   module subroutine whm_util_sort_pl(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a WHM massive body object in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(whm_pl), intent(inout) :: self      
         !! WHM massive body object
      character(*),  intent(in)    :: sortby    
         !! Sorting attribute
      logical,       intent(in)    :: ascending 
         !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B) :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(pl => self, npl => self%nbody)
         select case(sortby)
         case("eta")
            call util_sort(direction * pl%eta(1:npl), ind)
         case("muj")
            call util_sort(direction * pl%muj(1:npl), ind)
         case("ir3j")
            call util_sort(direction * pl%ir3j(1:npl), ind)
         case("xj", "vj")
            write(*,*) 'Cannot sort by ' // trim(adjustl(sortby)) // '. Component not sortable!'
         case default
            call swiftest_util_sort_pl(pl, sortby, ascending)
            return
         end select

         call pl%rearrange(ind)
      end associate

      return
   end subroutine whm_util_sort_pl


   module subroutine whm_util_sort_rearrange_pl(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange WHM massive body structure in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(whm_pl),               intent(inout) :: self 
         !! WHM massive body object
      integer(I4B),  dimension(:), intent(in)    :: ind  
         !! Index array used to restructure the body (should contain all 1:n index values in the desired order)

      if (self%nbody == 0) return

      associate(pl => self, npl => self%nbody)
         call util_sort_rearrange(pl%eta,  ind, npl)
         call util_sort_rearrange(pl%xj,   ind, npl)
         call util_sort_rearrange(pl%vj,   ind, npl)
         call util_sort_rearrange(pl%muj,  ind, npl)
         call util_sort_rearrange(pl%ir3j, ind, npl)

         call swiftest_util_sort_rearrange_pl(pl,ind)
      end associate

      return
   end subroutine whm_util_sort_rearrange_pl


   module subroutine whm_util_spill_pl(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) WHM test particle structure from active list to discard list
      !! 
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(whm_pl),                         intent(inout) :: self        
         !! WHM massive body object
      class(swiftest_body),                  intent(inout) :: discards    
         !! Discarded object 
      logical, dimension(:),                 intent(in)    :: lspill_list 
         !! Logical array of bodies to spill into the discards
      logical,               intent(in)    :: ldestructive 
         !! Logical flag indicating whether or not this operation should alter the keeps array or not

      associate(keeps => self)
         select type(discards)
         class is (whm_pl)
            call util_spill(keeps%eta, discards%eta, lspill_list, ldestructive)
            call util_spill(keeps%muj, discards%muj, lspill_list, ldestructive)
            call util_spill(keeps%ir3j, discards%ir3j, lspill_list, ldestructive)
            call util_spill(keeps%xj, discards%xj, lspill_list, ldestructive)
            call util_spill(keeps%vj, discards%vj, lspill_list, ldestructive)

            call swiftest_util_spill_pl(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) "Invalid object passed to the spill method. Source must be of class whm_pl or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine whm_util_spill_pl
   
end submodule s_whm_util

!! Copyright 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
!! This file is part of Swiftest.
!! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
!! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
!! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
!! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
!! You should have received a copy of the GNU General Public License along with Swiftest. 
!! If not, see: https://www.gnu.org/licenses. 

module globals
   !! author: David A. Minton
   !! graph: false
   !!
   !! Basic parameters, definitions, and global type definitions used throughout the Swiftest project
   !! Adapted from David E. Kaufmann's Swifter routine: globals.f90 and module_swifter.f90
   use, intrinsic :: iso_fortran_env  ! Use the intrinsic kind definitions
   implicit none
   public

   integer, parameter :: I8B = int64 !! Symbolic name for kind types of 8-byte integers
   integer, parameter :: I4B = int32 !! Symbolic name for kind types of 4-byte integers
   integer, parameter :: I2B = int16 !! Symbolic name for kind types of 2-byte integers
   integer, parameter :: I1B = int8  !! Symbolic name for kind types of 1-byte integers

   integer, parameter :: SP = real32  !! Symbolic name for kind types of single-precision reals
   integer, parameter :: DP = real64  !! Symbolic name for kind types of double-precision reals
#ifdef QUADPREC
   integer, parameter :: QP = selected_Real_kind(30) !! Symbolic name for kind types of quad-precision reals
#else
   integer, parameter :: QP = real64 !! Stick to DP
#endif

   real(DP), parameter :: PIBY2  = 1.570796326794896619231321691639751442099_DP !! Definition of /(\pi / 2\)
   real(DP), parameter :: PI     = 3.141592653589793238462643383279502884197_DP !! Definition of /(\pi\)
   real(DP), parameter :: PI3BY2 = 4.712388980384689857693965074919254326296_DP !! Definition of /(3 \pi / 2\)
   real(DP), parameter :: TWOPI  = 6.283185307179586476925286766559005768394_DP !! Definition of 2 \pi
   real(DP), parameter :: THIRD  = 0.333333333333333333333333333333333333333_DP !! Definition of 1 / 3
   real(DP), parameter :: SIXTH  = 0.166666666666666666666666666666666666667_DP !! Definition of 1 / 3
   real(DP), parameter :: DEG2RAD = PI / 180.0_DP !! Definition of conversion factor from degrees to radians
   real(DP), parameter :: RAD2DEG = 180.0_DP / PI !! Definition of conversion factor from degrees to radians
   real(DP), parameter :: GC        = 6.6743E-11_DP   !! Universal gravitational constant in SI units
   real(DP), parameter :: einsteinC = 299792458.0_DP  !! Speed of light in SI units

   integer(I4B), parameter :: LOWERCASE_BEGIN  = iachar('a') !! ASCII character set parameter for lower to upper conversion - start 
                                                             !! of lowercase
   integer(I4B), parameter :: LOWERCASE_END    = iachar('z') !! ASCII character set parameter for lower to upper conversion - end of 
                                                             !! lowercase
   integer(I4B), parameter :: UPPERCASE_OFFSET = iachar('A') - iachar('a') !! ASCII character set parameter for lower to upper 
                                                                           !! conversion - offset between upper and lower

   character(*), parameter :: VERSION = "2023.12.0" !! Swiftest version

   !> Symbolic name for integrator types
   character(*), parameter :: UNKNOWN_INTEGRATOR = "UKNOWN INTEGRATOR"
   character(*), parameter :: INT_BS                 = "Bulirsch-Stoer"
   character(*), parameter :: INT_HELIO              = "Democratic Heliocentric"
   character(*), parameter :: INT_RA15               = "Radau 15th order"
   character(*), parameter :: INT_TU4                = "T+U 4th order"
   character(*), parameter :: INT_WHM                = "Wisdom-Holman Method"
   character(*), parameter :: INT_RMVS               = "Regularized Mixed Variable Symplectic"
   character(*), parameter :: INT_SYMBA              = "SyMBA"
   character(*), parameter :: INT_RINGMOONS          = "SyMBA-RINGMOONS"

   integer(I4B), parameter :: STRMAX = 512 !! Maximum size of character strings
   integer(I4B), parameter :: NAMELEN = 32 !! Maximum size of name strings

   character(*), parameter :: CB_TYPE_NAME = "Central Body"
   character(*), parameter :: PL_TYPE_NAME = "Massive Body"
   character(*), parameter :: TP_TYPE_NAME = "Test Particle"
   character(*), parameter :: PL_TINY_TYPE_NAME = "Semi-Interacting Massive Body"

   ! OpenMP Parameters
   integer(I4B)            :: nthreads = 1 !! Number of OpenMP threads
   integer(I4B), parameter :: NTHERSHOLD = 1000 !! Threshold value for OpenMP loop parallelization

   integer(I4B), parameter :: SUCCESS =  0 !! Symbolic name for function return/flag code for success
   integer(I4B), parameter :: FAILURE = -1 !! Symbolic name for function return/flag code for failure
   integer(I4B), parameter :: USAGE = -2 !! Symbolic name for function return/flag code for printing the usage message
   integer(I4B), parameter :: HELP  = -3 !! Symbolic name for function return/flag code for printing the usage message

   integer(I4B), parameter :: ELLIPSE   = -1 !! Symbolic names for orbit types - ellipse
   integer(I4B), parameter :: PARABOLA  =  0 !! Symbolic names for orbit types - parabola
   integer(I4B), parameter :: HYPERBOLA =  1 !! Symbolic names for orbit types - hyperbola

   !> Symbolic names for body/particle status codes:
   integer(I4B), parameter :: ACTIVE              =  0
   integer(I4B), parameter :: INACTIVE            =  1
   integer(I4B), parameter :: DISCARDED_RMAX      = -1
   integer(I4B), parameter :: DISCARDED_RMIN      = -2
   integer(I4B), parameter :: DISCARDED_RMAXU     = -3
   integer(I4B), parameter :: DISCARDED_PERI      = -4
   integer(I4B), parameter :: DISCARDED_PLR       = -5
   integer(I4B), parameter :: DISCARDED_PLQ       = -6
   integer(I4B), parameter :: DISCARDED_DRIFTERR  = -7
   integer(I4B), parameter :: MERGED              = -8
   integer(I4B), parameter :: DISRUPTED           = -9
   integer(I4B), parameter :: SUPERCATASTROPHIC   = -10
   integer(I4B), parameter :: GRAZE_AND_MERGE     = -11
   integer(I4B), parameter :: HIT_AND_RUN_DISRUPT = -12
   integer(I4B), parameter :: HIT_AND_RUN_PURE    = -13
   integer(I4B), parameter :: COLLIDED            = -14
   integer(I4B), parameter :: NEW_PARTICLE        = -15
   integer(I4B), parameter :: OLD_PARTICLE        = -16

   !> String labels for body/particle addition/subtraction in discard file
   character(*), parameter :: ADD = '+1'
   character(*), parameter :: SUB = '-1'

   !> Standard file names
   integer(I4B), parameter :: NDUMPFILES = 2
   character(*), parameter :: PARAM_RESTART_FILE = "param.restart.in"
#ifdef COARRAY
   character(STRMAX)       :: SWIFTEST_LOG_FILE                  !! Name of file to use to log output when using "COMPACT" or 
                                                                 !! "PROGRESS" display style (each co-image gets its own log file)
#else
   character(*), parameter :: SWIFTEST_LOG_FILE = "swiftest.log" !! Name of file to use to log output when using "COMPACT" or 
                                                                 !! "PROGRESS" display style
#endif
   integer(I4B), parameter :: SWIFTEST_LOG_OUT = 33 !! File unit for log file when using "COMPACT" display style 

   !> Default file names that can be changed by the user in the parameters file
   character(*), parameter :: CB_INFILE        = 'cb.in'
   character(*), parameter :: PL_INFILE        = 'pl.in'
   character(*), parameter :: TP_INFILE        = 'tp.in'
   character(*), parameter :: NC_INFILE        = 'init_cond.nc'
   character(*), parameter :: BIN_OUTFILE      = 'data.nc'
   integer(I4B), parameter :: BINUNIT          = 20 !! File unit number for the binary output file
   integer(I4B), parameter :: PARTICLEUNIT     = 44 !! File unit number for the binary particle info output file
   integer(I4B), parameter :: LUN              = 42 !! File unit number for files that are opened and closed within a single 
                                                    !! subroutine call, and therefore should not collide

   !> Miscellaneous constants:
   integer(I4B), parameter :: NDIM   = 3                  !! Number of dimensions in our reality
   integer(I4B), parameter :: NDIM2  = 2 * NDIM           !! 2x the number of dimensions
   real(DP),     parameter :: VSMALL = sqrt(TINY(1._DP)) !! Very small number used to prevent floating underflow

end module globals

! Copyright 2024 - The Minton Group at Purdue University
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module rmvs
   !! author: David A. Minton
   !!
   !! Definition of classes and methods specific to the Regularized Mixed Variable Symplectic (INT_RMVS) integrator
   !! Partially adapted from David E. Kaufmann's Swifter module: module_rmvs.f90
   use swiftest
   use whm
   implicit none
   public

   integer(I4B), private, parameter :: NTENC = 10
   integer(I4B), private, parameter :: NTPHENC = 3
   integer(I4B), private, parameter :: NTPENC = NTENC * NTPHENC
   real(DP),     private, parameter :: RHSCALE = 3.5_DP
   real(DP),     private, parameter :: RHPSCALE = 1.0_DP
   real(DP),     private, parameter :: FACQDT = 2.0_DP


   !> In the RMVS integrator, pl-tp encounters are handeled, but not pl-pl 
   type, extends(whm_nbody_system) :: rmvs_nbody_system
      logical                               :: lplanetocentric = .false.  
         !! Flag that indicates that the object is a planetocentric set of masive bodies used for close encounter calculations
      real(DP)                              :: rts                        
         !! fraction of Hill's sphere radius to use as radius of encounter region
      real(DP), dimension(:,:), allocatable :: vbeg                       
         !! Planet velocities at beginning ot step
   contains
      !> Replace the abstract procedures with concrete ones
      procedure :: dealloc    => rmvs_util_dealloc_system           
         !! Performs RMVS-specific deallocation
      procedure :: initialize => rmvs_util_setup_initialize_system  
         !! Performs RMVS-specific initilization steps, including generating the close encounter planetocentric structures
      procedure :: step       => rmvs_step_system                   
         !! Advance the RMVS nbody system forward in time by one step
   end type rmvs_nbody_system

   type, private :: rmvs_interp
      real(DP), dimension(:, :), allocatable :: x     
         !! interpolated heliocentric planet position for outer encounter
      real(DP), dimension(:, :), allocatable :: v     
         !! interpolated heliocentric planet velocity for outer encounter
      real(DP), dimension(:, :), allocatable :: aobl  
         !! Encountering planet's oblateness acceleration value
      real(DP), dimension(:, :), allocatable :: atide 
         !! Encountering planet's tidal acceleration value
   contains
      procedure :: dealloc => rmvs_util_dealloc_interp 
         !! Deallocates all allocatable arrays
      final ::   rmvs_final_interp   
         !! Finalizes the RMVS interpolated nbody_system variables object - deallocates all allocatables
   end type rmvs_interp


   !> RMVS central body particle class 
   type, extends(whm_cb) :: rmvs_cb
      type(rmvs_interp), dimension(:), allocatable :: outer 
         !! interpolated heliocentric central body position for outer encounters
      type(rmvs_interp), dimension(:), allocatable :: inner 
         !! interpolated heliocentric central body position for inner encounters
      logical                                      :: lplanetocentric = .false.  
         !! Flag that indicates that the object is a planetocentric set of masive bodies used for close encounter calculations
   contains
      procedure :: dealloc => rmvs_util_dealloc_cb 
         !! Deallocates all allocatable arrays
      final     ::            rmvs_final_cb   
         !! Finalizes the RMVS central body object - deallocates all allocatables
   end type rmvs_cb


   !! RMVS test particle class
   type, extends(whm_tp) :: rmvs_tp
      !! Note to developers: If you add componenets to this class, be sure to update methods and subroutines that traverse the
      !!    component list, such as rmvs_util_setup_tp and rmvs_util_spill_tp
      ! encounter steps)
      logical, dimension(:),   allocatable :: lperi  
         !! planetocentric pericenter passage flag (persistent for a full rmvs time step) over a full RMVS time step)
      integer(I4B), dimension(:),   allocatable :: plperP 
         !! index of planet associated with pericenter distance peri (persistent over a full RMVS time step)
      integer(I4B), dimension(:),   allocatable :: plencP 
         !! index of planet that test particle is encountering (not persistent for a full RMVS time step)

      ! The following are used to correctly set the oblateness values of the acceleration during an inner encounter with a planet
      type(rmvs_cb)                             :: cb_heliocentric 
         !! Copy of original central body object passed to close encounter (used for oblateness acceleration during planetocentric 
         !! encoountters)
      real(DP),     dimension(:,:), allocatable :: rheliocentric   
         !! original heliocentric position (used for oblateness calculation during close encounters)
      integer(I4B)                              :: index           
         !!  inner substep number within current set
      integer(I4B)                              :: ipleP           
         !!  index value of encountering planet
      logical                                   :: lplanetocentric = .false.  
         !! Flag that indicates that the object is a planetocentric set of masive bodies used for close encounter calculations
   contains
      procedure :: discard         => rmvs_discard_tp             
         !! Check to see if test particles should be discarded based on pericenter passage distances with respect to planets 
         !! encountered
      procedure :: encounter_check => rmvs_encounter_check_tp     
         !! Checks if any test particles are undergoing a close encounter with a massive body
      procedure :: accel           => rmvs_kick_getacch_tp        
         !! Calculates either the standard or modified version of the acceleration depending if the
                                                                  
         !!    if the test particle is undergoing a close encounter or not
      procedure :: setup           => rmvs_util_setup_tp               
         !! Constructor method - Allocates space for the input number of bodiess
      procedure :: append          => rmvs_util_append_tp         
         !! Appends elements from one structure to another
      procedure :: dealloc         => rmvs_util_dealloc_tp        
         !! Deallocates all allocatable arrays
      procedure :: fill            => rmvs_util_fill_tp           
         !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: resize          => rmvs_util_resize_tp         
         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: sort            => rmvs_util_sort_tp           
         !! Sorts body arrays by a sortable componen
      procedure :: rearrange       => rmvs_util_sort_rearrange_tp 
         !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill           => rmvs_util_spill_tp          
         !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
      final     ::                    rmvs_final_tp          
         !! Finalizes the RMVS test particle object - deallocates all allocatables
   end type rmvs_tp

 
   !> RMVS massive body particle class
   type, extends(whm_pl) :: rmvs_pl
      integer(I4B),             dimension(:), allocatable :: nenc                      
         !! number of test particles encountering planet this full rmvs time step
      integer(I4B),             dimension(:), allocatable :: tpenc1P                   
         !! index of first test particle encountering planet
      integer(I4B),             dimension(:), allocatable :: plind                     
         !! Connects the planetocentric indices back to the heliocentric planet list
      type(rmvs_interp),        dimension(:), allocatable :: outer                     
         !! interpolated heliocentric central body position for outer encounters
      type(rmvs_interp),        dimension(:), allocatable :: inner                     
         !! interpolated heliocentric central body position for inner encounters
      class(rmvs_nbody_system), dimension(:), allocatable :: planetocentric            
         !! Planetocentric version of the massive body objects (one for each massive body)
      logical                                             :: lplanetocentric = .false. 
         !! Flag that indicates that the object is a planetocentric set of masive bodies used for close encounter calculations
   contains
      procedure :: setup     => rmvs_util_setup_pl          
         !! Constructor method - Allocates space for the input number of bodiess
      procedure :: append    => rmvs_util_append_pl         
         !! Appends elements from one structure to another
      procedure :: dealloc   => rmvs_util_dealloc_pl        
         !! Deallocates all allocatable arrays
      procedure :: fill      => rmvs_util_fill_pl           
         !! "Fills" bodies from one object into another depending on the results of a mask (uses the UNPACK intrinsic)
      procedure :: resize    => rmvs_util_resize_pl         
         !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      procedure :: sort      => rmvs_util_sort_pl           
         !! Sorts body arrays by a sortable componen
      procedure :: rearrange => rmvs_util_sort_rearrange_pl 
         !! Rearranges the order of array elements of body based on an input index array. Used in sorting methods
      procedure :: spill     => rmvs_util_spill_pl          
         !! "Spills" bodies from one object to another depending on the results of a mask (uses the PACK intrinsic)
      final     ::              rmvs_final_pl               
         !! Finalizes the RMVS massive body object - deallocates all allocatables
   end type rmvs_pl

   interface
      module subroutine rmvs_discard_tp(self, nbody_system, param)
         implicit none
         class(rmvs_tp),               intent(inout) :: self   
            !! RMVS test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters 
      end subroutine rmvs_discard_tp

      module function rmvs_encounter_check_tp(self, param, nbody_system, dt) result(lencounter)
         implicit none
         class(rmvs_tp),             intent(inout) :: self       
            !! RMVS test particle object  
         class(swiftest_parameters), intent(inout) :: param      
            !! Current run configuration parameters 
         class(rmvs_nbody_system),   intent(inout) :: nbody_system     
            !! RMVS nbody system object
         real(DP),                   intent(in)    :: dt         
            !! step size
         logical                                   :: lencounter 
            !! Returns true if there is at least one close encounter      
      end function rmvs_encounter_check_tp

      module subroutine rmvs_kick_getacch_tp(self, nbody_system, param, t, lbeg)
         implicit none
         class(rmvs_tp),               intent(inout) :: self   
            !! RMVS test particle data structure
         class(swiftest_nbody_system), intent(inout) :: nbody_system 
            !! Swiftest central body particle data structuree 
         class(swiftest_parameters),   intent(inout) :: param  
            !! Current run configuration parameters
         real(DP),                     intent(in)    :: t      
            !! Current time
         logical,                      intent(in)    :: lbeg   
            !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine rmvs_kick_getacch_tp

      module subroutine rmvs_util_setup_pl(self, n, param)
         implicit none
         class(rmvs_pl),             intent(inout) :: self  
            !! RMVS massive body object
         integer(I4B),               intent(in)    :: n     
            !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parameters
      end subroutine rmvs_util_setup_pl

      module subroutine rmvs_util_setup_initialize_system(self, system_history, param)
         implicit none
         class(rmvs_nbody_system),                intent(inout) :: self           
            !! RMVS system object
         class(swiftest_storage),    allocatable, intent(inout) :: system_history 
            !! Stores the system history between output dumps
         class(swiftest_parameters),              intent(inout) :: param          
            !! Current run configuration parameters 
      end subroutine rmvs_util_setup_initialize_system

      module subroutine rmvs_util_setup_tp(self, n, param)
         implicit none
         class(rmvs_tp),            intent(inout) :: self 
            !! RMVS test particle object
         integer(I4B),              intent(in)    :: n     
            !! Number of particles to allocate space for
         class(swiftest_parameters), intent(in)    :: param 
            !! Current run configuration parametere
      end subroutine rmvs_util_setup_tp

      module subroutine rmvs_util_append_pl(self, source, lsource_mask)
         implicit none
         class(rmvs_pl),                  intent(inout) :: self         
            !! RMVS massive body object
         class(swiftest_body),            intent(in)    :: source       
            !! Source object to append
         logical, dimension(:),           intent(in)    :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine rmvs_util_append_pl

      module subroutine rmvs_util_append_tp(self, source, lsource_mask)
         implicit none
         class(rmvs_tp),                  intent(inout) :: self         
            !! RMVS test particle object
         class(swiftest_body),            intent(in)    :: source       
            !! Source object to append
         logical, dimension(:),           intent(in)    :: lsource_mask 
            !! Logical mask indicating which elements to append to
      end subroutine rmvs_util_append_tp

      module subroutine rmvs_util_dealloc_cb(self)
         implicit none
         class(rmvs_cb),  intent(inout) :: self 
            !! RMVS central body object
      end subroutine rmvs_util_dealloc_cb

      module subroutine rmvs_util_dealloc_interp(self)
         implicit none
         class(rmvs_interp),  intent(inout) :: self 
            !! RMVS interpolated nbody_system variables object
      end subroutine rmvs_util_dealloc_interp

      module subroutine rmvs_util_dealloc_pl(self)
         implicit none
         class(rmvs_pl),  intent(inout) :: self 
            !! RMVS massive body object
      end subroutine rmvs_util_dealloc_pl

      module subroutine rmvs_util_dealloc_system(self)
         implicit none
         class(rmvs_nbody_system), intent(inout) :: self
      end subroutine rmvs_util_dealloc_system

      module subroutine rmvs_util_dealloc_tp(self)
         implicit none
         class(rmvs_tp),  intent(inout) :: self 
            !! RMVS test particle object
      end subroutine rmvs_util_dealloc_tp

      module subroutine rmvs_util_fill_pl(self, inserts, lfill_list)
         implicit none
         class(rmvs_pl),        intent(inout) :: self       
            !! RMVS massive body object 
         class(swiftest_body),  intent(in)    :: inserts    
            !! Inserted object 
         logical, dimension(:), intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine rmvs_util_fill_pl

      module subroutine rmvs_util_fill_tp(self, inserts, lfill_list)
         implicit none
         class(rmvs_tp),        intent(inout) :: self        
            !! RMVS massive body object
         class(swiftest_body),  intent(in)    :: inserts     
            !!  Inserted object 
         logical, dimension(:), intent(in)    :: lfill_list 
            !! Logical array of bodies to merge into the keeps
      end subroutine rmvs_util_fill_tp

      module subroutine rmvs_util_resize_pl(self, nnew)
         implicit none
         class(rmvs_pl), intent(inout) :: self  
            !! RMVS massive body object
         integer(I4B),   intent(in)    :: nnew  
            !! New size neded
      end subroutine rmvs_util_resize_pl

      module subroutine rmvs_util_resize_tp(self, nnew)
         implicit none
         class(rmvs_tp), intent(inout) :: self  
            !! RMVS test particle object
         integer(I4B),   intent(in)    :: nnew  
            !! New size neded
      end subroutine rmvs_util_resize_tp

      module subroutine rmvs_util_sort_pl(self, sortby, ascending)
         implicit none
         class(rmvs_pl), intent(inout) :: self      
            !! RMVS massive body object
         character(*),   intent(in)    :: sortby    
            !! Sorting attribute
         logical,        intent(in)    :: ascending 
            !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine rmvs_util_sort_pl   

      module subroutine rmvs_util_sort_tp(self, sortby, ascending)
         implicit none
         class(rmvs_tp), intent(inout) :: self      
            !! RMVS test particle object
         character(*),   intent(in)    :: sortby    
            !! Sorting attribute
         logical,        intent(in)    :: ascending 
            !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      end subroutine rmvs_util_sort_tp

      module subroutine rmvs_util_sort_rearrange_pl(self, ind)
         implicit none
         class(rmvs_pl),               intent(inout) :: self 
            !! RMVS massive body object
         integer(I4B),   dimension(:), intent(in)    :: ind  
            !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine rmvs_util_sort_rearrange_pl

      module subroutine rmvs_util_sort_rearrange_tp(self, ind)
         implicit none
         class(rmvs_tp),                intent(inout) :: self 
            !! RMVS test particle object
         integer(I4B),    dimension(:), intent(in)    :: ind  
            !! Index array used to restructure the body (should contain all 1:n index values in the desired order)
      end subroutine rmvs_util_sort_rearrange_tp

      module subroutine rmvs_util_spill_pl(self, discards, lspill_list, ldestructive)
         implicit none
         class(rmvs_pl),        intent(inout) :: self         
            !! RMVS massive body object
         class(swiftest_body),  intent(inout) :: discards     
            !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine rmvs_util_spill_pl

      module subroutine rmvs_util_spill_tp(self, discards, lspill_list, ldestructive)
         implicit none
         class(rmvs_tp),        intent(inout) :: self         
            !! RMVS test particle object
         class(swiftest_body),  intent(inout) :: discards     
            !! Discarded object 
         logical, dimension(:), intent(in)    :: lspill_list  
            !! Logical array of bodies to spill into the discards
         logical,               intent(in)    :: ldestructive 
            !! Logical flag indicating whether or not this operation should alter the keeps array or not
      end subroutine rmvs_util_spill_tp

      module subroutine rmvs_step_system(self, param, t, dt)
         implicit none
         class(rmvs_nbody_system),   intent(inout) :: self    
            !! RMVS nbody system object
         class(swiftest_parameters), intent(inout) :: param  
            !! Current run configuration parameters 
         real(DP),                   intent(in)    :: t      
            !! Simulation time
         real(DP),                   intent(in)    :: dt     
            !! Current stepsize
      end subroutine rmvs_step_system

   end interface


#ifdef COARRAY
   interface coclone
      module procedure rmvs_coarray_coclone_tp
   end interface

   interface cocollect
      module procedure rmvs_coarray_cocollect_tp
   end interface

#endif

   contains

      subroutine rmvs_final_cb(self)
         !! author: David A. Minton
         !!
         !! Finalize the RMVS massive body object - deallocates all allocatables
         implicit none
         ! Arguments
         type(rmvs_cb),  intent(inout) :: self 
            !! RMVS central body object
         call self%dealloc()
         return
      end subroutine rmvs_final_cb


      subroutine rmvs_final_interp(self)
         !! author: David A. Minton
         !!
         !! Finalize the RMVS nbody system object - deallocates all allocatables
         implicit none
         ! Arguments
         type(rmvs_interp),  intent(inout) :: self 
            !! RMVS nbody system object
         call self%dealloc()
         return
      end subroutine rmvs_final_interp


      subroutine rmvs_final_pl(self)
         !! author: David A. Minton
         !!
         !! Finalize the RMVS massive body object - deallocates all allocatables
         implicit none
         ! Arguments
         type(rmvs_pl),  intent(inout) :: self 
            !! RMVS massive body object
         call self%dealloc()
         return
      end subroutine rmvs_final_pl


      subroutine rmvs_final_tp(self)
         !! author: David A. Minton
         !!
         !! Finalize the RMVS test particle object - deallocates all allocatables
         implicit none
         ! Arguments
         type(rmvs_tp),  intent(inout) :: self 
            !! RMVS test particle object
         call self%dealloc()
         return
      end subroutine rmvs_final_tp


#ifdef COARRAY

   subroutine rmvs_coarray_coclone_tp(tp)
      !! author: David A. Minton
      !!
      !! Broadcasts the image 1 object to all other images in a coarray 
      implicit none
      ! Arguments
      type(rmvs_tp),intent(inout),codimension[*]  :: tp  !! RMVS pl object

      call coclone(tp%lperi)
      call coclone(tp%plperP) 
      call coclone(tp%plencP)
      call co_broadcast(tp%index,1)
      call co_broadcast(tp%ipleP,1)
      call co_broadcast(tp%lplanetocentric,1)

      call co_broadcast(tp%lfirst,1)
      call co_broadcast(tp%nbody,1)
      call coclone(tp%id)
      call coclone(tp%info)
      call coclone(tp%lmask)
      call coclone(tp%status)
      call coclone(tp%ldiscard)
      call coclone(tp%lcollision)
      call coclone(tp%lencounter)
      call coclone(tp%mu)
      call coclone(tp%rh)
      call coclone(tp%vh)
      call coclone(tp%rb)
      call coclone(tp%vb)
      call coclone(tp%ah)
      call coclone(tp%aobl)
      call coclone(tp%agr)
      call coclone(tp%atide)
      call coclone(tp%isperi)
      call coclone(tp%peri)
      call coclone(tp%atp)
      call coclone(tp%a)
      call coclone(tp%e)
      call coclone(tp%inc)
      call coclone(tp%capom)
      call coclone(tp%omega)
      call coclone(tp%capm) 
      call coclone(tp%nplenc)

      return
   end subroutine rmvs_coarray_coclone_tp


   subroutine rmvs_coarray_cocollect_tp(tp)
      !! author: David A. Minton
      !!
      !! Broadcasts the image 1 object to all other images in a coarray 
      implicit none
      ! Arguments
      type(rmvs_tp),intent(inout),codimension[*]  :: tp  !! RMVS pl object

      call cocollect(tp%lperi)
      call cocollect(tp%plperP) 
      call cocollect(tp%plencP)

      call co_sum(tp%npltp,1)
      call cocollect(tp%nplenc)
      call co_sum(tp%nbody,1)
      call cocollect(tp%id)
      call cocollect(tp%info)
      call cocollect(tp%lmask)
      call cocollect(tp%status)
      call cocollect(tp%ldiscard)
      call cocollect(tp%lcollision)
      call cocollect(tp%lencounter)
      call cocollect(tp%mu)
      call cocollect(tp%rh)
      call cocollect(tp%vh)
      call cocollect(tp%rb)
      call cocollect(tp%vb)
      call cocollect(tp%ah)
      call cocollect(tp%aobl)
      call cocollect(tp%agr)
      call cocollect(tp%atide)
      call cocollect(tp%ir3h)
      call cocollect(tp%isperi)
      call cocollect(tp%peri)
      call cocollect(tp%atp)
      call cocollect(tp%a)
      call cocollect(tp%e)
      call cocollect(tp%inc)
      call cocollect(tp%capom)
      call cocollect(tp%omega)
      call cocollect(tp%capm)

      return
   end subroutine rmvs_coarray_cocollect_tp

#endif 


end module rmvs

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(symba) s_symba_util
   use swiftest
   use fraggle
contains

   module subroutine symba_util_append_pl(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one massive body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      !! Arguments
      class(symba_pl), intent(inout) :: self  
         !! SyMBA massive body object
      class(swiftest_body), intent(in) :: source       
         !! Source object to append
      logical, dimension(:), intent(in) :: lsource_mask 
         !! Logical mask indicating which elements to append to

      select type(source)
      class is (symba_pl)
         call util_append(self%levelg, source%levelg, lsource_mask=lsource_mask)
         call util_append(self%levelm, source%levelm, lsource_mask=lsource_mask)
         ! Note: helio_pl does not have its own append method, so we skip back to the base class
         call swiftest_util_append_pl(self, source, lsource_mask) 
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class symba_pl or its descendents!"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine symba_util_append_pl


   module subroutine symba_util_append_tp(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from test particle object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      !! Arguments
      class(symba_tp),  intent(inout) :: self 
         !! SyMBA test particle object
      class(swiftest_body), intent(in) :: source  
         !! Source object to append
      logical, dimension(:), intent(in) :: lsource_mask 
         !! Logical mask indicating which elements to append to

      select type(source)
      class is (symba_tp)
         call util_append(self%levelg, source%levelg, lsource_mask=lsource_mask)
         call util_append(self%levelm, source%levelm, lsource_mask=lsource_mask)
         ! Note: helio_tp does not have its own append method, so we skip back to the base class
         call swiftest_util_append_tp(self, source, lsource_mask) 
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class symba_tp or its descendents!"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine symba_util_append_tp


   module subroutine symba_util_dealloc_pl(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Arguments
      class(symba_pl),  intent(inout) :: self 
         !! SyMBA massive body object

      if (allocated(self%levelg)) deallocate(self%levelg)
      if (allocated(self%levelm)) deallocate(self%levelm)

      call self%helio_pl%dealloc()

      return
   end subroutine symba_util_dealloc_pl


   module subroutine symba_util_dealloc_system(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables and resets all values to defaults. Acts as a base for a finalizer
      implicit none
      ! Arguments
      class(symba_nbody_system), intent(inout) :: self
         !! SyMBA nbody_system object

      self%irec = -1
      call self%helio_nbody_system%dealloc()

      return
   end subroutine symba_util_dealloc_system


   module subroutine symba_util_dealloc_tp(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Arguments
      class(symba_tp),  intent(inout) :: self 
         !! SyMBA test particle object

      if (allocated(self%levelg)) deallocate(self%levelg)
      if (allocated(self%levelm)) deallocate(self%levelm)

      call self%helio_tp%dealloc() 

      return
   end subroutine symba_util_dealloc_tp


   module subroutine symba_util_fill_pl(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new SyMBA test particle structure into an old one. 
      !! This is the inverse of a fill operation.
      !! 
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self
         !! SyMBA masive body object
      class(swiftest_body), intent(in) :: inserts
         !! Inserted object 
      logical, dimension(:), intent(in) :: lfill_list
         !! Logical array of bodies to merge into the keeps

      associate(keeps => self)
         select type(inserts)
         class is (symba_pl)
            call util_fill(keeps%levelg, inserts%levelg, lfill_list)
            call util_fill(keeps%levelm, inserts%levelm, lfill_list)
            ! Note: helio_pl does not have its own fill method, so we skip back to the base class
            call swiftest_util_fill_pl(keeps, inserts, lfill_list)  
         class default
            write(*,*) "Invalid object passed to the fill method. Source must be of class symba_pl or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine symba_util_fill_pl


   module subroutine symba_util_fill_tp(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new SyMBA test particle structure into an old one. 
      !! This is the inverse of a fill operation.
      !! 
      implicit none
      ! Arguments
      class(symba_tp), intent(inout) :: self 
         !! SyMBA test particle object
      class(swiftest_body), intent(in) :: inserts 
         !! Inserted object 
      logical, dimension(:), intent(in) :: lfill_list 
         !! Logical array of bodies to merge into the keeps

      associate(keeps => self)
         select type(inserts)
         class is (symba_tp)
            call util_fill(keeps%levelg, inserts%levelg, lfill_list)
            call util_fill(keeps%levelm, inserts%levelm, lfill_list)
            ! Note: helio_tp does not have its own fill method, so we skip back to the base class
            call swiftest_util_fill_tp(keeps, inserts, lfill_list) 
         class default
            write(*,*) "Invalid object passed to the fill method. Source must be of class symba_tp or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate

      return
   end subroutine symba_util_fill_tp


   module subroutine symba_util_flatten_eucl_plpl(self, param)
      !! author: Jacob R. Elliott and David A. Minton
      !!
      !! Turns i,j indices into k index for use in the Euclidean distance matrix. This also sets the lmtiny flag and computes the
      !! number of interactions that excludes semi-interacting bodies with each other (Gmass < GMTINY).
      !! This method will also sort the bodies in descending order by Mass
      !!
      !! Reference:
      !!
      !!    Mélodie Angeletti, Jean-Marie Bonny, Jonas Koko. Parallel Euclidean distance matrix computation on big datasets *. 
      !!       2019. hal-0204751
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self  
         !! SyMBA massive body object
      class(swiftest_parameters), intent(inout) :: param 
         !! Current run configuration parameters
      ! Internals
      integer(I8B) :: npl, nplm

      if (self%nbody == 0) then
         self%nplm = 0
         return
      end if

      associate(pl => self, nplplm => self%nplplm)
         npl = int(self%nbody, kind=I8B)
         if (param%lmtiny_pl) then 
            pl%lmtiny(1:npl) = pl%Gmass(1:npl) < param%GMTINY 
            nplm = count(.not. pl%lmtiny(1:npl))
         else
            nplm = npl
         end if
         pl%nplm = int(nplm, kind=I4B)
         ! number of entries in a strict lower triangle, npl x npl, minus first column including only mutually interacting bodies
         nplplm = nplm * npl - nplm * (nplm + 1_I8B) / 2_I8B 

         call swiftest_util_flatten_eucl_plpl(pl, param)
      end associate

      return
   end subroutine symba_util_flatten_eucl_plpl


   module subroutine symba_util_resize_pl(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a SyMBA massive body object against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self  
         !! SyMBA massive body object
      integer(I4B), intent(in) :: nnew  
         !! New size neded

      call util_resize(self%levelg, nnew)
      call util_resize(self%levelm, nnew)

      call swiftest_util_resize_pl(self, nnew)

      return
   end subroutine symba_util_resize_pl

   module subroutine symba_util_resize_tp(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a test particle object against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(symba_tp), intent(inout) :: self 
         !! SyMBA test particle object
      integer(I4B), intent(in):: nnew 
         !! New size neded

      call util_resize(self%levelg, nnew)
      call util_resize(self%levelm, nnew)

      call swiftest_util_resize_tp(self, nnew)

      return
   end subroutine symba_util_resize_tp

   module subroutine symba_util_set_renc(self, scale)
      !! author: David A. Minton
      !!
      !! Sets the critical radius for encounter given an input recursion depth
      !!
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self 
         !! SyMBA massive body object
      integer(I4B), intent(in) :: scale 
         !! Current recursion depth
      ! Internals
      integer(I4B) :: i
      real(DP)     :: rshell_irec

      if (self%nbody == 0) return
      associate(pl => self, npl => self%nbody)
         rshell_irec = 1._DP
         do i = 1, scale
            rshell_irec = rshell_irec * RSHELL
         end do
         pl%renc(1:npl) = pl%rhill(1:npl) * RHSCALE * rshell_irec
      end associate

      return
   end subroutine symba_util_set_renc


   module subroutine symba_util_setup_initialize_system(self, system_history, param)
      !! author: David A. Minton
      !!
      !! Initialize an SyMBA nbody system from files and sets up the planetocentric structures.
      !! This subroutine will also sort the massive bodies in descending order by mass
      !! 
      implicit none
      ! Arguments
      class(symba_nbody_system), intent(inout) :: self 
         !! SyMBA nbody_system object
      class(swiftest_storage),allocatable, intent(inout) :: system_history 
         !! Stores the system history between output dumps
      class(swiftest_parameters), intent(inout) :: param 
         !! Current run configuration parameters 

      ! Call parent method
      associate(nbody_system => self)
         call helio_util_setup_initialize_system(nbody_system, system_history, param)
         call nbody_system%pltp_encounter%setup(0_I8B)
         call nbody_system%plpl_encounter%setup(0_I8B)
         call nbody_system%plpl_collision%setup(0_I8B)
         call nbody_system%pltp_collision%setup(0_I8B)

         if (allocated(nbody_system%collider)) deallocate(nbody_system%collider)
         select case(param%collision_model)
         case("MERGE")
            allocate(collision_basic :: nbody_system%collider)
         case("BOUNCE")
            allocate(collision_bounce :: nbody_system%collider)
         case("FRAGGLE")
            allocate(collision_fraggle :: nbody_system%collider)
         end select
         call nbody_system%collider%setup(nbody_system)

      end associate

      return
   end subroutine symba_util_setup_initialize_system


   module subroutine symba_util_setup_pl(self, n, param)
      !! author: David A. Minton
      !!
      !! Allocate SyMBA test particle structure
      !!
      !! Equivalent in functionality to David E. Kaufmann's Swifter routine symba_util_setup.f90
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self  
         !! SyMBA massive body object
      integer(I4B),  intent(in) :: n 
         !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in) :: param 
         !! Current run configuration parameter

      ! Call allocation method for parent class. 
      call self%helio_pl%setup(n, param) 
      if (n == 0) return

      allocate(self%levelg(n))
      allocate(self%levelm(n))

      self%levelg(:) = -1
      self%levelm(:) = -1
      return
   end subroutine symba_util_setup_pl


   module subroutine symba_util_setup_tp(self, n, param)
      !! author: David A. Minton
      !!
      !! Allocate WHM test particle structure
      !!
      !! Equivalent in functionality to David E. Kaufmann's Swifter routine whm_util_setup.f90
      implicit none
      ! Arguments
      class(symba_tp), intent(inout) :: self  
         !! SyMBA test particle object
      integer(I4B), intent(in) :: n 
         !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in) :: param 
         !! Current run configuration parameter

      !> Call allocation method for parent class. 
      call self%helio_tp%setup(n, param) 
      if (n == 0) return

      allocate(self%levelg(n))
      allocate(self%levelm(n))

      self%levelg(:) = -1
      self%levelm(:) = -1
      
      return
   end subroutine symba_util_setup_tp


   module subroutine symba_util_sort_pl(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a SyMBA massive body object in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self      
         !! SyMBA massive body object
      character(*), intent(in)    :: sortby    
         !! Sorting attribute
      logical, intent(in)    :: ascending 
         !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B)                        :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(pl => self, npl => self%nbody)
         select case(sortby)
         case("levelg")
            call util_sort(direction * pl%levelg(1:npl), ind)
         case("levelm")
            call util_sort(direction * pl%levelm(1:npl), ind)

         case default ! Look for components in the parent class
            call swiftest_util_sort_pl(pl, sortby, ascending)
            return
         end select

         call pl%rearrange(ind)

      end associate
      return
   end subroutine symba_util_sort_pl


   module subroutine symba_util_sort_tp(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a SyMBA test particle object in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(symba_tp), intent(inout) :: self  
         !! SyMBA test particle object
      character(*), intent(in)  :: sortby  
         !! Sorting attribute
      logical, intent(in) :: ascending 
         !! Logical flag indicating whether or not the sorting should be in ascending or descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B)                        :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(tp => self, ntp => self%nbody)
         select case(sortby)
         case("nplenc")
            call util_sort(direction * tp%nplenc(1:ntp), ind)
         case("levelg")
            call util_sort(direction * tp%levelg(1:ntp), ind)
         case("levelm")
            call util_sort(direction * tp%levelm(1:ntp), ind)
         case default ! Look for components in the parent class
            call swiftest_util_sort_tp(tp, sortby, ascending)
            return
         end select

         call tp%rearrange(ind)
      end associate

      return
   end subroutine symba_util_sort_tp


   module subroutine symba_util_sort_rearrange_pl(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange SyMBA massive body structure in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self !
         ! SyMBA massive body object
      integer(I4B), dimension(:), intent(in) :: ind 
         !! Index array used to restructure the body (should contain all 1:n index values in the desired order)

      associate(pl => self, npl => self%nbody)
         call util_sort_rearrange(pl%levelg,     ind, npl)
         call util_sort_rearrange(pl%levelm,     ind, npl)
         call swiftest_util_sort_rearrange_pl(pl,ind)
      end associate

      return
   end subroutine symba_util_sort_rearrange_pl


   module subroutine symba_util_sort_rearrange_tp(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange SyMBA test particle object in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(symba_tp), intent(inout) :: self 
         !! SyMBA test particle object
      integer(I4B), dimension(:), intent(in) :: ind
         !! Index array used to restructure the body (should contain all 1:n index values in the desired order)

      associate(tp => self, ntp => self%nbody)
         call util_sort_rearrange(tp%nplenc, ind, ntp)
         call util_sort_rearrange(tp%levelg, ind, ntp)
         call util_sort_rearrange(tp%levelm, ind, ntp)

         call swiftest_util_sort_rearrange_tp(tp,ind)
      end associate
      
      return
   end subroutine symba_util_sort_rearrange_tp


   module subroutine symba_util_spill_pl(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) SyMBA massive body particle structure from active list to discard list
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(symba_pl), intent(inout) :: self        
         !! SyMBA massive body object
      class(swiftest_body), intent(inout) :: discards
         !! Discarded object 
      logical, dimension(:), intent(in) :: lspill_list
         !! Logical array of bodies to spill into the discards
      logical,  intent(in)  :: ldestructive 
         !! Logical flag indicating whether or not this operation should alter body by removing the discard list

      ! For each component, pack the discarded bodies into the discard object and do the inverse with the keeps
      !> Spill all the common components
      associate(keeps => self)
         select type(discards)
         class is (symba_pl)
            call util_spill(keeps%levelg, discards%levelg, lspill_list, ldestructive)
            call util_spill(keeps%levelm, discards%levelm, lspill_list, ldestructive)

            call swiftest_util_spill_pl(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) "Invalid object passed to the spill method. Source must be of class symba_pl or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate
     
      return
   end subroutine symba_util_spill_pl


   module subroutine symba_util_spill_tp(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) SyMBA test particle structure from active list to discard list
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(symba_tp), intent(inout) :: self  
         !! SyMBA test particle object
      class(swiftest_body),  intent(inout) :: discards     
         !! Discarded object 
      logical, dimension(:), intent(in) :: lspill_list  
         !! Logical array of bodies to spill into the discards
      logical, intent(in) :: ldestructive 
         !! Logical flag indicating whether or not this operation should alter body by removing the discard list

      ! For each component, pack the discarded bodies into the discard object and do the inverse with the keeps
      !> Spill all the common components
      associate(keeps => self)
         select type(discards)
         class is (symba_tp)
            call util_spill(keeps%levelg, discards%levelg, lspill_list, ldestructive)
            call util_spill(keeps%levelm, discards%levelm, lspill_list, ldestructive)

            call swiftest_util_spill_tp(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) "Invalid object passed to the spill method. Source must be of class symba_tp or its descendents!"
            call base_util_exit(FAILURE)
         end select
      end associate
     
      return
   end subroutine symba_util_spill_tp



end submodule s_symba_util

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule(swiftest) s_swiftest_kick
contains
   module subroutine swiftest_kick_getacch_int_pl(self, param)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations of massive bodies
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int.f90
      implicit none
      ! Arguments
      class(swiftest_pl),         intent(inout) :: self  !! Swiftest massive body object
      class(swiftest_parameters), intent(inout) :: param !! Current swiftest run configuration parameters
      ! Internals
#ifdef PROFILE
      type(walltimer), save :: timer 
#endif

      if (param%lflatten_interactions) then
         if (param%lclose) then
            call swiftest_kick_getacch_int_all(self%nbody, self%nplpl, self%k_plpl, self%rh, self%Gmass, self%radius, self%ah)
         else
            call swiftest_kick_getacch_int_all(self%nbody, self%nplpl, self%k_plpl, self%rh, self%Gmass, self%ah)
         end if
      else
         if (param%lclose) then
            call swiftest_kick_getacch_int_all(self%nbody, self%nbody, self%rh, self%Gmass, self%radius, self%ah)
         else
            call swiftest_kick_getacch_int_all(self%nbody, self%nbody, self%rh, self%Gmass, self%ah)
         end if
      end if

      return
   end subroutine swiftest_kick_getacch_int_pl


   module subroutine swiftest_kick_getacch_int_tp(self, param, GMpl, rhp, npl)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations of test particles by massive bodies
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int_tp.f90
      implicit none
      ! Arguments
      class(swiftest_tp),         intent(inout) :: self  !! Swiftest test particle object
      class(swiftest_parameters), intent(inout) :: param !! Current swiftest run configuration parameters
      real(DP), dimension(:),     intent(in)    :: GMpl  !! Massive body masses
      real(DP), dimension(:,:),   intent(in)    :: rhp   !! Massive body position vectors
      integer(I4B),               intent(in)    :: npl   !! Number of active massive bodies

      if ((self%nbody == 0) .or. (npl == 0)) return

      call swiftest_kick_getacch_int_all_tp(self%nbody, npl, self%rh, rhp, GMpl, self%lmask, self%ah)
      
      return
   end subroutine swiftest_kick_getacch_int_tp


   module subroutine swiftest_kick_getacch_int_all_flat_rad_pl(npl, nplpl, k_plpl, r, Gmass, radius, acc)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations for massive bodies, with parallelization.
      !! This is the flattened (single loop) version that uses the k_plpl interaction pair index array
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int.f9
      implicit none
      integer(I4B),                 intent(in)             :: npl    !! Number of massive bodies
      integer(I8B),                 intent(in)             :: nplpl  !! Number of massive body interactions to compute
      integer(I4B), dimension(:,:), intent(in)             :: k_plpl !! Array of interaction pair indices (flattened upper triangular matrix)
      real(DP),     dimension(:,:), intent(in)             :: r      !! Position vector array
      real(DP),     dimension(:),   intent(in)             :: Gmass  !! Array of massive body G*mass
      real(DP),     dimension(:),   intent(in)             :: radius !! Array of massive body radii
      real(DP),     dimension(:,:), intent(inout)          :: acc    !! Acceleration vector array 
      ! Internals
      integer(I8B)                      :: k
      real(DP), dimension(NDIM,npl) :: ahi, ahj
      integer(I4B) :: i, j
      real(DP)     :: rji2, rlim2
      real(DP)     :: rx, ry, rz

      ahi(:,:) = 0.0_DP
      ahj(:,:) = 0.0_DP

      !$omp parallel do default(private) schedule(static)&
      !$omp shared(nplpl, k_plpl, r, Gmass, radius) &
      !$omp lastprivate(i, j, rji2, rlim2, rx, ry, rz) &
      !$omp reduction(+:ahi,ahj) 
      do k = 1_I8B, nplpl
         i = k_plpl(1, k)
         j = k_plpl(2, k)
         rx = r(1, j) - r(1, i) 
         ry = r(2, j) - r(2, i) 
         rz = r(3, j) - r(3, i) 
         rji2 = rx**2 + ry**2 + rz**2
         rlim2 = (radius(i) + radius(j))**2
         if (rji2 > rlim2) call swiftest_kick_getacch_int_one_pl(rji2, rx, ry, rz, Gmass(i), Gmass(j), &
                                 ahi(1,i), ahi(2,i), ahi(3,i), ahj(1,j), ahj(2,j), ahj(3,j))
      end do
      !$omp end parallel do 

      acc(:,:) = acc(:,:) + ahi(:,:) + ahj(:,:)

      return
   end subroutine swiftest_kick_getacch_int_all_flat_rad_pl


   module subroutine swiftest_kick_getacch_int_all_flat_norad_pl(npl, nplpl, k_plpl, r, Gmass, acc)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations for massive bodies, with parallelization.
      !! This is the flattened (single loop) version that uses the k_plpl interaction pair index array
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int.f9
      implicit none
      integer(I4B),                 intent(in)             :: npl    !! Number of massive bodies
      integer(I8B),                 intent(in)             :: nplpl  !! Number of massive body interactions to compute
      integer(I4B), dimension(:,:), intent(in)             :: k_plpl !! Array of interaction pair indices (flattened upper triangular matrix)
      real(DP),     dimension(:,:), intent(in)             :: r      !! Position vector array
      real(DP),     dimension(:),   intent(in)             :: Gmass  !! Array of massive body G*mass
      real(DP),     dimension(:,:), intent(inout)          :: acc    !! Acceleration vector array 
      ! Internals
      integer(I8B)                      :: k
      real(DP), dimension(NDIM,npl) :: ahi, ahj
      integer(I4B) :: i, j
      real(DP)     :: rji2
      real(DP)     :: rx, ry, rz

      ahi(:,:) = 0.0_DP
      ahj(:,:) = 0.0_DP

      !$omp parallel do default(private) schedule(static)&
      !$omp shared(nplpl, k_plpl, r, Gmass) &
      !$omp lastprivate(i, j, rji2, rx, ry, rz) &
      !$omp reduction(+:ahi,ahj) 
      do k = 1_I8B, nplpl
         i = k_plpl(1, k)
         j = k_plpl(2, k)
         rx = r(1, j) - r(1, i) 
         ry = r(2, j) - r(2, i) 
         rz = r(3, j) - r(3, i) 
         rji2 = rx**2 + ry**2 + rz**2
         call swiftest_kick_getacch_int_one_pl(rji2, rx, ry, rz, Gmass(i), Gmass(j), &
                                       ahi(1,i), ahi(2,i), ahi(3,i), ahj(1,j), ahj(2,j), ahj(3,j))
      end do
      !$omp end parallel do
     
      acc(:,:) = acc(:,:) + ahi(:,:) + ahj(:,:)

      return
   end subroutine swiftest_kick_getacch_int_all_flat_norad_pl


   module subroutine swiftest_kick_getacch_int_all_tri_rad_pl(npl, nplm, r, Gmass, radius, acc)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations for massive bodies, with parallelization.
      !! This is the upper triangular matrix (double loop) version.
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int.f9
      implicit none
      integer(I4B),                 intent(in)             :: npl    !! Total number of massive bodies
      integer(I4B),                 intent(in)             :: nplm   !! Number of fully interacting massive bodies
      real(DP),     dimension(:,:), intent(in)             :: r      !! Position vector array
      real(DP),     dimension(:),   intent(in)             :: Gmass  !! Array of massive body G*mass
      real(DP),     dimension(:),   intent(in)             :: radius !! Array of massive body radii
      real(DP),     dimension(:,:), intent(inout)          :: acc    !! Acceleration vector array 
      ! Internals
      integer(I4B) :: i, j, nplt
      real(DP)     :: rji2, rlim2, fac, rx, ry, rz
      real(DP), dimension(NDIM,npl) :: ahi, ahj
      logical :: lmtiny

      nplt = npl - nplm
      lmtiny = (nplt > nplm)

      if (lmtiny) then
         ahi(:,:) = 0.0_DP
         ahj(:,:) = 0.0_DP
         !$omp parallel do default(private) schedule(static)&
         !$omp shared(npl, nplm, r, Gmass, radius) &
         !$omp reduction(+:ahi,ahj)
         do i = 1, nplm
#ifdef DOCONLOC
            do concurrent(j = i+1:npl) shared(i,r,radius,ahi,ahj,Gmass) local(rx,ry,rz,rji2,rlim2)
#else
            do concurrent(j = i+1:npl)
#endif
               rx = r(1, j) - r(1, i) 
               ry = r(2, j) - r(2, i) 
               rz = r(3, j) - r(3, i) 
               rji2 = rx**2 + ry**2 + rz**2
               rlim2 = (radius(i) + radius(j))**2
               if (rji2 > rlim2) call swiftest_kick_getacch_int_one_pl(rji2, rx, ry, rz, Gmass(i), Gmass(j), &
                                          ahi(1,i), ahi(2,i), ahi(3,i), ahj(1,j), ahj(2,j), ahj(3,j))
            end do
         end do
         !$omp end parallel do
#ifdef DOCONLOC
         do concurrent(i = 1:npl) shared(acc,ahi,ahj)
#else
         do concurrent(i = 1:npl)
#endif
            acc(:,i) = acc(:,i) + ahi(:,i) + ahj(:,i)
         end do
      else 
         !$omp parallel do default(private) schedule(static)&
         !$omp shared(npl, nplm, r, Gmass, radius, acc)
         do i = 1, nplm
#ifdef DOCONLOC
            do concurrent(j = 1:npl, i/=j) shared(i,r,radius,Gmass,acc) local(rx,ry,rz,rji2,rlim2,fac)
#else
            do concurrent(j = 1:npl, i/=j)
#endif
               rx = r(1,j) - r(1,i)
               ry = r(2,j) - r(2,i)
               rz = r(3,j) - r(3,i)
               rji2 = rx**2 + ry**2 + rz**2
               rlim2 = (radius(i) + radius(j))**2
               if (rji2 > rlim2)  then
                  fac = Gmass(j) / (rji2 * sqrt(rji2))
                  acc(1,i) = acc(1,i) + fac * rx
                  acc(2,i) = acc(2,i) + fac * ry
                  acc(3,i) = acc(3,i) + fac * rz
               end if
            end do
         end do
         !$omp end parallel do

         if (nplt > 0) then
            !$omp parallel do default(private) schedule(static)&
            !$omp shared(npl, nplm, r, Gmass, radius, acc)
            do i = nplm+1,npl
#ifdef DOCONLOC
               do concurrent(j = 1:nplm) shared(i,r,radius,Gmass,acc) local(rx,ry,rz,rji2,rlim2,fac)
#else
               do concurrent(j = 1:nplm)
#endif
                  rx = r(1,j) - r(1,i)
                  ry = r(2,j) - r(2,i)
                  rz = r(3,j) - r(3,i)
                  rji2 = rx**2 + ry**2 + rz**2
                  rlim2 = (radius(i) + radius(j))**2
                  if (rji2 > rlim2)  then
                     fac = Gmass(j) / (rji2 * sqrt(rji2))
                     acc(1,i) = acc(1,i) + fac * rx
                     acc(2,i) = acc(2,i) + fac * ry
                     acc(3,i) = acc(3,i) + fac * rz
                  end if
               end do
            end do
            !$omp end parallel do
         end if

      end if


      return
   end subroutine swiftest_kick_getacch_int_all_tri_rad_pl


   module subroutine swiftest_kick_getacch_int_all_tri_norad_pl(npl, nplm, r, Gmass, acc)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations for massive bodies, with parallelization.
      !! This is the upper triangular matrix (double loop) version.
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int.f9
      implicit none
      integer(I4B),                 intent(in)             :: npl    !! Total number of massive bodies
      integer(I4B),                 intent(in)             :: nplm   !! Number of fully interacting massive bodies
      real(DP),     dimension(:,:), intent(in)             :: r      !! Position vector array
      real(DP),     dimension(:),   intent(in)             :: Gmass  !! Array of massive body G*mass
      real(DP),     dimension(:,:), intent(inout)          :: acc    !! Acceleration vector array 
      ! Internals
      integer(I4B) :: i, j, nplt
      real(DP)     :: rji2, fac, rx, ry, rz
      real(DP), dimension(NDIM,npl) :: ahi, ahj
      logical :: lmtiny

      nplt = npl - nplm
      lmtiny = (nplt > nplm)

      if (lmtiny) then
         ahi(:,:) = 0.0_DP
         ahj(:,:) = 0.0_DP
         !$omp parallel do default(private) schedule(static)&
         !$omp shared(npl, nplm, r, Gmass) &
         !$omp reduction(+:ahi,ahj)
         do i = 1, nplm
#ifdef DOCONLOC
            do concurrent(j = i+1:npl) shared(i,r,Gmass,ahi,ahj) local(rx,ry,rz,rji2)
#else
            do concurrent(j = i+1:npl)
#endif
               rx = r(1, j) - r(1, i) 
               ry = r(2, j) - r(2, i) 
               rz = r(3, j) - r(3, i) 
               rji2 = rx**2 + ry**2 + rz**2
               call swiftest_kick_getacch_int_one_pl(rji2, rx, ry, rz, Gmass(i), Gmass(j), &
                                          ahi(1,i), ahi(2,i), ahi(3,i), ahj(1,j), ahj(2,j), ahj(3,j))
            end do
         end do
         !$omp end parallel do
#ifdef DOCONLOC
         do concurrent(i = 1:npl) shared(acc,ahi,ahj)
#else
         do concurrent(i = 1:npl)
#endif
            acc(:,i) = acc(:,i) + ahi(:,i) + ahj(:,i)
         end do
      else 
         !$omp parallel do default(private) schedule(static)&
         !$omp shared(npl, nplm, r, Gmass, acc)
         do i = 1, nplm
#ifdef DOCONLOC
            do concurrent(j = 1:npl, j/=i) shared(i,r,Gmass, acc) local(rx,ry,rz,rji2,fac)
#else
            do concurrent(j = 1:npl, j/=i)
#endif
               rx = r(1,j) - r(1,i)
               ry = r(2,j) - r(2,i)
               rz = r(3,j) - r(3,i)
               rji2 = rx**2 + ry**2 + rz**2
               fac = Gmass(j) / (rji2 * sqrt(rji2))
               acc(1,i) = acc(1,i) + fac * rx
               acc(2,i) = acc(2,i) + fac * ry
               acc(3,i) = acc(3,i) + fac * rz
            end do
         end do
         !$omp end parallel do

         if (nplt > 0) then
            !$omp parallel do default(private) schedule(static)&
            !$omp shared(npl, nplm, r, Gmass, acc)
            do i = nplm+1,npl
#ifdef DOCONLOC
               do concurrent(j = 1:nplm) shared(i,r,Gmass,acc) local(rx,ry,rz,rji2,fac)
#else
               do concurrent(j = 1:nplm)
#endif
                  rx = r(1,j) - r(1,i)
                  ry = r(2,j) - r(2,i)
                  rz = r(3,j) - r(3,i)
                  rji2 = rx**2 + ry**2 + rz**2
                  fac = Gmass(j) / (rji2 * sqrt(rji2))
                  acc(1,i) = acc(1,i) + fac * rx
                  acc(2,i) = acc(2,i) + fac * ry
                  acc(3,i) = acc(3,i) + fac * rz
               end do
            end do
            !$omp end parallel do
         end if

      end if

      return
   end subroutine swiftest_kick_getacch_int_all_tri_norad_pl


   module subroutine swiftest_kick_getacch_int_all_tp(ntp, npl, rtp, rpl, GMpl, lmask, acc)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations of test particles by massive bodies with parallelisim
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int_tp.f99
      implicit none
      integer(I4B),                 intent(in)    :: ntp    !! Number of test particles
      integer(I4B),                 intent(in)    :: npl    !! Number of massive bodies
      real(DP),     dimension(:,:), intent(in)    :: rtp    !! Test particle position vector array
      real(DP),     dimension(:,:), intent(in)    :: rpl    !! Massive body particle position vector array
      real(DP),     dimension(:),   intent(in)    :: GMpl   !! Array of massive body G*mass
      logical,      dimension(:),   intent(in)    :: lmask  !! Logical mask indicating which test particles should be computed
      real(DP),     dimension(:,:), intent(inout) :: acc    !! Acceleration vector array 
      ! Internals
      real(DP)     :: rji2
      real(DP)     :: rx, ry, rz
      integer(I4B) :: i, j

      !$omp parallel do default(private) schedule(static)&
      !$omp shared(npl, ntp, lmask, rtp, rpl, GMpl) &
      !$omp reduction(+:acc)
      do i = 1, ntp
         if (lmask(i)) then
#ifdef DOCONLOC
            do concurrent (j = 1:npl) shared(rtp,rpl,GMpl,acc) local(rx,ry,rz,rji2)
#else
            do concurrent (j = 1:npl)
#endif
               rx = rtp(1, i) - rpl(1, j)
               ry = rtp(2, i) - rpl(2, j)
               rz = rtp(3, i) - rpl(3, j)
               rji2 = rx**2 + ry**2 + rz**2
               call swiftest_kick_getacch_int_one_tp(rji2, rx, ry, rz, GMpl(j), acc(1,i), acc(2,i), acc(3,i))
            end do
         end if
      end do
      !$omp end parallel do
      
      return
   end subroutine swiftest_kick_getacch_int_all_tp


   pure module subroutine swiftest_kick_getacch_int_one_pl(rji2, xr, yr, zr, Gmi, Gmj, axi, ayi, azi, axj, ayj, azj)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations for a single pair of massive bodies
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int.f9
      implicit none
      real(DP), intent(in)  :: rji2            !! Square of distance between the two bodies
      real(DP), intent(in)  :: xr, yr, zr      !! Distances between the two bodies in x, y, and z directions
      real(DP), intent(in)  :: Gmi             !! G*mass of body i
      real(DP), intent(in)  :: Gmj             !! G*mass of body j
      real(DP), intent(inout) :: axi, ayi, azi !! Acceleration vector components of body i
      real(DP), intent(inout) :: axj, ayj, azj !! Acceleration vector components of body j
      ! Internals
      real(DP) :: faci, facj, irij3

      irij3 = 1.0_DP / (rji2 * sqrt(rji2))
      faci = Gmi * irij3
      facj = Gmj * irij3
      axi = axi + facj * xr
      ayi = ayi + facj * yr
      azi = azi + facj * zr
      axj = axj - faci * xr
      ayj = ayj - faci * yr
      azj = azj - faci * zr

      return
   end subroutine swiftest_kick_getacch_int_one_pl


   pure module subroutine swiftest_kick_getacch_int_one_tp(rji2, xr, yr, zr, GMpl, ax, ay, az)
      !! author: David A. Minton
      !!
      !! Compute direct cross (third) term heliocentric accelerations of a single test particle massive body pair.
      !!
      !! Adapted from Hal Levison's Swift routine getacch_ah3_tp.f
      !! Adapted from David E. Kaufmann's Swifter routine whm_kick_getacch_ah3.f90 and helio_kick_getacch_int_tp.f90
      implicit none
      real(DP), intent(in)  :: rji2         !! Square of distance between the test particle and massive body
      real(DP), intent(in)  :: xr, yr, zr   !! Distances between the two bodies in x, y, and z directions
      real(DP), intent(in)  :: Gmpl         !! G*mass of massive body
      real(DP), intent(inout) :: ax, ay, az !! Acceleration vector components of test particle
      ! Internals
      real(DP) :: fac

      fac = GMpl / (rji2*sqrt(rji2))
      ax = ax - fac * xr
      ay = ay - fac * yr
      az = az - fac * zr

      return
   end subroutine swiftest_kick_getacch_int_one_tp

end submodule s_swiftest_kick

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (swiftest) s_swiftest_util
   use whm
   use rmvs
   use helio
   use symba
   use fraggle
contains


   module subroutine swiftest_util_append_arr_info(arr, source, nold, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append a single array of particle information type onto another. If the destination array is not allocated, or is not big 
      !! enough, this will allocate space for it.
      implicit none
      ! Arguments
      type(swiftest_particle_info), dimension(:), allocatable, intent(inout)        :: arr          !! Destination array 
      type(swiftest_particle_info), dimension(:), allocatable, intent(in)           :: source       !! Array to append 
      integer(I4B),                                            intent(in), optional :: nold         !! Extent of original array. 
                                                                                                    !! If passed, the source array 
                                                                                                    !! will begin at arr(nold+1). 
                                                                                                    !! Otherwise, the size of arr 
                                                                                                    !! will be used.
      logical,                      dimension(:),              intent(in), optional :: lsource_mask !! Logical mask indicating which
                                                                                                    !! elements to append to
      ! Internals
      integer(I4B) :: nnew, nsrc, nend_orig, i
      integer(I4B), dimension(:), allocatable :: idx

      if (.not.allocated(source)) return

      if (present(lsource_mask)) then
         nsrc = count(lsource_mask(:))
      else
         nsrc = size(source)
      end if
      if (nsrc == 0) return

      if (.not.allocated(arr)) then
         nend_orig = 0
         allocate(arr(nsrc))
      else
         if (present(nold)) then
            nend_orig = nold
         else
            nend_orig = size(arr)
         end if
         call util_resize(arr, nend_orig + nsrc)
      end if
      nnew = nend_orig + nsrc

      allocate(idx(nsrc))
      if (present(lsource_mask)) then
         idx = pack([(i, i = 1, size(lsource_mask))], lsource_mask(:))
      else
         idx = [(i, i = 1,nsrc)]
      end  if

      call swiftest_util_copy_particle_info_arr(source(:), arr(nend_orig+1:nnew), idx)

      return
   end subroutine swiftest_util_append_arr_info


   module subroutine swiftest_util_append_arr_kin(arr, source, nold, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append a single array of kinship type onto another. If the destination array is not allocated, or is not big enough, this 
      !! will allocate space for it.
      implicit none
      ! Arguments
      type(swiftest_kinship), dimension(:), allocatable, intent(inout)        :: arr          !! Destination array 
      type(swiftest_kinship), dimension(:), allocatable, intent(in)           :: source       !! Array to append 
      integer(I4B),                                      intent(in), optional :: nold         !! Extent of original array. 
                                                                                              !! If passed, the source array will 
                                                                                              !! begin at arr(nold+1). Otherwise, 
                                                                                              !! the size of arr will be used.
      logical,                dimension(:),              intent(in), optional :: lsource_mask !! Logical mask indicating which 
                                                                                              !! elements to append to
      ! Internals
      integer(I4B) :: nnew, nsrc, nend_orig

      if (.not.allocated(source)) return

      if (present(lsource_mask)) then
         nsrc = count(lsource_mask(:))
      else
         nsrc = size(source)
      end if
      if (nsrc == 0) return

      if (.not.allocated(arr)) then
         nend_orig = 0
         allocate(arr(nsrc))
      else
         if (present(nold)) then
            nend_orig = nold
         else
            nend_orig = size(arr)
         end if
         call util_resize(arr, nend_orig + nsrc)
      end if
      nnew = nend_orig + nsrc

      if (present(lsource_mask)) then
         arr(nend_orig + 1:nnew) = pack(source(1:nsrc), lsource_mask(1:nsrc))
      else
         arr(nend_orig + 1:nnew) = source(1:nsrc)
      end if

      return
   end subroutine swiftest_util_append_arr_kin


   module subroutine swiftest_util_append_body(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one Swiftest body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      ! Arguments
      class(swiftest_body),  intent(inout) :: self         !! Swiftest body object
      class(swiftest_body),  intent(in)    :: source       !! Source object to append
      logical, dimension(:), intent(in)    :: lsource_mask !! Logical mask indicating which elements to append to
      ! Internals


      call util_append(self%id, source%id, lsource_mask=lsource_mask)
      call util_append(self%info, source%info, lsource_mask=lsource_mask)
      call util_append(self%lmask, source%lmask, lsource_mask=lsource_mask)
      call util_append(self%status, source%status, lsource_mask=lsource_mask)
      call util_append(self%ldiscard, source%ldiscard, lsource_mask=lsource_mask)
      call util_append(self%lencounter, source%lencounter, lsource_mask=lsource_mask)
      call util_append(self%lcollision, source%lcollision, lsource_mask=lsource_mask)
      call util_append(self%mu, source%mu, lsource_mask=lsource_mask)
      call util_append(self%rh, source%rh, lsource_mask=lsource_mask)
      call util_append(self%vh, source%vh, lsource_mask=lsource_mask)
      call util_append(self%rb, source%rb, lsource_mask=lsource_mask)
      call util_append(self%vb, source%vb, lsource_mask=lsource_mask)
      call util_append(self%ah, source%ah, lsource_mask=lsource_mask)
      call util_append(self%aobl, source%aobl, lsource_mask=lsource_mask)
      call util_append(self%atide, source%atide, lsource_mask=lsource_mask)
      call util_append(self%agr, source%agr, lsource_mask=lsource_mask)
      call util_append(self%ir3h, source%ir3h, lsource_mask=lsource_mask)
      call util_append(self%isperi, source%isperi, lsource_mask=lsource_mask)
      call util_append(self%peri, source%peri, lsource_mask=lsource_mask)
      call util_append(self%atp, source%atp, lsource_mask=lsource_mask)
      call util_append(self%a, source%a, lsource_mask=lsource_mask)
      call util_append(self%e, source%e, lsource_mask=lsource_mask)
      call util_append(self%inc, source%inc, lsource_mask=lsource_mask)
      call util_append(self%capom, source%capom, lsource_mask=lsource_mask)
      call util_append(self%omega, source%omega, lsource_mask=lsource_mask)
      call util_append(self%capm, source%capm, lsource_mask=lsource_mask)

      self%nbody = self%nbody + count(lsource_mask(:))

      return
   end subroutine swiftest_util_append_body


   module subroutine swiftest_util_append_pl(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one Swiftest body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      ! Arguments
      class(swiftest_pl),              intent(inout) :: self         !! Swiftest massive body object
      class(swiftest_body),            intent(in)    :: source       !! Source object to append
      logical, dimension(:),           intent(in)    :: lsource_mask !! Logical mask indicating which elements to append to

      select type(source)
      class is (swiftest_pl)
         call util_append(self%mass, source%mass, lsource_mask=lsource_mask)
         call util_append(self%Gmass, source%Gmass, lsource_mask=lsource_mask)
         call util_append(self%rhill, source%rhill, lsource_mask=lsource_mask)
         call util_append(self%renc, source%renc, lsource_mask=lsource_mask)
         call util_append(self%radius, source%radius, lsource_mask=lsource_mask)
         call util_append(self%density, source%density, lsource_mask=lsource_mask)
         call util_append(self%rbeg, source%rbeg, lsource_mask=lsource_mask)
         call util_append(self%rend, source%rend, lsource_mask=lsource_mask)
         call util_append(self%vbeg, source%vbeg, lsource_mask=lsource_mask)
         call util_append(self%Ip, source%Ip, lsource_mask=lsource_mask)
         call util_append(self%rot, source%rot, lsource_mask=lsource_mask)
         call util_append(self%k2, source%k2, lsource_mask=lsource_mask)
         call util_append(self%Q, source%Q, lsource_mask=lsource_mask)
         call util_append(self%tlag, source%tlag, lsource_mask=lsource_mask)
         call util_append(self%kin, source%kin, lsource_mask=lsource_mask)
         call util_append(self%lmtiny, source%lmtiny, lsource_mask=lsource_mask)
         call util_append(self%nplenc, source%nplenc, lsource_mask=lsource_mask)
         call util_append(self%ntpenc, source%ntpenc, lsource_mask=lsource_mask)

         if (allocated(self%k_plpl)) deallocate(self%k_plpl)

         call swiftest_util_append_body(self, source, lsource_mask)
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class swiftest_pl or its descendents"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine swiftest_util_append_pl


   module subroutine swiftest_util_append_tp(self, source, lsource_mask)
      !! author: David A. Minton
      !!
      !! Append components from one Swiftest body object to another. 
      !! This method will automatically resize the destination body if it is too small
      implicit none
      ! Arguments
      class(swiftest_tp),              intent(inout) :: self         !! Swiftest test particle object
      class(swiftest_body),            intent(in)    :: source       !! Source object to append
      logical, dimension(:),           intent(in)    :: lsource_mask !! Logical mask indicating which elements to append to

      select type(source)
      class is (swiftest_tp)
         call util_append(self%nplenc, source%nplenc, lsource_mask=lsource_mask)

         call swiftest_util_append_body(self, source, lsource_mask)
      class default
         write(*,*) "Invalid object passed to the append method. Source must be of class swiftest_tp or its descendents"
         call base_util_exit(FAILURE)
      end select

      return
   end subroutine swiftest_util_append_tp


   module subroutine swiftest_util_coord_h2b_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert massive bodies from heliocentric to barycentric coordinates (position and velocity)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_h2b.f90 
      !! Adapted from Hal Levison's Swift routine coord_h2b.f 
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb), intent(inout) :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B)  :: i
      real(DP)      :: Gmtot
      real(DP), dimension(NDIM) :: xtmp, vtmp

      if (self%nbody == 0) return
      associate(pl => self, npl => self%nbody)
         Gmtot = cb%Gmass
         xtmp(:) = 0.0_DP
         vtmp(:) = 0.0_DP
         do i = 1, npl
            if (pl%status(i) == INACTIVE) cycle
            Gmtot = Gmtot + pl%Gmass(i)
            xtmp(:) = xtmp(:) + pl%Gmass(i) * pl%rh(:,i)
            vtmp(:) = vtmp(:) + pl%Gmass(i) * pl%vh(:,i)
         end do
         cb%rb(:) = -xtmp(:) / Gmtot
         cb%vb(:) = -vtmp(:) / Gmtot
         do i = 1, npl
            if (pl%status(i) == INACTIVE) cycle
            pl%rb(:,i) = pl%rh(:,i) + cb%rb(:)
            pl%vb(:,i) = pl%vh(:,i) + cb%vb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_h2b_pl


   module subroutine swiftest_util_coord_h2b_tp(self, cb)
      !! author: David A. Minton
      !!
      !! Convert test particles from heliocentric to barycentric coordinates (position and velocity)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_h2b_tp.f90 
      !! Adapted from Hal Levison's Swift routine coord_h2b_tp.f 
      implicit none
      ! Arguments
      class(swiftest_tp), intent(inout) :: self !! Swiftest test particle object
      class(swiftest_cb), intent(in) :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return
      associate(tp => self)
         ntp = self%nbody
#ifdef DOCONLOC
         do concurrent (i = 1:ntp, tp%status(i) /= INACTIVE) shared(cb,tp)
#else
         do concurrent (i = 1:ntp, tp%status(i) /= INACTIVE)
#endif
            tp%rb(:, i) = tp%rh(:, i) + cb%rb(:)
            tp%vb(:, i) = tp%vh(:, i) + cb%vb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_h2b_tp


   module subroutine swiftest_util_coord_b2h_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert massive bodies from barycentric to heliocentric coordinates (position and velocity)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_b2h.f90 
      !! Adapted from Hal Levison's Swift routine coord_b2h.f 
      implicit none
      ! Arguments
      class(swiftest_pl),     intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb),  intent(inout) :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B)          :: i, npl

      if (self%nbody == 0) return

      associate(pl => self)
         npl = self%nbody
#ifdef DOCONLOC
         do concurrent (i = 1:npl, pl%status(i) /= INACTIVE) shared(cb,pl)
#else
         do concurrent (i = 1:npl, pl%status(i) /= INACTIVE)
#endif
            pl%rh(:, i) = pl%rb(:, i) - cb%rb(:)
            pl%vh(:, i) = pl%vb(:, i) - cb%vb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_b2h_pl


   module subroutine swiftest_util_coord_b2h_tp(self, cb)
      !! author: David A. Minton
      !!
      !! Convert test particles from barycentric to heliocentric coordinates (position and velocity)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_b2h_tp.f90 
      !! Adapted from Hal Levison's Swift routine coord_b2h_tp.f 
      implicit none
      ! Arguments
      class(swiftest_tp),     intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb),  intent(in)    :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return

      associate(tp => self)
         ntp = self%nbody
#ifdef DOCONLOC
         do concurrent(i = 1:ntp, tp%status(i) /= INACTIVE) shared(cb,tp)
#else
         do concurrent(i = 1:ntp, tp%status(i) /= INACTIVE)
#endif
            tp%rh(:, i) = tp%rb(:, i) - cb%rb(:)
            tp%vh(:, i) = tp%vb(:, i) - cb%vb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_b2h_tp


   module subroutine swiftest_util_coord_vb2vh_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert massive bodies from barycentric to heliocentric coordinates (velocity only)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_vb2vh.f90 
      !! Adapted from Hal Levison's Swift routine coord_vb2vh.f 
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb), intent(inout) :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B)              :: i, npl

      if (self%nbody == 0) return

      associate(pl => self)
         npl = self%nbody
         cb%vb(:) = 0.0_DP
         do i = npl, 1, -1
            if (pl%status(i) /= INACTIVE) cb%vb(:) = cb%vb(:) - pl%Gmass(i) * pl%vb(:, i) / cb%Gmass
         end do
#ifdef DOCONLOC
         do concurrent(i = 1:npl) shared(cb,pl)
#else
         do concurrent(i = 1:npl)
#endif
            pl%vh(:, i) = pl%vb(:, i) - cb%vb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_vb2vh_pl


   module subroutine swiftest_util_coord_vb2vh_tp(self, vbcb)
      !! author: David A. Minton
      !!
      !! Convert test particles from barycentric to heliocentric coordinates (velocity only)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_vb2vh_tp.f90 
      !! Adapted from Hal Levison's Swift routine coord_vb2h_tp.f 
      implicit none
      ! Arguments
      class(swiftest_tp),     intent(inout) :: self !! Swiftest test particle object
      real(DP), dimension(:), intent(in)    :: vbcb !! Barycentric velocity of the central body

      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody)
         where (tp%lmask(1:ntp))
            tp%vh(1, 1:ntp) = tp%vb(1, 1:ntp) - vbcb(1)
            tp%vh(2, 1:ntp) = tp%vb(2, 1:ntp) - vbcb(2)
            tp%vh(3, 1:ntp) = tp%vb(3, 1:ntp) - vbcb(3)
         end where
      end associate

      return
   end subroutine swiftest_util_coord_vb2vh_tp


   module subroutine swiftest_util_coord_vh2vb_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert massive bodies from heliocentric to barycentric coordinates (velocity only)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_vh2vb.f90 
      !! Adapted from Hal Levison's Swift routine coord_vh2b.f 
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb), intent(inout) :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B)  :: i, npl
      real(DP)      :: Gmtot

      if (self%nbody == 0) return

      associate(pl => self)
         npl = self%nbody
         Gmtot = cb%Gmass + sum(pl%Gmass(1:npl))
         cb%vb(:) = 0.0_DP
         do i = 1, npl
            cb%vb(:) = cb%vb(:) - pl%Gmass(i) * pl%vh(:, i) 
         end do
         cb%vb(:) = cb%vb(:) / Gmtot
#ifdef DOCONLOC
         do concurrent(i = 1:npl) shared(cb,pl)
#else
         do concurrent(i = 1:npl)
#endif
            pl%vb(:, i) = pl%vh(:, i) + cb%vb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_vh2vb_pl


   module subroutine swiftest_util_coord_vh2vb_tp(self, vbcb)
      !! author: David A. Minton
      !!
      !! Convert test particles from heliocentric to barycentric coordinates (velocity only)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_vh2vb_tp.f90
      !! Adapted from Hal Levison's Swift routine coord_vh2b_tp.f 
      implicit none
      ! Arguments
      class(swiftest_tp),     intent(inout) :: self !! Swiftest test particle object
      real(DP), dimension(:), intent(in)    :: vbcb !! Barycentric velocity of the central body

      if (self%nbody == 0) return

      associate(tp => self, ntp => self%nbody)
         where (tp%lmask(1:ntp))
            tp%vb(1, 1:ntp) = tp%vh(1, 1:ntp) + vbcb(1)
            tp%vb(2, 1:ntp) = tp%vh(2, 1:ntp) + vbcb(2)
            tp%vb(3, 1:ntp) = tp%vh(3, 1:ntp) + vbcb(3)
         end where
      end associate

      return
   end subroutine swiftest_util_coord_vh2vb_tp
   

   module subroutine swiftest_util_coord_rh2rb_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Convert position vectors of massive bodies from heliocentric to barycentric coordinates (position only)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_h2b.f90 
      !! Adapted from Hal Levison's Swift routine coord_h2b.f 
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb), intent(inout) :: cb   !! Swiftest central body object
      ! Internals
      integer(I4B)  :: i
      real(DP)      :: Gmtot
      real(DP), dimension(NDIM) :: xtmp

      if (self%nbody == 0) return
      associate(pl => self, npl => self%nbody)
         Gmtot = cb%Gmass
         xtmp(:) = 0.0_DP
         do i = 1, npl
            if (pl%status(i) == INACTIVE) cycle
            Gmtot = Gmtot + pl%Gmass(i)
            xtmp(:) = xtmp(:) + pl%Gmass(i) * pl%rh(:,i)
         end do
         cb%rb(:) = -xtmp(:) / Gmtot
         do i = 1, npl
            if (pl%status(i) == INACTIVE) cycle
            pl%rb(:,i) = pl%rh(:,i) + cb%rb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_rh2rb_pl


   module subroutine swiftest_util_coord_rh2rb_tp(self, cb)
      !! author: David A. Minton
      !!
      !! Convert test particles from heliocentric to barycentric coordinates (position only)
      !!
      !! Adapted from David E. Kaufmann's Swifter routine coord_h2b_tp.f90 
      !! Adapted from Hal Levison's Swift routine coord_h2b_tp.f 
      implicit none
      ! Arguments
      class(swiftest_tp), intent(inout) :: self !! Swiftest test particle object
      class(swiftest_cb), intent(in) :: cb      !! Swiftest central body object
      ! Internals
      integer(I4B) :: i, ntp

      if (self%nbody == 0) return
      associate(tp => self)
         ntp = self%nbody
#ifdef DOCONLOC
         do concurrent (i = 1:ntp, tp%status(i) /= INACTIVE) shared(cb,tp)
#else
         do concurrent (i = 1:ntp, tp%status(i) /= INACTIVE)
#endif
            tp%rb(:, i) = tp%rh(:, i) + cb%rb(:)
         end do
      end associate

      return
   end subroutine swiftest_util_coord_rh2rb_tp


   module subroutine swiftest_util_copy_particle_info(self, source)
      !! author: David A. Minton
      !!
      !! Copies one set of information object components into another, component-by-component
      implicit none
      class(swiftest_particle_info),  intent(inout) :: self
      class(swiftest_particle_info),  intent(in)    :: source

      call self%set_value(&
         name = source%name, &
         particle_type = source%particle_type, &
         status = source%status, & 
         origin_type = source%origin_type, &
         origin_time = source%origin_time, & 
         collision_id = source%collision_id, &
         origin_rh = source%origin_rh(:), &
         origin_vh = source%origin_vh(:), &
         discard_time = source%discard_time, & 
         discard_rh = source%discard_rh(:), &
         discard_vh = source%discard_vh(:), &
         discard_body_id = source%discard_body_id &
      )

      return
   end subroutine swiftest_util_copy_particle_info


   module subroutine swiftest_util_copy_particle_info_arr(source, dest, idx)
      !! author: David A. Minton
      !!
      !! Copies contents from an array of one particle information objects to another.
      implicit none
      class(swiftest_particle_info), dimension(:), intent(in)             :: source !! Source object to copy into
      class(swiftest_particle_info), dimension(:), intent(inout)          :: dest   !! Swiftest body object with particle metadata 
                                                                                    !! information object
      integer(I4B),                  dimension(:), intent(in),   optional :: idx    !! Optional array of indices to draw the source 
                                                                                    !! object
      ! Internals
      integer(I4B) :: i, j, n, nsource, ndest

      if (size(source) == 0) return

      if (present(idx)) then
         n = size(idx)
      else
         n = size(source)
      end if

      nsource = size(source)
      ndest = size(dest)

      if ((n == 0) .or. (n > ndest) .or. (n > nsource)) then
         write(*,*) 'Particle info copy operation failed. n, nsource, ndest: ',n, nsource, ndest
         return
      end if

      do i = 1, n
         if (present(idx)) then
            j = idx(i)
         else
            j = i
         end if 
         call dest(i)%copy(source(j))
      end do
      
      return
   end subroutine swiftest_util_copy_particle_info_arr


   module subroutine swiftest_util_dealloc_body(self)
      !! author: David A. Minton
      !!
      !! Finalize the Swiftest body object - deallocates all allocatables
      implicit none
      ! Argument
      class(swiftest_body),  intent(inout) :: self

      self%lfirst = .true.
      self%nbody = 0
      if (allocated(self%id)) deallocate(self%id)
      if (allocated(self%info)) deallocate(self%info)
      if (allocated(self%status)) deallocate(self%status)
      if (allocated(self%lmask)) deallocate(self%lmask)
      if (allocated(self%ldiscard)) deallocate(self%ldiscard)
      if (allocated(self%lcollision)) deallocate(self%lcollision)
      if (allocated(self%lencounter)) deallocate(self%lencounter)
      if (allocated(self%mu)) deallocate(self%mu)
      if (allocated(self%rh)) deallocate(self%rh)
      if (allocated(self%vh)) deallocate(self%vh)
      if (allocated(self%rb)) deallocate(self%rb)
      if (allocated(self%vb)) deallocate(self%vb)
      if (allocated(self%ah)) deallocate(self%ah)
      if (allocated(self%aobl)) deallocate(self%aobl)
      if (allocated(self%agr)) deallocate(self%agr)
      if (allocated(self%atide)) deallocate(self%atide)
      if (allocated(self%ir3h)) deallocate(self%ir3h)
      if (allocated(self%isperi)) deallocate(self%isperi)
      if (allocated(self%peri)) deallocate(self%peri)
      if (allocated(self%atp)) deallocate(self%atp)
      if (allocated(self%a)) deallocate(self%a)
      if (allocated(self%e)) deallocate(self%e)
      if (allocated(self%inc)) deallocate(self%inc)
      if (allocated(self%capom)) deallocate(self%capom)
      if (allocated(self%omega)) deallocate(self%omega)
      if (allocated(self%capm)) deallocate(self%capm)

      return
   end subroutine swiftest_util_dealloc_body


   module subroutine swiftest_util_dealloc_cb(self)
      !! author: David A. Minton
      !!
      !! Finalize the Swiftest central body object - deallocates all allocatables
      implicit none
      ! Arguments
      class(swiftest_cb), intent(inout) :: self !! Swiftest central body object

      if (allocated(self%info)) deallocate(self%info)

      self%id       = 0      
      self%mass     = 0.0_DP 
      self%Gmass    = 0.0_DP 
      self%radius   = 0.0_DP 
      self%density  = 1.0_DP 
      self%j2rp2    = 0.0_DP 
      self%j4rp4    = 0.0_DP 
      self%aobl     = 0.0_DP 
      self%atide    = 0.0_DP 
      self%aoblbeg  = 0.0_DP 
      self%aoblend  = 0.0_DP 
      self%atidebeg = 0.0_DP 
      self%atideend = 0.0_DP 
      self%rb       = 0.0_DP 
      self%vb       = 0.0_DP 
      self%agr      = 0.0_DP 
      self%Ip       = 0.0_DP 
      self%rot      = 0.0_DP 
      self%k2       = 0.0_DP 
      self%Q        = 0.0_DP 
      self%tlag     = 0.0_DP 
      self%L0       = 0.0_DP 
      self%dL       = 0.0_DP 
      self%GM0      = 0.0_DP 
      self%dGM      = 0.0_DP 
      self%R0       = 0.0_DP 
      self%dR       = 0.0_DP 

      return
   end subroutine swiftest_util_dealloc_cb


   module subroutine swiftest_util_dealloc_kin(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatabale arrays
      implicit none
      ! Arguments
      class(swiftest_kinship),  intent(inout) :: self !! Swiftest kinship object

      if (allocated(self%child)) deallocate(self%child)

      return
   end subroutine swiftest_util_dealloc_kin


   module subroutine swiftest_util_dealloc_pl(self)
      !! author: David A. Minton
      !!
      !! Finalize the Swiftest massive body object - deallocates all allocatables
      implicit none
      ! Argument
      class(swiftest_pl),  intent(inout) :: self !! Swiftest massive body object
      ! Internals
      integer(I4B) :: i

      if (allocated(self%mass)) deallocate(self%mass)
      if (allocated(self%Gmass)) deallocate(self%Gmass)
      if (allocated(self%rhill)) deallocate(self%rhill)
      if (allocated(self%renc)) deallocate(self%renc)
      if (allocated(self%radius)) deallocate(self%radius)
      if (allocated(self%density)) deallocate(self%density)
      if (allocated(self%rbeg)) deallocate(self%rbeg)
      if (allocated(self%rend)) deallocate(self%rend)
      if (allocated(self%vbeg)) deallocate(self%vbeg)
      if (allocated(self%Ip)) deallocate(self%Ip)
      if (allocated(self%rot)) deallocate(self%rot)
      if (allocated(self%k2)) deallocate(self%k2)
      if (allocated(self%Q)) deallocate(self%Q)
      if (allocated(self%tlag)) deallocate(self%tlag)
      if (allocated(self%k_plpl)) deallocate(self%k_plpl)
      if (allocated(self%lmtiny)) deallocate(self%lmtiny)
      if (allocated(self%nplenc)) deallocate(self%nplenc)
      if (allocated(self%ntpenc)) deallocate(self%ntpenc)


      if (allocated(self%kin)) then
         do i = 1, self%nbody
            call self%kin(i)%dealloc()
         end do
         deallocate(self%kin)
      end if

      call swiftest_util_dealloc_body(self)

      return
   end subroutine swiftest_util_dealloc_pl


   module subroutine swiftest_util_dealloc_storage(self)
      !! author: David A. Minton
      !!
      !! Resets a storage object by deallocating all items and resetting the frame counter to 0
      use base, only : base_util_dealloc_storage
      implicit none
      ! Arguments
      class(swiftest_storage), intent(inout) :: self !! Swiftest storage object

      if (allocated(self%nc)) deallocate(self%nc)
      call base_util_dealloc_storage(self)

      return
   end subroutine swiftest_util_dealloc_storage


   module subroutine swiftest_util_dealloc_system(self)
      !! author: David A. Minton
      !!
      !! Deallocates all allocatables and resets all values to defaults. Acts as a base for a finalizer
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self

      if (allocated(self%cb)) deallocate(self%cb)
      if (allocated(self%pl)) deallocate(self%pl)
      if (allocated(self%tp)) deallocate(self%tp)
      if (allocated(self%tp_discards)) deallocate(self%tp_discards)
      if (allocated(self%pl_discards)) deallocate(self%pl_discards)
      if (allocated(self%pl_adds)) deallocate(self%pl_adds)
      if (allocated(self%tp_adds)) deallocate(self%tp_adds)
      if (allocated(self%pltp_encounter)) deallocate(self%pltp_encounter)
      if (allocated(self%plpl_encounter)) deallocate(self%plpl_encounter)
      if (allocated(self%plpl_collision)) deallocate(self%plpl_collision)
      if (allocated(self%pltp_collision)) deallocate(self%pltp_collision)
      if (allocated(self%collider)) deallocate(self%collider)
      if (allocated(self%encounter_history)) deallocate(self%encounter_history)
      if (allocated(self%collision_history)) deallocate(self%collision_history)

      self%t = -1.0_DP            
      self%GMtot = 0.0_DP         
      self%ke_orbit = 0.0_DP      
      self%ke_spin = 0.0_DP       
      self%pe = 0.0_DP            
      self%be = 0.0_DP            
      self%te = 0.0_DP            
      self%oblpot = 0.0_DP        
      self%L_orbit = 0.0_DP        
      self%L_spin = 0.0_DP         
      self%L_total = 0.0_DP          
      self%ke_orbit_orig = 0.0_DP 
      self%ke_spin_orig = 0.0_DP  
      self%pe_orig = 0.0_DP       
      self%be_orig = 0.0_DP       
      self%E_orbit_orig = 0.0_DP   
      self%GMtot_orig = 0.0_DP    
      self%L_total_orig = 0.0_DP     
      self%L_orbit_orig = 0.0_DP   
      self%L_spin_orig = 0.0_DP    
      self%L_escape = 0.0_DP       
      self%GMescape = 0.0_DP      
      self%E_collisions = 0.0_DP   
      self%E_untracked = 0.0_DP    

      self%ke_orbit_error    = 0.0_DP
      self%ke_spin_error     = 0.0_DP
      self%pe_error          = 0.0_DP
      self%be_error          = 0.0_DP
      self%E_orbit_error     = 0.0_DP
      self%Ecoll_error       = 0.0_DP
      self%E_untracked_error = 0.0_DP
      self%te_error          = 0.0_DP
      self%L_orbit_error     = 0.0_DP
      self%L_spin_error      = 0.0_DP
      self%L_escape_error    = 0.0_DP
      self%L_total_error     = 0.0_DP
      self%Mtot_error        = 0.0_DP
      self%Mescape_error     = 0.0_DP

      return
   end subroutine swiftest_util_dealloc_system


   module subroutine swiftest_util_dealloc_tp(self)
      !! author: David A. Minton
      !!
      !! Finalize the Swiftest test particle object - deallocates all allocatables
      implicit none
      ! Argument
      class(swiftest_tp),  intent(inout) :: self !! Swiftest test particle object

      if (allocated(self%k_pltp)) deallocate(self%k_pltp)
      if (allocated(self%nplenc)) deallocate(self%nplenc)

      call swiftest_util_dealloc_body(self)

      return
   end subroutine swiftest_util_dealloc_tp


   module subroutine swiftest_util_fill_arr_info(keeps, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Performs a fill operation on a single array of particle origin information types
      !! This is the inverse of a spill operation
      implicit none
      ! Arguments
      type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: keeps      !! Array of values to keep 
      type(swiftest_particle_info), dimension(:), allocatable, intent(in)    :: inserts    !! Array of values to insert into keep
      logical,                      dimension(:),              intent(in)    :: lfill_list !! Logical array of bodies to merge into
                                                                                           !! the keeps
      ! Internals
      integer(I4B), dimension(:), allocatable  :: insert_idx
      integer(I4B) :: i, nkeep, ninsert

      if (.not.allocated(keeps) .or. .not.allocated(inserts)) return

      nkeep = size(keeps)
      ninsert = count(lfill_list)

      allocate(insert_idx(ninsert))

      insert_idx(:) = pack([(i, i = 1, nkeep)], lfill_list)
      call swiftest_util_copy_particle_info_arr(inserts, keeps, insert_idx)

      return
   end subroutine swiftest_util_fill_arr_info


   module subroutine swiftest_util_fill_arr_kin(keeps, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Performs a fill operation on a single array of particle kinship types
      !! This is the inverse of a spill operation   
      implicit none
      ! Arguments
      type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: keeps      !! Array of values to keep 
      type(swiftest_kinship), dimension(:), allocatable, intent(in)    :: inserts    !! Array of values to insert into keep
      logical,             dimension(:),              intent(in)    :: lfill_list !! Logical array of bodies to merge into the keeps

      if (.not.allocated(keeps) .or. .not.allocated(inserts)) return

      keeps(:) = unpack(keeps(:),   .not.lfill_list(:), keeps(:))
      keeps(:) = unpack(inserts(:),      lfill_list(:), keeps(:))
   
      return
   end subroutine swiftest_util_fill_arr_kin


   module subroutine swiftest_util_fill_body(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new Swiftest generic particle structure into an old one. 
      !! This is the inverse of a spill operation.
      implicit none
      ! Arguments
      class(swiftest_body),  intent(inout) :: self       !! Swiftest generic body object
      class(swiftest_body),  intent(in)    :: inserts    !! Inserted object 
      logical, dimension(:), intent(in)    :: lfill_list !! Logical array of bodies to merge into the keeps

      ! For each component, pack the discarded bodies into the discard object and do the inverse with the keeps
      !> Fill all the common components
      associate(keeps => self)
         call util_fill(keeps%id,         inserts%id,         lfill_list)
         call util_fill(keeps%info,       inserts%info,       lfill_list)
         call util_fill(keeps%lmask,      inserts%lmask,      lfill_list)
         call util_fill(keeps%status,     inserts%status,     lfill_list)
         call util_fill(keeps%ldiscard,   inserts%ldiscard,   lfill_list)
         call util_fill(keeps%lcollision, inserts%lcollision, lfill_list)
         call util_fill(keeps%lencounter, inserts%lencounter, lfill_list)
         call util_fill(keeps%mu,         inserts%mu,         lfill_list)
         call util_fill(keeps%rh,         inserts%rh,         lfill_list)
         call util_fill(keeps%vh,         inserts%vh,         lfill_list)
         call util_fill(keeps%rb,         inserts%rb,         lfill_list)
         call util_fill(keeps%vb,         inserts%vb,         lfill_list)
         call util_fill(keeps%ah,         inserts%ah,         lfill_list)
         call util_fill(keeps%aobl,       inserts%aobl,       lfill_list)
         call util_fill(keeps%agr,        inserts%agr,        lfill_list)
         call util_fill(keeps%atide,      inserts%atide,      lfill_list)
         call util_fill(keeps%ir3h,       inserts%ir3h,       lfill_list)
         call util_fill(keeps%isperi,     inserts%isperi,     lfill_list)
         call util_fill(keeps%peri,       inserts%peri,       lfill_list)
         call util_fill(keeps%atp,        inserts%atp,        lfill_list)
         call util_fill(keeps%a,          inserts%a,          lfill_list)
         call util_fill(keeps%e,          inserts%e,          lfill_list)
         call util_fill(keeps%inc,        inserts%inc,        lfill_list)
         call util_fill(keeps%capom,      inserts%capom,      lfill_list)
         call util_fill(keeps%omega,      inserts%omega,      lfill_list)
         call util_fill(keeps%capm,       inserts%capm,       lfill_list)
           
         ! This is the base class, so will be the last to be called in the cascade. 
         keeps%nbody = size(keeps%id(:))
      end associate
     
      return
   end subroutine swiftest_util_fill_body


   module subroutine swiftest_util_fill_pl(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new Swiftest massive body structure into an old one. 
      !! This is the inverse of a spill operation.
      implicit none
      ! Arguments
      class(swiftest_pl),    intent(inout) :: self       !! Swiftest massive body object
      class(swiftest_body),  intent(in)    :: inserts    !! Swiftest body object to be inserted
      logical, dimension(:), intent(in)    :: lfill_list !! Logical array of bodies to merge into the keeps

      associate(keeps => self)

      select type (inserts) ! The standard requires us to select the type of both arguments in order to access all the components
         class is (swiftest_pl)
            !> Fill components specific to the massive body class
            call util_fill(keeps%mass,    inserts%mass,    lfill_list)
            call util_fill(keeps%Gmass,   inserts%Gmass,   lfill_list)
            call util_fill(keeps%rhill,   inserts%rhill,   lfill_list)
            call util_fill(keeps%renc,    inserts%renc,    lfill_list)
            call util_fill(keeps%radius,  inserts%radius,  lfill_list)
            call util_fill(keeps%density, inserts%density, lfill_list)
            call util_fill(keeps%rbeg,    inserts%rbeg,    lfill_list)
            call util_fill(keeps%rend,    inserts%rend,    lfill_list)
            call util_fill(keeps%vbeg,    inserts%vbeg,    lfill_list)
            call util_fill(keeps%Ip,      inserts%Ip,      lfill_list)
            call util_fill(keeps%rot,     inserts%rot,     lfill_list)
            call util_fill(keeps%k2,      inserts%k2,      lfill_list)
            call util_fill(keeps%Q,       inserts%Q,       lfill_list)
            call util_fill(keeps%tlag,    inserts%tlag,    lfill_list)
            call util_fill(keeps%kin,     inserts%kin,     lfill_list)
            call util_fill(keeps%nplenc,  inserts%nplenc,  lfill_list)
            call util_fill(keeps%ntpenc,  inserts%ntpenc,  lfill_list)

            if (allocated(keeps%k_plpl)) deallocate(keeps%k_plpl)
            
            call swiftest_util_fill_body(keeps, inserts, lfill_list)
         class default
            write(*,*) 'Error! fill method called for incompatible return type on swiftest_pl'
         end select
      end associate

      return
   end subroutine swiftest_util_fill_pl


   module subroutine swiftest_util_fill_tp(self, inserts, lfill_list)
      !! author: David A. Minton
      !!
      !! Insert new Swiftest test particle structure into an old one. 
      !! This is the inverse of a fill operation.
      implicit none
      ! Arguments
      class(swiftest_tp),    intent(inout) :: self       !! Swiftest test particle object
      class(swiftest_body),  intent(in)    :: inserts    !! Swiftest body object to be inserted
      logical, dimension(:), intent(in)    :: lfill_list !! Logical array of bodies to merge into the keeps

      associate(keeps => self)
         select type(inserts)
         class is (swiftest_tp)
            !> Spill components specific to the test particle class
            call util_fill(keeps%nplenc,  inserts%nplenc,  lfill_list)

            call swiftest_util_fill_body(keeps, inserts, lfill_list)
         class default
            write(*,*) 'Error! fill method called for incompatible return type on swiftest_tp'
         end select
      end associate

      return
   end subroutine swiftest_util_fill_tp


   pure module subroutine swiftest_util_flatten_eucl_ij_to_k(n, i, j, k)
      !! author: Jacob R. Elliott and David A. Minton
      !!
      !! Turns i,j indices into k index for use in the Euclidean distance matrix for pl-pl interactions.
      !!
      !! Reference:
      !!
      !!    Mélodie Angeletti, Jean-Marie Bonny, Jonas Koko. Parallel Euclidean distance matrix computation on big datasets *. 
      !!       2019. hal-0204751
      implicit none
      ! Arguments
      integer(I4B), intent(in)  :: n !! Number of bodies
      integer(I4B), intent(in)  :: i !! Index of the ith body
      integer(I4B), intent(in)  :: j !! Index of the jth body
      integer(I8B), intent(out) :: k !! Index of the flattened matrix
      ! Internals
      integer(I8B) :: i8, j8, n8
     
      i8 = int(i, kind=I8B)
      j8 = int(j, kind=I8B)
      n8 = int(n, kind=I8B)
      k = (i8 - 1_I8B) * n8 - i8 * (i8 - 1_I8B) / 2_I8B + (j8 - i8)

      return
   end subroutine swiftest_util_flatten_eucl_ij_to_k


   pure module subroutine swiftest_util_flatten_eucl_k_to_ij(n, k, i, j)
      !! author: Jacob R. Elliott and David A. Minton
      !!
      !! Turns k index into i,j indices for use in the Euclidean distance matrix for pl-pl interactions.
      !!
      !! Reference:
      !!
      !!    Mélodie Angeletti, Jean-Marie Bonny, Jonas Koko. Parallel Euclidean distance matrix computation on big datasets *. 
      !!       2019. hal-0204751
      implicit none
      ! Arguments
      integer(I4B), intent(in)  :: n !! Number of bodies
      integer(I8B), intent(in)  :: k !! Index of the flattened matrix
      integer(I4B), intent(out) :: i !! Index of the ith body
      integer(I4B), intent(out) :: j !! Index of the jth body
      ! Internals
      integer(I8B) :: kp, p, i8, j8, n8

      n8 = int(n, kind=I8B)
    
      kp = n8 * (n8 - 1_I8B) / 2_I8B - k
      p = floor((sqrt(1._DP + 8_I8B * kp) - 1_I8B) / 2_I8B)
      i8 = n8 - 1_I8B - p
      j8 = k - (n8 - 1_I8B) * (n8 - 2_I8B) / 2_I8B + p * (p + 1_I8B) / 2_I8B + 1_I8B

      i = int(i8, kind=I4B)
      j = int(j8, kind=I4B)

      return
   end subroutine swiftest_util_flatten_eucl_k_to_ij


   module subroutine swiftest_util_flatten_eucl_plpl(self, param)
      !! author: Jacob R. Elliott and David A. Minton
      !!
      !! Turns i,j indices into k index for use in the Euclidean distance matrix for pl-pl interactions for a Swiftest massive body 
      !! object
      !!
      !! Reference:
      !!
      !!    Mélodie Angeletti, Jean-Marie Bonny, Jonas Koko. Parallel Euclidean distance matrix computation on big datasets *. 
      !!       2019. hal-0204751
      implicit none
      ! Arguments
      class(swiftest_pl),         intent(inout) :: self  !! Swiftest massive body object
      class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B) :: err, i, j, npl
      integer(I8B) :: k, npl8

      associate(nplpl => self%nplpl)
         npl = self%nbody
         npl8 = int(npl, kind=I8B)
         nplpl = npl8 * (npl8 - 1_I8B) / 2_I8B ! number of entries in a strict lower triangle, npl x npl
         if (param%lflatten_interactions) then
            if (allocated(self%k_plpl)) deallocate(self%k_plpl) ! Reset the index array if it's been set previously
            allocate(self%k_plpl(2, nplpl), stat=err)
            if (err /=0) then ! An error occurred trying to allocate this big array. This probably means it's too big to fit in 
                              ! memory, and so we will force the run back into triangular mode
               param%lflatten_interactions = .false.
            else
#ifdef DOCONLOC
               do concurrent (i=1:npl, j=1:npl, j>i) shared(self) local(k)
#else
               do concurrent (i=1:npl, j=1:npl, j>i)
#endif
                  call swiftest_util_flatten_eucl_ij_to_k(npl, i, j, k)
                  self%k_plpl(1, k) = i
                  self%k_plpl(2, k) = j
               end do
            end if
         end if
      end associate

      return
   end subroutine swiftest_util_flatten_eucl_plpl


   module subroutine swiftest_util_flatten_eucl_pltp(self, pl, param)
      !! author: Jacob R. Elliott and David A. Minton
      !!
      !! Turns i,j indices into k index for use in the Euclidean distance matrix for pl-tp interactions
      !!
      !! Reference:
      !!
      !!    Mélodie Angeletti, Jean-Marie Bonny, Jonas Koko. Parallel Euclidean distance matrix computation on big datasets *. 
      !!       2019. hal-0204751
      implicit none
      ! Arguments
      class(swiftest_tp),         intent(inout) :: self  !! Swiftest test particle object
      class(swiftest_pl),         intent(in)    :: pl    !! Swiftest massive body object
      class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B) :: i, j
      integer(I8B) :: counter, npl8, ntp8

      associate(ntp => self%nbody, npl => pl%nbody, npltp => self%npltp)
         npl8 = int(npl, kind=I8B)
         ntp8 = int(ntp, kind=I8B)
         npltp = npl8 * ntp8 
         if (allocated(self%k_pltp)) deallocate(self%k_pltp) ! Reset the index array if it's been set previously
         allocate(self%k_pltp(2, npltp))
         counter = 1_I8B
         do i = 1, npl
            do j = 1,  ntp
               self%k_pltp(1, counter) = i
               self%k_pltp(2, counter) = j
               counter = counter + 1_I8B
            end do
         end do
      end associate

      return
   end subroutine swiftest_util_flatten_eucl_pltp


   module subroutine swiftest_util_get_energy_and_momentum_system(self, param)
      !! author: David A. Minton
      !!
      !! Compute total nbody_system angular momentum vector and kinetic, potential and total nbody_system energy
      !!  
      !! Adapted from David E. Kaufmann Swifter routine symba_energy_eucl.f90
      !!  
      !! Adapted from Martin Duncan's Swift routine anal_energy.f
      implicit none
      class(swiftest_nbody_system), intent(inout) :: self     !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param    !! Current run configuration parameters
      ! Internals
      integer(I4B) :: i,j, npl
      real(DP) :: kecb, kespincb
      real(DP), dimension(self%pl%nbody) :: kepl, kespinpl
      real(DP), dimension(NDIM,self%pl%nbody) :: Lplorbit
      real(DP), dimension(NDIM,self%pl%nbody) :: Lplspin
      real(DP), dimension(NDIM) :: Lcborbit, Lcbspin
      real(DP), dimension(NDIM) :: h

      associate(nbody_system => self, pl => self%pl, cb => self%cb)
         npl = self%pl%nbody
         nbody_system%L_orbit(:) = 0.0_DP
         nbody_system%L_spin(:) = 0.0_DP
         nbody_system%L_total(:) = 0.0_DP
         nbody_system%ke_orbit = 0.0_DP
         nbody_system%ke_spin = 0.0_DP

         nbody_system%GMtot = cb%Gmass
         if (npl > 0) then
            kepl(:) = 0.0_DP
            Lplorbit(:,:) = 0.0_DP
            Lplspin(:,:) = 0.0_DP
            pl%lmask(1:npl) = pl%status(1:npl) /= INACTIVE
            nbody_system%GMtot = nbody_system%GMtot + sum(pl%Gmass(1:npl), pl%lmask(1:npl)) 
         end if
            
         kecb = cb%mass * dot_product(cb%vb(:), cb%vb(:))
         nbody_system%be_cb = -3*cb%Gmass * cb%mass / (5 * cb%radius) 
         Lcborbit(:) = cb%mass * (cb%rb(:) .cross. cb%vb(:))
         if (npl > 0) then

#ifdef DOCONLOC
            do concurrent (i = 1:npl, pl%lmask(i)) shared(pl,Lplorbit,kepl,npl) local(h) 
#else
            do concurrent (i = 1:npl, pl%lmask(i))
#endif
               h(1) = pl%rb(2,i) * pl%vb(3,i) - pl%rb(3,i) * pl%vb(2,i)
               h(2) = pl%rb(3,i) * pl%vb(1,i) - pl%rb(1,i) * pl%vb(3,i)
               h(3) = pl%rb(1,i) * pl%vb(2,i) - pl%rb(2,i) * pl%vb(1,i)
   
            ! Angular momentum from orbit 
               Lplorbit(:,i) = pl%mass(i) * h(:)

               ! Kinetic energy from orbit
               kepl(i) = pl%mass(i) * dot_product(pl%vb(:,i), pl%vb(:,i)) 
            end do
         end if

         if (param%lrotation) then
            kespincb = cb%mass * cb%Ip(3) * cb%radius**2 * dot_product(cb%rot(:), cb%rot(:))

            ! For simplicity, we always assume that the rotation pole is the 3rd principal axis
            Lcbspin(:) = cb%Ip(3) * cb%mass * cb%radius**2 * cb%rot(:)

            if (npl > 0) then
#ifdef DOCONLOC
               do concurrent (i = 1:npl, pl%lmask(i)) shared(pl,Lplspin,kespinpl)
#else
               do concurrent (i = 1:npl, pl%lmask(i))
#endif
                  ! Currently we assume that the rotation pole is the 3rd principal axis
                  ! Angular momentum from spin
                  Lplspin(:,i) = pl%mass(i) * pl%Ip(3,i) * pl%radius(i)**2 * pl%rot(:,i)

                  ! Kinetic energy from spin
                  kespinpl(i) = pl%mass(i) * pl%Ip(3,i) * pl%radius(i)**2 * dot_product(pl%rot(:,i), pl%rot(:,i))
               end do

               nbody_system%ke_spin = 0.5_DP * (kespincb + sum(kespinpl(1:npl), pl%lmask(1:npl)))
            else
               nbody_system%ke_spin = 0.5_DP * kespincb
            end if

            if (npl > 0) then
#ifdef DOCONLOC
               do concurrent (j = 1:NDIM) shared(nbody_system,pl,Lplspin,Lcbspin)
#else
               do concurrent (j = 1:NDIM)
#endif
                  nbody_system%L_spin(j) = Lcbspin(j) + sum(Lplspin(j,1:npl), pl%lmask(1:npl))
               end do
            else
               nbody_system%L_spin(:) = Lcbspin(:)
            end if
         else
            nbody_system%ke_spin = 0.0_DP
            nbody_system%L_spin(:) = 0.0_DP
         end if
 
         if (npl > 0) then
            if (param%lflatten_interactions) then
               call swiftest_util_get_potential_energy(npl, pl%nplpl, pl%k_plpl, pl%lmask, cb%Gmass, pl%Gmass, pl%mass, pl%rb, &
                                                      nbody_system%pe)
            else
               call swiftest_util_get_potential_energy(npl, pl%lmask, cb%Gmass, pl%Gmass, pl%mass, pl%rb, nbody_system%pe)
            end if
         end if

         ! Potential energy from the oblateness term
         if (param%lnon_spherical_cb) then
            call nbody_system%obl_pot()
            nbody_system%pe = nbody_system%pe + nbody_system%oblpot
         end if

         if (npl > 0) then
            nbody_system%ke_orbit = 0.5_DP * (kecb + sum(kepl(1:npl), pl%lmask(1:npl)))
#ifdef DOCONLOC
            do concurrent (j = 1:NDIM) shared(nbody_system,pl,Lcborbit,Lplorbit,npl)
#else  
            do concurrent (j = 1:NDIM)
#endif
               nbody_system%L_orbit(j) = Lcborbit(j) + sum(Lplorbit(j,1:npl), pl%lmask(1:npl)) 
            end do
         else
            nbody_system%ke_orbit = 0.5_DP * kecb
            nbody_system%L_orbit(:) = Lcborbit(:)
         end if

         if ((param%lclose .and. (npl > 0))) then
            nbody_system%be = sum(-3*pl%Gmass(1:npl)*pl%mass(1:npl)/(5*pl%radius(1:npl)), pl%lmask(1:npl)) 
         else
            nbody_system%be = 0.0_DP
         end if
         nbody_system%te = nbody_system%ke_orbit + nbody_system%ke_spin + nbody_system%pe + nbody_system%be 
         nbody_system%L_total(:) = nbody_system%L_orbit(:) + nbody_system%L_spin(:)
      end associate

      return
   end subroutine swiftest_util_get_energy_and_momentum_system


   module subroutine swiftest_util_get_potential_energy_flat(npl, nplpl, k_plpl, lmask, GMcb, Gmass, mass, rb, pe)
      !! author: David A. Minton
      !!
      !! Compute total nbody_system potential energy
      implicit none
      ! Arguments
      integer(I4B),                 intent(in)  :: npl
      integer(I8B),                 intent(in)  :: nplpl
      integer(I4B), dimension(:,:), intent(in)  :: k_plpl
      logical,      dimension(:),   intent(in)  :: lmask
      real(DP),                     intent(in)  :: GMcb
      real(DP),     dimension(:),   intent(in)  :: Gmass
      real(DP),     dimension(:),   intent(in)  :: mass
      real(DP),     dimension(:,:), intent(in)  :: rb
      real(DP),                     intent(out) :: pe
      ! Internals
      integer(I4B) :: i, j
      integer(I8B) :: k
      real(DP), dimension(npl) :: pecb
      real(DP), dimension(nplpl) :: pepl 
      logical, dimension(nplpl) :: lstatpl

      ! Do the central body potential energy component first
      where(.not. lmask(1:npl))
         pecb(1:npl) = 0.0_DP
      end where

#ifdef DOCONLOC
      do concurrent(i = 1:npl, lmask(i)) shared(lmask,pecb,GMcb,mass,rb)
#else
      do concurrent(i = 1:npl, lmask(i))
#endif
         pecb(i) = -GMcb * mass(i) / norm2(rb(:,i)) 
      end do

      !$omp parallel do default(private) schedule(static)&
      !$omp shared(k_plpl, rb, mass, Gmass, pepl, lstatpl, lmask) &
      !$omp firstprivate(nplpl)
      do k = 1, nplpl
         i = k_plpl(1,k)
         j = k_plpl(2,k)
         lstatpl(k) = (lmask(i) .and. lmask(j))
         if (lstatpl(k)) then
            pepl(k) = -(Gmass(i) * mass(j)) / norm2(rb(:, i) - rb(:, j))
         else
            pepl(k) = 0.0_DP
         end if
      end do
      !$omp end parallel do 

      pe = sum(pepl(:), lstatpl(:)) + sum(pecb(1:npl), lmask(1:npl))

      return
   end subroutine swiftest_util_get_potential_energy_flat


   module subroutine swiftest_util_get_potential_energy_triangular(npl, lmask, GMcb, Gmass, mass, rb, pe)
      !! author: David A. Minton
      !!
      !! Compute total nbody_system potential energy
      implicit none
      ! Arguments
      integer(I4B),                 intent(in)  :: npl
      logical,      dimension(:),   intent(in)  :: lmask
      real(DP),                     intent(in)  :: GMcb
      real(DP),     dimension(:),   intent(in)  :: Gmass
      real(DP),     dimension(:),   intent(in)  :: mass
      real(DP),     dimension(:,:), intent(in)  :: rb
      real(DP),                     intent(out) :: pe
      ! Internals
      integer(I4B) :: i, j
      real(DP), dimension(npl) :: pecb, pepl

      ! Do the central body potential energy component first
      where(.not. lmask(1:npl))
         pecb(1:npl) = 0.0_DP
      end where

#ifdef DOCONLOC
      do concurrent(i = 1:npl, lmask(i)) shared(lmask, pecb, GMcb, mass, rb, lmask)
#else
      do concurrent(i = 1:npl, lmask(i))
#endif
         pecb(i) = -GMcb * mass(i) / norm2(rb(:,i)) 
      end do

      pe = 0.0_DP
      !$omp parallel do default(private) schedule(static)&
      !$omp shared(lmask, Gmass, mass, rb) &
      !$omp firstprivate(npl) &
      !$omp reduction(+:pe) 
      do i = 1, npl
         if (lmask(i)) then
#ifdef DOCONLOC
            do concurrent(j = i+1:npl, lmask(i) .and. lmask(j)) shared(lmask, pepl, rb, mass, Gmass, lmask) 
#else
            do concurrent(j = i+1:npl, lmask(i) .and. lmask(j))
#endif
               pepl(j) = - (Gmass(i) * mass(j)) / norm2(rb(:, i) - rb(:, j))
            end do
            pe = pe + sum(pepl(i+1:npl), lmask(i+1:npl))
         end if
      end do
      !$omp end parallel do
      pe = pe + sum(pecb(1:npl), lmask(1:npl))

      return
   end subroutine swiftest_util_get_potential_energy_triangular


   module subroutine swiftest_util_get_idvalues_system(self, idvals)
      !! author: David A. Minton
      !!
      !! Returns an array of all id values saved in this snapshot
      implicit none
      ! Arguments
      class(swiftest_nbody_system),            intent(in)  :: self   !! Encounter snapshot object
      integer(I4B), dimension(:), allocatable, intent(out) :: idvals !! Array of all id values saved in this snapshot
      ! Internals
      integer(I4B) :: npl, ntp

      if (allocated(self%pl)) then
         npl = self%pl%nbody
      else
         npl = 0
      end if 
      if (allocated(self%tp)) then
         ntp = self%tp%nbody
      else
         ntp = 0
      end if

      allocate(idvals(1 + npl+ntp))

      idvals(1) = self%cb%id
      if (npl > 0) idvals(2:npl+1) = self%pl%id(:)
      if (ntp > 0) idvals(npl+2:npl+ntp+1) = self%tp%id(:)

      return

   end subroutine swiftest_util_get_idvalues_system


   module subroutine swiftest_util_get_vals_storage(self, idvals, tvals)
      !! author: David A. Minton
      !!
      !! Gets the id values in a storage object, regardless of whether it is encounter of collision
      ! Argument
      class(swiftest_storage),              intent(in)  :: self   !! Swiftest storage object
      integer(I4B), dimension(:), allocatable, intent(out) :: idvals !! Array of all id values in all snapshots
      real(DP),     dimension(:), allocatable, intent(out) :: tvals  !! Array of all time values in all snapshots
      ! Internals
      integer(I4B) :: i, n, nlo, nhi, ntotal
      integer(I4B), dimension(:), allocatable :: itmp

      associate(storage => self, nsnaps => self%iframe)

         allocate(tvals(nsnaps))
         tvals(:) = 0.0_DP

         ! First pass to get total number of ids
         ntotal = 0
         do i = 1, nsnaps
            if (allocated(storage%frame(i)%item)) then
               select type(snapshot => storage%frame(i)%item)
               class is (swiftest_nbody_system)
                  tvals(i) = snapshot%t
                  call snapshot%get_idvals(itmp)
                  if (allocated(itmp)) then
                     n = size(itmp)
                     ntotal = ntotal + n
                  end if
               end select
            end if
         end do

         allocate(idvals(ntotal))
         nlo = 1
         ! Second pass to store all ids get all of the ids stored
         do i = 1, nsnaps
            if (allocated(storage%frame(i)%item)) then
               select type(snapshot => storage%frame(i)%item)
               class is (swiftest_nbody_system)
                  tvals(i) = snapshot%t
                  call snapshot%get_idvals(itmp)
                  if (allocated(itmp)) then
                     n = size(itmp)
                     nhi = nlo + n - 1
                     idvals(nlo:nhi) = itmp(1:n)
                     nlo = nhi + 1 
                  end if
               end select
            end if
         end do

      end associate 
      return
   end subroutine swiftest_util_get_vals_storage


   module subroutine swiftest_util_index_array(ind_arr, n)
      !! author: David A. Minton
      !!
      !! Creates or resizes an index array of size n where ind_arr = [1, 2, ... n].
      !! This subroutine swiftest_assumes that if ind_arr is already allocated, it is a pre-existing index array of a different size
      implicit none
      ! Arguments
      integer(I4B), dimension(:), allocatable, intent(inout) :: ind_arr !! Index array. Input is a pre-existing index array where 
                                                                        !! n /= size(ind_arr). Output is a new index array 
                                                                        !! ind_arr = [1, 2, ... n]
      integer(I4B),                            intent(in)    :: n       !! The new size of the index array
      ! Internals
      integer(I4B) :: nold, i
      integer(I4B), dimension(:), allocatable :: itmp

      if (allocated(ind_arr)) then
         nold = size(ind_arr)
         if (nold == n) return ! Nothing to do, so go home
      else
         nold = 0
      end if

      allocate(itmp(n))
      if (n >= nold) then
         if (nold > 0) itmp(1:nold) = ind_arr(1:nold)
         itmp(nold+1:n) = [(i, i = nold + 1, n)]
         call move_alloc(itmp, ind_arr)
      else
         itmp(1:n) = ind_arr(1:n)
         call move_alloc(itmp, ind_arr)
      end if

      return
   end subroutine swiftest_util_index_array


   module subroutine swiftest_util_index_map_storage(self)
      !! author: David A. Minton
      !!
      !! Maps body id values to storage index values so we don't have to use unlimited dimensions for id
      implicit none
      ! Arguments
      class(swiftest_storage), intent(inout) :: self  !! Swiftest storage object
      ! Internals
      integer(I4B), dimension(:), allocatable :: idvals
      real(DP), dimension(:), allocatable :: tvals
 
      call swiftest_util_get_vals_storage(self, idvals, tvals)

      call util_unique(idvals,self%idvals,self%idmap)
      self%nid = size(self%idvals)

      call util_unique(tvals,self%tvals,self%tmap)
      self%nt = size(self%tvals)

      return
   end subroutine swiftest_util_index_map_storage


   module subroutine swiftest_util_make_impactors_pl(self, idx)
      !! author: David A. Minton
      !!
      !! This is a simple wrapper function that is used to make a type-bound procedure using a subroutine whose interface is in the
      !! collision module, which must be defined first
      implicit none
      class(swiftest_pl),         intent(inout) :: self  !! Massive body object
      integer(I4B), dimension(:), intent(in)    :: idx !! Array holding the indices of the two bodies involved in the collision)

      call collision_resolve_make_impactors_pl(self, idx)

      return
   end subroutine swiftest_util_make_impactors_pl


   module subroutine swiftest_util_peri(n,m, r, v, atp, q, isperi)
      !! author: David A. Minton
      !!
      !! Helper function that does the pericenter passage computation for any body
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_peri.f90
      !! Adapted from Hal Levison's Swift routine util_mass_peri.f
      implicit none
      ! Arguments
      integer(I4B),                 intent(in)    :: n      !! Number of bodies
      real(DP),     dimension(:),   intent(in)    :: m      !! Mass term (mu for HELIO coordinates, and Gmtot for BARY)
      real(DP),     dimension(:,:), intent(in)    :: r      !! Position vectors (rh for HELIO coordinates, rb for BARY)
      real(DP),     dimension(:,:), intent(in)    :: v      !! Position vectors (vh for HELIO coordinates, rb for BARY)
      real(DP),     dimension(:),   intent(out)   :: atp    !! Semimajor axis 
      real(DP),     dimension(:),   intent(out)   :: q      !! Periapsis
      integer(I4B), dimension(:),   intent(inout) :: isperi !! Periapsis passage flag
      ! Internals
      integer(I4B) :: i
      real(DP), dimension(n) :: e !! Temporary, just to make use of the xv2aeq subroutine
      real(DP) :: vdotr

      do i = 1,n
         vdotr = dot_product(r(:,i),v(:,i))
         if (isperi(i) == -1) then
            if (vdotr >= 0.0) then
               isperi(i) = 0
               call swiftest_orbel_xv2aeq(m(i),r(1,i),r(2,i),r(3,i),v(1,i),v(2,i),v(3,i),atp(i),e(i),q(i))
            end if
         else
            if (vdotr > 0.0) then
               isperi(i) = -1
            else
               isperi(i) = 1
            end if
         end if
      end do

      return
   end subroutine swiftest_util_peri


   module subroutine swiftest_util_peri_body(self, nbody_system, param)
      !! author: David A. Minton
      !!
      !! Determine nbody_system pericenter passages for bodies
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: symba_peri.f90
      !! Adapted from Hal Levison's Swift routine util_mass_peri.f
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self   !! SyMBA massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters
      ! Internals
      integer(I4B) :: i

      if (self%nbody == 0) return

      select type(self)
      class is (swiftest_pl)
         if (self%lfirst) self%isperi(:) = 0
      end select

      if (param%qmin_coord == "HELIO") then
         call swiftest_util_peri(self%nbody, self%mu, self%rh, self%vh, self%atp, self%peri, self%isperi)
      else 
         call swiftest_util_peri(self%nbody, [(nbody_system%Gmtot,i=1,self%nbody)], self%rb, self%vb, self%atp, self%peri, &
                                 self%isperi)
      end if

      return
   end subroutine swiftest_util_peri_body


   module subroutine swiftest_util_rearray_pl(self, nbody_system, param)
      !! Author: the Purdue Swiftest Team -  David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
      !!
      !! Clean up the massive body structures to remove discarded bodies and add new bodies
      use symba
      implicit none
      ! Arguments
      class(swiftest_pl),           intent(inout) :: self   !! Swiftest massive body object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters
      ! Internals
      class(swiftest_pl), allocatable :: tmp !! The discarded body list.
      integer(I4B) :: i, npl, nadd, idnew1, idnew2, idold1, idold2
      integer(I8B) :: k, nenc_old, nencmin
      logical, dimension(:), allocatable :: lmask
      class(encounter_list), allocatable :: plplenc_old
      logical :: lencounter

      associate(pl => self, tp => nbody_system%tp, cb => nbody_system%cb, pl_adds => nbody_system%pl_adds)

         npl = pl%nbody
         nadd = pl_adds%nbody
         if (npl == 0) return
         ! Deallocate any temporary variables
         if (allocated(pl%rbeg)) deallocate(pl%rbeg)
         if (allocated(pl%rend)) deallocate(pl%rend)

         ! Remove the discards and destroy the list, as the nbody_system already tracks pl_discards elsewhere
         allocate(lmask(npl))
         lmask(1:npl) = pl%ldiscard(1:npl)
         if (count(lmask(:)) > 0) then
            allocate(tmp, mold=self)
            call pl%spill(tmp, lspill_list=lmask, ldestructive=.true.)
            npl = pl%nbody
            call tmp%setup(0,param)
            deallocate(tmp)
            deallocate(lmask)
         end if

         ! Add in any new bodies
         if (nadd > 0) then
            ! Append the adds to the main pl object
            call pl%append(pl_adds, lsource_mask=[(.true., i=1, nadd)])
            npl = pl%nbody
         end if

         if (npl == 0) then
            if (param%lmtiny_pl) pl%nplm = 0
            ! There are no more massive bodies. Reset the encounter lists and move on
            if (allocated(nbody_system%plpl_encounter)) call nbody_system%plpl_encounter%setup(0_I8B)
            if (allocated(nbody_system%pltp_encounter)) call nbody_system%pltp_encounter%setup(0_I8B)
            return
         end if

         ! Reset all of the status flags for the remaining bodies
         pl%status(1:npl) = ACTIVE
         do i = 1, npl
            call pl%info(i)%set_value(status="ACTIVE")
         end do
         pl%ldiscard(1:npl) = .false.
         pl%lcollision(1:npl) = .false.
         pl%lmask(1:npl) = .true.

         if (param%lmtiny_pl) then
            pl%lmtiny(1:npl) = pl%Gmass(1:npl) < param%GMTINY
            where(pl%lmtiny(1:npl))
               pl%info(1:npl)%particle_type = PL_TINY_TYPE_NAME 
            elsewhere
               pl%info(1:npl)%particle_type = PL_TYPE_NAME 
            end where
            pl%nplm = count(.not.pl%lmtiny(1:npl))
         end if

         ! Reindex the new list of bodies 
         select type(pl)
         class is (helio_pl)
            call pl%sort("mass", ascending=.false.)
         class is (whm_pl) 
            call pl%sort("ir3h", ascending=.false.)
         end select
         call pl%flatten(param)

         call pl%set_rhill(cb)

         ! Reset the kinship trackers
         call pl%reset_kinship([(i, i=1, npl)])

         if (allocated(nbody_system%plpl_encounter)) then
            ! Store the original plplenc list so we don't remove any of the original encounters
            nenc_old = nbody_system%plpl_encounter%nenc
            if (nenc_old > 0_I8B) then 
               allocate(plplenc_old, source=nbody_system%plpl_encounter)
               call plplenc_old%copy(nbody_system%plpl_encounter)
            end if

            ! Re-build the encounter list
            ! Be sure to get the level info if this is a SyMBA nbody_system
            select type(nbody_system)
            class is (symba_nbody_system)
            select type(pl)
            class is (symba_pl)
            select type(tp)
            class is (symba_tp)
               lencounter = pl%encounter_check(param, nbody_system, param%dt, nbody_system%irec) 
               if (tp%nbody > 0) then
                  lencounter = tp%encounter_check(param, nbody_system, param%dt, nbody_system%irec)
               end if
            end select
            end select
            end select

            ! Re-index the encounter list as the index values may have changed
            if (nenc_old > 0_I8B) then
               nencmin = min(nbody_system%plpl_encounter%nenc, plplenc_old%nenc) 
               nbody_system%plpl_encounter%nenc = nencmin
               do k = 1_I8B, nencmin
                  idnew1 = nbody_system%plpl_encounter%id1(k)
                  idnew2 = nbody_system%plpl_encounter%id2(k)
                  idold1 = plplenc_old%id1(k)
                  idold2 = plplenc_old%id2(k)
                  if ((idnew1 == idold1) .and. (idnew2 == idold2)) then
                     ! This is an encounter we already know about, so save the old information
                     nbody_system%plpl_encounter%lvdotr(k) = plplenc_old%lvdotr(k) 
                     nbody_system%plpl_encounter%lclosest(k) = plplenc_old%lclosest(k) 
                     nbody_system%plpl_encounter%status(k) = plplenc_old%status(k) 
                     nbody_system%plpl_encounter%r1(:,k) = plplenc_old%r1(:,k)
                     nbody_system%plpl_encounter%r2(:,k) = plplenc_old%r2(:,k)
                     nbody_system%plpl_encounter%v1(:,k) = plplenc_old%v1(:,k)
                     nbody_system%plpl_encounter%v2(:,k) = plplenc_old%v2(:,k)
                     nbody_system%plpl_encounter%tcollision(k) = plplenc_old%tcollision(k)
                     nbody_system%plpl_encounter%level(k) = plplenc_old%level(k)
                  else if (((idnew1 == idold2) .and. (idnew2 == idold1))) then
                     ! This is an encounter we already know about, but with the order reversed, so save the old information
                     nbody_system%plpl_encounter%lvdotr(k) = plplenc_old%lvdotr(k) 
                     nbody_system%plpl_encounter%lclosest(k) = plplenc_old%lclosest(k) 
                     nbody_system%plpl_encounter%status(k) = plplenc_old%status(k) 
                     nbody_system%plpl_encounter%r1(:,k) = plplenc_old%r2(:,k)
                     nbody_system%plpl_encounter%r2(:,k) = plplenc_old%r1(:,k)
                     nbody_system%plpl_encounter%v1(:,k) = plplenc_old%v2(:,k)
                     nbody_system%plpl_encounter%v2(:,k) = plplenc_old%v1(:,k)
                     nbody_system%plpl_encounter%tcollision(k) = plplenc_old%tcollision(k)
                     nbody_system%plpl_encounter%level(k) = plplenc_old%level(k)
                  end if
                  nbody_system%plpl_encounter%index1(k) = findloc(pl%id(1:npl), nbody_system%plpl_encounter%id1(k), dim=1)
                  nbody_system%plpl_encounter%index2(k) = findloc(pl%id(1:npl), nbody_system%plpl_encounter%id2(k), dim=1)
               end do
               if (allocated(lmask)) deallocate(lmask)
               allocate(lmask(nencmin))
               nenc_old = nencmin
               if (any(nbody_system%plpl_encounter%index1(1:nencmin) == 0) .or. &
                  any(nbody_system%plpl_encounter%index2(1:nencmin) == 0)) then
                  lmask(:) = nbody_system%plpl_encounter%index1(1:nencmin) /= 0 .and. &
                             nbody_system%plpl_encounter%index2(1:nencmin) /= 0
               else
                  return
               end if
               nencmin = count(lmask(:))
               nbody_system%plpl_encounter%nenc = nencmin
               if (nencmin > 0_I8B) then
                  nbody_system%plpl_encounter%index1(1:nencmin) = pack(nbody_system%plpl_encounter%index1(1:nenc_old), &
                                                                       lmask(1:nenc_old))
                  nbody_system%plpl_encounter%index2(1:nencmin) = pack(nbody_system%plpl_encounter%index2(1:nenc_old), &
                                                                       lmask(1:nenc_old))
                  nbody_system%plpl_encounter%id1(1:nencmin) = pack(nbody_system%plpl_encounter%id1(1:nenc_old), lmask(1:nenc_old))
                  nbody_system%plpl_encounter%id2(1:nencmin) = pack(nbody_system%plpl_encounter%id2(1:nenc_old), lmask(1:nenc_old))
                  nbody_system%plpl_encounter%lvdotr(1:nencmin) = pack(nbody_system%plpl_encounter%lvdotr(1:nenc_old), &
                                                                       lmask(1:nenc_old))
                  nbody_system%plpl_encounter%lclosest(1:nencmin) = pack(nbody_system%plpl_encounter%lclosest(1:nenc_old), &
                                                                         lmask(1:nenc_old))
                  nbody_system%plpl_encounter%status(1:nencmin) = pack(nbody_system%plpl_encounter%status(1:nenc_old), &
                                                                       lmask(1:nenc_old))
                  nbody_system%plpl_encounter%tcollision(1:nencmin) = pack(nbody_system%plpl_encounter%tcollision(1:nenc_old), &
                                                                           lmask(1:nenc_old))
                  nbody_system%plpl_encounter%level(1:nencmin) = pack(nbody_system%plpl_encounter%level(1:nenc_old), &
                                                                      lmask(1:nenc_old))
                  do i = 1, NDIM
                     nbody_system%plpl_encounter%r1(i, 1:nencmin) = pack(nbody_system%plpl_encounter%r1(i, 1:nenc_old), &
                                                                         lmask(1:nenc_old))
                     nbody_system%plpl_encounter%r2(i, 1:nencmin) = pack(nbody_system%plpl_encounter%r2(i, 1:nenc_old), &
                                                                         lmask(1:nenc_old))
                     nbody_system%plpl_encounter%v1(i, 1:nencmin) = pack(nbody_system%plpl_encounter%v1(i, 1:nenc_old), &
                                                                         lmask(1:nenc_old))
                     nbody_system%plpl_encounter%v2(i, 1:nencmin) = pack(nbody_system%plpl_encounter%v2(i, 1:nenc_old), &
                                                                         lmask(1:nenc_old))
                  end do
               end if
            end if
         end if
      end associate

      return
   end subroutine swiftest_util_rearray_pl


   module subroutine swiftest_util_rearray_tp(self, nbody_system, param)
      !! Author: David A. Minton
      !!
      !! Clean up the test particle structures to remove discarded bodies
      use symba
      implicit none
      ! Arguments
      class(swiftest_tp),           intent(inout) :: self   !! Swiftest test particle object
      class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
      ! Internals
      class(swiftest_tp), allocatable :: tmp !! The discarded body list.
      integer(I4B) :: i, ntp, npl
      integer(I8B) :: k, nenc
      logical, dimension(:), allocatable :: lmask
      logical :: lencounter

      associate(tp => self, pl => nbody_system%pl, cb => nbody_system%cb, pl_adds => nbody_system%pl_adds)

         ntp = tp%nbody
         if (ntp == 0) return
         npl = pl%nbody

         ! Remove the discards and destroy the list, as the nbody_system already tracks tp_discards elsewhere
         allocate(lmask(ntp))
         lmask(1:ntp) = tp%ldiscard(1:ntp)
         if (count(lmask(:)) > 0) then
            allocate(tmp, mold=self)
            call tp%spill(tmp, lspill_list=lmask, ldestructive=.true.)
            ntp = tp%nbody
            call tmp%setup(0,param)
            deallocate(tmp)
            deallocate(lmask)
         end if
         ntp = tp%nbody
         if (ntp == 0) then
            ! There are no more test particles. Reset the encounter list and move on
            if (allocated(nbody_system%pltp_encounter)) call nbody_system%pltp_encounter%setup(0_I8B)
            return
         end if

         ! Reset all of the status flags for the remaining bodies
         tp%status(1:ntp) = ACTIVE
         do i = 1, ntp
            call tp%info(i)%set_value(status="ACTIVE")
         end do
         tp%ldiscard(1:ntp) = .false.
         tp%lcollision(1:ntp) = .false.
         tp%lmask(1:ntp) = .true.

         if (allocated(nbody_system%pltp_encounter)) then
            ! Index values may have changed, so re-index the encounter list
            nenc = nbody_system%pltp_encounter%nenc
            do k = 1_I8B, nenc
               nbody_system%pltp_encounter%index1(k) = findloc(pl%id(1:npl), nbody_system%pltp_encounter%id1(k), dim=1)
               nbody_system%pltp_encounter%index2(k) = findloc(tp%id(1:ntp), nbody_system%pltp_encounter%id2(k), dim=1)
            end do

         end if

      end associate

      return
   end subroutine swiftest_util_rearray_tp


   module subroutine swiftest_util_rescale_system(self, param, mscale, dscale, tscale)
      !! author: David A. Minton
      !!
      !! Rescales an nbody system to a new set of units. Inputs are the multipliers on the mass (mscale), distance (dscale), and 
      !! time units (tscale). Rescales all united quantities in the nbody_system, as well as the mass conversion factors, 
      !! gravitational constant, and Einstein's constant in the parameter object.
      implicit none
      class(swiftest_nbody_system), intent(inout) :: self   !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters. Returns with new values of the 
                                                            !! scale vactors and GU
      real(DP),                     intent(in)    :: mscale, dscale, tscale !! Scale factors for mass, distance, and time units 
      ! Internals
      real(DP) :: vscale

      param%MU2KG = param%MU2KG * mscale
      param%DU2M = param%DU2M * dscale
      param%TU2S = param%TU2S * tscale

      ! Calculate the G for the nbody_system units
      param%GU = GC / (param%DU2M**3 / (param%MU2KG * param%TU2S**2))

      if (param%lgr) then
         ! Calculate the inverse speed of light in the nbody_system units
         param%inv_c2 = einsteinC * param%TU2S / param%DU2M
         param%inv_c2 = (param%inv_c2)**(-2)
      end if

      vscale = dscale / tscale

      associate(cb => self%cb, pl => self%pl, npl => self%pl%nbody, tp => self%tp, ntp => self%tp%nbody)

         cb%mass = cb%mass / mscale
         cb%Gmass = param%GU * cb%mass 
         cb%radius = cb%radius / dscale
         cb%rb(:) = cb%rb(:) / dscale
         cb%vb(:) = cb%vb(:) / vscale
         cb%rot(:) = cb%rot(:) * tscale
         pl%mass(1:npl) = pl%mass(1:npl) / mscale
         pl%Gmass(1:npl) = param%GU * pl%mass(1:npl) 
         pl%radius(1:npl) = pl%radius(1:npl) / dscale
         pl%rh(:,1:npl) = pl%rh(:,1:npl) / dscale
         pl%vh(:,1:npl) = pl%vh(:,1:npl) / vscale
         pl%rb(:,1:npl) = pl%rb(:,1:npl) / dscale
         pl%vb(:,1:npl) = pl%vb(:,1:npl) / vscale
         pl%rot(:,1:npl) = pl%rot(:,1:npl) * tscale

      end associate


      return
   end subroutine swiftest_util_rescale_system 


   module subroutine swiftest_util_reset_kinship_pl(self, idx)
      !! author: David A. Minton
      !! 
      !! Resets the kinship status of bodies.
      !!
      implicit none
      class(swiftest_pl),         intent(inout) :: self !! SyMBA massive body object
      integer(I4B), dimension(:), intent(in)    :: idx  !! Index array of bodies to reset
      ! Internals
      integer(I4B) :: i, j

      self%kin(idx(:))%parent = idx(:)
      self%kin(idx(:))%nchild = 0
      do j = 1, size(idx(:))
         i = idx(j)
         if (allocated(self%kin(i)%child)) deallocate(self%kin(i)%child)
      end do

      return
   end subroutine swiftest_util_reset_kinship_pl


   module subroutine swiftest_util_resize_arr_info(arr, nnew)
      !! author: David A. Minton
      !!
      !! Resizes an array component of type character string. Array will only be resized if has previously been allocated. 
      !! Passing nnew = 0 will deallocate.
      implicit none
      ! Arguments
      type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: arr  !! Array to resize
      integer(I4B),                                         intent(in)    :: nnew !! New size
      ! Internals
      type(swiftest_particle_info), dimension(:), allocatable :: tmp !! Temporary storage array in case the input array is already 
                                                                     !! allocated
      integer(I4B) :: nold !! Old size

      if (nnew < 0) return

      if (nnew == 0) then
         if (allocated(arr)) deallocate(arr)
         return
      end if
      
      if (allocated(arr)) then
         nold = size(arr)
      else
         nold = 0
      end if

      if (nnew == nold) return
      
      allocate(tmp(nnew))
      if (nnew > nold) then
         call swiftest_util_copy_particle_info_arr(arr(1:nold), tmp(1:nold))
      else
         call swiftest_util_copy_particle_info_arr(arr(1:nnew), tmp(1:nnew))
      end if

      call move_alloc(tmp, arr)

      return
   end subroutine swiftest_util_resize_arr_info

  
   module subroutine swiftest_util_resize_arr_kin(arr, nnew)
      !! author: David A. Minton
      !!
      !! Resizes an array component of type character string. Array will only be resized if has previously been allocated. 
      !! Passing nnew = 0 will deallocate.
      implicit none
      ! Arguments
      type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: arr  !! Array to resize
      integer(I4B),                                      intent(in)    :: nnew !! New size
      ! Internals
      type(swiftest_kinship), dimension(:), allocatable :: tmp !! Temporary storage array in case the input array is already 
                                                               !! allocated
      integer(I4B) :: nold !! Old size

      if (nnew < 0) return

      if (nnew == 0) then
         if (allocated(arr)) deallocate(arr)
         return
      end if
      
      if (allocated(arr)) then
         nold = size(arr)
      else
         nold = 0
      end if

      allocate(tmp(nnew))
      if (nnew > nold) then
         tmp(1:nold) = arr(1:nold)
      else
         tmp(1:nnew) = arr(1:nnew)
      end if
      call move_alloc(tmp, arr)

      return
   end subroutine swiftest_util_resize_arr_kin


   module subroutine swiftest_util_resize_body(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a Swiftest body against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(swiftest_body), intent(inout) :: self  !! Swiftest body object
      integer(I4B),         intent(in)    :: nnew  !! New size neded

      call util_resize(self%info, nnew)
      call util_resize(self%id, nnew)
      call util_resize(self%status, nnew)
      call util_resize(self%lcollision, nnew)
      call util_resize(self%lencounter, nnew)
      call util_resize(self%ldiscard, nnew)
      call util_resize(self%lmask, nnew)
      call util_resize(self%mu, nnew)
      call util_resize(self%rh, nnew)
      call util_resize(self%vh, nnew)
      call util_resize(self%rb, nnew)
      call util_resize(self%vb, nnew)
      call util_resize(self%ah, nnew)
      call util_resize(self%aobl, nnew)
      call util_resize(self%atide, nnew)
      call util_resize(self%agr, nnew)
      call util_resize(self%ir3h, nnew)
      call util_resize(self%a, nnew)
      call util_resize(self%e, nnew)
      call util_resize(self%inc, nnew)
      call util_resize(self%capom, nnew)
      call util_resize(self%omega, nnew)
      call util_resize(self%capm, nnew)
      self%nbody = count(self%status(1:nnew) /= INACTIVE)

      return
   end subroutine swiftest_util_resize_body


   module subroutine swiftest_util_resize_pl(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a Swiftest massive body against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self  !! Swiftest massive body object
      integer(I4B),       intent(in)    :: nnew  !! New size neded

      call swiftest_util_resize_body(self, nnew)

      call util_resize(self%mass, nnew)
      call util_resize(self%Gmass, nnew)
      call util_resize(self%rhill, nnew)
      call util_resize(self%renc, nnew)
      call util_resize(self%radius, nnew)
      call util_resize(self%rbeg, nnew)
      call util_resize(self%rend, nnew)
      call util_resize(self%vbeg, nnew)
      call util_resize(self%density, nnew)
      call util_resize(self%Ip, nnew)
      call util_resize(self%rot, nnew)
      call util_resize(self%k2, nnew)
      call util_resize(self%Q, nnew)
      call util_resize(self%tlag, nnew)
      call util_resize(self%kin, nnew)
      call util_resize(self%lmtiny, nnew)
      call util_resize(self%nplenc, nnew)
      call util_resize(self%ntpenc, nnew)



      if (allocated(self%k_plpl)) deallocate(self%k_plpl)

      return
   end subroutine swiftest_util_resize_pl


   module subroutine swiftest_util_resize_tp(self, nnew)
      !! author: David A. Minton
      !!
      !! Checks the current size of a Swiftest test particle against the requested size and resizes it if it is too small.
      implicit none
      ! Arguments
      class(swiftest_tp), intent(inout) :: self  !! Swiftest test particle object
      integer(I4B),       intent(in)    :: nnew  !! New size neded

      call swiftest_util_resize_body(self, nnew)

      call util_resize(self%nplenc, nnew)
      call util_resize(self%isperi, nnew)
      call util_resize(self%peri, nnew)
      call util_resize(self%atp, nnew)

      return
   end subroutine swiftest_util_resize_tp


   module subroutine swiftest_util_set_beg_end_pl(self, rbeg, rend, vbeg)
      !! author: David A. Minton
      !! 
      !! Sets one or more of the values of rbeg, rend, and vbeg
      implicit none
      ! Arguments
      class(swiftest_pl),       intent(inout)          :: self !! Swiftest massive body object
      real(DP), dimension(:,:), intent(in),   optional :: rbeg, rend, vbeg

      if (present(rbeg)) then
         if (allocated(self%rbeg)) deallocate(self%rbeg)
         allocate(self%rbeg, source=rbeg)
      end if
      if (present(rend)) then
         if (allocated(self%rend)) deallocate(self%rend)
         allocate(self%rend, source=rend)
      end if
      if (present(vbeg)) then
         if (allocated(self%vbeg)) deallocate(self%vbeg)
         allocate(self%vbeg, source=vbeg)
      end if

      return
   end subroutine swiftest_util_set_beg_end_pl


   module subroutine swiftest_util_set_ir3h(self)
      !! author: David A. Minton
      !!
      !! Sets the inverse heliocentric radius term (1/rh**3) for all bodies in a structure
      implicit none
      ! Arguments
      class(swiftest_body),         intent(inout) :: self !! Swiftest generic body object
      ! Internals
      integer(I4B) :: i
      real(DP) :: r2, irh

      if (self%nbody > 0) then

         do i = 1, self%nbody
            r2 = dot_product(self%rh(:, i), self%rh(:, i))
            irh = 1.0_DP / sqrt(r2)
            self%ir3h(i) = irh / r2
         end do
      end if

      return
   end subroutine swiftest_util_set_ir3h


   module subroutine swiftest_util_set_msys(self)
      !! author: David A. Minton
      !!
      !! Sets the value of msys and the vector mass quantities based on the total mass of the nbody_system
      implicit none
      ! Arguments
      class(swiftest_nbody_system),  intent(inout) :: self    !! Swiftest nobdy nbody_system object

      self%Gmtot = self%cb%Gmass
      if (self%pl%nbody > 0) self%Gmtot = self%Gmtot + sum(self%pl%Gmass(1:self%pl%nbody), &
                                                           self%pl%status(1:self%pl%nbody) /= INACTIVE)

      return
   end subroutine swiftest_util_set_msys


   module subroutine swiftest_util_set_mu_pl(self, cb)
      !! author: David A. Minton
      !!
      !! Computes G * (M + m) for each massive body
      implicit none
      ! Arguments
      class(swiftest_pl),           intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb),           intent(inout) :: cb   !! Swiftest central body object

      if (self%nbody > 0) self%mu(1:self%nbody) = cb%Gmass + self%Gmass(1:self%nbody)

      return
   end subroutine swiftest_util_set_mu_pl


   module subroutine swiftest_util_set_mu_tp(self, cb)
      !! author: David A. Minton
      !!
      !! Converts certain scalar values to arrays so that they can be used in elemental functions
      implicit none
      ! Arguments
      class(swiftest_tp),           intent(inout) :: self !! Swiftest test particle object
      class(swiftest_cb),           intent(inout) :: cb   !! Swiftest central body object

      if (self%nbody == 0) return
      self%mu(1:self%nbody) = cb%Gmass

      return
   end subroutine swiftest_util_set_mu_tp


   module subroutine swiftest_util_set_particle_info(self, name, particle_type, status, origin_type, origin_time, collision_id, &
                                            origin_rh, origin_vh, discard_time, discard_rh, discard_vh, discard_body_id)
      !! author: David A. Minton
      !!
      !! Sets one or more values of the particle information metadata object
      implicit none
      ! Arguments
      class(swiftest_particle_info), intent(inout)           :: self
      character(len=*),              intent(in),    optional :: name            !! Non-unique name
      character(len=*),              intent(in),    optional :: particle_type   !! String containing a description of the particle 
                                                                                !!  type (Central Body, Massive Body, Test Particle)
      character(len=*),              intent(in),    optional :: status          !! Particle status description: ACTIVE, MERGED, 
                                                                                !!  FRAGMENTED, etc.
      character(len=*),              intent(in),    optional :: origin_type     !! String containing a description of the origin of
                                                                                !!  the particle (e.g. Initial Conditions, 
                                                                                !!  Supercatastrophic, Disruption, etc.)
      real(DP),                      intent(in),    optional :: origin_time     !! The time of the particle's formation
      integer(I4B),                  intent(in),    optional :: collision_id    !! The ID fo the collision that formed the particle
      real(DP), dimension(:),        intent(in),    optional :: origin_rh       !! The heliocentric distance vector at the time of 
                                                                                !!  the particle's formation
      real(DP), dimension(:),        intent(in),    optional :: origin_vh       !! The heliocentric velocity vector at the time of 
                                                                                !!  the particle's formation
      real(DP),                      intent(in),    optional :: discard_time    !! The time of the particle's discard
      real(DP), dimension(:),        intent(in),    optional :: discard_rh      !! The heliocentric distance vector at the time of 
                                                                                !!  the particle's discard
      real(DP), dimension(:),        intent(in),    optional :: discard_vh      !! The heliocentric velocity vector at the time of 
                                                                                !! the particle's discard
      integer(I4B),                  intent(in),    optional :: discard_body_id !! The id of the other body involved in the discard
                                                                                !! (0 if no other body involved)
      ! Internals
      character(len=NAMELEN) :: lenstr
      character(len=:), allocatable :: fmtlabel

      write(lenstr, *) NAMELEN
      fmtlabel = "(A" // trim(adjustl(lenstr)) // ")"

      if (present(name)) then
         write(self%name, fmtlabel) name
         call swiftest_io_remove_nul_char(self%name)
      end if
      if (present(particle_type)) then
         write(self%particle_type, fmtlabel) particle_type
         call swiftest_io_remove_nul_char(self%particle_type)
      end if 
      if (present(status)) then
         write(self%status, fmtlabel) status
         call swiftest_io_remove_nul_char(self%status)
      end if
      if (present(origin_type)) then
         write(self%origin_type, fmtlabel) origin_type
         call swiftest_io_remove_nul_char(self%origin_type)
      end if
      if (present(origin_time)) then
         self%origin_time = origin_time
      end if
      if (present(collision_id)) then
         self%collision_id = collision_id
      end if
      if (present(origin_rh)) then
         self%origin_rh(:) = origin_rh(:)
      end if
      if (present(origin_vh)) then
         self%origin_vh(:) = origin_vh(:)
      end if
      if (present(discard_time)) then
         self%discard_time = discard_time
      end if
      if (present(discard_rh)) then
         self%discard_rh(:) = discard_rh(:)
      end if
      if (present(discard_vh)) then
         self%discard_vh(:) = discard_vh(:)
      end if
      if (present(discard_body_id)) then
         self%discard_body_id = discard_body_id
      end if

      return
   end subroutine swiftest_util_set_particle_info


   module subroutine swiftest_util_set_renc_I4B(self, scale)
      !! author: David A. Minton
      !!
      !! Sets the critical radius for encounter given an input scale factor
      !!
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      integer(I4B),       intent(in)    :: scale !! Input scale factor (multiplier of Hill's sphere size)

      associate(pl => self, npl => self%nbody)
         pl%renc(1:npl) = pl%rhill(1:npl) * scale
      end associate

      return
   end subroutine swiftest_util_set_renc_I4B


   module subroutine swiftest_util_set_renc_DP(self, scale)
      !! author: David A. Minton
      !!
      !! Sets the critical radius for encounter given an input scale factor
      !!
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      real(DP),           intent(in)    :: scale !! Input scale factor (multiplier of Hill's sphere size)

      associate(pl => self, npl => self%nbody)
         pl%renc(1:npl) = pl%rhill(1:npl) * scale
      end associate

      return
   end subroutine swiftest_util_set_renc_DP


   module subroutine swiftest_util_set_rhill(self,cb)
      !! author: David A. Minton
      !!
      !! Sets the value of the Hill's radius
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb), intent(inout) :: cb   !! Swiftest central body object

      if (self%nbody == 0) return
      if (cb%Gmass <= tiny(1.0_DP)) return

      call self%xv2el(cb) 
      where(self%a(1:self%nbody) > 0.0_DP)
         self%rhill(1:self%nbody) = self%a(1:self%nbody) * (self%Gmass(1:self%nbody) / cb%Gmass / 3)**THIRD 
      elsewhere
         self%rhill(1:self%nbody) = (.mag.self%rh(:,1:self%nbody)) * (self%Gmass(1:self%nbody) / cb%Gmass / 3)**THIRD 
      end where

      return
   end subroutine swiftest_util_set_rhill


   module subroutine swiftest_util_set_rhill_approximate(self,cb)
      !! author: David A. Minton
      !!
      !! Sets the approximate value of the Hill's radius using the heliocentric radius instead of computing the semimajor axis
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self !! Swiftest massive body object
      class(swiftest_cb), intent(inout) :: cb   !! Swiftest central body object
      ! Internals
      real(DP), dimension(:), allocatable :: rh

      if (self%nbody == 0) return

      rh(1:self%nbody) = .mag. self%rh(:,1:self%nbody)
      self%rhill(1:self%nbody) = rh(1:self%nbody) * (self%Gmass(1:self%nbody) / cb%Gmass / 3)**THIRD 

      return
   end subroutine swiftest_util_set_rhill_approximate

   module subroutine swiftest_util_setup_construct_system(nbody_system, param)

      !! author: David A. Minton
      !!
      !! Constructor for a Swiftest nbody system. Creates the nbody system object based on the user-input integrator
      !! 
      implicit none
      ! Arguments
      class(swiftest_nbody_system), allocatable, intent(inout) :: nbody_system !! Swiftest nbody_system object
      class(swiftest_parameters),                intent(inout) :: param        !! Current run configuration parameters
      select case(param%integrator)
      case (INT_BS)
         write(*,*) 'Bulirsch-Stoer integrator not yet enabled'
       case (INT_HELIO)
         allocate(helio_nbody_system :: nbody_system)
         select type(nbody_system)
         class is (helio_nbody_system)
            allocate(helio_cb :: nbody_system%cb)
            allocate(helio_pl :: nbody_system%pl)
            allocate(helio_tp :: nbody_system%tp)
            allocate(helio_pl :: nbody_system%pl_discards)
            allocate(helio_tp :: nbody_system%tp_discards)
         end select
         param%collision_model = "MERGE"
      case (INT_RA15)
         write(*,*) 'Radau integrator not yet enabled'
      case (INT_TU4)
         write(*,*) 'INT_TU4 integrator not yet enabled'
      case (INT_WHM)
         allocate(whm_nbody_system :: nbody_system)
         select type(nbody_system)
         class is (whm_nbody_system)
            allocate(whm_cb :: nbody_system%cb)
            allocate(whm_pl :: nbody_system%pl)
            allocate(whm_tp :: nbody_system%tp)
            allocate(whm_pl :: nbody_system%pl_discards)
            allocate(whm_tp :: nbody_system%tp_discards)
         end select
         param%collision_model = "MERGE"
      case (INT_RMVS)
         allocate(rmvs_nbody_system :: nbody_system)
         select type(nbody_system)
         class is (rmvs_nbody_system)
            allocate(rmvs_cb :: nbody_system%cb)
            allocate(rmvs_pl :: nbody_system%pl)
            allocate(rmvs_tp :: nbody_system%tp)
            allocate(rmvs_pl :: nbody_system%pl_discards)
            allocate(rmvs_tp :: nbody_system%tp_discards)
         end select
         param%collision_model = "MERGE"
      case (INT_SYMBA)
         allocate(symba_nbody_system :: nbody_system)
         select type(nbody_system)
         class is (symba_nbody_system)
            allocate(symba_cb :: nbody_system%cb)
            allocate(symba_pl :: nbody_system%pl)
            allocate(symba_tp :: nbody_system%tp)

            allocate(symba_tp :: nbody_system%tp_discards)
            allocate(symba_pl :: nbody_system%pl_adds)
            allocate(symba_pl :: nbody_system%pl_discards)

            allocate(symba_list_pltp     :: nbody_system%pltp_encounter)
            allocate(symba_list_plpl     :: nbody_system%plpl_encounter)
            allocate(collision_list_plpl :: nbody_system%plpl_collision)
            allocate(collision_list_pltp :: nbody_system%pltp_collision)
         end select
      case (INT_RINGMOONS)
         write(*,*) 'RINGMOONS-SyMBA integrator not yet enabled'
      case default
         write(*,*) 'Unkown integrator',param%integrator
         call base_util_exit(FAILURE,param%display_unit)
      end select
      nbody_system%lfirst_io = .true.
      nbody_system%lfirst_peri = .true.

      allocate(swiftest_particle_info :: nbody_system%cb%info)

      nbody_system%t = param%tstart

      return
   end subroutine swiftest_util_setup_construct_system


   module subroutine swiftest_util_setup_initialize_particle_info_system(self, param)
      !! author: David A. Minton
      !!
      !! Setup up particle information metadata from initial conditions
      !
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self  !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param !! Current run configuration parameters
      ! Internals
      integer(I4B) :: i

      associate(pl => self%pl, npl => self%pl%nbody, tp => self%tp, ntp => self%tp%nbody)

         if (.not. allocated(self%cb%info)) allocate(swiftest_particle_info :: self%cb%info)

         call self%cb%info%set_value(particle_type=CB_TYPE_NAME, status="ACTIVE", origin_type="Initial conditions", &
                                origin_time=param%t0, origin_rh=[0.0_DP, 0.0_DP, 0.0_DP], origin_vh=[0.0_DP, 0.0_DP, 0.0_DP])
         do i = 1, self%pl%nbody
            call pl%info(i)%set_value(particle_type=PL_TYPE_NAME, status="ACTIVE", origin_type="Initial conditions", &
                                       origin_time=param%t0, origin_rh=self%pl%rh(:,i), origin_vh=self%pl%vh(:,i))
         end do
         do i = 1, self%tp%nbody
            call tp%info(i)%set_value(particle_type=TP_TYPE_NAME, status="ACTIVE", origin_type="Initial conditions", &
                                      origin_time=param%t0, origin_rh=self%tp%rh(:,i), origin_vh=self%tp%vh(:,i))
         end do

      end associate

      return
   end subroutine swiftest_util_setup_initialize_particle_info_system


   module subroutine swiftest_util_setup_initialize_system(self, system_history, param)
      !! author: David A. Minton
      !!
      !! Wrapper method to initialize a basic Swiftest nbody system from files
      !!
      implicit none
      ! Arguments
      class(swiftest_nbody_system),              intent(inout) :: self           !! Swiftest nbody_system object
      class(swiftest_storage),      allocatable, intent(inout) :: system_history !! Stores the system history between output dumps
      class(swiftest_parameters),                intent(inout) :: param          !! Current run configuration parameters
      ! Internals
      type(encounter_storage)  :: encounter_history
      type(collision_storage)  :: collision_history

      call encounter_history%setup(4096)
      call collision_history%setup(4096)

      if (allocated(system_history)) then
         call system_history%dealloc()
         deallocate(system_history)
      end if
      allocate(swiftest_storage :: system_history)
      call system_history%setup(param%dump_cadence)
      allocate(swiftest_netcdf_parameters :: system_history%nc)

      associate(nbody_system => self, cb => self%cb, pl => self%pl, tp => self%tp, nc => system_history%nc)
         call nbody_system%read_in(nc, param)
         call nbody_system%validate_ids(param)
         call nbody_system%set_msys()
         call pl%set_mu(cb) 
         call tp%set_mu(cb) 
         if (param%in_form == "EL") then
            call pl%el2xv(cb)
            call tp%el2xv(cb)
         end if
         call pl%flatten(param)
         if (.not.param%lrhill_present) call pl%set_rhill(cb)
         pl%lfirst = param%lfirstkick
         tp%lfirst = param%lfirstkick

         if (.not.param%lrestart) then
            call nbody_system%init_particle_info(param)
         end if

         ! Write initial conditions to file
         nc%file_name = param%outfile
         call nbody_system%initialize_output_file(nc, param) 
         call nc%close()

         allocate(collision_basic :: nbody_system%collider)
         call nbody_system%collider%setup(nbody_system)

         if (param%lenc_save_trajectory .or. param%lenc_save_closest) then
            allocate(encounter_netcdf_parameters :: encounter_history%nc)
            select type(nc => encounter_history%nc)
            class is (encounter_netcdf_parameters)
               nc%file_name = ENCOUNTER_OUTFILE
               if (.not.param%lrestart) then
                  call nc%initialize(param)
                  call nc%close()
               end if
            end select
            allocate(nbody_system%encounter_history, source=encounter_history)
         end if
        
         allocate(collision_netcdf_parameters :: collision_history%nc)
         select type(nc => collision_history%nc)
         class is (collision_netcdf_parameters)
            nc%file_name = COLLISION_OUTFILE
            if (param%lrestart) then
               call nc%open(param) ! This will find the nc%max_idslot variable
            else
               call nc%initialize(param)
            end if
            call nc%close()
            nbody_system%collider%maxid_collision = nc%max_idslot
         end select

         allocate(nbody_system%collision_history, source=collision_history)        
         
         nbody_system%collider%max_rot = MAX_ROT_SI * param%TU2S 

      end associate

      return
   end subroutine swiftest_util_setup_initialize_system


   module subroutine swiftest_util_setup_body(self, n, param)
      !! author: David A. Minton
      !!
      !! Constructor for base Swiftest particle class. Allocates space for all particles and
      !! initializes all components with a value.
      !! Note: Timing tests indicate that (NDIM, n) is more efficient than (NDIM, n) 
      implicit none
      ! Arguments
      class(swiftest_body),       intent(inout) :: self  !! Swiftest generic body object
      integer(I4B),               intent(in)    :: n     !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameter
      ! Internals
      integer(I4B) :: i

      if (n < 0) return

      self%lfirst = .true.

      call self%dealloc()

      self%nbody = n
      if (n == 0) return

      allocate(swiftest_particle_info :: self%info(n))
      allocate(self%id(n))
      allocate(self%status(n))
      allocate(self%ldiscard(n))
      allocate(self%lmask(n))
      allocate(self%mu(n))
      allocate(self%rh(NDIM, n))
      allocate(self%vh(NDIM, n))
      allocate(self%rb(NDIM, n))
      allocate(self%vb(NDIM, n))
      allocate(self%ah(NDIM, n))
      allocate(self%ir3h(n))
      allocate(self%isperi(n))
      allocate(self%peri(n))
      allocate(self%atp(n))
      if (param%lclose) then
         allocate(self%lcollision(n))
         allocate(self%lencounter(n))
         self%lcollision(:) = .false.
         self%lencounter(:) = .false.
      end if

      self%id(:) = 0
      do i = 1, n
         call self%info(i)%set_value(&
            name = "UNNAMED", &
            particle_type = "UNKNOWN", &
            status = "INACTIVE", & 
            origin_type = "UNKNOWN", &
            collision_id = 0, &
            origin_time = -huge(1.0_DP), & 
            origin_rh = [0.0_DP, 0.0_DP, 0.0_DP], &
            origin_vh = [0.0_DP, 0.0_DP, 0.0_DP], &
            discard_time = huge(1.0_DP), & 
            discard_rh = [0.0_DP, 0.0_DP, 0.0_DP], &
            discard_vh = [0.0_DP, 0.0_DP, 0.0_DP], &
            discard_body_id = -1  &
         )
      end do

      self%status(:) = INACTIVE
      self%ldiscard(:) = .false.
      self%lmask(:)  = .false.
      self%mu(:)     = 0.0_DP
      self%rh(:,:)   = 0.0_DP
      self%vh(:,:)   = 0.0_DP
      self%rb(:,:)   = 0.0_DP
      self%vb(:,:)   = 0.0_DP
      self%ah(:,:)   = 0.0_DP
      self%ir3h(:)   = 0.0_DP
      self%isperi(:) = 1
      self%peri(:)   = 0.0_DP
      self%atp(:)    = 0.0_DP

      if (param%lnon_spherical_cb) then
         allocate(self%aobl(NDIM, n))
         self%aobl(:,:) = 0.0_DP
      end if
      if (param%ltides) then
         allocate(self%atide(NDIM, n))
         self%atide(:,:) = 0.0_DP
      end if
      if (param%lgr) then
         allocate(self%agr(NDIM, n))
         self%agr(:,:) = 0.0_DP
      end if

      return
   end subroutine swiftest_util_setup_body


   module subroutine swiftest_util_setup_pl(self, n, param)
      !! author: David A. Minton
      !!
      !! Constructor for base Swiftest massive body class. Allocates space for all particles and
      !! initializes all components with a value. 
      implicit none
      ! Arguments
      class(swiftest_pl),         intent(inout) :: self  !! Swiftest massive body object
      integer(I4B),               intent(in)    :: n     !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameter
      ! Internals
      integer(I4B) :: i

      !> Call allocation method for parent class
      !> The parent class here is the abstract swiftest_body class, so we can't use the type-bound procedure
      call swiftest_util_setup_body(self, n, param)
      if (n == 0) return

      allocate(self%mass(n))
      allocate(self%Gmass(n))
      allocate(self%rhill(n))
      allocate(self%renc(n))

      self%mass(:) = 0.0_DP
      self%Gmass(:) = 0.0_DP
      self%rhill(:) = 0.0_DP
      self%renc(:) = 0.0_DP

      self%nplpl = 0   

      if (param%lclose) then
         allocate(self%nplenc(n))
         allocate(self%ntpenc(n))
         allocate(self%radius(n))
         allocate(self%density(n))
         allocate(self%kin(n))

         self%nplenc(:) = 0
         self%ntpenc(:) = 0
         self%radius(:) = 0.0_DP
         self%density(:) = 1.0_DP
         call self%reset_kinship([(i, i=1, n)])
      end if

      if (param%lmtiny_pl) then
         allocate(self%lmtiny(n))
         self%lmtiny(:) = .false.
      end if

      if (param%lrotation) then
         allocate(self%rot(NDIM, n))
         allocate(self%Ip(NDIM, n))
         self%rot(:,:) = 0.0_DP
         self%Ip(:,:) = 0.0_DP
      end if

      if (param%ltides) then
         allocate(self%k2(n))
         allocate(self%Q(n))
         allocate(self%tlag(n))
         self%k2(:) = 0.0_DP
         self%Q(:) = 0.0_DP
         self%tlag(:) = 0.0_DP
      end if
      
      return
   end subroutine swiftest_util_setup_pl
   

   module subroutine swiftest_util_setup_tp(self, n, param)
      !! author: David A. Minton
      !!
      !! Constructor for base Swiftest test particle particle class. Allocates space for 
      !! all particles and initializes all components with a value. 
      implicit none
      ! Arguments
      class(swiftest_tp),         intent(inout) :: self  !! Swiftest test particle object
      integer(I4B),               intent(in)    :: n     !! Number of particles to allocate space for
      class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameter

      !> Call allocation method for parent class
      !> The parent class here is the abstract swiftest_body class, so we can't use the type-bound procedure
      call swiftest_util_setup_body(self, n, param)
      if (n == 0) return

      allocate(self%nplenc(n))

      self%npltp = 0_I8B
      self%nplenc(:) = 0

      return
   end subroutine swiftest_util_setup_tp
 

   module subroutine swiftest_util_snapshot_system(self, param, nbody_system, t, arg)
      !! author: David A. Minton
      !!
      !! Takes a snapshot of the nbody_system for later file storage
      implicit none
      ! Arguments
      class(swiftest_storage),      intent(inout)        :: self         !! Swiftest storage object
      class(swiftest_parameters),   intent(inout)        :: param        !! Current run configuration parameters
      class(swiftest_nbody_system), intent(inout)        :: nbody_system !! Swiftest nbody system object to store
      real(DP),                     intent(in), optional :: t            !! Time of snapshot if different from nbody_system time
      character(*),                 intent(in), optional :: arg          !! Optional argument (needed for extended storage type used
                                                                         !!  in collision snapshots)
      ! Internals
      class(swiftest_nbody_system), allocatable :: snapshot

      ! To allow for runs to be restarted in a bit-identical way, we'll need to run the same coordinate conversion routines we would
      !  run upon restarting
      select type(pl => nbody_system%pl)
      class is (whm_pl)
         call pl%h2j(nbody_system%cb)
      class is (helio_pl)
         call pl%vh2vb(nbody_system%cb)
      end select

      select type(tp => nbody_system%tp)
      class is (helio_tp)
      select type(cb => nbody_system%cb)
      class is (helio_cb)
         call tp%vh2vb(vbcb = -cb%ptbeg)
      end select
      end select

      if (.not.param%lrhill_present) call nbody_system%pl%set_rhill(nbody_system%cb)

      ! Take a minimal snapshot wihout all of the extra storage objects
      allocate(snapshot, mold=nbody_system)
      allocate(snapshot%cb, source=nbody_system%cb )
      allocate(snapshot%pl, source=nbody_system%pl )
      allocate(snapshot%tp, source=nbody_system%tp )

      snapshot%t                 = nbody_system%t
      snapshot%GMtot             = nbody_system%GMtot
      snapshot%ke_orbit          = nbody_system%ke_orbit
      snapshot%ke_spin           = nbody_system%ke_spin
      snapshot%pe                = nbody_system%pe
      snapshot%be                = nbody_system%be
      snapshot%te                = nbody_system%te
      snapshot%oblpot            = nbody_system%oblpot
      snapshot%L_orbit           = nbody_system%L_orbit
      snapshot%L_spin            = nbody_system%L_spin
      snapshot%L_total           = nbody_system%L_total
      snapshot%ke_orbit_orig     = nbody_system%ke_orbit_orig
      snapshot%ke_spin_orig      = nbody_system%ke_spin_orig
      snapshot%pe_orig           = nbody_system%pe_orig
      snapshot%be_orig           = nbody_system%be_orig
      snapshot%E_orbit_orig      = nbody_system%E_orbit_orig
      snapshot%GMtot_orig        = nbody_system%GMtot_orig
      snapshot%L_total_orig      = nbody_system%L_total_orig
      snapshot%L_orbit_orig      = nbody_system%L_orbit_orig
      snapshot%L_spin_orig       = nbody_system%L_spin_orig
      snapshot%L_escape          = nbody_system%L_escape
      snapshot%GMescape          = nbody_system%GMescape
      snapshot%E_collisions      = nbody_system%E_collisions
      snapshot%E_untracked       = nbody_system%E_untracked
      snapshot%ke_orbit_error    = nbody_system%ke_orbit_error   
      snapshot%ke_spin_error     = nbody_system%ke_spin_error    
      snapshot%pe_error          = nbody_system%pe_error         
      snapshot%be_error          = nbody_system%be_error         
      snapshot%E_orbit_error     = nbody_system%E_orbit_error    
      snapshot%Ecoll_error       = nbody_system%Ecoll_error      
      snapshot%E_untracked_error = nbody_system%E_untracked_error
      snapshot%te_error          = nbody_system%te_error         
      snapshot%L_orbit_error     = nbody_system%L_orbit_error    
      snapshot%L_spin_error      = nbody_system%L_spin_error     
      snapshot%L_escape_error    = nbody_system%L_escape_error   
      snapshot%L_total_error     = nbody_system%L_total_error    
      snapshot%Mtot_error        = nbody_system%Mtot_error       
      snapshot%Mescape_error     = nbody_system%Mescape_error    
      snapshot%lbeg              = nbody_system%lbeg


      ! Store a snapshot of the nbody_system for posterity
      call base_util_snapshot_save(self, snapshot)
      self%nt = self%iframe
      self%nid = self%nid + 1 ! Central body
      if (allocated(nbody_system%pl)) self%nid = self%nid + nbody_system%pl%nbody
      if (allocated(nbody_system%tp)) self%nid = self%nid + nbody_system%tp%nbody
       
      return
   end subroutine swiftest_util_snapshot_system


   module subroutine swiftest_util_sort_body(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a Swiftest body structure in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(swiftest_body), intent(inout) :: self      !! Swiftest body object
      character(*),         intent(in)    :: sortby    !! Sorting attribute
      logical,              intent(in)    :: ascending !! Logical flag indicating whether or not the sorting should be in ascending 
                                                       !!  or descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B)                        :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(body => self, n => self%nbody)
         select case(sortby)
         case("id")
            call util_sort(direction * body%id(1:n), ind)
         case("status")
            call util_sort(direction * body%status(1:n), ind)
         case("ir3h")
            call util_sort(direction * body%ir3h(1:n), ind)
         case("a")
            call util_sort(direction * body%a(1:n), ind)
         case("e")
            call util_sort(direction * body%e(1:n), ind)
         case("inc")
            call util_sort(direction * body%inc(1:n), ind)
         case("capom")
            call util_sort(direction * body%capom(1:n), ind)
         case("mu")
            call util_sort(direction * body%mu(1:n), ind)
         case("peri")
            call util_sort(direction * body%peri(1:n), ind)
         case("atp")
            call util_sort(direction * body%atp(1:n), ind)
         case("info","lfirst","nbody","ldiscard","lcollision","lencounter","rh","vh","rb","vb","ah","aobl","atide","agr","isperi")
            write(*,*) 'Cannot sort by ' // trim(adjustl(sortby)) // '. Component not sortable!'
         case default
            write(*,*) 'Cannot sort by ' // trim(adjustl(sortby)) // '. Component not found!'
            return
         end select

         call body%rearrange(ind)

      end associate

      return
   end subroutine swiftest_util_sort_body


   module subroutine swiftest_util_sort_pl(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a Swiftest massive body object in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(swiftest_pl), intent(inout) :: self      !! Swiftest massive body object
      character(*),       intent(in)    :: sortby    !! Sorting attribute
      logical,            intent(in)    :: ascending !! Logical flag indicating whether or not the sorting should be in ascending or
                                                     !!  descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B)                        :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(pl => self, npl => self%nbody)
         select case(sortby)
         case("Gmass","mass")
            call util_sort(direction * pl%Gmass(1:npl), ind)
         case("rhill")
            call util_sort(direction * pl%rhill(1:npl), ind)
         case("renc")
            call util_sort(direction * pl%renc(1:npl), ind)
         case("radius")
            call util_sort(direction * pl%radius(1:npl), ind)
         case("density")
            call util_sort(direction * pl%density(1:npl), ind)
         case("k2")
            call util_sort(direction * pl%k2(1:npl), ind)
         case("Q")
            call util_sort(direction * pl%Q(1:npl), ind)
         case("tlag")
            call util_sort(direction * pl%tlag(1:npl), ind)
         case("nplenc")
            call util_sort(direction * pl%nplenc(1:npl), ind)
         case("ntpenc")
            call util_sort(direction * pl%ntpenc(1:npl), ind)
         case("lmtiny", "nplm", "nplplm", "kin", "rbeg", "rend", "vbeg", "Ip", "rot", "k_plpl", "nplpl")
            write(*,*) 'Cannot sort by ' // trim(adjustl(sortby)) // '. Component not sortable!'
         case default ! Look for components in the parent class
            call swiftest_util_sort_body(pl, sortby, ascending)
            return
         end select

         call pl%rearrange(ind)

      end associate

      return
   end subroutine swiftest_util_sort_pl


   module subroutine swiftest_util_sort_tp(self, sortby, ascending)
      !! author: David A. Minton
      !!
      !! Sort a Swiftest test particle object  in-place. 
      !! sortby is a string indicating which array component to sort.
      implicit none
      ! Arguments
      class(swiftest_tp), intent(inout) :: self      !! Swiftest test particle object
      character(*),       intent(in)    :: sortby    !! Sorting attribute
      logical,            intent(in)    :: ascending !! Logical flag indicating whether or not the sorting should be in ascending or
                                                     !!  descending order
      ! Internals
      integer(I4B), dimension(:), allocatable :: ind
      integer(I4B)                        :: direction

      if (self%nbody == 0) return

      if (ascending) then
         direction = 1
      else
         direction = -1
      end if

      associate(tp => self, ntp => self%nbody)
         select case(sortby)
         case("nplenc")
            call util_sort(direction * tp%nplenc(1:ntp), ind)
         case default ! Look for components in the parent class
            call swiftest_util_sort_body(tp, sortby, ascending)
            return
         end select

         call tp%rearrange(ind)

      end associate

      return
   end subroutine swiftest_util_sort_tp


   module subroutine swiftest_util_sort_rearrange_body(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange Swiftest body structure in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(swiftest_body),               intent(inout) :: self !! Swiftest body object
      integer(I4B),         dimension(:), intent(in)    :: ind  !! Index array used to restructure the body 
                                                                !!  (should contain all 1:n index values in the desired order)

      associate(n => self%nbody)
         call util_sort_rearrange(self%id,       ind, n)
         call util_sort_rearrange(self%lmask,    ind, n)
         call util_sort_rearrange(self%info,     ind, n)
         call util_sort_rearrange(self%status,   ind, n)
         call util_sort_rearrange(self%ldiscard, ind, n)
         call util_sort_rearrange(self%lcollision, ind, n)
         call util_sort_rearrange(self%lencounter, ind, n)
         call util_sort_rearrange(self%rh,       ind, n)
         call util_sort_rearrange(self%vh,       ind, n)
         call util_sort_rearrange(self%rb,       ind, n)
         call util_sort_rearrange(self%vb,       ind, n)
         call util_sort_rearrange(self%ah,       ind, n)
         call util_sort_rearrange(self%aobl,     ind, n)
         call util_sort_rearrange(self%agr,      ind, n)
         call util_sort_rearrange(self%atide,    ind, n)
         call util_sort_rearrange(self%ir3h,     ind, n)
         call util_sort_rearrange(self%isperi,   ind, n)
         call util_sort_rearrange(self%peri,     ind, n)
         call util_sort_rearrange(self%atp,      ind, n)
         call util_sort_rearrange(self%mu,       ind, n)
         call util_sort_rearrange(self%a,        ind, n)
         call util_sort_rearrange(self%e,        ind, n)
         call util_sort_rearrange(self%inc,      ind, n)
         call util_sort_rearrange(self%capom,    ind, n)
         call util_sort_rearrange(self%omega,    ind, n)
         call util_sort_rearrange(self%capm,     ind, n)
      end associate

      return
   end subroutine swiftest_util_sort_rearrange_body


   module subroutine swiftest_util_sort_rearrange_arr_info(arr, ind, n)
      !! author: David A. Minton
      !!
      !! Rearrange a single array of particle information type in-place from an index list.
      implicit none
      ! Arguments
      type(swiftest_particle_info),  dimension(:), allocatable, intent(inout) :: arr !! Destination array 
      integer(I4B),                  dimension(:),              intent(in)    :: ind !! Index to rearrange against
      integer(I4B),                                             intent(in)    :: n   !! Number of elements in arr & ind to rearrange
      ! Internals
      type(swiftest_particle_info),  dimension(:), allocatable :: tmp !! Temporary copy of array used during rearrange operation

      if (.not. allocated(arr) .or. n <= 0) return
      allocate(tmp, mold=arr)

      call swiftest_util_copy_particle_info_arr(arr, tmp, ind)
      call move_alloc(tmp, arr)

      return
   end subroutine swiftest_util_sort_rearrange_arr_info
 

   pure module subroutine swiftest_util_sort_rearrange_arr_kin(arr, ind, n)
      !! author: David A. Minton
      !!
      !! Rearrange a single array of particle kinship type in-place from an index list.
      implicit none
      ! Arguments
      type(swiftest_kinship),  dimension(:), allocatable, intent(inout) :: arr !! Destination array 
      integer(I4B),            dimension(:),              intent(in)    :: ind !! Index to rearrange against
      integer(I4B),                                       intent(in)    :: n   !! Number of elements in arr and ind to rearrange
      ! Internals
      type(swiftest_kinship),  dimension(:), allocatable :: tmp !! Temporary copy of array used during rearrange operation
      integer(I4B) :: i,j

      if (.not. allocated(arr) .or. n <= 0) return
      allocate(tmp, source=arr)
      tmp(1:n) = arr(ind(1:n))

      do i = 1, n
         do j = 1, tmp(i)%nchild
            tmp(i)%child(j) = ind(tmp(i)%child(j))
         end do
      end do

      call move_alloc(tmp, arr)
      return
   end subroutine swiftest_util_sort_rearrange_arr_kin


   module subroutine swiftest_util_sort_rearrange_pl(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange Swiftest massive body structure in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      class(swiftest_pl),               intent(inout) :: self !! Swiftest massive body object
      integer(I4B),       dimension(:), intent(in)    :: ind  !! Index array used to restructure the body 
                                                              !!  (should contain all 1:n index values in the desired order)

      associate(pl => self, npl => self%nbody)
         call util_sort_rearrange(pl%mass,    ind, npl)
         call util_sort_rearrange(pl%Gmass,   ind, npl)
         call util_sort_rearrange(pl%rhill,   ind, npl)
         call util_sort_rearrange(pl%renc,    ind, npl)
         call util_sort_rearrange(pl%radius,  ind, npl)
         call util_sort_rearrange(pl%density, ind, npl)
         call util_sort_rearrange(pl%rbeg,    ind, npl)
         call util_sort_rearrange(pl%vbeg,    ind, npl)
         call util_sort_rearrange(pl%Ip,      ind, npl)
         call util_sort_rearrange(pl%rot,     ind, npl)
         call util_sort_rearrange(pl%k2,      ind, npl)
         call util_sort_rearrange(pl%Q,       ind, npl)
         call util_sort_rearrange(pl%tlag,    ind, npl)
         call util_sort_rearrange(pl%kin,        ind, npl)
         call util_sort_rearrange(pl%lmtiny,     ind, npl)
         call util_sort_rearrange(pl%nplenc,     ind, npl)
         call util_sort_rearrange(pl%ntpenc,     ind, npl)

         if (allocated(pl%k_plpl)) deallocate(pl%k_plpl)

         call swiftest_util_sort_rearrange_body(pl, ind)
      end associate

      return
   end subroutine swiftest_util_sort_rearrange_pl


   module subroutine swiftest_util_sort_rearrange_tp(self, ind)
      !! author: David A. Minton
      !!
      !! Rearrange Swiftest massive body structure in-place from an index list.
      !! This is a helper utility used to make polymorphic sorting work on Swiftest structures.
      implicit none
      ! Arguments
      class(swiftest_tp),                 intent(inout) :: self !! Swiftest test particle object
      integer(I4B),         dimension(:), intent(in)    :: ind  !! Index array used to restructure the body 
                                                                !!  (should contain all 1:n index values in the desired order)

      associate(tp => self, ntp => self%nbody)
         call util_sort_rearrange(tp%nplenc,  ind, ntp)

         if (allocated(tp%k_pltp)) deallocate(tp%k_pltp)

         call swiftest_util_sort_rearrange_body(tp, ind)
      end associate

      return
   end subroutine swiftest_util_sort_rearrange_tp


   module subroutine swiftest_util_spill_arr_info(keeps, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Performs a spill operation on a single array of particle origin information types
      !! This is the inverse of a spill operation
      implicit none
      ! Arguments
      type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: keeps        !! Array of values to keep 
      type(swiftest_particle_info), dimension(:), allocatable, intent(inout) :: discards     !! Array of discards
      logical,                       dimension(:),              intent(in)   :: lspill_list  !! Logical array of bodies to spill 
                                                                                             !!  into the discardss
      logical,                                                  intent(in)   :: ldestructive !! Logical flag indicating whether or
                                                                                             !!  not this operation should alter the
                                                                                             !!  keeps array or not
      ! Internals
      integer(I4B) :: i, nspill, nkeep, nlist
      integer(I4B), dimension(:), allocatable :: idx
      type(swiftest_particle_info), dimension(:), allocatable :: tmp

      nkeep = count(.not.lspill_list(:))
      nspill = count(lspill_list(:))
      nlist = size(lspill_list(:))

      if (.not.allocated(keeps) .or. nspill == 0) return
      if (size(keeps) < nkeep) return
      if (.not.allocated(discards)) then
         allocate(discards(nspill))
      else if (size(discards) /= nspill) then
         deallocate(discards)
         allocate(discards(nspill))
      end if

      allocate(idx(nspill))
      idx(:) = pack([(i, i = 1, nlist)], lspill_list)
      call swiftest_util_copy_particle_info_arr(keeps, discards, idx)
      if (ldestructive) then
         if (nkeep > 0) then
            deallocate(idx)
            allocate(idx(nkeep))
            allocate(tmp(nkeep))
            idx(:) = pack([(i, i = 1, nlist)], .not. lspill_list)
            call swiftest_util_copy_particle_info_arr(keeps, tmp, idx)
            call move_alloc(tmp, keeps)
         else
            deallocate(keeps)
         end if
      end if

      return
   end subroutine swiftest_util_spill_arr_info


   module subroutine swiftest_util_spill_arr_kin(keeps, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Performs a spill operation on a single array of particle kinships
      !! This is the inverse of a spill operation
      implicit none
      ! Arguments
      type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: keeps        !! Array of values to keep 
      type(swiftest_kinship), dimension(:), allocatable, intent(inout) :: discards     !! Array of discards
      logical,                dimension(:),              intent(in)    :: lspill_list  !! Logical array of bodies to spill into the
                                                                                       !!  discardss
      logical,                                           intent(in)    :: ldestructive !! Logical flag indicating whether or not
                                                                                       !!  this operation should alter the keeps
                                                                                       !!  array or not
      ! Internals
      integer(I4B) :: nspill, nkeep, nlist
      type(swiftest_kinship), dimension(:), allocatable :: tmp

      nkeep = count(.not.lspill_list(:))
      nspill = count(lspill_list(:))
      nlist = size(lspill_list(:))

      if (.not.allocated(keeps) .or. nspill == 0) return
      if (size(keeps) < nkeep) return
      if (.not.allocated(discards)) then
         allocate(discards(nspill))
      else if (size(discards) /= nspill) then
         deallocate(discards)
         allocate(discards(nspill))
      end if

      discards(:) = pack(keeps(1:nlist), lspill_list(1:nlist))
      if (ldestructive) then
         if (nkeep > 0) then
            allocate(tmp(nkeep))
            tmp(:) = pack(keeps(1:nlist), .not. lspill_list(1:nlist))
            call move_alloc(tmp, keeps)
         else
            deallocate(keeps)
         end if
      end if

      return
   end subroutine swiftest_util_spill_arr_kin


   module subroutine swiftest_util_spill_body(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) Swiftest generic particle structure from active list to discard list
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(swiftest_body),  intent(inout) :: self         !! Swiftest generic body object
      class(swiftest_body),  intent(inout) :: discards     !! Discarded object 
      logical, dimension(:), intent(in)    :: lspill_list  !! Logical array of bodies to spill into the discards
      logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter
                                                           !!  body by removing the discard list
      ! Internals
      integer(I4B) :: nbody_old

      ! For each component, pack the discarded bodies into the discard object and do the inverse with the keeps
      !> Spill all the common components
      associate(keeps => self)
         
         call util_spill(keeps%id,         discards%id,         lspill_list, ldestructive)
         call util_spill(keeps%info,       discards%info,       lspill_list, ldestructive)
         call util_spill(keeps%lmask,      discards%lmask,      lspill_list, ldestructive)
         call util_spill(keeps%status,     discards%status,     lspill_list, ldestructive)
         call util_spill(keeps%ldiscard,   discards%ldiscard,   lspill_list, ldestructive)
         call util_spill(keeps%lcollision, discards%lcollision, lspill_list, ldestructive)
         call util_spill(keeps%lencounter, discards%lencounter, lspill_list, ldestructive)
         call util_spill(keeps%mu,         discards%mu,         lspill_list, ldestructive)
         call util_spill(keeps%rh,         discards%rh,         lspill_list, ldestructive)
         call util_spill(keeps%vh,         discards%vh,         lspill_list, ldestructive)
         call util_spill(keeps%rb,         discards%rb,         lspill_list, ldestructive)
         call util_spill(keeps%vb,         discards%vb,         lspill_list, ldestructive)
         call util_spill(keeps%ah,         discards%ah,         lspill_list, ldestructive)
         call util_spill(keeps%aobl,       discards%aobl,       lspill_list, ldestructive)
         call util_spill(keeps%agr,        discards%agr,        lspill_list, ldestructive)
         call util_spill(keeps%atide,      discards%atide,      lspill_list, ldestructive)
         call util_spill(keeps%ir3h,       discards%ir3h,       lspill_list, ldestructive)
         call util_spill(keeps%isperi,     discards%isperi,     lspill_list, ldestructive)
         call util_spill(keeps%peri,       discards%peri,       lspill_list, ldestructive)
         call util_spill(keeps%atp,        discards%atp,        lspill_list, ldestructive)
         call util_spill(keeps%a,          discards%a,          lspill_list, ldestructive)
         call util_spill(keeps%e,          discards%e,          lspill_list, ldestructive)
         call util_spill(keeps%inc,        discards%inc,        lspill_list, ldestructive)
         call util_spill(keeps%capom,      discards%capom,      lspill_list, ldestructive)
         call util_spill(keeps%omega,      discards%omega,      lspill_list, ldestructive)
         call util_spill(keeps%capm,       discards%capm,       lspill_list, ldestructive)

         nbody_old = keeps%nbody

         ! This is the base class, so will be the last to be called in the cascade. 
         ! Therefore we need to set the nbody values for both the keeps and discareds
         discards%nbody = count(lspill_list(1:nbody_old))
         if (ldestructive) keeps%nbody = nbody_old- discards%nbody
      end associate
     
      return
   end subroutine swiftest_util_spill_body


   module subroutine swiftest_util_spill_pl(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) Swiftest massive body structure from active list to discard list
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(swiftest_pl),    intent(inout) :: self        !! Swiftest massive body object
      class(swiftest_body),  intent(inout) :: discards    !! Discarded object 
      logical, dimension(:), intent(in)    :: lspill_list !! Logical array of bodies to spill into the discards
      logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter
                                                           !!  body by removing the discard list

      associate(keeps => self)
         select type (discards) !The standard requires us to select the type of both arguments in order to access all the components
         class is (swiftest_pl)
            !> Spill components specific to the massive body class
            call util_spill(keeps%mass,    discards%mass,    lspill_list, ldestructive)
            call util_spill(keeps%Gmass,   discards%Gmass,   lspill_list, ldestructive)
            call util_spill(keeps%rhill,   discards%rhill,   lspill_list, ldestructive)
            call util_spill(keeps%renc,    discards%renc,    lspill_list, ldestructive)
            call util_spill(keeps%radius,  discards%radius,  lspill_list, ldestructive)
            call util_spill(keeps%density, discards%density, lspill_list, ldestructive)
            call util_spill(keeps%rbeg,    discards%rbeg,    lspill_list, ldestructive)
            call util_spill(keeps%rend,    discards%rend,    lspill_list, ldestructive)
            call util_spill(keeps%vbeg,    discards%vbeg,    lspill_list, ldestructive)
            call util_spill(keeps%Ip,      discards%Ip,      lspill_list, ldestructive)
            call util_spill(keeps%rot,     discards%rot,     lspill_list, ldestructive)
            call util_spill(keeps%k2,      discards%k2,      lspill_list, ldestructive)
            call util_spill(keeps%Q,       discards%Q,       lspill_list, ldestructive)
            call util_spill(keeps%tlag,    discards%tlag,    lspill_list, ldestructive)
            call util_spill(keeps%kin,     discards%kin,     lspill_list, ldestructive)
            call util_spill(keeps%lmtiny,  discards%lmtiny,  lspill_list, ldestructive)
            call util_spill(keeps%nplenc,  discards%nplenc,  lspill_list, ldestructive)
            call util_spill(keeps%ntpenc,  discards%ntpenc,  lspill_list, ldestructive)

            if (ldestructive .and. allocated(keeps%k_plpl)) deallocate(keeps%k_plpl)

            call swiftest_util_spill_body(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) 'Error! spill method called for incompatible return type on swiftest_pl'
         end select
      end associate

      return
   end subroutine swiftest_util_spill_pl   


   module subroutine swiftest_util_spill_tp(self, discards, lspill_list, ldestructive)
      !! author: David A. Minton
      !!
      !! Move spilled (discarded) Swiftest test particle structure from active list to discard list
      !! Adapted from David E. Kaufmann's Swifter routine whm_discard_spill.f90
      implicit none
      ! Arguments
      class(swiftest_tp),    intent(inout) :: self         !! Swiftest test particle object
      class(swiftest_body),  intent(inout) :: discards     !! Discarded object 
      logical, dimension(:), intent(in)    :: lspill_list  !! Logical array of bodies to spill into the discardse
      logical,               intent(in)    :: ldestructive !! Logical flag indicating whether or not this operation should alter
                                                           !!  body by removing the discard list

      associate(keeps => self, ntp => self%nbody)
         select type(discards)
         class is (swiftest_tp)
            !> Spill components specific to the test particle class
            call util_spill(keeps%nplenc,  discards%nplenc,  lspill_list, ldestructive)
            call swiftest_util_spill_body(keeps, discards, lspill_list, ldestructive)
         class default
            write(*,*) 'Error! spill method called for incompatible return type on swiftest_tp'
         end select
      end associate

      return
   end subroutine swiftest_util_spill_tp


   module subroutine swiftest_util_valid_id_system(self, param)
      !! author: David A. Minton
      !!
      !! Validate massive body and test particle ids
      !! If non-unique values detected, it will replace them
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: util_valid.f90
      implicit none
      ! Arguments
      class(swiftest_nbody_system), intent(inout) :: self   !! Swiftest nbody system object
      class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters
      ! Internals
      integer(I4B) :: i, nid
      integer(I4B), dimension(:), allocatable :: idarr, unique_idarr, idmap

      associate(cb => self%cb, pl => self%pl, npl => self%pl%nbody, tp => self%tp, ntp => self%tp%nbody, maxid => self%maxid)
         nid = 1 + npl+ ntp
         allocate(idarr(nid))
         ! Central body should always be id=0
         cb%id = 0
         idarr(1) = cb%id
         do i = 1, npl
            idarr(1+i) = pl%id(i)
         end do
         do i = 1, ntp
            idarr(1+npl+i) = tp%id(i)
         end do
         maxid = maxval(idarr)

         ! Check to see if the ids are unique
         call util_unique(idarr, unique_idarr, idmap)
         if (size(unique_idarr) == nid) return ! All id values are unique

         ! Fix any duplicate id values and update the maxid
         call util_sort(idmap)
         do i = 2, size(idmap)
            if (idmap(i) == idmap(i-1)) then
               maxid = maxid + 1
               if (i < 1 + npl) then
                  pl%id(i - 1) = maxid 
               else
                  tp%id(i - 1 - npl) = maxid
               end if
            end if
         end do

      end associate

      return
   end subroutine swiftest_util_valid_id_system


   module subroutine swiftest_util_version()
      !! author: David A. Minton
      !!
      !! Print program version information to terminale
      !!
      !! Adapted from David E. Kaufmann's Swifter routine: util_version.f90
      implicit none
      write(*, 200) VERSION
      200 format(/, "************* Swiftest: Version ", f3.1, " *************",/,  &
            "Based off of Swifter:",/,                                             &
            "Authors:",/,                                                          &
            "    The Purdue University Swiftest Development team ",/,              &
            "    Lead by David A. Minton ",/,                                      &
            "    Carlisle Wishard, Jennifer Pouplin, Jacob Elliott, Dana Singh.",/,&
            "Please address comments and questions to:",/,                         &
            "    David A. Minton",/,                                               &
            "    Department Earth, Atmospheric, & Planetary Sciences ",/,          &
            "    Purdue University",/,                                             &
            "    550 Stadium Mall Drive",/,                                        &
            "    West Lafayette, Indiana 47907", /,                                &
            "    765-494-3292 ",/,                                                 &
            "    daminton@purdue.edu",/,                                           &
            "Special thanks to Hal Levison, Martin Duncan, and David Kaufmann",/,  &
            "for the original SWIFTER and SWIFT codes that made this possible.",/, &
            "************************************************", /)


      return
   end subroutine swiftest_util_version

end submodule s_swiftest_util

! Copyight 2022 - David Minton, Carlisle Wishard, Jennifer Pouplin, Jake Elliott, & Dana Singh
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

module helio
   !! author: The Purdue Swiftest Team - David A. Minton, Carlisle A. Wishard, Jennifer L.L. Pouplin, and Jacob R. Elliott
   !!
   !! Definition of classes and methods specific to the Democratic Heliocentric Method
   !! Adapted from David E. Kaufmann's Swifter routine: module_helio.f90
   use swiftest
   use whm
   implicit none
   public


   type, extends(whm_nbody_system) :: helio_nbody_system
   contains
      procedure :: step       => helio_step_system             !! Advance the Helio nbody system forward in time by one step
      procedure :: initialize => helio_util_setup_initialize_system !! Performs Helio-specific initilization steps, including converting to DH coordinates
   end type helio_nbody_system


   !> Helio central body particle class
   type, extends(swiftest_cb) :: helio_cb
      real(DP), dimension(NDIM)  :: ptbeg !! negative barycentric velocity of the central body at the beginning of time step
      real(DP), dimension(NDIM)  :: ptend !! negative barycentric velocity of the central body at the end of time step
   contains
   end type helio_cb


   !! Helio massive body particle class
   type, extends(swiftest_pl) :: helio_pl
   contains
      procedure :: drift       => helio_drift_pl           !! Method for Danby drift in Democratic Heliocentric coordinates 
      procedure :: lindrift    => helio_drift_linear_pl    !! Method for linear drift of massive bodies due to barycentric momentum of Sun
      procedure :: accel_gr    => helio_gr_kick_getacch_pl !! Acceleration term arising from the post-Newtonian correction
      procedure :: gr_pos_kick => helio_gr_p4_pl           !! Position kick due to p**4 term in the post-Newtonian correction
      procedure :: accel       => helio_kick_getacch_pl    !! Compute heliocentric accelerations of massive bodies
      procedure :: kick        => helio_kick_vb_pl         !! Kicks the barycentric velocities
      procedure :: step        => helio_step_pl            !! Steps the body forward one stepsize
   end type helio_pl


   !! Helio test particle class
   type, extends(swiftest_tp) :: helio_tp
   contains
      procedure :: lindrift    => helio_drift_linear_tp    !! Method for linear drift of massive bodies due to barycentric momentum of Sun
      procedure :: drift       => helio_drift_tp           !! Method for Danby drift in Democratic Heliocentric coordinates 
      procedure :: accel_gr    => helio_gr_kick_getacch_tp !! Acceleration term arising from the post-Newtonian correction
      procedure :: gr_pos_kick => helio_gr_p4_tp           !! Position kick due to p**4 term in the post-Newtonian correction
      procedure :: accel       => helio_kick_getacch_tp    !! Compute heliocentric accelerations of massive bodies
      procedure :: kick        => helio_kick_vb_tp         !! Kicks the barycentric velocities
      procedure :: step        => helio_step_tp            !! Steps the body forward one stepsize
   end type helio_tp

   interface
      module subroutine helio_drift_body(self, nbody_system, param, dt)
         implicit none
         class(swiftest_body),         intent(inout) :: self   !! Swiftest massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Stepsize
      end subroutine helio_drift_body
   
      module subroutine helio_drift_pl(self, nbody_system, param, dt)
         implicit none
         class(helio_pl),              intent(inout) :: self   !! Helio massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Stepsize
      end subroutine helio_drift_pl

      module subroutine helio_drift_tp(self, nbody_system, param, dt)
         implicit none
         class(helio_tp),              intent(inout) :: self   !! Helio massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Stepsize
      end subroutine helio_drift_tp

      module subroutine helio_drift_linear_pl(self, cb, dt, lbeg)
         implicit none
         class(helio_pl),               intent(inout) :: self !! Helio massive body object
         class(helio_cb),               intent(inout) :: cb   !! Helio central body
         real(DP),                      intent(in)    :: dt   !! Stepsize
         logical,                       intent(in)    :: lbeg !! Argument that determines whether or not this is the beginning or end of the step
      end subroutine helio_drift_linear_pl 

      module subroutine helio_drift_linear_tp(self, cb, dt, lbeg)
         implicit none
         class(helio_tp),               intent(inout) :: self !! Helio test particle object
         class(helio_cb),               intent(in)    :: cb   !! Helio central body
         real(DP),                      intent(in)    :: dt   !! Stepsize
         logical,                       intent(in)    :: lbeg !! Argument that determines whether or not this is the beginning or end of the step
      end subroutine helio_drift_linear_tp

      pure module subroutine helio_gr_kick_getacch_pl(self, param) 
         implicit none
         class(helio_pl),            intent(inout) :: self   !! Helio massive body particle data structure
         class(swiftest_parameters), intent(in)    :: param !! Current run configuration parameters 
      end subroutine helio_gr_kick_getacch_pl
   
      pure module subroutine helio_gr_kick_getacch_tp(self, param)
         implicit none
         class(helio_tp),            intent(inout) :: self   !! Helio massive body particle data structure
         class(swiftest_parameters), intent(in)    :: param  !! Current run configuration parameters 
      end subroutine helio_gr_kick_getacch_tp
      
      pure module subroutine helio_gr_p4_pl(self, nbody_system, param, dt)
         implicit none
         class(helio_pl),              intent(inout) :: self   !! Swiftest particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Step size
      end subroutine helio_gr_p4_pl
   
      pure module subroutine helio_gr_p4_tp(self, nbody_system, param, dt)
         implicit none
         class(helio_tp),              intent(inout) :: self   !! Swiftest particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(in)    :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: dt     !! Step size
      end subroutine helio_gr_p4_tp

      module subroutine helio_kick_getacch_pl(self, nbody_system, param, t, lbeg)
         implicit none
         class(helio_pl),              intent(inout) :: self   !! Helio massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current simulation time
         logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine helio_kick_getacch_pl

      module subroutine helio_kick_getacch_tp(self, nbody_system, param, t, lbeg)
         implicit none
         class(helio_tp),              intent(inout) :: self   !! Helio test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters
         real(DP),                     intent(in)    :: t      !! Current time
         logical,                      intent(in)    :: lbeg   !! Logical flag that determines whether or not this is the beginning or end of the step
      end subroutine helio_kick_getacch_tp

      module subroutine helio_kick_vb_pl(self, nbody_system, param, t, dt, lbeg)
         implicit none
         class(helio_pl),              intent(inout) :: self   !! Helio massive body object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current time
         real(DP),                     intent(in)    :: dt     !! Stepsize
         logical,                      intent(in)    :: lbeg   !! Logical flag indicating whether this is the beginning of the half step or not. 
      end subroutine helio_kick_vb_pl

      module subroutine helio_kick_vb_tp(self, nbody_system, param, t, dt, lbeg)
         implicit none
         class(helio_tp),              intent(inout) :: self   !! Helio test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current time
         real(DP),                     intent(in)    :: dt     !! Stepsize
         logical,                      intent(in)    :: lbeg   !! Logical flag indicating whether this is the beginning of the half step or not. 
      end subroutine helio_kick_vb_tp

      module subroutine helio_util_setup_initialize_system(self, system_history, param)
         implicit none
         class(helio_nbody_system),               intent(inout) :: self           !! Helio nbody system object
         class(swiftest_storage),    allocatable, intent(inout) :: system_history !! Stores the system history between output dumps
         class(swiftest_parameters),              intent(inout) :: param          !! Current run configuration parameters 
      end subroutine helio_util_setup_initialize_system

      module subroutine helio_step_pl(self, nbody_system, param, t, dt)
         implicit none
         class(helio_pl),              intent(inout) :: self   !! Helio massive body particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current simulation time
         real(DP),                     intent(in)    :: dt     !! Stepsize
      end subroutine helio_step_pl

      module subroutine helio_step_system(self, param, t, dt)
         implicit none
         class(helio_nbody_system),  intent(inout) :: self  !! Helio nbody system object
         class(swiftest_parameters), intent(inout) :: param !! Current run configuration parameters
         real(DP),                   intent(in)    :: t     !! Simulation time
         real(DP),                   intent(in)    :: dt    !! Current stepsize
      end subroutine helio_step_system

      module subroutine helio_step_tp(self, nbody_system, param, t, dt)
         implicit none
         class(helio_tp),              intent(inout) :: self   !! Helio test particle object
         class(swiftest_nbody_system), intent(inout) :: nbody_system !! Swiftest nbody system object
         class(swiftest_parameters),   intent(inout) :: param  !! Current run configuration parameters 
         real(DP),                     intent(in)    :: t      !! Current simulation time
         real(DP),                     intent(in)    :: dt     !! Stepsizee
      end subroutine helio_step_tp
   end interface

end module helio

! Copyight 2023 - David Minton
! This file is part of Swiftest.
! Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Swiftest. 
! If not, see: https://www.gnu.org/licenses. 

submodule (rmvs) s_rmvs_coarray
use coarray
use swiftest
use whm
contains

    module subroutine rmvs_coarray_coclone_cb(self)
        !! author: David A. Minton
        !!
        !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(rmvs_cb),intent(inout),codimension[*]  :: self  !! RMVS pl object

        call coclone(self%outer)
        call coclone(self%inner)
        call coclone(self%lplanetocentric)

        call swiftest_coarray_coclone_cb(self)

        return
    end subroutine rmvs_coarray_coclone_cb


    module subroutine rmvs_coarray_coclone_interp(self)
        !! author: David A. Minton
        !!
        !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(rmvs_interp),intent(inout),codimension[*]  :: self  !! RMVS pl object

        call coclone(self%x)
        call coclone(self%v) 
        call coclone(self%aobl)
        call coclone(self%atide)

        return
    end subroutine rmvs_coarray_coclone_interp


    module subroutine rmvs_coarray_coclone_pl(self)
        !! author: David A. Minton
        !!
        !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(rmvs_pl),intent(inout),codimension[*]  :: self  !! RMVS pl object

        call coclone(self%nenc)
        call coclone(self%tpenc1P)
        call coclone(self%plind)
        call coclone(self%outer)
        call coclone(self%lplanetocentric)

        call whm_coarray_coclone_pl(self)

        return
    end subroutine rmvs_coarray_coclone_pl


    module subroutine rmvs_coarray_coclone_system(self)
        !! author: David A. Minton
         !!
         !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(rmvs_nbody_system),intent(inout),codimension[*]  :: self  !! Swiftest body object
        ! Internals
        integer(I4B) :: i, img

        call coclone(self%lplanetocentric)
        call coclone(self%rts)
        call coclone(self%vbeg)

        call swiftest_coarray_coclone_system(self)

        return
    end subroutine rmvs_coarray_coclone_system


    module subroutine rmvs_coarray_coclone_tp(self)
        !! author: David A. Minton
        !!
        !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(rmvs_tp),intent(inout),codimension[*]  :: self  !! RMVS pl object

        call coclone(self%lperi)
        call coclone(self%plperP) 
        call coclone(self%plencP)
        call coclone(self%index)
        call coclone(self%ipleP)
        call coclone(self%lplanetocentric)

        call swiftest_coarray_coclone_tp(self)

        return
    end subroutine rmvs_coarray_coclone_tp


    module subroutine rmvs_coarray_component_clone_interp_arr1D(var,src_img)
        implicit none
        !! author: David A. Minton
        !!
        !! Copies a component of a coarray derived type from the specified source image to the current local one. The default source image is 1
        !! swiftest_particle_info scalar version
        ! Arguments
        type(rmvs_interp), dimension(:), allocatable, intent(inout) :: var
        integer(I4B), intent(in),optional :: src_img
        ! Internals
        type(rmvs_interp), dimension(:), codimension[:], allocatable :: tmp
        integer(I4B) :: i,img, si
        integer(I4B), save :: n[*]
        logical, save :: isalloc[*]
    
        if (present(src_img)) then
            si = src_img
        else
            si = 1
        end if

        sync all
        isalloc = allocated(var)
        if (isalloc) n = size(var)
        sync all 
        if (.not. isalloc[si]) return

        allocate(tmp(n[si])[*])
        do i = 1, n[si]
            call tmp(i)%coclone()
        end do
        if (this_image() /= si) then
            if (allocated(var)) deallocate(var)
            allocate(var, source=tmp)
        end if

        return
    end subroutine rmvs_coarray_component_clone_interp_arr1D


    module subroutine rmvs_coarray_cocollect_tp(self)
        !! author: David A. Minton
        !!
        !! Broadcasts the image 1 object to all other images in a coarray 
        implicit none
        ! Arguments
        class(rmvs_tp),intent(inout),codimension[*]  :: self  !! RMVS pl object

        call cocollect(self%lperi)
        call cocollect(self%plperP) 
        call cocollect(self%plencP)

        call swiftest_coarray_cocollect_tp(self)

        return
    end subroutine rmvs_coarray_cocollect_tp

end submodule s_rmvs_coarray

#!/bin/bash
# This script will determine the paths to the suite of compilers and return values for CC, CXX, FC, and F77 based on the compiler 
# vender options
# On x86_64 Linux machines, Intel compilers are preferred.
# On aarch64 Linux machines, default GNU compilers are preferred.
# On MacOS machines, GNU compilers from Homebrew are preferred.
# 
# Copyright 2023 - David Minton
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
# Parse arguments
case "$OS" in
    Intel|Linux|MacOSX)
        ;;
    *)
        echo "Unknown compiler type: $OS"
        echo "Valid options are Intel, Linux, or MacOSX"
        echo $USTMT
        exit 1
        ;;
esac

set -a
# Only replace compiler definitions if they are not already set
case $OS in
    Intel)
        if [ ! -v FC ]; then
            if command -v ifx &> /dev/null; then
                FC=$(command -v ifx)
            elif command -v ifort &> /dev/null; then
                FC=$(command -v mpiifort)
            else
                printf "Error. Cannot find valid Intel Fortran compiler.\n"
                exit 1
            fi
        fi
        if [ ! -v F77 ]; then
            F77="${FC}"
        fi

        if [ ! -v CC ]; then
            if command -v icx &> /dev/null; then 
                CC=$(command -v icx)
            elif command -v icc &> /dev/null; then
                CC=$(command -v icc)
            else
                printf "Error. Cannot find valid Intel C compiler.\n"
                exit 1
            fi
        fi

        if [ ! -v CXX ]; then
            if command -v icpx &> /dev/null; then
                CXX=$(command -v icpx)
            elif command -v icpc &> /dev/null; then
                CXX=$(command -v icpc)
            else
                printf "Error. Cannot find valid Intel C++ compiler.\n"
                exit 1
            fi
        fi

        if command -v mpiifort &> /dev/null; then
            I_MPI_F90=${FC}
            FC=$(command -v mpiifort)
        fi

        if command -v mpiicc &> /dev/null; then
            I_MPI_CC =${CC}
            CC=$(command -v mpiicc)
        fi

        if command -v mpiicpc &> /dev/null; then
            I_MPI_CXX =${CXX}
            CXX=$(command -v mpiicpc)
        fi

        CPP=${CPP:-$HOMEBRE_PREFIX/bin/cpp-13}
        ;;
    Linux)
        FC=${FC:-$(command -v gfortran)}
        CC=${CC:-$(command -v gcc)}
        CXX=${CXX:-$(command -v g++)}
        CPP=${CPP:-$(command -v cpp)}
        ;;
    MacOSX)
        if [ $ARCH = "arm64" ]; then
            if $(brew --version &> /dev/null); then 
                brew install llvm@16 libomp 
            else
                echo \"Please install Homebrew first\" 
                exit 1 
            fi
            COMPILER_PREFIX=${COMPILER_PREFIX:-"${HOMEBREW_PREFIX}/opt/llvm"}
            CC=${CC:-${COMPILER_PREFIX}/bin/clang}
            CXX=${CXX:-${COMPILER_PREFIX}/bin/clang++}
            CPP=${CPP:-${COMPILER_PREFIX}/bin/clang-cpp}
            AR=${AR:-${COMPILER_PREFIX}/bin/llvm-ar}
            NM=${NM:-${COMPILER_PREFIX}/bin/llvm-nm}
            RANLIB=${RANLIB:-${COMPILER_PREFIX}/bin/llvm-ranlib}
            FROOT=$(realpath $(dirname $(command -v gfortran))/..) 
            FC=$(command -v gfortran)
            LD_LIBRARY_PATH="${COMPILER_PREFIX}/lib:${FROOT}/lib:${LD_LIBRARY_PATH}"
            LDFLAGS="-L${HOMEBREW_PREFIX}/opt/llvm/lib/c++ -Wl,-rpath,${HOMEBREW_PREFIX}/opt/llvm/lib/c+ -L${HOMEBREW_PREFIX}/opt/libomp/lib -Wl,-no_compact_unwind"
            CPPFLAGS="-isystem ${HOMEBREW_PREFIX}/opt/libomp/include"
            LIBS="-lomp ${LIBS}"
            CPATH="${FROOT}/include:${CPATH}"
            CXXFLAGS="${CFLAGS} ${CXXFLAGS}"
            FCFLAGS="${CFLAGS} ${FCFLAGS}"
            CFLAGS="-mmacosx-version-min=${MACOSX_DEPLOYMENT_TARGET} -Wno-deprecated-non-prototype ${CFLAGS}"
        else
            if $(brew --version &> /dev/null); then 
                brew install gcc
            else
                echo \"Please install Homebrew first\" 
                exit 1 
            fi
            COMPILER_PREFIX=${COMPILER_PREFIX:-"${HOMEBREW_PREFIX}/Cellar/gcc/13.1.0/"}
            CC=${CC:-${COMPILER_PREFIX}/bin/gcc-13}
            CXX=${CXX:-${COMPILER_PREFIX}/bin/g++-13}
            CPP=${CPP:-${COMPILER_PREFIX}/bin/cpp-13}
            AR=${AR:-${COMPILER_PREFIX}/bin/gcc-ar-13}
            NM=${NM:-${COMPILER_PREFIX}/bin/gcc-nm-13}
            RANLIB=${RANLIB:-${COMPILER_PREFIX}/bin/gcc-ranlib-13}
            FC=${FC:-${COMPILER_PREFIX}/bin/gfortran-13}
            LD_LIBRARY_PATH="${COMPILER_PREFIX}/lib/gcc/13:${LD_LIBRARY_PATH}"
            LDFLAGS="-L${HOMEBREW_PREFIX}/opt/llvm/lib/c++ -Wl,-rpath,${HOMEBREW_PREFIX}/opt/llvm/lib/c+  -Wl,-no_compact_unwind"
            CPPFLAGS="-isystem ${HOMEBREW_PREFIX}/opt/libomp/include"
            LIBS="-lgomp ${LIBS}"
            CPATH="${FROOT}/include:${CPATH}"
            CXXFLAGS="${CFLAGS} ${CXXFLAGS}"
            FCFLAGS="${CFLAGS} ${FCFLAGS}"
            CFLAGS="-mmacosx-version-min=${MACOSX_DEPLOYMENT_TARGET} -Wno-deprecated-non-prototype ${CFLAGS}"
        fi    
        ;;
    *)
        printf "Unknown compiler type: ${OS}\n"
        echo "Valid options are Intel, Linux, or MacOSX"
        printf $USTMT
        exit 1
        ;;
esac
F77=${FC}

#!/bin/bash
#
# This gets the current gfortran version number
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 

case $FC in
    *"mpiifort"*|*"ifx"*)
      OMPI_FC="$(command -v ifort || command -v ifx)"
      ;;
    *"gfortran"*|*"mpifort")
      OMPI_FC="$(command -v gfortran-14 || command -v gfortran-13 || command -v gfortran-12 || command -v gfortran)"
      ;;
    *)
      "No Fortran compiler found"
      exit 1
      ;;
esac
echo "${OMPI_FC}"
set +a

#!/bin/bash
# This script will build the z library needed by HDF5
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
ZLIB_VER="1.3.1"
SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*          STARTING DEPENDENCY BUILD                    *\n"
printf "*********************************************************\n"
printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n"
printf "Installing to ${ZLIB_ROOT}\n"
printf "\n"

printf "*********************************************************\n"
printf "*             FETCHING ZLIB SOURCE                      *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"
mkdir -p "${DEPENDENCY_DIR}"
if [ ! -d "${DEPENDENCY_DIR}"/zlib-${ZLIB_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/zlib-* ] && rm -rf "${DEPENDENCY_DIR}"/zlib-*
    curl -L https://github.com/madler/zlib/releases/download/v${ZLIB_VER}/zlib-${ZLIB_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi

printf "*********************************************************\n"
printf "*               BUILDING ZLIB LIBRARY                   *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "INSTALL_PREFIX: ${ZLIB_ROOT}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/zlib-*
cmake -B build -S . -G Ninja -DCMAKE_INSTALL_PREFIX="${ZLIB_ROOT}" -DCMAKE_INSTALL_LIBDIR="lib" -DCMAKE_POSITION_INDEPENDENT_CODE:BOOL=ON 
OS=$(uname -s)
if [[ "${OS}" == "Darwin" ]]; then
    LIBEXT="dylib"
elif [[ "${OS}" == "Linux" ]]; then
    LIBEXT="so"
elif [[ "${OS}" == *"MINGW64"* ]]; then
    LIBEXT="dll"
fi 
cmake --build build -j${NPROC}
if [ -w "${ZLIB_ROOT}" ]; then
    cmake --install build 
    rm -f "${ZLIB_ROOT}"/lib/libz*${LIBEXT}*
    # On some platforms the name is slightly different. Rename it so that later scripts can find it more easily
    if [ -f "${ZLIB_ROOT}"/lib/libzlibstatic.a ]; then #
        mv "${ZLIB_ROOT}"/lib/libzlibstatic.a "${ZLIB_ROOT}"/lib/libz.a
    fi
else
    sudo cmake --install build
    sudo rm -f "${ZLIB_ROOT}"/lib/libz*${LIBEXT}*
    if [ -f "${ZLIB_ROOT}"/lib/libzlibstatic.a ]; then
        sudo mv "${ZLIB_ROOT}"/lib/libzlibstatic.a "${ZLIB_ROOT}"/lib/libz.a
    fi
fi


if [ $? -ne 0 ]; then
   printf "zlib could not be compiled.\n"
   exit 1
fi

#!/bin/bash
# This script will build the c-blosc library needed by HDF5
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
BLOSC_VER="1.21.5"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*          STARTING DEPENDENCY BUILD                    *\n"
printf "*********************************************************\n"
printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n"
printf "Installing to ${BLOSC_ROOT}\n"
printf "\n"

printf "*********************************************************\n"
printf "*             FETCHING BLOSC SOURCE                      *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"
mkdir -p "${DEPENDENCY_DIR}"
if [ ! -d "${DEPENDENCY_DIR}"/c-blosc-${BLOSC_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/c-blosc-* ] && rm -rf "${DEPENDENCY_DIR}"/c-blosc-*
    curl -L https://github.com/Blosc/c-blosc/archive/refs/tags/v${BLOSC_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi
printf "*********************************************************\n"
printf "*               BUILDING BLOSC LIBRARY                  *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "INSTALL_PREFIX: ${BLOSC_ROOT}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/c-blosc-*
cmake -B build -S . -G Ninja -DCMAKE_INSTALL_PREFIX=${BLOSC_ROOT} -DCMAKE_INSTALL_LIBDIR="lib" -DBUILD_SHARED:BOOL=OFF -DBUILD_STATIC:BOOL=ON -DBUILD_TESTS:BOOL=OFF -DBUILD_FUZZERS:BOOL=OFF -DBUILD_BENCHMARKS:BOOL=OFF -DBUILD_EXAMPLES:BOOL=OFF -DPREFER_EXTERNAL_ZLIB:BOOL=ON -DPREFER_EXTERNAL_ZSTD:BOOL=ON -DCMAKE_POSITION_INDEPENDENT_CODE:BOOL=ON 
cmake --build build -j${NPROC}    
if [ -w "${BLOSC_ROOT}" ]; then
    cmake --install build 
else
    sudo cmake --install build 
fi

if [ $? -ne 0 ]; then
   printf "c-blosc could not be compiled.\n"
   exit 1
fi

#!/bin/bash
# This script will build all of the dependency libraries needed by Swiftest. Builds the following from source:
# Ninja, libaec, bzip2, zstd, hdf5, netcdf-c, netcdf-fortran
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 

# Determine the platform and architecture
SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}"/..)

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

echo "Checking for Ninja"
if ! command -v ninja &> /dev/null; then
    NINJA_VER="1.11.1"

    printf "*********************************************************\n"
    printf "*             FETCHING NINJA SOURCE                      *\n"
    printf "*********************************************************\n"
    printf "Copying files to ${DEPENDENCY_DIR}\n"
    mkdir -p "${DEPENDENCY_DIR}"
    if [ ! -d "${DEPENDENCY_DIR}"/ninja-${NINJA_VER} ]; then
        [ -d "${DEPENDENCY_DIR}"/ninja-* ] && rm -rf "${DEPENDENCY_DIR}"/ninja-*
        curl -L https://github.com/ninja-build/ninja/archive/refs/tags/v${NINJA_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
    fi
    cd "${DEPENDENCY_DIR}"/ninja-*
    cmake -B build -S . -DCMAKE_INSTALL_PREFIX=/usr/local
    cmake --build build 
    if [ -w "${PREFIX}" ]; then
        cmake --install build 
    else
        sudo cmake --install build
    fi
fi

echo "Checking for OpenMP"

# Get the OpenMP Libraries
OS=$(uname -s)
if [ $OS = "Darwin" ]; then
    echo "Fetching OpenMP libraries for MacOS"
    "${SCRIPT_DIR}"/get_lomp.sh 
fi

echo "Starting build scripts"

"${SCRIPT_DIR}"/build_zlib.sh 
"${SCRIPT_DIR}"/build_libaec.sh
"${SCRIPT_DIR}"/build_bzip2.sh 
"${SCRIPT_DIR}"/build_zstd.sh 
"${SCRIPT_DIR}"/build_blosc.sh
"${SCRIPT_DIR}"/build_hdf5.sh 
"${SCRIPT_DIR}"/build_netcdf-c.sh
"${SCRIPT_DIR}"/build_netcdf-fortran.sh
"${SCRIPT_DIR}"/build_shtools.sh 

if [ $OS = "Linux" ]; then
    FORTNAME="$(basename $OMPI_FC)"
    if [ $FORTNAME="gfortran" ]; then
        "${SCRIPT_DIR}"/build_opencoarrays.sh
    fi
fi

printf "\n"
printf "*********************************************************\n"
printf "*             DEPENDENCIES ARE BUILT                    *\n"
printf "*********************************************************\n"
printf "Dependencys are installed to: ${PREFIX}\n\n"

#!/bin/bash
# This script will generate cross-platform wheels for the Swiftest Python package using Docker. If it is called from MacOS it will
# also generate a Mac build.
#
# Copyright 2023 - David Minton
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 

# Determine the platform and architecture
set -a
SCRIPT_DIR=$(realpath $(dirname $0))
ARGS=$@
. ${SCRIPT_DIR}/_build_getopts.sh ${ARGS}

set -e
${SCRIPT_DIR}/build_dependencies.sh ${ARGS}
${SCRIPT_DIR}/build_swiftest.sh ${ARGS}

#!/bin/bash
# This script will gets the arguments common to all the dependency build scripts
# 
# Copyright 2023 - David Minton
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
set -a
SCRIPT_DIR=$(realpath $(dirname $0))
ROOT_DIR=$(realpath ${SCRIPT_DIR}/..)

# Parse arguments
USTMT="Usage: ${0} <-d /path/to/dependency/source> [-p /prefix/path|{/usr/local}] [-m MACOSX_DEPLOYMENT_TARGET|{11.0}]"
PREFIX=/usr/local
DEPENDENCY_DIR="${ROOT_DIR}/_dependencies"
MACOSX_DEPLOYMENT_TARGET="13.0"
while getopts ":d:p:m:h" ARG; do
    case "${ARG}" in
    d)
        mkdir -p ${OPTARG}
        DEPENDENCY_DIR=$(realpath "${OPTARG}")
        ;;
    p)
        mkdir -p ${OPTARG}
        PREFIX=$(realpath "${OPTARG}")
        ;;
    m)
        MACOSX_DEPLOYMENT_TARGET="${OPTARG}"
        ;;
    :)      
        printf "Error: -${OPTARG} requires an argument.\n"
        printf "$USTMT\n"
        exit 1
        ;;
    h)
        printf "$USTMT\n"
        exit 1
        ;;
    *)
        ;;
    esac
done

read -r OS ARCH < <($SCRIPT_DIR/get_platform.sh)

if [ -z ${DEPENDENCY_ENV_VARS+x} ]; then
    . ${SCRIPT_DIR}/set_compilers.sh 

    LD_LIBRARY_PATH="${PREFIX}/lib:${LD_LIBRARY_PATH}"
    CPPFLAGS="${CPPFLAGS} -isystem ${PREFIX}/include"
    LDFLAGS="${LDFLAGS} -L${PREFIX}/lib"
    CPATH="${CPATH} ${PREFIX}/include}"

    HDF5_ROOT="${PREFIX}"
    HDF5_LIBDIR="${HDF5_ROOT}/lib"
    HDF5_INCLUDE_DIR="${HDF5_ROOT}/include"
    HDF5_PLUGIN_PATH="${HDF5_LIBDIR}/plugin"
    NCDIR="${PREFIX}"
    NFDIR="${PREFIX}"
    NETCDF_FORTRAN_HOME=${NFDIR}
    NETCDF_HOME=${NCDIR}

    DEPENDENCY_ENV_VARS=true
fi

mkdir -p ${DEPENDENCY_DIR}
mkdir -p ${PREFIX}/lib
mkdir -p ${PREFIX}/include
mkdir -p ${PREFIX}/share
mkdir -p ${PREFIX}/bin

#!/bin/bash
# This script will hdf5 from source
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
HDF5_VER="1.14.4"
HDF5_SUBVER="2"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*          STARTING DEPENDENCY BUILD                    *\n"
printf "*********************************************************\n"
printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n"
printf "Installing to ${HDF5_ROOT}\n"
printf "\n"

printf "*********************************************************\n"
printf "*             FETCHING HDF5 SOURCE                      *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"

HDF5_SRC_DIR="${DEPENDENCY_DIR}"/hdf5-${HDF5_VER}-${HDF5_SUBVER}

printf "Checking if HDF5 source directory exists\n"
if [[ (-d "${HDF5_SRC_DIR}") && (-f "${HDF5_SRC_DIR}"/README.md) ]]; then
    OLDVER=$(grep version "${HDF5_SRC_DIR}"/README.md | awk '{print $3}' | sed 's/\./_/g')
    printf "Existing copy of HDF5 source detected\n"
else 
    curl -s -L https://github.com/HDFGroup/hdf5/releases/download/hdf5_${HDF5_VER}.${HDF5_SUBVER}/hdf5-${HDF5_VER}-${HDF5_SUBVER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi
printf "\n"
printf "*********************************************************\n"
printf "*               BUILDING HDF5 LIBRARY                   *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "INSTALL_PREFIX: ${HDF5_ROOT}\n"
printf "*********************************************************\n"

cd "${HDF5_SRC_DIR}"

ZLIB_LIBRARY="${ZLIB_ROOT}/lib/libz.a"
SZIP_LIBRARY="${SZIP_ROOT}/lib/libsz.a"

ARGLIST="-DCMAKE_INSTALL_PREFIX:PATH=${HDF5_ROOT} \
    -DHDF5_ALLOW_EXTERNAL_SUPPORT:STRING="NO" \
    -DCMAKE_BUILD_TYPE:STRING="Release" \
    -DHDF5_ENABLE_Z_LIB_SUPPORT:BOOL=ON  \
    -DZLIB_LIBRARY:FILEPATH=${ZLIB_LIBRARY} \
    -DZLIB_INCLUDE_DIR:PATH=${ZLIB_ROOT}/include \
    -DZLIB_USE_EXTERNAL:BOOL=OFF
    -DHDF5_ENABLE_SZIP_SUPPORT:BOOL=ON  \
    -DSZIP_LIBRARY:FILEPATH=${SZIP_LIBRARY} \
    -DSZIP_INCLUDE_DIR:PATH=${SZIP_ROOT}/include \
    -DSZIP_USE_EXTERNAL:BOOL=OFF \
    -DHDF5_ENABLE_PLUGIN_SUPPORT:BOOL=OFF \
    -DHDF5_BUILD_CPP_LIB:BOOL=OFF \
    -DHDF5_BUILD_FORTRAN:BOOL=OFF \
    -DHDF5_BUILD_JAVA:BOOL=OFF \
    -DHDF5_BUILD_EXAMPLES:BOOL=OFF \
    -DBUILD_TESTING:BOOL=OFF \
    -DBUILD_STATIC_LIBS:BOOL=ON \
    -DBUILD_SHARED_LIBS:BOOL=OFF \
    -DHDF5_ENABLE_ALL_WARNINGS:BOOL=OFF \
    -DHDF5_TEST_PARALLEL:BOOL=OFF \
    -DHDF5_TEST_SERIAL:BOOL=OFF \
    -DHDF5_TEST_SWMR:BOOL=OFF \
    -DCMAKE_POSITION_INDEPENDENT_CODE:BOOL=ON \
    -DHDF5_ENABLE_PARALLEL:BOOL:BOOL=ON \
    -DHDF5_BUILD_PARALLEL_TOOLS:BOOL=OFF \
    -DHDF5_ENABLE_THREADSAFE:BOOL=OFF" 

if [ $OS = "Darwin" ]; then
    ARGLIST="${ARGLIST} -DCMAKE_BUILD_WITH_INSTALL_RPATH:BOOL=OFF"
fi

cmake -B build -C ./config/cmake/cacheinit.cmake -G Ninja ${ARGLIST} .

cmake --build build -j${NPROC} --config Release
if [ -w "${HDF5_ROOT}" ]; then
    cmake --install build 
else
    sudo cmake --install build 
fi

if [ $? -ne 0 ]; then
   printf "hdf5 could not be compiled.\n"
   exit 1
fi

#!/bin/bash
# This script will build the Swiftest package. It is assumed that compatible dependencies have been built already before this is run
# 
# Copyright 2023 - David Minton
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
set -a
if [ -z ${SCRIPT_DIR+x} ]; then SCRIPT_DIR=$(realpath $(dirname $0)); fi
ARGS=$@
. ${SCRIPT_DIR}/_build_getopts.sh ${ARGS}

# Determine if we are in the correct directory (the script can either be run from the Swiftest project root directory or the
# buildscripts directory)
if [ ! -f "${ROOT_DIR}/setup.py" ]; then
    echo "Error: setup.py not found" 
    exit 1
fi

printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n\n"
printf "Installing to ${PREFIX}\n"
printf "Dependency libraries in ${PREFIX}\n"


SKBUILD_CONFIGURE_OPTIONS="-DBUILD_SHARED_LIBS=OFF"

if [ $OS = "Intel" ]; then 
    FCFLAGS="${CFLAGS} -standard-semantics"
    SKBUILD_CONFIGURE_OPTIONS="${SKBUILD_CONFIGURE_OPTIONS} -DMACHINE_CODE_VALUE=\"SSE2\""
else
    SKBUILD_CONFIGURE_OPTIONS="${SKBUILD_CONFIGURE_OPTIONS} -DMACHINE_CODE_VALUE=\"generic\""
fi

read -r OS ARCH < <($SCRIPT_DIR/get_platform.sh)
echo $OS $ARCH

cd $ROOT_DIR

printf "\n"
printf "*********************************************************\n"
printf "*                   BUILDING SWIFTEST                   *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "FFLAGS: ${FFLAGS}\n"
printf "FCFLAGS: ${FCFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "NETCDF_FORTRAN_HOME: ${NETCDF_FORTRAN_HOME}\n"
printf "SKBUILD_CONFIGURE_OPTIONS: ${SKBUILD_CONFIGURE_OPTIONS}\n"
if [ $OS = "MacOSX" ]; then
    printf "MACOSX_DEPLOYMENT_TARGET: ${MACOSX_DEPLOYMENT_TARGET}\n"
fi
printf "*********************************************************\n"

python3 -m pip install build pip
python3 -m build --sdist
if [ $OS = "MacOSX" ]; then
    cibuildwheel --platform macos
elif [ $OS = "Linux" ]; then
    cibuildwheel --platform linux
fi

#!/bin/bash
# This script will build the NetCDF C library from source
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
NC_VER="4.9.2"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*          STARTING DEPENDENCY BUILD                    *\n"
printf "*********************************************************\n"
printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n"
printf "Installing to ${NCDIR}\n"
printf "\n"


printf "*********************************************************\n"
printf "*            FETCHING NETCDF-C SOURCE                   *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"

if [ ! -d "${DEPENDENCY_DIR}"/netcdf-c-${NC_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/netcdf-c-* ] && rm -rf "${DEPENDENCY_DIR}"/netcdf-c-*
    curl -s -L https://github.com/Unidata/netcdf-c/archive/refs/tags/v${NC_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi
LIBS="-lhdf5_hl -lhdf5 -lm -lz -lzstd -lbz2 -lcurl -lsz ${LIBS}"
LDFLAGS="${LDFLAGS} ${LIBS}"
printf "\n"
printf "*********************************************************\n"
printf "*              BUILDING NETCDF-C LIBRARY                *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "HDF5_ROOT: ${HDF5_ROOT}\n"
printf "INSTALL_PREFIX: ${NCDIR}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/netcdf-c-*
cmake -B build -S . -G Ninja  \
    -DCMAKE_BUILD_TYPE:STRING="Release" \
    -DHDF5_DIR:PATH=${HDF5_ROOT}/cmake \
    -DHDF5_ROOT:PATH=${HDF5_ROOT} \
    -DCMAKE_FIND_ROOT_PATH:PATH="${NCDIR}" \
    -DCMAKE_INSTALL_PREFIX:STRING="${NCDIR}" \
    -DENABLE_DAP:BOOL=OFF \
    -DENABLE_BYTERANGE:BOOL=OFF \
    -DENABLE_NCZARR:BOOL=OFF \
    -DENABLE_NCZARR_FILTERS:BOOL=OFF \
    -DENABLE_LIBXML2:BOOL=OFF \
    -DCMAKE_INSTALL_LIBDIR="lib" \
    -DENABLE_REMOTE_FORTRAN_BOOTSTRAP:BOOL=OFF \
    -DENABLE_PLUGINS:BOOL=OFF \
    -DBUILD_UTILITIES:BOOL=OFF \
    -DBUILD_TESTING:BOOL=OFF \
    -DENABLE_DAP_REMOTE_TESTS:BOOL=OFF \
    -DENABLE_SHARED_LIBRARY_VERSION:BOOL=OFF \
    -DBUILD_SHARED_LIBS:BOOL=OFF \
    -DENABLE_TESTS:BOOL=OFF \
    -DENABLE_EXTRA_TESTS:BOOL=OFF \
    -DCMAKE_POSITION_INDEPENDENT_CODE:BOOL=ON \
    -DNC_EXTRA_DEPS:STRING="${LIBS}" \
    -DENABLE_PARALLEL4:BOOL=ON

cmake --build build -j${NPROC} 
if [ -w "${NCDIR}" ]; then
    cmake --install build 
else
    sudo cmake --install build 
fi

if [ $? -ne 0 ]; then
   printf "netcdf-c could not be compiled."\n
   exit 1
fi

#!/bin/bash
# This script will build the OpenCoarrays libraries from source
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
OpenCoarrays_VER="2.10.2"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*             FETCHING OpenCoarrays SOURCE               *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"
mkdir -p "${DEPENDENCY_DIR}"
if [ ! -d "${DEPENDENCY_DIR}"/OpenCoarrays-${OpenCoarrays_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/OpenCoarrays-* ] && rm -rf "${DEPENDENCY_DIR}"/OpenCoarrays-*
    curl -L https://github.com/sourceryinstitute/OpenCoarrays/releases/download/${OpenCoarrays_VER}/OpenCoarrays-${OpenCoarrays_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi

printf "*********************************************************\n"
printf "*               BUILDING OpenCoarrays LIBRARY           *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "FFLAGS: ${FFLAGS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "OpenCoarrays_HOME: ${OpenCoarrays_HOME}\n"
printf "FC : ${FC}\n"
printf "CC : ${CC}\n"
printf "CXX: ${CXX}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/OpenCoarrays-*

export TERM=xterm
./install.sh --prefix-root=${OpenCoarrays_HOME}/../.. --yes-to-all --with-fortran ${FC} --with-cxx ${CXX} --with-c ${CC} --verbose

if [ $? -ne 0 ]; then
   printf "OpenCoarrays could not be compiled.\n"
   exit 1
fi

#!/bin/bash
# This script will determine the platform (OS and architecture) and format them in a way that other scripts can make use of.
#
# The following combinations are valid:
# Linux x86_64
# Linux aarch64
# MacOSX x86_64
# MacOSX arm64 
#
# Copyright 2023 - David Minton
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 


# Determine the platform and architecture
OS=$(uname -s)
ARCH=$(uname -m)


case $ARCH in
    x86_64)
        ;;
    amd64)
        ARCH="x86_64"
        ;;
    arm64)
        if [ "$OS" = "Linux" ]; then
            ARCH="aarch64"
        fi
        ;;
    aarch64)
        if [ "$OS" = "Darwin" ]; then
            ARCH="arm64"
        fi
        ;;
    *)
        echo "Swiftest is currently not configured to build for platform ${OS}-${ARCH}"
        exit 1
        ;;
esac


case $OS in
    Linux)
        ;; 
    Darwin)
        OS="MacOSX" 
        ;;
    *MSYS*)
        OS="Windows"
        ;;
    *)
        echo "Swiftest is currently not configured to build for platform ${OS}-${ARCH}"
        exit 1
        ;;
esac

echo $OS $ARCH

#!/bin/bash
# This script will build the SHTOOLS libraries from source
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
SHTOOLS_VER="4.13.1"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*             FETCHING SHTOOLS SOURCE                      *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"
mkdir -p "${DEPENDENCY_DIR}"
if [ ! -d "${DEPENDENCY_DIR}"/SHTOOLS-${SHTOOLS_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/SHTOOLS-* ] && rm -rf "${DEPENDENCY_DIR}"/SHTOOLS-*
    curl -L https://github.com/SHTOOLS/SHTOOLS/archive/refs/tags/v${SHTOOLS_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi

printf "*********************************************************\n"
printf "*               BUILDING SHTOOLS LIBRARY                   *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "FFLAGS: ${FFLAGS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/SHTOOLS*

case $FC in
    *"mpiifort"*|*"ifx"*)
        echo "Using Intel Fortran compiler"
        make -j${NPROC} F95="${OMPI_FC}" CXX="${CXX}" F95FLAGS="-fPIC -m64 -fpp -free -O3 ${FFLAGS} -Tf" fortran
        make -j${NPROC} F95="${OMPI_FC}" CXX="${CXX}" F95FLAGS="-fPIC -m64 -fpp -free -O3 ${FFLAGS} -Tf" fortran-mp
        ;;
    *"gfortran"*|*"mpifort")
        echo "Everything else"
        make -j${NPROC} F95="${OMPI_FC}" CXX="${CXX}" F95FLAGS="-fPIC -O3 -std=gnu -ffast-math ${FFLAGS}" fortran
        make -j${NPROC} F95="${OMPI_FC}" CXX="${CXX}" F95FLAGS="-fPIC -O3 -std=gnu -ffast-math ${FFLAGS}" fortran-mp
        ;;
esac

if [ -w "${PREFIX}" ]; then
    make F95="${FC}" PREFIX="${PREFIX}" install
else
    sudo make F95="${FC}" PREFIX="${PREFIX}" install
fi
cd ..

if [ $? -ne 0 ]; then
   printf "SHTOOLS could not be compiled.\n"
   exit 1
fi

#!/bin/bash
# This script will build the bz2 library needed by HDF5
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
BZ2_VER="1.0.8"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*          STARTING DEPENDENCY BUILD                    *\n"
printf "*********************************************************\n"
printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n"
printf "Installing to ${BZ2_ROOT}\n"
printf "\n"

printf "*********************************************************\n"
printf "*             FETCHING BZ2 SOURCE                      *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"
mkdir -p "${DEPENDENCY_DIR}"
if [ ! -d "${DEPENDENCY_DIR}"/bzip2-${BZ2_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/bzip2-* ] && rm -rf "${DEPENDENCY_DIR}"/bzip2-*
    curl -L https://gitlab.com/bzip2/bzip2/-/archive/bzip2-${BZ2_VER}/bzip2-bzip2-${BZ2_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi
printf "*********************************************************\n"
printf "*               BUILDING BZ2 LIBRARY                  *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "INSTALL_PREFIX: ${BZ2_ROOT}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/bzip2-*
printf "Updating Makefile with new flags\n"
# Update the Makefile to use the environment flags set by this script
if [ ! -f Makefile.bak ]; then
    mv Makefile Makefile.bak
fi
sed 's/^LDFLAGS=$/LDFLAGS+= /' Makefile.bak > Makefile.tmp
sed 's/^CFLAGS=-Wall -Winline -O2 -g $(BIGFILES)$/CFLAGS+=-Wall -Winline -O2 -g $(BIGFILES)/' Makefile.tmp > Makefile
rm Makefile.tmp

make clean
make
    
if [ -w "${BZ2_ROOT}" ]; then
    make install PREFIX=${BZ2_ROOT}
else
    sudo make install PREFIX=${BZ2_ROOT}
fi
set +a
if [ $? -ne 0 ]; then
   printf "bz2 could not be compiled.\n"
   exit 1
fi

#!/bin/bash
# This script will build the NetCDF Fortran library from source
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Swiftest.
# Swiftest is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Swiftest is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Swiftest. 
# If not, see: https://www.gnu.org/licenses. 
NF_VER="4.6.1"

SCRIPT_DIR=$(realpath "$(dirname "$0")")
ROOT_DIR=$(realpath "${SCRIPT_DIR}/..")

set -e
cd "${ROOT_DIR}"
. "${SCRIPT_DIR}"/set_environment.sh

printf "*********************************************************\n"
printf "*          STARTING DEPENDENCY BUILD                    *\n"
printf "*********************************************************\n"
printf "Using ${OS} compilers:\nFC: ${FC}\nCC: ${CC}\nCXX: ${CXX}\n"
printf "Installing to ${NFDIR}\n"
printf "\n"

printf "*********************************************************\n"
printf "*          FETCHING NETCDF-FORTRAN SOURCE                  *\n"
printf "*********************************************************\n"
printf "Copying files to ${DEPENDENCY_DIR}\n"
if [ ! -d "${DEPENDENCY_DIR}"/netcdf-fortran-${NF_VER} ]; then
    [ -d "${DEPENDENCY_DIR}"/netcdf-fortran-* ] && rm -rf "${DEPENDENCY_DIR}"/netcdf-fortran-*
    curl -s -L https://github.com/Unidata/netcdf-fortran/archive/refs/tags/v${NF_VER}.tar.gz | tar xvz -C "${DEPENDENCY_DIR}"
fi 
CFLAGS="$(${NCDIR}/bin/nc-config --cflags) $CFLAGS"
LIBS="$(${NCDIR}/bin/nc-config --libs --static) $LIBS"
NCLIBDIR=$(${NCDIR}/bin/nc-config --libdir)
LDFLAGS="$LDFLAGS $LIBS"
printf "\n"
printf "*********************************************************\n"
printf "*          BUILDING NETCDF-FORTRAN LIBRARY              *\n"
printf "*********************************************************\n"
printf "LIBS: ${LIBS}\n"
printf "CFLAGS: ${CFLAGS}\n"
printf "CPPFLAGS: ${CPPFLAGS}\n"
printf "CPATH: ${CPATH}\n"
printf "LD_LIBRARY_PATH: ${LD_LIBRARY_PATH}\n"
printf "LDFLAGS: ${LDFLAGS}\n"
printf "netCDF_LIBRARIES: ${netCDF_LIBRARIES}\n"
printf "*********************************************************\n"

cd "${DEPENDENCY_DIR}"/netcdf-fortran-*

# This will patch the CMakeLists.txt file to add in the proper szip library link
CMAKE_LISTS_FILE="CMakeLists.txt"

CODE_TO_INSERT=$(cat <<'EOF'
find_library(SZIP_LIBRARY NAMES sz libsz PATHS "\${PACKAGE_PREFIX_DIR}/lib" NO_DEFAULT_PATH)
if(SZIP_LIBRARY)
  get_target_property(current_iface_libs netCDF::netcdf INTERFACE_LINK_LIBRARIES)
  if(current_iface_libs)
    list(APPEND current_iface_libs "\${SZIP_LIBRARY}")
  else()
    set(current_iface_libs "\${SZIP_LIBRARY}")
  endif()
  set_target_properties(netCDF::netcdf PROPERTIES
    INTERFACE_LINK_LIBRARIES "\${current_iface_libs}"
  )
endif()
EOF
)

LINE_NUMBER=636

awk -v line_num="$LINE_NUMBER" -v code="$CODE_TO_INSERT" 'NR == line_num {print code} {print}' "$CMAKE_LISTS_FILE" > temp_file && mv temp_file "$CMAKE_LISTS_FILE"

echo "Modified CMakeLists.txt and added the new code block before line $LINE_NUMBER."
#############

cmake -B build -S . -G Ninja \
    -DCMAKE_INSTALL_PREFIX:PATH=${NFDIR} \
    -DCMAKE_INSTALL_LIBDIR="lib" \
    -DBUILD_EXAMPLES:BOOL=OFF \
    -DBUILD_TESTING:BOOL=OFF \
    -DCMAKE_POSITION_INDEPENDENT_CODE:BOOL=ON \
    -DBUILD_SHARED_LIBS:BOOL=OFF \
    -DENABLE_TESTS:BOOL=OFF     

cmake --build build -j${NPROC} 
if [ -w "${NFDIR}" ]; then
    cmake --install build 
else
    sudo cmake --install build 
fi

if [ $? -ne 0 ]; then
   printf "netcdf-fortran could not be compiled.\n"
   exit 1
fi

---
title: 'Swiftest: An \textit{N}-body Integrator for Gravitational Systems'
tags:
  - Python
  - Fortran
  - Astronomy
  - Dynamics
  - N-body
  - Planetary Systems
authors:
  - name: Carlisle Wishard
    affiliation: "1,4"
    orcid: 0009-0001-0733-3268
    equal-contrib: true 
  - name: Jennifer Pouplin
    affiliation: "1,3"
  - name: Jacob Elliott
    affiliation: "1"
  - name: Dana Singh
    affiliation: "5"
  - name: Kaustub Anand
    affiliation: "1, 2"
  - name: David Minton
    affiliation: "1"
    orcid: 0000-0003-1656-9704
    equal-contrib: true 
    corresponding: true 
affiliations:
  - name: Department of Earth, Atmospheric, and Planetary Sciences, Purdue University, USA
    index: 1
  - name: School of Aeronautics and Astronautics, Purdue University, USA
    index: 2
  - name: Department of Physics and Astronomy, Purdue University, USA
    index: 3
  - name: Evansville Museum of Arts, History & Science, USA
    index: 4
  - name : SAIC, Princeton, NJ, USA
    index: 5

date: 06 October 2023
bibliography: paper.bib
---

# Summary
`Swiftest` is a software package designed to model the long-term dynamics of system of bodies in orbit around a dominant central body, such a planetary system around a star, or a satellite system around a planet. The main body of the program is written in Modern Fortran, taking advantage of the object-oriented capabilities included with Fortran 2003 and the parallel capabilities included with Fortran 2008 and Fortran 2018. `Swiftest` also includes a Python package that allows the user to quickly generate input, run simulations, and process output from the simulations. `Swiftest` uses a NetCDF output file format which makes data analysis with the `Swiftest` Python package a streamlined and flexible process for the user.

# Statement of Need
Building off a strong legacy, including its predecessors `Swifter` [@kaufmann_swifter_nodate] and `Swift` [@Levison:1994], `Swiftest` takes the next step in modeling the dynamics of planetary systems by improving the performance and ease of use of software, and by introducing a new collisional fragmentation model. Currently, `Swiftest` includes the four main symplectic integrators included in its predecessors: 

WHM
  : Wisdom-Holman method.  `WHM` is a symplectic integrator that is best suited for cases in which the orbiting bodies do not have close encounters with each other. For details see @Wisdom:1991.

RMVS
  : Regularized Mixed Variable Symplectic. `RMVS` is an extension of `WHM` that handles close approaches between test particles and massive bodies. For details, see @Levison:1994.

HELIO
  : Democratic Heliocentric method.  This is a basic symplectic integrator that uses democratic heliocentric coordinates instead of the Jacobi coordinates used by `WHM`. Like `WHM` it is not suited for simulating close encounters between orbiting bodies. For details, see @Duncan:1998. 

SyMBA
  : Symplectic Massive Body Algorithm. This is an extension of `HELIO` that handles close approaches between massive bodies and any of the other objects in the simulation. It also includes semi-interacting massive bodies that can gravitationally influence fully massive bodies but not each other. This algorithm is described in the @Duncan:1998. See also @Levison:2000.

All of the integrators that are currently implemented are based symplectic integrators, which are designed to model massive bodies (e.g. planets) or test particles (e.g. asteroids) in orbit of a single dominant central body (e.g. the Sun) for very long periods of times (e.g. Gy). The core components of `Swiftest` were inherited from the `Swift`/`Swifter` codebase, but have been somewhat modified for performance. The `Swift`-family of integrators are most comparable to other symplectic integrators, which are among the most popular numerical methods used to study the long-term dynamics of planetary systems. 

The `SyMBA` integrator included in `Swiftest` is most similar to the hybrid symplectic integrator `MERCURY6` [@Chambers:1999], the `MERCURIUS` integrator of `REBOUND` [@Rein:2012;@Rein:2015], and the GPU-enabled hybrid symplectic integrators such as  `QYMSYM` [@Moore:2011] and `GENGA II` [@Grimm:2022], with some important distinctions. The hybrid symplectic integrators typically employ a symplectic method, such as the original WHM method in Jacobi coordinates or the modified method that uses the Democratic Heliocentric coordinates, only when bodies are far from each other relative to their gravitational spheres of influence (some multiple of a Hill's sphere). When bodies approach each other, the integration is smoothly switched to a non-symplectic method, such as Bulirsch-Stoer or IAS15. In contrast, `SyMBA` is a multi-step method that recursively subdivides the step size of bodies undergoing close approach with each other. 

In addition `Swiftest` contains a number of significant enhancements relative to its predecessors:

- It includes a fully symplectic implementation of the post-Newtonian correction (General Relativity) as described in @Saha:1994.
- Output data is stored in NetCDF4 (HDF5) format, making data analysis, cross-platform compatibility, and portability far more robust than the flat binary file formats used by its predecessors.
- It makes use of CPU-based parallelization via OpenMP. It also makes use of SIMD instructions, but these are available only when compiled for target host machine rather than when installed from PyPI via pip.
- Simulations can be run by means of a standalone binary driver program, similar to its predecessors, or from a compiled Python module. Both the standalone driver and Python module link to the same compiled library, so simulations run by either method are identical.
- It comes with an extensive set of Python scripts to help generate simulation initial conditions and post-process simulation results.
- It includes the `Fraggle` collisional fragmentation model that is used to generate collisional fragments on trajectories that conserve linear and angular momentum and lose the appropriate amount of collisional energy for inelastic collisions between massive bodies in `SyMBA` simulations. The collisional outcome is determined using standard methods based on the work of @Leinhardt:2012 and @Stewart:2012.

# Performance
Modeling the behavior of thousands of fully interacting bodies over long timescales is computationally expensive, with typical runs taking weeks or months to complete. The addition of collisional fragmentation can quickly generate hundreds or thousands of new bodies in a short time period, creating further computational challenges for traditional \textit{n}-body integrators. As a result, enhancing computational performance was a key aspect of the development of `Swiftest`. Here we show a comparison between the performance of `Swift`, `Swifter-OMP` (a parallel version of `Swifter`), and `Swiftest` on simulations with 1k, 2k, 8k, and 16k fully interacting bodies. The number of cores dedicated to each run is varied from 1 to 24 to test the parallel performance of each program.

\autoref{fig:performance} shows the results of this performance test. We can see that `Swiftest` outperforms `Swifter-OMP` and `Swift` in each simulation set, even when run in serial. When run in parallel, `Swiftest` shows a significant performance boost when the number of bodies is increased. The improved performance of `Swiftest` compared to `Swifter-OMP` and `Swift` is a critical step forward in \textit{n}-body modeling, providing a powerful tool for modeling the dynamical evolution of planetary systems.

![Performance testing of `Swiftest` on systems of (a) 1k, (b) 2k, (c) 8k, and (d) 16k fully interacting massive bodies. All simulations were run using the \textit{SyMBA} integrator included in `Swift`, `Swifter-OMP` (and earlier attempt to parallelize `Swifter`), and `Swiftest`. Speedup is measured relative to `Swiftest` for 1 CPU (dashed), with an ideal 1:1 speedup shown as an upper limit (dotted). The performance of `Swifter-OMP` is shown in green while the performance of `Swiftest` is shown in blue. All simulations were run on the Purdue University Rosen Center for Advanced Computing Brown Community Cluster. Brown contains 550 Dell compute nodes, with each node containing 2 12-core Intel Xeon Gold Sky Lake processors, resulting in 24 cores per node. Each node has 96 GB of memory. \label{fig:performance}](performance.png)

# Acknowledgements
`Swiftest` was developed at Purdue University and was funded under the NASA Emerging Worlds and Solar System Workings programs. Active development by the Purdue Swiftest Team is ongoing and contributions from the community are highly encouraged.

# References

# swiftest.add_body(**kwargs)
| Key Word Name   | Key Word Description                                                                                                                    | Options                        |
|-----------------|-----------------------------------------------------------------------------------------------------------------------------------------|--------------------------------|
| ```name```      | Name(s) of bodies.                                                                                                                      | string or array-like of strings
| ```id```        | Unique identification value(s) of bodies.                                                                                               | float or array-like of floats
| ```a```         | Semi-major axis value(s) of bodies. Only used if  ```init_cond_format``` is set to ```EL```.                                            | float or array-like of floats
| ```e```         | Eccentricity value(s) of bodies. Only used if  ```init_cond_format``` is set to ```EL```.                                               | float or array-like of floats
| ```inc```       | Inclination value(s) of bodies in degrees. Only used if  ```init_cond_format``` is set to ```EL```.                                                | float or array-like of floats
| ```capom```     | Longitude of the ascending node value(s) of bodies in degrees. Only used if  ```init_cond_format``` is set to ```EL```.                            | float or array-like of floats
| ```omega```     | Argument of pericenter value(s) of bodies in degrees. Only used if  ```init_cond_format``` is set to ```EL```.                                     | float or array-like of floats
| ```capm```      | Mean anomaly value(s) of bodies in degrees. Only used if  ```init_cond_format``` is set to ```EL```.                                               | float or array-like of floats
| ```rh```        | Position vector(s) of bodies. Only used if  ```init_cond_format``` is set to ```XV```.                                                  | (n,3) array-like of floats
| ```vh```        | Velocity vector(s) of bodies. Only used if  ```init_cond_format``` is set to ```XV```.                                                  | (n,3) array-like of floats
| ```mass```      | Mass value(s) of bodies. Only for massive bodies. Only  ```mass``` **OR** ```Gmass``` may be set.                                       | float or array-like of floats
| ```Gmass```     | Gravitational mass value(s) of bodies. Only for massive bodies. Only  ```mass``` **OR** ```Gmass``` may be set.                         | float or array-like of floats
| ```radius```    | Radius value(s) of bodies. Only for massive bodies.                                                                                     | float or array-like of floats
| ```rhill```     | Hill Radius value(s) of bodies. Only for massive bodies.                                                                                | float or array-like of floats
| ```rot```       | Rotation rate vector(s) of bodies in degrees/TU. Only for massive bodies. Only used if ```rotation``` is set to ```True```.                           | (n,3) array-like of floats
| ```Ip```        | Principal axes moments of inertia vector(s) of bodies. Only for massive bodies. Only used if ```rotation``` is set to ```True```.       | (n,3) array-like of floats
| ```J2```        | The unitless value of the spherical harmonic term equal to J2*R^2 where R is the radius of the central body.                                                                                                     | float or array-like of floats
| ```J4```        | The unitless value of the spherical harmonic term equal to J4*R^4 where R is the radius of the central body.                                                                                                     | float or array-like of floats

# swiftest.save(**kwargs)
| Key Word Name   | Key Word Description                                                                                  | Options                                    |
|-----------------|-------------------------------------------------------------------------------------------------------|--------------------------------------------|
|```codename```   | Name of the N-body code to use. Default is ```Swiftest```.                                            | ```Swiftest```, ```Swifter```, ```Swift```  
|```param_file``` | Alternative name of the parameter input file.                                                         | string (ex. ```myparam.in```)  
|```param```      | Alternative parameter dictionary.                                                                     | dictionary  
|```framenum```   | Time frame from which to generate initial conditions. Default is -1 or the last frame in the dataset. | integer (ex. ```10```)  

---
project: Swiftest
author: David A. Minton
summary: High performance Fortran functions used by the swiftest project via ISO_C_BINDING interfaces and Cython.
project_github: https://github.com/MintonGroup/swiftest
project_download: https://github.com/MintonGroup/swiftest/releases
project_website: https://swiftest.readthedocs.io
github: https://github.com/MintonGroup/
src_dir: src
output_dir: ./docs/_static/fortran_docs
source: true
graph: true
sort: alpha
print_creation_date: true
extra_mods: iso_c_binding:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fC_005fBINDING.html
            ieee_arithmetic:https://gcc.gnu.org/onlinedocs/gfortran/IEEE-modules.html
            ieee_exceptions:https://gcc.gnu.org/onlinedocs/gfortran/IEEE-modules.html
            iso_fortran_env:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fFORTRAN_005fENV.html
creation_date: %Y-%m-%d %H:%M %z
md_extensions: markdown.extensions.toc
               markdown.extensions.smarty
---

This is the documentation for the Fortran components of Swiftest

# swiftest.Simulation(**kwargs)
The following key word arguments are specific to the ```swiftest.Simulation``` method. 
| Key Word Name                   | Key Word Description                                                                               | Options                                                                                            | Compatible Integrators |
|---------------------------------|----------------------------------------------------------------------------------------------------|----------------------------------------------------------------------------------------------------|------------------------|
|```simdir```                     | Path to subdirectory in which to store data. Default is ```/simdir```.                             | pathlike string (ex. ```path/to/directory```)                                                      | all                    
|```read_param```                 | Read in a pre-existing parameter input file. Default is ```False```.                               | ```True```, ```False```                                                                            | all
|```param_file```                 | Name of the pre-existing parameter input file. Only used if ```read_param``` is set to ```True```. | string (ex. ```param.in```)                                                                        | all
|```read_data```                  | Read in a pre-existing simulation output file. Default is ```False```.                             | ```True```, ```False```                                                                            | all
|```codename```                   | Name of the N-body code to use. Default is ```Swiftest```.                                         | ```Swiftest```, ```Swifter```, ```Swift```                                                         | all
|```integrator```                 | Name of the N-body integrator to use. Default is ```symba```.                                      | ```symba```, ```helio```, ```rmvs```, ```whm```                                                    | all

# Parameters
These parameters can be entered as key word arguments into the ```swiftest.Simulation``` method, the ```swiftest.get_parameter``` method, the ```swiftest.set_parameter``` method, the ```swiftest.run``` method, or through editing the ASCII **<span>param.in</span>** directly, as described in the ```Usage``` column. If the key word argument or parameter's name changes between usage as a Python key word argument and as a parameter in the ASCII input files, the name of the key word argument is listed first, followed by the name of the ASCII parameter in the ```Key Word / Parameter Name``` column. Many parameters retain their Swift / Swifter names in the ASCII for backwards compatibility, but change names in the Python for readability.

| Key Word / Parameter Name       | Key Word / Parameter Description                                                                   | Options                                                                                            | Compatible Integrators | Usage |
|---------------------------------|----------------------------------------------------------------------------------------------------|----------------------------------------------------------------------------------------------------|------------------------|-------|
|```t0```                         | The reference time for the start of the simulation in time units. Default is ```0.0```.            | floating point (ex. ```0.0```)                                                                     | all                    | Both  |
|```tstart```                     | Simulation start time for a restarted run in time units. Default is ```0.0```.                     | floating point (ex. ```0.0```)                                                                     | all                    | Both  |
|```tstop```                      | Simulation end time in time units. Must be greater than ```tstart```.                              | floating point (ex. ```100.0```)                                                                   | all                    | Both  |
|```dt```                         | Simulation step size in time units. Must be less than or equal to ```tstop```-```tstart```.        | floating point (ex. ```0.005```)                                                                   | all                    | Both  |
|```istep_out```                  | The number of time steps (```dt```) between output saves to memory. Either ```istep_out``` **OR** ```tstep_out``` may be set. Default is ```1```. | integer (ex. ```200```)                             | all                    | Both  |
|```tstep_out```                  | The approximate time between when outputs saved in memory are written to file in time units. Either ```istep_out``` **OR** ```tstep_out``` may be set. Calculates ```istep_out = floor(tstep_out / dt)``` | floating point (ex. ```10.0```) | all | Both
|```dump_cadence```               | The number of output steps between when data saved to memory is written to file. Setting to ```0``` results in writing data to file only at the completion of the simulation. Default is ```10```. | integer (ex. ```10```) | all | Both |
|```init_cond_file_type``` / ```IN_TYPE``` | Input file type. Default is ```NETCDF_DOUBLE```.                                          | ```NETCDF_DOUBLE```, ```NETCDF_FLOAT```, ```ASCII```                                               | all                    | Both  |
|```init_cond_file_name``` / ```PL_IN```, ```TP_IN```, ```CB_IN```, ```NC_IN``` | Input file name(s). If using Python and ```init_cond_file_type``` is set to ```NETCDF_DOUBLE``` or ```NETCDF_FLOAT```, default is ```init_cond.nc```. If using Python and ```init_cond_file_type``` is set to ```ASCII```, default is a dictionary: ```{"CB" : "cb.in", "PL" : "pl.in", "TP" : "tp.in"}```. If editing the ASCII **<span>param.in</span>**, each input file name is a separate parameter. If ```IN_TYPE``` is set to ```NETCDF_DOUBLE``` or ```NETCDF_FLOAT```, default is ```init_cond.nc```. If ```IN_TYPE``` is set to ```ASCII```, defaults are ```CB.IN```, ```PL.IN```, and ```TP.in```. | string (ex. ```my_init_cond.nc```), dictionary ```{"CB" : "mycb.in", "PL" : "mypl.in", "TP" : "mytp.in"}``` | all | Both
|```init_cond_format``` / ```IN_FORM```  | Input format. Default is ```EL```.                                                          | ```EL```, ```XV```                                                                                 | all                    | Both  |
|```output_file_type``` / ```OUT_TYPE``` | Output file type. Default is ```NETCDF_DOUBLE```. | ```NETCDF_DOUBLE```, ```NETCDF_FLOAT```, Swift / Swifter Only : ```REAL4```, ```REAL8```, ```XDR4```, ```XDR8```                             | all                    | Both  |
|```output_file_name``` / ```BIN_OUT```  | Output file name. Default is ```bin.nc```.                                                  | string (ex. ```mydata.nc```)                                                                       | all                    | Both  |
|```output_format``` / ```OUT_FORM```    | Output format. Default is ```XVEL```.                                                       | ```XV```, ```XVEL```                                                                               | all                    | Both  |
| ```OUT_STAT```                  | Output status. Default is ```REPLACE```.                                                           | ```NEW```, ```APPEND```, ```REPLACE```, ```UNKNOWN```                                              | all                    | ASCII only |
|```MU```                         | Mass unit system to use in the simulation. Default is ```Msun```.                                  | ```Msun```, ```Mearth```, ```kg```, ```g``` (case-insensitive)                                     | all                    | Python only |
|```DU```                         | Distance unit system to use in the simulation. Default is ```AU```.                                | ```AU```, ```Rearth```, ```m```, ```cm``` (case-insensitive)                                       | all                    | Python only |
|```TU```                         | Time unit system to use in the simulation. Default is ```Y```.                                     | ```Y```, ```YR```, ```DAY``` (Julian day), ```d``` (Julian day), ```JD``` (Julian day), ```s``` (case-insensitive) | all    | Python only |
|```MU_name```                    | The name of the mass unit. Overrides ```MU```.                                                     | string (ex. ```kilograms```)                                                                       | all                    | Python only |
|```DU_name```                    | The name of the distance unit. Overrides ```DU```.                                                 | string (ex. ```meters```)                                                                          | all                    | Python only |
|```TU_name```                    | The name of the time unit. Overrides ```TU```.                                                     | string (ex. ```seconds```)                                                                         | all                    | Python only |
|```MU2KG```                      | Mass units to kilogram conversion factor. Overrides ```MU```.                                      | floating point (ex. ```1.988409870698051e+30```)                                                   | all                    | Both  |
|```DU2M```                       | Distance units to meters conversion factor. Overrides ```DU```.                                    | floating point (ex. ```31557600.0```)                                                              | all                    | Both  |
|```TU2S```                       | Time units to seconds conversion factor. Overrides ```TU```.                                       | floating point (ex. ```149597870700.0```)                                                          | all                    | Both  |
|```rmin``` / ```CHK_RMIN```      | Heliocentric distance at which a test particle is considered merged with the central body in distance units. Default is the radius of the central body in system units. | floating point (ex. ```0.3```) | all                   | Both  |
|```rmax``` / ```CHK_RMAX```      | Heliocentric distance at which a test particle is too distant from the central body in distance units. Default is ```10000.0 AU```. | floating point (ex. ```10000.0```)                                | all                    | Both  |
|```qmin_coord``` / ```CHK_QMIN_COORD``` | Coordinate frame used to check for minimum pericenter distance. Default is ```HELIO```.     | ```HELIO```, ```BARY```                                                                            | all                    | Both  |
| ```CHK_QMIN```                  | Pericenter distance at which a test particle is too close to the pericenter of the system in distance units. | floating point, turn off using ```-1.0```                                                | all                    | ASCII only |
| ```CHK_QMIN_RANGE```            | Upper and lower bounds of the semimajor axis range used to check the pericenter distance.          | two floating points, turn off using ```-1.0 -1.0```                                                | all                    | ASCII only |
| ```CHK_EJECT```                 | Heliocentric distance at which an unbound test particle is too distant from the central body in distance units. | floating point (ex. ```1000.0```)                                                     | all                    | ASCII only |
|```extra_force``` / ```EXTRA_FORCE``` | Additional user defined force routines provided. Default is ```False``` / ```NO```.           | ```True```, ```False``` / ```YES```, ```NO```                                                      | all                    | Both  |
|```close_encounter_check``` / ```CHK_CLOSE``` | Check for close encounters. Default is ```True``` / ```YES```. Requires radius of massive bodies to be provided in initial conditions. | ```True```, ```False```  / ```YES```, ```NO```    | all                    | Both  |
|```interaction_loops```          | Method for checking for interactions between bodies. Default is ```TRIANGULAR```.                  | ```TRIANGULAR```, ```FLAT```, ```ADAPTIVE```                                                       | all                    | Both  |
|```encounter_check_loops``` / ```ENCOUNTER_CHECK``` | Method for checking for close encounters between bodies. Default is ```TRIANGULAR```.  | ```TRIANGULAR```, ```SORTSWEEP```, ```ADAPTIVE```                                           | all                    | Both  |
|```encounter_save```             | Save data for each close encounter to a file. Warning! This can generate very large files!         | ```TRAJECTORY```, ```CLOSEST```, ```BOTH```                                                        | SyMBA                  | Python only |
|```collision_model```            | Resolve collisions. Default is ```MERGE```.                                                        | ```MERGE```, ```BOUNCE```, ```FRAGGLE```                                                           | SyMBA                  | Both  |
|```nfrag_reduction```            | Factor to reduce the number of fragments generated by a collision. See below for a more detailed explanation. | floating point, default is ```30.0```, minumum is ```1.0```                             | SyMBA                  | Both  |
|```minimum_fragment_gmass``` / ```MIN_GMFRAG``` | Minimum fragment mass in gravitational mass units. Default is ```0.0```. Either ```minimum_fragment_gmass``` **OR** ```minimum_fragment_mass``` may be set. | floating point (ex. ```1e-9```) | SyMBA             | Both  |
|```minimum_fragment_mass```      | Minimum fragment mass in mass units. Either ```minimum_fragment_gmass``` **OR** ```minimum_fragment_mass``` may be set. | floating point (ex. ```1e20```)                                               | SyMBA                  | Python only |
|```rotation```                   | Rotation of massive bodies. Requires rotation vectors, radii, and moments of inertia to be provided in initial conditions. Default is ```False```. | ```True```, ```False``` / ```YES```, ```NO```      | SyMBA                  | Both  |
|```rhill_present```              | Hill Radius present in massive body input file. Default is ```False```.                            | ```True```, ```False``` / ```YES```, ```NO```                                                      | SyMBA                  | Both  |
|```compute_conservation_values``` / ```ENERGY``` | Track and report the total energy, angular momentum, and mass of the system. Default is ```False```. | ```True```, ```False``` / ```YES```, ```NO```                                    | SyMBA                  | Both  |
|```general_relativity``` / ```GR``` | General relativity. Default is ```True```.                                                      | ```True```, ```False``` / ```YES```, ```NO```                                                      | all                    | Both  |
|```big_discard```                | Include data for all fully-interacting bodies (above GMTINY) in each discard. Swifter only. Default is ```False```. | ```True```, ```False``` / ```YES```, ```NO```                                     | all                    | Both  |
|```restart```                    | If ```True```, the simulation given by ```output_file_name``` will be restarted from ```t0```.  Default is ```False```. | ```True```, ```False```                                                       | all                    | Python only |
|```gmtiny```                     | Mass cutoff between fully and semi-interacting massive bodies in gravitational mass units. Default is ```0.0```. Either ```mtiny``` **OR** ```gmtiny``` may be set. | floating point (ex. ```4e-6```)   | all                    | Both  |
|```mtiny```                      | Mass cutoff between fully and semi-interacting massive bodies in mass units. Either ```mtiny``` **OR** ```gmtiny``` may be set. | floating point (ex. ```1e23```)                                       | all                    | Python only |

In the above list, the following are defined as:
- ```HELIO``` - Use the heliocentric coordinate frame.
- ```BARY``` - Use the barycentric coordinate frame.
- ```XV``` - Heliocentric position and velocity components.
- ```EL``` - Osculating orbital elements.
- ```XVEL``` - Heliocentric position and velocity components and osculating orbital elements.
- ```NETCDF_FLOAT``` - Single precision NetCDF format.
- ```NETCDF_DOUBLE``` - Double precision NetCDF format.
- ```REAL4``` - Single precision 4-byte native Fortran binary format (Swifter/Swift only)
- ```REAL8``` - Double precision 8-byte native Fortran binary format (Swifter/Swift only)
- ```XDR4``` - Single precision 4-byte XDR format (Swifter/Swift only)
- ```XDR8``` - Double precision 8-byte XDR format (Swifter/Swift only)
- ```TRAJECTORY``` - Save the position and velocity vectors of all bodies involved in the close encounter at each intermediary step of the encounter
- ```CLOSEST``` - Save the position and velocity vectors of all bodies involved in the close encounter at the point of closest approach 
- ```MERGE``` - Perfectly conserve the mass of all colliding bodies into a single resultant body
- ```BOUNCE``` - Perfectly-elastic collision in which all bodies reverse trajectory after the collision
- ```FRAGGLE``` - Collisional fragments are generated as a result of a collision
- ```NFRAG_REDUCTION``` - Based on the SFD defined in Leinhardt & Stewart (2012), Fraggle dictates that ```N``` fragments be generated between the mass of the second largest remnant and ```MIN_GMFRAG```, with the maximum value of ```N``` being ```3000```. To improve performance, this number can be reduced by ```N / NFRAG_REDUCTION```.

For more details on the ```INTERACTION_LOOPS``` and ```ENCOUNTER_CHECK``` options, see the **Updates to Swifter SyMBA** section.
